/*!
 ***********************************************************************************************************************
 * APTIV PRIVILEGED AND CONFIDENTIAL
 *
 * @file RunAllTests.cc
 * @brief Runs all the google tests linked to the binary this is compiled with.
 *
 * @section License
 *
 * Copyright (c) 2018- Aptiv. All rights reserved.
 * NOTE: Removing this heading is prohibited.
 *
 * @section Open Source License List
 *
 * This is a list of any open-source project used by this file.
 ***********************************************************************************************************************
 */

#include <SimpleComms/Status.h>
#include <gmock/gmock.h>
#include <gtest/gtest.h>

void setDefaults()
{
    // Set the default value for Status::States which can be used in all tests.
    ::testing::DefaultValue<SimpleComms::Status::States>::Set(SimpleComms::Status::States::Error);
}

GTEST_API_ int main(int argc, char** argv)
{
    setDefaults();

    ::testing::InitGoogleMock(&argc, argv);
    return RUN_ALL_TESTS();
}