/**
 * \copyright
 * Copyright (c) 2020- Motional. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Motional and its suppliers, if any.
 * The intellectual and technical concepts contained herein are proprietary to Motional and its suppliers and may be
 * covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material is strictly forbidden unless prior written
 * permission is obtained from Motional.
 *
 * \brief Implements SystemClock::uninitializeSystemClock
 */

#include <Clock/SystemClock.h>

namespace ottotime {

/*!
 * @brief Implements static member function that un-initializes the system clock
 *
 * @note This function is only supposed to be called by unit tests.
 */
void SystemClock::uninitializeSystemClock(void)
{
    if (!SystemClock::initialized_) {
        return;
    }

    SystemClock::externalClock_ = nullptr;
    SystemClock::externalClockParams_ = PlaybackClockParams();
    SystemClock::localBaseTime_ = ottotime::otimePoint();
    SystemClock::synchronizedBaseTime_ = ottotime::otimePoint();
    SystemClock::steadyBaseTime_ = ottotime::otimePoint();

    SystemClock::mode_ = SystemClock::SystemTimeMode::TimeModeSteady;
    SystemClock::initialized_ = false;
}

} // namespace ottotime
