/**
 * \copyright
 * Copyright (c) 2021- Motional. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Motional, its affiliates, and its suppliers (if
 * any). The intellectual and technical concepts contained herein are proprietary to Motional, its affiliates, and its
 * suppliers (if any) and may be covered by U.S. and Foreign Patents, patents in process, and are protected by trade
 * secrets or copyright law. Dissemination of this information or reproduction of this material is strictly forbidden
 * unless prior written permission is obtained from Motional.
 *
 * \file
 * \brief DDS Quality of Service Helper
 */

#include "DDSConfiguratorHelper.hpp"
namespace DDSComms {

// Should be performant due to RVO
BytesTopicType createMsg(const std::string& sendMsg,
                         [[maybe_unused]] const uint32_t& sequenceNumber,
                         [[maybe_unused]] const std::string& origin)
{
    BytesTopicType msg{origin, sequenceNumber, {}};
    std::vector<uint8_t> vecCopy = {sendMsg.begin(), sendMsg.end()};
    msg.payload() = std::move(vecCopy);
    return msg;
}

// Should be performant due to RVO
std::string getMsgData(const BytesTopicType& sample)
{
    return std::string(sample.payload().begin(), sample.payload().end());
}

void setSequenceNumber([[maybe_unused]] BytesTopicType& msg, [[maybe_unused]] const uint32_t& sequenceNumber)
{
    msg.sequenceNumber(sequenceNumber);
}

} // namespace DDSComms