/****************************************************************

  Generated by Eclipse Cyclone DDS IDL to CXX Translator
  File name: UserBytesTopicType.idl
  Source: ../av-stack/platform/middleware/libs/DDSComms/types/cyclone//UserBytesTopicType.hpp
  Cyclone DDS: v0.9.0

*****************************************************************/
#ifndef DDSCXX____AV_STACK_PLATFORM_MIDDLEWARE_LIBS_DDSCOMMS_TYPES_CYCLONE__USERBYTESTOPICTYPE_HPP
#define DDSCXX____AV_STACK_PLATFORM_MIDDLEWARE_LIBS_DDSCOMMS_TYPES_CYCLONE__USERBYTESTOPICTYPE_HPP

#include <cstdint>
#include <iostream>
#include <string>
#include <vector>

#include "org/eclipse/cyclonedds/core/OstreamWrap.hpp"

class BytesMsgType
{
private:
    std::string origin_;
    uint32_t sequenceNumber_ = 0;
    std::vector<uint8_t> payload_;

public:
    BytesMsgType() = default;

    explicit BytesMsgType(const std::string& origin, uint32_t sequenceNumber, const std::vector<uint8_t>& payload)
        : origin_(origin)
        , sequenceNumber_(sequenceNumber)
        , payload_(payload)
    {}

    const std::string& origin() const { return this->origin_; }
    std::string& origin() { return this->origin_; }
    void origin(const std::string& _val_) { this->origin_ = _val_; }
    void origin(std::string&& _val_) { this->origin_ = _val_; }
    uint32_t sequenceNumber() const { return this->sequenceNumber_; }
    uint32_t& sequenceNumber() { return this->sequenceNumber_; }
    void sequenceNumber(uint32_t _val_) { this->sequenceNumber_ = _val_; }
    const std::vector<uint8_t>& payload() const { return this->payload_; }
    std::vector<uint8_t>& payload() { return this->payload_; }
    void payload(const std::vector<uint8_t>& _val_) { this->payload_ = _val_; }
    void payload(std::vector<uint8_t>&& _val_) { this->payload_ = _val_; }

    bool operator==(const BytesMsgType& _other) const
    {
        return origin_ == _other.origin_ && sequenceNumber_ == _other.sequenceNumber_ && payload_ == _other.payload_;
    }

    bool operator!=(const BytesMsgType& _other) const { return !(*this == _other); }
};

std::ostream& operator<<(std::ostream& o, const BytesMsgType& sample);

#include "dds/topic/TopicTraits.hpp"
#include "org/eclipse/cyclonedds/topic/TopicTraits.hpp"
#include "org/eclipse/cyclonedds/topic/datatopic.hpp"

namespace org {
namespace eclipse {
namespace cyclonedds {
namespace topic {

template<>
constexpr const char* TopicTraits<::BytesMsgType>::getTypeName()
{
    return "BytesMsgType";
}

template<>
inline ddsi_sertype* TopicTraits<::BytesMsgType>::getSerType()
{
    return static_cast<ddsi_sertype*>(new ddscxx_sertype<BytesMsgType>());
}

template<>
constexpr bool TopicTraits<::BytesMsgType>::isSelfContained()
{
    return false;
}

template<>
constexpr bool TopicTraits<::BytesMsgType>::isKeyless()
{
    return true;
}

} // namespace topic
} // namespace cyclonedds
} // namespace eclipse
} // namespace org

namespace dds {
namespace topic {

template<>
struct topic_type_name<::BytesMsgType>
{
    static std::string value() { return org::eclipse::cyclonedds::topic::TopicTraits<::BytesMsgType>::getTypeName(); }
};

} // namespace topic
} // namespace dds

REGISTER_TOPIC_TYPE(::BytesMsgType)

namespace org {
namespace eclipse {
namespace cyclonedds {
namespace core {
namespace cdr {

template<>
entity_properties_t get_type_props<::BytesMsgType>();

template<typename T, std::enable_if_t<std::is_base_of<cdr_stream, T>::value, bool> = true>
bool write(T& streamer, const ::BytesMsgType& instance, entity_properties_t& props)
{
    (void)instance;
    if (!streamer.start_struct(props))
        return false;
    bool firstcall = true;
    while (auto& prop = streamer.next_entity(props, firstcall)) {
        switch (prop.m_id) {
            case 0:
                if (!streamer.start_member(prop))
                    return false;
                if (!write_string(streamer, instance.origin(), 0))
                    return false;
                if (!streamer.finish_member(prop))
                    return false;
                break;
            case 1:
                if (!streamer.start_member(prop))
                    return false;
                if (!write(streamer, instance.sequenceNumber()))
                    return false;
                if (!streamer.finish_member(prop))
                    return false;
                break;
            case 2:
                if (!streamer.start_member(prop))
                    return false;
                if (!streamer.start_consecutive(false, true))
                    return false;
                {
                    uint32_t se_1 = uint32_t(instance.payload().size());
                    if (!write(streamer, se_1))
                        return false;
                    if (se_1 > 0 && !write(streamer, instance.payload()[0], se_1))
                        return false;
                } // end sequence 1
                if (!streamer.finish_consecutive())
                    return false;
                if (!streamer.finish_member(prop))
                    return false;
                break;
        }
    }
    return streamer.finish_struct(props);
}

template<typename S, std::enable_if_t<std::is_base_of<cdr_stream, S>::value, bool> = true>
bool write(S& str, const ::BytesMsgType& instance, bool as_key)
{
    auto props = get_type_props<::BytesMsgType>();
    str.set_mode(cdr_stream::stream_mode::write, as_key);
    return write(str, instance, props);
}

template<typename T, std::enable_if_t<std::is_base_of<cdr_stream, T>::value, bool> = true>
bool read(T& streamer, ::BytesMsgType& instance, entity_properties_t& props)
{
    (void)instance;
    if (!streamer.start_struct(props))
        return false;
    bool firstcall = true;
    while (auto& prop = streamer.next_entity(props, firstcall)) {
        if (prop.ignore) {
            streamer.skip_entity(prop);
            continue;
        }
        switch (prop.m_id) {
            case 0:
                if (!streamer.start_member(prop))
                    return false;
                if (!read_string(streamer, instance.origin(), 0))
                    return false;
                if (!streamer.finish_member(prop))
                    return false;
                break;
            case 1:
                if (!streamer.start_member(prop))
                    return false;
                if (!read(streamer, instance.sequenceNumber()))
                    return false;
                if (!streamer.finish_member(prop))
                    return false;
                break;
            case 2:
                if (!streamer.start_member(prop))
                    return false;
                if (!streamer.start_consecutive(false, true))
                    return false;
                {
                    uint32_t se_1 = uint32_t(instance.payload().size());
                    if (!read(streamer, se_1))
                        return false;
                    instance.payload().resize(se_1);
                    if (se_1 > 0 && !read(streamer, instance.payload()[0], se_1))
                        return false;
                } // end sequence 1
                if (!streamer.finish_consecutive())
                    return false;
                if (!streamer.finish_member(prop))
                    return false;
                break;
            default:
                if (prop.must_understand_remote && streamer.status(must_understand_fail))
                    return false;
                else
                    streamer.skip_entity(prop);
                break;
        }
    }
    return streamer.finish_struct(props);
}

template<typename S, std::enable_if_t<std::is_base_of<cdr_stream, S>::value, bool> = true>
bool read(S& str, ::BytesMsgType& instance, bool as_key)
{
    auto props = get_type_props<::BytesMsgType>();
    str.set_mode(cdr_stream::stream_mode::read, as_key);
    return read(str, instance, props);
}

template<typename T, std::enable_if_t<std::is_base_of<cdr_stream, T>::value, bool> = true>
bool move(T& streamer, const ::BytesMsgType& instance, entity_properties_t& props)
{
    (void)instance;
    if (!streamer.start_struct(props))
        return false;
    bool firstcall = true;
    while (auto& prop = streamer.next_entity(props, firstcall)) {
        switch (prop.m_id) {
            case 0:
                if (!streamer.start_member(prop))
                    return false;
                if (!move_string(streamer, instance.origin(), 0))
                    return false;
                if (!streamer.finish_member(prop))
                    return false;
                break;
            case 1:
                if (!streamer.start_member(prop))
                    return false;
                if (!move(streamer, instance.sequenceNumber()))
                    return false;
                if (!streamer.finish_member(prop))
                    return false;
                break;
            case 2:
                if (!streamer.start_member(prop))
                    return false;
                if (!streamer.start_consecutive(false, true))
                    return false;
                {
                    uint32_t se_1 = uint32_t(instance.payload().size());
                    if (!move(streamer, se_1))
                        return false;
                    if (se_1 > 0 && !move(streamer, uint8_t(), se_1))
                        return false;
                } // end sequence 1
                if (!streamer.finish_consecutive())
                    return false;
                if (!streamer.finish_member(prop))
                    return false;
                break;
        }
    }
    return streamer.finish_struct(props);
}

template<typename S, std::enable_if_t<std::is_base_of<cdr_stream, S>::value, bool> = true>
bool move(S& str, const ::BytesMsgType& instance, bool as_key)
{
    auto props = get_type_props<::BytesMsgType>();
    str.set_mode(cdr_stream::stream_mode::move, as_key);
    return move(str, instance, props);
}

template<typename T, std::enable_if_t<std::is_base_of<cdr_stream, T>::value, bool> = true>
bool max(T& streamer, const ::BytesMsgType& instance, entity_properties_t& props)
{
    (void)instance;
    if (!streamer.start_struct(props))
        return false;
    bool firstcall = true;
    while (auto& prop = streamer.next_entity(props, firstcall)) {
        switch (prop.m_id) {
            case 0:
                if (!streamer.start_member(prop))
                    return false;
                if (!max_string(streamer, instance.origin(), 0))
                    return false;
                if (!streamer.finish_member(prop))
                    return false;
                break;
            case 1:
                if (!streamer.start_member(prop))
                    return false;
                if (!max(streamer, instance.sequenceNumber()))
                    return false;
                if (!streamer.finish_member(prop))
                    return false;
                break;
            case 2:
                if (!streamer.start_member(prop))
                    return false;
                if (!streamer.start_consecutive(false, true))
                    return false;
                {
                    uint32_t se_1 = 0;
                    if (!max(streamer, se_1))
                        return false;
                    if (se_1 > 0 && !max(streamer, uint8_t(), se_1))
                        return false;
                } // end sequence 1
                if (!streamer.finish_consecutive())
                    return false;
                streamer.position(SIZE_MAX);
                if (!streamer.finish_member(prop))
                    return false;
                break;
        }
    }
    return streamer.finish_struct(props);
}

template<typename S, std::enable_if_t<std::is_base_of<cdr_stream, S>::value, bool> = true>
bool max(S& str, const ::BytesMsgType& instance, bool as_key)
{
    auto props = get_type_props<::BytesMsgType>();
    str.set_mode(cdr_stream::stream_mode::max, as_key);
    return max(str, instance, props);
}

} // namespace cdr
} // namespace core
} // namespace cyclonedds
} // namespace eclipse
} // namespace org

#endif // DDSCXX____AV_STACK_PLATFORM_MIDDLEWARE_LIBS_DDSCOMMS_TYPES_CYCLONE__USERBYTESTOPICTYPE_HPP
