#ifndef _DIAGHELPER_H_
#define _DIAGHELPER_H_

#include <cstdio>
#include <cstring>
#include <fstream>
#include <iostream>
#include <libconfig.h++>
#include <unistd.h>
#include <vector>

typedef struct device
{
    std::string name;
    std::string type;
    std::string addr;
    std::string host;
} Device;

namespace DiagHelper {
std::string convertToText(int i);
std::string getHostIP(std::string name);
void readConfigFile(libconfig::Config& cfg);
std::vector<Device> getDeviceInfo();
std::string getHostVehicleName();
std::vector<Device> parseConfigFile(libconfig::Config& cfg);
} // namespace DiagHelper

#endif //_DIAGHELPER_H_
