/**
 * \copyright
 * Copyright (c) 2020- Motional. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Motional, its affiliates, and its suppliers (if
 * any). The intellectual and technical concepts contained herein are proprietary to Motional, its affiliates, and its
 * suppliers (if any) and may be covered by U.S. and Foreign Patents, patents in process, and are protected by trade
 * secrets or copyright law. Dissemination of this information or reproduction of this material is strictly forbidden
 * unless prior written permission is obtained from Motional.
 *
 * \file
 * \brief helper functions for AvSystemStatus
 */

#ifndef _AV_MSG_IDLHELPER_AvSystemStatus_
#define _AV_MSG_IDLHELPER_AvSystemStatus_

#include <interfaces/AvSystemStatus/AvSystemStatus.h>
#include <string>

namespace av {
namespace msg {
namespace utils {

inline std::string missionTypeToString(const uint32_t& state)
{
    std::string returnStr{"UNDEFINED"};
    switch (state) {
        case static_cast<uint32_t>(av::msg::AVSSIS::AvMissionStatus::NOT_READY):
            returnStr = "NOT_READY";
            break;
        case static_cast<uint32_t>(av::msg::AVSSIS::AvMissionStatus::READY):
            returnStr = "READY";
            break;
        case static_cast<uint32_t>(av::msg::AVSSIS::AvMissionStatus::ACTIVE):
            returnStr = "ACTIVE";
            break;
        case static_cast<uint32_t>(av::msg::AVSSIS::AvMissionStatus::SNA):
            returnStr = "SNA";
            break;
        default:
            break;
    }
    return returnStr;
}

inline std::string healthTypeToString(const uint32_t& state)
{
    std::string returnStr{"UNDEFINED"};
    switch (state) {
        case static_cast<uint32_t>(av::msg::AVSSIS::AvHealthState::INIT):
            returnStr = "INIT";
            break;
        case static_cast<uint32_t>(av::msg::AVSSIS::AvHealthState::NOMINAL):
            returnStr = "NOMINAL";
            break;
        case static_cast<uint32_t>(av::msg::AVSSIS::AvHealthState::DEGRADED):
            returnStr = "DEGRADED";
            break;
        case static_cast<uint32_t>(av::msg::AVSSIS::AvHealthState::FAULTED):
            returnStr = "FAULTED";
            break;
        case static_cast<uint32_t>(av::msg::AVSSIS::AvHealthState::SNA):
            returnStr = "SNA";
            break;
        default:
            break;
    }
    return returnStr;
}

} // namespace utils
} // namespace msg
} // namespace av

#endif
