/*!
 ***********************************************************************************************************************
 * APTIV PRIVILEGED AND CONFIDENTIAL
 *
 * @brief LocalizationPose helper functions headers
 *
 * @section License
 *
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTE: Removing this heading is prohibited.
 *
 * @section Open Source License List
 *
 * This is a list of any open-source project used by this file.
 ***********************************************************************************************************************
 */

#ifndef _IDLHELPER_LOCALIZATIONPOSEHELPER_H_
#define _IDLHELPER_LOCALIZATIONPOSEHELPER_H_

#include <Eigen/Eigen>
#include <chrono>

#include <TimeStamp/otime.h>
#include <interfaces/LocalizationPose/LocalizationPose.h>

namespace idlhelper {
struct LocalizationPoseHelper : public LocalizationPose
{
    LocalizationPoseHelper();
    LocalizationPoseHelper(LocalizationPose);

    Eigen::Vector3d getPosition() const;

    Eigen::Quaterniond getQuaternion() const;

    Eigen::Vector3d getRollPitchYaw() const;

    Eigen::Vector3d getVelocity() const;

    Eigen::Vector3d getAngularRate() const;

    Eigen::Vector3d getAcceleration() const;

    std::chrono::system_clock::time_point getTimestamp() const;

    ottotime::otimePoint getTimePoint() const;
};
} // namespace idlhelper

#endif //_IDLHELPER_LOCALIZATIONPOSEHELPER_H_
