/**
 * \copyright
 * Copyright (c) 2020- Motional. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Motional, its affiliates, and its suppliers (if
 * any). The intellectual and technical concepts contained herein are proprietary to Motional, its affiliates, and its
 * suppliers (if any) and may be covered by U.S. and Foreign Patents, patents in process, and are protected by trade
 * secrets or copyright law. Dissemination of this information or reproduction of this material is strictly forbidden
 * unless prior written permission is obtained from Motional.
 *
 * \file
 * \brief helper functions for SystemStatus
 */

#ifndef _AV_MSG_IDLHELPER_SystemStatus_
#define _AV_MSG_IDLHELPER_SystemStatus_

#include "lib/avlog/avlog.hpp"
#include "lib/base/enum/Trait.hpp"
#include <interfaces/SystemStatus/SystemStatus.h>
#include <string>

namespace av {
namespace msg {
namespace utils {

inline std::string severityToString(const av::msg::SystemStatusSeverity& severityLevel)
{
    std::string returnStr{"undefined"};
    switch (severityLevel) {
        case SystemStatusSeverity::info:
            returnStr = "info";
            break;
        case SystemStatusSeverity::warning:
            returnStr = "warning";
            break;
        case SystemStatusSeverity::fatal:
            returnStr = "fatal";
            break;
        default:
            break;
    }
    return returnStr;
}

} // namespace utils
} // namespace msg
} // namespace av

template<>
struct base::EnumTrait<av::msg::SystemStatusSeverity>
{
    static constexpr std::array namedEnumerators{
        base::Enumerator{av::msg::SystemStatusSeverity::info, "info"},
        base::Enumerator{av::msg::SystemStatusSeverity::warning, "warning"},
        base::Enumerator{av::msg::SystemStatusSeverity::fatal, "fatal"},
    };
};

AVLOG_ENUM_FORMAT(av::msg::SystemStatusSeverity)

#endif
