/**
 * \copyright
 * Copyright (c) 2020 Motional. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 *
 * All information contained herein is, and remains the property of
 * Motional and its suppliers, if any.  The intellectual and technical
 * concepts contained herein are proprietary to Motional and its
 * suppliers and may be covered by U.S. and Foreign Patents, patents
 * in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Motional.
 */
#ifndef LATENCYLOGGERVIAPROGRESSREPORTER_H
#define LATENCYLOGGERVIAPROGRESSREPORTER_H

#include "platform/middleware/libs/LatencyLogger/include/LatencyLogger/LatencyLogger.h"

namespace av {
/// @brief Sets up LatencyLogger to write to ProgressReporter.
///
/// Note that, if you initLatencyLoggerViaProgressReporter() after it's already
/// been called, and shutDownLatencyLoggerViaProgressReporter() has not yet been
/// called, it will have no effect. In particular, the
/// ViaProgressReporterBuilder will not change.
void initLatencyLoggerViaProgressReporter();

/// @brief Removes the Builder that sends latency events to ProgressReporter.
///
/// Note that shutDownLatencyLoggerViaProgressReporter() is idempotent: if you
/// call it twice, with no initLatencyLoggerViaProgressReporter() in between,
/// the second call will have no effect.
void shutDownLatencyLoggerViaProgressReporter();
} // namespace av

#endif // LATENCYLOGGERVIAPROGRESSREPORTER_H
