// Copyright (c) 2021- Motional. All rights reserved.
//
// NOTICE: Removing this heading is prohibited.
//
// All information contained herein is, and remains the property of Motional, its affiliates, and
// its suppliers (if any). The intellectual and technical concepts contained herein are proprietary
// to Motional, its affiliates, and its suppliers (if any) and may be covered by U.S. and Foreign
// Patents, patents in process, and are protected by trade secrets or copyright law. Dissemination
// of this information or reproduction of this material is strictly forbidden unless prior written
// permission is obtained from Motional.

#pragma once

#include "platform/middleware/libs/LatencyLogger/include/LatencyLogger/LatencyLoggerTypes.hpp"

#include "lib/avlog/DataLogger.hpp"
#include "platform/middleware/libs/TimeStamp/include/TimeStamp/otime.h"

namespace av {
namespace latency {

class DataLoggerWriter
{
public:
    /// Construct a writer logging to the specified absolute path and a
    /// specificied async mode.
    DataLoggerWriter(const std::string& logPath, bool async = true);

    /// Construct a writer logging to the AvLog directory. Note that AvLog must
    /// be initialized before constructing a writer this way.
    static DataLoggerWriter UsingLoggerName(const std::string& loggerName);

    /// Function to log a latency event.
    void operator()(const std::string& loggingName,
                    const std::string& checkpointName,
                    const ottotime::otimePoint& timestamp,
                    av::latency::EventID eventID,
                    std::vector<av::latency::Pred>&& predecessors);

    void flush();

private:
    DataLoggerWriter(avlog::DataLogger&& dl);

    avlog::DataLogger dl_;
};

} // namespace latency
} // namespace av
