/**
 * \copyright
 * Copyright (c) 2021 Motional. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 *
 * All information contained herein is, and remains the property of
 * Motional and its suppliers, if any.  The intellectual and technical
 * concepts contained herein are proprietary to Motional and its
 * suppliers and may be covered by U.S. and Foreign Patents, patents
 * in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Motional.
 */

#pragma once

#include "platform/middleware/libs/LatencyLogger/include/LatencyLogger/LatencyLoggerTypes.hpp"

#include "platform/middleware/libs/TimeStamp/include/TimeStamp/otime.h"

#include <nlohmann/json.hpp>

#include <fstream>

namespace av {

namespace latency {

class JSONWriter
{
public:
    JSONWriter(const std::string& loggingName, const std::string& subFolder = "LatencyLogger");

    void operator()(const std::string& loggingName,
                    const std::string& checkpointName,
                    const ottotime::otimePoint& timestamp,
                    av::latency::EventID eventID,
                    std::vector<av::latency::Pred>&& predecessors);

private:
    std::ofstream outFile_;
};

} // namespace latency
} // namespace av
