/**
 * \copyright
 * Copyright (c) 2020 Motional. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 *
 * All information contained herein is, and remains the property of
 * Motional and its suppliers, if any.  The intellectual and technical
 * concepts contained herein are proprietary to Motional and its
 * suppliers and may be covered by U.S. and Foreign Patents, patents
 * in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Motional.
 */

/*
 * Design doc:
 *
 * https://confluence.ci.motional.com/confluence/display/SI/Latency+Logging
 */

#pragma once

#include <cstdint>

namespace av {
namespace latency {

/// The identifier for logged events. Randomly generated IDs have the
/// high bit set to 0; IDs that represent CAN packet IDs have the high
/// bit set to 1. In the various FooEvent() methods that return the
/// EventID of the logged event, if logging is disabled, the returned
/// ID will be 0.
using EventID = uint64_t;

/// Alias for EventID. Used to be a separate type.
using Pred = EventID;

} // namespace latency
} // namespace av
