/*!
 ***********************************************************************************************************************
 * MOTIONAL PRIVILEGED AND CONFIDENTIAL
 *
 * @file NoInitializeTest.cpp
 * @brief This file implements tests for the LatencyLogger class.
 *
 * @section License
 *
 * Copyright (c) 2021- Motional. All rights reserved.
 * NOTE: Removing this heading is prohibited.
 *
 * @section Open Source License List
 *
 * This is a list of any open-source project used by this file.
 ***********************************************************************************************************************
 */

#include "platform/middleware/libs/LatencyLogger/test/TestWriter.hpp"
#include "platform/middleware/libs/config/include/config/ConfigParser.h"

namespace av {

TEST(NoInitializeTest, NoInitialize)
{
    EXPECT_NO_THROW(LatencyLogger::getLogger());

    LatencyLogger& logger = LatencyLogger::getLogger();

    const av::latency::EventID liftoff = logger.RegularEvent("Liftoff");

    av::latency::EventID splashdown = logger.RegularEvent("Splashdown", {liftoff});

    EXPECT_EQ(splashdown, av::latency::EventID{0}); // logger was not initialized
}

} // namespace av
