/// @copyright Copyright (c) 2021- Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// @brief brief Gen2 status reporting wrapper minimalist implementation

#include "include/MonitoringNotifier/MonitoringNotifier.hpp"

namespace av {

MonitoringNotifier::MonitoringNotifier(std::shared_ptr<MonitoringStatusProvider> provider)
    : monitorProvider_(std::move(provider))
{}

void MonitoringNotifier::notify(av::msg::TaskState currentState,
                                av::msg::FaultSource faultSource,
                                const std::string& description)
{
    if (monitorProvider_) {
        monitorProvider_->updateStatus(usecFromTimePoint(av::AvClock::now()), currentState, faultSource, description);
    }
}

void MonitoringNotifier::resetStatus()
{
    if (monitorProvider_) {
        monitorProvider_->setStatus(
            usecFromTimePoint(av::AvClock::now()), av::msg::TaskState::UP, av::msg::FaultSource::INTERNAL, "");
    }
}

} // namespace av