/// @copyright Copyright (c) 2021- Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// @brief Utility functions for hashing classes

#ifndef _HASH_VECTOR_
#define _HASH_VECTOR_

#include <cstddef>
#include <functional>

// Reference: https://stackoverflow.com/a/27216842
template<typename T>
std::size_t hashVector(const T& v) noexcept
{
    using type = typename T::value_type;
    std::size_t h = v.size();
    for (const type& t : v) {
        h ^= std::hash<type>()(t) + 0x9e3779b9 + (h << 6) + (h >> 2);
    }
    return h;
}

#endif // _HASH_VECTOR_