/*!
***********************************************************************************************************************
* APTIV PRIVILEGED AND CONFIDENTIAL
*
* @file IntrospectionForwardDecl.h
* @product Messaging Infrastructure
* @version
* @released
* @updated
* @brief Introspection archive for ottoware base datums
*
* This file implements a cereal-compatible Archive type that allows us to inspect datums at runtime.
* It does this by recursing through a datum's serialize() methods like any other archive, but
* instead it gets the demangled variable type name, the variable name if the user has added it
* using a name-value pair, and the value.
*
* @section License
*
* Copyright (c) 2018- Aptiv. All rights reserved.
* NOTE: Removing this heading is prohibited.
*
* @section Open Source License List
* - Cereal
*
* This is a list of any open-source project used by this file.
***********************************************************************************************************************
*/

#ifndef _ODATUM_INTROSPECTION_FORWARD_DECL_H_
#define _ODATUM_INTROSPECTION_FORWARD_DECL_H_

#include <memory>

namespace aptv {
// Forward decl
struct FieldInfo;

// Convenience typedef
using FieldInfoPtr = std::shared_ptr<FieldInfo>;
} // namespace aptv

#endif // _ODATUM_INTROSPECTION_FORWARD_DECL_H_
