#include <gmock/gmock.h>
#include <gtest/gtest.h>

#include <ORCLibrary/OperationalRequirementsChecker.hpp>

class MockChecker : public OperationalRequirementsChecker<int>
{
public:
    MOCK_METHOD1(setRequirements, void(ConfigSection& requirementParams));
    MOCK_METHOD1(checkRequirements, void(const int& requirementsInput));
    MOCK_METHOD0(sendDiagnosticData, void());
};

TEST(ORCLibraryTests, TestCheckRequirements)
{
    MockChecker mock_obj{};
    EXPECT_CALL(mock_obj, checkRequirements(0));
    mock_obj.checkRequirements(0);
}

TEST(ORCLibraryTests, TestSendDiagnosticData)
{
    MockChecker mock_obj{};
    EXPECT_CALL(mock_obj, sendDiagnosticData());
    mock_obj.sendDiagnosticData();
}
