#include <unistd.h>

#define __ENABLE_OTTO_PROFILER__
#include <OttoProfiler/OttoProfiler.h>

const size_t msecond2usecond = 1000;

void test1()
{
    // Need to be the first line!
    __OTTO_PROFILER__("test1")

    const size_t msecond = 10;
    usleep(msecond * msecond2usecond);

    {
        // Need to be the first line!
        __OTTO_PROFILER__(inside_test1)
        const size_t mseconds = 13;
        usleep(mseconds * msecond2usecond);
    }
}

void test2()
{
    // Need to be the first line!
    __OTTO_PROFILER__(test2)

    const size_t msecond = 10;
    usleep(msecond * msecond2usecond);
}

void test3()
{
    for (size_t i = 0; i < 10; i++) {
        // Need to be the first line!
        __OTTO_PROFILER__(test3)
        const size_t msecond = i;
        usleep(static_cast<useconds_t>(msecond * msecond2usecond));
        ottoProfiler::showLastRecorded();
    }
}

void test4()
{
    for (int i = 0; i < 1e6 + 2; i++) {
        // Need to be the first line!
        __OTTO_PROFILER__(test4)
    }
}

void func(const std::string& s)
{
    __OTTO_PROFILER_STRING_NAME__(s)
}

void test5()
{
    for (int i = 0; i < 1e2; i++) {
        func("str1");
    }

    for (int i = 0; i < 1e2; i++) {
        func("str2");
    }
}

int main()
{
    std::cout << "test1" << std::endl;
    test1();

    std::cout << "test2" << std::endl;
    test2();

    std::cout << "test3" << std::endl;
    test3();

    std::cout << "test4" << std::endl;
    test4();

    std::cout << "test5" << std::endl;
    test5();
    __OTTO_PROFILER_DISPLAY__
    return 0;
}
