/*!
 ***********************************************************
 * @file ControlMessages.cc
 * @brief A file implementing a function for Control
 * Messages.
 *
 * @section License
 *
 * Copyright (c) 2015- Delphi Automotive. All rights
 * reserved.
 *
 * @section changeLogs Change Logs
 *
 ***********************************************************
 */

/**********************************************************
  Copyright (c) 2014-2015 Ottomatika, Inc.
 **********************************************************/

/**********************************************************
  Simple Comms
  Copyright (c) 2010-2013 Carnegie Mellon University,
  All rights reserved.

  This source code was developed in part with support from
  sponsors including General Motors, the National Science
  Foundation and the US Department of Transportation.

  Use of this software is strictly governed by agreements
  between Carnegie Mellon University and various sponsors.

  Users of this software must also be fully aware and agree
  that Carnegie Mellon does not guarantee the correct
  functioning of this software in any system. Carnegie
  Mellon or any of its affiliates will not be liable for any
  damage and/or penalties resulting from the use of this
  software. Any user of this software takes complete
  responsibility for the use of any software or design.
 **********************************************************/

/*
 * ControlMessages.cc
 * Tugrul Galatali
 * 02/10/2007
 *
 * Copyright (C) 2007
 * Carnegie Mellon University
 * All rights reserved
 */
#include <SimpleComms/ControlMessages.h>
#include <algorithm>
#include <arpa/inet.h>
#include <cstring>
#include <string>
#include <vector>

namespace SimpleComms {

const char* transportName(const Transports::TransportTypes& transport)
{
    switch (transport) {
        case Transports::UnixDomainSocket:
            return "UnixDomainSocket";
        case Transports::UDP:
            return "UDP";
        case Transports::TCP:
            return "TCP";
    }

    return "Unknown";
}

} // namespace SimpleComms
