/*!
 ***********************************************************************************************************************
 * APTIV PRIVILEGED AND CONFIDENTIAL
 *
 * @file sparse_map_test.cpp
 * @product common
 * @version 1.0
 * @released TODO
 * @updated 2019-04-01
 * @brief Tests the loading of a sparsemap file into a CPP application
 *
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Aptiv and its suppliers, if any.
 * The intellectual and technical concepts contained herein are proprietary to Aptiv and its suppliers and may be
 * covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material is strictly forbidden unless prior written
 * permission is obtained from Aptiv.
 *
 * @section Open Source License List
 *
 * This is a list of any open-source project used by this file.
 ***********************************************************************************************************************
 */
#include <SparseMap/SparseMap.h>
#include <boost/property_tree/json_parser.hpp>

using namespace grid_map;

void print(boost::property_tree::ptree const& pt)
{
    using boost::property_tree::ptree;
    ptree::const_iterator end = pt.end();
    for (ptree::const_iterator it = pt.begin(); it != end; ++it) {
        std::cout << it->first << ": " << it->second.get_value<std::string>() << std::endl;
        print(it->second);
    }
}

int main(int argc, char** argv)
{
    // test read json
    std::string json_config_path = "/home/max/oneNorth/lidarMap_onenorth_svy21_10.json";
    boost::property_tree::ptree root;
    boost::property_tree::read_json(json_config_path, root);
    // print
    print(root);

    if (root.find("EPSG") != root.not_found()) {
        std::cout << "find EPSG" << std::endl;
        int epsg = root.get<int>("EPSG");
        std::cout << "epsg " << epsg << std::endl;
    } else {
        std::cout << "no find EPSG" << std::endl;
    }

    std::string paramFile = "/home/max/oneNorth/lidarMap_onenorth_svy21_10.json";
    std::string mapFile = "/home/max/oneNorth/lidarMap_onenorth_svy21_10.txt";

    SparseMapParams spmParam = readSparseMapConfig(paramFile);
    SparseMap map(mapFile, spmParam);

    std::cout << "... LOAD MAP DONE" << std::endl;
}
