/*!
 ***********************************************************************************************************************
 * APTIV PRIVILEGED AND CONFIDENTIAL
 *
 * @file StringUtils.h
 * @product common
 * @version TODO <Release Number>
 * @released TODO <date>
 * @updated September 25, 2018
 * @brief This defines a string utlities class.
 *
 * @section License
 *
 * Copyright (c) 2018- Aptiv. All rights reserved.
 * NOTE: Removing this heading is prohibited.
 *
 ***********************************************************************************************************************
 */

#include <StringUtils/StringUtils.h>

#include <limits>
#include <sstream>
#include <unistd.h>

namespace string_utils {

std::vector<std::string> splitString(const std::string& str, const char delimiter)
{
    std::vector<std::string> tokens;
    std::string token;
    std::istringstream tokenStream(str);
    bool pendingDelimiter = false;

    while (std::getline(tokenStream, token, delimiter)) {
        pendingDelimiter = !tokenStream.eof();
        tokens.push_back(token);
    }

    if (pendingDelimiter) {
        tokens.push_back(std::string{});
    }

    return tokens;
}

uint16_t toShort(const std::string& str)
{
    auto val = std::stoi(str);

    if (val < 0) {
        throw std::range_error(str + " is negative");
    }

    if (val > static_cast<int32_t>(std::numeric_limits<uint16_t>::max())) {
        throw std::range_error(str + " is larger than a uint16_t");
    }

    return static_cast<uint16_t>(val);
}
} // namespace string_utils
