#ifndef OTTOTIME_CONVERSIONS_H
#define OTTOTIME_CONVERSIONS_H

#include <TimeStamp/otime.h>
#include <avtime/Time.hpp>

namespace av {

inline Duration durationFromOtimeDuration(const ottotime::otimeDuration otd)
{
    return Duration{otd.totalNanoSeconds()};
}

inline TimePoint timePointFromOtimePoint(const ottotime::otimePoint otp)
{
    return TimePoint{durationFromOtimeDuration(otp.timeSinceEpoch())};
}

inline TimePoint timePointFromOtimeSpec(const ottotime::otimeSpec ots)
{
    // Just use conversion from Avutils
    return timePointFromTimespec<av::AvClock>(ots);
}

inline ottotime::otimeDuration otimeDurationFromDuration(const Duration duration)
{
    return ottotime::oNanoSeconds{duration.count()};
}

inline ottotime::otimePoint otimePointFromTimePoint(const TimePoint timePoint)
{

    return ottotime::otimePoint{otimeDurationFromDuration(timePoint.time_since_epoch())};
}

inline ottotime::otimeSpec otimeSpecFromTimePoint(const TimePoint timePoint)
{
    // Just use conversion from Avutils
    return timespecFromTimePoint<ottotime::otimeSpec>(timePoint);
}

} // namespace av

#endif // OTTOTIME_CONVERSIONS_H
