/// @copyright Copyright (c) 2022 - Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file:
/// https://gitlab.ci.motional.com/systems/av-netwrok-infrastructure/Gen2-AVT-Sample-B/-/blob/dd539e5d752bcae0408ed2b8f29b270cc0db624e/Gen2_AVT_B_Control_CAN1.dbc

#include "VehicleCANLibrary/g2h/av_proto/AV_BodyCMD_02_A1_200ms.hpp"
#include <algorithm>
#include <string.h>

using namespace av::can::g2h::avproto;

AV_BodyCMD_02_A1_200ms::AV_BodyCMD_02_A1_200ms(const uint32_t id)
{
    canPacket_.id = id;
    canPacket_.length = AV_BodyCMD_02_A1_200ms_CONSTS::AV_BODYCMD_02_A1_200MS_PACKET_LEN;
}

AV_BodyCMD_02_A1_200ms::AV_BodyCMD_02_A1_200ms(const uint32_t id, uint8_t* const payload, const uint8_t size)
{
    canPacket_.id = id;

    if ((size <= sizeof(canPacket_.data)) && payload) {
        canPacket_.length = size;
        std::copy_n(payload, size, canPacket_.data);
    }
}

const CanFdPacket& AV_BodyCMD_02_A1_200ms::getCanPacket() const
{
    return canPacket_;
}

double AV_BodyCMD_02_A1_200ms::getA1_01_AsstSdWdwCmd() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[5]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x7);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No Action
    //  1 --> 25% open
    //  2 --> 50% open
    //  3 --> Auto Down
    //  4 --> Auto Up
    //  5 --> Reserved
    //  6 --> Reserved
    //  7 --> Invalid
    return output;
}

double AV_BodyCMD_02_A1_200ms::getA1_01_BrglrHrnRlyCmd() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x30);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Reserved
    //  3 --> Reserved
    return output;
}

double AV_BodyCMD_02_A1_200ms::getA1_01_DrLkUnLkCmd() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x3);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No Action
    //  1 --> All_Dr_lock
    //  2 --> All_Dr unlock
    //  3 --> All_passenger_door_unlock
    return output;
}

double AV_BodyCMD_02_A1_200ms::getA1_01_DrvrSdWdwCmd() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[5]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x38);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No Action
    //  1 --> 25% open
    //  2 --> 50% open
    //  3 --> Auto Down
    //  4 --> Auto Up
    //  5 --> Reserved
    //  6 --> Reserved
    //  7 --> Invalid
    return output;
}

double AV_BodyCMD_02_A1_200ms::getA1_01_HdLmpHiOnCmd() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x30);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Reserved
    //  3 --> Reserved
    return output;
}

double AV_BodyCMD_02_A1_200ms::getA1_01_HdLmpLoOnCmd() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Auto
    //  3 --> Rerserved
    return output;
}

double AV_BodyCMD_02_A1_200ms::getA1_01_RrLftWdwCmd() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xe);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No Action
    //  1 --> 25% open
    //  2 --> 50% open
    //  3 --> Auto Down
    //  4 --> Auto Up
    //  5 --> Reserved
    //  6 --> Reserved
    //  7 --> Invalid
    return output;
}

double AV_BodyCMD_02_A1_200ms::getA1_01_RrRtWdwCmd() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[5]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1c0);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                                  // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No Action
    //  1 --> 25% open
    //  2 --> 50% open
    //  3 --> Auto Down
    //  4 --> Auto Up
    //  5 --> Reserved
    //  6 --> Reserved
    //  7 --> Invalid
    return output;
}

double AV_BodyCMD_02_A1_200ms::getA1_01_Turn_Signal_Lf() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x30);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not used
    //  3 --> Error indicator
    return output;
}

double AV_BodyCMD_02_A1_200ms::getA1_01_Turn_Signal_Rt() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc0);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not used
    //  3 --> Error indicator
    return output;
}

double AV_BodyCMD_02_A1_200ms::getA1_01_WshdWiperCmd() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Auto
    //  1 --> High
    //  2 --> Low
    //  3 --> Off
    return output;
}

double AV_BodyCMD_02_A1_200ms::getAV_BodyCMD_AlvCnt2_A1Val() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[2]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    return output;
}

double AV_BodyCMD_02_A1_200ms::getAV_BodyCMD_Crc2_A1Val() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[0]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[1]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffff);                               // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);        // Unsigned value

    return output;
}

int64_t AV_BodyCMD_02_A1_200ms::setA1_01_AsstSdWdwCmd(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[5] &= static_cast<uint8_t>(~0x7);                // clear the bits for new data
    canPacket_.data[5] |= static_cast<uint8_t>((bitBuffer) & (0x7)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No Action
    //  1 --> 25% open
    //  2 --> 50% open
    //  3 --> Auto Down
    //  4 --> Auto Up
    //  5 --> Reserved
    //  6 --> Reserved
    //  7 --> Invalid
    return 0;
}

int64_t AV_BodyCMD_02_A1_200ms::setA1_01_BrglrHrnRlyCmd(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[6] &= static_cast<uint8_t>(~0x30);                     // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer << 4) & (0x30)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Reserved
    //  3 --> Reserved
    return 0;
}

int64_t AV_BodyCMD_02_A1_200ms::setA1_01_DrLkUnLkCmd(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0x3);                // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer) & (0x3)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No Action
    //  1 --> All_Dr_lock
    //  2 --> All_Dr unlock
    //  3 --> All_passenger_door_unlock
    return 0;
}

int64_t AV_BodyCMD_02_A1_200ms::setA1_01_DrvrSdWdwCmd(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[5] &= static_cast<uint8_t>(~0x38);                     // clear the bits for new data
    canPacket_.data[5] |= static_cast<uint8_t>((bitBuffer << 3) & (0x38)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No Action
    //  1 --> 25% open
    //  2 --> 50% open
    //  3 --> Auto Down
    //  4 --> Auto Up
    //  5 --> Reserved
    //  6 --> Reserved
    //  7 --> Invalid
    return 0;
}

int64_t AV_BodyCMD_02_A1_200ms::setA1_01_HdLmpHiOnCmd(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0x30);                     // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer << 4) & (0x30)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Reserved
    //  3 --> Reserved
    return 0;
}

int64_t AV_BodyCMD_02_A1_200ms::setA1_01_HdLmpLoOnCmd(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0xc);                     // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer << 2) & (0xc)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Auto
    //  3 --> Rerserved
    return 0;
}

int64_t AV_BodyCMD_02_A1_200ms::setA1_01_RrLftWdwCmd(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[6] &= static_cast<uint8_t>(~0xe);                     // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer << 1) & (0xe)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No Action
    //  1 --> 25% open
    //  2 --> 50% open
    //  3 --> Auto Down
    //  4 --> Auto Up
    //  5 --> Reserved
    //  6 --> Reserved
    //  7 --> Invalid
    return 0;
}

int64_t AV_BodyCMD_02_A1_200ms::setA1_01_RrRtWdwCmd(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[5] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[5] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    canPacket_.data[6] &= static_cast<uint8_t>(~0x1);                      // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer >> 2) & (0x1));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No Action
    //  1 --> 25% open
    //  2 --> 50% open
    //  3 --> Auto Down
    //  4 --> Auto Up
    //  5 --> Reserved
    //  6 --> Reserved
    //  7 --> Invalid
    return 0;
}

int64_t AV_BodyCMD_02_A1_200ms::setA1_01_Turn_Signal_Lf(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0x30);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer << 4) & (0x30)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not used
    //  3 --> Error indicator
    return 0;
}

int64_t AV_BodyCMD_02_A1_200ms::setA1_01_Turn_Signal_Rt(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not used
    //  3 --> Error indicator
    return 0;
}

int64_t AV_BodyCMD_02_A1_200ms::setA1_01_WshdWiperCmd(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0xc);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer << 2) & (0xc)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Auto
    //  1 --> High
    //  2 --> Low
    //  3 --> Off
    return 0;
}

int64_t AV_BodyCMD_02_A1_200ms::setAV_BodyCMD_AlvCnt2_A1Val(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[2] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[2] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    return 0;
}

int64_t AV_BodyCMD_02_A1_200ms::setAV_BodyCMD_Crc2_A1Val(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[0] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[0] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[1] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[1] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff)); // push in new data
    return 0;
}
