/// @copyright Copyright (c) 2021- Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file: /home/scotty/Downloads/Gen2_AVT_B_Control_CAN1.dbc

#include "VehicleCANLibrary/g2h/av_proto/AV_DATC_01_00ms.hpp"
#include <algorithm>
#include <string.h>

using namespace av::can::g2h::avproto;

AV_DATC_01_00ms::AV_DATC_01_00ms(const uint32_t id)
{
    canPacket_.id = id;
    canPacket_.length = AV_DATC_01_00ms_CONSTS::AV_DATC_01_00MS_PACKET_LEN;
}

AV_DATC_01_00ms::AV_DATC_01_00ms(const uint32_t id, uint8_t* const payload, const uint8_t size)
{
    canPacket_.id = id;

    if ((size <= sizeof(canPacket_.data)) && payload) {
        canPacket_.length = size;
        std::copy_n(payload, size, canPacket_.data);
    }
}

const CanFdPacket& AV_DATC_01_00ms::getCanPacket() const
{
    return canPacket_;
}

double AV_DATC_01_00ms::getAV_DATC_AlvCnt1Val() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[2]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    return output;
}

double AV_DATC_01_00ms::getAV_DATC_AutoSet_A() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> reserved
    //  1 --> AUTO ON
    //  2 --> reserved
    //  3 --> Invalid
    return output;
}

double AV_DATC_01_00ms::getAV_DATC_BlowerSet_A() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xf0);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> DATC Off
    //  1 --> reserved
    //  2 --> 1 level
    //  3 --> 2 level
    //  4 --> 3 level
    //  5 --> 4 level
    //  6 --> 5 level
    //  7 --> 6 level
    //  8 --> 7 level
    //  9 --> 8 level
    //  15 --> Invalid
    return output;
}

double AV_DATC_01_00ms::getAV_DATC_Crc1Val() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[0]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[1]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffff);                               // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);        // Unsigned value

    return output;
}

double AV_DATC_01_00ms::getAV_DATC_DrvTempCSet_A() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);         // Unsigned value

    output = (output * static_cast<double>(0.5)) + static_cast<double>(14); // (output * scale_factor) + bias

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Blank
    //  2 --> PHY=HEX*0.5 + 14
    //  3 --> PHY=HEX*0.5 + 14
    //  4 --> PHY=HEX*0.5 + 14
    //  5 --> PHY=HEX*0.5 + 14
    //  6 --> PHY=HEX*0.5 + 14
    //  7 --> PHY=HEX*0.5 + 14
    //  8 --> PHY=HEX*0.5 + 14
    //  9 --> PHY=HEX*0.5 + 14
    //  10 --> PHY=HEX*0.5 + 14
    //  11 --> PHY=HEX*0.5 + 14
    //  12 --> PHY=HEX*0.5 + 14
    //  13 --> PHY=HEX*0.5 + 14
    //  14 --> PHY=HEX*0.5 + 14
    //  15 --> PHY=HEX*0.5 + 14
    //  16 --> PHY=HEX*0.5 + 14
    //  17 --> PHY=HEX*0.5 + 14
    //  18 --> PHY=HEX*0.5 + 14
    //  19 --> PHY=HEX*0.5 + 14
    //  20 --> PHY=HEX*0.5 + 14
    //  21 --> PHY=HEX*0.5 + 14
    //  22 --> PHY=HEX*0.5 + 14
    //  23 --> PHY=HEX*0.5 + 14
    //  24 --> PHY=HEX*0.5 + 14
    //  25 --> PHY=HEX*0.5 + 14
    //  26 --> PHY=HEX*0.5 + 14
    //  27 --> PHY=HEX*0.5 + 14
    //  28 --> PHY=HEX*0.5 + 14
    //  29 --> PHY=HEX*0.5 + 14
    //  30 --> PHY=HEX*0.5 + 14
    //  31 --> PHY=HEX*0.5 + 14
    //  32 --> PHY=HEX*0.5 + 14
    //  33 --> PHY=HEX*0.5 + 14
    //  34 --> PHY=HEX*0.5 + 14
    //  35 --> PHY=HEX*0.5 + 14
    //  36 --> PHY=HEX*0.5 + 14
    //  37 --> 0x25~0xFD:Reserved
    //  253 --> 0x25~0xFD:Reserved
    //  255 --> Invalid
    return output;
}

double AV_DATC_01_00ms::getAV_DATC_DrvTempFSet_A() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);         // Unsigned value

    output = output + static_cast<double>(56); // output + bias

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Blank
    //  2 --> PHY=HEX*1 + 56
    //  3 --> PHY=HEX*1 + 56
    //  4 --> PHY=HEX*1 + 56
    //  5 --> PHY=HEX*1 + 56
    //  6 --> PHY=HEX*1 + 56
    //  7 --> PHY=HEX*1 + 56
    //  8 --> PHY=HEX*1 + 56
    //  9 --> PHY=HEX*1 + 56
    //  10 --> PHY=HEX*1 + 56
    //  11 --> PHY=HEX*1 + 56
    //  12 --> PHY=HEX*1 + 56
    //  13 --> PHY=HEX*1 + 56
    //  14 --> PHY=HEX*1 + 56
    //  15 --> PHY=HEX*1 + 56
    //  16 --> PHY=HEX*1 + 56
    //  17 --> PHY=HEX*1 + 56
    //  18 --> PHY=HEX*1 + 56
    //  19 --> PHY=HEX*1 + 56
    //  20 --> PHY=HEX*1 + 56
    //  21 --> PHY=HEX*1 + 56
    //  22 --> PHY=HEX*1 + 56
    //  23 --> PHY=HEX*1 + 56
    //  24 --> PHY=HEX*1 + 56
    //  25 --> PHY=HEX*1 + 56
    //  26 --> PHY=HEX*1 + 56
    //  27 --> PHY=HEX*1 + 56
    //  28 --> PHY=HEX*1 + 56
    //  29 --> PHY=HEX*1 + 56
    //  30 --> PHY=HEX*1 + 56
    //  31 --> PHY=HEX*1 + 56
    //  32 --> PHY=HEX*1 + 56
    //  33 --> PHY=HEX*1 + 56
    //  34 --> PHY=HEX*1 + 56
    //  35 --> PHY=HEX*1 + 56
    //  36 --> PHY=HEX*1 + 56
    //  37 --> 0x25~0xFD:Reserved
    //  253 --> 0x25~0xFD:Reserved
    //  255 --> Invalid
    return output;
}

double AV_DATC_01_00ms::getAV_DATC_FrDefogSet_A() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc0);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Defog Off
    //  1 --> Defog On
    //  2 --> reserved
    //  3 --> Invalid
    return output;
}

double AV_DATC_01_00ms::getAV_DATC_IntakeSet_A() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x3);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> REC Off (Fresh On)
    //  1 --> REC ON (Fresh Off
    //  2 --> reserved
    //  3 --> Invalid
    return output;
}

double AV_DATC_01_00ms::getAV_DATC_ModeSet_A() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xf);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> reserved
    //  1 --> VENT
    //  2 --> BL
    //  3 --> FLOOR
    //  4 --> MIX
    //  15 --> Invalid
    return output;
}

double AV_DATC_01_00ms::getAV_DATC_PassTempCSet_A() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[5]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);         // Unsigned value

    output = (output * static_cast<double>(0.5)) + static_cast<double>(14); // (output * scale_factor) + bias

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Blank
    //  2 --> PHY=HEX*0.5 + 14
    //  3 --> PHY=HEX*0.5 + 14
    //  4 --> PHY=HEX*0.5 + 14
    //  5 --> PHY=HEX*0.5 + 14
    //  6 --> PHY=HEX*0.5 + 14
    //  7 --> PHY=HEX*0.5 + 14
    //  8 --> PHY=HEX*0.5 + 14
    //  9 --> PHY=HEX*0.5 + 14
    //  10 --> PHY=HEX*0.5 + 14
    //  11 --> PHY=HEX*0.5 + 14
    //  12 --> PHY=HEX*0.5 + 14
    //  13 --> PHY=HEX*0.5 + 14
    //  14 --> PHY=HEX*0.5 + 14
    //  15 --> PHY=HEX*0.5 + 14
    //  16 --> PHY=HEX*0.5 + 14
    //  17 --> PHY=HEX*0.5 + 14
    //  18 --> PHY=HEX*0.5 + 14
    //  19 --> PHY=HEX*0.5 + 14
    //  20 --> PHY=HEX*0.5 + 14
    //  21 --> PHY=HEX*0.5 + 14
    //  22 --> PHY=HEX*0.5 + 14
    //  23 --> PHY=HEX*0.5 + 14
    //  24 --> PHY=HEX*0.5 + 14
    //  25 --> PHY=HEX*0.5 + 14
    //  26 --> PHY=HEX*0.5 + 14
    //  27 --> PHY=HEX*0.5 + 14
    //  28 --> PHY=HEX*0.5 + 14
    //  29 --> PHY=HEX*0.5 + 14
    //  30 --> PHY=HEX*0.5 + 14
    //  31 --> PHY=HEX*0.5 + 14
    //  32 --> PHY=HEX*0.5 + 14
    //  33 --> PHY=HEX*0.5 + 14
    //  34 --> PHY=HEX*0.5 + 14
    //  35 --> PHY=HEX*0.5 + 14
    //  36 --> PHY=HEX*0.5 + 14
    //  37 --> 0x25~0xFD:Reserved
    //  253 --> 0x25~0xFD:Reserved
    //  255 --> Invalid
    return output;
}

double AV_DATC_01_00ms::getAV_DATC_PassTempFSet_A() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);         // Unsigned value

    output = output + static_cast<double>(56); // output + bias

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Blank
    //  2 --> PHY=HEX*1 + 56
    //  3 --> PHY=HEX*1 + 56
    //  4 --> PHY=HEX*1 + 56
    //  5 --> PHY=HEX*1 + 56
    //  6 --> PHY=HEX*1 + 56
    //  7 --> PHY=HEX*1 + 56
    //  8 --> PHY=HEX*1 + 56
    //  9 --> PHY=HEX*1 + 56
    //  10 --> PHY=HEX*1 + 56
    //  11 --> PHY=HEX*1 + 56
    //  12 --> PHY=HEX*1 + 56
    //  13 --> PHY=HEX*1 + 56
    //  14 --> PHY=HEX*1 + 56
    //  15 --> PHY=HEX*1 + 56
    //  16 --> PHY=HEX*1 + 56
    //  17 --> PHY=HEX*1 + 56
    //  18 --> PHY=HEX*1 + 56
    //  19 --> PHY=HEX*1 + 56
    //  20 --> PHY=HEX*1 + 56
    //  21 --> PHY=HEX*1 + 56
    //  22 --> PHY=HEX*1 + 56
    //  23 --> PHY=HEX*1 + 56
    //  24 --> PHY=HEX*1 + 56
    //  25 --> PHY=HEX*1 + 56
    //  26 --> PHY=HEX*1 + 56
    //  27 --> PHY=HEX*1 + 56
    //  28 --> PHY=HEX*1 + 56
    //  29 --> PHY=HEX*1 + 56
    //  30 --> PHY=HEX*1 + 56
    //  31 --> PHY=HEX*1 + 56
    //  32 --> PHY=HEX*1 + 56
    //  33 --> PHY=HEX*1 + 56
    //  34 --> PHY=HEX*1 + 56
    //  35 --> PHY=HEX*1 + 56
    //  36 --> PHY=HEX*1 + 56
    //  37 --> 0x25~0xFD:Reserved
    //  253 --> 0x25~0xFD:Reserved
    //  255 --> Invalid
    return output;
}

double AV_DATC_01_00ms::getAV_DATC_TempUnitSet_A() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x30);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Celsius
    //  2 --> Fahrenheit
    //  3 --> Invalid
    return output;
}

int64_t AV_DATC_01_00ms::setAV_DATC_AlvCnt1Val(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[2] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[2] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    return 0;
}

int64_t AV_DATC_01_00ms::setAV_DATC_AutoSet_A(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[7] &= static_cast<uint8_t>(~0xc);                     // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer << 2) & (0xc)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> reserved
    //  1 --> AUTO ON
    //  2 --> reserved
    //  3 --> Invalid
    return 0;
}

int64_t AV_DATC_01_00ms::setAV_DATC_BlowerSet_A(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[7] &= static_cast<uint8_t>(~0xf0);                     // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer << 4) & (0xf0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> DATC Off
    //  1 --> reserved
    //  2 --> 1 level
    //  3 --> 2 level
    //  4 --> 3 level
    //  5 --> 4 level
    //  6 --> 5 level
    //  7 --> 6 level
    //  8 --> 7 level
    //  9 --> 8 level
    //  15 --> Invalid
    return 0;
}

int64_t AV_DATC_01_00ms::setAV_DATC_Crc1Val(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[0] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[0] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[1] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[1] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff)); // push in new data
    return 0;
}

int64_t AV_DATC_01_00ms::setAV_DATC_DrvTempCSet_A(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(14)) /
                                                  static_cast<double>(0.5)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Blank
    //  2 --> PHY=HEX*0.5 + 14
    //  3 --> PHY=HEX*0.5 + 14
    //  4 --> PHY=HEX*0.5 + 14
    //  5 --> PHY=HEX*0.5 + 14
    //  6 --> PHY=HEX*0.5 + 14
    //  7 --> PHY=HEX*0.5 + 14
    //  8 --> PHY=HEX*0.5 + 14
    //  9 --> PHY=HEX*0.5 + 14
    //  10 --> PHY=HEX*0.5 + 14
    //  11 --> PHY=HEX*0.5 + 14
    //  12 --> PHY=HEX*0.5 + 14
    //  13 --> PHY=HEX*0.5 + 14
    //  14 --> PHY=HEX*0.5 + 14
    //  15 --> PHY=HEX*0.5 + 14
    //  16 --> PHY=HEX*0.5 + 14
    //  17 --> PHY=HEX*0.5 + 14
    //  18 --> PHY=HEX*0.5 + 14
    //  19 --> PHY=HEX*0.5 + 14
    //  20 --> PHY=HEX*0.5 + 14
    //  21 --> PHY=HEX*0.5 + 14
    //  22 --> PHY=HEX*0.5 + 14
    //  23 --> PHY=HEX*0.5 + 14
    //  24 --> PHY=HEX*0.5 + 14
    //  25 --> PHY=HEX*0.5 + 14
    //  26 --> PHY=HEX*0.5 + 14
    //  27 --> PHY=HEX*0.5 + 14
    //  28 --> PHY=HEX*0.5 + 14
    //  29 --> PHY=HEX*0.5 + 14
    //  30 --> PHY=HEX*0.5 + 14
    //  31 --> PHY=HEX*0.5 + 14
    //  32 --> PHY=HEX*0.5 + 14
    //  33 --> PHY=HEX*0.5 + 14
    //  34 --> PHY=HEX*0.5 + 14
    //  35 --> PHY=HEX*0.5 + 14
    //  36 --> PHY=HEX*0.5 + 14
    //  37 --> 0x25~0xFD:Reserved
    //  253 --> 0x25~0xFD:Reserved
    //  255 --> Invalid
    return 0;
}

int64_t AV_DATC_01_00ms::setAV_DATC_DrvTempFSet_A(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value) - static_cast<int64_t>(56); // value - bias

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Blank
    //  2 --> PHY=HEX*1 + 56
    //  3 --> PHY=HEX*1 + 56
    //  4 --> PHY=HEX*1 + 56
    //  5 --> PHY=HEX*1 + 56
    //  6 --> PHY=HEX*1 + 56
    //  7 --> PHY=HEX*1 + 56
    //  8 --> PHY=HEX*1 + 56
    //  9 --> PHY=HEX*1 + 56
    //  10 --> PHY=HEX*1 + 56
    //  11 --> PHY=HEX*1 + 56
    //  12 --> PHY=HEX*1 + 56
    //  13 --> PHY=HEX*1 + 56
    //  14 --> PHY=HEX*1 + 56
    //  15 --> PHY=HEX*1 + 56
    //  16 --> PHY=HEX*1 + 56
    //  17 --> PHY=HEX*1 + 56
    //  18 --> PHY=HEX*1 + 56
    //  19 --> PHY=HEX*1 + 56
    //  20 --> PHY=HEX*1 + 56
    //  21 --> PHY=HEX*1 + 56
    //  22 --> PHY=HEX*1 + 56
    //  23 --> PHY=HEX*1 + 56
    //  24 --> PHY=HEX*1 + 56
    //  25 --> PHY=HEX*1 + 56
    //  26 --> PHY=HEX*1 + 56
    //  27 --> PHY=HEX*1 + 56
    //  28 --> PHY=HEX*1 + 56
    //  29 --> PHY=HEX*1 + 56
    //  30 --> PHY=HEX*1 + 56
    //  31 --> PHY=HEX*1 + 56
    //  32 --> PHY=HEX*1 + 56
    //  33 --> PHY=HEX*1 + 56
    //  34 --> PHY=HEX*1 + 56
    //  35 --> PHY=HEX*1 + 56
    //  36 --> PHY=HEX*1 + 56
    //  37 --> 0x25~0xFD:Reserved
    //  253 --> 0x25~0xFD:Reserved
    //  255 --> Invalid
    return 0;
}

int64_t AV_DATC_01_00ms::setAV_DATC_FrDefogSet_A(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[8] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Defog Off
    //  1 --> Defog On
    //  2 --> reserved
    //  3 --> Invalid
    return 0;
}

int64_t AV_DATC_01_00ms::setAV_DATC_IntakeSet_A(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[7] &= static_cast<uint8_t>(~0x3);                // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer) & (0x3)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> REC Off (Fresh On)
    //  1 --> REC ON (Fresh Off
    //  2 --> reserved
    //  3 --> Invalid
    return 0;
}

int64_t AV_DATC_01_00ms::setAV_DATC_ModeSet_A(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[8] &= static_cast<uint8_t>(~0xf);                // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer) & (0xf)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> reserved
    //  1 --> VENT
    //  2 --> BL
    //  3 --> FLOOR
    //  4 --> MIX
    //  15 --> Invalid
    return 0;
}

int64_t AV_DATC_01_00ms::setAV_DATC_PassTempCSet_A(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(14)) /
                                                  static_cast<double>(0.5)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[5] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[5] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Blank
    //  2 --> PHY=HEX*0.5 + 14
    //  3 --> PHY=HEX*0.5 + 14
    //  4 --> PHY=HEX*0.5 + 14
    //  5 --> PHY=HEX*0.5 + 14
    //  6 --> PHY=HEX*0.5 + 14
    //  7 --> PHY=HEX*0.5 + 14
    //  8 --> PHY=HEX*0.5 + 14
    //  9 --> PHY=HEX*0.5 + 14
    //  10 --> PHY=HEX*0.5 + 14
    //  11 --> PHY=HEX*0.5 + 14
    //  12 --> PHY=HEX*0.5 + 14
    //  13 --> PHY=HEX*0.5 + 14
    //  14 --> PHY=HEX*0.5 + 14
    //  15 --> PHY=HEX*0.5 + 14
    //  16 --> PHY=HEX*0.5 + 14
    //  17 --> PHY=HEX*0.5 + 14
    //  18 --> PHY=HEX*0.5 + 14
    //  19 --> PHY=HEX*0.5 + 14
    //  20 --> PHY=HEX*0.5 + 14
    //  21 --> PHY=HEX*0.5 + 14
    //  22 --> PHY=HEX*0.5 + 14
    //  23 --> PHY=HEX*0.5 + 14
    //  24 --> PHY=HEX*0.5 + 14
    //  25 --> PHY=HEX*0.5 + 14
    //  26 --> PHY=HEX*0.5 + 14
    //  27 --> PHY=HEX*0.5 + 14
    //  28 --> PHY=HEX*0.5 + 14
    //  29 --> PHY=HEX*0.5 + 14
    //  30 --> PHY=HEX*0.5 + 14
    //  31 --> PHY=HEX*0.5 + 14
    //  32 --> PHY=HEX*0.5 + 14
    //  33 --> PHY=HEX*0.5 + 14
    //  34 --> PHY=HEX*0.5 + 14
    //  35 --> PHY=HEX*0.5 + 14
    //  36 --> PHY=HEX*0.5 + 14
    //  37 --> 0x25~0xFD:Reserved
    //  253 --> 0x25~0xFD:Reserved
    //  255 --> Invalid
    return 0;
}

int64_t AV_DATC_01_00ms::setAV_DATC_PassTempFSet_A(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value) - static_cast<int64_t>(56); // value - bias

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[6] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Blank
    //  2 --> PHY=HEX*1 + 56
    //  3 --> PHY=HEX*1 + 56
    //  4 --> PHY=HEX*1 + 56
    //  5 --> PHY=HEX*1 + 56
    //  6 --> PHY=HEX*1 + 56
    //  7 --> PHY=HEX*1 + 56
    //  8 --> PHY=HEX*1 + 56
    //  9 --> PHY=HEX*1 + 56
    //  10 --> PHY=HEX*1 + 56
    //  11 --> PHY=HEX*1 + 56
    //  12 --> PHY=HEX*1 + 56
    //  13 --> PHY=HEX*1 + 56
    //  14 --> PHY=HEX*1 + 56
    //  15 --> PHY=HEX*1 + 56
    //  16 --> PHY=HEX*1 + 56
    //  17 --> PHY=HEX*1 + 56
    //  18 --> PHY=HEX*1 + 56
    //  19 --> PHY=HEX*1 + 56
    //  20 --> PHY=HEX*1 + 56
    //  21 --> PHY=HEX*1 + 56
    //  22 --> PHY=HEX*1 + 56
    //  23 --> PHY=HEX*1 + 56
    //  24 --> PHY=HEX*1 + 56
    //  25 --> PHY=HEX*1 + 56
    //  26 --> PHY=HEX*1 + 56
    //  27 --> PHY=HEX*1 + 56
    //  28 --> PHY=HEX*1 + 56
    //  29 --> PHY=HEX*1 + 56
    //  30 --> PHY=HEX*1 + 56
    //  31 --> PHY=HEX*1 + 56
    //  32 --> PHY=HEX*1 + 56
    //  33 --> PHY=HEX*1 + 56
    //  34 --> PHY=HEX*1 + 56
    //  35 --> PHY=HEX*1 + 56
    //  36 --> PHY=HEX*1 + 56
    //  37 --> 0x25~0xFD:Reserved
    //  253 --> 0x25~0xFD:Reserved
    //  255 --> Invalid
    return 0;
}

int64_t AV_DATC_01_00ms::setAV_DATC_TempUnitSet_A(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[8] &= static_cast<uint8_t>(~0x30);                     // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer << 4) & (0x30)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Celsius
    //  2 --> Fahrenheit
    //  3 --> Invalid
    return 0;
}
