/// @copyright Copyright (c) 2022 - Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file:
/// https://gitlab.ci.motional.com/systems/av-netwrok-infrastructure/Gen2-AVT-Sample-B/-/blob/dd539e5d752bcae0408ed2b8f29b270cc0db624e/Gen2_AVT_B_Control_CAN1.dbc

#include "VehicleCANLibrary/g2h/av_proto/AV_Heading_B_4.hpp"
#include <algorithm>
#include <string.h>

using namespace av::can::g2h::avproto;

AV_Heading_B_4::AV_Heading_B_4(const uint32_t id)
{
    canPacket_.id = id;
    canPacket_.length = AV_Heading_B_4_CONSTS::AV_HEADING_B_4_PACKET_LEN;
}

AV_Heading_B_4::AV_Heading_B_4(const uint32_t id, uint8_t* const payload, const uint8_t size)
{
    canPacket_.id = id;

    if ((size <= sizeof(canPacket_.data)) && payload) {
        canPacket_.length = size;
        std::copy_n(payload, size, canPacket_.data);
    }
}

const CanFdPacket& AV_Heading_B_4::getCanPacket() const
{
    return canPacket_;
}

double AV_Heading_B_4::getALIV_AV_Heading_B_4() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[2]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    return output;
}

double AV_Heading_B_4::getAUTH_AV_Waypoint_B() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[27]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[28]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[29]) << 16; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[30]) << 24; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[31]) << 32; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffffffffff);                           // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);          // Unsigned value

    return output;
}

double AV_Heading_B_4::getCRC_AV_Heading_B_4() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[0]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[1]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffff);                               // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);        // Unsigned value

    return output;
}

double AV_Heading_B_4::getFV_AV_Waypoint_B() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[20]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[21]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[22]) << 16; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[23]) << 24; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[24]) << 32; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[25]) << 40; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[26]) << 48; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffffffffffffff);                       // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);                // Unsigned value

    if ((output > static_cast<double>(7.20575940379279e+16)) || (output < static_cast<double>(0))) // check for boundary
    {
        output = static_cast<double>(AV_Heading_B_4_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Heading_B_4::getu_Heading_B_52() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1fff);                               // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);              // Unsigned value

    output = (output * static_cast<double>(0.00087)) + static_cast<double>(-3.1415); // (output * scale_factor) + bias

    if ((output > static_cast<double>(3.1415)) || (output < static_cast<double>(-3.1415))) // check for boundary
    {
        output = static_cast<double>(AV_Heading_B_4_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Heading_B_4::getu_Heading_B_53() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[5]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]) << 16; // Bytes containing signal
    bitBuffer &= UINT64_C(0x3ffe0);                               // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.00087)) + static_cast<double>(-3.1415); // (output * scale_factor) + bias

    if ((output > static_cast<double>(3.1415)) || (output < static_cast<double>(-3.1415))) // check for boundary
    {
        output = static_cast<double>(AV_Heading_B_4_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Heading_B_4::getu_Heading_B_54() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x7ffc);                               // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                                  // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.00087)) + static_cast<double>(-3.1415); // (output * scale_factor) + bias

    if ((output > static_cast<double>(3.1415)) || (output < static_cast<double>(-3.1415))) // check for boundary
    {
        output = static_cast<double>(AV_Heading_B_4_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Heading_B_4::getu_Heading_B_55() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]) << 16; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff80);                               // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.00087)) + static_cast<double>(-3.1415); // (output * scale_factor) + bias

    if ((output > static_cast<double>(3.1415)) || (output < static_cast<double>(-3.1415))) // check for boundary
    {
        output = static_cast<double>(AV_Heading_B_4_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Heading_B_4::getu_Heading_B_56() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]);        // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[11]) << 16; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1fff0);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                                    // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.00087)) + static_cast<double>(-3.1415); // (output * scale_factor) + bias

    if ((output > static_cast<double>(3.1415)) || (output < static_cast<double>(-3.1415))) // check for boundary
    {
        output = static_cast<double>(AV_Heading_B_4_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Heading_B_4::getu_Heading_B_57() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[11]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[12]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x3ffe);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.00087)) + static_cast<double>(-3.1415); // (output * scale_factor) + bias

    if ((output > static_cast<double>(3.1415)) || (output < static_cast<double>(-3.1415))) // check for boundary
    {
        output = static_cast<double>(AV_Heading_B_4_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Heading_B_4::getu_Heading_B_58() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[12]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[13]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[14]) << 16; // Bytes containing signal
    bitBuffer &= UINT64_C(0x7ffc0);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                                    // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.00087)) + static_cast<double>(-3.1415); // (output * scale_factor) + bias

    if ((output > static_cast<double>(3.1415)) || (output < static_cast<double>(-3.1415))) // check for boundary
    {
        output = static_cast<double>(AV_Heading_B_4_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Heading_B_4::getu_Heading_B_59() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[14]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[15]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff8);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.00087)) + static_cast<double>(-3.1415); // (output * scale_factor) + bias

    if ((output > static_cast<double>(3.1415)) || (output < static_cast<double>(-3.1415))) // check for boundary
    {
        output = static_cast<double>(AV_Heading_B_4_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Heading_B_4::getu_Heading_B_60() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[16]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[17]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1fff);                                // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);               // Unsigned value

    output = (output * static_cast<double>(0.00087)) + static_cast<double>(-3.1415); // (output * scale_factor) + bias

    if ((output > static_cast<double>(3.1415)) || (output < static_cast<double>(-3.1415))) // check for boundary
    {
        output = static_cast<double>(AV_Heading_B_4_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

int64_t AV_Heading_B_4::setALIV_AV_Heading_B_4(const double value) noexcept
{
    if ((value > static_cast<double>(255)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Heading_B_4_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[2] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[2] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    return 0;
}

int64_t AV_Heading_B_4::setAUTH_AV_Waypoint_B(const double value) noexcept
{
    if ((value > static_cast<double>(1099511627775)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Heading_B_4_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[27] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[27] |= static_cast<uint8_t>((bitBuffer) & (0xff));       // push in new data
    canPacket_.data[28] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[28] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff));  // push in new data
    canPacket_.data[29] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[29] |= static_cast<uint8_t>((bitBuffer >> 16) & (0xff)); // push in new data
    canPacket_.data[30] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[30] |= static_cast<uint8_t>((bitBuffer >> 24) & (0xff)); // push in new data
    canPacket_.data[31] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[31] |= static_cast<uint8_t>((bitBuffer >> 32) & (0xff)); // push in new data
    return 0;
}

int64_t AV_Heading_B_4::setCRC_AV_Heading_B_4(const double value) noexcept
{
    if ((value > static_cast<double>(65535)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Heading_B_4_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[0] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[0] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[1] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[1] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff)); // push in new data
    return 0;
}

int64_t AV_Heading_B_4::setFV_AV_Waypoint_B(const double value) noexcept
{
    if ((value > static_cast<double>(7.20575940379279e+16)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Heading_B_4_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[20] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[20] |= static_cast<uint8_t>((bitBuffer) & (0xff));       // push in new data
    canPacket_.data[21] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[21] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff));  // push in new data
    canPacket_.data[22] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[22] |= static_cast<uint8_t>((bitBuffer >> 16) & (0xff)); // push in new data
    canPacket_.data[23] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[23] |= static_cast<uint8_t>((bitBuffer >> 24) & (0xff)); // push in new data
    canPacket_.data[24] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[24] |= static_cast<uint8_t>((bitBuffer >> 32) & (0xff)); // push in new data
    canPacket_.data[25] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[25] |= static_cast<uint8_t>((bitBuffer >> 40) & (0xff)); // push in new data
    canPacket_.data[26] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[26] |= static_cast<uint8_t>((bitBuffer >> 48) & (0xff)); // push in new data
    return 0;
}

int64_t AV_Heading_B_4::setu_Heading_B_52(const double value) noexcept
{
    if ((value > static_cast<double>(3.1415)) ||
        (value < static_cast<double>(-3.1415))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Heading_B_4_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-3.1415)) /
                                                  static_cast<double>(0.00087)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[4] &= static_cast<uint8_t>(~0x1f);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer >> 8) & (0x1f)); // push in new data
    return 0;
}

int64_t AV_Heading_B_4::setu_Heading_B_53(const double value) noexcept
{
    if ((value > static_cast<double>(3.1415)) ||
        (value < static_cast<double>(-3.1415))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Heading_B_4_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-3.1415)) /
                                                  static_cast<double>(0.00087)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0xe0);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer << 5) & (0xe0)); // push in new data
    canPacket_.data[5] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[5] |= static_cast<uint8_t>((bitBuffer >> 3) & (0xff)); // push in new data
    canPacket_.data[6] &= static_cast<uint8_t>(~0x3);                      // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer >> 11) & (0x3)); // push in new data
    return 0;
}

int64_t AV_Heading_B_4::setu_Heading_B_54(const double value) noexcept
{
    if ((value > static_cast<double>(3.1415)) ||
        (value < static_cast<double>(-3.1415))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Heading_B_4_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-3.1415)) /
                                                  static_cast<double>(0.00087)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[6] &= static_cast<uint8_t>(~0xfc);                     // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer << 2) & (0xfc)); // push in new data
    canPacket_.data[7] &= static_cast<uint8_t>(~0x7f);                     // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer >> 6) & (0x7f)); // push in new data
    return 0;
}

int64_t AV_Heading_B_4::setu_Heading_B_55(const double value) noexcept
{
    if ((value > static_cast<double>(3.1415)) ||
        (value < static_cast<double>(-3.1415))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Heading_B_4_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-3.1415)) /
                                                  static_cast<double>(0.00087)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[7] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    canPacket_.data[8] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer >> 1) & (0xff)); // push in new data
    canPacket_.data[9] &= static_cast<uint8_t>(~0xf);                      // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer >> 9) & (0xf));  // push in new data
    return 0;
}

int64_t AV_Heading_B_4::setu_Heading_B_56(const double value) noexcept
{
    if ((value > static_cast<double>(3.1415)) ||
        (value < static_cast<double>(-3.1415))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Heading_B_4_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-3.1415)) /
                                                  static_cast<double>(0.00087)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[9] &= static_cast<uint8_t>(~0xf0);                      // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer << 4) & (0xf0));  // push in new data
    canPacket_.data[10] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer >> 4) & (0xff)); // push in new data
    canPacket_.data[11] &= static_cast<uint8_t>(~0x1);                      // clear the bits for new data
    canPacket_.data[11] |= static_cast<uint8_t>((bitBuffer >> 12) & (0x1)); // push in new data
    return 0;
}

int64_t AV_Heading_B_4::setu_Heading_B_57(const double value) noexcept
{
    if ((value > static_cast<double>(3.1415)) ||
        (value < static_cast<double>(-3.1415))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Heading_B_4_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-3.1415)) /
                                                  static_cast<double>(0.00087)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[11] &= static_cast<uint8_t>(~0xfe);                     // clear the bits for new data
    canPacket_.data[11] |= static_cast<uint8_t>((bitBuffer << 1) & (0xfe)); // push in new data
    canPacket_.data[12] &= static_cast<uint8_t>(~0x3f);                     // clear the bits for new data
    canPacket_.data[12] |= static_cast<uint8_t>((bitBuffer >> 7) & (0x3f)); // push in new data
    return 0;
}

int64_t AV_Heading_B_4::setu_Heading_B_58(const double value) noexcept
{
    if ((value > static_cast<double>(3.1415)) ||
        (value < static_cast<double>(-3.1415))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Heading_B_4_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-3.1415)) /
                                                  static_cast<double>(0.00087)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[12] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[12] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    canPacket_.data[13] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[13] |= static_cast<uint8_t>((bitBuffer >> 2) & (0xff)); // push in new data
    canPacket_.data[14] &= static_cast<uint8_t>(~0x7);                      // clear the bits for new data
    canPacket_.data[14] |= static_cast<uint8_t>((bitBuffer >> 10) & (0x7)); // push in new data
    return 0;
}

int64_t AV_Heading_B_4::setu_Heading_B_59(const double value) noexcept
{
    if ((value > static_cast<double>(3.1415)) ||
        (value < static_cast<double>(-3.1415))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Heading_B_4_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-3.1415)) /
                                                  static_cast<double>(0.00087)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[14] &= static_cast<uint8_t>(~0xf8);                     // clear the bits for new data
    canPacket_.data[14] |= static_cast<uint8_t>((bitBuffer << 3) & (0xf8)); // push in new data
    canPacket_.data[15] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[15] |= static_cast<uint8_t>((bitBuffer >> 5) & (0xff)); // push in new data
    return 0;
}

int64_t AV_Heading_B_4::setu_Heading_B_60(const double value) noexcept
{
    if ((value > static_cast<double>(3.1415)) ||
        (value < static_cast<double>(-3.1415))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Heading_B_4_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-3.1415)) /
                                                  static_cast<double>(0.00087)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[16] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[16] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[17] &= static_cast<uint8_t>(~0x1f);                     // clear the bits for new data
    canPacket_.data[17] |= static_cast<uint8_t>((bitBuffer >> 8) & (0x1f)); // push in new data
    return 0;
}
