/// @copyright Copyright (c) 2021- Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file: /home/scotty/Downloads/Gen2_AVT_B_Control_CAN1.dbc

#include <VehicleCANLibrary/g2h/av_proto/AV_MLM_04_00ms.hpp>
#include <algorithm>
#include <string.h>

using namespace av::can::g2h::avproto;

AV_MLM_04_00ms::AV_MLM_04_00ms(const uint32_t id)
{
    canPacket_.id = id;
    canPacket_.length = AV_MLM_04_00ms_CONSTS::AV_MLM_04_00MS_PACKET_LEN;
}

AV_MLM_04_00ms::AV_MLM_04_00ms(const uint32_t id, uint8_t* const payload, const uint8_t size)
{
    canPacket_.id = id;

    if ((size <= sizeof(canPacket_.data)) && payload) {
        canPacket_.length = size;
        std::copy_n(payload, size, canPacket_.data);
    }
}

const CanFdPacket& AV_MLM_04_00ms::getCanPacket() const
{
    return canPacket_;
}

double AV_MLM_04_00ms::getAV_LEDStips_RLBrightness() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x7);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> 4Step
    //  6 --> RESERVED
    //  7 --> Invalid
    return output;
}

double AV_MLM_04_00ms::getAV_LEDStips_RLColor_B() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[2]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x7fc);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                                  // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0x0FF:Blue Color 0~255 (User Selection)
    //  255 --> 0x0x000~0x0FF:Blue Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:RESERVED
    //  510 --> 0x101~0x1FE:RESERVED
    //  511 --> Invalid
    return output;
}

double AV_MLM_04_00ms::getAV_LEDStips_RLColor_G() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[1]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[2]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x3fe);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                                  // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0x0FF:Green Color 0~255 (User Selection)
    //  255 --> 0x0x000~0x0FF:Green Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:RESERVED
    //  510 --> 0x101~0x1FE:RESERVED
    //  511 --> Invalid
    return output;
}

double AV_MLM_04_00ms::getAV_LEDStips_RLColor_R() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[0]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[1]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1ff);                                // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);        // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0x0FF:Red Color 0~255 (User Selection)
    //  255 --> 0x0x000~0x0FF:Red Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:RESERVED
    //  510 --> 0x101~0x1FE:RESERVED
    //  511 --> Invalid
    return output;
}

double AV_MLM_04_00ms::getAV_LEDStips_RLFrequency() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x38);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> RESERVED
    //  6 --> RESERVED
    //  7 --> Invalid
    return output;
}

double AV_MLM_04_00ms::getAV_LEDStips_RLPattern() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xf8);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Pattern1
    //  2 --> Pattern2
    //  3 --> Pattern3
    //  4 --> Pattern4
    //  5 --> Pattern5
    //  6 --> Pattern6
    //  7 --> Pattern7
    //  8 --> Pattern8
    //  9 --> Pattern9
    //  10 --> RESERVED
    //  11 --> RESERVED
    //  12 --> RESERVED
    //  13 --> RESERVED
    //  14 --> RESERVED
    //  15 --> RESERVED
    //  16 --> RESERVED
    //  17 --> RESERVED
    //  18 --> RESERVED
    //  19 --> RESERVED
    //  20 --> RESERVED
    //  21 --> RESERVED
    //  22 --> RESERVED
    //  23 --> RESERVED
    //  24 --> RESERVED
    //  25 --> RESERVED
    //  26 --> RESERVED
    //  27 --> RESERVED
    //  28 --> RESERVED
    //  29 --> RESERVED
    //  30 --> RESERVED
    //  31 --> Invalid
    return output;
}

double AV_MLM_04_00ms::getAV_LEDStips_RLPower_OnOff() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[5]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> On
    //  3 --> Invalid
    return output;
}

double AV_MLM_04_00ms::getAV_LEDStips_RLSpeed() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[5]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x3c0);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                                  // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> 4Step
    //  6 --> 5Step
    //  7 --> 6Step
    //  8 --> 7Step
    //  9 --> 8Step
    //  10 --> RESERVED
    //  11 --> RESERVED
    //  12 --> RESERVED
    //  13 --> RESERVED
    //  14 --> RESERVED
    //  15 --> Invalid
    return output;
}

int64_t AV_MLM_04_00ms::setAV_LEDStips_RLBrightness(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0x7);                // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer) & (0x7)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> 4Step
    //  6 --> RESERVED
    //  7 --> Invalid
    return 0;
}

int64_t AV_MLM_04_00ms::setAV_LEDStips_RLColor_B(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[2] &= static_cast<uint8_t>(~0xfc);                     // clear the bits for new data
    canPacket_.data[2] |= static_cast<uint8_t>((bitBuffer << 2) & (0xfc)); // push in new data
    canPacket_.data[3] &= static_cast<uint8_t>(~0x7);                      // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer >> 6) & (0x7));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0x0FF:Blue Color 0~255 (User Selection)
    //  255 --> 0x0x000~0x0FF:Blue Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:RESERVED
    //  510 --> 0x101~0x1FE:RESERVED
    //  511 --> Invalid
    return 0;
}

int64_t AV_MLM_04_00ms::setAV_LEDStips_RLColor_G(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[1] &= static_cast<uint8_t>(~0xfe);                     // clear the bits for new data
    canPacket_.data[1] |= static_cast<uint8_t>((bitBuffer << 1) & (0xfe)); // push in new data
    canPacket_.data[2] &= static_cast<uint8_t>(~0x3);                      // clear the bits for new data
    canPacket_.data[2] |= static_cast<uint8_t>((bitBuffer >> 7) & (0x3));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0x0FF:Green Color 0~255 (User Selection)
    //  255 --> 0x0x000~0x0FF:Green Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:RESERVED
    //  510 --> 0x101~0x1FE:RESERVED
    //  511 --> Invalid
    return 0;
}

int64_t AV_MLM_04_00ms::setAV_LEDStips_RLColor_R(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[0] &= static_cast<uint8_t>(~0xff);                    // clear the bits for new data
    canPacket_.data[0] |= static_cast<uint8_t>((bitBuffer) & (0xff));     // push in new data
    canPacket_.data[1] &= static_cast<uint8_t>(~0x1);                     // clear the bits for new data
    canPacket_.data[1] |= static_cast<uint8_t>((bitBuffer >> 8) & (0x1)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0x0FF:Red Color 0~255 (User Selection)
    //  255 --> 0x0x000~0x0FF:Red Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:RESERVED
    //  510 --> 0x101~0x1FE:RESERVED
    //  511 --> Invalid
    return 0;
}

int64_t AV_MLM_04_00ms::setAV_LEDStips_RLFrequency(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0x38);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer << 3) & (0x38)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> RESERVED
    //  6 --> RESERVED
    //  7 --> Invalid
    return 0;
}

int64_t AV_MLM_04_00ms::setAV_LEDStips_RLPattern(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0xf8);                     // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer << 3) & (0xf8)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Pattern1
    //  2 --> Pattern2
    //  3 --> Pattern3
    //  4 --> Pattern4
    //  5 --> Pattern5
    //  6 --> Pattern6
    //  7 --> Pattern7
    //  8 --> Pattern8
    //  9 --> Pattern9
    //  10 --> RESERVED
    //  11 --> RESERVED
    //  12 --> RESERVED
    //  13 --> RESERVED
    //  14 --> RESERVED
    //  15 --> RESERVED
    //  16 --> RESERVED
    //  17 --> RESERVED
    //  18 --> RESERVED
    //  19 --> RESERVED
    //  20 --> RESERVED
    //  21 --> RESERVED
    //  22 --> RESERVED
    //  23 --> RESERVED
    //  24 --> RESERVED
    //  25 --> RESERVED
    //  26 --> RESERVED
    //  27 --> RESERVED
    //  28 --> RESERVED
    //  29 --> RESERVED
    //  30 --> RESERVED
    //  31 --> Invalid
    return 0;
}

int64_t AV_MLM_04_00ms::setAV_LEDStips_RLPower_OnOff(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[5] &= static_cast<uint8_t>(~0xc);                     // clear the bits for new data
    canPacket_.data[5] |= static_cast<uint8_t>((bitBuffer << 2) & (0xc)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> On
    //  3 --> Invalid
    return 0;
}

int64_t AV_MLM_04_00ms::setAV_LEDStips_RLSpeed(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    canPacket_.data[5] &= static_cast<uint8_t>(~0x3);                      // clear the bits for new data
    canPacket_.data[5] |= static_cast<uint8_t>((bitBuffer >> 2) & (0x3));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> 4Step
    //  6 --> 5Step
    //  7 --> 6Step
    //  8 --> 7Step
    //  9 --> 8Step
    //  10 --> RESERVED
    //  11 --> RESERVED
    //  12 --> RESERVED
    //  13 --> RESERVED
    //  14 --> RESERVED
    //  15 --> Invalid
    return 0;
}
