/// @copyright Copyright (c) 2022 - Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file:
/// https://gitlab.ci.motional.com/systems/av-netwrok-infrastructure/Gen2-AVT-Sample-B/-/blob/dd539e5d752bcae0408ed2b8f29b270cc0db624e/Gen2_AVT_B_Control_CAN1.dbc

#include "VehicleCANLibrary/g2h/av_proto/AV_Waypoints_A_X3.hpp"
#include <algorithm>
#include <string.h>

using namespace av::can::g2h::avproto;

AV_Waypoints_A_X3::AV_Waypoints_A_X3(const uint32_t id)
{
    canPacket_.id = id;
    canPacket_.length = AV_Waypoints_A_X3_CONSTS::AV_WAYPOINTS_A_X3_PACKET_LEN;
}

AV_Waypoints_A_X3::AV_Waypoints_A_X3(const uint32_t id, uint8_t* const payload, const uint8_t size)
{
    canPacket_.id = id;

    if ((size <= sizeof(canPacket_.data)) && payload) {
        canPacket_.length = size;
        std::copy_n(payload, size, canPacket_.data);
    }
}

const CanFdPacket& AV_Waypoints_A_X3::getCanPacket() const
{
    return canPacket_;
}

double AV_Waypoints_A_X3::getALIV_AV_Waypoints_A_X3() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[2]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    return output;
}

double AV_Waypoints_A_X3::getCRC_AV_Waypoints_A_X3() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[0]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[1]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffff);                               // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);        // Unsigned value

    return output;
}

double AV_Waypoints_A_X3::getL_Waypoint_A_X35() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1fff);                               // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);              // Unsigned value

    output = (output * static_cast<double>(0.0003)) + static_cast<double>(-1.2); // (output * scale_factor) + bias

    if ((output > static_cast<double>(1.2)) || (output < static_cast<double>(-1.2))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Waypoints_A_X3::getL_Waypoint_A_X36() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[5]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]) << 16; // Bytes containing signal
    bitBuffer &= UINT64_C(0x3ffe0);                               // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.0003)) + static_cast<double>(-1.2); // (output * scale_factor) + bias

    if ((output > static_cast<double>(1.2)) || (output < static_cast<double>(-1.2))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Waypoints_A_X3::getL_Waypoint_A_X37() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x7ffc);                               // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                                  // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.0003)) + static_cast<double>(-1.2); // (output * scale_factor) + bias

    if ((output > static_cast<double>(1.2)) || (output < static_cast<double>(-1.2))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Waypoints_A_X3::getL_Waypoint_A_X38() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]) << 16; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff80);                               // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.0003)) + static_cast<double>(-1.2); // (output * scale_factor) + bias

    if ((output > static_cast<double>(1.2)) || (output < static_cast<double>(-1.2))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Waypoints_A_X3::getL_Waypoint_A_X39() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]);        // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[11]) << 16; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1fff0);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                                    // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.0003)) + static_cast<double>(-1.2); // (output * scale_factor) + bias

    if ((output > static_cast<double>(1.2)) || (output < static_cast<double>(-1.2))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Waypoints_A_X3::getL_Waypoint_A_X40() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[11]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[12]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x3ffe);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.0003)) + static_cast<double>(-1.2); // (output * scale_factor) + bias

    if ((output > static_cast<double>(1.2)) || (output < static_cast<double>(-1.2))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Waypoints_A_X3::getL_Waypoint_A_X41() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[12]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[13]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[14]) << 16; // Bytes containing signal
    bitBuffer &= UINT64_C(0x7ffc0);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                                    // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.0003)) + static_cast<double>(-1.2); // (output * scale_factor) + bias

    if ((output > static_cast<double>(1.2)) || (output < static_cast<double>(-1.2))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Waypoints_A_X3::getL_Waypoint_A_X42() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[14]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[15]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff8);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.0003)) + static_cast<double>(-1.2); // (output * scale_factor) + bias

    if ((output > static_cast<double>(1.2)) || (output < static_cast<double>(-1.2))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Waypoints_A_X3::getL_Waypoint_A_X43() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[16]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[17]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1fff);                                // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);               // Unsigned value

    output = (output * static_cast<double>(0.0003)) + static_cast<double>(-1.2); // (output * scale_factor) + bias

    if ((output > static_cast<double>(1.2)) || (output < static_cast<double>(-1.2))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Waypoints_A_X3::getL_Waypoint_A_X44() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[17]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[18]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[19]) << 16; // Bytes containing signal
    bitBuffer &= UINT64_C(0x3ffe0);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                                    // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.0003)) + static_cast<double>(-1.2); // (output * scale_factor) + bias

    if ((output > static_cast<double>(1.2)) || (output < static_cast<double>(-1.2))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Waypoints_A_X3::getL_Waypoint_A_X45() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[19]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[20]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x7ffc);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.0003)) + static_cast<double>(-1.2); // (output * scale_factor) + bias

    if ((output > static_cast<double>(1.2)) || (output < static_cast<double>(-1.2))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Waypoints_A_X3::getL_Waypoint_A_X46() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[20]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[21]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[22]) << 16; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff80);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                                    // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.0003)) + static_cast<double>(-1.2); // (output * scale_factor) + bias

    if ((output > static_cast<double>(1.2)) || (output < static_cast<double>(-1.2))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Waypoints_A_X3::getL_Waypoint_A_X47() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[22]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[23]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[24]) << 16; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1fff0);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                                    // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.0003)) + static_cast<double>(-1.2); // (output * scale_factor) + bias

    if ((output > static_cast<double>(1.2)) || (output < static_cast<double>(-1.2))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Waypoints_A_X3::getL_Waypoint_A_X48() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[24]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[25]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x3ffe);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.0003)) + static_cast<double>(-1.2); // (output * scale_factor) + bias

    if ((output > static_cast<double>(1.2)) || (output < static_cast<double>(-1.2))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Waypoints_A_X3::getL_Waypoint_A_X49() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[25]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[26]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[27]) << 16; // Bytes containing signal
    bitBuffer &= UINT64_C(0x7ffc0);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                                    // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.0003)) + static_cast<double>(-1.2); // (output * scale_factor) + bias

    if ((output > static_cast<double>(1.2)) || (output < static_cast<double>(-1.2))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Waypoints_A_X3::getL_Waypoint_A_X50() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[27]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[28]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff8);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.0003)) + static_cast<double>(-1.2); // (output * scale_factor) + bias

    if ((output > static_cast<double>(1.2)) || (output < static_cast<double>(-1.2))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Waypoints_A_X3::getL_Waypoint_A_X51() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[29]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[30]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1fff);                                // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);               // Unsigned value

    output = (output * static_cast<double>(0.0003)) + static_cast<double>(-1.2); // (output * scale_factor) + bias

    if ((output > static_cast<double>(1.2)) || (output < static_cast<double>(-1.2))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

int64_t AV_Waypoints_A_X3::setALIV_AV_Waypoints_A_X3(const double value) noexcept
{
    if ((value > static_cast<double>(255)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[2] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[2] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    return 0;
}

int64_t AV_Waypoints_A_X3::setCRC_AV_Waypoints_A_X3(const double value) noexcept
{
    if ((value > static_cast<double>(65535)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[0] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[0] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[1] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[1] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff)); // push in new data
    return 0;
}

int64_t AV_Waypoints_A_X3::setL_Waypoint_A_X35(const double value) noexcept
{
    if ((value > static_cast<double>(1.2)) ||
        (value < static_cast<double>(-1.2))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-1.2)) /
                                                  static_cast<double>(0.0003)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[4] &= static_cast<uint8_t>(~0x1f);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer >> 8) & (0x1f)); // push in new data
    return 0;
}

int64_t AV_Waypoints_A_X3::setL_Waypoint_A_X36(const double value) noexcept
{
    if ((value > static_cast<double>(1.2)) ||
        (value < static_cast<double>(-1.2))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-1.2)) /
                                                  static_cast<double>(0.0003)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0xe0);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer << 5) & (0xe0)); // push in new data
    canPacket_.data[5] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[5] |= static_cast<uint8_t>((bitBuffer >> 3) & (0xff)); // push in new data
    canPacket_.data[6] &= static_cast<uint8_t>(~0x3);                      // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer >> 11) & (0x3)); // push in new data
    return 0;
}

int64_t AV_Waypoints_A_X3::setL_Waypoint_A_X37(const double value) noexcept
{
    if ((value > static_cast<double>(1.2)) ||
        (value < static_cast<double>(-1.2))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-1.2)) /
                                                  static_cast<double>(0.0003)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[6] &= static_cast<uint8_t>(~0xfc);                     // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer << 2) & (0xfc)); // push in new data
    canPacket_.data[7] &= static_cast<uint8_t>(~0x7f);                     // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer >> 6) & (0x7f)); // push in new data
    return 0;
}

int64_t AV_Waypoints_A_X3::setL_Waypoint_A_X38(const double value) noexcept
{
    if ((value > static_cast<double>(1.2)) ||
        (value < static_cast<double>(-1.2))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-1.2)) /
                                                  static_cast<double>(0.0003)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[7] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    canPacket_.data[8] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer >> 1) & (0xff)); // push in new data
    canPacket_.data[9] &= static_cast<uint8_t>(~0xf);                      // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer >> 9) & (0xf));  // push in new data
    return 0;
}

int64_t AV_Waypoints_A_X3::setL_Waypoint_A_X39(const double value) noexcept
{
    if ((value > static_cast<double>(1.2)) ||
        (value < static_cast<double>(-1.2))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-1.2)) /
                                                  static_cast<double>(0.0003)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[9] &= static_cast<uint8_t>(~0xf0);                      // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer << 4) & (0xf0));  // push in new data
    canPacket_.data[10] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer >> 4) & (0xff)); // push in new data
    canPacket_.data[11] &= static_cast<uint8_t>(~0x1);                      // clear the bits for new data
    canPacket_.data[11] |= static_cast<uint8_t>((bitBuffer >> 12) & (0x1)); // push in new data
    return 0;
}

int64_t AV_Waypoints_A_X3::setL_Waypoint_A_X40(const double value) noexcept
{
    if ((value > static_cast<double>(1.2)) ||
        (value < static_cast<double>(-1.2))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-1.2)) /
                                                  static_cast<double>(0.0003)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[11] &= static_cast<uint8_t>(~0xfe);                     // clear the bits for new data
    canPacket_.data[11] |= static_cast<uint8_t>((bitBuffer << 1) & (0xfe)); // push in new data
    canPacket_.data[12] &= static_cast<uint8_t>(~0x3f);                     // clear the bits for new data
    canPacket_.data[12] |= static_cast<uint8_t>((bitBuffer >> 7) & (0x3f)); // push in new data
    return 0;
}

int64_t AV_Waypoints_A_X3::setL_Waypoint_A_X41(const double value) noexcept
{
    if ((value > static_cast<double>(1.2)) ||
        (value < static_cast<double>(-1.2))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-1.2)) /
                                                  static_cast<double>(0.0003)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[12] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[12] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    canPacket_.data[13] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[13] |= static_cast<uint8_t>((bitBuffer >> 2) & (0xff)); // push in new data
    canPacket_.data[14] &= static_cast<uint8_t>(~0x7);                      // clear the bits for new data
    canPacket_.data[14] |= static_cast<uint8_t>((bitBuffer >> 10) & (0x7)); // push in new data
    return 0;
}

int64_t AV_Waypoints_A_X3::setL_Waypoint_A_X42(const double value) noexcept
{
    if ((value > static_cast<double>(1.2)) ||
        (value < static_cast<double>(-1.2))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-1.2)) /
                                                  static_cast<double>(0.0003)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[14] &= static_cast<uint8_t>(~0xf8);                     // clear the bits for new data
    canPacket_.data[14] |= static_cast<uint8_t>((bitBuffer << 3) & (0xf8)); // push in new data
    canPacket_.data[15] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[15] |= static_cast<uint8_t>((bitBuffer >> 5) & (0xff)); // push in new data
    return 0;
}

int64_t AV_Waypoints_A_X3::setL_Waypoint_A_X43(const double value) noexcept
{
    if ((value > static_cast<double>(1.2)) ||
        (value < static_cast<double>(-1.2))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-1.2)) /
                                                  static_cast<double>(0.0003)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[16] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[16] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[17] &= static_cast<uint8_t>(~0x1f);                     // clear the bits for new data
    canPacket_.data[17] |= static_cast<uint8_t>((bitBuffer >> 8) & (0x1f)); // push in new data
    return 0;
}

int64_t AV_Waypoints_A_X3::setL_Waypoint_A_X44(const double value) noexcept
{
    if ((value > static_cast<double>(1.2)) ||
        (value < static_cast<double>(-1.2))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-1.2)) /
                                                  static_cast<double>(0.0003)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[17] &= static_cast<uint8_t>(~0xe0);                     // clear the bits for new data
    canPacket_.data[17] |= static_cast<uint8_t>((bitBuffer << 5) & (0xe0)); // push in new data
    canPacket_.data[18] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[18] |= static_cast<uint8_t>((bitBuffer >> 3) & (0xff)); // push in new data
    canPacket_.data[19] &= static_cast<uint8_t>(~0x3);                      // clear the bits for new data
    canPacket_.data[19] |= static_cast<uint8_t>((bitBuffer >> 11) & (0x3)); // push in new data
    return 0;
}

int64_t AV_Waypoints_A_X3::setL_Waypoint_A_X45(const double value) noexcept
{
    if ((value > static_cast<double>(1.2)) ||
        (value < static_cast<double>(-1.2))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-1.2)) /
                                                  static_cast<double>(0.0003)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[19] &= static_cast<uint8_t>(~0xfc);                     // clear the bits for new data
    canPacket_.data[19] |= static_cast<uint8_t>((bitBuffer << 2) & (0xfc)); // push in new data
    canPacket_.data[20] &= static_cast<uint8_t>(~0x7f);                     // clear the bits for new data
    canPacket_.data[20] |= static_cast<uint8_t>((bitBuffer >> 6) & (0x7f)); // push in new data
    return 0;
}

int64_t AV_Waypoints_A_X3::setL_Waypoint_A_X46(const double value) noexcept
{
    if ((value > static_cast<double>(1.2)) ||
        (value < static_cast<double>(-1.2))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-1.2)) /
                                                  static_cast<double>(0.0003)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[20] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[20] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    canPacket_.data[21] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[21] |= static_cast<uint8_t>((bitBuffer >> 1) & (0xff)); // push in new data
    canPacket_.data[22] &= static_cast<uint8_t>(~0xf);                      // clear the bits for new data
    canPacket_.data[22] |= static_cast<uint8_t>((bitBuffer >> 9) & (0xf));  // push in new data
    return 0;
}

int64_t AV_Waypoints_A_X3::setL_Waypoint_A_X47(const double value) noexcept
{
    if ((value > static_cast<double>(1.2)) ||
        (value < static_cast<double>(-1.2))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-1.2)) /
                                                  static_cast<double>(0.0003)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[22] &= static_cast<uint8_t>(~0xf0);                     // clear the bits for new data
    canPacket_.data[22] |= static_cast<uint8_t>((bitBuffer << 4) & (0xf0)); // push in new data
    canPacket_.data[23] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[23] |= static_cast<uint8_t>((bitBuffer >> 4) & (0xff)); // push in new data
    canPacket_.data[24] &= static_cast<uint8_t>(~0x1);                      // clear the bits for new data
    canPacket_.data[24] |= static_cast<uint8_t>((bitBuffer >> 12) & (0x1)); // push in new data
    return 0;
}

int64_t AV_Waypoints_A_X3::setL_Waypoint_A_X48(const double value) noexcept
{
    if ((value > static_cast<double>(1.2)) ||
        (value < static_cast<double>(-1.2))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-1.2)) /
                                                  static_cast<double>(0.0003)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[24] &= static_cast<uint8_t>(~0xfe);                     // clear the bits for new data
    canPacket_.data[24] |= static_cast<uint8_t>((bitBuffer << 1) & (0xfe)); // push in new data
    canPacket_.data[25] &= static_cast<uint8_t>(~0x3f);                     // clear the bits for new data
    canPacket_.data[25] |= static_cast<uint8_t>((bitBuffer >> 7) & (0x3f)); // push in new data
    return 0;
}

int64_t AV_Waypoints_A_X3::setL_Waypoint_A_X49(const double value) noexcept
{
    if ((value > static_cast<double>(1.2)) ||
        (value < static_cast<double>(-1.2))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-1.2)) /
                                                  static_cast<double>(0.0003)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[25] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[25] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    canPacket_.data[26] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[26] |= static_cast<uint8_t>((bitBuffer >> 2) & (0xff)); // push in new data
    canPacket_.data[27] &= static_cast<uint8_t>(~0x7);                      // clear the bits for new data
    canPacket_.data[27] |= static_cast<uint8_t>((bitBuffer >> 10) & (0x7)); // push in new data
    return 0;
}

int64_t AV_Waypoints_A_X3::setL_Waypoint_A_X50(const double value) noexcept
{
    if ((value > static_cast<double>(1.2)) ||
        (value < static_cast<double>(-1.2))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-1.2)) /
                                                  static_cast<double>(0.0003)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[27] &= static_cast<uint8_t>(~0xf8);                     // clear the bits for new data
    canPacket_.data[27] |= static_cast<uint8_t>((bitBuffer << 3) & (0xf8)); // push in new data
    canPacket_.data[28] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[28] |= static_cast<uint8_t>((bitBuffer >> 5) & (0xff)); // push in new data
    return 0;
}

int64_t AV_Waypoints_A_X3::setL_Waypoint_A_X51(const double value) noexcept
{
    if ((value > static_cast<double>(1.2)) ||
        (value < static_cast<double>(-1.2))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoints_A_X3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-1.2)) /
                                                  static_cast<double>(0.0003)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[29] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[29] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[30] &= static_cast<uint8_t>(~0x1f);                     // clear the bits for new data
    canPacket_.data[30] |= static_cast<uint8_t>((bitBuffer >> 8) & (0x1f)); // push in new data
    return 0;
}
