/// @copyright Copyright (c) 2022 - Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file:
/// https://gitlab.ci.motional.com/systems/av-netwrok-infrastructure/Gen2-AVT-Sample-B/-/blob/dd539e5d752bcae0408ed2b8f29b270cc0db624e/Gen2_AVT_B_Control_CAN2.dbc

#include "VehicleCANLibrary/g2h/av_proto/R_AV_Dynamics_Request.hpp"
#include <algorithm>
#include <string.h>

using namespace av::can::g2h::avproto;

R_AV_Dynamics_Request::R_AV_Dynamics_Request(const uint32_t id)
{
    canPacket_.id = id;
    canPacket_.length = R_AV_Dynamics_Request_CONSTS::R_AV_DYNAMICS_REQUEST_PACKET_LEN;
}

R_AV_Dynamics_Request::R_AV_Dynamics_Request(const uint32_t id, uint8_t* const payload, const uint8_t size)
{
    canPacket_.id = id;

    if ((size <= sizeof(canPacket_.data)) && payload) {
        canPacket_.length = size;
        std::copy_n(payload, size, canPacket_.data);
    }
}

const CanFdPacket& R_AV_Dynamics_Request::getCanPacket() const
{
    return canPacket_;
}

double R_AV_Dynamics_Request::getR_ALIV_AV_Dynamics_Request() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[2]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    return output;
}

double R_AV_Dynamics_Request::getR_AUTH_AV_Dynamics_Request() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[27]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[28]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[29]) << 16; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[30]) << 24; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[31]) << 32; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffffffffff);                           // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);          // Unsigned value

    return output;
}

double R_AV_Dynamics_Request::getR_CRC_AV_Dynamics_Request() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[0]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[1]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffff);                               // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);        // Unsigned value

    return output;
}

double R_AV_Dynamics_Request::getR_FV_AV_Dynamics_Request() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[20]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[21]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[22]) << 16; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[23]) << 24; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[24]) << 32; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[25]) << 40; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[26]) << 48; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffffffffffffff);                       // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);                // Unsigned value

    if ((output > static_cast<double>(7.20575940379279e+16)) || (output < static_cast<double>(0))) // check for boundary
    {
        output = static_cast<double>(R_AV_Dynamics_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double R_AV_Dynamics_Request::getR_a_FeedForwardAccel_Rq() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[5]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffe0);                               // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                                  // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.01)) + static_cast<double>(-10); // (output * scale_factor) + bias

    if ((output > static_cast<double>(10)) || (output < static_cast<double>(-10))) // check for boundary
    {
        output = static_cast<double>(R_AV_Dynamics_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double R_AV_Dynamics_Request::getR_a_RoadWheelAngleAccel_Rq() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]);        // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[11]) << 16; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1ffff8);                               // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                                    // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(3.49066e-05)) +
             static_cast<double>(-4.36332313); // (output * scale_factor) + bias

    if ((output > static_cast<double>(4.787193792)) ||
        (output < static_cast<double>(-4.36332313))) // check for boundary
    {
        output = static_cast<double>(R_AV_Dynamics_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double R_AV_Dynamics_Request::getR_u_RoadWheelAngle_Rq() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffff);                               // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);              // Unsigned value

    output = (output * static_cast<double>(4.798e-05)) + static_cast<double>(-1.5708); // (output * scale_factor) + bias

    if ((output > static_cast<double>(1.5708)) || (output < static_cast<double>(-1.5708))) // check for boundary
    {
        output = static_cast<double>(R_AV_Dynamics_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double R_AV_Dynamics_Request::getR_v_TargetSpeed_Rq() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1fff);                               // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);              // Unsigned value

    output = (output * static_cast<double>(0.01)) + static_cast<double>(-10); // (output * scale_factor) + bias

    if ((output > static_cast<double>(40)) || (output < static_cast<double>(-10))) // check for boundary
    {
        output = static_cast<double>(R_AV_Dynamics_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double R_AV_Dynamics_Request::getR_w_RoadWheelAngleRate_Rq() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x7ff);                                // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);              // Unsigned value

    output = (output * static_cast<double>(0.001)) + static_cast<double>(-0.65); // (output * scale_factor) + bias

    if ((output > static_cast<double>(0.65)) || (output < static_cast<double>(-0.65))) // check for boundary
    {
        output = static_cast<double>(R_AV_Dynamics_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

int64_t R_AV_Dynamics_Request::setR_ALIV_AV_Dynamics_Request(const double value) noexcept
{
    if ((value > static_cast<double>(255)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(R_AV_Dynamics_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[2] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[2] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    return 0;
}

int64_t R_AV_Dynamics_Request::setR_AUTH_AV_Dynamics_Request(const double value) noexcept
{
    if ((value > static_cast<double>(1099511627775)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(R_AV_Dynamics_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[27] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[27] |= static_cast<uint8_t>((bitBuffer) & (0xff));       // push in new data
    canPacket_.data[28] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[28] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff));  // push in new data
    canPacket_.data[29] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[29] |= static_cast<uint8_t>((bitBuffer >> 16) & (0xff)); // push in new data
    canPacket_.data[30] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[30] |= static_cast<uint8_t>((bitBuffer >> 24) & (0xff)); // push in new data
    canPacket_.data[31] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[31] |= static_cast<uint8_t>((bitBuffer >> 32) & (0xff)); // push in new data
    return 0;
}

int64_t R_AV_Dynamics_Request::setR_CRC_AV_Dynamics_Request(const double value) noexcept
{
    if ((value > static_cast<double>(65535)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(R_AV_Dynamics_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[0] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[0] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[1] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[1] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff)); // push in new data
    return 0;
}

int64_t R_AV_Dynamics_Request::setR_FV_AV_Dynamics_Request(const double value) noexcept
{
    if ((value > static_cast<double>(7.20575940379279e+16)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(R_AV_Dynamics_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[20] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[20] |= static_cast<uint8_t>((bitBuffer) & (0xff));       // push in new data
    canPacket_.data[21] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[21] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff));  // push in new data
    canPacket_.data[22] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[22] |= static_cast<uint8_t>((bitBuffer >> 16) & (0xff)); // push in new data
    canPacket_.data[23] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[23] |= static_cast<uint8_t>((bitBuffer >> 24) & (0xff)); // push in new data
    canPacket_.data[24] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[24] |= static_cast<uint8_t>((bitBuffer >> 32) & (0xff)); // push in new data
    canPacket_.data[25] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[25] |= static_cast<uint8_t>((bitBuffer >> 40) & (0xff)); // push in new data
    canPacket_.data[26] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[26] |= static_cast<uint8_t>((bitBuffer >> 48) & (0xff)); // push in new data
    return 0;
}

int64_t R_AV_Dynamics_Request::setR_a_FeedForwardAccel_Rq(const double value) noexcept
{
    if ((value > static_cast<double>(10)) ||
        (value < static_cast<double>(-10))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(R_AV_Dynamics_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-10)) /
                                                  static_cast<double>(0.01)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0xe0);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer << 5) & (0xe0)); // push in new data
    canPacket_.data[5] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[5] |= static_cast<uint8_t>((bitBuffer >> 3) & (0xff)); // push in new data
    return 0;
}

int64_t R_AV_Dynamics_Request::setR_a_RoadWheelAngleAccel_Rq(const double value) noexcept
{
    if ((value > static_cast<double>(4.787193792)) ||
        (value < static_cast<double>(-4.36332313))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(R_AV_Dynamics_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-4.36332313)) /
                                                  static_cast<double>(3.49066e-05)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[9] &= static_cast<uint8_t>(~0xf8);                       // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer << 3) & (0xf8));   // push in new data
    canPacket_.data[10] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer >> 5) & (0xff));  // push in new data
    canPacket_.data[11] &= static_cast<uint8_t>(~0x1f);                      // clear the bits for new data
    canPacket_.data[11] |= static_cast<uint8_t>((bitBuffer >> 13) & (0x1f)); // push in new data
    return 0;
}

int64_t R_AV_Dynamics_Request::setR_u_RoadWheelAngle_Rq(const double value) noexcept
{
    if ((value > static_cast<double>(1.5708)) ||
        (value < static_cast<double>(-1.5708))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(R_AV_Dynamics_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-1.5708)) /
                                                  static_cast<double>(4.798e-05)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[6] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[7] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff)); // push in new data
    return 0;
}

int64_t R_AV_Dynamics_Request::setR_v_TargetSpeed_Rq(const double value) noexcept
{
    if ((value > static_cast<double>(40)) ||
        (value < static_cast<double>(-10))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(R_AV_Dynamics_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-10)) /
                                                  static_cast<double>(0.01)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[4] &= static_cast<uint8_t>(~0x1f);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer >> 8) & (0x1f)); // push in new data
    return 0;
}

int64_t R_AV_Dynamics_Request::setR_w_RoadWheelAngleRate_Rq(const double value) noexcept
{
    if ((value > static_cast<double>(0.65)) ||
        (value < static_cast<double>(-0.65))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(R_AV_Dynamics_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-0.65)) /
                                                  static_cast<double>(0.001)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[8] &= static_cast<uint8_t>(~0xff);                    // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer) & (0xff));     // push in new data
    canPacket_.data[9] &= static_cast<uint8_t>(~0x7);                     // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer >> 8) & (0x7)); // push in new data
    return 0;
}
