/// @copyright Copyright (c) 2022 - Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file:
/// https://gitlab.ci.motional.com/systems/av-netwrok-infrastructure/Gen2-AVT-Sample-B/-/blob/dd539e5d752bcae0408ed2b8f29b270cc0db624e/Gen2_AVT_B_Control_CAN2.dbc

#include "VehicleCANLibrary/g2h/av_proto/R_AV_Waypoint_Speeds_A_1.hpp"
#include <algorithm>
#include <string.h>

using namespace av::can::g2h::avproto;

R_AV_Waypoint_Speeds_A_1::R_AV_Waypoint_Speeds_A_1(const uint32_t id)
{
    canPacket_.id = id;
    canPacket_.length = R_AV_Waypoint_Speeds_A_1_CONSTS::R_AV_WAYPOINT_SPEEDS_A_1_PACKET_LEN;
}

R_AV_Waypoint_Speeds_A_1::R_AV_Waypoint_Speeds_A_1(const uint32_t id, uint8_t* const payload, const uint8_t size)
{
    canPacket_.id = id;

    if ((size <= sizeof(canPacket_.data)) && payload) {
        canPacket_.length = size;
        std::copy_n(payload, size, canPacket_.data);
    }
}

const CanFdPacket& R_AV_Waypoint_Speeds_A_1::getCanPacket() const
{
    return canPacket_;
}

double R_AV_Waypoint_Speeds_A_1::getR_ALIV_AV_Waypoint_Speeds_A_1() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[2]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    return output;
}

double R_AV_Waypoint_Speeds_A_1::getR_CRC_AV_Waypoint_Speeds_A_1() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[0]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[1]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffff);                               // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);        // Unsigned value

    return output;
}

double R_AV_Waypoint_Speeds_A_1::getR_v_WaypointSpeed_A_1() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff);                                // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);              // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double R_AV_Waypoint_Speeds_A_1::getR_v_WaypointSpeed_A_10() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[16]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[17]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff0);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double R_AV_Waypoint_Speeds_A_1::getR_v_WaypointSpeed_A_11() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[18]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[19]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff);                                 // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);               // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double R_AV_Waypoint_Speeds_A_1::getR_v_WaypointSpeed_A_12() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[19]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[20]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff0);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double R_AV_Waypoint_Speeds_A_1::getR_v_WaypointSpeed_A_13() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[21]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[22]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff);                                 // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);               // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double R_AV_Waypoint_Speeds_A_1::getR_v_WaypointSpeed_A_14() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[22]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[23]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff0);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double R_AV_Waypoint_Speeds_A_1::getR_v_WaypointSpeed_A_15() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[24]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[25]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff);                                 // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);               // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double R_AV_Waypoint_Speeds_A_1::getR_v_WaypointSpeed_A_16() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[25]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[26]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff0);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double R_AV_Waypoint_Speeds_A_1::getR_v_WaypointSpeed_A_17() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[27]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[28]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff);                                 // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);               // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double R_AV_Waypoint_Speeds_A_1::getR_v_WaypointSpeed_A_2() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[5]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff0);                               // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                                  // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double R_AV_Waypoint_Speeds_A_1::getR_v_WaypointSpeed_A_3() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff);                                // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);              // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double R_AV_Waypoint_Speeds_A_1::getR_v_WaypointSpeed_A_4() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff0);                               // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                                  // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double R_AV_Waypoint_Speeds_A_1::getR_v_WaypointSpeed_A_5() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff);                                 // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);               // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double R_AV_Waypoint_Speeds_A_1::getR_v_WaypointSpeed_A_6() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[11]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff0);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double R_AV_Waypoint_Speeds_A_1::getR_v_WaypointSpeed_A_7() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[12]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[13]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff);                                 // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);               // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double R_AV_Waypoint_Speeds_A_1::getR_v_WaypointSpeed_A_8() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[13]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[14]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff0);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double R_AV_Waypoint_Speeds_A_1::getR_v_WaypointSpeed_A_9() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[15]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[16]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff);                                 // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);               // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

int64_t R_AV_Waypoint_Speeds_A_1::setR_ALIV_AV_Waypoint_Speeds_A_1(const double value) noexcept
{
    if ((value > static_cast<double>(255)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[2] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[2] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    return 0;
}

int64_t R_AV_Waypoint_Speeds_A_1::setR_CRC_AV_Waypoint_Speeds_A_1(const double value) noexcept
{
    if ((value > static_cast<double>(65535)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[0] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[0] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[1] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[1] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff)); // push in new data
    return 0;
}

int64_t R_AV_Waypoint_Speeds_A_1::setR_v_WaypointSpeed_A_1(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0xff);                    // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer) & (0xff));     // push in new data
    canPacket_.data[4] &= static_cast<uint8_t>(~0xf);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xf)); // push in new data
    return 0;
}

int64_t R_AV_Waypoint_Speeds_A_1::setR_v_WaypointSpeed_A_10(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[16] &= static_cast<uint8_t>(~0xf0);                     // clear the bits for new data
    canPacket_.data[16] |= static_cast<uint8_t>((bitBuffer << 4) & (0xf0)); // push in new data
    canPacket_.data[17] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[17] |= static_cast<uint8_t>((bitBuffer >> 4) & (0xff)); // push in new data
    return 0;
}

int64_t R_AV_Waypoint_Speeds_A_1::setR_v_WaypointSpeed_A_11(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[18] &= static_cast<uint8_t>(~0xff);                    // clear the bits for new data
    canPacket_.data[18] |= static_cast<uint8_t>((bitBuffer) & (0xff));     // push in new data
    canPacket_.data[19] &= static_cast<uint8_t>(~0xf);                     // clear the bits for new data
    canPacket_.data[19] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xf)); // push in new data
    return 0;
}

int64_t R_AV_Waypoint_Speeds_A_1::setR_v_WaypointSpeed_A_12(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[19] &= static_cast<uint8_t>(~0xf0);                     // clear the bits for new data
    canPacket_.data[19] |= static_cast<uint8_t>((bitBuffer << 4) & (0xf0)); // push in new data
    canPacket_.data[20] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[20] |= static_cast<uint8_t>((bitBuffer >> 4) & (0xff)); // push in new data
    return 0;
}

int64_t R_AV_Waypoint_Speeds_A_1::setR_v_WaypointSpeed_A_13(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[21] &= static_cast<uint8_t>(~0xff);                    // clear the bits for new data
    canPacket_.data[21] |= static_cast<uint8_t>((bitBuffer) & (0xff));     // push in new data
    canPacket_.data[22] &= static_cast<uint8_t>(~0xf);                     // clear the bits for new data
    canPacket_.data[22] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xf)); // push in new data
    return 0;
}

int64_t R_AV_Waypoint_Speeds_A_1::setR_v_WaypointSpeed_A_14(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[22] &= static_cast<uint8_t>(~0xf0);                     // clear the bits for new data
    canPacket_.data[22] |= static_cast<uint8_t>((bitBuffer << 4) & (0xf0)); // push in new data
    canPacket_.data[23] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[23] |= static_cast<uint8_t>((bitBuffer >> 4) & (0xff)); // push in new data
    return 0;
}

int64_t R_AV_Waypoint_Speeds_A_1::setR_v_WaypointSpeed_A_15(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[24] &= static_cast<uint8_t>(~0xff);                    // clear the bits for new data
    canPacket_.data[24] |= static_cast<uint8_t>((bitBuffer) & (0xff));     // push in new data
    canPacket_.data[25] &= static_cast<uint8_t>(~0xf);                     // clear the bits for new data
    canPacket_.data[25] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xf)); // push in new data
    return 0;
}

int64_t R_AV_Waypoint_Speeds_A_1::setR_v_WaypointSpeed_A_16(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[25] &= static_cast<uint8_t>(~0xf0);                     // clear the bits for new data
    canPacket_.data[25] |= static_cast<uint8_t>((bitBuffer << 4) & (0xf0)); // push in new data
    canPacket_.data[26] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[26] |= static_cast<uint8_t>((bitBuffer >> 4) & (0xff)); // push in new data
    return 0;
}

int64_t R_AV_Waypoint_Speeds_A_1::setR_v_WaypointSpeed_A_17(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[27] &= static_cast<uint8_t>(~0xff);                    // clear the bits for new data
    canPacket_.data[27] |= static_cast<uint8_t>((bitBuffer) & (0xff));     // push in new data
    canPacket_.data[28] &= static_cast<uint8_t>(~0xf);                     // clear the bits for new data
    canPacket_.data[28] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xf)); // push in new data
    return 0;
}

int64_t R_AV_Waypoint_Speeds_A_1::setR_v_WaypointSpeed_A_2(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0xf0);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer << 4) & (0xf0)); // push in new data
    canPacket_.data[5] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[5] |= static_cast<uint8_t>((bitBuffer >> 4) & (0xff)); // push in new data
    return 0;
}

int64_t R_AV_Waypoint_Speeds_A_1::setR_v_WaypointSpeed_A_3(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[6] &= static_cast<uint8_t>(~0xff);                    // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer) & (0xff));     // push in new data
    canPacket_.data[7] &= static_cast<uint8_t>(~0xf);                     // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xf)); // push in new data
    return 0;
}

int64_t R_AV_Waypoint_Speeds_A_1::setR_v_WaypointSpeed_A_4(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[7] &= static_cast<uint8_t>(~0xf0);                     // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer << 4) & (0xf0)); // push in new data
    canPacket_.data[8] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer >> 4) & (0xff)); // push in new data
    return 0;
}

int64_t R_AV_Waypoint_Speeds_A_1::setR_v_WaypointSpeed_A_5(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[9] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[10] &= static_cast<uint8_t>(~0xf);                     // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xf)); // push in new data
    return 0;
}

int64_t R_AV_Waypoint_Speeds_A_1::setR_v_WaypointSpeed_A_6(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[10] &= static_cast<uint8_t>(~0xf0);                     // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer << 4) & (0xf0)); // push in new data
    canPacket_.data[11] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[11] |= static_cast<uint8_t>((bitBuffer >> 4) & (0xff)); // push in new data
    return 0;
}

int64_t R_AV_Waypoint_Speeds_A_1::setR_v_WaypointSpeed_A_7(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[12] &= static_cast<uint8_t>(~0xff);                    // clear the bits for new data
    canPacket_.data[12] |= static_cast<uint8_t>((bitBuffer) & (0xff));     // push in new data
    canPacket_.data[13] &= static_cast<uint8_t>(~0xf);                     // clear the bits for new data
    canPacket_.data[13] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xf)); // push in new data
    return 0;
}

int64_t R_AV_Waypoint_Speeds_A_1::setR_v_WaypointSpeed_A_8(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[13] &= static_cast<uint8_t>(~0xf0);                     // clear the bits for new data
    canPacket_.data[13] |= static_cast<uint8_t>((bitBuffer << 4) & (0xf0)); // push in new data
    canPacket_.data[14] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[14] |= static_cast<uint8_t>((bitBuffer >> 4) & (0xff)); // push in new data
    return 0;
}

int64_t R_AV_Waypoint_Speeds_A_1::setR_v_WaypointSpeed_A_9(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(R_AV_Waypoint_Speeds_A_1_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[15] &= static_cast<uint8_t>(~0xff);                    // clear the bits for new data
    canPacket_.data[15] |= static_cast<uint8_t>((bitBuffer) & (0xff));     // push in new data
    canPacket_.data[16] &= static_cast<uint8_t>(~0xf);                     // clear the bits for new data
    canPacket_.data[16] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xf)); // push in new data
    return 0;
}
