/// @copyright Copyright (c) 2022 - Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file:
/// https://gitlab.ci.motional.com/systems/av-netwrok-infrastructure/Gen2-AVT-Sample-B/-/blob/dd539e5d752bcae0408ed2b8f29b270cc0db624e/Gen2_AVT_B_Control_CAN2.dbc

#include "VehicleCANLibrary/g2h/av_proto/R_VIC_BodyCtrl_FB_01A_PE_200ms.hpp"
#include <algorithm>
#include <string.h>

using namespace av::can::g2h::avproto;

R_VIC_BodyCtrl_FB_01A_PE_200ms::R_VIC_BodyCtrl_FB_01A_PE_200ms(const uint32_t id)
{
    canPacket_.id = id;
    canPacket_.length = R_VIC_BodyCtrl_FB_01A_PE_200ms_CONSTS::R_VIC_BODYCTRL_FB_01A_PE_200MS_PACKET_LEN;
}

R_VIC_BodyCtrl_FB_01A_PE_200ms::R_VIC_BodyCtrl_FB_01A_PE_200ms(const uint32_t id,
                                                               uint8_t* const payload,
                                                               const uint8_t size)
{
    canPacket_.id = id;

    if ((size <= sizeof(canPacket_.data)) && payload) {
        canPacket_.length = size;
        std::copy_n(payload, size, canPacket_.data);
    }
}

const CanFdPacket& R_VIC_BodyCtrl_FB_01A_PE_200ms::getCanPacket() const
{
    return canPacket_;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_BurglarHornRlySta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[28]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x3);                              // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);    // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Not Used
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_DoorLock_AsstDrUnLkSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[15]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x6);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Lock
    //  1 --> Unlock
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_DoorLock_DrvDrUnLkSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[14]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x60);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Lock
    //  1 --> Unlock
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_DoorLock_RrLftDrUnLkSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[16]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x18);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Lock
    //  1 --> Unlock
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_DoorLock_RrRtDrUnLkSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[17]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x60);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Lock
    //  1 --> Unlock
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_ExtLamp_BckUpLmpSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_ExtLamp_HzrdSwSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[5]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_ExtLamp_StpLmpSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x30);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_ExtLamp_TrnSigLmpLftBlnkngSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x3);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_ExtLamp_TrnSigLmpRtBlnkngSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_IntCabinLight_Fr() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[28]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_IntCabinLight_RrLf() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[28]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x30);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_IntCabinLight_RrRt() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[28]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc0);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Lamp_AutoLtSnsrHorVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffc0);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Lamp_AutoLtSnsrNightSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x30);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> Night
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Lamp_AutoLtSnsrVerVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[11]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[12]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x3ff);                                 // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);         // Unsigned value

    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Lamp_FrTrnSigLmpLftOpnSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x3);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> Open Status
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Lamp_FrTrnSigLmpLftPCLSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x30);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> PCL Status
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Lamp_FrTrnSigLmpRtOpnSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> Open Status
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Lamp_FrTrnSigLmpRtPCLSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc0);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> PCL Status
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Lamp_HdLmpHiLftOpnSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x30);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> Open Status
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Lamp_HdLmpHiRtOpnSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> Open Status
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Lamp_HdLmpHiSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x3);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Lamp_HdLmpLoLftOpnSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc0);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> Open Status
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Lamp_HdLmpLoRtOpnSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x30);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> Open Status
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Lamp_HdLmpLoSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x3);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Lamp_Hdlmp_Low_PCLstatus_LH() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[5]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x3);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> In Normal Condition
    //  1 --> Reserved
    //  2 --> PCL
    //  3 --> Reserved
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Lamp_Hdlmp_Low_PCLstatus_RH() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc0);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> In Normal Condition
    //  1 --> Reserved
    //  2 --> PCL
    //  3 --> Reserved
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Lamp_LedHdLmpSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> LED Headlamp is in nornal condition
    //  1 --> Reserved
    //  2 --> LED Fail
    //  3 --> Reserved
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Lamp_RrTrnSigLmpLftOpnSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x30);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> Open Status
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Lamp_RrTrnSigLmpLftPCLSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x3);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> PCL Status
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Lamp_RrTrnSigLmpRtOpnSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc0);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> Open Status
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Lamp_RrTrnSigLmpRtPCLSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> PCL Status
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Lamp_StpLmpLftOpnSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc0);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> Open Status
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Lamp_StpLmpRtOpnSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x3);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> Open Status
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Lamp_TrnSigLmpLftActiveSt() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[5]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x30);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off (Inactive)
    //  1 --> On (Active)
    //  2 --> Reserved
    //  3 --> Invalid
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Lamp_TrnSigLmpRtActiveSt() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[5]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc0);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off (Inactive)
    //  1 --> On (Active)
    //  2 --> Reserved
    //  3 --> Invalid
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_OHCL_MoodLampSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[29]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x3);                              // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);    // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_PTGM_AntiPinchSnsr() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[19]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc0);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Applied
    //  2 --> Not applied
    //  3 --> Invalid
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_PTGM_CmdWarn() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[19]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x38);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Gear P or Vehicle speed
    //  2 --> Obstacle detected
    //  3 --> System temporary error
    //  4 --> Power mode OFF
    //  5 --> Reserved
    //  6 --> Reserved
    //  7 --> Invalid
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_PTGM_OpnClsState() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[18]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[19]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x780);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Closed
    //  2 --> 1 lvl open
    //  3 --> 2 lvl open
    //  4 --> 3 lvl open
    //  5 --> 4 lvl open
    //  6 --> Full open
    //  7 --> Reserved
    //  8 --> Closing operation
    //  9 --> Opening operation
    //  10 --> Position Error
    //  11 --> Reserved
    //  12 --> Reserved
    //  13 --> Reserved
    //  14 --> Reserved
    //  15 --> Invalid
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_SBCM_AST_DoorStatus() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[15]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[16]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1e0);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Unknown
    //  1 --> FullClosed
    //  2 --> FullOpened
    //  3 --> EasyAccessMode
    //  4 --> WithinPopUpRange
    //  5 --> BeyondPopUpRange
    //  6 --> WaitForLatchOpen
    //  7 --> MovgOutTip2Run
    //  8 --> MovgOutManAssist
    //  9 --> MovgOutPopUp
    //  10 --> MovgOutReverse
    //  11 --> MovgInAuto
    //  12 --> MovgInTip2Run
    //  13 --> MovgInManAssist
    //  14 --> MovgInDenormalized
    //  15 --> Reserved_1
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_SBCM_AST_Door_Blocked() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[16]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x6);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On (Blocked)
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_SBCM_RL_DoorStatus() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[16]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[17]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x780);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Unknown
    //  1 --> FullClosed
    //  2 --> FullOpened
    //  3 --> EasyAccessMode
    //  4 --> WithinPopUpRange
    //  5 --> BeyondPopUpRange
    //  6 --> WaitForLatchOpen
    //  7 --> MovgOutTip2Run
    //  8 --> MovgOutManAssist
    //  9 --> MovgOutPopUp
    //  10 --> MovgOutReverse
    //  11 --> MovgInAuto
    //  12 --> MovgInTip2Run
    //  13 --> MovgInManAssist
    //  14 --> MovgInDenormalized
    //  15 --> Reserved_1
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_SBCM_RL_Door_Blocked() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[17]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x18);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On (Blocked)
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_SBCM_RR_DoorStatus() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[18]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x1e);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Unknown
    //  1 --> FullClosed
    //  2 --> FullOpened
    //  3 --> EasyAccessMode
    //  4 --> WithinPopUpRange
    //  5 --> BeyondPopUpRange
    //  6 --> WaitForLatchOpen
    //  7 --> MovgOutTip2Run
    //  8 --> MovgOutManAssist
    //  9 --> MovgOutPopUp
    //  10 --> MovgOutReverse
    //  11 --> MovgInAuto
    //  12 --> MovgInTip2Run
    //  13 --> MovgInManAssist
    //  14 --> MovgInDenormalized
    //  15 --> Reserved_1
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_SBCM_RR_Door_Blocked() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[18]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x60);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On (Blocked)
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_VIC_BodyCtrl_FB_01A_AlvCnt1Val() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[2]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_VIC_BodyCtrl_FB_01A_Crc1Val() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[0]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[1]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffff);                               // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);        // Unsigned value

    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Warn_AsstDrSwSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[15]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x18);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Close
    //  1 --> Open
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Warn_DrvDrSwSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[14]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[15]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x180);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Close
    //  1 --> Open
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Warn_HoodSwSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[20]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x3);                              // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);    // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Warn_RrLftDrSwSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[16]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x60);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Close
    //  1 --> Open
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Warn_RrRtDrSwSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[17]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[18]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x180);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Close
    //  1 --> Open
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Window_AsstPwrWdwAutoSwSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[23]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Window_AsstPwrWdwDnSwSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[23]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x30);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Window_AsstPwrWdwUpSwSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[23]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc0);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Window_AsstSdWdwActSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[22]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x1e);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No Action
    //  1 --> Manual Down
    //  2 --> Manual Up
    //  3 --> RLY Stuck/FET Error
    //  4 --> Motor Stop Error
    //  5 --> Auto Down
    //  6 --> Auto Up
    //  7 --> Reverse
    //  8 --> Reserved
    //  9 --> Reserved
    //  10 --> Reserved
    //  11 --> Reserved
    //  12 --> Reserved
    //  13 --> Reserved
    //  14 --> Reserved
    //  15 --> Invalid
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Window_AsstSdWdwDetailOpnSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[22]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xe0);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Full Close
    //  1 --> 1~30% Open
    //  2 --> 31~99% Open
    //  3 --> Full Open
    //  4 --> Reserved
    //  5 --> Reserved
    //  6 --> Reserved
    //  7 --> Invalid
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Window_AsstSdWdwErrAntPinch() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[23]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x3);                              // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);    // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Calibrated
    //  1 --> De-Calibrated
    //  2 --> Reserved
    //  3 --> Invalid
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Window_DrvPwrWdwAutoSwSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[21]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x18);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Window_DrvPwrWdwDnSwSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[21]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x60);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Window_DrvPwrWdwUpSwSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[21]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[22]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x180);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Window_DrvrSdWdwActSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[20]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x3c);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No Action
    //  1 --> Manual Down
    //  2 --> Manual Up
    //  3 --> RLY Stuck/FET Error
    //  4 --> Motor Stop Error
    //  5 --> Auto Down
    //  6 --> Auto Up
    //  7 --> Reverse
    //  8 --> Reserved
    //  9 --> Reserved
    //  10 --> Reserved
    //  11 --> Reserved
    //  12 --> Reserved
    //  13 --> Reserved
    //  14 --> Reserved
    //  15 --> Invalid
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Window_DrvrSdWdwDetailOpnSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[20]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[21]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1c0);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Full Close
    //  1 --> 1~30% Open
    //  2 --> 31~99% Open
    //  3 --> Full Open
    //  4 --> Reserved
    //  5 --> Reserved
    //  6 --> Reserved
    //  7 --> Invalid
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Window_DrvrSdWdwErrAntPinch() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[21]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x6);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Calibrated
    //  1 --> De-Calibrated
    //  2 --> Reserved
    //  3 --> Invalid
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Window_PwrWdwMvInhbtSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[27]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc0);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> RESERVED
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Window_RrLftPwrWdwAutoSwSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[24]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x3);                              // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);    // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Window_RrLftPwrWdwDnSwSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[24]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Window_RrLftPwrWdwUpSwSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[24]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x30);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Window_RrLftWdwActSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[24]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[25]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x3c0);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No Action
    //  1 --> Manual Down
    //  2 --> Manual Up
    //  3 --> RLY Stuck/FET Error
    //  4 --> Motor Stop Error
    //  5 --> Auto Down
    //  6 --> Auto Up
    //  7 --> Reverse
    //  8 --> Reserved
    //  9 --> Reserved
    //  10 --> Reserved
    //  11 --> Reserved
    //  12 --> Reserved
    //  13 --> Reserved
    //  14 --> Reserved
    //  15 --> Invalid
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Window_RrLftWdwDetailOpnSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[25]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x1c);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Full Close
    //  1 --> 1~30% Open
    //  2 --> 31~99% Open
    //  3 --> Full Open
    //  4 --> Reserved
    //  5 --> Reserved
    //  6 --> Reserved
    //  7 --> Invalid
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Window_RrLftWdwErrAntPinch() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[25]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x60);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Calibrated
    //  1 --> De-Calibrated
    //  2 --> Reserved
    //  3 --> Invalid
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Window_RrRtPwrWdwAutoSwSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[25]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[26]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x180);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Window_RrRtPwrWdwDnSwSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[26]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x6);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Window_RrRtPwrWdwUpSwSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[26]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x18);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Window_RrRtWdwActSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[26]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[27]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1e0);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No Action
    //  1 --> Manual Down
    //  2 --> Manual Up
    //  3 --> RLY Stuck/FET Error
    //  4 --> Motor Stop Error
    //  5 --> Auto Down
    //  6 --> Auto Up
    //  7 --> Reverse
    //  8 --> Reserved
    //  9 --> Reserved
    //  10 --> Reserved
    //  11 --> Reserved
    //  12 --> Reserved
    //  13 --> Reserved
    //  14 --> Reserved
    //  15 --> Invalid
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Window_RrRtWdwDetailOpnSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[27]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xe);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Full Close
    //  1 --> 1~30% Open
    //  2 --> 31~99% Open
    //  3 --> Full Open
    //  4 --> Reserved
    //  5 --> Reserved
    //  6 --> Reserved
    //  7 --> Invalid
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Window_RrRtWdwErrAntPinch() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[27]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x30);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Calibrated
    //  1 --> De-Calibrated
    //  2 --> Reserved
    //  3 --> Invalid
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Wiper_IntStepSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[14]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x1c);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> STEP1(SLOW)
    //  1 --> STEP2
    //  2 --> STEP3
    //  3 --> STEP4
    //  4 --> STEP5(FAST)
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Wiper_RainAmount() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[12]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[13]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x3fc);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = output * static_cast<double>(0.5); // output * scale_factor

    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Wiper_RainSnsrSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[13]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x3c);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> OFF
    //  1 --> Rain Detected
    //  2 --> Low
    //  3 --> High
    //  4 --> Fault 1
    //  5 --> Fault 2
    //  6 --> Fault 3
    //  7 --> Reserved
    //  8 --> Reserved
    //  9 --> Reserved
    //  10 --> Reserved
    //  11 --> Reserved
    //  12 --> Reserved
    //  13 --> Reserved
    //  14 --> Not Used
    //  15 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Wiper_RrWiperWshSwSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[14]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x3);                              // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);    // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double R_VIC_BodyCtrl_FB_01A_PE_200ms::getR_Wiper_WiperRlyFRSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[13]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc0);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> Low
    //  2 --> High
    //  3 --> Error Indicator
    return output;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_BurglarHornRlySta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[28] &= static_cast<uint8_t>(~0x3);                // clear the bits for new data
    canPacket_.data[28] |= static_cast<uint8_t>((bitBuffer) & (0x3)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Not Used
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_DoorLock_AsstDrUnLkSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[15] &= static_cast<uint8_t>(~0x6);                     // clear the bits for new data
    canPacket_.data[15] |= static_cast<uint8_t>((bitBuffer << 1) & (0x6)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Lock
    //  1 --> Unlock
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_DoorLock_DrvDrUnLkSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[14] &= static_cast<uint8_t>(~0x60);                     // clear the bits for new data
    canPacket_.data[14] |= static_cast<uint8_t>((bitBuffer << 5) & (0x60)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Lock
    //  1 --> Unlock
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_DoorLock_RrLftDrUnLkSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[16] &= static_cast<uint8_t>(~0x18);                     // clear the bits for new data
    canPacket_.data[16] |= static_cast<uint8_t>((bitBuffer << 3) & (0x18)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Lock
    //  1 --> Unlock
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_DoorLock_RrRtDrUnLkSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[17] &= static_cast<uint8_t>(~0x60);                     // clear the bits for new data
    canPacket_.data[17] |= static_cast<uint8_t>((bitBuffer << 5) & (0x60)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Lock
    //  1 --> Unlock
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_ExtLamp_BckUpLmpSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[9] &= static_cast<uint8_t>(~0xc);                     // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer << 2) & (0xc)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_ExtLamp_HzrdSwSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[5] &= static_cast<uint8_t>(~0xc);                     // clear the bits for new data
    canPacket_.data[5] |= static_cast<uint8_t>((bitBuffer << 2) & (0xc)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_ExtLamp_StpLmpSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[8] &= static_cast<uint8_t>(~0x30);                     // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer << 4) & (0x30)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_ExtLamp_TrnSigLmpLftBlnkngSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[6] &= static_cast<uint8_t>(~0x3);                // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer) & (0x3)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_ExtLamp_TrnSigLmpRtBlnkngSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[6] &= static_cast<uint8_t>(~0xc);                     // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer << 2) & (0xc)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_IntCabinLight_Fr(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[28] &= static_cast<uint8_t>(~0xc);                     // clear the bits for new data
    canPacket_.data[28] |= static_cast<uint8_t>((bitBuffer << 2) & (0xc)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_IntCabinLight_RrLf(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[28] &= static_cast<uint8_t>(~0x30);                     // clear the bits for new data
    canPacket_.data[28] |= static_cast<uint8_t>((bitBuffer << 4) & (0x30)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_IntCabinLight_RrRt(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[28] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[28] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Lamp_AutoLtSnsrHorVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[9] &= static_cast<uint8_t>(~0xc0);                      // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0));  // push in new data
    canPacket_.data[10] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer >> 2) & (0xff)); // push in new data
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Lamp_AutoLtSnsrNightSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[9] &= static_cast<uint8_t>(~0x30);                     // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer << 4) & (0x30)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> Night
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Lamp_AutoLtSnsrVerVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[11] &= static_cast<uint8_t>(~0xff);                    // clear the bits for new data
    canPacket_.data[11] |= static_cast<uint8_t>((bitBuffer) & (0xff));     // push in new data
    canPacket_.data[12] &= static_cast<uint8_t>(~0x3);                     // clear the bits for new data
    canPacket_.data[12] |= static_cast<uint8_t>((bitBuffer >> 8) & (0x3)); // push in new data
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Lamp_FrTrnSigLmpLftOpnSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[7] &= static_cast<uint8_t>(~0x3);                // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer) & (0x3)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> Open Status
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Lamp_FrTrnSigLmpLftPCLSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[7] &= static_cast<uint8_t>(~0x30);                     // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer << 4) & (0x30)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> PCL Status
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Lamp_FrTrnSigLmpRtOpnSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[7] &= static_cast<uint8_t>(~0xc);                     // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer << 2) & (0xc)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> Open Status
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Lamp_FrTrnSigLmpRtPCLSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[7] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> PCL Status
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Lamp_HdLmpHiLftOpnSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0x30);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer << 4) & (0x30)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> Open Status
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Lamp_HdLmpHiRtOpnSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0xc);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer << 2) & (0xc)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> Open Status
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Lamp_HdLmpHiSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0x3);                // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer) & (0x3)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Lamp_HdLmpLoLftOpnSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> Open Status
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Lamp_HdLmpLoRtOpnSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0x30);                     // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer << 4) & (0x30)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> Open Status
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Lamp_HdLmpLoSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0x3);                // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer) & (0x3)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Lamp_Hdlmp_Low_PCLstatus_LH(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[5] &= static_cast<uint8_t>(~0x3);                // clear the bits for new data
    canPacket_.data[5] |= static_cast<uint8_t>((bitBuffer) & (0x3)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> In Normal Condition
    //  1 --> Reserved
    //  2 --> PCL
    //  3 --> Reserved
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Lamp_Hdlmp_Low_PCLstatus_RH(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> In Normal Condition
    //  1 --> Reserved
    //  2 --> PCL
    //  3 --> Reserved
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Lamp_LedHdLmpSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0xc);                     // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer << 2) & (0xc)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> LED Headlamp is in nornal condition
    //  1 --> Reserved
    //  2 --> LED Fail
    //  3 --> Reserved
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Lamp_RrTrnSigLmpLftOpnSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[6] &= static_cast<uint8_t>(~0x30);                     // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer << 4) & (0x30)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> Open Status
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Lamp_RrTrnSigLmpLftPCLSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[8] &= static_cast<uint8_t>(~0x3);                // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer) & (0x3)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> PCL Status
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Lamp_RrTrnSigLmpRtOpnSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[6] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> Open Status
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Lamp_RrTrnSigLmpRtPCLSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[8] &= static_cast<uint8_t>(~0xc);                     // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer << 2) & (0xc)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> PCL Status
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Lamp_StpLmpLftOpnSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[8] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> Open Status
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Lamp_StpLmpRtOpnSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[9] &= static_cast<uint8_t>(~0x3);                // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer) & (0x3)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> Open Status
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Lamp_TrnSigLmpLftActiveSt(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[5] &= static_cast<uint8_t>(~0x30);                     // clear the bits for new data
    canPacket_.data[5] |= static_cast<uint8_t>((bitBuffer << 4) & (0x30)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off (Inactive)
    //  1 --> On (Active)
    //  2 --> Reserved
    //  3 --> Invalid
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Lamp_TrnSigLmpRtActiveSt(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[5] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[5] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off (Inactive)
    //  1 --> On (Active)
    //  2 --> Reserved
    //  3 --> Invalid
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_OHCL_MoodLampSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[29] &= static_cast<uint8_t>(~0x3);                // clear the bits for new data
    canPacket_.data[29] |= static_cast<uint8_t>((bitBuffer) & (0x3)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_PTGM_AntiPinchSnsr(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[19] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[19] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Applied
    //  2 --> Not applied
    //  3 --> Invalid
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_PTGM_CmdWarn(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[19] &= static_cast<uint8_t>(~0x38);                     // clear the bits for new data
    canPacket_.data[19] |= static_cast<uint8_t>((bitBuffer << 3) & (0x38)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Gear P or Vehicle speed
    //  2 --> Obstacle detected
    //  3 --> System temporary error
    //  4 --> Power mode OFF
    //  5 --> Reserved
    //  6 --> Reserved
    //  7 --> Invalid
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_PTGM_OpnClsState(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[18] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[18] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    canPacket_.data[19] &= static_cast<uint8_t>(~0x7);                      // clear the bits for new data
    canPacket_.data[19] |= static_cast<uint8_t>((bitBuffer >> 1) & (0x7));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Closed
    //  2 --> 1 lvl open
    //  3 --> 2 lvl open
    //  4 --> 3 lvl open
    //  5 --> 4 lvl open
    //  6 --> Full open
    //  7 --> Reserved
    //  8 --> Closing operation
    //  9 --> Opening operation
    //  10 --> Position Error
    //  11 --> Reserved
    //  12 --> Reserved
    //  13 --> Reserved
    //  14 --> Reserved
    //  15 --> Invalid
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_SBCM_AST_DoorStatus(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[15] &= static_cast<uint8_t>(~0xe0);                     // clear the bits for new data
    canPacket_.data[15] |= static_cast<uint8_t>((bitBuffer << 5) & (0xe0)); // push in new data
    canPacket_.data[16] &= static_cast<uint8_t>(~0x1);                      // clear the bits for new data
    canPacket_.data[16] |= static_cast<uint8_t>((bitBuffer >> 3) & (0x1));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Unknown
    //  1 --> FullClosed
    //  2 --> FullOpened
    //  3 --> EasyAccessMode
    //  4 --> WithinPopUpRange
    //  5 --> BeyondPopUpRange
    //  6 --> WaitForLatchOpen
    //  7 --> MovgOutTip2Run
    //  8 --> MovgOutManAssist
    //  9 --> MovgOutPopUp
    //  10 --> MovgOutReverse
    //  11 --> MovgInAuto
    //  12 --> MovgInTip2Run
    //  13 --> MovgInManAssist
    //  14 --> MovgInDenormalized
    //  15 --> Reserved_1
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_SBCM_AST_Door_Blocked(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[16] &= static_cast<uint8_t>(~0x6);                     // clear the bits for new data
    canPacket_.data[16] |= static_cast<uint8_t>((bitBuffer << 1) & (0x6)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On (Blocked)
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_SBCM_RL_DoorStatus(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[16] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[16] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    canPacket_.data[17] &= static_cast<uint8_t>(~0x7);                      // clear the bits for new data
    canPacket_.data[17] |= static_cast<uint8_t>((bitBuffer >> 1) & (0x7));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Unknown
    //  1 --> FullClosed
    //  2 --> FullOpened
    //  3 --> EasyAccessMode
    //  4 --> WithinPopUpRange
    //  5 --> BeyondPopUpRange
    //  6 --> WaitForLatchOpen
    //  7 --> MovgOutTip2Run
    //  8 --> MovgOutManAssist
    //  9 --> MovgOutPopUp
    //  10 --> MovgOutReverse
    //  11 --> MovgInAuto
    //  12 --> MovgInTip2Run
    //  13 --> MovgInManAssist
    //  14 --> MovgInDenormalized
    //  15 --> Reserved_1
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_SBCM_RL_Door_Blocked(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[17] &= static_cast<uint8_t>(~0x18);                     // clear the bits for new data
    canPacket_.data[17] |= static_cast<uint8_t>((bitBuffer << 3) & (0x18)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On (Blocked)
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_SBCM_RR_DoorStatus(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[18] &= static_cast<uint8_t>(~0x1e);                     // clear the bits for new data
    canPacket_.data[18] |= static_cast<uint8_t>((bitBuffer << 1) & (0x1e)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Unknown
    //  1 --> FullClosed
    //  2 --> FullOpened
    //  3 --> EasyAccessMode
    //  4 --> WithinPopUpRange
    //  5 --> BeyondPopUpRange
    //  6 --> WaitForLatchOpen
    //  7 --> MovgOutTip2Run
    //  8 --> MovgOutManAssist
    //  9 --> MovgOutPopUp
    //  10 --> MovgOutReverse
    //  11 --> MovgInAuto
    //  12 --> MovgInTip2Run
    //  13 --> MovgInManAssist
    //  14 --> MovgInDenormalized
    //  15 --> Reserved_1
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_SBCM_RR_Door_Blocked(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[18] &= static_cast<uint8_t>(~0x60);                     // clear the bits for new data
    canPacket_.data[18] |= static_cast<uint8_t>((bitBuffer << 5) & (0x60)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On (Blocked)
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_VIC_BodyCtrl_FB_01A_AlvCnt1Val(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[2] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[2] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_VIC_BodyCtrl_FB_01A_Crc1Val(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[0] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[0] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[1] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[1] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff)); // push in new data
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Warn_AsstDrSwSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[15] &= static_cast<uint8_t>(~0x18);                     // clear the bits for new data
    canPacket_.data[15] |= static_cast<uint8_t>((bitBuffer << 3) & (0x18)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Close
    //  1 --> Open
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Warn_DrvDrSwSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[14] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[14] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    canPacket_.data[15] &= static_cast<uint8_t>(~0x1);                      // clear the bits for new data
    canPacket_.data[15] |= static_cast<uint8_t>((bitBuffer >> 1) & (0x1));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Close
    //  1 --> Open
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Warn_HoodSwSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[20] &= static_cast<uint8_t>(~0x3);                // clear the bits for new data
    canPacket_.data[20] |= static_cast<uint8_t>((bitBuffer) & (0x3)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Warn_RrLftDrSwSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[16] &= static_cast<uint8_t>(~0x60);                     // clear the bits for new data
    canPacket_.data[16] |= static_cast<uint8_t>((bitBuffer << 5) & (0x60)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Close
    //  1 --> Open
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Warn_RrRtDrSwSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[17] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[17] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    canPacket_.data[18] &= static_cast<uint8_t>(~0x1);                      // clear the bits for new data
    canPacket_.data[18] |= static_cast<uint8_t>((bitBuffer >> 1) & (0x1));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Close
    //  1 --> Open
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Window_AsstPwrWdwAutoSwSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[23] &= static_cast<uint8_t>(~0xc);                     // clear the bits for new data
    canPacket_.data[23] |= static_cast<uint8_t>((bitBuffer << 2) & (0xc)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Window_AsstPwrWdwDnSwSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[23] &= static_cast<uint8_t>(~0x30);                     // clear the bits for new data
    canPacket_.data[23] |= static_cast<uint8_t>((bitBuffer << 4) & (0x30)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Window_AsstPwrWdwUpSwSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[23] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[23] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Window_AsstSdWdwActSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[22] &= static_cast<uint8_t>(~0x1e);                     // clear the bits for new data
    canPacket_.data[22] |= static_cast<uint8_t>((bitBuffer << 1) & (0x1e)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No Action
    //  1 --> Manual Down
    //  2 --> Manual Up
    //  3 --> RLY Stuck/FET Error
    //  4 --> Motor Stop Error
    //  5 --> Auto Down
    //  6 --> Auto Up
    //  7 --> Reverse
    //  8 --> Reserved
    //  9 --> Reserved
    //  10 --> Reserved
    //  11 --> Reserved
    //  12 --> Reserved
    //  13 --> Reserved
    //  14 --> Reserved
    //  15 --> Invalid
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Window_AsstSdWdwDetailOpnSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[22] &= static_cast<uint8_t>(~0xe0);                     // clear the bits for new data
    canPacket_.data[22] |= static_cast<uint8_t>((bitBuffer << 5) & (0xe0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Full Close
    //  1 --> 1~30% Open
    //  2 --> 31~99% Open
    //  3 --> Full Open
    //  4 --> Reserved
    //  5 --> Reserved
    //  6 --> Reserved
    //  7 --> Invalid
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Window_AsstSdWdwErrAntPinch(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[23] &= static_cast<uint8_t>(~0x3);                // clear the bits for new data
    canPacket_.data[23] |= static_cast<uint8_t>((bitBuffer) & (0x3)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Calibrated
    //  1 --> De-Calibrated
    //  2 --> Reserved
    //  3 --> Invalid
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Window_DrvPwrWdwAutoSwSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[21] &= static_cast<uint8_t>(~0x18);                     // clear the bits for new data
    canPacket_.data[21] |= static_cast<uint8_t>((bitBuffer << 3) & (0x18)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Window_DrvPwrWdwDnSwSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[21] &= static_cast<uint8_t>(~0x60);                     // clear the bits for new data
    canPacket_.data[21] |= static_cast<uint8_t>((bitBuffer << 5) & (0x60)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Window_DrvPwrWdwUpSwSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[21] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[21] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    canPacket_.data[22] &= static_cast<uint8_t>(~0x1);                      // clear the bits for new data
    canPacket_.data[22] |= static_cast<uint8_t>((bitBuffer >> 1) & (0x1));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Window_DrvrSdWdwActSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[20] &= static_cast<uint8_t>(~0x3c);                     // clear the bits for new data
    canPacket_.data[20] |= static_cast<uint8_t>((bitBuffer << 2) & (0x3c)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No Action
    //  1 --> Manual Down
    //  2 --> Manual Up
    //  3 --> RLY Stuck/FET Error
    //  4 --> Motor Stop Error
    //  5 --> Auto Down
    //  6 --> Auto Up
    //  7 --> Reverse
    //  8 --> Reserved
    //  9 --> Reserved
    //  10 --> Reserved
    //  11 --> Reserved
    //  12 --> Reserved
    //  13 --> Reserved
    //  14 --> Reserved
    //  15 --> Invalid
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Window_DrvrSdWdwDetailOpnSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[20] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[20] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    canPacket_.data[21] &= static_cast<uint8_t>(~0x1);                      // clear the bits for new data
    canPacket_.data[21] |= static_cast<uint8_t>((bitBuffer >> 2) & (0x1));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Full Close
    //  1 --> 1~30% Open
    //  2 --> 31~99% Open
    //  3 --> Full Open
    //  4 --> Reserved
    //  5 --> Reserved
    //  6 --> Reserved
    //  7 --> Invalid
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Window_DrvrSdWdwErrAntPinch(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[21] &= static_cast<uint8_t>(~0x6);                     // clear the bits for new data
    canPacket_.data[21] |= static_cast<uint8_t>((bitBuffer << 1) & (0x6)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Calibrated
    //  1 --> De-Calibrated
    //  2 --> Reserved
    //  3 --> Invalid
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Window_PwrWdwMvInhbtSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[27] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[27] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> RESERVED
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Window_RrLftPwrWdwAutoSwSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[24] &= static_cast<uint8_t>(~0x3);                // clear the bits for new data
    canPacket_.data[24] |= static_cast<uint8_t>((bitBuffer) & (0x3)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Window_RrLftPwrWdwDnSwSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[24] &= static_cast<uint8_t>(~0xc);                     // clear the bits for new data
    canPacket_.data[24] |= static_cast<uint8_t>((bitBuffer << 2) & (0xc)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Window_RrLftPwrWdwUpSwSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[24] &= static_cast<uint8_t>(~0x30);                     // clear the bits for new data
    canPacket_.data[24] |= static_cast<uint8_t>((bitBuffer << 4) & (0x30)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Window_RrLftWdwActSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[24] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[24] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    canPacket_.data[25] &= static_cast<uint8_t>(~0x3);                      // clear the bits for new data
    canPacket_.data[25] |= static_cast<uint8_t>((bitBuffer >> 2) & (0x3));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No Action
    //  1 --> Manual Down
    //  2 --> Manual Up
    //  3 --> RLY Stuck/FET Error
    //  4 --> Motor Stop Error
    //  5 --> Auto Down
    //  6 --> Auto Up
    //  7 --> Reverse
    //  8 --> Reserved
    //  9 --> Reserved
    //  10 --> Reserved
    //  11 --> Reserved
    //  12 --> Reserved
    //  13 --> Reserved
    //  14 --> Reserved
    //  15 --> Invalid
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Window_RrLftWdwDetailOpnSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[25] &= static_cast<uint8_t>(~0x1c);                     // clear the bits for new data
    canPacket_.data[25] |= static_cast<uint8_t>((bitBuffer << 2) & (0x1c)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Full Close
    //  1 --> 1~30% Open
    //  2 --> 31~99% Open
    //  3 --> Full Open
    //  4 --> Reserved
    //  5 --> Reserved
    //  6 --> Reserved
    //  7 --> Invalid
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Window_RrLftWdwErrAntPinch(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[25] &= static_cast<uint8_t>(~0x60);                     // clear the bits for new data
    canPacket_.data[25] |= static_cast<uint8_t>((bitBuffer << 5) & (0x60)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Calibrated
    //  1 --> De-Calibrated
    //  2 --> Reserved
    //  3 --> Invalid
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Window_RrRtPwrWdwAutoSwSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[25] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[25] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    canPacket_.data[26] &= static_cast<uint8_t>(~0x1);                      // clear the bits for new data
    canPacket_.data[26] |= static_cast<uint8_t>((bitBuffer >> 1) & (0x1));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Window_RrRtPwrWdwDnSwSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[26] &= static_cast<uint8_t>(~0x6);                     // clear the bits for new data
    canPacket_.data[26] |= static_cast<uint8_t>((bitBuffer << 1) & (0x6)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Window_RrRtPwrWdwUpSwSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[26] &= static_cast<uint8_t>(~0x18);                     // clear the bits for new data
    canPacket_.data[26] |= static_cast<uint8_t>((bitBuffer << 3) & (0x18)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Window_RrRtWdwActSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[26] &= static_cast<uint8_t>(~0xe0);                     // clear the bits for new data
    canPacket_.data[26] |= static_cast<uint8_t>((bitBuffer << 5) & (0xe0)); // push in new data
    canPacket_.data[27] &= static_cast<uint8_t>(~0x1);                      // clear the bits for new data
    canPacket_.data[27] |= static_cast<uint8_t>((bitBuffer >> 3) & (0x1));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No Action
    //  1 --> Manual Down
    //  2 --> Manual Up
    //  3 --> RLY Stuck/FET Error
    //  4 --> Motor Stop Error
    //  5 --> Auto Down
    //  6 --> Auto Up
    //  7 --> Reverse
    //  8 --> Reserved
    //  9 --> Reserved
    //  10 --> Reserved
    //  11 --> Reserved
    //  12 --> Reserved
    //  13 --> Reserved
    //  14 --> Reserved
    //  15 --> Invalid
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Window_RrRtWdwDetailOpnSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[27] &= static_cast<uint8_t>(~0xe);                     // clear the bits for new data
    canPacket_.data[27] |= static_cast<uint8_t>((bitBuffer << 1) & (0xe)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Full Close
    //  1 --> 1~30% Open
    //  2 --> 31~99% Open
    //  3 --> Full Open
    //  4 --> Reserved
    //  5 --> Reserved
    //  6 --> Reserved
    //  7 --> Invalid
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Window_RrRtWdwErrAntPinch(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[27] &= static_cast<uint8_t>(~0x30);                     // clear the bits for new data
    canPacket_.data[27] |= static_cast<uint8_t>((bitBuffer << 4) & (0x30)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Calibrated
    //  1 --> De-Calibrated
    //  2 --> Reserved
    //  3 --> Invalid
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Wiper_IntStepSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[14] &= static_cast<uint8_t>(~0x1c);                     // clear the bits for new data
    canPacket_.data[14] |= static_cast<uint8_t>((bitBuffer << 2) & (0x1c)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> STEP1(SLOW)
    //  1 --> STEP2
    //  2 --> STEP3
    //  3 --> STEP4
    //  4 --> STEP5(FAST)
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Wiper_RainAmount(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value / static_cast<double>(0.5)); // value / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[12] &= static_cast<uint8_t>(~0xfc);                     // clear the bits for new data
    canPacket_.data[12] |= static_cast<uint8_t>((bitBuffer << 2) & (0xfc)); // push in new data
    canPacket_.data[13] &= static_cast<uint8_t>(~0x3);                      // clear the bits for new data
    canPacket_.data[13] |= static_cast<uint8_t>((bitBuffer >> 6) & (0x3));  // push in new data
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Wiper_RainSnsrSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[13] &= static_cast<uint8_t>(~0x3c);                     // clear the bits for new data
    canPacket_.data[13] |= static_cast<uint8_t>((bitBuffer << 2) & (0x3c)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> OFF
    //  1 --> Rain Detected
    //  2 --> Low
    //  3 --> High
    //  4 --> Fault 1
    //  5 --> Fault 2
    //  6 --> Fault 3
    //  7 --> Reserved
    //  8 --> Reserved
    //  9 --> Reserved
    //  10 --> Reserved
    //  11 --> Reserved
    //  12 --> Reserved
    //  13 --> Reserved
    //  14 --> Not Used
    //  15 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Wiper_RrWiperWshSwSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[14] &= static_cast<uint8_t>(~0x3);                // clear the bits for new data
    canPacket_.data[14] |= static_cast<uint8_t>((bitBuffer) & (0x3)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t R_VIC_BodyCtrl_FB_01A_PE_200ms::setR_Wiper_WiperRlyFRSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[13] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[13] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> Low
    //  2 --> High
    //  3 --> Error Indicator
    return 0;
}
