/// @copyright Copyright (c) 2021- Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file: /home/scotty/Downloads/Gen2_AVT_B_Control_CAN1.dbc

#include "VehicleCANLibrary/g2h/av_proto/VIC_BodyCtrl_FB_01B_PE_200ms.hpp"
#include <algorithm>
#include <string.h>

using namespace av::can::g2h::avproto;

VIC_BodyCtrl_FB_01B_PE_200ms::VIC_BodyCtrl_FB_01B_PE_200ms(const uint32_t id)
{
    canPacket_.id = id;
    canPacket_.length = VIC_BodyCtrl_FB_01B_PE_200ms_CONSTS::VIC_BODYCTRL_FB_01B_PE_200MS_PACKET_LEN;
}

VIC_BodyCtrl_FB_01B_PE_200ms::VIC_BodyCtrl_FB_01B_PE_200ms(const uint32_t id,
                                                           uint8_t* const payload,
                                                           const uint8_t size)
{
    canPacket_.id = id;

    if ((size <= sizeof(canPacket_.data)) && payload) {
        canPacket_.length = size;
        std::copy_n(payload, size, canPacket_.data);
    }
}

const CanFdPacket& VIC_BodyCtrl_FB_01B_PE_200ms::getCanPacket() const
{
    return canPacket_;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_FtwellFrBlueVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[25]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[26]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1ff);                                 // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);         // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0x0FF:Blue Color 0~255 (User Selection)
    //  255 --> 0x0x000~0x0FF:Blue Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:Reserved
    //  510 --> 0x101~0x1FE:Reserved
    //  511 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_FtwellFrBrgtnsVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[26]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xe);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> 4Step
    //  6 --> Reserved
    //  7 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_FtwellFrFrqVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[26]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x70);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> Reserved
    //  6 --> Reserved
    //  7 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_FtwellFrGreenVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[26]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[27]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xff80);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0x0FF:Green Color 0~255 (User Selection)
    //  255 --> 0x0x000~0x0FF:Green Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:Reserved
    //  510 --> 0x101~0x1FE:Reserved
    //  511 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_FtwellFrPatternVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[28]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x1f);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);    // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Pattern 1~9
    //  2 --> Pattern 1~9
    //  3 --> Pattern 1~9
    //  4 --> Pattern 1~9
    //  5 --> Pattern 1~9
    //  6 --> Pattern 1~9
    //  7 --> Pattern 1~9
    //  8 --> Pattern 1~9
    //  9 --> Pattern 1~9
    //  10 --> Reserved
    //  11 --> Reserved
    //  12 --> Reserved
    //  13 --> Reserved
    //  14 --> Reserved
    //  15 --> Reserved
    //  16 --> Reserved
    //  17 --> Reserved
    //  18 --> Reserved
    //  19 --> Reserved
    //  20 --> Reserved
    //  21 --> Reserved
    //  22 --> Reserved
    //  23 --> Reserved
    //  24 --> Reserved
    //  25 --> Reserved
    //  26 --> Reserved
    //  27 --> Reserved
    //  28 --> Reserved
    //  29 --> Reserved
    //  30 --> Reserved
    //  31 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_FtwellFrPwrVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[28]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x60);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> On
    //  3 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_FtwellFrRedVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[28]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[29]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xff80);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0x0FF:Red Color 0~255 (User Selection)
    //  255 --> 0x0x000~0x0FF:Red Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:Reserved
    //  510 --> 0x101~0x1FE:Reserved
    //  511 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_FtwellFrVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[30]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xf);                              // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);    // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> 4Step
    //  6 --> 5Step
    //  7 --> 6Step
    //  8 --> 7Step
    //  9 --> 8Step
    //  10 --> Invalid
    //  11 --> Invalid
    //  12 --> Invalid
    //  13 --> Invalid
    //  14 --> Invalid
    //  15 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_LedStipsFlDrBlueVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1ff);                                // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);        // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0xFF:Blue Color 0~255 (User Selection)
    //  255 --> 0x0x000~0xFF:Blue Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:RESERVED
    //  510 --> 0x101~0x1FE:RESERVED
    //  511 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_LedStipsFlDrBrgtnsVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x70);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> 4Step
    //  6 --> RESERVED
    //  7 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_LedStipsFlDrFrqVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xe);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> RESERVED
    //  6 --> RESERVED
    //  7 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_LedStipsFlDrGreenVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[5]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xff80);                               // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                                  // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0xFF:Green Color 0~255 (User Selection)
    //  255 --> 0x0x000~0xFF:Green Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:RESERVED
    //  510 --> 0x101~0x1FE:RESERVED
    //  511 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_LedStipsFlDrPatternVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x1f);                            // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Pattern 1~9
    //  2 --> Pattern 1~9
    //  3 --> Pattern 1~9
    //  4 --> Pattern 1~9
    //  5 --> Pattern 1~9
    //  6 --> Pattern 1~9
    //  7 --> Pattern 1~9
    //  8 --> Pattern 1~9
    //  9 --> Pattern 1~9
    //  10 --> RESERVED
    //  11 --> RESERVED
    //  12 --> RESERVED
    //  13 --> RESERVED
    //  14 --> RESERVED
    //  15 --> RESERVED
    //  16 --> RESERVED
    //  17 --> RESERVED
    //  18 --> RESERVED
    //  19 --> RESERVED
    //  20 --> RESERVED
    //  21 --> RESERVED
    //  22 --> RESERVED
    //  23 --> RESERVED
    //  24 --> RESERVED
    //  25 --> RESERVED
    //  26 --> RESERVED
    //  27 --> RESERVED
    //  28 --> RESERVED
    //  29 --> RESERVED
    //  30 --> RESERVED
    //  31 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_LedStipsFlDrPwrVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x60);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> On
    //  3 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_LedStipsFlDrRedVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xff80);                               // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                                  // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0xFF:Red Color 0~255 (User Selection)
    //  255 --> 0x0x000~0xFF:Red Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:RESERVED
    //  510 --> 0x101~0x1FE:RESERVED
    //  511 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_LedStipsFlDrSpdVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xf);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> 4Step
    //  6 --> 5Step
    //  7 --> 6Step
    //  8 --> 7Step
    //  9 --> 8Step
    //  10 --> Invalid
    //  11 --> Invalid
    //  12 --> Invalid
    //  13 --> Invalid
    //  14 --> Invalid
    //  15 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_LedStipsFrDrBlueVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1ff0);                               // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                                  // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0xFF:Blue Color 0~255 (User Selection)
    //  255 --> 0x0x000~0xFF:Blue Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:RESERVED
    //  510 --> 0x101~0x1FE:RESERVED
    //  511 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_LedStipsFrDrBrgtnsVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xe0);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> 4Step
    //  6 --> RESERVED
    //  7 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_LedStipsFrDrFrqVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x7);                              // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);    // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> RESERVED
    //  6 --> RESERVED
    //  7 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_LedStipsFrDrGreenVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[11]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xff8);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0xFF:Green Color 0~255 (User Selection)
    //  255 --> 0x0x000~0xFF:Green Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:RESERVED
    //  510 --> 0x101~0x1FE:RESERVED
    //  511 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_LedStipsFrDrPatternVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[11]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[12]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1f0);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Pattern 1~9
    //  2 --> Pattern 1~9
    //  3 --> Pattern 1~9
    //  4 --> Pattern 1~9
    //  5 --> Pattern 1~9
    //  6 --> Pattern 1~9
    //  7 --> Pattern 1~9
    //  8 --> Pattern 1~9
    //  9 --> Pattern 1~9
    //  10 --> RESERVED
    //  11 --> RESERVED
    //  12 --> RESERVED
    //  13 --> RESERVED
    //  14 --> RESERVED
    //  15 --> RESERVED
    //  16 --> RESERVED
    //  17 --> RESERVED
    //  18 --> RESERVED
    //  19 --> RESERVED
    //  20 --> RESERVED
    //  21 --> RESERVED
    //  22 --> RESERVED
    //  23 --> RESERVED
    //  24 --> RESERVED
    //  25 --> RESERVED
    //  26 --> RESERVED
    //  27 --> RESERVED
    //  28 --> RESERVED
    //  29 --> RESERVED
    //  30 --> RESERVED
    //  31 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_LedStipsFrDrPwrVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[12]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x6);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> On
    //  3 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_LedStipsFrDrRedVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[12]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[13]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xff8);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0xFF:Red Color 0~255 (User Selection)
    //  255 --> 0x0x000~0xFF:Red Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:RESERVED
    //  510 --> 0x101~0x1FE:RESERVED
    //  511 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_LedStipsFrDrSpdVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[13]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xf0);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> 4Step
    //  6 --> 5Step
    //  7 --> 6Step
    //  8 --> 7Step
    //  9 --> 8Step
    //  10 --> Invalid
    //  11 --> Invalid
    //  12 --> Invalid
    //  13 --> Invalid
    //  14 --> Invalid
    //  15 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_LedStipsRlDrBlueVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[14]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[15]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1ff);                                 // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);         // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0xFF:Blue Color 0~255 (User Selection)
    //  255 --> 0x0x000~0xFF:Blue Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:RESERVED
    //  510 --> 0x101~0x1FE:RESERVED
    //  511 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_LedStipsRlDrBrgtnsVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[15]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xe);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> 4Step
    //  6 --> RESERVED
    //  7 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_LedStipsRlDrFrqVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[15]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x70);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> RESERVED
    //  6 --> RESERVED
    //  7 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_LedStipsRlDrGreenVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[15]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[16]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xff80);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0xFF:Green Color 0~255 (User Selection)
    //  255 --> 0x0x000~0xFF:Green Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:RESERVED
    //  510 --> 0x101~0x1FE:RESERVED
    //  511 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_LedStipsRlDrPatternVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[17]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x1f);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);    // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Pattern 1~9
    //  2 --> Pattern 1~9
    //  3 --> Pattern 1~9
    //  4 --> Pattern 1~9
    //  5 --> Pattern 1~9
    //  6 --> Pattern 1~9
    //  7 --> Pattern 1~9
    //  8 --> Pattern 1~9
    //  9 --> Pattern 1~9
    //  10 --> RESERVED
    //  11 --> RESERVED
    //  12 --> RESERVED
    //  13 --> RESERVED
    //  14 --> RESERVED
    //  15 --> RESERVED
    //  16 --> RESERVED
    //  17 --> RESERVED
    //  18 --> RESERVED
    //  19 --> RESERVED
    //  20 --> RESERVED
    //  21 --> RESERVED
    //  22 --> RESERVED
    //  23 --> RESERVED
    //  24 --> RESERVED
    //  25 --> RESERVED
    //  26 --> RESERVED
    //  27 --> RESERVED
    //  28 --> RESERVED
    //  29 --> RESERVED
    //  30 --> RESERVED
    //  31 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_LedStipsRlDrPwrVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[17]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x60);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> On
    //  3 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_LedStipsRlDrRedVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[17]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[18]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xff80);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0xFF:Red Color 0~255 (User Selection)
    //  255 --> 0x0x000~0xFF:Red Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:RESERVED
    //  510 --> 0x101~0x1FE:RESERVED
    //  511 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_LedStipsRlDrSpdVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[19]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xf);                              // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);    // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> 4Step
    //  6 --> 5Step
    //  7 --> 6Step
    //  8 --> 7Step
    //  9 --> 8Step
    //  10 --> Invalid
    //  11 --> Invalid
    //  12 --> Invalid
    //  13 --> Invalid
    //  14 --> Invalid
    //  15 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_LedStipsRrDrBlueVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[19]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[20]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1ff0);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0xFF:Blue Color 0~255 (User Selection)
    //  255 --> 0x0x000~0xFF:Blue Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:RESERVED
    //  510 --> 0x101~0x1FE:RESERVED
    //  511 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_LedStipsRrDrBrgtnsVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[20]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xe0);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> 4Step
    //  6 --> RESERVED
    //  7 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_LedStipsRrDrFrqVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[21]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x7);                              // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);    // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> RESERVED
    //  6 --> RESERVED
    //  7 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_LedStipsRrDrGreenVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[21]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[22]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xff8);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0xFF:Green Color 0~255 (User Selection)
    //  255 --> 0x0x000~0xFF:Green Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:RESERVED
    //  510 --> 0x101~0x1FE:RESERVED
    //  511 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_LedStipsRrDrPatternVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[22]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[23]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1f0);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Pattern 1~9
    //  2 --> Pattern 1~9
    //  3 --> Pattern 1~9
    //  4 --> Pattern 1~9
    //  5 --> Pattern 1~9
    //  6 --> Pattern 1~9
    //  7 --> Pattern 1~9
    //  8 --> Pattern 1~9
    //  9 --> Pattern 1~9
    //  10 --> RESERVED
    //  11 --> RESERVED
    //  12 --> RESERVED
    //  13 --> RESERVED
    //  14 --> RESERVED
    //  15 --> RESERVED
    //  16 --> RESERVED
    //  17 --> RESERVED
    //  18 --> RESERVED
    //  19 --> RESERVED
    //  20 --> RESERVED
    //  21 --> RESERVED
    //  22 --> RESERVED
    //  23 --> RESERVED
    //  24 --> RESERVED
    //  25 --> RESERVED
    //  26 --> RESERVED
    //  27 --> RESERVED
    //  28 --> RESERVED
    //  29 --> RESERVED
    //  30 --> RESERVED
    //  31 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_LedStipsRrDrPwrVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[23]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x6);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> On
    //  3 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_LedStipsRrDrRedVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[23]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[24]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xff8);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0xFF:Red Color 0~255 (User Selection)
    //  255 --> 0x0x000~0xFF:Red Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:RESERVED
    //  510 --> 0x101~0x1FE:RESERVED
    //  511 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getMLM_LedStipsRrDrSpdVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[24]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xf0);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> 4Step
    //  6 --> 5Step
    //  7 --> 6Step
    //  8 --> 7Step
    //  9 --> 8Step
    //  10 --> Invalid
    //  11 --> Invalid
    //  12 --> Invalid
    //  13 --> Invalid
    //  14 --> Invalid
    //  15 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getVIC_BodyCtrl_FB_01B_AlvCnt1Val() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[2]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    return output;
}

double VIC_BodyCtrl_FB_01B_PE_200ms::getVIC_BodyCtrl_FB_01B_Crc1Val() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[0]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[1]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffff);                               // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);        // Unsigned value

    return output;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_FtwellFrBlueVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[25] &= static_cast<uint8_t>(~0xff);                    // clear the bits for new data
    canPacket_.data[25] |= static_cast<uint8_t>((bitBuffer) & (0xff));     // push in new data
    canPacket_.data[26] &= static_cast<uint8_t>(~0x1);                     // clear the bits for new data
    canPacket_.data[26] |= static_cast<uint8_t>((bitBuffer >> 8) & (0x1)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0x0FF:Blue Color 0~255 (User Selection)
    //  255 --> 0x0x000~0x0FF:Blue Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:Reserved
    //  510 --> 0x101~0x1FE:Reserved
    //  511 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_FtwellFrBrgtnsVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[26] &= static_cast<uint8_t>(~0xe);                     // clear the bits for new data
    canPacket_.data[26] |= static_cast<uint8_t>((bitBuffer << 1) & (0xe)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> 4Step
    //  6 --> Reserved
    //  7 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_FtwellFrFrqVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[26] &= static_cast<uint8_t>(~0x70);                     // clear the bits for new data
    canPacket_.data[26] |= static_cast<uint8_t>((bitBuffer << 4) & (0x70)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> Reserved
    //  6 --> Reserved
    //  7 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_FtwellFrGreenVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[26] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[26] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    canPacket_.data[27] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[27] |= static_cast<uint8_t>((bitBuffer >> 1) & (0xff)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0x0FF:Green Color 0~255 (User Selection)
    //  255 --> 0x0x000~0x0FF:Green Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:Reserved
    //  510 --> 0x101~0x1FE:Reserved
    //  511 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_FtwellFrPatternVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[28] &= static_cast<uint8_t>(~0x1f);                // clear the bits for new data
    canPacket_.data[28] |= static_cast<uint8_t>((bitBuffer) & (0x1f)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Pattern 1~9
    //  2 --> Pattern 1~9
    //  3 --> Pattern 1~9
    //  4 --> Pattern 1~9
    //  5 --> Pattern 1~9
    //  6 --> Pattern 1~9
    //  7 --> Pattern 1~9
    //  8 --> Pattern 1~9
    //  9 --> Pattern 1~9
    //  10 --> Reserved
    //  11 --> Reserved
    //  12 --> Reserved
    //  13 --> Reserved
    //  14 --> Reserved
    //  15 --> Reserved
    //  16 --> Reserved
    //  17 --> Reserved
    //  18 --> Reserved
    //  19 --> Reserved
    //  20 --> Reserved
    //  21 --> Reserved
    //  22 --> Reserved
    //  23 --> Reserved
    //  24 --> Reserved
    //  25 --> Reserved
    //  26 --> Reserved
    //  27 --> Reserved
    //  28 --> Reserved
    //  29 --> Reserved
    //  30 --> Reserved
    //  31 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_FtwellFrPwrVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[28] &= static_cast<uint8_t>(~0x60);                     // clear the bits for new data
    canPacket_.data[28] |= static_cast<uint8_t>((bitBuffer << 5) & (0x60)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> On
    //  3 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_FtwellFrRedVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[28] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[28] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    canPacket_.data[29] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[29] |= static_cast<uint8_t>((bitBuffer >> 1) & (0xff)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0x0FF:Red Color 0~255 (User Selection)
    //  255 --> 0x0x000~0x0FF:Red Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:Reserved
    //  510 --> 0x101~0x1FE:Reserved
    //  511 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_FtwellFrVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[30] &= static_cast<uint8_t>(~0xf);                // clear the bits for new data
    canPacket_.data[30] |= static_cast<uint8_t>((bitBuffer) & (0xf)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> 4Step
    //  6 --> 5Step
    //  7 --> 6Step
    //  8 --> 7Step
    //  9 --> 8Step
    //  10 --> Invalid
    //  11 --> Invalid
    //  12 --> Invalid
    //  13 --> Invalid
    //  14 --> Invalid
    //  15 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_LedStipsFlDrBlueVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0xff);                    // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer) & (0xff));     // push in new data
    canPacket_.data[4] &= static_cast<uint8_t>(~0x1);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer >> 8) & (0x1)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0xFF:Blue Color 0~255 (User Selection)
    //  255 --> 0x0x000~0xFF:Blue Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:RESERVED
    //  510 --> 0x101~0x1FE:RESERVED
    //  511 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_LedStipsFlDrBrgtnsVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0x70);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer << 4) & (0x70)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> 4Step
    //  6 --> RESERVED
    //  7 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_LedStipsFlDrFrqVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0xe);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer << 1) & (0xe)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> RESERVED
    //  6 --> RESERVED
    //  7 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_LedStipsFlDrGreenVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    canPacket_.data[5] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[5] |= static_cast<uint8_t>((bitBuffer >> 1) & (0xff)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0xFF:Green Color 0~255 (User Selection)
    //  255 --> 0x0x000~0xFF:Green Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:RESERVED
    //  510 --> 0x101~0x1FE:RESERVED
    //  511 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_LedStipsFlDrPatternVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[6] &= static_cast<uint8_t>(~0x1f);                // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer) & (0x1f)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Pattern 1~9
    //  2 --> Pattern 1~9
    //  3 --> Pattern 1~9
    //  4 --> Pattern 1~9
    //  5 --> Pattern 1~9
    //  6 --> Pattern 1~9
    //  7 --> Pattern 1~9
    //  8 --> Pattern 1~9
    //  9 --> Pattern 1~9
    //  10 --> RESERVED
    //  11 --> RESERVED
    //  12 --> RESERVED
    //  13 --> RESERVED
    //  14 --> RESERVED
    //  15 --> RESERVED
    //  16 --> RESERVED
    //  17 --> RESERVED
    //  18 --> RESERVED
    //  19 --> RESERVED
    //  20 --> RESERVED
    //  21 --> RESERVED
    //  22 --> RESERVED
    //  23 --> RESERVED
    //  24 --> RESERVED
    //  25 --> RESERVED
    //  26 --> RESERVED
    //  27 --> RESERVED
    //  28 --> RESERVED
    //  29 --> RESERVED
    //  30 --> RESERVED
    //  31 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_LedStipsFlDrPwrVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[6] &= static_cast<uint8_t>(~0x60);                     // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer << 5) & (0x60)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> On
    //  3 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_LedStipsFlDrRedVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[6] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    canPacket_.data[7] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer >> 1) & (0xff)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0xFF:Red Color 0~255 (User Selection)
    //  255 --> 0x0x000~0xFF:Red Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:RESERVED
    //  510 --> 0x101~0x1FE:RESERVED
    //  511 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_LedStipsFlDrSpdVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[8] &= static_cast<uint8_t>(~0xf);                // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer) & (0xf)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> 4Step
    //  6 --> 5Step
    //  7 --> 6Step
    //  8 --> 7Step
    //  9 --> 8Step
    //  10 --> Invalid
    //  11 --> Invalid
    //  12 --> Invalid
    //  13 --> Invalid
    //  14 --> Invalid
    //  15 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_LedStipsFrDrBlueVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[8] &= static_cast<uint8_t>(~0xf0);                     // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer << 4) & (0xf0)); // push in new data
    canPacket_.data[9] &= static_cast<uint8_t>(~0x1f);                     // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer >> 4) & (0x1f)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0xFF:Blue Color 0~255 (User Selection)
    //  255 --> 0x0x000~0xFF:Blue Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:RESERVED
    //  510 --> 0x101~0x1FE:RESERVED
    //  511 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_LedStipsFrDrBrgtnsVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[9] &= static_cast<uint8_t>(~0xe0);                     // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer << 5) & (0xe0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> 4Step
    //  6 --> RESERVED
    //  7 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_LedStipsFrDrFrqVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[10] &= static_cast<uint8_t>(~0x7);                // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer) & (0x7)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> RESERVED
    //  6 --> RESERVED
    //  7 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_LedStipsFrDrGreenVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[10] &= static_cast<uint8_t>(~0xf8);                     // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer << 3) & (0xf8)); // push in new data
    canPacket_.data[11] &= static_cast<uint8_t>(~0xf);                      // clear the bits for new data
    canPacket_.data[11] |= static_cast<uint8_t>((bitBuffer >> 5) & (0xf));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0xFF:Green Color 0~255 (User Selection)
    //  255 --> 0x0x000~0xFF:Green Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:RESERVED
    //  510 --> 0x101~0x1FE:RESERVED
    //  511 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_LedStipsFrDrPatternVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[11] &= static_cast<uint8_t>(~0xf0);                     // clear the bits for new data
    canPacket_.data[11] |= static_cast<uint8_t>((bitBuffer << 4) & (0xf0)); // push in new data
    canPacket_.data[12] &= static_cast<uint8_t>(~0x1);                      // clear the bits for new data
    canPacket_.data[12] |= static_cast<uint8_t>((bitBuffer >> 4) & (0x1));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Pattern 1~9
    //  2 --> Pattern 1~9
    //  3 --> Pattern 1~9
    //  4 --> Pattern 1~9
    //  5 --> Pattern 1~9
    //  6 --> Pattern 1~9
    //  7 --> Pattern 1~9
    //  8 --> Pattern 1~9
    //  9 --> Pattern 1~9
    //  10 --> RESERVED
    //  11 --> RESERVED
    //  12 --> RESERVED
    //  13 --> RESERVED
    //  14 --> RESERVED
    //  15 --> RESERVED
    //  16 --> RESERVED
    //  17 --> RESERVED
    //  18 --> RESERVED
    //  19 --> RESERVED
    //  20 --> RESERVED
    //  21 --> RESERVED
    //  22 --> RESERVED
    //  23 --> RESERVED
    //  24 --> RESERVED
    //  25 --> RESERVED
    //  26 --> RESERVED
    //  27 --> RESERVED
    //  28 --> RESERVED
    //  29 --> RESERVED
    //  30 --> RESERVED
    //  31 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_LedStipsFrDrPwrVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[12] &= static_cast<uint8_t>(~0x6);                     // clear the bits for new data
    canPacket_.data[12] |= static_cast<uint8_t>((bitBuffer << 1) & (0x6)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> On
    //  3 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_LedStipsFrDrRedVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[12] &= static_cast<uint8_t>(~0xf8);                     // clear the bits for new data
    canPacket_.data[12] |= static_cast<uint8_t>((bitBuffer << 3) & (0xf8)); // push in new data
    canPacket_.data[13] &= static_cast<uint8_t>(~0xf);                      // clear the bits for new data
    canPacket_.data[13] |= static_cast<uint8_t>((bitBuffer >> 5) & (0xf));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0xFF:Red Color 0~255 (User Selection)
    //  255 --> 0x0x000~0xFF:Red Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:RESERVED
    //  510 --> 0x101~0x1FE:RESERVED
    //  511 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_LedStipsFrDrSpdVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[13] &= static_cast<uint8_t>(~0xf0);                     // clear the bits for new data
    canPacket_.data[13] |= static_cast<uint8_t>((bitBuffer << 4) & (0xf0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> 4Step
    //  6 --> 5Step
    //  7 --> 6Step
    //  8 --> 7Step
    //  9 --> 8Step
    //  10 --> Invalid
    //  11 --> Invalid
    //  12 --> Invalid
    //  13 --> Invalid
    //  14 --> Invalid
    //  15 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_LedStipsRlDrBlueVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[14] &= static_cast<uint8_t>(~0xff);                    // clear the bits for new data
    canPacket_.data[14] |= static_cast<uint8_t>((bitBuffer) & (0xff));     // push in new data
    canPacket_.data[15] &= static_cast<uint8_t>(~0x1);                     // clear the bits for new data
    canPacket_.data[15] |= static_cast<uint8_t>((bitBuffer >> 8) & (0x1)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0xFF:Blue Color 0~255 (User Selection)
    //  255 --> 0x0x000~0xFF:Blue Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:RESERVED
    //  510 --> 0x101~0x1FE:RESERVED
    //  511 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_LedStipsRlDrBrgtnsVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[15] &= static_cast<uint8_t>(~0xe);                     // clear the bits for new data
    canPacket_.data[15] |= static_cast<uint8_t>((bitBuffer << 1) & (0xe)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> 4Step
    //  6 --> RESERVED
    //  7 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_LedStipsRlDrFrqVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[15] &= static_cast<uint8_t>(~0x70);                     // clear the bits for new data
    canPacket_.data[15] |= static_cast<uint8_t>((bitBuffer << 4) & (0x70)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> RESERVED
    //  6 --> RESERVED
    //  7 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_LedStipsRlDrGreenVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[15] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[15] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    canPacket_.data[16] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[16] |= static_cast<uint8_t>((bitBuffer >> 1) & (0xff)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0xFF:Green Color 0~255 (User Selection)
    //  255 --> 0x0x000~0xFF:Green Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:RESERVED
    //  510 --> 0x101~0x1FE:RESERVED
    //  511 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_LedStipsRlDrPatternVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[17] &= static_cast<uint8_t>(~0x1f);                // clear the bits for new data
    canPacket_.data[17] |= static_cast<uint8_t>((bitBuffer) & (0x1f)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Pattern 1~9
    //  2 --> Pattern 1~9
    //  3 --> Pattern 1~9
    //  4 --> Pattern 1~9
    //  5 --> Pattern 1~9
    //  6 --> Pattern 1~9
    //  7 --> Pattern 1~9
    //  8 --> Pattern 1~9
    //  9 --> Pattern 1~9
    //  10 --> RESERVED
    //  11 --> RESERVED
    //  12 --> RESERVED
    //  13 --> RESERVED
    //  14 --> RESERVED
    //  15 --> RESERVED
    //  16 --> RESERVED
    //  17 --> RESERVED
    //  18 --> RESERVED
    //  19 --> RESERVED
    //  20 --> RESERVED
    //  21 --> RESERVED
    //  22 --> RESERVED
    //  23 --> RESERVED
    //  24 --> RESERVED
    //  25 --> RESERVED
    //  26 --> RESERVED
    //  27 --> RESERVED
    //  28 --> RESERVED
    //  29 --> RESERVED
    //  30 --> RESERVED
    //  31 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_LedStipsRlDrPwrVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[17] &= static_cast<uint8_t>(~0x60);                     // clear the bits for new data
    canPacket_.data[17] |= static_cast<uint8_t>((bitBuffer << 5) & (0x60)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> On
    //  3 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_LedStipsRlDrRedVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[17] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[17] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    canPacket_.data[18] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[18] |= static_cast<uint8_t>((bitBuffer >> 1) & (0xff)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0xFF:Red Color 0~255 (User Selection)
    //  255 --> 0x0x000~0xFF:Red Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:RESERVED
    //  510 --> 0x101~0x1FE:RESERVED
    //  511 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_LedStipsRlDrSpdVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[19] &= static_cast<uint8_t>(~0xf);                // clear the bits for new data
    canPacket_.data[19] |= static_cast<uint8_t>((bitBuffer) & (0xf)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> 4Step
    //  6 --> 5Step
    //  7 --> 6Step
    //  8 --> 7Step
    //  9 --> 8Step
    //  10 --> Invalid
    //  11 --> Invalid
    //  12 --> Invalid
    //  13 --> Invalid
    //  14 --> Invalid
    //  15 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_LedStipsRrDrBlueVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[19] &= static_cast<uint8_t>(~0xf0);                     // clear the bits for new data
    canPacket_.data[19] |= static_cast<uint8_t>((bitBuffer << 4) & (0xf0)); // push in new data
    canPacket_.data[20] &= static_cast<uint8_t>(~0x1f);                     // clear the bits for new data
    canPacket_.data[20] |= static_cast<uint8_t>((bitBuffer >> 4) & (0x1f)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0xFF:Blue Color 0~255 (User Selection)
    //  255 --> 0x0x000~0xFF:Blue Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:RESERVED
    //  510 --> 0x101~0x1FE:RESERVED
    //  511 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_LedStipsRrDrBrgtnsVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[20] &= static_cast<uint8_t>(~0xe0);                     // clear the bits for new data
    canPacket_.data[20] |= static_cast<uint8_t>((bitBuffer << 5) & (0xe0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> 4Step
    //  6 --> RESERVED
    //  7 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_LedStipsRrDrFrqVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[21] &= static_cast<uint8_t>(~0x7);                // clear the bits for new data
    canPacket_.data[21] |= static_cast<uint8_t>((bitBuffer) & (0x7)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> RESERVED
    //  6 --> RESERVED
    //  7 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_LedStipsRrDrGreenVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[21] &= static_cast<uint8_t>(~0xf8);                     // clear the bits for new data
    canPacket_.data[21] |= static_cast<uint8_t>((bitBuffer << 3) & (0xf8)); // push in new data
    canPacket_.data[22] &= static_cast<uint8_t>(~0xf);                      // clear the bits for new data
    canPacket_.data[22] |= static_cast<uint8_t>((bitBuffer >> 5) & (0xf));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0xFF:Green Color 0~255 (User Selection)
    //  255 --> 0x0x000~0xFF:Green Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:RESERVED
    //  510 --> 0x101~0x1FE:RESERVED
    //  511 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_LedStipsRrDrPatternVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[22] &= static_cast<uint8_t>(~0xf0);                     // clear the bits for new data
    canPacket_.data[22] |= static_cast<uint8_t>((bitBuffer << 4) & (0xf0)); // push in new data
    canPacket_.data[23] &= static_cast<uint8_t>(~0x1);                      // clear the bits for new data
    canPacket_.data[23] |= static_cast<uint8_t>((bitBuffer >> 4) & (0x1));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Pattern 1~9
    //  2 --> Pattern 1~9
    //  3 --> Pattern 1~9
    //  4 --> Pattern 1~9
    //  5 --> Pattern 1~9
    //  6 --> Pattern 1~9
    //  7 --> Pattern 1~9
    //  8 --> Pattern 1~9
    //  9 --> Pattern 1~9
    //  10 --> RESERVED
    //  11 --> RESERVED
    //  12 --> RESERVED
    //  13 --> RESERVED
    //  14 --> RESERVED
    //  15 --> RESERVED
    //  16 --> RESERVED
    //  17 --> RESERVED
    //  18 --> RESERVED
    //  19 --> RESERVED
    //  20 --> RESERVED
    //  21 --> RESERVED
    //  22 --> RESERVED
    //  23 --> RESERVED
    //  24 --> RESERVED
    //  25 --> RESERVED
    //  26 --> RESERVED
    //  27 --> RESERVED
    //  28 --> RESERVED
    //  29 --> RESERVED
    //  30 --> RESERVED
    //  31 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_LedStipsRrDrPwrVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[23] &= static_cast<uint8_t>(~0x6);                     // clear the bits for new data
    canPacket_.data[23] |= static_cast<uint8_t>((bitBuffer << 1) & (0x6)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> On
    //  3 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_LedStipsRrDrRedVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[23] &= static_cast<uint8_t>(~0xf8);                     // clear the bits for new data
    canPacket_.data[23] |= static_cast<uint8_t>((bitBuffer << 3) & (0xf8)); // push in new data
    canPacket_.data[24] &= static_cast<uint8_t>(~0xf);                      // clear the bits for new data
    canPacket_.data[24] |= static_cast<uint8_t>((bitBuffer >> 5) & (0xf));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x000~0xFF:Red Color 0~255 (User Selection)
    //  255 --> 0x0x000~0xFF:Red Color 0~255 (User Selection)
    //  256 --> Default
    //  257 --> 0x101~0x1FE:RESERVED
    //  510 --> 0x101~0x1FE:RESERVED
    //  511 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setMLM_LedStipsRrDrSpdVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[24] &= static_cast<uint8_t>(~0xf0);                     // clear the bits for new data
    canPacket_.data[24] |= static_cast<uint8_t>((bitBuffer << 4) & (0xf0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> 1Step
    //  3 --> 2Step
    //  4 --> 3Step
    //  5 --> 4Step
    //  6 --> 5Step
    //  7 --> 6Step
    //  8 --> 7Step
    //  9 --> 8Step
    //  10 --> Invalid
    //  11 --> Invalid
    //  12 --> Invalid
    //  13 --> Invalid
    //  14 --> Invalid
    //  15 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setVIC_BodyCtrl_FB_01B_AlvCnt1Val(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[2] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[2] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_BodyCtrl_FB_01B_PE_200ms::setVIC_BodyCtrl_FB_01B_Crc1Val(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[0] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[0] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[1] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[1] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff)); // push in new data
    return 0;
}
