/// @copyright Copyright (c) 2021- Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file: /home/scotty/Downloads/Gen2_AVT_B_Control_CAN1.dbc

#include "VehicleCANLibrary/g2h/av_proto/VIC_BodyCtrl_FB_01C_PE_200ms.hpp"
#include <algorithm>
#include <string.h>

using namespace av::can::g2h::avproto;

VIC_BodyCtrl_FB_01C_PE_200ms::VIC_BodyCtrl_FB_01C_PE_200ms(const uint32_t id)
{
    canPacket_.id = id;
    canPacket_.length = VIC_BodyCtrl_FB_01C_PE_200ms_CONSTS::VIC_BODYCTRL_FB_01C_PE_200MS_PACKET_LEN;
}

VIC_BodyCtrl_FB_01C_PE_200ms::VIC_BodyCtrl_FB_01C_PE_200ms(const uint32_t id,
                                                           uint8_t* const payload,
                                                           const uint8_t size)
{
    canPacket_.id = id;

    if ((size <= sizeof(canPacket_.data)) && payload) {
        canPacket_.length = size;
        std::copy_n(payload, size, canPacket_.data);
    }
}

const CanFdPacket& VIC_BodyCtrl_FB_01C_PE_200ms::getCanPacket() const
{
    return canPacket_;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getAPSM_AstHeightPosition() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[5]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x3fc);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                                  // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x00~0xFE:POSITION
    //  254 --> 0x0x00~0xFE:POSITION
    //  255 --> invalid
    return output;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getAPSM_AstReclinePosition() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x3fc);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                                  // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x00~0xFE:POSITION
    //  254 --> 0x0x00~0xFE:POSITION
    //  255 --> invalid
    return output;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getAPSM_AstSlidePosition() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x3fc);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                                  // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x00~0xFE:POSITION
    //  254 --> 0x0x00~0xFE:POSITION
    //  255 --> invalid
    return output;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getAPSM_SeatPosRclnLmt_Sta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Recline Fwd Limit
    //  2 --> Recline Bwd Limit
    //  3 --> Not Initialized
    return output;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getAPSM_SeatPosSldLmt_Sta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x30);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Slide Fwd Limit
    //  2 --> Slide Bwd Limit
    //  3 --> Not Initialized
    return output;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getAPSS_StRlxModeBtn() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[13]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[14]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x180);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> On
    //  3 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getAPSS_StRlxReturnBtn() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[14]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x6);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> On
    //  3 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getAPSS_StRlxTltDnMvBtn() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[14]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x60);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> On
    //  3 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getAPSS_StRlxTltUpMvBtn() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[14]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x18);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> On
    //  3 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getBCM_Ign1InSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x180);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> IGN1 Off
    //  1 --> IGN1 On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getBCM_Ign2InSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x6);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> IGN2 Off
    //  1 --> IGN2 On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getBCM_IgnSwSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x38);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> KeyOff
    //  1 --> KeyIn
    //  2 --> Acc
    //  3 --> Ign
    //  4 --> St
    //  5 --> Reseved
    //  6 --> Not Used
    //  7 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getICU_BS1BatVol() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[11]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[12]) << 16; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfffc0);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                                    // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.001)) + static_cast<double>(6); // (output * scale_factor) + bias

    return output;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getICU_BS1ValFlagSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[12]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x30);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Valid condition
    //  1 --> Invalid condition
    return output;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getICU_BS2SoC() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[12]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[13]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x7f80);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    return output;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getICU_BS2_FSOC() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[12]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x40);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> valid
    //  1 --> invalid
    return output;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getLamp_LtSwSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[14]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[15]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x180);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Light Sw Off
    //  1 --> Tail Sw On
    //  2 --> HeadLamp Low Sw On
    //  3 --> AutoLight Sw On
    return output;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getLamp_TrnSigLftSwSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[15]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x6);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getLamp_TrnSigRtSwSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[15]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x18);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getVIC_BodyCtrl_FB_01C_AlvCnt1Val() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[2]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    return output;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getVIC_BodyCtrl_FB_01C_Crc1Val() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[0]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[1]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffff);                               // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);        // Unsigned value

    return output;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getWarn_AsstStBltSwSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc0);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Unbelted
    //  1 --> Belted
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getWarn_DisWrngSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x1f);                            // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> Shift_P_Warning
    //  16 --> Vehicle_is_On(DigitalKey)
    //  17 --> Power Auto Off Ready
    //  18 --> Auth_Fail_Waring2 (non-SSB immo coil)
    //  19 --> ReAuth_Warning (Digital Key)
    //  20 --> ReAuth_Warning (FingerPrint)
    //  21 --> ReAuth_Warning (Digital Key&FingerPrint)
    //  30 --> Not Used
    //  31 --> Error Indicator
    //  2 --> Key_Bat_Discharge_Warning
    //  3 --> Not_Unlocked_Warning
    //  4 --> AC_Plug_Connected_Warning
    //  5 --> Escl_Ecu_Fail_Warning
    //  6 --> Engine_Start_Operation_IND
    //  7 --> Auth_Fail_Warning
    //  8 --> Key_Removal_IND
    //  9 --> SMK_Lamp_Warning
    //  10 --> SSB_Warning
    //  11 --> Auth_Fail_Warning2
    //  12 --> Vehicle_Not_P_Warning
    //  13 --> Stop Lamp Fuse Fail Warning
    //  14 --> Not P_N Warning
    //  15 --> Vehicle_is_On(FingerPrint)
    return output;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getWarn_DrvStBltSwSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x3);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Unbelted
    //  1 --> Belted
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getWarn_ImmoLmpOnReq() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x60);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getWarn_PassStOccSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off (UnSeated)
    //  1 --> On (Seated)
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getWarn_RrCtrSBRMATSwSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[5]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x3);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off (UnSeated)
    //  1 --> On (Seated)
    //  3 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getWarn_RrCtrStBltSwSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x3);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Unbelted
    //  1 --> Belted
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getWarn_RrLftSBRMATSwSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x30);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off (UnSeated)
    //  1 --> On (Seated)
    //  3 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getWarn_RrLftStBltSwSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Unbelted
    //  1 --> Belted
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getWarn_RrRhtSBRMATSwSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc0);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off (UnSeated)
    //  1 --> On (Seated)
    //  3 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getWarn_RrRtStBltSwSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x30);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Unbelted
    //  1 --> Belted
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getWarn_WshrFldSwSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc0);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return output;
}

double VIC_BodyCtrl_FB_01C_PE_200ms::getWiper_FrWiperSwSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[15]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xe0);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Wiper Sw Off
    //  1 --> Wiper Int or Auto Sw On(Refer to C_RainSnsOption)
    //  2 --> Wiper Low Sw On
    //  3 --> Wiper High Sw On
    //  4 --> Reserved
    //  5 --> Reserved
    //  6 --> Not Used
    //  7 --> Error Indicator
    return output;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setAPSM_AstHeightPosition(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[5] &= static_cast<uint8_t>(~0xfc);                     // clear the bits for new data
    canPacket_.data[5] |= static_cast<uint8_t>((bitBuffer << 2) & (0xfc)); // push in new data
    canPacket_.data[6] &= static_cast<uint8_t>(~0x3);                      // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer >> 6) & (0x3));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x00~0xFE:POSITION
    //  254 --> 0x0x00~0xFE:POSITION
    //  255 --> invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setAPSM_AstReclinePosition(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[6] &= static_cast<uint8_t>(~0xfc);                     // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer << 2) & (0xfc)); // push in new data
    canPacket_.data[7] &= static_cast<uint8_t>(~0x3);                      // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer >> 6) & (0x3));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x00~0xFE:POSITION
    //  254 --> 0x0x00~0xFE:POSITION
    //  255 --> invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setAPSM_AstSlidePosition(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[7] &= static_cast<uint8_t>(~0xfc);                     // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer << 2) & (0xfc)); // push in new data
    canPacket_.data[8] &= static_cast<uint8_t>(~0x3);                      // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer >> 6) & (0x3));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x00~0xFE:POSITION
    //  254 --> 0x0x00~0xFE:POSITION
    //  255 --> invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setAPSM_SeatPosRclnLmt_Sta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[8] &= static_cast<uint8_t>(~0xc);                     // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer << 2) & (0xc)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Recline Fwd Limit
    //  2 --> Recline Bwd Limit
    //  3 --> Not Initialized
    return 0;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setAPSM_SeatPosSldLmt_Sta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[8] &= static_cast<uint8_t>(~0x30);                     // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer << 4) & (0x30)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Slide Fwd Limit
    //  2 --> Slide Bwd Limit
    //  3 --> Not Initialized
    return 0;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setAPSS_StRlxModeBtn(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[13] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[13] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    canPacket_.data[14] &= static_cast<uint8_t>(~0x1);                      // clear the bits for new data
    canPacket_.data[14] |= static_cast<uint8_t>((bitBuffer >> 1) & (0x1));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> On
    //  3 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setAPSS_StRlxReturnBtn(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[14] &= static_cast<uint8_t>(~0x6);                     // clear the bits for new data
    canPacket_.data[14] |= static_cast<uint8_t>((bitBuffer << 1) & (0x6)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> On
    //  3 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setAPSS_StRlxTltDnMvBtn(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[14] &= static_cast<uint8_t>(~0x60);                     // clear the bits for new data
    canPacket_.data[14] |= static_cast<uint8_t>((bitBuffer << 5) & (0x60)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> On
    //  3 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setAPSS_StRlxTltUpMvBtn(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[14] &= static_cast<uint8_t>(~0x18);                     // clear the bits for new data
    canPacket_.data[14] |= static_cast<uint8_t>((bitBuffer << 3) & (0x18)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> Off
    //  2 --> On
    //  3 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setBCM_Ign1InSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[9] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    canPacket_.data[10] &= static_cast<uint8_t>(~0x1);                     // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer >> 1) & (0x1)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> IGN1 Off
    //  1 --> IGN1 On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setBCM_Ign2InSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[10] &= static_cast<uint8_t>(~0x6);                     // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer << 1) & (0x6)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> IGN2 Off
    //  1 --> IGN2 On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setBCM_IgnSwSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[10] &= static_cast<uint8_t>(~0x38);                     // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer << 3) & (0x38)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> KeyOff
    //  1 --> KeyIn
    //  2 --> Acc
    //  3 --> Ign
    //  4 --> St
    //  5 --> Reseved
    //  6 --> Not Used
    //  7 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setICU_BS1BatVol(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(6)) /
                                                  static_cast<double>(0.001)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[10] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    canPacket_.data[11] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[11] |= static_cast<uint8_t>((bitBuffer >> 2) & (0xff)); // push in new data
    canPacket_.data[12] &= static_cast<uint8_t>(~0xf);                      // clear the bits for new data
    canPacket_.data[12] |= static_cast<uint8_t>((bitBuffer >> 10) & (0xf)); // push in new data
    return 0;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setICU_BS1ValFlagSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[12] &= static_cast<uint8_t>(~0x30);                     // clear the bits for new data
    canPacket_.data[12] |= static_cast<uint8_t>((bitBuffer << 4) & (0x30)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Valid condition
    //  1 --> Invalid condition
    return 0;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setICU_BS2SoC(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[12] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[12] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    canPacket_.data[13] &= static_cast<uint8_t>(~0x7f);                     // clear the bits for new data
    canPacket_.data[13] |= static_cast<uint8_t>((bitBuffer >> 1) & (0x7f)); // push in new data
    return 0;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setICU_BS2_FSOC(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[12] &= static_cast<uint8_t>(~0x40);                     // clear the bits for new data
    canPacket_.data[12] |= static_cast<uint8_t>((bitBuffer << 6) & (0x40)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> valid
    //  1 --> invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setLamp_LtSwSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[14] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[14] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    canPacket_.data[15] &= static_cast<uint8_t>(~0x1);                      // clear the bits for new data
    canPacket_.data[15] |= static_cast<uint8_t>((bitBuffer >> 1) & (0x1));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Light Sw Off
    //  1 --> Tail Sw On
    //  2 --> HeadLamp Low Sw On
    //  3 --> AutoLight Sw On
    return 0;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setLamp_TrnSigLftSwSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[15] &= static_cast<uint8_t>(~0x6);                     // clear the bits for new data
    canPacket_.data[15] |= static_cast<uint8_t>((bitBuffer << 1) & (0x6)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setLamp_TrnSigRtSwSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[15] &= static_cast<uint8_t>(~0x18);                     // clear the bits for new data
    canPacket_.data[15] |= static_cast<uint8_t>((bitBuffer << 3) & (0x18)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setVIC_BodyCtrl_FB_01C_AlvCnt1Val(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[2] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[2] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setVIC_BodyCtrl_FB_01C_Crc1Val(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[0] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[0] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[1] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[1] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setWarn_AsstStBltSwSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Unbelted
    //  1 --> Belted
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setWarn_DisWrngSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[9] &= static_cast<uint8_t>(~0x1f);                // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer) & (0x1f)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> Shift_P_Warning
    //  16 --> Vehicle_is_On(DigitalKey)
    //  17 --> Power Auto Off Ready
    //  18 --> Auth_Fail_Waring2 (non-SSB immo coil)
    //  19 --> ReAuth_Warning (Digital Key)
    //  20 --> ReAuth_Warning (FingerPrint)
    //  21 --> ReAuth_Warning (Digital Key&FingerPrint)
    //  30 --> Not Used
    //  31 --> Error Indicator
    //  2 --> Key_Bat_Discharge_Warning
    //  3 --> Not_Unlocked_Warning
    //  4 --> AC_Plug_Connected_Warning
    //  5 --> Escl_Ecu_Fail_Warning
    //  6 --> Engine_Start_Operation_IND
    //  7 --> Auth_Fail_Warning
    //  8 --> Key_Removal_IND
    //  9 --> SMK_Lamp_Warning
    //  10 --> SSB_Warning
    //  11 --> Auth_Fail_Warning2
    //  12 --> Vehicle_Not_P_Warning
    //  13 --> Stop Lamp Fuse Fail Warning
    //  14 --> Not P_N Warning
    //  15 --> Vehicle_is_On(FingerPrint)
    return 0;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setWarn_DrvStBltSwSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0x3);                // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer) & (0x3)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Unbelted
    //  1 --> Belted
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setWarn_ImmoLmpOnReq(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[9] &= static_cast<uint8_t>(~0x60);                     // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer << 5) & (0x60)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setWarn_PassStOccSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0xc);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer << 2) & (0xc)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off (UnSeated)
    //  1 --> On (Seated)
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setWarn_RrCtrSBRMATSwSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[5] &= static_cast<uint8_t>(~0x3);                // clear the bits for new data
    canPacket_.data[5] |= static_cast<uint8_t>((bitBuffer) & (0x3)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off (UnSeated)
    //  1 --> On (Seated)
    //  3 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setWarn_RrCtrStBltSwSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0x3);                // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer) & (0x3)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Unbelted
    //  1 --> Belted
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setWarn_RrLftSBRMATSwSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0x30);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer << 4) & (0x30)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off (UnSeated)
    //  1 --> On (Seated)
    //  3 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setWarn_RrLftStBltSwSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0xc);                     // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer << 2) & (0xc)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Unbelted
    //  1 --> Belted
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setWarn_RrRhtSBRMATSwSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off (UnSeated)
    //  1 --> On (Seated)
    //  3 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setWarn_RrRtStBltSwSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0x30);                     // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer << 4) & (0x30)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Unbelted
    //  1 --> Belted
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setWarn_WshrFldSwSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[8] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return 0;
}

int64_t VIC_BodyCtrl_FB_01C_PE_200ms::setWiper_FrWiperSwSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[15] &= static_cast<uint8_t>(~0xe0);                     // clear the bits for new data
    canPacket_.data[15] |= static_cast<uint8_t>((bitBuffer << 5) & (0xe0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Wiper Sw Off
    //  1 --> Wiper Int or Auto Sw On(Refer to C_RainSnsOption)
    //  2 --> Wiper Low Sw On
    //  3 --> Wiper High Sw On
    //  4 --> Reserved
    //  5 --> Reserved
    //  6 --> Not Used
    //  7 --> Error Indicator
    return 0;
}
