/// @copyright Copyright (c) 2021- Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file: /home/scotty/Downloads/Gen2_AVT_B_Control_CAN1.dbc

#include "VehicleCANLibrary/g2h/av_proto/VIC_BodyCtrl_FB_02_P_200ms.hpp"
#include <algorithm>
#include <string.h>

using namespace av::can::g2h::avproto;

VIC_BodyCtrl_FB_02_P_200ms::VIC_BodyCtrl_FB_02_P_200ms(const uint32_t id)
{
    canPacket_.id = id;
    canPacket_.length = VIC_BodyCtrl_FB_02_P_200ms_CONSTS::VIC_BODYCTRL_FB_02_P_200MS_PACKET_LEN;
}

VIC_BodyCtrl_FB_02_P_200ms::VIC_BodyCtrl_FB_02_P_200ms(const uint32_t id, uint8_t* const payload, const uint8_t size)
{
    canPacket_.id = id;

    if ((size <= sizeof(canPacket_.data)) && payload) {
        canPacket_.length = size;
        std::copy_n(payload, size, canPacket_.data);
    }
}

const CanFdPacket& VIC_BodyCtrl_FB_02_P_200ms::getCanPacket() const
{
    return canPacket_;
}

double VIC_BodyCtrl_FB_02_P_200ms::getCDM_HS_OpnClsState() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x6);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Reserved
    //  1 --> Open
    //  2 --> Close
    //  3 --> Reserved
    return output;
}

double VIC_BodyCtrl_FB_02_P_200ms::getDATC_AV_AutoSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[14]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x78);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> OFF
    //  2 --> 1st & 2nd & 3rd On (3 Step Type)
    //  3 --> 1st & 2nd On (3 Step Type)
    //  4 --> 1st On (3 Step Type)
    //  5 --> Reserved
    //  6 --> Reserved
    //  7 --> Reserved
    //  8 --> Reserved
    //  9 --> Reserved
    //  10 --> Reserved
    //  11 --> Reserved
    //  12 --> Reserved
    //  13 --> Reserved
    //  14 --> Reserved
    //  15 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_02_P_200ms::getDATC_AV_BlowerSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[14]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[15]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x780);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> OFF
    //  1 --> Blank Display
    //  2 --> 1 Step
    //  3 --> 2 Step
    //  4 --> 3 Step
    //  5 --> 4 Step
    //  6 --> 5 Step
    //  7 --> 6 Step
    //  8 --> 7 Step
    //  9 --> 8 Step
    //  10 --> BLOWER AUTO
    //  11 --> Reserved
    //  12 --> Reserved
    //  13 --> Reserved
    //  14 --> Reserved
    //  15 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_02_P_200ms::getDATC_AV_DrvTempCSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x7f8);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.5)) + static_cast<double>(14); // (output * scale_factor) + bias

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Blank
    //  2 --> PHY=HEX*0.5 + 14
    //  3 --> PHY=HEX*0.5 + 14
    //  4 --> PHY=HEX*0.5 + 14
    //  5 --> PHY=HEX*0.5 + 14
    //  6 --> PHY=HEX*0.5 + 14
    //  7 --> PHY=HEX*0.5 + 14
    //  8 --> PHY=HEX*0.5 + 14
    //  9 --> PHY=HEX*0.5 + 14
    //  10 --> PHY=HEX*0.5 + 14
    //  11 --> PHY=HEX*0.5 + 14
    //  12 --> PHY=HEX*0.5 + 14
    //  13 --> PHY=HEX*0.5 + 14
    //  14 --> PHY=HEX*0.5 + 14
    //  15 --> PHY=HEX*0.5 + 14
    //  16 --> PHY=HEX*0.5 + 14
    //  17 --> PHY=HEX*0.5 + 14
    //  18 --> PHY=HEX*0.5 + 14
    //  19 --> PHY=HEX*0.5 + 14
    //  20 --> PHY=HEX*0.5 + 14
    //  21 --> PHY=HEX*0.5 + 14
    //  22 --> PHY=HEX*0.5 + 14
    //  23 --> PHY=HEX*0.5 + 14
    //  24 --> PHY=HEX*0.5 + 14
    //  25 --> PHY=HEX*0.5 + 14
    //  26 --> PHY=HEX*0.5 + 14
    //  27 --> PHY=HEX*0.5 + 14
    //  28 --> PHY=HEX*0.5 + 14
    //  29 --> PHY=HEX*0.5 + 14
    //  30 --> PHY=HEX*0.5 + 14
    //  31 --> PHY=HEX*0.5 + 14
    //  32 --> PHY=HEX*0.5 + 14
    //  33 --> PHY=HEX*0.5 + 14
    //  34 --> PHY=HEX*0.5 + 14
    //  35 --> PHY=HEX*0.5 + 14
    //  36 --> PHY=HEX*0.5 + 14
    //  37 --> 0x25~0xFD:Reserved
    //  253 --> 0x25~0xFD:Reserved
    //  255 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_02_P_200ms::getDATC_AV_DrvTempFSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[11]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x7f8);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = output + static_cast<double>(56); // output + bias

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Blank
    //  2 --> PHY=HEX*1 + 56
    //  3 --> PHY=HEX*1 + 56
    //  4 --> PHY=HEX*1 + 56
    //  5 --> PHY=HEX*1 + 56
    //  6 --> PHY=HEX*1 + 56
    //  7 --> PHY=HEX*1 + 56
    //  8 --> PHY=HEX*1 + 56
    //  9 --> PHY=HEX*1 + 56
    //  10 --> PHY=HEX*1 + 56
    //  11 --> PHY=HEX*1 + 56
    //  12 --> PHY=HEX*1 + 56
    //  13 --> PHY=HEX*1 + 56
    //  14 --> PHY=HEX*1 + 56
    //  15 --> PHY=HEX*1 + 56
    //  16 --> PHY=HEX*1 + 56
    //  17 --> PHY=HEX*1 + 56
    //  18 --> PHY=HEX*1 + 56
    //  19 --> PHY=HEX*1 + 56
    //  20 --> PHY=HEX*1 + 56
    //  21 --> PHY=HEX*1 + 56
    //  22 --> PHY=HEX*1 + 56
    //  23 --> PHY=HEX*1 + 56
    //  24 --> PHY=HEX*1 + 56
    //  25 --> PHY=HEX*1 + 56
    //  26 --> PHY=HEX*1 + 56
    //  27 --> PHY=HEX*1 + 56
    //  28 --> PHY=HEX*1 + 56
    //  29 --> PHY=HEX*1 + 56
    //  30 --> PHY=HEX*1 + 56
    //  31 --> PHY=HEX*1 + 56
    //  32 --> PHY=HEX*1 + 56
    //  33 --> PHY=HEX*1 + 56
    //  34 --> PHY=HEX*1 + 56
    //  35 --> PHY=HEX*1 + 56
    //  36 --> PHY=HEX*1 + 56
    //  37 --> 0x25~0xFD:Reserved
    //  253 --> 0x25~0xFD:Reserved
    //  255 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_02_P_200ms::getDATC_AV_EWPActRPM() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[11]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[12]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x7f8);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = output * static_cast<double>(20); // output * scale_factor

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x0~0xFE:EWP actual rpm
    //  254 --> 0x0x0~0xFE:EWP actual rpm
    //  255 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_02_P_200ms::getDATC_AV_FrDefSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[15]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[16]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x180);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> FRONT DEF switch is not selected
    //  1 --> FRONT DEF switch is selected
    //  2 --> Not Used
    //  3 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_02_P_200ms::getDATC_AV_IntakeSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[16]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x6);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> REC (Fresh off)
    //  2 --> FRE (REC off)
    //  3 --> Error indicator
    return output;
}

double VIC_BodyCtrl_FB_02_P_200ms::getDATC_AV_ModeSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[15]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x78);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Blank (AUTO)
    //  1 --> VENT
    //  2 --> B_L
    //  3 --> FLOOR
    //  4 --> MIX
    //  5 --> DEF
    //  6 --> AUTO DEFOG
    //  7 --> NOT USED
    //  8 --> NOT USED
    //  9 --> NOT USED
    //  10 --> NOT USED
    //  11 --> NOT USED
    //  12 --> NOT USED
    //  13 --> NOT USED
    //  14 --> NOT USED
    //  15 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_02_P_200ms::getDATC_AV_PassTempCSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[12]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[13]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x7f8);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.5)) + static_cast<double>(14); // (output * scale_factor) + bias

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Blank
    //  2 --> PHY=HEX*0.5 + 14
    //  3 --> PHY=HEX*0.5 + 14
    //  4 --> PHY=HEX*0.5 + 14
    //  5 --> PHY=HEX*0.5 + 14
    //  6 --> PHY=HEX*0.5 + 14
    //  7 --> PHY=HEX*0.5 + 14
    //  8 --> PHY=HEX*0.5 + 14
    //  9 --> PHY=HEX*0.5 + 14
    //  10 --> PHY=HEX*0.5 + 14
    //  11 --> PHY=HEX*0.5 + 14
    //  12 --> PHY=HEX*0.5 + 14
    //  13 --> PHY=HEX*0.5 + 14
    //  14 --> PHY=HEX*0.5 + 14
    //  15 --> PHY=HEX*0.5 + 14
    //  16 --> PHY=HEX*0.5 + 14
    //  17 --> PHY=HEX*0.5 + 14
    //  18 --> PHY=HEX*0.5 + 14
    //  19 --> PHY=HEX*0.5 + 14
    //  20 --> PHY=HEX*0.5 + 14
    //  21 --> PHY=HEX*0.5 + 14
    //  22 --> PHY=HEX*0.5 + 14
    //  23 --> PHY=HEX*0.5 + 14
    //  24 --> PHY=HEX*0.5 + 14
    //  25 --> PHY=HEX*0.5 + 14
    //  26 --> PHY=HEX*0.5 + 14
    //  27 --> PHY=HEX*0.5 + 14
    //  28 --> PHY=HEX*0.5 + 14
    //  29 --> PHY=HEX*0.5 + 14
    //  30 --> PHY=HEX*0.5 + 14
    //  31 --> PHY=HEX*0.5 + 14
    //  32 --> PHY=HEX*0.5 + 14
    //  33 --> PHY=HEX*0.5 + 14
    //  34 --> PHY=HEX*0.5 + 14
    //  35 --> PHY=HEX*0.5 + 14
    //  36 --> PHY=HEX*0.5 + 14
    //  37 --> 0x25~0xFD:Reserved
    //  253 --> 0x25~0xFD:Reserved
    //  255 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_02_P_200ms::getDATC_AV_PassTempFSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[13]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[14]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x7f8);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = output + static_cast<double>(56); // output + bias

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Blank
    //  2 --> PHY=HEX*1 + 56
    //  3 --> PHY=HEX*1 + 56
    //  4 --> PHY=HEX*1 + 56
    //  5 --> PHY=HEX*1 + 56
    //  6 --> PHY=HEX*1 + 56
    //  7 --> PHY=HEX*1 + 56
    //  8 --> PHY=HEX*1 + 56
    //  9 --> PHY=HEX*1 + 56
    //  10 --> PHY=HEX*1 + 56
    //  11 --> PHY=HEX*1 + 56
    //  12 --> PHY=HEX*1 + 56
    //  13 --> PHY=HEX*1 + 56
    //  14 --> PHY=HEX*1 + 56
    //  15 --> PHY=HEX*1 + 56
    //  16 --> PHY=HEX*1 + 56
    //  17 --> PHY=HEX*1 + 56
    //  18 --> PHY=HEX*1 + 56
    //  19 --> PHY=HEX*1 + 56
    //  20 --> PHY=HEX*1 + 56
    //  21 --> PHY=HEX*1 + 56
    //  22 --> PHY=HEX*1 + 56
    //  23 --> PHY=HEX*1 + 56
    //  24 --> PHY=HEX*1 + 56
    //  25 --> PHY=HEX*1 + 56
    //  26 --> PHY=HEX*1 + 56
    //  27 --> PHY=HEX*1 + 56
    //  28 --> PHY=HEX*1 + 56
    //  29 --> PHY=HEX*1 + 56
    //  30 --> PHY=HEX*1 + 56
    //  31 --> PHY=HEX*1 + 56
    //  32 --> PHY=HEX*1 + 56
    //  33 --> PHY=HEX*1 + 56
    //  34 --> PHY=HEX*1 + 56
    //  35 --> PHY=HEX*1 + 56
    //  36 --> PHY=HEX*1 + 56
    //  37 --> 0x25~0xFD:Reserved
    //  253 --> 0x25~0xFD:Reserved
    //  255 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_02_P_200ms::getDATC_AV_TempUnitSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[16]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x18);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Centigrade(ï¿½ï¿½)
    //  1 --> Fahrenheit(ï¿½ï¿½)
    //  2 --> Not used
    //  3 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_02_P_200ms::getTPMS_FLPosWrngLmpSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x3);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> FL POSITION Warning lamp OFF
    //  1 --> FL POSITION Warning lamp ON
    //  2 --> Not used
    //  3 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_02_P_200ms::getTPMS_FLTirePrsrVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  255 --> Error
    return output;
}

double VIC_BodyCtrl_FB_02_P_200ms::getTPMS_FRPosWrngLmpSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> FR POSITION Warning lamp OFF
    //  1 --> FR POSITION Warning lamp ON
    //  2 --> Not used
    //  3 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_02_P_200ms::getTPMS_FRTirePrsrVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  255 --> Error
    return output;
}

double VIC_BodyCtrl_FB_02_P_200ms::getTPMS_PrsrUnitSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x30);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> psi
    //  1 --> kpa
    //  2 --> bar
    //  3 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_02_P_200ms::getTPMS_RLPosWrngLmpSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc0);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> RL POSITION Warning lamp OFF
    //  1 --> RL POSITION Warning lamp ON
    //  2 --> Not used
    //  3 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_02_P_200ms::getTPMS_RLTirePrsrVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[5]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  255 --> Error
    return output;
}

double VIC_BodyCtrl_FB_02_P_200ms::getTPMS_RRPosWrngLmpSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x3);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> RR POSITION Warning lamp OFF
    //  1 --> RR POSITION Warning lamp ON
    //  2 --> Not used
    //  3 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_02_P_200ms::getTPMS_RRTirePrsrVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  255 --> Error
    return output;
}

double VIC_BodyCtrl_FB_02_P_200ms::getTPMS_SnsrSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1c0);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                                  // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> inactive
    //  1 --> active
    //  2 --> reserved
    //  3 --> reserved
    //  4 --> reserved
    //  5 --> reserved
    //  6 --> reserved
    //  7 --> reserved
    return output;
}

double VIC_BodyCtrl_FB_02_P_200ms::getTPMS_TreadWrngLmpSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> TREAD Warning lamp OFF
    //  1 --> TREAD Warning lamp ON
    //  2 --> TREAD Warning lamp BLINKING(2Hz)
    //  3 --> Tire Pressure Set (Indirect TPMS Only)
    return output;
}

double VIC_BodyCtrl_FB_02_P_200ms::getTPMS_WrngLmpSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x30);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> TPMS Malfunction Warning lamp OFF
    //  1 --> TPMS Malfunction Warning lamp ON
    //  2 --> TPMS Malfunction Warning lamp BLINKING(2Hz)
    //  3 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_02_P_200ms::getVIC_BodyCtrl_FB_02_AlvCnt1Val() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[2]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    return output;
}

double VIC_BodyCtrl_FB_02_P_200ms::getVIC_BodyCtrl_FB_02_Crc1Val() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[0]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[1]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffff);                               // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);        // Unsigned value

    return output;
}

int64_t VIC_BodyCtrl_FB_02_P_200ms::setCDM_HS_OpnClsState(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[9] &= static_cast<uint8_t>(~0x6);                     // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer << 1) & (0x6)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Reserved
    //  1 --> Open
    //  2 --> Close
    //  3 --> Reserved
    return 0;
}

int64_t VIC_BodyCtrl_FB_02_P_200ms::setDATC_AV_AutoSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[14] &= static_cast<uint8_t>(~0x78);                     // clear the bits for new data
    canPacket_.data[14] |= static_cast<uint8_t>((bitBuffer << 3) & (0x78)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> OFF
    //  2 --> 1st & 2nd & 3rd On (3 Step Type)
    //  3 --> 1st & 2nd On (3 Step Type)
    //  4 --> 1st On (3 Step Type)
    //  5 --> Reserved
    //  6 --> Reserved
    //  7 --> Reserved
    //  8 --> Reserved
    //  9 --> Reserved
    //  10 --> Reserved
    //  11 --> Reserved
    //  12 --> Reserved
    //  13 --> Reserved
    //  14 --> Reserved
    //  15 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_02_P_200ms::setDATC_AV_BlowerSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[14] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[14] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    canPacket_.data[15] &= static_cast<uint8_t>(~0x7);                      // clear the bits for new data
    canPacket_.data[15] |= static_cast<uint8_t>((bitBuffer >> 1) & (0x7));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> OFF
    //  1 --> Blank Display
    //  2 --> 1 Step
    //  3 --> 2 Step
    //  4 --> 3 Step
    //  5 --> 4 Step
    //  6 --> 5 Step
    //  7 --> 6 Step
    //  8 --> 7 Step
    //  9 --> 8 Step
    //  10 --> BLOWER AUTO
    //  11 --> Reserved
    //  12 --> Reserved
    //  13 --> Reserved
    //  14 --> Reserved
    //  15 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_02_P_200ms::setDATC_AV_DrvTempCSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(14)) /
                                                  static_cast<double>(0.5)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[9] &= static_cast<uint8_t>(~0xf8);                     // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer << 3) & (0xf8)); // push in new data
    canPacket_.data[10] &= static_cast<uint8_t>(~0x7);                     // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer >> 5) & (0x7)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Blank
    //  2 --> PHY=HEX*0.5 + 14
    //  3 --> PHY=HEX*0.5 + 14
    //  4 --> PHY=HEX*0.5 + 14
    //  5 --> PHY=HEX*0.5 + 14
    //  6 --> PHY=HEX*0.5 + 14
    //  7 --> PHY=HEX*0.5 + 14
    //  8 --> PHY=HEX*0.5 + 14
    //  9 --> PHY=HEX*0.5 + 14
    //  10 --> PHY=HEX*0.5 + 14
    //  11 --> PHY=HEX*0.5 + 14
    //  12 --> PHY=HEX*0.5 + 14
    //  13 --> PHY=HEX*0.5 + 14
    //  14 --> PHY=HEX*0.5 + 14
    //  15 --> PHY=HEX*0.5 + 14
    //  16 --> PHY=HEX*0.5 + 14
    //  17 --> PHY=HEX*0.5 + 14
    //  18 --> PHY=HEX*0.5 + 14
    //  19 --> PHY=HEX*0.5 + 14
    //  20 --> PHY=HEX*0.5 + 14
    //  21 --> PHY=HEX*0.5 + 14
    //  22 --> PHY=HEX*0.5 + 14
    //  23 --> PHY=HEX*0.5 + 14
    //  24 --> PHY=HEX*0.5 + 14
    //  25 --> PHY=HEX*0.5 + 14
    //  26 --> PHY=HEX*0.5 + 14
    //  27 --> PHY=HEX*0.5 + 14
    //  28 --> PHY=HEX*0.5 + 14
    //  29 --> PHY=HEX*0.5 + 14
    //  30 --> PHY=HEX*0.5 + 14
    //  31 --> PHY=HEX*0.5 + 14
    //  32 --> PHY=HEX*0.5 + 14
    //  33 --> PHY=HEX*0.5 + 14
    //  34 --> PHY=HEX*0.5 + 14
    //  35 --> PHY=HEX*0.5 + 14
    //  36 --> PHY=HEX*0.5 + 14
    //  37 --> 0x25~0xFD:Reserved
    //  253 --> 0x25~0xFD:Reserved
    //  255 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_02_P_200ms::setDATC_AV_DrvTempFSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value) - static_cast<int64_t>(56); // value - bias

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[10] &= static_cast<uint8_t>(~0xf8);                     // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer << 3) & (0xf8)); // push in new data
    canPacket_.data[11] &= static_cast<uint8_t>(~0x7);                      // clear the bits for new data
    canPacket_.data[11] |= static_cast<uint8_t>((bitBuffer >> 5) & (0x7));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Blank
    //  2 --> PHY=HEX*1 + 56
    //  3 --> PHY=HEX*1 + 56
    //  4 --> PHY=HEX*1 + 56
    //  5 --> PHY=HEX*1 + 56
    //  6 --> PHY=HEX*1 + 56
    //  7 --> PHY=HEX*1 + 56
    //  8 --> PHY=HEX*1 + 56
    //  9 --> PHY=HEX*1 + 56
    //  10 --> PHY=HEX*1 + 56
    //  11 --> PHY=HEX*1 + 56
    //  12 --> PHY=HEX*1 + 56
    //  13 --> PHY=HEX*1 + 56
    //  14 --> PHY=HEX*1 + 56
    //  15 --> PHY=HEX*1 + 56
    //  16 --> PHY=HEX*1 + 56
    //  17 --> PHY=HEX*1 + 56
    //  18 --> PHY=HEX*1 + 56
    //  19 --> PHY=HEX*1 + 56
    //  20 --> PHY=HEX*1 + 56
    //  21 --> PHY=HEX*1 + 56
    //  22 --> PHY=HEX*1 + 56
    //  23 --> PHY=HEX*1 + 56
    //  24 --> PHY=HEX*1 + 56
    //  25 --> PHY=HEX*1 + 56
    //  26 --> PHY=HEX*1 + 56
    //  27 --> PHY=HEX*1 + 56
    //  28 --> PHY=HEX*1 + 56
    //  29 --> PHY=HEX*1 + 56
    //  30 --> PHY=HEX*1 + 56
    //  31 --> PHY=HEX*1 + 56
    //  32 --> PHY=HEX*1 + 56
    //  33 --> PHY=HEX*1 + 56
    //  34 --> PHY=HEX*1 + 56
    //  35 --> PHY=HEX*1 + 56
    //  36 --> PHY=HEX*1 + 56
    //  37 --> 0x25~0xFD:Reserved
    //  253 --> 0x25~0xFD:Reserved
    //  255 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_02_P_200ms::setDATC_AV_EWPActRPM(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value / static_cast<double>(20)); // value / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[11] &= static_cast<uint8_t>(~0xf8);                     // clear the bits for new data
    canPacket_.data[11] |= static_cast<uint8_t>((bitBuffer << 3) & (0xf8)); // push in new data
    canPacket_.data[12] &= static_cast<uint8_t>(~0x7);                      // clear the bits for new data
    canPacket_.data[12] |= static_cast<uint8_t>((bitBuffer >> 5) & (0x7));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0x0x0~0xFE:EWP actual rpm
    //  254 --> 0x0x0~0xFE:EWP actual rpm
    //  255 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_02_P_200ms::setDATC_AV_FrDefSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[15] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[15] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    canPacket_.data[16] &= static_cast<uint8_t>(~0x1);                      // clear the bits for new data
    canPacket_.data[16] |= static_cast<uint8_t>((bitBuffer >> 1) & (0x1));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> FRONT DEF switch is not selected
    //  1 --> FRONT DEF switch is selected
    //  2 --> Not Used
    //  3 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_02_P_200ms::setDATC_AV_IntakeSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[16] &= static_cast<uint8_t>(~0x6);                     // clear the bits for new data
    canPacket_.data[16] |= static_cast<uint8_t>((bitBuffer << 1) & (0x6)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Default
    //  1 --> REC (Fresh off)
    //  2 --> FRE (REC off)
    //  3 --> Error indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_02_P_200ms::setDATC_AV_ModeSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[15] &= static_cast<uint8_t>(~0x78);                     // clear the bits for new data
    canPacket_.data[15] |= static_cast<uint8_t>((bitBuffer << 3) & (0x78)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Blank (AUTO)
    //  1 --> VENT
    //  2 --> B_L
    //  3 --> FLOOR
    //  4 --> MIX
    //  5 --> DEF
    //  6 --> AUTO DEFOG
    //  7 --> NOT USED
    //  8 --> NOT USED
    //  9 --> NOT USED
    //  10 --> NOT USED
    //  11 --> NOT USED
    //  12 --> NOT USED
    //  13 --> NOT USED
    //  14 --> NOT USED
    //  15 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_02_P_200ms::setDATC_AV_PassTempCSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(14)) /
                                                  static_cast<double>(0.5)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[12] &= static_cast<uint8_t>(~0xf8);                     // clear the bits for new data
    canPacket_.data[12] |= static_cast<uint8_t>((bitBuffer << 3) & (0xf8)); // push in new data
    canPacket_.data[13] &= static_cast<uint8_t>(~0x7);                      // clear the bits for new data
    canPacket_.data[13] |= static_cast<uint8_t>((bitBuffer >> 5) & (0x7));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Blank
    //  2 --> PHY=HEX*0.5 + 14
    //  3 --> PHY=HEX*0.5 + 14
    //  4 --> PHY=HEX*0.5 + 14
    //  5 --> PHY=HEX*0.5 + 14
    //  6 --> PHY=HEX*0.5 + 14
    //  7 --> PHY=HEX*0.5 + 14
    //  8 --> PHY=HEX*0.5 + 14
    //  9 --> PHY=HEX*0.5 + 14
    //  10 --> PHY=HEX*0.5 + 14
    //  11 --> PHY=HEX*0.5 + 14
    //  12 --> PHY=HEX*0.5 + 14
    //  13 --> PHY=HEX*0.5 + 14
    //  14 --> PHY=HEX*0.5 + 14
    //  15 --> PHY=HEX*0.5 + 14
    //  16 --> PHY=HEX*0.5 + 14
    //  17 --> PHY=HEX*0.5 + 14
    //  18 --> PHY=HEX*0.5 + 14
    //  19 --> PHY=HEX*0.5 + 14
    //  20 --> PHY=HEX*0.5 + 14
    //  21 --> PHY=HEX*0.5 + 14
    //  22 --> PHY=HEX*0.5 + 14
    //  23 --> PHY=HEX*0.5 + 14
    //  24 --> PHY=HEX*0.5 + 14
    //  25 --> PHY=HEX*0.5 + 14
    //  26 --> PHY=HEX*0.5 + 14
    //  27 --> PHY=HEX*0.5 + 14
    //  28 --> PHY=HEX*0.5 + 14
    //  29 --> PHY=HEX*0.5 + 14
    //  30 --> PHY=HEX*0.5 + 14
    //  31 --> PHY=HEX*0.5 + 14
    //  32 --> PHY=HEX*0.5 + 14
    //  33 --> PHY=HEX*0.5 + 14
    //  34 --> PHY=HEX*0.5 + 14
    //  35 --> PHY=HEX*0.5 + 14
    //  36 --> PHY=HEX*0.5 + 14
    //  37 --> 0x25~0xFD:Reserved
    //  253 --> 0x25~0xFD:Reserved
    //  255 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_02_P_200ms::setDATC_AV_PassTempFSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value) - static_cast<int64_t>(56); // value - bias

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[13] &= static_cast<uint8_t>(~0xf8);                     // clear the bits for new data
    canPacket_.data[13] |= static_cast<uint8_t>((bitBuffer << 3) & (0xf8)); // push in new data
    canPacket_.data[14] &= static_cast<uint8_t>(~0x7);                      // clear the bits for new data
    canPacket_.data[14] |= static_cast<uint8_t>((bitBuffer >> 5) & (0x7));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Blank
    //  2 --> PHY=HEX*1 + 56
    //  3 --> PHY=HEX*1 + 56
    //  4 --> PHY=HEX*1 + 56
    //  5 --> PHY=HEX*1 + 56
    //  6 --> PHY=HEX*1 + 56
    //  7 --> PHY=HEX*1 + 56
    //  8 --> PHY=HEX*1 + 56
    //  9 --> PHY=HEX*1 + 56
    //  10 --> PHY=HEX*1 + 56
    //  11 --> PHY=HEX*1 + 56
    //  12 --> PHY=HEX*1 + 56
    //  13 --> PHY=HEX*1 + 56
    //  14 --> PHY=HEX*1 + 56
    //  15 --> PHY=HEX*1 + 56
    //  16 --> PHY=HEX*1 + 56
    //  17 --> PHY=HEX*1 + 56
    //  18 --> PHY=HEX*1 + 56
    //  19 --> PHY=HEX*1 + 56
    //  20 --> PHY=HEX*1 + 56
    //  21 --> PHY=HEX*1 + 56
    //  22 --> PHY=HEX*1 + 56
    //  23 --> PHY=HEX*1 + 56
    //  24 --> PHY=HEX*1 + 56
    //  25 --> PHY=HEX*1 + 56
    //  26 --> PHY=HEX*1 + 56
    //  27 --> PHY=HEX*1 + 56
    //  28 --> PHY=HEX*1 + 56
    //  29 --> PHY=HEX*1 + 56
    //  30 --> PHY=HEX*1 + 56
    //  31 --> PHY=HEX*1 + 56
    //  32 --> PHY=HEX*1 + 56
    //  33 --> PHY=HEX*1 + 56
    //  34 --> PHY=HEX*1 + 56
    //  35 --> PHY=HEX*1 + 56
    //  36 --> PHY=HEX*1 + 56
    //  37 --> 0x25~0xFD:Reserved
    //  253 --> 0x25~0xFD:Reserved
    //  255 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_02_P_200ms::setDATC_AV_TempUnitSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[16] &= static_cast<uint8_t>(~0x18);                     // clear the bits for new data
    canPacket_.data[16] |= static_cast<uint8_t>((bitBuffer << 3) & (0x18)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Centigrade(ï¿½ï¿½)
    //  1 --> Fahrenheit(ï¿½ï¿½)
    //  2 --> Not used
    //  3 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_02_P_200ms::setTPMS_FLPosWrngLmpSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[7] &= static_cast<uint8_t>(~0x3);                // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer) & (0x3)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> FL POSITION Warning lamp OFF
    //  1 --> FL POSITION Warning lamp ON
    //  2 --> Not used
    //  3 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_02_P_200ms::setTPMS_FLTirePrsrVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  255 --> Error
    return 0;
}

int64_t VIC_BodyCtrl_FB_02_P_200ms::setTPMS_FRPosWrngLmpSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[7] &= static_cast<uint8_t>(~0xc);                     // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer << 2) & (0xc)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> FR POSITION Warning lamp OFF
    //  1 --> FR POSITION Warning lamp ON
    //  2 --> Not used
    //  3 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_02_P_200ms::setTPMS_FRTirePrsrVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  255 --> Error
    return 0;
}

int64_t VIC_BodyCtrl_FB_02_P_200ms::setTPMS_PrsrUnitSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[7] &= static_cast<uint8_t>(~0x30);                     // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer << 4) & (0x30)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> psi
    //  1 --> kpa
    //  2 --> bar
    //  3 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_02_P_200ms::setTPMS_RLPosWrngLmpSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[7] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> RL POSITION Warning lamp OFF
    //  1 --> RL POSITION Warning lamp ON
    //  2 --> Not used
    //  3 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_02_P_200ms::setTPMS_RLTirePrsrVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[5] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[5] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  255 --> Error
    return 0;
}

int64_t VIC_BodyCtrl_FB_02_P_200ms::setTPMS_RRPosWrngLmpSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[8] &= static_cast<uint8_t>(~0x3);                // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer) & (0x3)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> RR POSITION Warning lamp OFF
    //  1 --> RR POSITION Warning lamp ON
    //  2 --> Not used
    //  3 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_02_P_200ms::setTPMS_RRTirePrsrVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[6] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  255 --> Error
    return 0;
}

int64_t VIC_BodyCtrl_FB_02_P_200ms::setTPMS_SnsrSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[8] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    canPacket_.data[9] &= static_cast<uint8_t>(~0x1);                      // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer >> 2) & (0x1));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> inactive
    //  1 --> active
    //  2 --> reserved
    //  3 --> reserved
    //  4 --> reserved
    //  5 --> reserved
    //  6 --> reserved
    //  7 --> reserved
    return 0;
}

int64_t VIC_BodyCtrl_FB_02_P_200ms::setTPMS_TreadWrngLmpSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[8] &= static_cast<uint8_t>(~0xc);                     // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer << 2) & (0xc)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> TREAD Warning lamp OFF
    //  1 --> TREAD Warning lamp ON
    //  2 --> TREAD Warning lamp BLINKING(2Hz)
    //  3 --> Tire Pressure Set (Indirect TPMS Only)
    return 0;
}

int64_t VIC_BodyCtrl_FB_02_P_200ms::setTPMS_WrngLmpSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[8] &= static_cast<uint8_t>(~0x30);                     // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer << 4) & (0x30)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> TPMS Malfunction Warning lamp OFF
    //  1 --> TPMS Malfunction Warning lamp ON
    //  2 --> TPMS Malfunction Warning lamp BLINKING(2Hz)
    //  3 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_02_P_200ms::setVIC_BodyCtrl_FB_02_AlvCnt1Val(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[2] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[2] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_BodyCtrl_FB_02_P_200ms::setVIC_BodyCtrl_FB_02_Crc1Val(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[0] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[0] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[1] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[1] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff)); // push in new data
    return 0;
}
