/// @copyright Copyright (c) 2021- Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file: /home/scotty/Downloads/Gen2_AVT_B_Control_CAN1.dbc

#include "VehicleCANLibrary/g2h/av_proto/VIC_BodyCtrl_FB_03_P_100ms.hpp"
#include <algorithm>
#include <string.h>

using namespace av::can::g2h::avproto;

VIC_BodyCtrl_FB_03_P_100ms::VIC_BodyCtrl_FB_03_P_100ms(const uint32_t id)
{
    canPacket_.id = id;
    canPacket_.length = VIC_BodyCtrl_FB_03_P_100ms_CONSTS::VIC_BODYCTRL_FB_03_P_100MS_PACKET_LEN;
}

VIC_BodyCtrl_FB_03_P_100ms::VIC_BodyCtrl_FB_03_P_100ms(const uint32_t id, uint8_t* const payload, const uint8_t size)
{
    canPacket_.id = id;

    if ((size <= sizeof(canPacket_.data)) && payload) {
        canPacket_.length = size;
        std::copy_n(payload, size, canPacket_.data);
    }
}

const CanFdPacket& VIC_BodyCtrl_FB_03_P_100ms::getCanPacket() const
{
    return canPacket_;
}

double VIC_BodyCtrl_FB_03_P_100ms::getACU_ActvFltSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x7);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Fault status is active
    //  1 --> Fault status is historic
    //  2 --> Fault does not exist
    //  3 --> Reserved
    //  4 --> Reserved
    //  5 --> Reserved
    //  6 --> Not used
    //  7 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getACU_EmerModSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x1);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> ACU is NOT Emergency mode
    //  1 --> ACU is Emergency mode
    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getACU_EvtTrigSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x80);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> EDR Not triggered.
    //  1 --> EDR triggered.
    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getACU_NumOfEmerModVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[5]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getACU_NumOfEvtTrigVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffff);                               // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);        // Unsigned value

    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getACU_PassArbg_SW_Sta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x18);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> NOT_APPLIED
    //  1 --> PAB_OFF
    //  2 --> PAB_ON
    //  3 --> Invalid
    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getACU_SysWrngLmpDis() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x7);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Warning Lamp off
    //  1 --> Warning Lamp on
    //  2 --> Warning Lamp flash
    //  3 --> Reserved
    //  4 --> Reserved
    //  5 --> Reserved
    //  6 --> Not used
    //  7 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getACU_TlltlLmpDis() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x38);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Telltale Lamp off
    //  1 --> Telltale Lamp on
    //  2 --> Telltale Lamp flash
    //  3 --> Reserved
    //  4 --> Reserved
    //  5 --> Reserved
    //  6 --> Not used
    //  7 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getALDC_AuxBattWrnAlrmReq() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[19]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x6);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Aux Bat warning alarm off
    //  1 --> Aux Bat warning alarm request
    //  2 --> Not used
    //  3 --> Error indicator
    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getALDC_AuxBattWrnLmpReq() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[18]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[19]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x180);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Aux Bat warning lamp off
    //  1 --> Aux Bat warning lamp request
    //  2 --> Not used
    //  3 --> Error indicator
    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getALDC_PwrDeratingSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[18]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x6);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Power Derating Off
    //  1 --> LDC Power Derating On
    //  2 --> Not used
    //  3 --> Error indicator
    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getALDC_SrvLmpReq() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[18]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x18);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal status
    //  1 --> Service lamp request
    //  2 --> Not used
    //  3 --> Error indicator
    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getALDC_SysCtrlablSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[17]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x60);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Not Controllable
    //  1 --> Controllable
    //  2 --> Not used
    //  3 --> Error indicator
    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getALDC_SysFltSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[18]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x60);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal status
    //  1 --> Fault status
    //  2 --> Not used
    //  3 --> Error indicator
    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getALDC_SysOpSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[17]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[18]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x180);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> PWM off
    //  1 --> PWM on
    //  2 --> Not used
    //  3 --> Error indicator
    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getCLU_OdoVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[12]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[13]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[14]) << 16; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[15]) << 24; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1fffffe);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                                    // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = output * static_cast<double>(0.1); // output * scale_factor

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  16777215 --> Error
    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getEV_HiTempSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[15]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x60);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> High Temp Status
    //  2 --> Not used
    //  3 --> Error indicator
    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getEV_LoTempSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[15]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x18);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Noraml
    //  1 --> Low temperature
    //  2 --> Not used
    //  3 --> Error indicator
    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getLDC_AuxBattWrnAlrmReq() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[17]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x18);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Aux Bat warning alarm off
    //  1 --> Aux Bat warning alarm request
    //  2 --> Not used
    //  3 --> Error indicator
    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getLDC_AuxBattWrnLmpReq() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[17]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x6);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Aux Bat warning lamp off
    //  1 --> Aux Bat warning lamp request
    //  2 --> Not used
    //  3 --> Error indicator
    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getLDC_PwrDeratingSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[16]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x18);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Power Derating Off
    //  1 --> LDC Power Derating On
    //  2 --> Not used
    //  3 --> Error indicator
    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getLDC_SrvLmpReq() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[16]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x60);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal status
    //  1 --> Service lamp request
    //  2 --> Not used
    //  3 --> Error indicator
    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getLDC_SysCtrlablSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[15]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[16]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x180);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Not Controllable
    //  1 --> Controllable
    //  2 --> Not used
    //  3 --> Error indicator
    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getLDC_SysFltSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[16]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[17]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x180);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal status
    //  1 --> Fault status
    //  2 --> Not used
    //  3 --> Error indicator
    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getLDC_SysOpSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[16]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x6);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> PWM off
    //  1 --> PWM on
    //  2 --> Not used
    //  3 --> Error indicator
    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getSeatBelt_DrvrBcklFltSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[19]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x18);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No Fault
    //  1 --> Fault condition exists
    //  2 --> Not used
    //  3 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getSeatBelt_DrvrBcklSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc0);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Driver Seat Belt Not Latched
    //  1 --> Driver Seat Belt Latched
    //  2 --> Not used
    //  3 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getSeatBelt_PassBcklFltSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[19]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x60);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No Fault
    //  1 --> Fault condition exists
    //  2 --> Not used
    //  3 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getSeatBelt_PassBcklSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x60);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Passenger Seat Belt Not Latched
    //  1 --> Passenger Seat Belt Latched
    //  2 --> Not used
    //  3 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getVCMS_ChgAlarm_Stat() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x1e);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Not Charge
    //  1 --> High Voltage Applied
    //  2 --> Charger Connected (AC)
    //  3 --> Charger Connected (DC)
    //  4 --> Reserved
    //  5 --> Reserved
    //  6 --> Wating for Schedule Charging
    //  7 --> Charging Start (Schedule)
    //  8 --> Charging Start (Normal)
    //  9 --> Reserved
    //  10 --> Reserved
    //  11 --> Reserved
    //  12 --> Charging Finished
    //  13 --> Charging Failed (AC)
    //  14 --> Charging Failed (DC)
    //  15 --> Reserved
    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getVCMS_ChgAlarm_Subcode() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1e0);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                                  // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Not Charge
    //  1 --> Charger Not Connected
    //  2 --> Charger Failure
    //  3 --> Controller Failure
    //  4 --> Not Gear 'P'
    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getVCMS_SERVICE_LAMP_Req() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x6);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not used
    //  3 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getVCU_DteBaseVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x3ff8);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getVCU_EvDrvRdyCluDispSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc0);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Ready Lamp Off
    //  1 --> Ready Lamp On
    //  2 --> Error Indicator
    //  3 --> Blinking
    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getVCU_LowSocAlertSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[11]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x7);                              // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);    // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No Alert
    //  1 --> Low SOC Alert 1
    //  2 --> Low SOC Alert 2
    //  3 --> Low SOC Alert 3
    //  4 --> Reserved
    //  5 --> Reserved
    //  6 --> Reserved
    //  7 --> SOC Unavailable Alert
    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getVCU_LowSocDispPcVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[11]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x78);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getVCU_ServiceLampReq() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[11]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[12]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x180);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> None
    //  1 --> Service Lamp On
    //  2 --> Not used
    //  3 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getVIC_BodyCtrl_FB_03_AlvCnt1Val() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[2]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getVIC_BodyCtrl_FB_03_Crc1Val() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[0]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[1]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffff);                               // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);        // Unsigned value

    return output;
}

double VIC_BodyCtrl_FB_03_P_100ms::getxEV_SrvLmpReq() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[15]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x6);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> Service Lamp On
    //  2 --> Not used
    //  3 --> Error indicator
    return output;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setACU_ActvFltSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[7] &= static_cast<uint8_t>(~0x7);                // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer) & (0x7)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Fault status is active
    //  1 --> Fault status is historic
    //  2 --> Fault does not exist
    //  3 --> Reserved
    //  4 --> Reserved
    //  5 --> Reserved
    //  6 --> Not used
    //  7 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setACU_EmerModSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[8] &= static_cast<uint8_t>(~0x1);                // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer) & (0x1)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> ACU is NOT Emergency mode
    //  1 --> ACU is Emergency mode
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setACU_EvtTrigSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[7] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> EDR Not triggered.
    //  1 --> EDR triggered.
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setACU_NumOfEmerModVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[5] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[5] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setACU_NumOfEvtTrigVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[4] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setACU_PassArbg_SW_Sta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[7] &= static_cast<uint8_t>(~0x18);                     // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer << 3) & (0x18)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> NOT_APPLIED
    //  1 --> PAB_OFF
    //  2 --> PAB_ON
    //  3 --> Invalid
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setACU_SysWrngLmpDis(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[6] &= static_cast<uint8_t>(~0x7);                // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer) & (0x7)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Warning Lamp off
    //  1 --> Warning Lamp on
    //  2 --> Warning Lamp flash
    //  3 --> Reserved
    //  4 --> Reserved
    //  5 --> Reserved
    //  6 --> Not used
    //  7 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setACU_TlltlLmpDis(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[6] &= static_cast<uint8_t>(~0x38);                     // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer << 3) & (0x38)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Telltale Lamp off
    //  1 --> Telltale Lamp on
    //  2 --> Telltale Lamp flash
    //  3 --> Reserved
    //  4 --> Reserved
    //  5 --> Reserved
    //  6 --> Not used
    //  7 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setALDC_AuxBattWrnAlrmReq(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[19] &= static_cast<uint8_t>(~0x6);                     // clear the bits for new data
    canPacket_.data[19] |= static_cast<uint8_t>((bitBuffer << 1) & (0x6)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Aux Bat warning alarm off
    //  1 --> Aux Bat warning alarm request
    //  2 --> Not used
    //  3 --> Error indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setALDC_AuxBattWrnLmpReq(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[18] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[18] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    canPacket_.data[19] &= static_cast<uint8_t>(~0x1);                      // clear the bits for new data
    canPacket_.data[19] |= static_cast<uint8_t>((bitBuffer >> 1) & (0x1));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Aux Bat warning lamp off
    //  1 --> Aux Bat warning lamp request
    //  2 --> Not used
    //  3 --> Error indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setALDC_PwrDeratingSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[18] &= static_cast<uint8_t>(~0x6);                     // clear the bits for new data
    canPacket_.data[18] |= static_cast<uint8_t>((bitBuffer << 1) & (0x6)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Power Derating Off
    //  1 --> LDC Power Derating On
    //  2 --> Not used
    //  3 --> Error indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setALDC_SrvLmpReq(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[18] &= static_cast<uint8_t>(~0x18);                     // clear the bits for new data
    canPacket_.data[18] |= static_cast<uint8_t>((bitBuffer << 3) & (0x18)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal status
    //  1 --> Service lamp request
    //  2 --> Not used
    //  3 --> Error indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setALDC_SysCtrlablSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[17] &= static_cast<uint8_t>(~0x60);                     // clear the bits for new data
    canPacket_.data[17] |= static_cast<uint8_t>((bitBuffer << 5) & (0x60)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Not Controllable
    //  1 --> Controllable
    //  2 --> Not used
    //  3 --> Error indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setALDC_SysFltSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[18] &= static_cast<uint8_t>(~0x60);                     // clear the bits for new data
    canPacket_.data[18] |= static_cast<uint8_t>((bitBuffer << 5) & (0x60)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal status
    //  1 --> Fault status
    //  2 --> Not used
    //  3 --> Error indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setALDC_SysOpSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[17] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[17] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    canPacket_.data[18] &= static_cast<uint8_t>(~0x1);                      // clear the bits for new data
    canPacket_.data[18] |= static_cast<uint8_t>((bitBuffer >> 1) & (0x1));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> PWM off
    //  1 --> PWM on
    //  2 --> Not used
    //  3 --> Error indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setCLU_OdoVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value / static_cast<double>(0.1)); // value / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[12] &= static_cast<uint8_t>(~0xfe);                      // clear the bits for new data
    canPacket_.data[12] |= static_cast<uint8_t>((bitBuffer << 1) & (0xfe));  // push in new data
    canPacket_.data[13] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[13] |= static_cast<uint8_t>((bitBuffer >> 7) & (0xff));  // push in new data
    canPacket_.data[14] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[14] |= static_cast<uint8_t>((bitBuffer >> 15) & (0xff)); // push in new data
    canPacket_.data[15] &= static_cast<uint8_t>(~0x1);                       // clear the bits for new data
    canPacket_.data[15] |= static_cast<uint8_t>((bitBuffer >> 23) & (0x1));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  16777215 --> Error
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setEV_HiTempSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[15] &= static_cast<uint8_t>(~0x60);                     // clear the bits for new data
    canPacket_.data[15] |= static_cast<uint8_t>((bitBuffer << 5) & (0x60)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> High Temp Status
    //  2 --> Not used
    //  3 --> Error indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setEV_LoTempSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[15] &= static_cast<uint8_t>(~0x18);                     // clear the bits for new data
    canPacket_.data[15] |= static_cast<uint8_t>((bitBuffer << 3) & (0x18)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Noraml
    //  1 --> Low temperature
    //  2 --> Not used
    //  3 --> Error indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setLDC_AuxBattWrnAlrmReq(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[17] &= static_cast<uint8_t>(~0x18);                     // clear the bits for new data
    canPacket_.data[17] |= static_cast<uint8_t>((bitBuffer << 3) & (0x18)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Aux Bat warning alarm off
    //  1 --> Aux Bat warning alarm request
    //  2 --> Not used
    //  3 --> Error indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setLDC_AuxBattWrnLmpReq(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[17] &= static_cast<uint8_t>(~0x6);                     // clear the bits for new data
    canPacket_.data[17] |= static_cast<uint8_t>((bitBuffer << 1) & (0x6)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Aux Bat warning lamp off
    //  1 --> Aux Bat warning lamp request
    //  2 --> Not used
    //  3 --> Error indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setLDC_PwrDeratingSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[16] &= static_cast<uint8_t>(~0x18);                     // clear the bits for new data
    canPacket_.data[16] |= static_cast<uint8_t>((bitBuffer << 3) & (0x18)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Power Derating Off
    //  1 --> LDC Power Derating On
    //  2 --> Not used
    //  3 --> Error indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setLDC_SrvLmpReq(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[16] &= static_cast<uint8_t>(~0x60);                     // clear the bits for new data
    canPacket_.data[16] |= static_cast<uint8_t>((bitBuffer << 5) & (0x60)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal status
    //  1 --> Service lamp request
    //  2 --> Not used
    //  3 --> Error indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setLDC_SysCtrlablSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[15] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[15] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    canPacket_.data[16] &= static_cast<uint8_t>(~0x1);                      // clear the bits for new data
    canPacket_.data[16] |= static_cast<uint8_t>((bitBuffer >> 1) & (0x1));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Not Controllable
    //  1 --> Controllable
    //  2 --> Not used
    //  3 --> Error indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setLDC_SysFltSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[16] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[16] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    canPacket_.data[17] &= static_cast<uint8_t>(~0x1);                      // clear the bits for new data
    canPacket_.data[17] |= static_cast<uint8_t>((bitBuffer >> 1) & (0x1));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal status
    //  1 --> Fault status
    //  2 --> Not used
    //  3 --> Error indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setLDC_SysOpSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[16] &= static_cast<uint8_t>(~0x6);                     // clear the bits for new data
    canPacket_.data[16] |= static_cast<uint8_t>((bitBuffer << 1) & (0x6)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> PWM off
    //  1 --> PWM on
    //  2 --> Not used
    //  3 --> Error indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setSeatBelt_DrvrBcklFltSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[19] &= static_cast<uint8_t>(~0x18);                     // clear the bits for new data
    canPacket_.data[19] |= static_cast<uint8_t>((bitBuffer << 3) & (0x18)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No Fault
    //  1 --> Fault condition exists
    //  2 --> Not used
    //  3 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setSeatBelt_DrvrBcklSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[6] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Driver Seat Belt Not Latched
    //  1 --> Driver Seat Belt Latched
    //  2 --> Not used
    //  3 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setSeatBelt_PassBcklFltSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[19] &= static_cast<uint8_t>(~0x60);                     // clear the bits for new data
    canPacket_.data[19] |= static_cast<uint8_t>((bitBuffer << 5) & (0x60)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No Fault
    //  1 --> Fault condition exists
    //  2 --> Not used
    //  3 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setSeatBelt_PassBcklSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[7] &= static_cast<uint8_t>(~0x60);                     // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer << 5) & (0x60)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Passenger Seat Belt Not Latched
    //  1 --> Passenger Seat Belt Latched
    //  2 --> Not used
    //  3 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setVCMS_ChgAlarm_Stat(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[8] &= static_cast<uint8_t>(~0x1e);                     // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer << 1) & (0x1e)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Not Charge
    //  1 --> High Voltage Applied
    //  2 --> Charger Connected (AC)
    //  3 --> Charger Connected (DC)
    //  4 --> Reserved
    //  5 --> Reserved
    //  6 --> Wating for Schedule Charging
    //  7 --> Charging Start (Schedule)
    //  8 --> Charging Start (Normal)
    //  9 --> Reserved
    //  10 --> Reserved
    //  11 --> Reserved
    //  12 --> Charging Finished
    //  13 --> Charging Failed (AC)
    //  14 --> Charging Failed (DC)
    //  15 --> Reserved
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setVCMS_ChgAlarm_Subcode(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[8] &= static_cast<uint8_t>(~0xe0);                     // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer << 5) & (0xe0)); // push in new data
    canPacket_.data[9] &= static_cast<uint8_t>(~0x1);                      // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer >> 3) & (0x1));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Not Charge
    //  1 --> Charger Not Connected
    //  2 --> Charger Failure
    //  3 --> Controller Failure
    //  4 --> Not Gear 'P'
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setVCMS_SERVICE_LAMP_Req(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[9] &= static_cast<uint8_t>(~0x6);                     // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer << 1) & (0x6)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    //  2 --> Not used
    //  3 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setVCU_DteBaseVal(const double value) noexcept
{
    if ((value > static_cast<double>(2047)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_BodyCtrl_FB_03_P_100ms_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[9] &= static_cast<uint8_t>(~0xf8);                      // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer << 3) & (0xf8));  // push in new data
    canPacket_.data[10] &= static_cast<uint8_t>(~0x3f);                     // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer >> 5) & (0x3f)); // push in new data
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setVCU_EvDrvRdyCluDispSta(const double value) noexcept
{
    if ((value > static_cast<double>(3)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_BodyCtrl_FB_03_P_100ms_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[10] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Ready Lamp Off
    //  1 --> Ready Lamp On
    //  2 --> Error Indicator
    //  3 --> Blinking
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setVCU_LowSocAlertSta(const double value) noexcept
{
    if ((value > static_cast<double>(7)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_BodyCtrl_FB_03_P_100ms_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[11] &= static_cast<uint8_t>(~0x7);                // clear the bits for new data
    canPacket_.data[11] |= static_cast<uint8_t>((bitBuffer) & (0x7)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No Alert
    //  1 --> Low SOC Alert 1
    //  2 --> Low SOC Alert 2
    //  3 --> Low SOC Alert 3
    //  4 --> Reserved
    //  5 --> Reserved
    //  6 --> Reserved
    //  7 --> SOC Unavailable Alert
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setVCU_LowSocDispPcVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[11] &= static_cast<uint8_t>(~0x78);                     // clear the bits for new data
    canPacket_.data[11] |= static_cast<uint8_t>((bitBuffer << 3) & (0x78)); // push in new data
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setVCU_ServiceLampReq(const double value) noexcept
{
    if ((value > static_cast<double>(3)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_BodyCtrl_FB_03_P_100ms_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[11] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[11] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    canPacket_.data[12] &= static_cast<uint8_t>(~0x1);                      // clear the bits for new data
    canPacket_.data[12] |= static_cast<uint8_t>((bitBuffer >> 1) & (0x1));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> None
    //  1 --> Service Lamp On
    //  2 --> Not used
    //  3 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setVIC_BodyCtrl_FB_03_AlvCnt1Val(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[2] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[2] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setVIC_BodyCtrl_FB_03_Crc1Val(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[0] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[0] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[1] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[1] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_BodyCtrl_FB_03_P_100ms::setxEV_SrvLmpReq(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[15] &= static_cast<uint8_t>(~0x6);                     // clear the bits for new data
    canPacket_.data[15] |= static_cast<uint8_t>((bitBuffer << 1) & (0x6)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> Service Lamp On
    //  2 --> Not used
    //  3 --> Error indicator
    return 0;
}
