/// @copyright Copyright (c) 2021- Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file: /home/scotty/Downloads/Gen2_AVT_B_Control_CAN1.dbc

#include "VehicleCANLibrary/g2h/av_proto/VIC_BodyCtrl_FB_04_P_10ms.hpp"
#include <algorithm>
#include <string.h>

using namespace av::can::g2h::avproto;

VIC_BodyCtrl_FB_04_P_10ms::VIC_BodyCtrl_FB_04_P_10ms(const uint32_t id)
{
    canPacket_.id = id;
    canPacket_.length = VIC_BodyCtrl_FB_04_P_10ms_CONSTS::VIC_BODYCTRL_FB_04_P_10MS_PACKET_LEN;
}

VIC_BodyCtrl_FB_04_P_10ms::VIC_BodyCtrl_FB_04_P_10ms(const uint32_t id, uint8_t* const payload, const uint8_t size)
{
    canPacket_.id = id;

    if ((size <= sizeof(canPacket_.data)) && payload) {
        canPacket_.length = size;
        std::copy_n(payload, size, canPacket_.data);
    }
}

const CanFdPacket& VIC_BodyCtrl_FB_04_P_10ms::getCanPacket() const
{
    return canPacket_;
}

double VIC_BodyCtrl_FB_04_P_10ms::getIMU_LatAccelSigSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[16]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[17]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1e0);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    return output;
}

double VIC_BodyCtrl_FB_04_P_10ms::getIMU_LatAccelVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[17]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[18]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[19]) << 16; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1fffe);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                                    // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.000127465)) +
             static_cast<double>(-4.17677312); // (output * scale_factor) + bias

    return output;
}

double VIC_BodyCtrl_FB_04_P_10ms::getIMU_LongAccelSigSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[19]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x1e);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    return output;
}

double VIC_BodyCtrl_FB_04_P_10ms::getIMU_LongAccelVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[19]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[20]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[21]) << 16; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1fffe0);                               // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                                    // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.000127465)) +
             static_cast<double>(-4.17677312); // (output * scale_factor) + bias

    return output;
}

double VIC_BodyCtrl_FB_04_P_10ms::getIMU_RollRtVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[21]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[22]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[23]) << 16; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1fffe0);                               // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                                    // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.005)) + static_cast<double>(-163.84); // (output * scale_factor) + bias

    return output;
}

double VIC_BodyCtrl_FB_04_P_10ms::getIMU_RollSigSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[23]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[24]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1e0);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    return output;
}

double VIC_BodyCtrl_FB_04_P_10ms::getIMU_VerAccelSigSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[24]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x1e);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    return output;
}

double VIC_BodyCtrl_FB_04_P_10ms::getIMU_VerAccelVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[24]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[25]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[26]) << 16; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1fffe0);                               // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                                    // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.000127465)) +
             static_cast<double>(-4.17677312); // (output * scale_factor) + bias

    return output;
}

double VIC_BodyCtrl_FB_04_P_10ms::getIMU_YawRtVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[26]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[27]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[28]) << 16; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1fffe0);                               // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                                    // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.005)) + static_cast<double>(-163.84); // (output * scale_factor) + bias

    return output;
}

double VIC_BodyCtrl_FB_04_P_10ms::getIMU_YawSigSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[28]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[29]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1e0);                                 // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                                   // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    return output;
}

double VIC_BodyCtrl_FB_04_P_10ms::getMCU_Mg1SrvLmpOnReq() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Service Lamp Off
    //  1 --> Service Lamp On by Mg1 MCU
    //  2 --> Not used
    //  3 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_04_P_10ms::getMDPS1_FDBK_CommSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xe);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> Primary communication error
    //  2 --> Backup communication error
    //  3 --> Primary & Backup communication error
    //  4 --> Primary & Backup communication Mismatching
    //  5 --> MDPS Internal communication Error
    //  6 --> Disengaged request error
    //  7 --> Reserved
    return output;
}

double VIC_BodyCtrl_FB_04_P_10ms::getMDPS1_FDBK_FltSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x30);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> Fault 1 (100%)
    //  2 --> Fault 2 (50%)
    //  3 --> Fault 3 (0%)
    return output;
}

double VIC_BodyCtrl_FB_04_P_10ms::getMDPS1_FDBK_Status() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1c0);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                                  // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Startup
    //  1 --> Not Ready
    //  2 --> Ready
    //  3 --> AV Mode w/ safety driver
    //  4 --> Driverless Mode
    //  5 --> Fault (manual)
    //  6 --> Reserved
    //  7 --> Reserved
    return output;
}

double VIC_BodyCtrl_FB_04_P_10ms::getVCMS_FltCode() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1f0);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                                  // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    return output;
}

double VIC_BodyCtrl_FB_04_P_10ms::getVCMS_FltType() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[5]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x380);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                                  // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> CMS Diag
    //  1 --> SEQ Diag
    //  2 --> EVSE Diag
    //  3 --> Fail-Safe Diag
    return output;
}

double VIC_BodyCtrl_FB_04_P_10ms::getVCU_EcmSeqSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> IG Off
    //  1 --> IG On_PowerLatch
    //  2 --> IG On Init
    //  3 --> IG On_Rdy
    //  4 --> IG On_Drivalble
    //  5 --> IG On_PD
    //  6 --> IGON_NonDrivable
    return output;
}

double VIC_BodyCtrl_FB_04_P_10ms::getVCU_EvDrvRdySta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x3);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> None
    //  1 --> EV Drivable
    //  2 --> Not used
    //  3 --> Error Indicator
    return output;
}

double VIC_BodyCtrl_FB_04_P_10ms::getVCU_GearPosSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xf0);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> P
    //  1 --> B
    //  2 --> Not Used
    //  3 --> Not Used
    //  4 --> Not Used
    //  5 --> D
    //  6 --> N
    //  7 --> R
    //  8 --> Not Used
    //  9 --> Not Display at Cluster
    //  10 --> Reserved
    //  11 --> Reserved
    //  12 --> Reserved
    //  13 --> Reserved
    //  14 --> Intermediate Position
    //  15 --> Fault
    return output;
}

double VIC_BodyCtrl_FB_04_P_10ms::getVCU_GearPosStaDisp() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xf);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> P
    //  1 --> B
    //  2 --> Not Used
    //  3 --> Not Used
    //  4 --> Not Used
    //  5 --> D
    //  6 --> N
    //  7 --> R
    //  8 --> Not Used
    //  9 --> Not Display at Cluster
    //  10 --> Reserved
    //  11 --> Reserved
    //  12 --> Manual Shift Mode on Retromode
    //  13 --> Reserved
    //  14 --> Intermediate Position
    //  15 --> Fault
    return output;
}

double VIC_BodyCtrl_FB_04_P_10ms::getVCU_LimpHomeModSta() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[5]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x70);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> Limphome Level 1
    //  2 --> Limphome Level 2
    //  3 --> Limphome Level 3
    //  4 --> Limphome Level 4
    return output;
}

double VIC_BodyCtrl_FB_04_P_10ms::getVIC_BodyCtrl_FB_04_AlvCnt1Val() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[2]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    return output;
}

double VIC_BodyCtrl_FB_04_P_10ms::getVIC_BodyCtrl_FB_04_Crc1Val() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[0]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[1]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffff);                               // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);        // Unsigned value

    return output;
}

double VIC_BodyCtrl_FB_04_P_10ms::getxEV_SocVal_VCU() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[5]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffc);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                                  // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = output * static_cast<double>(0.1); // output * scale_factor

    return output;
}

int64_t VIC_BodyCtrl_FB_04_P_10ms::setIMU_LatAccelSigSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[16] &= static_cast<uint8_t>(~0xe0);                     // clear the bits for new data
    canPacket_.data[16] |= static_cast<uint8_t>((bitBuffer << 5) & (0xe0)); // push in new data
    canPacket_.data[17] &= static_cast<uint8_t>(~0x1);                      // clear the bits for new data
    canPacket_.data[17] |= static_cast<uint8_t>((bitBuffer >> 3) & (0x1));  // push in new data
    return 0;
}

int64_t VIC_BodyCtrl_FB_04_P_10ms::setIMU_LatAccelVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-4.17677312)) /
                                                  static_cast<double>(0.000127465)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[17] &= static_cast<uint8_t>(~0xfe);                     // clear the bits for new data
    canPacket_.data[17] |= static_cast<uint8_t>((bitBuffer << 1) & (0xfe)); // push in new data
    canPacket_.data[18] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[18] |= static_cast<uint8_t>((bitBuffer >> 7) & (0xff)); // push in new data
    canPacket_.data[19] &= static_cast<uint8_t>(~0x1);                      // clear the bits for new data
    canPacket_.data[19] |= static_cast<uint8_t>((bitBuffer >> 15) & (0x1)); // push in new data
    return 0;
}

int64_t VIC_BodyCtrl_FB_04_P_10ms::setIMU_LongAccelSigSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[19] &= static_cast<uint8_t>(~0x1e);                     // clear the bits for new data
    canPacket_.data[19] |= static_cast<uint8_t>((bitBuffer << 1) & (0x1e)); // push in new data
    return 0;
}

int64_t VIC_BodyCtrl_FB_04_P_10ms::setIMU_LongAccelVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-4.17677312)) /
                                                  static_cast<double>(0.000127465)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[19] &= static_cast<uint8_t>(~0xe0);                      // clear the bits for new data
    canPacket_.data[19] |= static_cast<uint8_t>((bitBuffer << 5) & (0xe0));  // push in new data
    canPacket_.data[20] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[20] |= static_cast<uint8_t>((bitBuffer >> 3) & (0xff));  // push in new data
    canPacket_.data[21] &= static_cast<uint8_t>(~0x1f);                      // clear the bits for new data
    canPacket_.data[21] |= static_cast<uint8_t>((bitBuffer >> 11) & (0x1f)); // push in new data
    return 0;
}

int64_t VIC_BodyCtrl_FB_04_P_10ms::setIMU_RollRtVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-163.84)) /
                                                  static_cast<double>(0.005)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[21] &= static_cast<uint8_t>(~0xe0);                      // clear the bits for new data
    canPacket_.data[21] |= static_cast<uint8_t>((bitBuffer << 5) & (0xe0));  // push in new data
    canPacket_.data[22] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[22] |= static_cast<uint8_t>((bitBuffer >> 3) & (0xff));  // push in new data
    canPacket_.data[23] &= static_cast<uint8_t>(~0x1f);                      // clear the bits for new data
    canPacket_.data[23] |= static_cast<uint8_t>((bitBuffer >> 11) & (0x1f)); // push in new data
    return 0;
}

int64_t VIC_BodyCtrl_FB_04_P_10ms::setIMU_RollSigSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[23] &= static_cast<uint8_t>(~0xe0);                     // clear the bits for new data
    canPacket_.data[23] |= static_cast<uint8_t>((bitBuffer << 5) & (0xe0)); // push in new data
    canPacket_.data[24] &= static_cast<uint8_t>(~0x1);                      // clear the bits for new data
    canPacket_.data[24] |= static_cast<uint8_t>((bitBuffer >> 3) & (0x1));  // push in new data
    return 0;
}

int64_t VIC_BodyCtrl_FB_04_P_10ms::setIMU_VerAccelSigSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[24] &= static_cast<uint8_t>(~0x1e);                     // clear the bits for new data
    canPacket_.data[24] |= static_cast<uint8_t>((bitBuffer << 1) & (0x1e)); // push in new data
    return 0;
}

int64_t VIC_BodyCtrl_FB_04_P_10ms::setIMU_VerAccelVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-4.17677312)) /
                                                  static_cast<double>(0.000127465)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[24] &= static_cast<uint8_t>(~0xe0);                      // clear the bits for new data
    canPacket_.data[24] |= static_cast<uint8_t>((bitBuffer << 5) & (0xe0));  // push in new data
    canPacket_.data[25] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[25] |= static_cast<uint8_t>((bitBuffer >> 3) & (0xff));  // push in new data
    canPacket_.data[26] &= static_cast<uint8_t>(~0x1f);                      // clear the bits for new data
    canPacket_.data[26] |= static_cast<uint8_t>((bitBuffer >> 11) & (0x1f)); // push in new data
    return 0;
}

int64_t VIC_BodyCtrl_FB_04_P_10ms::setIMU_YawRtVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-163.84)) /
                                                  static_cast<double>(0.005)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[26] &= static_cast<uint8_t>(~0xe0);                      // clear the bits for new data
    canPacket_.data[26] |= static_cast<uint8_t>((bitBuffer << 5) & (0xe0));  // push in new data
    canPacket_.data[27] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[27] |= static_cast<uint8_t>((bitBuffer >> 3) & (0xff));  // push in new data
    canPacket_.data[28] &= static_cast<uint8_t>(~0x1f);                      // clear the bits for new data
    canPacket_.data[28] |= static_cast<uint8_t>((bitBuffer >> 11) & (0x1f)); // push in new data
    return 0;
}

int64_t VIC_BodyCtrl_FB_04_P_10ms::setIMU_YawSigSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[28] &= static_cast<uint8_t>(~0xe0);                     // clear the bits for new data
    canPacket_.data[28] |= static_cast<uint8_t>((bitBuffer << 5) & (0xe0)); // push in new data
    canPacket_.data[29] &= static_cast<uint8_t>(~0x1);                      // clear the bits for new data
    canPacket_.data[29] |= static_cast<uint8_t>((bitBuffer >> 3) & (0x1));  // push in new data
    return 0;
}

int64_t VIC_BodyCtrl_FB_04_P_10ms::setMCU_Mg1SrvLmpOnReq(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[6] &= static_cast<uint8_t>(~0xc);                     // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer << 2) & (0xc)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Service Lamp Off
    //  1 --> Service Lamp On by Mg1 MCU
    //  2 --> Not used
    //  3 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_04_P_10ms::setMDPS1_FDBK_CommSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[8] &= static_cast<uint8_t>(~0xe);                     // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer << 1) & (0xe)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> Primary communication error
    //  2 --> Backup communication error
    //  3 --> Primary & Backup communication error
    //  4 --> Primary & Backup communication Mismatching
    //  5 --> MDPS Internal communication Error
    //  6 --> Disengaged request error
    //  7 --> Reserved
    return 0;
}

int64_t VIC_BodyCtrl_FB_04_P_10ms::setMDPS1_FDBK_FltSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[8] &= static_cast<uint8_t>(~0x30);                     // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer << 4) & (0x30)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> Fault 1 (100%)
    //  2 --> Fault 2 (50%)
    //  3 --> Fault 3 (0%)
    return 0;
}

int64_t VIC_BodyCtrl_FB_04_P_10ms::setMDPS1_FDBK_Status(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[8] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    canPacket_.data[9] &= static_cast<uint8_t>(~0x1);                      // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer >> 2) & (0x1));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Startup
    //  1 --> Not Ready
    //  2 --> Ready
    //  3 --> AV Mode w/ safety driver
    //  4 --> Driverless Mode
    //  5 --> Fault (manual)
    //  6 --> Reserved
    //  7 --> Reserved
    return 0;
}

int64_t VIC_BodyCtrl_FB_04_P_10ms::setVCMS_FltCode(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[7] &= static_cast<uint8_t>(~0xf0);                     // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer << 4) & (0xf0)); // push in new data
    canPacket_.data[8] &= static_cast<uint8_t>(~0x1);                      // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer >> 4) & (0x1));  // push in new data
    return 0;
}

int64_t VIC_BodyCtrl_FB_04_P_10ms::setVCMS_FltType(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[5] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[5] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    canPacket_.data[6] &= static_cast<uint8_t>(~0x3);                      // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer >> 1) & (0x3));  // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> CMS Diag
    //  1 --> SEQ Diag
    //  2 --> EVSE Diag
    //  3 --> Fail-Safe Diag
    return 0;
}

int64_t VIC_BodyCtrl_FB_04_P_10ms::setVCU_EcmSeqSta(const double value) noexcept
{
    if ((value > static_cast<double>(255)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_BodyCtrl_FB_04_P_10ms_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> IG Off
    //  1 --> IG On_PowerLatch
    //  2 --> IG On Init
    //  3 --> IG On_Rdy
    //  4 --> IG On_Drivalble
    //  5 --> IG On_PD
    //  6 --> IGON_NonDrivable
    return 0;
}

int64_t VIC_BodyCtrl_FB_04_P_10ms::setVCU_EvDrvRdySta(const double value) noexcept
{
    if ((value > static_cast<double>(3)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_BodyCtrl_FB_04_P_10ms_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0x3);                // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer) & (0x3)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> None
    //  1 --> EV Drivable
    //  2 --> Not used
    //  3 --> Error Indicator
    return 0;
}

int64_t VIC_BodyCtrl_FB_04_P_10ms::setVCU_GearPosSta(const double value) noexcept
{
    if ((value > static_cast<double>(15)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_BodyCtrl_FB_04_P_10ms_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[6] &= static_cast<uint8_t>(~0xf0);                     // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer << 4) & (0xf0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> P
    //  1 --> B
    //  2 --> Not Used
    //  3 --> Not Used
    //  4 --> Not Used
    //  5 --> D
    //  6 --> N
    //  7 --> R
    //  8 --> Not Used
    //  9 --> Not Display at Cluster
    //  10 --> Reserved
    //  11 --> Reserved
    //  12 --> Reserved
    //  13 --> Reserved
    //  14 --> Intermediate Position
    //  15 --> Fault
    return 0;
}

int64_t VIC_BodyCtrl_FB_04_P_10ms::setVCU_GearPosStaDisp(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[7] &= static_cast<uint8_t>(~0xf);                // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer) & (0xf)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> P
    //  1 --> B
    //  2 --> Not Used
    //  3 --> Not Used
    //  4 --> Not Used
    //  5 --> D
    //  6 --> N
    //  7 --> R
    //  8 --> Not Used
    //  9 --> Not Display at Cluster
    //  10 --> Reserved
    //  11 --> Reserved
    //  12 --> Manual Shift Mode on Retromode
    //  13 --> Reserved
    //  14 --> Intermediate Position
    //  15 --> Fault
    return 0;
}

int64_t VIC_BodyCtrl_FB_04_P_10ms::setVCU_LimpHomeModSta(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[5] &= static_cast<uint8_t>(~0x70);                     // clear the bits for new data
    canPacket_.data[5] |= static_cast<uint8_t>((bitBuffer << 4) & (0x70)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Normal
    //  1 --> Limphome Level 1
    //  2 --> Limphome Level 2
    //  3 --> Limphome Level 3
    //  4 --> Limphome Level 4
    return 0;
}

int64_t VIC_BodyCtrl_FB_04_P_10ms::setVIC_BodyCtrl_FB_04_AlvCnt1Val(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[2] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[2] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_BodyCtrl_FB_04_P_10ms::setVIC_BodyCtrl_FB_04_Crc1Val(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[0] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[0] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[1] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[1] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_BodyCtrl_FB_04_P_10ms::setxEV_SocVal_VCU(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value / static_cast<double>(0.1)); // value / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0xfc);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer << 2) & (0xfc)); // push in new data
    canPacket_.data[5] &= static_cast<uint8_t>(~0xf);                      // clear the bits for new data
    canPacket_.data[5] |= static_cast<uint8_t>((bitBuffer >> 6) & (0xf));  // push in new data
    return 0;
}
