/// @copyright Copyright (c) 2022 - Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file:
/// https://gitlab.ci.motional.com/systems/av-netwrok-infrastructure/Gen2-AVT-Sample-B/-/blob/dd539e5d752bcae0408ed2b8f29b270cc0db624e/Gen2_AVT_B_Control_CAN1.dbc

#include "VehicleCANLibrary/g2h/av_proto/VIC_Dynamic_Request.hpp"
#include <algorithm>
#include <string.h>

using namespace av::can::g2h::avproto;

VIC_Dynamic_Request::VIC_Dynamic_Request(const uint32_t id)
{
    canPacket_.id = id;
    canPacket_.length = VIC_Dynamic_Request_CONSTS::VIC_DYNAMIC_REQUEST_PACKET_LEN;
}

VIC_Dynamic_Request::VIC_Dynamic_Request(const uint32_t id, uint8_t* const payload, const uint8_t size)
{
    canPacket_.id = id;

    if ((size <= sizeof(canPacket_.data)) && payload) {
        canPacket_.length = size;
        std::copy_n(payload, size, canPacket_.data);
    }
}

const CanFdPacket& VIC_Dynamic_Request::getCanPacket() const
{
    return canPacket_;
}

double VIC_Dynamic_Request::getALIV_Dynamic_Request() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[2]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    return output;
}

double VIC_Dynamic_Request::getAUTH_Dynamic_Request() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[27]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[28]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[29]) << 16; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[30]) << 24; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[31]) << 32; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffffffffff);                           // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);          // Unsigned value

    return output;
}

double VIC_Dynamic_Request::getCRC_Dynamic_Request() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[0]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[1]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffff);                               // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);        // Unsigned value

    return output;
}

double VIC_Dynamic_Request::getFV_Dynamic_Request() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[20]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[21]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[22]) << 16; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[23]) << 24; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[24]) << 32; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[25]) << 40; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[26]) << 48; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffffffffffffff);                       // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);                // Unsigned value

    if ((output > static_cast<double>(7.20575940379279e+16)) || (output < static_cast<double>(0))) // check for boundary
    {
        output = static_cast<double>(VIC_Dynamic_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double VIC_Dynamic_Request::getF_LateralForceDisturb() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[18]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[19]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff0);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = output + static_cast<double>(-1500); // output + bias

    if ((output > static_cast<double>(1500)) || (output < static_cast<double>(-1500))) // check for boundary
    {
        output = static_cast<double>(VIC_Dynamic_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double VIC_Dynamic_Request::getF_LongitudinalForceDisturb() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[17]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[18]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff);                                 // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);               // Unsigned value

    output = output + static_cast<double>(-1500); // output + bias

    if ((output > static_cast<double>(1500)) || (output < static_cast<double>(-1500))) // check for boundary
    {
        output = static_cast<double>(VIC_Dynamic_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double VIC_Dynamic_Request::getTq_WheelTorque_Rq() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[15]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[16]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffff);                                // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);               // Unsigned value

    output = output + static_cast<double>(-32768); // output + bias

    return output;
}

double VIC_Dynamic_Request::geta_FeedForwardAccel_Rq_10ms() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]) << 16; // Bytes containing signal
    bitBuffer &= UINT64_C(0x3fff8);                               // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.001)) + static_cast<double>(-10); // (output * scale_factor) + bias

    if ((output > static_cast<double>(10)) || (output < static_cast<double>(-10))) // check for boundary
    {
        output = static_cast<double>(VIC_Dynamic_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double VIC_Dynamic_Request::geta_HandWheelAngleAccel_Rq() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[13]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[14]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfffe);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.1)) + static_cast<double>(-1440); // (output * scale_factor) + bias

    if ((output > static_cast<double>(1440)) || (output < static_cast<double>(-1440))) // check for boundary
    {
        output = static_cast<double>(VIC_Dynamic_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double VIC_Dynamic_Request::getc_Curvature_Rq() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x3fff);                               // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);              // Unsigned value

    output = (output * static_cast<double>(0.0001)) + static_cast<double>(-0.5); // (output * scale_factor) + bias

    if ((output > static_cast<double>(0.5)) || (output < static_cast<double>(-0.5))) // check for boundary
    {
        output = static_cast<double>(VIC_Dynamic_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double VIC_Dynamic_Request::getj_TargetJerk_Rq() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfffc);                               // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                                  // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.01)) + static_cast<double>(-50); // (output * scale_factor) + bias

    if ((output > static_cast<double>(50)) || (output < static_cast<double>(-50))) // check for boundary
    {
        output = static_cast<double>(VIC_Dynamic_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double VIC_Dynamic_Request::getv_TargetSpeed_Rq_10ms() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[5]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]) << 16; // Bytes containing signal
    bitBuffer &= UINT64_C(0x7ffc0);                               // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.01)) + static_cast<double>(-10); // (output * scale_factor) + bias

    if ((output > static_cast<double>(40)) || (output < static_cast<double>(-10))) // check for boundary
    {
        output = static_cast<double>(VIC_Dynamic_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double VIC_Dynamic_Request::getw_HandWheelAngleRate_Rq() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[11]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[12]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[13]) << 16; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1fff8);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                                    // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.1)) + static_cast<double>(-720); // (output * scale_factor) + bias

    if ((output > static_cast<double>(720)) || (output < static_cast<double>(-720))) // check for boundary
    {
        output = static_cast<double>(VIC_Dynamic_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double VIC_Dynamic_Request::getw_RoadWheelAngleRate_Rq_10ms() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[11]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x7ff);                                 // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);               // Unsigned value

    output = (output * static_cast<double>(0.001)) + static_cast<double>(-0.65); // (output * scale_factor) + bias

    if ((output > static_cast<double>(0.65)) || (output < static_cast<double>(-0.65))) // check for boundary
    {
        output = static_cast<double>(VIC_Dynamic_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

int64_t VIC_Dynamic_Request::setALIV_Dynamic_Request(const double value) noexcept
{
    if ((value > static_cast<double>(255)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_Dynamic_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[2] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[2] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_Dynamic_Request::setAUTH_Dynamic_Request(const double value) noexcept
{
    if ((value > static_cast<double>(1099511627775)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_Dynamic_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[27] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[27] |= static_cast<uint8_t>((bitBuffer) & (0xff));       // push in new data
    canPacket_.data[28] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[28] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff));  // push in new data
    canPacket_.data[29] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[29] |= static_cast<uint8_t>((bitBuffer >> 16) & (0xff)); // push in new data
    canPacket_.data[30] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[30] |= static_cast<uint8_t>((bitBuffer >> 24) & (0xff)); // push in new data
    canPacket_.data[31] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[31] |= static_cast<uint8_t>((bitBuffer >> 32) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_Dynamic_Request::setCRC_Dynamic_Request(const double value) noexcept
{
    if ((value > static_cast<double>(65535)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_Dynamic_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[0] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[0] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[1] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[1] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_Dynamic_Request::setFV_Dynamic_Request(const double value) noexcept
{
    if ((value > static_cast<double>(7.20575940379279e+16)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_Dynamic_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[20] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[20] |= static_cast<uint8_t>((bitBuffer) & (0xff));       // push in new data
    canPacket_.data[21] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[21] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff));  // push in new data
    canPacket_.data[22] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[22] |= static_cast<uint8_t>((bitBuffer >> 16) & (0xff)); // push in new data
    canPacket_.data[23] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[23] |= static_cast<uint8_t>((bitBuffer >> 24) & (0xff)); // push in new data
    canPacket_.data[24] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[24] |= static_cast<uint8_t>((bitBuffer >> 32) & (0xff)); // push in new data
    canPacket_.data[25] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[25] |= static_cast<uint8_t>((bitBuffer >> 40) & (0xff)); // push in new data
    canPacket_.data[26] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[26] |= static_cast<uint8_t>((bitBuffer >> 48) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_Dynamic_Request::setF_LateralForceDisturb(const double value) noexcept
{
    if ((value > static_cast<double>(1500)) ||
        (value < static_cast<double>(-1500))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_Dynamic_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value) - static_cast<int64_t>(-1500); // value - bias

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[18] &= static_cast<uint8_t>(~0xf0);                     // clear the bits for new data
    canPacket_.data[18] |= static_cast<uint8_t>((bitBuffer << 4) & (0xf0)); // push in new data
    canPacket_.data[19] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[19] |= static_cast<uint8_t>((bitBuffer >> 4) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_Dynamic_Request::setF_LongitudinalForceDisturb(const double value) noexcept
{
    if ((value > static_cast<double>(1500)) ||
        (value < static_cast<double>(-1500))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_Dynamic_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value) - static_cast<int64_t>(-1500); // value - bias

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[17] &= static_cast<uint8_t>(~0xff);                    // clear the bits for new data
    canPacket_.data[17] |= static_cast<uint8_t>((bitBuffer) & (0xff));     // push in new data
    canPacket_.data[18] &= static_cast<uint8_t>(~0xf);                     // clear the bits for new data
    canPacket_.data[18] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xf)); // push in new data
    return 0;
}

int64_t VIC_Dynamic_Request::setTq_WheelTorque_Rq(const double value) noexcept
{
    if ((value > static_cast<double>(32767)) ||
        (value < static_cast<double>(-32768))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_Dynamic_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value) - static_cast<int64_t>(-32768); // value - bias

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[15] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[15] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[16] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[16] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_Dynamic_Request::seta_FeedForwardAccel_Rq_10ms(const double value) noexcept
{
    if ((value > static_cast<double>(10)) ||
        (value < static_cast<double>(-10))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_Dynamic_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-10)) /
                                                  static_cast<double>(0.001)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[6] &= static_cast<uint8_t>(~0xf8);                     // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer << 3) & (0xf8)); // push in new data
    canPacket_.data[7] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer >> 5) & (0xff)); // push in new data
    canPacket_.data[8] &= static_cast<uint8_t>(~0x3);                      // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer >> 13) & (0x3)); // push in new data
    return 0;
}

int64_t VIC_Dynamic_Request::seta_HandWheelAngleAccel_Rq(const double value) noexcept
{
    if ((value > static_cast<double>(1440)) ||
        (value < static_cast<double>(-1440))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_Dynamic_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-1440)) /
                                                  static_cast<double>(0.1)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[13] &= static_cast<uint8_t>(~0xfe);                     // clear the bits for new data
    canPacket_.data[13] |= static_cast<uint8_t>((bitBuffer << 1) & (0xfe)); // push in new data
    canPacket_.data[14] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[14] |= static_cast<uint8_t>((bitBuffer >> 7) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_Dynamic_Request::setc_Curvature_Rq(const double value) noexcept
{
    if ((value > static_cast<double>(0.5)) ||
        (value < static_cast<double>(-0.5))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_Dynamic_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-0.5)) /
                                                  static_cast<double>(0.0001)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[4] &= static_cast<uint8_t>(~0x3f);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer >> 8) & (0x3f)); // push in new data
    return 0;
}

int64_t VIC_Dynamic_Request::setj_TargetJerk_Rq(const double value) noexcept
{
    if ((value > static_cast<double>(50)) ||
        (value < static_cast<double>(-50))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_Dynamic_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-50)) /
                                                  static_cast<double>(0.01)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[8] &= static_cast<uint8_t>(~0xfc);                     // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer << 2) & (0xfc)); // push in new data
    canPacket_.data[9] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer >> 6) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_Dynamic_Request::setv_TargetSpeed_Rq_10ms(const double value) noexcept
{
    if ((value > static_cast<double>(40)) ||
        (value < static_cast<double>(-10))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_Dynamic_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-10)) /
                                                  static_cast<double>(0.01)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    canPacket_.data[5] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[5] |= static_cast<uint8_t>((bitBuffer >> 2) & (0xff)); // push in new data
    canPacket_.data[6] &= static_cast<uint8_t>(~0x7);                      // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer >> 10) & (0x7)); // push in new data
    return 0;
}

int64_t VIC_Dynamic_Request::setw_HandWheelAngleRate_Rq(const double value) noexcept
{
    if ((value > static_cast<double>(720)) ||
        (value < static_cast<double>(-720))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_Dynamic_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-720)) /
                                                  static_cast<double>(0.1)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[11] &= static_cast<uint8_t>(~0xf8);                     // clear the bits for new data
    canPacket_.data[11] |= static_cast<uint8_t>((bitBuffer << 3) & (0xf8)); // push in new data
    canPacket_.data[12] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[12] |= static_cast<uint8_t>((bitBuffer >> 5) & (0xff)); // push in new data
    canPacket_.data[13] &= static_cast<uint8_t>(~0x1);                      // clear the bits for new data
    canPacket_.data[13] |= static_cast<uint8_t>((bitBuffer >> 13) & (0x1)); // push in new data
    return 0;
}

int64_t VIC_Dynamic_Request::setw_RoadWheelAngleRate_Rq_10ms(const double value) noexcept
{
    if ((value > static_cast<double>(0.65)) ||
        (value < static_cast<double>(-0.65))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_Dynamic_Request_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-0.65)) /
                                                  static_cast<double>(0.001)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[10] &= static_cast<uint8_t>(~0xff);                    // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer) & (0xff));     // push in new data
    canPacket_.data[11] &= static_cast<uint8_t>(~0x7);                     // clear the bits for new data
    canPacket_.data[11] |= static_cast<uint8_t>((bitBuffer >> 8) & (0x7)); // push in new data
    return 0;
}
