/// @copyright Copyright (c) 2022 - Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file:
/// https://gitlab.ci.motional.com/systems/av-netwrok-infrastructure/Gen2-AVT-Sample-B/-/blob/dd539e5d752bcae0408ed2b8f29b270cc0db624e/Gen2_AVT_B_Control_CAN1.dbc

#include "VehicleCANLibrary/g2h/av_proto/VIC_Lateral_Control.hpp"
#include <algorithm>
#include <string.h>

using namespace av::can::g2h::avproto;

VIC_Lateral_Control::VIC_Lateral_Control(const uint32_t id)
{
    canPacket_.id = id;
    canPacket_.length = VIC_Lateral_Control_CONSTS::VIC_LATERAL_CONTROL_PACKET_LEN;
}

VIC_Lateral_Control::VIC_Lateral_Control(const uint32_t id, uint8_t* const payload, const uint8_t size)
{
    canPacket_.id = id;

    if ((size <= sizeof(canPacket_.data)) && payload) {
        canPacket_.length = size;
        std::copy_n(payload, size, canPacket_.data);
    }
}

const CanFdPacket& VIC_Lateral_Control::getCanPacket() const
{
    return canPacket_;
}

double VIC_Lateral_Control::getALIV_Lateral_Control() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[2]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    return output;
}

double VIC_Lateral_Control::getAUTH_Lateral_Control() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[27]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[28]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[29]) << 16; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[30]) << 24; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[31]) << 32; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffffffffff);                           // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);          // Unsigned value

    return output;
}

double VIC_Lateral_Control::getB_YawRate_Valid() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x4);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    return output;
}

double VIC_Lateral_Control::getCRC_Lateral_Control() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[0]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[1]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffff);                               // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);        // Unsigned value

    return output;
}

double VIC_Lateral_Control::getFV_Lateral_Control() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[20]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[21]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[22]) << 16; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[23]) << 24; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[24]) << 32; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[25]) << 40; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[26]) << 48; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffffffffffffff);                       // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);                // Unsigned value

    if ((output > static_cast<double>(7.20575940379279e+16)) || (output < static_cast<double>(0))) // check for boundary
    {
        output = static_cast<double>(VIC_Lateral_Control_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double VIC_Lateral_Control::getsts_LatControlMode() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x7);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    return output;
}

double VIC_Lateral_Control::getu_RoadWheelAngleCurrent() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffff);                               // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);              // Unsigned value

    output = (output * static_cast<double>(4.798e-05)) + static_cast<double>(-1.5708); // (output * scale_factor) + bias

    if ((output > static_cast<double>(1.5708)) || (output < static_cast<double>(-1.5708))) // check for boundary
    {
        output = static_cast<double>(VIC_Lateral_Control_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double VIC_Lateral_Control::getu_RoadWheelAngleDesired() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[5]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffff);                               // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);              // Unsigned value

    output = (output * static_cast<double>(4.798e-05)) + static_cast<double>(-1.5708); // (output * scale_factor) + bias

    if ((output > static_cast<double>(1.5708)) || (output < static_cast<double>(-1.5708))) // check for boundary
    {
        output = static_cast<double>(VIC_Lateral_Control_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double VIC_Lateral_Control::getw_YawRate() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x3ff);                                // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);              // Unsigned value

    output = (output * static_cast<double>(0.01)) + static_cast<double>(-3.14); // (output * scale_factor) + bias

    if ((output > static_cast<double>(3.14)) || (output < static_cast<double>(-3.14))) // check for boundary
    {
        output = static_cast<double>(VIC_Lateral_Control_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

int64_t VIC_Lateral_Control::setALIV_Lateral_Control(const double value) noexcept
{
    if ((value > static_cast<double>(255)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_Lateral_Control_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[2] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[2] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_Lateral_Control::setAUTH_Lateral_Control(const double value) noexcept
{
    if ((value > static_cast<double>(1099511627775)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_Lateral_Control_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[27] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[27] |= static_cast<uint8_t>((bitBuffer) & (0xff));       // push in new data
    canPacket_.data[28] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[28] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff));  // push in new data
    canPacket_.data[29] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[29] |= static_cast<uint8_t>((bitBuffer >> 16) & (0xff)); // push in new data
    canPacket_.data[30] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[30] |= static_cast<uint8_t>((bitBuffer >> 24) & (0xff)); // push in new data
    canPacket_.data[31] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[31] |= static_cast<uint8_t>((bitBuffer >> 32) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_Lateral_Control::setB_YawRate_Valid(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0x4);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer << 2) & (0x4)); // push in new data
    return 0;
}

int64_t VIC_Lateral_Control::setCRC_Lateral_Control(const double value) noexcept
{
    if ((value > static_cast<double>(65535)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_Lateral_Control_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[0] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[0] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[1] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[1] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_Lateral_Control::setFV_Lateral_Control(const double value) noexcept
{
    if ((value > static_cast<double>(7.20575940379279e+16)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_Lateral_Control_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[20] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[20] |= static_cast<uint8_t>((bitBuffer) & (0xff));       // push in new data
    canPacket_.data[21] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[21] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff));  // push in new data
    canPacket_.data[22] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[22] |= static_cast<uint8_t>((bitBuffer >> 16) & (0xff)); // push in new data
    canPacket_.data[23] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[23] |= static_cast<uint8_t>((bitBuffer >> 24) & (0xff)); // push in new data
    canPacket_.data[24] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[24] |= static_cast<uint8_t>((bitBuffer >> 32) & (0xff)); // push in new data
    canPacket_.data[25] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[25] |= static_cast<uint8_t>((bitBuffer >> 40) & (0xff)); // push in new data
    canPacket_.data[26] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[26] |= static_cast<uint8_t>((bitBuffer >> 48) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_Lateral_Control::setsts_LatControlMode(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[9] &= static_cast<uint8_t>(~0x7);                // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer) & (0x7)); // push in new data
    return 0;
}

int64_t VIC_Lateral_Control::setu_RoadWheelAngleCurrent(const double value) noexcept
{
    if ((value > static_cast<double>(1.5708)) ||
        (value < static_cast<double>(-1.5708))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_Lateral_Control_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-1.5708)) /
                                                  static_cast<double>(4.798e-05)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[7] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[8] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_Lateral_Control::setu_RoadWheelAngleDesired(const double value) noexcept
{
    if ((value > static_cast<double>(1.5708)) ||
        (value < static_cast<double>(-1.5708))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_Lateral_Control_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-1.5708)) /
                                                  static_cast<double>(4.798e-05)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[5] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[5] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[6] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_Lateral_Control::setw_YawRate(const double value) noexcept
{
    if ((value > static_cast<double>(3.14)) ||
        (value < static_cast<double>(-3.14))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_Lateral_Control_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-3.14)) /
                                                  static_cast<double>(0.01)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0xff);                    // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer) & (0xff));     // push in new data
    canPacket_.data[4] &= static_cast<uint8_t>(~0x3);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer >> 8) & (0x3)); // push in new data
    return 0;
}
