/// @copyright Copyright (c) 2022 - Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file:
/// https://gitlab.ci.motional.com/systems/av-netwrok-infrastructure/Gen2-AVT-Sample-B/-/blob/dd539e5d752bcae0408ed2b8f29b270cc0db624e/Gen2_AVT_B_Control_CAN1.dbc

#include "VehicleCANLibrary/g2h/av_proto/VIC_VEH_DRV_Interface.hpp"
#include <algorithm>
#include <string.h>

using namespace av::can::g2h::avproto;

VIC_VEH_DRV_Interface::VIC_VEH_DRV_Interface(const uint32_t id)
{
    canPacket_.id = id;
    canPacket_.length = VIC_VEH_DRV_Interface_CONSTS::VIC_VEH_DRV_INTERFACE_PACKET_LEN;
}

VIC_VEH_DRV_Interface::VIC_VEH_DRV_Interface(const uint32_t id, uint8_t* const payload, const uint8_t size)
{
    canPacket_.id = id;

    if ((size <= sizeof(canPacket_.data)) && payload) {
        canPacket_.length = size;
        std::copy_n(payload, size, canPacket_.data);
    }
}

const CanFdPacket& VIC_VEH_DRV_Interface::getCanPacket() const
{
    return canPacket_;
}

double VIC_VEH_DRV_Interface::getALIV_VEH_DRV_Interface() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[2]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    return output;
}

double VIC_VEH_DRV_Interface::getAUTH_VEH_DRV_Interface() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[27]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[28]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[29]) << 16; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[30]) << 24; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[31]) << 32; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffffffffff);                           // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);          // Unsigned value

    return output;
}

double VIC_VEH_DRV_Interface::getB_AD_Transition() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x4);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return output;
}

double VIC_VEH_DRV_Interface::getB_AEB_Nominal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x80);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 1
    //  1 --> 0
    return output;
}

double VIC_VEH_DRV_Interface::getB_ASD_Transition() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x8);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return output;
}

double VIC_VEH_DRV_Interface::getB_AVHealth_Nominal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x80);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0
    //  1 --> 1
    return output;
}

double VIC_VEH_DRV_Interface::getB_AV_PwrState_Ready() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x40);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0
    //  1 --> 1
    return output;
}

double VIC_VEH_DRV_Interface::getB_AllDoors_Closed() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x80);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 1
    //  1 --> 1
    return output;
}

double VIC_VEH_DRV_Interface::getB_AllDoors_Locked() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x80);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0
    //  1 --> 1
    return output;
}

double VIC_VEH_DRV_Interface::getB_AutoButton() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x3);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Not Pressed
    //  1 --> Pressed
    //  3 --> SNA
    return output;
}

double VIC_VEH_DRV_Interface::getB_BrakeOverride() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No
    //  1 --> Yes
    //  3 --> SNA
    return output;
}

double VIC_VEH_DRV_Interface::getB_ChrgPort_Closed() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[12]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x1);                              // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);    // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 1
    //  1 --> 0
    return output;
}

double VIC_VEH_DRV_Interface::getB_DvrSeatbelt_Secured() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[12]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x2);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 1
    //  1 --> 0
    return output;
}

double VIC_VEH_DRV_Interface::getB_ECUState_Nominal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[12]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x4);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 1
    //  1 --> 0
    return output;
}

double VIC_VEH_DRV_Interface::getB_EPB() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x20);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return output;
}

double VIC_VEH_DRV_Interface::getB_EPB_Applied() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[12]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x10);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0
    //  1 --> 1
    return output;
}

double VIC_VEH_DRV_Interface::getB_EPB_Released() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[12]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x20);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0
    //  1 --> 1
    return output;
}

double VIC_VEH_DRV_Interface::getB_EV_Driverable() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[12]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x80);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 1
    //  1 --> 0
    return output;
}

double VIC_VEH_DRV_Interface::getB_EnableButton() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                             // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    if ((output > static_cast<double>(1)) || (output < static_cast<double>(0))) // check for boundary
    {
        output = static_cast<double>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Not Pressed
    //  1 --> Pressed
    //  3 --> SNA
    return output;
}

double VIC_VEH_DRV_Interface::getB_EngageBtn_Press() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[12]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x8);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0
    //  1 --> 1
    return output;
}

double VIC_VEH_DRV_Interface::getB_EngageButton() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc0);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Not Pressed
    //  1 --> Pressed
    //  3 --> SNA
    return output;
}

double VIC_VEH_DRV_Interface::getB_Estopbtn_Press() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[12]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x40);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0
    //  1 --> 1
    return output;
}

double VIC_VEH_DRV_Interface::getB_GVPM_IMU_Nominal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[13]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x1);                              // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);    // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 1
    //  1 --> 1
    return output;
}

double VIC_VEH_DRV_Interface::getB_HoldManual() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x2);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return output;
}

double VIC_VEH_DRV_Interface::getB_LoggingButton() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x30);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Not Pressed
    //  1 --> Pressed
    //  3 --> SNA
    return output;
}

double VIC_VEH_DRV_Interface::getB_ManualTakeover() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x1);                              // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);    // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return output;
}

double VIC_VEH_DRV_Interface::getB_Other_ECUstate_Nominal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[13]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x2);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 1
    //  1 --> 1
    return output;
}

double VIC_VEH_DRV_Interface::getB_ParkingBrake() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc0);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return output;
}

double VIC_VEH_DRV_Interface::getB_SSA_NotPresent() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[13]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x4);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 1
    //  1 --> 0
    return output;
}

double VIC_VEH_DRV_Interface::getB_Seatbelt() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x40);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return output;
}

double VIC_VEH_DRV_Interface::getB_SteerOverride() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x3);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No
    //  1 --> Yes
    //  3 --> SNA
    return output;
}

double VIC_VEH_DRV_Interface::getB_ThrottleOverride() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No
    //  1 --> Yes
    //  3 --> SNA
    return output;
}

double VIC_VEH_DRV_Interface::getB_TransitPark() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x10);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return output;
}

double VIC_VEH_DRV_Interface::getB_Trns_In_Drive() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[13]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x8);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0
    //  1 --> 1
    return output;
}

double VIC_VEH_DRV_Interface::getB_Trns_In_Park() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[13]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x10);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0
    //  1 --> 1
    return output;
}

double VIC_VEH_DRV_Interface::getB_TrunkHood_Closed() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[13]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x20);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0
    //  1 --> 1
    return output;
}

double VIC_VEH_DRV_Interface::getB_Zero_Veh_Vel() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[13]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x40);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0
    //  1 --> 1
    return output;
}

double VIC_VEH_DRV_Interface::getCRC_VEH_DRV_Interface() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[0]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[1]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffff);                               // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);        // Unsigned value

    return output;
}

double VIC_VEH_DRV_Interface::getFV_VEH_DRV_Interface() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[20]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[21]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[22]) << 16; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[23]) << 24; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[24]) << 32; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[25]) << 40; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[26]) << 48; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffffffffffffff);                       // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);                // Unsigned value

    if ((output > static_cast<double>(7.20575940379279e+16)) || (output < static_cast<double>(0))) // check for boundary
    {
        output = static_cast<double>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double VIC_VEH_DRV_Interface::getper_AccelPedalPostion() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[5]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x3fff);                               // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);              // Unsigned value

    output = output * static_cast<double>(0.01); // output * scale_factor

    if ((output > static_cast<double>(100)) || (output < static_cast<double>(0))) // check for boundary
    {
        output = static_cast<double>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double VIC_VEH_DRV_Interface::getper_BrakePedalPosition() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x3fff);                               // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);              // Unsigned value

    output = output * static_cast<double>(0.01); // output * scale_factor

    if ((output > static_cast<double>(100)) || (output < static_cast<double>(0))) // check for boundary
    {
        output = static_cast<double>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double VIC_VEH_DRV_Interface::getsts_AuthSwitch() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x3);                             // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);         // Unsigned value

    if ((output > static_cast<double>(2)) || (output < static_cast<double>(0))) // check for boundary
    {
        output = static_cast<double>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Neutral Position
    //  1 --> ASD Authentication
    //  2 --> AD Authentication
    //  3 --> SNA
    return output;
}

double VIC_VEH_DRV_Interface::getsts_BdyInf_Mode() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[13]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x80);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Manual Mode
    //  1 --> Auto Mode
    return output;
}

double VIC_VEH_DRV_Interface::getsts_BrkInf_Mode() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[14]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x3);                              // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);    // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Manual Mode
    //  1 --> Auto Safety Driver Mode
    //  2 --> Auto Driverless
    //  3 --> Reserved
    return output;
}

double VIC_VEH_DRV_Interface::getsts_IgnitionPosition() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x70);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Lock
    //  1 --> Off_Accessory
    //  2 --> Run
    //  3 --> Start
    //  7 --> SNA
    return output;
}

double VIC_VEH_DRV_Interface::getsts_PpsInf_Mode() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[14]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Manual Mode
    //  1 --> Auto Safety Driver Mode
    //  2 --> Auto Driverless
    //  3 --> Reserved
    return output;
}

double VIC_VEH_DRV_Interface::getsts_SWRC_CrsSw() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x70);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Idle Position
    //  1 --> Plus/Set
    //  2 --> Minus/Set
    //  3 --> Time gap (Distance, SCC only)
    //  4 --> Pause/Resume
    //  5 --> Touch
    //  6 --> Reserved
    //  7 --> Reserved
    return output;
}

double VIC_VEH_DRV_Interface::getsts_SteerInf_Mode() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[14]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x30);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Manual Mode
    //  1 --> Auto Safety Driver Mode
    //  2 --> Auto Driverless
    //  3 --> Reserved
    return output;
}

double VIC_VEH_DRV_Interface::getsts_VIC1ModeManager() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[11]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x1f);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);    // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  31 --> SNA
    //  13 --> AD-Degraded Parked
    //  12 --> ASD-Degraded Parked
    //  11 --> AD-Stopping
    //  10 --> ASD-Stopping
    //  9 --> AD-Drive
    //  8 --> ASD-Drive
    //  7 --> AD-Park
    //  0 --> ShutOff
    //  1 --> Initialization
    //  2 --> PrepManual
    //  3 --> Manual
    //  4 --> PrepASD
    //  5 --> PrepAD
    //  6 --> ASD-Park
    return output;
}

double VIC_VEH_DRV_Interface::getsts_VIC1_ECUState() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[11]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xe0);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> NotSet
    //  1 --> Nominal
    //  2 --> Faulted
    //  3 --> Reboot
    //  4 --> Power Down
    //  5 --> Reserved
    //  6 --> Reserved
    //  7 --> Reserved
    return output;
}

double VIC_VEH_DRV_Interface::getsts_VIC_StopAction() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[15]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x6);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No Stop Action
    //  1 --> SSA_1
    //  2 --> SSA_2
    //  3 --> Reserved
    return output;
}

int64_t VIC_VEH_DRV_Interface::setALIV_VEH_DRV_Interface(const double value) noexcept
{
    if ((value > static_cast<double>(255)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[2] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[2] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setAUTH_VEH_DRV_Interface(const double value) noexcept
{
    if ((value > static_cast<double>(1099511627775)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[27] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[27] |= static_cast<uint8_t>((bitBuffer) & (0xff));       // push in new data
    canPacket_.data[28] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[28] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff));  // push in new data
    canPacket_.data[29] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[29] |= static_cast<uint8_t>((bitBuffer >> 16) & (0xff)); // push in new data
    canPacket_.data[30] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[30] |= static_cast<uint8_t>((bitBuffer >> 24) & (0xff)); // push in new data
    canPacket_.data[31] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[31] |= static_cast<uint8_t>((bitBuffer >> 32) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_AD_Transition(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[10] &= static_cast<uint8_t>(~0x4);                     // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer << 2) & (0x4)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_AEB_Nominal(const double value) noexcept
{
    if ((value > static_cast<double>(1)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 1
    //  1 --> 0
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_ASD_Transition(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[10] &= static_cast<uint8_t>(~0x8);                     // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer << 3) & (0x8)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_AVHealth_Nominal(const double value) noexcept
{
    if ((value > static_cast<double>(1)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[10] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0
    //  1 --> 1
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_AV_PwrState_Ready(const double value) noexcept
{
    if ((value > static_cast<double>(1)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[10] &= static_cast<uint8_t>(~0x40);                     // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer << 6) & (0x40)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0
    //  1 --> 1
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_AllDoors_Closed(const double value) noexcept
{
    if ((value > static_cast<double>(1)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[8] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 1
    //  1 --> 1
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_AllDoors_Locked(const double value) noexcept
{
    if ((value > static_cast<double>(1)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[9] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0
    //  1 --> 1
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_AutoButton(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0x3);                // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer) & (0x3)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Not Pressed
    //  1 --> Pressed
    //  3 --> SNA
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_BrakeOverride(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0xc);                     // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer << 2) & (0xc)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No
    //  1 --> Yes
    //  3 --> SNA
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_ChrgPort_Closed(const double value) noexcept
{
    if ((value > static_cast<double>(1)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[12] &= static_cast<uint8_t>(~0x1);                // clear the bits for new data
    canPacket_.data[12] |= static_cast<uint8_t>((bitBuffer) & (0x1)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 1
    //  1 --> 0
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_DvrSeatbelt_Secured(const double value) noexcept
{
    if ((value > static_cast<double>(1)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[12] &= static_cast<uint8_t>(~0x2);                     // clear the bits for new data
    canPacket_.data[12] |= static_cast<uint8_t>((bitBuffer << 1) & (0x2)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 1
    //  1 --> 0
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_ECUState_Nominal(const double value) noexcept
{
    if ((value > static_cast<double>(1)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[12] &= static_cast<uint8_t>(~0x4);                     // clear the bits for new data
    canPacket_.data[12] |= static_cast<uint8_t>((bitBuffer << 2) & (0x4)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 1
    //  1 --> 0
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_EPB(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[10] &= static_cast<uint8_t>(~0x20);                     // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer << 5) & (0x20)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_EPB_Applied(const double value) noexcept
{
    if ((value > static_cast<double>(1)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[12] &= static_cast<uint8_t>(~0x10);                     // clear the bits for new data
    canPacket_.data[12] |= static_cast<uint8_t>((bitBuffer << 4) & (0x10)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0
    //  1 --> 1
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_EPB_Released(const double value) noexcept
{
    if ((value > static_cast<double>(1)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[12] &= static_cast<uint8_t>(~0x20);                     // clear the bits for new data
    canPacket_.data[12] |= static_cast<uint8_t>((bitBuffer << 5) & (0x20)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0
    //  1 --> 1
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_EV_Driverable(const double value) noexcept
{
    if ((value > static_cast<double>(1)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[12] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[12] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 1
    //  1 --> 0
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_EnableButton(const double value) noexcept
{
    if ((value > static_cast<double>(1)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[9] &= static_cast<uint8_t>(~0xc);                     // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer << 2) & (0xc)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Not Pressed
    //  1 --> Pressed
    //  3 --> SNA
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_EngageBtn_Press(const double value) noexcept
{
    if ((value > static_cast<double>(1)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[12] &= static_cast<uint8_t>(~0x8);                     // clear the bits for new data
    canPacket_.data[12] |= static_cast<uint8_t>((bitBuffer << 3) & (0x8)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0
    //  1 --> 1
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_EngageButton(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[6] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Not Pressed
    //  1 --> Pressed
    //  3 --> SNA
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_Estopbtn_Press(const double value) noexcept
{
    if ((value > static_cast<double>(1)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[12] &= static_cast<uint8_t>(~0x40);                     // clear the bits for new data
    canPacket_.data[12] |= static_cast<uint8_t>((bitBuffer << 6) & (0x40)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0
    //  1 --> 1
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_GVPM_IMU_Nominal(const double value) noexcept
{
    if ((value > static_cast<double>(1)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[13] &= static_cast<uint8_t>(~0x1);                // clear the bits for new data
    canPacket_.data[13] |= static_cast<uint8_t>((bitBuffer) & (0x1)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 1
    //  1 --> 1
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_HoldManual(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[10] &= static_cast<uint8_t>(~0x2);                     // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer << 1) & (0x2)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_LoggingButton(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0x30);                     // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer << 4) & (0x30)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Not Pressed
    //  1 --> Pressed
    //  3 --> SNA
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_ManualTakeover(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[10] &= static_cast<uint8_t>(~0x1);                // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer) & (0x1)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_Other_ECUstate_Nominal(const double value) noexcept
{
    if ((value > static_cast<double>(1)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[13] &= static_cast<uint8_t>(~0x2);                     // clear the bits for new data
    canPacket_.data[13] |= static_cast<uint8_t>((bitBuffer << 1) & (0x2)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 1
    //  1 --> 1
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_ParkingBrake(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_SSA_NotPresent(const double value) noexcept
{
    if ((value > static_cast<double>(1)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[13] &= static_cast<uint8_t>(~0x4);                     // clear the bits for new data
    canPacket_.data[13] |= static_cast<uint8_t>((bitBuffer << 2) & (0x4)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 1
    //  1 --> 0
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_Seatbelt(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[8] &= static_cast<uint8_t>(~0x40);                     // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer << 6) & (0x40)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_SteerOverride(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0x3);                // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer) & (0x3)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No
    //  1 --> Yes
    //  3 --> SNA
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_ThrottleOverride(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0xc);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer << 2) & (0xc)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No
    //  1 --> Yes
    //  3 --> SNA
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_TransitPark(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[10] &= static_cast<uint8_t>(~0x10);                     // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer << 4) & (0x10)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_Trns_In_Drive(const double value) noexcept
{
    if ((value > static_cast<double>(1)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[13] &= static_cast<uint8_t>(~0x8);                     // clear the bits for new data
    canPacket_.data[13] |= static_cast<uint8_t>((bitBuffer << 3) & (0x8)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0
    //  1 --> 1
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_Trns_In_Park(const double value) noexcept
{
    if ((value > static_cast<double>(1)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[13] &= static_cast<uint8_t>(~0x10);                     // clear the bits for new data
    canPacket_.data[13] |= static_cast<uint8_t>((bitBuffer << 4) & (0x10)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0
    //  1 --> 1
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_TrunkHood_Closed(const double value) noexcept
{
    if ((value > static_cast<double>(1)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[13] &= static_cast<uint8_t>(~0x20);                     // clear the bits for new data
    canPacket_.data[13] |= static_cast<uint8_t>((bitBuffer << 5) & (0x20)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0
    //  1 --> 1
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_Zero_Veh_Vel(const double value) noexcept
{
    if ((value > static_cast<double>(1)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[13] &= static_cast<uint8_t>(~0x40);                     // clear the bits for new data
    canPacket_.data[13] |= static_cast<uint8_t>((bitBuffer << 6) & (0x40)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> 0
    //  1 --> 1
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setCRC_VEH_DRV_Interface(const double value) noexcept
{
    if ((value > static_cast<double>(65535)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[0] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[0] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[1] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[1] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setFV_VEH_DRV_Interface(const double value) noexcept
{
    if ((value > static_cast<double>(7.20575940379279e+16)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[20] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[20] |= static_cast<uint8_t>((bitBuffer) & (0xff));       // push in new data
    canPacket_.data[21] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[21] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff));  // push in new data
    canPacket_.data[22] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[22] |= static_cast<uint8_t>((bitBuffer >> 16) & (0xff)); // push in new data
    canPacket_.data[23] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[23] |= static_cast<uint8_t>((bitBuffer >> 24) & (0xff)); // push in new data
    canPacket_.data[24] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[24] |= static_cast<uint8_t>((bitBuffer >> 32) & (0xff)); // push in new data
    canPacket_.data[25] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[25] |= static_cast<uint8_t>((bitBuffer >> 40) & (0xff)); // push in new data
    canPacket_.data[26] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[26] |= static_cast<uint8_t>((bitBuffer >> 48) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setper_AccelPedalPostion(const double value) noexcept
{
    if ((value > static_cast<double>(100)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value / static_cast<double>(0.01)); // value / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[5] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[5] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[6] &= static_cast<uint8_t>(~0x3f);                     // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer >> 8) & (0x3f)); // push in new data
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setper_BrakePedalPosition(const double value) noexcept
{
    if ((value > static_cast<double>(100)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value / static_cast<double>(0.01)); // value / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[7] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[8] &= static_cast<uint8_t>(~0x3f);                     // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer >> 8) & (0x3f)); // push in new data
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setsts_AuthSwitch(const double value) noexcept
{
    if ((value > static_cast<double>(2)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[9] &= static_cast<uint8_t>(~0x3);                // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer) & (0x3)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Neutral Position
    //  1 --> ASD Authentication
    //  2 --> AD Authentication
    //  3 --> SNA
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setsts_BdyInf_Mode(const double value) noexcept
{
    if ((value > static_cast<double>(1)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[13] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[13] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Manual Mode
    //  1 --> Auto Mode
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setsts_BrkInf_Mode(const double value) noexcept
{
    if ((value > static_cast<double>(3)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[14] &= static_cast<uint8_t>(~0x3);                // clear the bits for new data
    canPacket_.data[14] |= static_cast<uint8_t>((bitBuffer) & (0x3)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Manual Mode
    //  1 --> Auto Safety Driver Mode
    //  2 --> Auto Driverless
    //  3 --> Reserved
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setsts_IgnitionPosition(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0x70);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer << 4) & (0x70)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Lock
    //  1 --> Off_Accessory
    //  2 --> Run
    //  3 --> Start
    //  7 --> SNA
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setsts_PpsInf_Mode(const double value) noexcept
{
    if ((value > static_cast<double>(3)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[14] &= static_cast<uint8_t>(~0xc);                     // clear the bits for new data
    canPacket_.data[14] |= static_cast<uint8_t>((bitBuffer << 2) & (0xc)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Manual Mode
    //  1 --> Auto Safety Driver Mode
    //  2 --> Auto Driverless
    //  3 --> Reserved
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setsts_SWRC_CrsSw(const double value) noexcept
{
    if ((value > static_cast<double>(7)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[9] &= static_cast<uint8_t>(~0x70);                     // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer << 4) & (0x70)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Idle Position
    //  1 --> Plus/Set
    //  2 --> Minus/Set
    //  3 --> Time gap (Distance, SCC only)
    //  4 --> Pause/Resume
    //  5 --> Touch
    //  6 --> Reserved
    //  7 --> Reserved
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setsts_SteerInf_Mode(const double value) noexcept
{
    if ((value > static_cast<double>(3)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[14] &= static_cast<uint8_t>(~0x30);                     // clear the bits for new data
    canPacket_.data[14] |= static_cast<uint8_t>((bitBuffer << 4) & (0x30)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Manual Mode
    //  1 --> Auto Safety Driver Mode
    //  2 --> Auto Driverless
    //  3 --> Reserved
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setsts_VIC1ModeManager(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[11] &= static_cast<uint8_t>(~0x1f);                // clear the bits for new data
    canPacket_.data[11] |= static_cast<uint8_t>((bitBuffer) & (0x1f)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  31 --> SNA
    //  13 --> AD-Degraded Parked
    //  12 --> ASD-Degraded Parked
    //  11 --> AD-Stopping
    //  10 --> ASD-Stopping
    //  9 --> AD-Drive
    //  8 --> ASD-Drive
    //  7 --> AD-Park
    //  0 --> ShutOff
    //  1 --> Initialization
    //  2 --> PrepManual
    //  3 --> Manual
    //  4 --> PrepASD
    //  5 --> PrepAD
    //  6 --> ASD-Park
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setsts_VIC1_ECUState(const double value) noexcept
{
    if ((value > static_cast<double>(7)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[11] &= static_cast<uint8_t>(~0xe0);                     // clear the bits for new data
    canPacket_.data[11] |= static_cast<uint8_t>((bitBuffer << 5) & (0xe0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> NotSet
    //  1 --> Nominal
    //  2 --> Faulted
    //  3 --> Reboot
    //  4 --> Power Down
    //  5 --> Reserved
    //  6 --> Reserved
    //  7 --> Reserved
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setsts_VIC_StopAction(const double value) noexcept
{
    if ((value > static_cast<double>(3)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[15] &= static_cast<uint8_t>(~0x6);                     // clear the bits for new data
    canPacket_.data[15] |= static_cast<uint8_t>((bitBuffer << 1) & (0x6)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No Stop Action
    //  1 --> SSA_1
    //  2 --> SSA_2
    //  3 --> Reserved
    return 0;
}
