/**
 * \copyright
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Aptiv and its suppliers, if any.
 * The intellectual and technical concepts contained herein are proprietary to Aptiv and its suppliers and may be
 * covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material is strictly forbidden unless prior written
 * permission is obtained from Aptiv.
 *
 * \brief This is a brief (1-line) description of the file.
 *
 * This file is generated with dbc2cpp script version : 3.1.0
 *
 * This file was generated from the following DBC file: /home/scotty/Downloads/Gen2_AVT_B_Control_CAN1.dbc
 *
 */

#include "VehicleCANLibrary/g2h/tcar/AV_MRMCommand.h"
#include <algorithm>
#include <string.h>

using namespace av::can::g2h::tcar;

AV_MRMCommand::AV_MRMCommand(const uint32_t id)
{
    canPacket_.id = id;
    canPacket_.length = AV_MRMCommand_CONSTS::AV_MRMCOMMAND_PACKET_LEN;
}

AV_MRMCommand::AV_MRMCommand(const uint32_t id, uint8_t* const payload, const uint8_t size)
{
    canPacket_.id = id;

    if ((size <= sizeof(canPacket_.data)) && payload) {
        canPacket_.length = size;
        std::copy_n(payload, size, canPacket_.data);
    }
}

const CanFdPacket& AV_MRMCommand::getCanPacket() const
{
    return canPacket_;
}

double AV_MRMCommand::getALIV_FaultCode() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[2]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    return output;
}

double AV_MRMCommand::getCRC_FaultCode() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[0]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[1]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffff);                               // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);        // Unsigned value

    return output;
}

double AV_MRMCommand::getMAC_FaultCode() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[24]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[25]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[26]) << 16; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[27]) << 24; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[28]) << 32; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[29]) << 40; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[30]) << 48; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[31]) << 56; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffffffffffffffff);                     // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);          // Unsigned value

    return output;
}

double AV_MRMCommand::getMRM_Type() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x1e);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  11 --> VSA2
    //  10 --> VSA1
    //  9 --> IMA2
    //  8 --> IMA1
    //  7 --> ASA5
    //  6 --> ASA4
    //  5 --> ASA3
    //  4 --> ASA2
    //  3 --> ASA1
    //  2 --> SSA2
    //  1 --> SSA1
    //  0 --> No Reaction
    return output;
}

double AV_MRMCommand::gett_MRMCommand_dec() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]) << 16; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1ffff);                               // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);               // Unsigned value

    output = output * static_cast<double>(10); // output * scale_factor

    if ((output > static_cast<double>(999990)) || (output < static_cast<double>(0))) // check for boundary
    {
        output = static_cast<double>(AV_MRMCommand_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_MRMCommand::gett_MRMCommand_int() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[5]) << 16; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]) << 24; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffffffff);                            // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);               // Unsigned value

    output = output + static_cast<double>(1607460325); // output + bias

    if ((output > static_cast<double>(4765132799)) || (output < static_cast<double>(1607460325))) // check for boundary
    {
        output = static_cast<double>(AV_MRMCommand_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

int64_t AV_MRMCommand::setALIV_FaultCode(const double value) noexcept
{
    if ((value > static_cast<double>(255)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_MRMCommand_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[2] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[2] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    return 0;
}

int64_t AV_MRMCommand::setCRC_FaultCode(const double value) noexcept
{
    if ((value > static_cast<double>(65535)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_MRMCommand_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[0] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[0] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[1] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[1] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff)); // push in new data
    return 0;
}

int64_t AV_MRMCommand::setMAC_FaultCode(const double value) noexcept
{
    if ((value > static_cast<double>(1.84467440737096e+19)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_MRMCommand_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[24] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[24] |= static_cast<uint8_t>((bitBuffer) & (0xff));       // push in new data
    canPacket_.data[25] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[25] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff));  // push in new data
    canPacket_.data[26] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[26] |= static_cast<uint8_t>((bitBuffer >> 16) & (0xff)); // push in new data
    canPacket_.data[27] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[27] |= static_cast<uint8_t>((bitBuffer >> 24) & (0xff)); // push in new data
    canPacket_.data[28] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[28] |= static_cast<uint8_t>((bitBuffer >> 32) & (0xff)); // push in new data
    canPacket_.data[29] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[29] |= static_cast<uint8_t>((bitBuffer >> 40) & (0xff)); // push in new data
    canPacket_.data[30] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[30] |= static_cast<uint8_t>((bitBuffer >> 48) & (0xff)); // push in new data
    canPacket_.data[31] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[31] |= static_cast<uint8_t>((bitBuffer >> 56) & (0xff)); // push in new data
    return 0;
}

int64_t AV_MRMCommand::setMRM_Type(const double value) noexcept
{
    if ((value > static_cast<double>(15)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_MRMCommand_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[9] &= static_cast<uint8_t>(~0x1e);                     // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer << 1) & (0x1e)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  11 --> VSA2
    //  10 --> VSA1
    //  9 --> IMA2
    //  8 --> IMA1
    //  7 --> ASA5
    //  6 --> ASA4
    //  5 --> ASA3
    //  4 --> ASA2
    //  3 --> ASA1
    //  2 --> SSA2
    //  1 --> SSA1
    //  0 --> No Reaction
    return 0;
}

int64_t AV_MRMCommand::sett_MRMCommand_dec(const double value) noexcept
{
    if ((value > static_cast<double>(999990)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_MRMCommand_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value / static_cast<double>(10)); // value / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[7] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[8] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff)); // push in new data
    canPacket_.data[9] &= static_cast<uint8_t>(~0x1);                      // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer >> 16) & (0x1)); // push in new data
    return 0;
}

int64_t AV_MRMCommand::sett_MRMCommand_int(const double value) noexcept
{
    if ((value > static_cast<double>(4765132799)) ||
        (value < static_cast<double>(1607460325))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_MRMCommand_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value) - static_cast<int64_t>(1607460325); // value - bias

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer) & (0xff));       // push in new data
    canPacket_.data[4] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff));  // push in new data
    canPacket_.data[5] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[5] |= static_cast<uint8_t>((bitBuffer >> 16) & (0xff)); // push in new data
    canPacket_.data[6] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer >> 24) & (0xff)); // push in new data
    return 0;
}
