/**
 * \copyright
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Aptiv and its suppliers, if any.
 * The intellectual and technical concepts contained herein are proprietary to Aptiv and its suppliers and may be
 * covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material is strictly forbidden unless prior written
 * permission is obtained from Aptiv.
 *
 * \brief This is a brief (1-line) description of the file.
 *
 * This file is generated with dbc2cpp script version : 3.1.0
 *
 * This file was generated from the following DBC file:
 * /home/lixun/Workspace/gen2-avt-sample-a/Gen2_AVT_A_Control_CAN1.dbc
 *
 */

#include "VehicleCANLibrary/g2h/tcar/AV_System_Status.h"
#include <algorithm>
#include <string.h>

using namespace av::can::g2h::tcar;

AV_System_Status::AV_System_Status(const uint32_t id)
{
    canPacket_.id = id;
    canPacket_.length = AV_System_Status_CONSTS::AV_SYSTEM_STATUS_PACKET_LEN;
}

AV_System_Status::AV_System_Status(const uint32_t id, uint8_t* const payload, const uint8_t size)
{
    canPacket_.id = id;

    if ((size <= sizeof(canPacket_.data)) && payload) {
        canPacket_.length = size;
        std::copy_n(payload, size, canPacket_.data);
    }
}

const CanFdPacket& AV_System_Status::getCanPacket() const
{
    return canPacket_;
}

double AV_System_Status::getALIV_AV_System_Status() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[2]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    return output;
}

double AV_System_Status::getB_PropulsionDirection() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x3);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Negative X Direction
    //  1 --> Positive X Direction
    //  3 --> SNA
    return output;
}

double AV_System_Status::getCRC_AV_System_Status() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[0]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[1]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffff);                               // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);        // Unsigned value

    return output;
}

double AV_System_Status::getMAC_AV_System_Status() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[24]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[25]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[26]) << 16; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[27]) << 24; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[28]) << 32; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[29]) << 40; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[30]) << 48; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[31]) << 56; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffffffffffffffff);                     // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);          // Unsigned value

    return output;
}

double AV_System_Status::getsts_AVState() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x1c);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Not Ready
    //  1 --> Ready
    //  2 --> Active
    //  7 --> SNA
    return output;
}

double AV_System_Status::getsts_HealthState() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xe0);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  7 --> SNA
    //  3 --> Faulted
    //  2 --> Degraded
    //  1 --> Nominal
    //  0 --> Init
    return output;
}

int64_t AV_System_Status::setALIV_AV_System_Status(const double value) noexcept
{
    if ((value > static_cast<double>(255)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_System_Status_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[2] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[2] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    return 0;
}

int64_t AV_System_Status::setB_PropulsionDirection(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0x3);                // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer) & (0x3)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Negative X Direction
    //  1 --> Positive X Direction
    //  3 --> SNA
    return 0;
}

int64_t AV_System_Status::setCRC_AV_System_Status(const double value) noexcept
{
    if ((value > static_cast<double>(65535)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_System_Status_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[0] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[0] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[1] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[1] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff)); // push in new data
    return 0;
}

int64_t AV_System_Status::setMAC_AV_System_Status(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[24] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[24] |= static_cast<uint8_t>((bitBuffer) & (0xff));       // push in new data
    canPacket_.data[25] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[25] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff));  // push in new data
    canPacket_.data[26] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[26] |= static_cast<uint8_t>((bitBuffer >> 16) & (0xff)); // push in new data
    canPacket_.data[27] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[27] |= static_cast<uint8_t>((bitBuffer >> 24) & (0xff)); // push in new data
    canPacket_.data[28] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[28] |= static_cast<uint8_t>((bitBuffer >> 32) & (0xff)); // push in new data
    canPacket_.data[29] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[29] |= static_cast<uint8_t>((bitBuffer >> 40) & (0xff)); // push in new data
    canPacket_.data[30] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[30] |= static_cast<uint8_t>((bitBuffer >> 48) & (0xff)); // push in new data
    canPacket_.data[31] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[31] |= static_cast<uint8_t>((bitBuffer >> 56) & (0xff)); // push in new data
    return 0;
}

int64_t AV_System_Status::setsts_AVState(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0x1c);                     // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer << 2) & (0x1c)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Not Ready
    //  1 --> Ready
    //  2 --> Active
    //  7 --> SNA
    return 0;
}

int64_t AV_System_Status::setsts_HealthState(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0xe0);                     // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer << 5) & (0xe0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  7 --> SNA
    //  3 --> Faulted
    //  2 --> Degraded
    //  1 --> Nominal
    //  0 --> Init
    return 0;
}
