/**
 * \copyright
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Aptiv and its suppliers, if any.
 * The intellectual and technical concepts contained herein are proprietary to Aptiv and its suppliers and may be
 * covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material is strictly forbidden unless prior written
 * permission is obtained from Aptiv.
 *
 * \brief This is a brief (1-line) description of the file.
 *
 * This file is generated with dbc2cpp script version : 3.1.0
 *
 * This file was generated from the following DBC file:
 * /home/lixun/Workspace/gen2-avt-sample-a/Gen2_AVT_A_Control_CAN1.dbc
 *
 */

#include "VehicleCANLibrary/g2h/tcar/AV_Waypoint_Speeds_A_3.h"
#include <algorithm>
#include <string.h>

using namespace av::can::g2h::tcar;

AV_Waypoint_Speeds_A_3::AV_Waypoint_Speeds_A_3(const uint32_t id)
{
    canPacket_.id = id;
    canPacket_.length = AV_Waypoint_Speeds_A_3_CONSTS::AV_WAYPOINT_SPEEDS_A_3_PACKET_LEN;
}

AV_Waypoint_Speeds_A_3::AV_Waypoint_Speeds_A_3(const uint32_t id, uint8_t* const payload, const uint8_t size)
{
    canPacket_.id = id;

    if ((size <= sizeof(canPacket_.data)) && payload) {
        canPacket_.length = size;
        std::copy_n(payload, size, canPacket_.data);
    }
}

const CanFdPacket& AV_Waypoint_Speeds_A_3::getCanPacket() const
{
    return canPacket_;
}

double AV_Waypoint_Speeds_A_3::getALIV_AV_Waypoint_Speeds_A_3() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[2]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    return output;
}

double AV_Waypoint_Speeds_A_3::getCRC_AV_Waypoint_Speeds_A_3() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[0]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[1]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffff);                               // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);        // Unsigned value

    return output;
}

double AV_Waypoint_Speeds_A_3::getv_WaypointSpeed_A_35() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff);                                // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);              // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Waypoint_Speeds_A_3::getv_WaypointSpeed_A_36() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[5]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff0);                               // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                                  // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Waypoint_Speeds_A_3::getv_WaypointSpeed_A_37() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff);                                // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);              // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Waypoint_Speeds_A_3::getv_WaypointSpeed_A_38() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff0);                               // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                                  // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Waypoint_Speeds_A_3::getv_WaypointSpeed_A_39() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff);                                 // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);               // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Waypoint_Speeds_A_3::getv_WaypointSpeed_A_40() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[11]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff0);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Waypoint_Speeds_A_3::getv_WaypointSpeed_A_41() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[12]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[13]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff);                                 // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);               // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Waypoint_Speeds_A_3::getv_WaypointSpeed_A_42() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[13]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[14]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff0);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Waypoint_Speeds_A_3::getv_WaypointSpeed_A_43() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[15]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[16]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff);                                 // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);               // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Waypoint_Speeds_A_3::getv_WaypointSpeed_A_44() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[16]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[17]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff0);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Waypoint_Speeds_A_3::getv_WaypointSpeed_A_45() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[18]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[19]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff);                                 // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);               // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Waypoint_Speeds_A_3::getv_WaypointSpeed_A_46() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[19]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[20]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff0);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Waypoint_Speeds_A_3::getv_WaypointSpeed_A_47() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[21]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[22]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff);                                 // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);               // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Waypoint_Speeds_A_3::getv_WaypointSpeed_A_48() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[22]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[23]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff0);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Waypoint_Speeds_A_3::getv_WaypointSpeed_A_49() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[24]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[25]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff);                                 // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);               // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Waypoint_Speeds_A_3::getv_WaypointSpeed_A_50() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[25]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[26]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff0);                                // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double AV_Waypoint_Speeds_A_3::getv_WaypointSpeed_A_51() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[27]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[28]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xfff);                                 // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);               // Unsigned value

    output = (output * static_cast<double>(0.02)) + static_cast<double>(-22); // (output * scale_factor) + bias

    if ((output > static_cast<double>(22)) || (output < static_cast<double>(-22))) // check for boundary
    {
        output = static_cast<double>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

int64_t AV_Waypoint_Speeds_A_3::setALIV_AV_Waypoint_Speeds_A_3(const double value) noexcept
{
    if ((value > static_cast<double>(255)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[2] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[2] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    return 0;
}

int64_t AV_Waypoint_Speeds_A_3::setCRC_AV_Waypoint_Speeds_A_3(const double value) noexcept
{
    if ((value > static_cast<double>(65535)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[0] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[0] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[1] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[1] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff)); // push in new data
    return 0;
}

int64_t AV_Waypoint_Speeds_A_3::setv_WaypointSpeed_A_35(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0xff);                    // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer) & (0xff));     // push in new data
    canPacket_.data[4] &= static_cast<uint8_t>(~0xf);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xf)); // push in new data
    return 0;
}

int64_t AV_Waypoint_Speeds_A_3::setv_WaypointSpeed_A_36(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0xf0);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer << 4) & (0xf0)); // push in new data
    canPacket_.data[5] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[5] |= static_cast<uint8_t>((bitBuffer >> 4) & (0xff)); // push in new data
    return 0;
}

int64_t AV_Waypoint_Speeds_A_3::setv_WaypointSpeed_A_37(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[6] &= static_cast<uint8_t>(~0xff);                    // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer) & (0xff));     // push in new data
    canPacket_.data[7] &= static_cast<uint8_t>(~0xf);                     // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xf)); // push in new data
    return 0;
}

int64_t AV_Waypoint_Speeds_A_3::setv_WaypointSpeed_A_38(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[7] &= static_cast<uint8_t>(~0xf0);                     // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer << 4) & (0xf0)); // push in new data
    canPacket_.data[8] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer >> 4) & (0xff)); // push in new data
    return 0;
}

int64_t AV_Waypoint_Speeds_A_3::setv_WaypointSpeed_A_39(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[9] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[10] &= static_cast<uint8_t>(~0xf);                     // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xf)); // push in new data
    return 0;
}

int64_t AV_Waypoint_Speeds_A_3::setv_WaypointSpeed_A_40(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[10] &= static_cast<uint8_t>(~0xf0);                     // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer << 4) & (0xf0)); // push in new data
    canPacket_.data[11] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[11] |= static_cast<uint8_t>((bitBuffer >> 4) & (0xff)); // push in new data
    return 0;
}

int64_t AV_Waypoint_Speeds_A_3::setv_WaypointSpeed_A_41(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[12] &= static_cast<uint8_t>(~0xff);                    // clear the bits for new data
    canPacket_.data[12] |= static_cast<uint8_t>((bitBuffer) & (0xff));     // push in new data
    canPacket_.data[13] &= static_cast<uint8_t>(~0xf);                     // clear the bits for new data
    canPacket_.data[13] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xf)); // push in new data
    return 0;
}

int64_t AV_Waypoint_Speeds_A_3::setv_WaypointSpeed_A_42(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[13] &= static_cast<uint8_t>(~0xf0);                     // clear the bits for new data
    canPacket_.data[13] |= static_cast<uint8_t>((bitBuffer << 4) & (0xf0)); // push in new data
    canPacket_.data[14] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[14] |= static_cast<uint8_t>((bitBuffer >> 4) & (0xff)); // push in new data
    return 0;
}

int64_t AV_Waypoint_Speeds_A_3::setv_WaypointSpeed_A_43(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[15] &= static_cast<uint8_t>(~0xff);                    // clear the bits for new data
    canPacket_.data[15] |= static_cast<uint8_t>((bitBuffer) & (0xff));     // push in new data
    canPacket_.data[16] &= static_cast<uint8_t>(~0xf);                     // clear the bits for new data
    canPacket_.data[16] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xf)); // push in new data
    return 0;
}

int64_t AV_Waypoint_Speeds_A_3::setv_WaypointSpeed_A_44(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[16] &= static_cast<uint8_t>(~0xf0);                     // clear the bits for new data
    canPacket_.data[16] |= static_cast<uint8_t>((bitBuffer << 4) & (0xf0)); // push in new data
    canPacket_.data[17] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[17] |= static_cast<uint8_t>((bitBuffer >> 4) & (0xff)); // push in new data
    return 0;
}

int64_t AV_Waypoint_Speeds_A_3::setv_WaypointSpeed_A_45(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[18] &= static_cast<uint8_t>(~0xff);                    // clear the bits for new data
    canPacket_.data[18] |= static_cast<uint8_t>((bitBuffer) & (0xff));     // push in new data
    canPacket_.data[19] &= static_cast<uint8_t>(~0xf);                     // clear the bits for new data
    canPacket_.data[19] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xf)); // push in new data
    return 0;
}

int64_t AV_Waypoint_Speeds_A_3::setv_WaypointSpeed_A_46(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[19] &= static_cast<uint8_t>(~0xf0);                     // clear the bits for new data
    canPacket_.data[19] |= static_cast<uint8_t>((bitBuffer << 4) & (0xf0)); // push in new data
    canPacket_.data[20] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[20] |= static_cast<uint8_t>((bitBuffer >> 4) & (0xff)); // push in new data
    return 0;
}

int64_t AV_Waypoint_Speeds_A_3::setv_WaypointSpeed_A_47(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[21] &= static_cast<uint8_t>(~0xff);                    // clear the bits for new data
    canPacket_.data[21] |= static_cast<uint8_t>((bitBuffer) & (0xff));     // push in new data
    canPacket_.data[22] &= static_cast<uint8_t>(~0xf);                     // clear the bits for new data
    canPacket_.data[22] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xf)); // push in new data
    return 0;
}

int64_t AV_Waypoint_Speeds_A_3::setv_WaypointSpeed_A_48(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[22] &= static_cast<uint8_t>(~0xf0);                     // clear the bits for new data
    canPacket_.data[22] |= static_cast<uint8_t>((bitBuffer << 4) & (0xf0)); // push in new data
    canPacket_.data[23] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[23] |= static_cast<uint8_t>((bitBuffer >> 4) & (0xff)); // push in new data
    return 0;
}

int64_t AV_Waypoint_Speeds_A_3::setv_WaypointSpeed_A_49(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[24] &= static_cast<uint8_t>(~0xff);                    // clear the bits for new data
    canPacket_.data[24] |= static_cast<uint8_t>((bitBuffer) & (0xff));     // push in new data
    canPacket_.data[25] &= static_cast<uint8_t>(~0xf);                     // clear the bits for new data
    canPacket_.data[25] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xf)); // push in new data
    return 0;
}

int64_t AV_Waypoint_Speeds_A_3::setv_WaypointSpeed_A_50(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[25] &= static_cast<uint8_t>(~0xf0);                     // clear the bits for new data
    canPacket_.data[25] |= static_cast<uint8_t>((bitBuffer << 4) & (0xf0)); // push in new data
    canPacket_.data[26] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[26] |= static_cast<uint8_t>((bitBuffer >> 4) & (0xff)); // push in new data
    return 0;
}

int64_t AV_Waypoint_Speeds_A_3::setv_WaypointSpeed_A_51(const double value) noexcept
{
    if ((value > static_cast<double>(22)) ||
        (value < static_cast<double>(-22))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(AV_Waypoint_Speeds_A_3_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-22)) /
                                                  static_cast<double>(0.02)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[27] &= static_cast<uint8_t>(~0xff);                    // clear the bits for new data
    canPacket_.data[27] |= static_cast<uint8_t>((bitBuffer) & (0xff));     // push in new data
    canPacket_.data[28] &= static_cast<uint8_t>(~0xf);                     // clear the bits for new data
    canPacket_.data[28] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xf)); // push in new data
    return 0;
}
