/**
 * \copyright
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Aptiv and its suppliers, if any.
 * The intellectual and technical concepts contained herein are proprietary to Aptiv and its suppliers and may be
 * covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material is strictly forbidden unless prior written
 * permission is obtained from Aptiv.
 *
 * \brief This is a brief (1-line) description of the file.
 *
 * This file is generated with dbc2cpp script version : 3.1.0
 *
 * This file was generated from the following DBC file:
 * /home/sowon.lee/Works/gen2-avt-sample-a/Gen2_AVT_A_Control_CAN1.dbc
 *
 */

#include "VehicleCANLibrary/g2h/tcar/VIC_VEH_DRV_Interface.h"
#include <algorithm>
#include <string.h>

using namespace av::can::g2h::tcar;

VIC_VEH_DRV_Interface::VIC_VEH_DRV_Interface(const uint32_t id)
{
    canPacket_.id = id;
    canPacket_.length = VIC_VEH_DRV_Interface_CONSTS::VIC_VEH_DRV_INTERFACE_PACKET_LEN;
}

VIC_VEH_DRV_Interface::VIC_VEH_DRV_Interface(const uint32_t id, uint8_t* const payload, const uint8_t size)
{
    canPacket_.id = id;

    if ((size <= sizeof(canPacket_.data)) && payload) {
        canPacket_.length = size;
        std::copy_n(payload, size, canPacket_.data);
    }
}

const CanFdPacket& VIC_VEH_DRV_Interface::getCanPacket() const
{
    return canPacket_;
}

double VIC_VEH_DRV_Interface::getALIV_VEH_DRV_Interface() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[2]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    return output;
}

double VIC_VEH_DRV_Interface::getB_AD_Transition() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x4);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return output;
}

double VIC_VEH_DRV_Interface::getB_ASD_Transition() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x8);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 3;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return output;
}

double VIC_VEH_DRV_Interface::getB_AutoButton() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x3);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Not Pressed
    //  1 --> Pressed
    //  3 --> SNA
    return output;
}

double VIC_VEH_DRV_Interface::getB_BrakeOverride() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No
    //  1 --> Yes
    //  3 --> SNA
    return output;
}

double VIC_VEH_DRV_Interface::getB_EPB() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x20);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return output;
}

double VIC_VEH_DRV_Interface::getB_EnableButton() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                             // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    if ((output > static_cast<double>(1)) || (output < static_cast<double>(0))) // check for boundary
    {
        output = static_cast<double>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Not Pressed
    //  1 --> Pressed
    //  3 --> SNA
    return output;
}

double VIC_VEH_DRV_Interface::getB_EngageButton() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc0);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Not Pressed
    //  1 --> Pressed
    //  3 --> SNA
    return output;
}

double VIC_VEH_DRV_Interface::getB_HoldManual() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x2);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 1;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return output;
}

double VIC_VEH_DRV_Interface::getB_LoggingButton() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x30);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Not Pressed
    //  1 --> Pressed
    //  3 --> SNA
    return output;
}

double VIC_VEH_DRV_Interface::getB_ManualTakeover() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x1);                              // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);    // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return output;
}

double VIC_VEH_DRV_Interface::getB_ParkingBrake() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc0);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return output;
}

double VIC_VEH_DRV_Interface::getB_Seatbelt() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x40);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return output;
}

double VIC_VEH_DRV_Interface::getB_SteerOverride() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x3);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No
    //  1 --> Yes
    //  3 --> SNA
    return output;
}

double VIC_VEH_DRV_Interface::getB_ThrottleOverride() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No
    //  1 --> Yes
    //  3 --> SNA
    return output;
}

double VIC_VEH_DRV_Interface::getB_TransitPark() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x10);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                              // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return output;
}

double VIC_VEH_DRV_Interface::getCRC_VEH_DRV_Interface() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[0]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[1]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffff);                               // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);        // Unsigned value

    return output;
}

double VIC_VEH_DRV_Interface::getMAC_VEH_DRV_Interface() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[24]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[25]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[26]) << 16; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[27]) << 24; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[28]) << 32; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[29]) << 40; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[30]) << 48; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[31]) << 56; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffffffffffffffff);                     // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);          // Unsigned value

    return output;
}

double VIC_VEH_DRV_Interface::getper_AccelPedalPostion() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[5]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x3fff);                               // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);              // Unsigned value

    output = output * static_cast<double>(0.01); // output * scale_factor

    if ((output > static_cast<double>(100)) || (output < static_cast<double>(0))) // check for boundary
    {
        output = static_cast<double>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double VIC_VEH_DRV_Interface::getper_BrakePedalPosition() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x3fff);                               // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);              // Unsigned value

    output = output * static_cast<double>(0.01); // output * scale_factor

    if ((output > static_cast<double>(100)) || (output < static_cast<double>(0))) // check for boundary
    {
        output = static_cast<double>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double VIC_VEH_DRV_Interface::getsts_AuthSwitch() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x3);                             // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);         // Unsigned value

    if ((output > static_cast<double>(2)) || (output < static_cast<double>(0))) // check for boundary
    {
        output = static_cast<double>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Neutral Position
    //  1 --> ASD Authentication
    //  2 --> AD Authentication
    //  3 --> SNA
    return output;
}

double VIC_VEH_DRV_Interface::getsts_IgnitionPosition() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x70);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Lock
    //  1 --> Off_Accessory
    //  2 --> Run
    //  3 --> Start
    //  7 --> SNA
    return output;
}

double VIC_VEH_DRV_Interface::getsts_SCModeManager() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[11]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x1f);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);    // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  31 --> SNA
    //  16 --> AD Test Stopped
    //  14 --> ASD Degraded Parked
    //  13 --> ASD Interim Degraded
    //  12 --> ASD Stopping SSA3
    //  11 --> ASD Stopping SSA1/SSA2
    //  10 --> ASD Driving
    //  9 --> ASD Interim
    //  8 --> ASD Parked/Auto-Ready
    //  7 --> AD Degraded Parked
    //  0 --> Manual
    //  1 --> AD Parked/Auto-Ready
    //  2 --> AD Interim
    //  3 --> AD Driving
    //  4 --> AD Stopping SSA1/SSA2
    //  5 --> AD Stopping SSA3
    //  6 --> AD Interim Degraded
    //  15 --> AD Test Stopping
    return output;
}

double VIC_VEH_DRV_Interface::getsts_SWRC_CrsSw() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x70);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Idle Position
    //  1 --> Plus/Set
    //  2 --> Minus/Set
    //  3 --> Time gap (Distance, SCC only)
    //  4 --> Pause/Resume
    //  5 --> Touch
    //  6 --> Reserved
    //  7 --> Reserved
    return output;
}

int64_t VIC_VEH_DRV_Interface::setALIV_VEH_DRV_Interface(const double value) noexcept
{
    if ((value > static_cast<double>(255)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[2] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[2] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_AD_Transition(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[10] &= static_cast<uint8_t>(~0x4);                     // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer << 2) & (0x4)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_ASD_Transition(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[10] &= static_cast<uint8_t>(~0x8);                     // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer << 3) & (0x8)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_AutoButton(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0x3);                // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer) & (0x3)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Not Pressed
    //  1 --> Pressed
    //  3 --> SNA
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_BrakeOverride(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0xc);                     // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer << 2) & (0xc)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No
    //  1 --> Yes
    //  3 --> SNA
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_EPB(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[10] &= static_cast<uint8_t>(~0x20);                     // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer << 5) & (0x20)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_EnableButton(const double value) noexcept
{
    if ((value > static_cast<double>(1)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[9] &= static_cast<uint8_t>(~0xc);                     // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer << 2) & (0xc)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Not Pressed
    //  1 --> Pressed
    //  3 --> SNA
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_EngageButton(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[6] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Not Pressed
    //  1 --> Pressed
    //  3 --> SNA
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_HoldManual(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[10] &= static_cast<uint8_t>(~0x2);                     // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer << 1) & (0x2)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_LoggingButton(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0x30);                     // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer << 4) & (0x30)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Not Pressed
    //  1 --> Pressed
    //  3 --> SNA
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_ManualTakeover(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[10] &= static_cast<uint8_t>(~0x1);                // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer) & (0x1)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_ParkingBrake(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_Seatbelt(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[8] &= static_cast<uint8_t>(~0x40);                     // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer << 6) & (0x40)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_SteerOverride(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0x3);                // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer) & (0x3)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No
    //  1 --> Yes
    //  3 --> SNA
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_ThrottleOverride(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0xc);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer << 2) & (0xc)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> No
    //  1 --> Yes
    //  3 --> SNA
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setB_TransitPark(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[10] &= static_cast<uint8_t>(~0x10);                     // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer << 4) & (0x10)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Off
    //  1 --> On
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setCRC_VEH_DRV_Interface(const double value) noexcept
{
    if ((value > static_cast<double>(65535)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[0] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[0] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[1] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[1] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setMAC_VEH_DRV_Interface(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[24] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[24] |= static_cast<uint8_t>((bitBuffer) & (0xff));       // push in new data
    canPacket_.data[25] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[25] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff));  // push in new data
    canPacket_.data[26] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[26] |= static_cast<uint8_t>((bitBuffer >> 16) & (0xff)); // push in new data
    canPacket_.data[27] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[27] |= static_cast<uint8_t>((bitBuffer >> 24) & (0xff)); // push in new data
    canPacket_.data[28] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[28] |= static_cast<uint8_t>((bitBuffer >> 32) & (0xff)); // push in new data
    canPacket_.data[29] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[29] |= static_cast<uint8_t>((bitBuffer >> 40) & (0xff)); // push in new data
    canPacket_.data[30] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[30] |= static_cast<uint8_t>((bitBuffer >> 48) & (0xff)); // push in new data
    canPacket_.data[31] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[31] |= static_cast<uint8_t>((bitBuffer >> 56) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setper_AccelPedalPostion(const double value) noexcept
{
    if ((value > static_cast<double>(100)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value / static_cast<double>(0.01)); // value / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[5] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[5] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[6] &= static_cast<uint8_t>(~0x3f);                     // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer >> 8) & (0x3f)); // push in new data
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setper_BrakePedalPosition(const double value) noexcept
{
    if ((value > static_cast<double>(100)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value / static_cast<double>(0.01)); // value / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[7] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[8] &= static_cast<uint8_t>(~0x3f);                     // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer >> 8) & (0x3f)); // push in new data
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setsts_AuthSwitch(const double value) noexcept
{
    if ((value > static_cast<double>(2)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[9] &= static_cast<uint8_t>(~0x3);                // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer) & (0x3)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Neutral Position
    //  1 --> ASD Authentication
    //  2 --> AD Authentication
    //  3 --> SNA
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setsts_IgnitionPosition(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0x70);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer << 4) & (0x70)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Lock
    //  1 --> Off_Accessory
    //  2 --> Run
    //  3 --> Start
    //  7 --> SNA
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setsts_SCModeManager(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[11] &= static_cast<uint8_t>(~0x1f);                // clear the bits for new data
    canPacket_.data[11] |= static_cast<uint8_t>((bitBuffer) & (0x1f)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  31 --> SNA
    //  16 --> AD Test Stopped
    //  14 --> ASD Degraded Parked
    //  13 --> ASD Interim Degraded
    //  12 --> ASD Stopping SSA3
    //  11 --> ASD Stopping SSA1/SSA2
    //  10 --> ASD Driving
    //  9 --> ASD Interim
    //  8 --> ASD Parked/Auto-Ready
    //  7 --> AD Degraded Parked
    //  0 --> Manual
    //  1 --> AD Parked/Auto-Ready
    //  2 --> AD Interim
    //  3 --> AD Driving
    //  4 --> AD Stopping SSA1/SSA2
    //  5 --> AD Stopping SSA3
    //  6 --> AD Interim Degraded
    //  15 --> AD Test Stopping
    return 0;
}

int64_t VIC_VEH_DRV_Interface::setsts_SWRC_CrsSw(const double value) noexcept
{
    if ((value > static_cast<double>(7)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_DRV_Interface_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[9] &= static_cast<uint8_t>(~0x70);                     // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer << 4) & (0x70)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Idle Position
    //  1 --> Plus/Set
    //  2 --> Minus/Set
    //  3 --> Time gap (Distance, SCC only)
    //  4 --> Pause/Resume
    //  5 --> Touch
    //  6 --> Reserved
    //  7 --> Reserved
    return 0;
}
