/**
 * \copyright
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Aptiv and its suppliers, if any.
 * The intellectual and technical concepts contained herein are proprietary to Aptiv and its suppliers and may be
 * covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material is strictly forbidden unless prior written
 * permission is obtained from Aptiv.
 *
 * \brief This is a brief (1-line) description of the file.
 *
 * This file is generated with dbc2cpp script version : 3.1.0
 *
 * This file was generated from the following DBC file:
 * /home/lixun/Workspace/Gen2-AVT-Sample-A/Gen2_AVT_A_Control_CAN1.dbc
 *
 */

#include "VehicleCANLibrary/g2h/tcar/VIC_VEH_Steering_Wheel.h"
#include <algorithm>
#include <string.h>

using namespace av::can::g2h::tcar;

VIC_VEH_Steering_Wheel::VIC_VEH_Steering_Wheel(const uint32_t id)
{
    canPacket_.id = id;
    canPacket_.length = VIC_VEH_Steering_Wheel_CONSTS::VIC_VEH_STEERING_WHEEL_PACKET_LEN;
}

VIC_VEH_Steering_Wheel::VIC_VEH_Steering_Wheel(const uint32_t id, uint8_t* const payload, const uint8_t size)
{
    canPacket_.id = id;

    if ((size <= sizeof(canPacket_.data)) && payload) {
        canPacket_.length = size;
        std::copy_n(payload, size, canPacket_.data);
    }
}

const CanFdPacket& VIC_VEH_Steering_Wheel::getCanPacket() const
{
    return canPacket_;
}

double VIC_VEH_Steering_Wheel::getALIV_VEH_Steering_Wheel() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[2]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    return output;
}

double VIC_VEH_Steering_Wheel::getB_SteeringWheel_Valid() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x1);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  1 --> Invalid
    //  0 --> Valid
    return output;
}

double VIC_VEH_Steering_Wheel::getCRC_VEH_Steering_Wheel() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[0]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[1]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffff);                               // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);        // Unsigned value

    return output;
}

double VIC_VEH_Steering_Wheel::getMAC_VEH_Steering_Wheel() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[24]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[25]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[26]) << 16; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[27]) << 24; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[28]) << 32; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[29]) << 40; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[30]) << 48; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[31]) << 56; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffffffffffffffff);                     // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);          // Unsigned value

    return output;
}

double VIC_VEH_Steering_Wheel::getu_SteeringWheelAngle() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[5]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]) << 16; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffff80);                              // Bitmask for signal data
    bitBuffer = bitBuffer >> 7;                                   // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.0002)) + static_cast<double>(-7.8539); // (output * scale_factor) + bias

    if ((output > static_cast<double>(7.8539)) || (output < static_cast<double>(-7.8539))) // check for boundary
    {
        output = static_cast<double>(VIC_VEH_Steering_Wheel_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double VIC_VEH_Steering_Wheel::getu_SteeringWheelOffset() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1fff);                               // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);              // Unsigned value

    output = (output * static_cast<double>(0.0002)) + static_cast<double>(-0.5); // (output * scale_factor) + bias

    if ((output > static_cast<double>(0.5)) || (output < static_cast<double>(-0.5))) // check for boundary
    {
        output = static_cast<double>(VIC_VEH_Steering_Wheel_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

double VIC_VEH_Steering_Wheel::getw_SteeringWheelSpeed() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[5]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x7fe0);                               // Bitmask for signal data
    bitBuffer = bitBuffer >> 5;                                  // right shift to remove 0s

    double output = static_cast<double>(bitBuffer); // Unsigned value

    output = (output * static_cast<double>(0.01)) + static_cast<double>(-3.14); // (output * scale_factor) + bias

    if ((output > static_cast<double>(3.14)) || (output < static_cast<double>(-3.14))) // check for boundary
    {
        output = static_cast<double>(VIC_VEH_Steering_Wheel_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    return output;
}

int64_t VIC_VEH_Steering_Wheel::setALIV_VEH_Steering_Wheel(const double value) noexcept
{
    if ((value > static_cast<double>(255)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_Steering_Wheel_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[2] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[2] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_VEH_Steering_Wheel::setB_SteeringWheel_Valid(const double value) noexcept
{
    if ((value > static_cast<double>(1)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_Steering_Wheel_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[8] &= static_cast<uint8_t>(~0x1);                // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer) & (0x1)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  1 --> Invalid
    //  0 --> Valid
    return 0;
}

int64_t VIC_VEH_Steering_Wheel::setCRC_VEH_Steering_Wheel(const double value) noexcept
{
    if ((value > static_cast<double>(65535)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_Steering_Wheel_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[0] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[0] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[1] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[1] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_VEH_Steering_Wheel::setMAC_VEH_Steering_Wheel(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[24] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[24] |= static_cast<uint8_t>((bitBuffer) & (0xff));       // push in new data
    canPacket_.data[25] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[25] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff));  // push in new data
    canPacket_.data[26] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[26] |= static_cast<uint8_t>((bitBuffer >> 16) & (0xff)); // push in new data
    canPacket_.data[27] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[27] |= static_cast<uint8_t>((bitBuffer >> 24) & (0xff)); // push in new data
    canPacket_.data[28] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[28] |= static_cast<uint8_t>((bitBuffer >> 32) & (0xff)); // push in new data
    canPacket_.data[29] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[29] |= static_cast<uint8_t>((bitBuffer >> 40) & (0xff)); // push in new data
    canPacket_.data[30] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[30] |= static_cast<uint8_t>((bitBuffer >> 48) & (0xff)); // push in new data
    canPacket_.data[31] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[31] |= static_cast<uint8_t>((bitBuffer >> 56) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_VEH_Steering_Wheel::setu_SteeringWheelAngle(const double value) noexcept
{
    if ((value > static_cast<double>(7.8539)) ||
        (value < static_cast<double>(-7.8539))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_Steering_Wheel_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-7.8539)) /
                                                  static_cast<double>(0.0002)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[5] &= static_cast<uint8_t>(~0x80);                     // clear the bits for new data
    canPacket_.data[5] |= static_cast<uint8_t>((bitBuffer << 7) & (0x80)); // push in new data
    canPacket_.data[6] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer >> 1) & (0xff)); // push in new data
    canPacket_.data[7] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer >> 9) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_VEH_Steering_Wheel::setu_SteeringWheelOffset(const double value) noexcept
{
    if ((value > static_cast<double>(0.5)) ||
        (value < static_cast<double>(-0.5))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_Steering_Wheel_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-0.5)) /
                                                  static_cast<double>(0.0002)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[4] &= static_cast<uint8_t>(~0x1f);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer >> 8) & (0x1f)); // push in new data
    return 0;
}

int64_t VIC_VEH_Steering_Wheel::setw_SteeringWheelSpeed(const double value) noexcept
{
    if ((value > static_cast<double>(3.14)) ||
        (value < static_cast<double>(-3.14))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_Steering_Wheel_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(-3.14)) /
                                                  static_cast<double>(0.01)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0xe0);                     // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer << 5) & (0xe0)); // push in new data
    canPacket_.data[5] &= static_cast<uint8_t>(~0x7f);                     // clear the bits for new data
    canPacket_.data[5] |= static_cast<uint8_t>((bitBuffer >> 3) & (0x7f)); // push in new data
    return 0;
}
