/**
 * \copyright
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Aptiv and its suppliers, if any.
 * The intellectual and technical concepts contained herein are proprietary to Aptiv and its suppliers and may be
 * covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material is strictly forbidden unless prior written
 * permission is obtained from Aptiv.
 *
 * \brief This is a brief (1-line) description of the file.
 *
 * This file is generated with dbc2cpp script version : 3.1.0
 *
 * This file was generated from the following DBC file:
 * /home/lixun/Workspace/gen2-avt-sample-a/Gen2_AVT_A_Control_CAN1.dbc
 *
 */

#include "VehicleCANLibrary/g2h/tcar/VIC_VEH_VIN.h"
#include <algorithm>
#include <string.h>

using namespace av::can::g2h::tcar;

VIC_VEH_VIN::VIC_VEH_VIN(const uint32_t id)
{
    canPacket_.id = id;
    canPacket_.length = VIC_VEH_VIN_CONSTS::VIC_VEH_VIN_PACKET_LEN;
}

VIC_VEH_VIN::VIC_VEH_VIN(const uint32_t id, uint8_t* const payload, const uint8_t size)
{
    canPacket_.id = id;

    if ((size <= sizeof(canPacket_.data)) && payload) {
        canPacket_.length = size;
        std::copy_n(payload, size, canPacket_.data);
    }
}

const CanFdPacket& VIC_VEH_VIN::getCanPacket() const
{
    return canPacket_;
}

double VIC_VEH_VIN::getALIV_VEH_VIN() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[2]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    return output;
}

double VIC_VEH_VIN::getCRC_VEH_VIN() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[0]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[1]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffff);                               // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);        // Unsigned value

    return output;
}

double VIC_VEH_VIN::getMAC_VEH_VIN() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[24]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[25]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[26]) << 16; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[27]) << 24; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[28]) << 32; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[29]) << 40; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[30]) << 48; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[31]) << 56; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffffffffffffffff);                     // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);          // Unsigned value

    return output;
}

double VIC_VEH_VIN::getVIN_Data() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]);       // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]) << 8;  // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[5]) << 16; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]) << 24; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]) << 32; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]) << 40; // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]) << 48; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffffffffffffff);                      // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);         // Unsigned value

    return output;
}

double VIC_VEH_VIN::getVIN_Message() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x3);                              // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);    // Unsigned value

    return output;
}

int64_t VIC_VEH_VIN::setALIV_VEH_VIN(const double value) noexcept
{
    if ((value > static_cast<double>(255)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_VIN_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[2] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[2] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_VEH_VIN::setCRC_VEH_VIN(const double value) noexcept
{
    if ((value > static_cast<double>(65535)) ||
        (value < static_cast<double>(0))) // error in setting value due to boundary overflow/underflow
    {
        return static_cast<int64_t>(VIC_VEH_VIN_CONSTS::ERROR_OUT_OF_BOUNDARY);
    }
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[0] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[0] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[1] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[1] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_VEH_VIN::setMAC_VEH_VIN(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[24] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[24] |= static_cast<uint8_t>((bitBuffer) & (0xff));       // push in new data
    canPacket_.data[25] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[25] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff));  // push in new data
    canPacket_.data[26] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[26] |= static_cast<uint8_t>((bitBuffer >> 16) & (0xff)); // push in new data
    canPacket_.data[27] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[27] |= static_cast<uint8_t>((bitBuffer >> 24) & (0xff)); // push in new data
    canPacket_.data[28] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[28] |= static_cast<uint8_t>((bitBuffer >> 32) & (0xff)); // push in new data
    canPacket_.data[29] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[29] |= static_cast<uint8_t>((bitBuffer >> 40) & (0xff)); // push in new data
    canPacket_.data[30] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[30] |= static_cast<uint8_t>((bitBuffer >> 48) & (0xff)); // push in new data
    canPacket_.data[31] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[31] |= static_cast<uint8_t>((bitBuffer >> 56) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_VEH_VIN::setVIN_Data(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer) & (0xff));       // push in new data
    canPacket_.data[4] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff));  // push in new data
    canPacket_.data[5] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[5] |= static_cast<uint8_t>((bitBuffer >> 16) & (0xff)); // push in new data
    canPacket_.data[6] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer >> 24) & (0xff)); // push in new data
    canPacket_.data[7] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer >> 32) & (0xff)); // push in new data
    canPacket_.data[8] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer >> 40) & (0xff)); // push in new data
    canPacket_.data[9] &= static_cast<uint8_t>(~0xff);                      // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer >> 48) & (0xff)); // push in new data
    return 0;
}

int64_t VIC_VEH_VIN::setVIN_Message(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[10] &= static_cast<uint8_t>(~0x3);                // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer) & (0x3)); // push in new data
    return 0;
}
