/**
 * \copyright
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Aptiv and its suppliers, if any.
 * The intellectual and technical concepts contained herein are proprietary to Aptiv and its suppliers and may be
 * covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material is strictly forbidden unless prior written
 * permission is obtained from Aptiv.
 *
 * \brief This is a brief (1-line) description of the file.
 *
 * This file is generated with dbc2cpp script version : 3.0.0
 *
 * This file was generated from the following DBC file: /media/jhsu/Jeffery_SSD/dbc/20200327_CANFD__Chassis.dbc
 *
 */

#include "VehicleCANLibrary/g2h/tcar/WHL_01_10ms.h"
#include <algorithm>
#include <string.h>

WHL_01_10ms::WHL_01_10ms(const uint32_t id)
{
    canPacket_.id = id;
    canPacket_.length = WHL_01_10ms_CONSTS::WHL_01_10MS_PACKET_LEN;
}

WHL_01_10ms::WHL_01_10ms(const uint32_t id, uint8_t* const payload, const uint8_t size)
{
    canPacket_.id = id;

    if ((size <= sizeof(canPacket_.data)) && payload) {
        canPacket_.length = size;
        std::copy_n(payload, size, canPacket_.data);
    }
}

const CanFdPacket& WHL_01_10ms::getCanPacket() const
{
    return canPacket_;
}

double WHL_01_10ms::getWHL_AlvCnt1Val() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[2]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    return output;
}

double WHL_01_10ms::getWHL_Crc1Val() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[0]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[1]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0xffff);                               // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);        // Unsigned value

    return output;
}

double WHL_01_10ms::getWHL_DirFLVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x3);                             // Bitmask for signal data
    const double output = static_cast<double>(bitBuffer);   // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Unknown (Wheel moving stop state or Not applied wheel sensor for direction)
    //  1 --> Forward direction
    //  2 --> Backward direction
    //  3 --> Error identifier
    return output;
}

double WHL_01_10ms::getWHL_DirFRVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc);                             // Bitmask for signal data
    bitBuffer = bitBuffer >> 2;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Unknown (Wheel moving stop state or Not applied wheel sensor for direction)
    //  1 --> Forward direction
    //  2 --> Backward direction
    //  3 --> Error identifier
    return output;
}

double WHL_01_10ms::getWHL_DirRLVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]); // Bytes containing signal
    bitBuffer &= UINT64_C(0x30);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 4;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Unknown (Wheel moving stop state or Not applied wheel sensor for direction)
    //  1 --> Forward direction
    //  2 --> Backward direction
    //  3 --> Error identifier
    return output;
}

double WHL_01_10ms::getWHL_DirRRVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[7]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xc0);                            // Bitmask for signal data
    bitBuffer = bitBuffer >> 6;                             // right shift to remove 0s

    const double output = static_cast<double>(bitBuffer); // Unsigned value

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Unknown (Wheel moving stop state or Not applied wheel sensor for direction)
    //  1 --> Forward direction
    //  2 --> Backward direction
    //  3 --> Error identifier
    return output;
}

double WHL_01_10ms::getWHL_PlsFLVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[3]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);         // Unsigned value

    output = output * static_cast<double>(0.5); // output * scale_factor

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  255 --> Error
    return output;
}

double WHL_01_10ms::getWHL_PlsFRVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[4]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);         // Unsigned value

    output = output * static_cast<double>(0.5); // output * scale_factor

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  255 --> Error
    return output;
}

double WHL_01_10ms::getWHL_PlsRLVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[5]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);         // Unsigned value

    output = output * static_cast<double>(0.5); // output * scale_factor

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  255 --> Error
    return output;
}

double WHL_01_10ms::getWHL_PlsRRVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[6]); // Bytes containing signal
    bitBuffer &= UINT64_C(0xff);                            // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);         // Unsigned value

    output = output * static_cast<double>(0.5); // output * scale_factor

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  255 --> Error
    return output;
}

double WHL_01_10ms::getWHL_SpdCalParmtr() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[17]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[18]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x1ff);                                 // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);               // Unsigned value

    output = (output * static_cast<double>(0.5)) + static_cast<double>(200); // (output * scale_factor) + bias

    return output;
}

double WHL_01_10ms::getWHL_SpdFLVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[8]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[9]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x3fff);                               // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);              // Unsigned value

    output = output * static_cast<double>(0.03125); // output * scale_factor

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  16383 --> Error
    return output;
}

double WHL_01_10ms::getWHL_SpdFRVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[10]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[11]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x3fff);                                // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);               // Unsigned value

    output = output * static_cast<double>(0.03125); // output * scale_factor

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  16383 --> Error
    return output;
}

double WHL_01_10ms::getWHL_SpdRLVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[12]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[13]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x3fff);                                // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);               // Unsigned value

    output = output * static_cast<double>(0.03125); // output * scale_factor

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  16383 --> Error
    return output;
}

double WHL_01_10ms::getWHL_SpdRRVal() const noexcept
{
    uint64_t bitBuffer{0};

    bitBuffer |= static_cast<uint64_t>(canPacket_.data[14]);      // Bytes containing signal
    bitBuffer |= static_cast<uint64_t>(canPacket_.data[15]) << 8; // Bytes containing signal
    bitBuffer &= UINT64_C(0x3fff);                                // Bitmask for signal data
    double output = static_cast<double>(bitBuffer);               // Unsigned value

    output = output * static_cast<double>(0.03125); // output * scale_factor

    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  16383 --> Error
    return output;
}

int64_t WHL_01_10ms::setWHL_AlvCnt1Val(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[2] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[2] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    return 0;
}

int64_t WHL_01_10ms::setWHL_Crc1Val(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[0] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[0] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[1] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[1] |= static_cast<uint8_t>((bitBuffer >> 8) & (0xff)); // push in new data
    return 0;
}

int64_t WHL_01_10ms::setWHL_DirFLVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[7] &= static_cast<uint8_t>(~0x3);                // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer) & (0x3)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Unknown (Wheel moving stop state or Not applied wheel sensor for direction)
    //  1 --> Forward direction
    //  2 --> Backward direction
    //  3 --> Error identifier
    return 0;
}

int64_t WHL_01_10ms::setWHL_DirFRVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[7] &= static_cast<uint8_t>(~0xc);                     // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer << 2) & (0xc)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Unknown (Wheel moving stop state or Not applied wheel sensor for direction)
    //  1 --> Forward direction
    //  2 --> Backward direction
    //  3 --> Error identifier
    return 0;
}

int64_t WHL_01_10ms::setWHL_DirRLVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[7] &= static_cast<uint8_t>(~0x30);                     // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer << 4) & (0x30)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Unknown (Wheel moving stop state or Not applied wheel sensor for direction)
    //  1 --> Forward direction
    //  2 --> Backward direction
    //  3 --> Error identifier
    return 0;
}

int64_t WHL_01_10ms::setWHL_DirRRVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value);

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[7] &= static_cast<uint8_t>(~0xc0);                     // clear the bits for new data
    canPacket_.data[7] |= static_cast<uint8_t>((bitBuffer << 6) & (0xc0)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  0 --> Unknown (Wheel moving stop state or Not applied wheel sensor for direction)
    //  1 --> Forward direction
    //  2 --> Backward direction
    //  3 --> Error identifier
    return 0;
}

int64_t WHL_01_10ms::setWHL_PlsFLVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value / static_cast<double>(0.5)); // value / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[3] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[3] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  255 --> Error
    return 0;
}

int64_t WHL_01_10ms::setWHL_PlsFRVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value / static_cast<double>(0.5)); // value / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[4] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[4] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  255 --> Error
    return 0;
}

int64_t WHL_01_10ms::setWHL_PlsRLVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value / static_cast<double>(0.5)); // value / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[5] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[5] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  255 --> Error
    return 0;
}

int64_t WHL_01_10ms::setWHL_PlsRRVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value / static_cast<double>(0.5)); // value / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[6] &= static_cast<uint8_t>(~0xff);                // clear the bits for new data
    canPacket_.data[6] |= static_cast<uint8_t>((bitBuffer) & (0xff)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  255 --> Error
    return 0;
}

int64_t WHL_01_10ms::setWHL_SpdCalParmtr(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>((value - static_cast<double>(200)) /
                                                  static_cast<double>(0.5)); // (value - bias) / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[17] &= static_cast<uint8_t>(~0xff);                    // clear the bits for new data
    canPacket_.data[17] |= static_cast<uint8_t>((bitBuffer) & (0xff));     // push in new data
    canPacket_.data[18] &= static_cast<uint8_t>(~0x1);                     // clear the bits for new data
    canPacket_.data[18] |= static_cast<uint8_t>((bitBuffer >> 8) & (0x1)); // push in new data
    return 0;
}

int64_t WHL_01_10ms::setWHL_SpdFLVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value / static_cast<double>(0.03125)); // value / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[8] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[8] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[9] &= static_cast<uint8_t>(~0x3f);                     // clear the bits for new data
    canPacket_.data[9] |= static_cast<uint8_t>((bitBuffer >> 8) & (0x3f)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  16383 --> Error
    return 0;
}

int64_t WHL_01_10ms::setWHL_SpdFRVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value / static_cast<double>(0.03125)); // value / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[10] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[10] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[11] &= static_cast<uint8_t>(~0x3f);                     // clear the bits for new data
    canPacket_.data[11] |= static_cast<uint8_t>((bitBuffer >> 8) & (0x3f)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  16383 --> Error
    return 0;
}

int64_t WHL_01_10ms::setWHL_SpdRLVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value / static_cast<double>(0.03125)); // value / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[12] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[12] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[13] &= static_cast<uint8_t>(~0x3f);                     // clear the bits for new data
    canPacket_.data[13] |= static_cast<uint8_t>((bitBuffer >> 8) & (0x3f)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  16383 --> Error
    return 0;
}

int64_t WHL_01_10ms::setWHL_SpdRRVal(const double value) noexcept
{
    const int64_t rawValue = static_cast<int64_t>(value / static_cast<double>(0.03125)); // value / scale_factor

    const uint64_t bitBuffer = static_cast<uint64_t>(rawValue);

    canPacket_.data[14] &= static_cast<uint8_t>(~0xff);                     // clear the bits for new data
    canPacket_.data[14] |= static_cast<uint8_t>((bitBuffer) & (0xff));      // push in new data
    canPacket_.data[15] &= static_cast<uint8_t>(~0x3f);                     // clear the bits for new data
    canPacket_.data[15] |= static_cast<uint8_t>((bitBuffer >> 8) & (0x3f)); // push in new data
    // Enum values & description listed down for reference
    //-----------------------------------------------------------
    //  16383 --> Error
    return 0;
}
