/// @copyright Copyright (c) 2021- Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file: /home/scotty/Downloads/Gen2_AVT_B_Control_CAN1.dbc

#ifndef AV_BodyCMD_10_A1_00ms_av_proto_H_
#define AV_BodyCMD_10_A1_00ms_av_proto_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::avproto {

namespace AV_BodyCMD_10_A1_00ms_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

/// This class contains members for decoding/encoding the CAN message AV_BodyCMD_10_A1_00ms
/// The default message identifier for AV_BodyCMD_10_A1_00ms is 0x7d (125)

/// For decoding this is the required length of a decodable message. If the message
/// is smaller there is data missing.
/// For encoding this the length of the CAN message encoded by this class assuming all
/// setters have been called. This value should be one greater than the largest index
/// written to by any of the setter methods.
const uint8_t AV_BODYCMD_10_A1_00MS_PACKET_LEN = UINT8_C(8);
} // namespace AV_BodyCMD_10_A1_00ms_CONSTS

class AV_BodyCMD_10_A1_00ms
{
public:
    AV_BodyCMD_10_A1_00ms(const uint32_t id);
    AV_BodyCMD_10_A1_00ms(const uint32_t id, uint8_t* const payload, const uint8_t size);

    /// @brief signal comment: AV_BodyCMD_CyclicRedundancyCheck10_A1Value
    double getAV_BodyCMD_Crc10_A1Val() const noexcept;
    /// @brief signal comment: AV_BodyCMD_AliveCounter10_A1Value
    double getAV_BodyCMD_AlvCnt10_A1Val() const noexcept;
    /// @brief signal comment: Hazard  Flasher command
    double getA1_10_Hazard_Flashers() const noexcept;
    /// @brief signal comment: Rear_Defroster command
    double getA1_10_RrDefroster() const noexcept;
    /// @brief signal comment: Front_Interior_cabin_light_command
    double getA1_10_FrInterior_cabin_light() const noexcept;
    /// @brief signal comment: Rear_Left_Interior_cabin_light_command
    double getA1_10_RrLf_Interior_cabin_light() const noexcept;
    /// @brief signal comment: Rear_Right_Interior_cabin_light_command
    double getA1_10_RrRt_Interior_cabin_light() const noexcept;
    /// @brief signal comment: Footwell_lamp_activation_command
    double getA1_10_Footwell_lamp_activation() const noexcept;
    /// @brief signal comment: Trunk operation command by VIC
    double getA1_10_AutomaticTrunkCmd() const noexcept;
    /// @brief signal comment: Front Passenger Dr Auto Close Command
    double getA1_10_Auto_Door_Close_Front_Pass() const noexcept;
    /// @brief signal comment: RL Dr Auto Close Command
    double getA1_10_Auto_Door_Close_RL() const noexcept;
    /// @brief signal comment: RR Dr Auto Close Command
    double getA1_10_Auto_Door_Close_RR() const noexcept;
    /// @brief signal comment: OHCL_Mood_Lamp_command
    double getA1_10_OHCL_MoodLamp() const noexcept;

    /// @brief signal comment: AV_BodyCMD_CyclicRedundancyCheck10_A1Value
    int64_t setAV_BodyCMD_Crc10_A1Val(const double value) noexcept;
    /// @brief signal comment: AV_BodyCMD_AliveCounter10_A1Value
    int64_t setAV_BodyCMD_AlvCnt10_A1Val(const double value) noexcept;
    /// @brief signal comment: Hazard  Flasher command
    int64_t setA1_10_Hazard_Flashers(const double value) noexcept;
    /// @brief signal comment: Rear_Defroster command
    int64_t setA1_10_RrDefroster(const double value) noexcept;
    /// @brief signal comment: Front_Interior_cabin_light_command
    int64_t setA1_10_FrInterior_cabin_light(const double value) noexcept;
    /// @brief signal comment: Rear_Left_Interior_cabin_light_command
    int64_t setA1_10_RrLf_Interior_cabin_light(const double value) noexcept;
    /// @brief signal comment: Rear_Right_Interior_cabin_light_command
    int64_t setA1_10_RrRt_Interior_cabin_light(const double value) noexcept;
    /// @brief signal comment: Footwell_lamp_activation_command
    int64_t setA1_10_Footwell_lamp_activation(const double value) noexcept;
    /// @brief signal comment: Trunk operation command by VIC
    int64_t setA1_10_AutomaticTrunkCmd(const double value) noexcept;
    /// @brief signal comment: Front Passenger Dr Auto Close Command
    int64_t setA1_10_Auto_Door_Close_Front_Pass(const double value) noexcept;
    /// @brief signal comment: RL Dr Auto Close Command
    int64_t setA1_10_Auto_Door_Close_RL(const double value) noexcept;
    /// @brief signal comment: RR Dr Auto Close Command
    int64_t setA1_10_Auto_Door_Close_RR(const double value) noexcept;
    /// @brief signal comment: OHCL_Mood_Lamp_command
    int64_t setA1_10_OHCL_MoodLamp(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::avproto

#endif
