/// @copyright Copyright (c) 2021- Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file: /home/scotty/Downloads/Gen2_AVT_B_Control_CAN1.dbc

#ifndef AV_DATC_01_00ms_av_proto_H_
#define AV_DATC_01_00ms_av_proto_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::avproto {

namespace AV_DATC_01_00ms_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

/// This class contains members for decoding/encoding the CAN message AV_DATC_01_00ms
/// The default message identifier for AV_DATC_01_00ms is 0x348 (840)

/// For decoding this is the required length of a decodable message. If the message
/// is smaller there is data missing.
/// For encoding this the length of the CAN message encoded by this class assuming all
/// setters have been called. This value should be one greater than the largest index
/// written to by any of the setter methods.
const uint8_t AV_DATC_01_00MS_PACKET_LEN = UINT8_C(16);
} // namespace AV_DATC_01_00ms_CONSTS

class AV_DATC_01_00ms
{
public:
    AV_DATC_01_00ms(const uint32_t id);
    AV_DATC_01_00ms(const uint32_t id, uint8_t* const payload, const uint8_t size);

    /// @brief signal comment: AV_DATC_CyclicRedundancyCheck1Value
    double getAV_DATC_Crc1Val() const noexcept;
    /// @brief signal comment: AV_DATC_AliveCounter1Value
    double getAV_DATC_AlvCnt1Val() const noexcept;
    /// @brief signal comment: Temperature control driver side in C (HU_DATC_DrTempSetC)
    /// Units: Celsius
    double getAV_DATC_DrvTempCSet_A() const noexcept;
    /// @brief signal comment: Temperature control driver side in F (HU_DATC_DrTempSetF)
    /// Units: Fahrenheit
    double getAV_DATC_DrvTempFSet_A() const noexcept;
    /// @brief signal comment: Temperature control passenger side in C (HU_DATC_PsTempSetC)
    /// Units: Celsius
    double getAV_DATC_PassTempCSet_A() const noexcept;
    /// @brief signal comment: Temperature control passenger side in F (HU_DATC_PsTempSetF)
    /// Units: Fahrenheit
    double getAV_DATC_PassTempFSet_A() const noexcept;
    /// @brief signal comment: HVAC recirculation (HU_DATC_IntakeSet)
    double getAV_DATC_IntakeSet_A() const noexcept;
    /// @brief signal comment: HVAC Auto mode (HU_DATC_AutoSet)
    double getAV_DATC_AutoSet_A() const noexcept;
    /// @brief signal comment: Blower speed (HU_DATC_MainBlower)
    double getAV_DATC_BlowerSet_A() const noexcept;
    /// @brief signal comment: Air direction (HU_DATC_FrontModeSet)
    double getAV_DATC_ModeSet_A() const noexcept;
    /// @brief signal comment: Temperature Unit (C_TempUnit)
    double getAV_DATC_TempUnitSet_A() const noexcept;
    /// @brief signal comment: Front Defog command (HU_DATC_FrontDefog)
    double getAV_DATC_FrDefogSet_A() const noexcept;

    /// @brief signal comment: AV_DATC_CyclicRedundancyCheck1Value
    int64_t setAV_DATC_Crc1Val(const double value) noexcept;
    /// @brief signal comment: AV_DATC_AliveCounter1Value
    int64_t setAV_DATC_AlvCnt1Val(const double value) noexcept;
    /// @brief signal comment: Temperature control driver side in C (HU_DATC_DrTempSetC)
    /// Units: Celsius
    int64_t setAV_DATC_DrvTempCSet_A(const double value) noexcept;
    /// @brief signal comment: Temperature control driver side in F (HU_DATC_DrTempSetF)
    /// Units: Fahrenheit
    int64_t setAV_DATC_DrvTempFSet_A(const double value) noexcept;
    /// @brief signal comment: Temperature control passenger side in C (HU_DATC_PsTempSetC)
    /// Units: Celsius
    int64_t setAV_DATC_PassTempCSet_A(const double value) noexcept;
    /// @brief signal comment: Temperature control passenger side in F (HU_DATC_PsTempSetF)
    /// Units: Fahrenheit
    int64_t setAV_DATC_PassTempFSet_A(const double value) noexcept;
    /// @brief signal comment: HVAC recirculation (HU_DATC_IntakeSet)
    int64_t setAV_DATC_IntakeSet_A(const double value) noexcept;
    /// @brief signal comment: HVAC Auto mode (HU_DATC_AutoSet)
    int64_t setAV_DATC_AutoSet_A(const double value) noexcept;
    /// @brief signal comment: Blower speed (HU_DATC_MainBlower)
    int64_t setAV_DATC_BlowerSet_A(const double value) noexcept;
    /// @brief signal comment: Air direction (HU_DATC_FrontModeSet)
    int64_t setAV_DATC_ModeSet_A(const double value) noexcept;
    /// @brief signal comment: Temperature Unit (C_TempUnit)
    int64_t setAV_DATC_TempUnitSet_A(const double value) noexcept;
    /// @brief signal comment: Front Defog command (HU_DATC_FrontDefog)
    int64_t setAV_DATC_FrDefogSet_A(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::avproto

#endif
