/// @copyright Copyright (c) 2021- Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file: /home/scotty/Downloads/Gen2_AVT_B_Control_CAN1.dbc

#ifndef AV_MLM_02_00ms_av_proto_H_
#define AV_MLM_02_00ms_av_proto_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::avproto {

namespace AV_MLM_02_00ms_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

/// This class contains members for decoding/encoding the CAN message AV_MLM_02_00ms
/// The default message identifier for AV_MLM_02_00ms is 0x25c (604)

/// For decoding this is the required length of a decodable message. If the message
/// is smaller there is data missing.
/// For encoding this the length of the CAN message encoded by this class assuming all
/// setters have been called. This value should be one greater than the largest index
/// written to by any of the setter methods.
const uint8_t AV_MLM_02_00MS_PACKET_LEN = UINT8_C(8);
} // namespace AV_MLM_02_00ms_CONSTS

class AV_MLM_02_00ms
{
public:
    AV_MLM_02_00ms(const uint32_t id);
    AV_MLM_02_00ms(const uint32_t id, uint8_t* const payload, const uint8_t size);

    /// @brief signal comment: Robo taxi request for mood lamp Color on Frt left Door (Red)
    double getAV_LEDStips_FLColor_R() const noexcept;
    /// @brief signal comment: Robo taxi request for mood lamp Color on Frt left Door (Green)
    double getAV_LEDStips_FLColor_G() const noexcept;
    /// @brief signal comment: Robo taxi request for mood lamp Color on Frt left Door (Blue)
    double getAV_LEDStips_FLColor_B() const noexcept;
    /// @brief signal comment: Robo taxi request for mood lamp pattern on Frt left Door
    double getAV_LEDStips_FLPattern() const noexcept;
    /// @brief signal comment: Robo taxi request for mood lamp brightness on Frt left Door
    double getAV_LEDStips_FLBrightness() const noexcept;
    /// @brief signal comment: Robo taxi request for mood lamp frequency on Frt left Door
    double getAV_LEDStips_FLFrequency() const noexcept;
    /// @brief signal comment: Robo taxi request for mood lamp speed on Frt left Door
    double getAV_LEDStips_FLSpeed() const noexcept;
    /// @brief signal comment: Robo taxi request for mood lamp power on Frt left Door
    double getAV_LEDStips_FLPower_OnOff() const noexcept;

    /// @brief signal comment: Robo taxi request for mood lamp Color on Frt left Door (Red)
    int64_t setAV_LEDStips_FLColor_R(const double value) noexcept;
    /// @brief signal comment: Robo taxi request for mood lamp Color on Frt left Door (Green)
    int64_t setAV_LEDStips_FLColor_G(const double value) noexcept;
    /// @brief signal comment: Robo taxi request for mood lamp Color on Frt left Door (Blue)
    int64_t setAV_LEDStips_FLColor_B(const double value) noexcept;
    /// @brief signal comment: Robo taxi request for mood lamp pattern on Frt left Door
    int64_t setAV_LEDStips_FLPattern(const double value) noexcept;
    /// @brief signal comment: Robo taxi request for mood lamp brightness on Frt left Door
    int64_t setAV_LEDStips_FLBrightness(const double value) noexcept;
    /// @brief signal comment: Robo taxi request for mood lamp frequency on Frt left Door
    int64_t setAV_LEDStips_FLFrequency(const double value) noexcept;
    /// @brief signal comment: Robo taxi request for mood lamp speed on Frt left Door
    int64_t setAV_LEDStips_FLSpeed(const double value) noexcept;
    /// @brief signal comment: Robo taxi request for mood lamp power on Frt left Door
    int64_t setAV_LEDStips_FLPower_OnOff(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::avproto

#endif
