/// @copyright Copyright (c) 2022 - Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file:
/// https://gitlab.ci.motional.com/systems/av-netwrok-infrastructure/Gen2-AVT-Sample-B/-/blob/dd539e5d752bcae0408ed2b8f29b270cc0db624e/Gen2_AVT_B_Control_CAN1.dbc

#ifndef AV_Waypoint_Speeds_A_2_av_proto_H_
#define AV_Waypoint_Speeds_A_2_av_proto_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::avproto {

namespace AV_Waypoint_Speeds_A_2_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

/// This class contains members for decoding/encoding the CAN message AV_Waypoint_Speeds_A_2
/// The default message identifier for AV_Waypoint_Speeds_A_2 is 0x138 (312)

/// For decoding this is the required length of a decodable message. If the message
/// is smaller there is data missing.
/// For encoding this the length of the CAN message encoded by this class assuming all
/// setters have been called. This value should be one greater than the largest index
/// written to by any of the setter methods.
const uint8_t AV_WAYPOINT_SPEEDS_A_2_PACKET_LEN = UINT8_C(32);
} // namespace AV_Waypoint_Speeds_A_2_CONSTS

class AV_Waypoint_Speeds_A_2
{
public:
    AV_Waypoint_Speeds_A_2(const uint32_t id);
    AV_Waypoint_Speeds_A_2(const uint32_t id, uint8_t* const payload, const uint8_t size);

    double getCRC_AV_Waypoint_Speeds_A_2() const noexcept;
    double getALIV_AV_Waypoint_Speeds_A_2() const noexcept;
    /// Units: m/s
    double getv_WaypointSpeed_A_18() const noexcept;
    /// Units: m/s
    double getv_WaypointSpeed_A_19() const noexcept;
    /// Units: m/s
    double getv_WaypointSpeed_A_20() const noexcept;
    /// Units: m/s
    double getv_WaypointSpeed_A_21() const noexcept;
    /// Units: m/s
    double getv_WaypointSpeed_A_22() const noexcept;
    /// Units: m/s
    double getv_WaypointSpeed_A_23() const noexcept;
    /// Units: m/s
    double getv_WaypointSpeed_A_24() const noexcept;
    /// Units: m/s
    double getv_WaypointSpeed_A_25() const noexcept;
    /// Units: m/s
    double getv_WaypointSpeed_A_26() const noexcept;
    /// Units: m/s
    double getv_WaypointSpeed_A_27() const noexcept;
    /// Units: m/s
    double getv_WaypointSpeed_A_28() const noexcept;
    /// Units: m/s
    double getv_WaypointSpeed_A_29() const noexcept;
    /// Units: m/s
    double getv_WaypointSpeed_A_30() const noexcept;
    /// Units: m/s
    double getv_WaypointSpeed_A_31() const noexcept;
    /// Units: m/s
    double getv_WaypointSpeed_A_32() const noexcept;
    /// Units: m/s
    double getv_WaypointSpeed_A_33() const noexcept;
    /// @brief signal comment: Speed34 for Trajectory A, Segment 2
    /// Units: m/s
    double getv_WaypointSpeed_A_34() const noexcept;

    int64_t setCRC_AV_Waypoint_Speeds_A_2(const double value) noexcept;
    int64_t setALIV_AV_Waypoint_Speeds_A_2(const double value) noexcept;
    /// Units: m/s
    int64_t setv_WaypointSpeed_A_18(const double value) noexcept;
    /// Units: m/s
    int64_t setv_WaypointSpeed_A_19(const double value) noexcept;
    /// Units: m/s
    int64_t setv_WaypointSpeed_A_20(const double value) noexcept;
    /// Units: m/s
    int64_t setv_WaypointSpeed_A_21(const double value) noexcept;
    /// Units: m/s
    int64_t setv_WaypointSpeed_A_22(const double value) noexcept;
    /// Units: m/s
    int64_t setv_WaypointSpeed_A_23(const double value) noexcept;
    /// Units: m/s
    int64_t setv_WaypointSpeed_A_24(const double value) noexcept;
    /// Units: m/s
    int64_t setv_WaypointSpeed_A_25(const double value) noexcept;
    /// Units: m/s
    int64_t setv_WaypointSpeed_A_26(const double value) noexcept;
    /// Units: m/s
    int64_t setv_WaypointSpeed_A_27(const double value) noexcept;
    /// Units: m/s
    int64_t setv_WaypointSpeed_A_28(const double value) noexcept;
    /// Units: m/s
    int64_t setv_WaypointSpeed_A_29(const double value) noexcept;
    /// Units: m/s
    int64_t setv_WaypointSpeed_A_30(const double value) noexcept;
    /// Units: m/s
    int64_t setv_WaypointSpeed_A_31(const double value) noexcept;
    /// Units: m/s
    int64_t setv_WaypointSpeed_A_32(const double value) noexcept;
    /// Units: m/s
    int64_t setv_WaypointSpeed_A_33(const double value) noexcept;
    /// @brief signal comment: Speed34 for Trajectory A, Segment 2
    /// Units: m/s
    int64_t setv_WaypointSpeed_A_34(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::avproto

#endif
