/// @copyright Copyright (c) 2022 - Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file:
/// https://gitlab.ci.motional.com/systems/av-netwrok-infrastructure/Gen2-AVT-Sample-B/-/blob/dd539e5d752bcae0408ed2b8f29b270cc0db624e/Gen2_AVT_B_Control_CAN1.dbc

#ifndef AV_Waypoints_A_X4_av_proto_H_
#define AV_Waypoints_A_X4_av_proto_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::avproto {

namespace AV_Waypoints_A_X4_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

/// This class contains members for decoding/encoding the CAN message AV_Waypoints_A_X4
/// The default message identifier for AV_Waypoints_A_X4 is 0x125 (293)

/// For decoding this is the required length of a decodable message. If the message
/// is smaller there is data missing.
/// For encoding this the length of the CAN message encoded by this class assuming all
/// setters have been called. This value should be one greater than the largest index
/// written to by any of the setter methods.
const uint8_t AV_WAYPOINTS_A_X4_PACKET_LEN = UINT8_C(32);
} // namespace AV_Waypoints_A_X4_CONSTS

class AV_Waypoints_A_X4
{
public:
    AV_Waypoints_A_X4(const uint32_t id);
    AV_Waypoints_A_X4(const uint32_t id, uint8_t* const payload, const uint8_t size);

    double getCRC_AV_Waypoints_A_X4() const noexcept;
    double getALIV_AV_Waypoints_A_X4() const noexcept;
    /// Units: m
    double getL_Waypoint_A_X52() const noexcept;
    /// Units: m
    double getL_Waypoint_A_X53() const noexcept;
    /// Units: m
    double getL_Waypoint_A_X54() const noexcept;
    /// Units: m
    double getL_Waypoint_A_X55() const noexcept;
    /// Units: m
    double getL_Waypoint_A_X56() const noexcept;
    /// Units: m
    double getL_Waypoint_A_X57() const noexcept;
    /// Units: m
    double getL_Waypoint_A_X58() const noexcept;
    /// Units: m
    double getL_Waypoint_A_X59() const noexcept;
    /// @brief signal comment: Xcoordinate60 for Trajectory A, Segment 4
    /// Units: m
    double getL_Waypoint_A_X60() const noexcept;

    int64_t setCRC_AV_Waypoints_A_X4(const double value) noexcept;
    int64_t setALIV_AV_Waypoints_A_X4(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_A_X52(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_A_X53(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_A_X54(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_A_X55(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_A_X56(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_A_X57(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_A_X58(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_A_X59(const double value) noexcept;
    /// @brief signal comment: Xcoordinate60 for Trajectory A, Segment 4
    /// Units: m
    int64_t setL_Waypoint_A_X60(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::avproto

#endif
