/// @copyright Copyright (c) 2022 - Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file:
/// https://gitlab.ci.motional.com/systems/av-netwrok-infrastructure/Gen2-AVT-Sample-B/-/blob/dd539e5d752bcae0408ed2b8f29b270cc0db624e/Gen2_AVT_B_Control_CAN1.dbc

#ifndef AV_Waypoints_B_X3_av_proto_H_
#define AV_Waypoints_B_X3_av_proto_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::avproto {

namespace AV_Waypoints_B_X3_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

/// This class contains members for decoding/encoding the CAN message AV_Waypoints_B_X3
/// The default message identifier for AV_Waypoints_B_X3 is 0x12c (300)

/// For decoding this is the required length of a decodable message. If the message
/// is smaller there is data missing.
/// For encoding this the length of the CAN message encoded by this class assuming all
/// setters have been called. This value should be one greater than the largest index
/// written to by any of the setter methods.
const uint8_t AV_WAYPOINTS_B_X3_PACKET_LEN = UINT8_C(32);
} // namespace AV_Waypoints_B_X3_CONSTS

class AV_Waypoints_B_X3
{
public:
    AV_Waypoints_B_X3(const uint32_t id);
    AV_Waypoints_B_X3(const uint32_t id, uint8_t* const payload, const uint8_t size);

    double getCRC_AV_Waypoints_B_X3() const noexcept;
    double getALIV_AV_Waypoints_B_X3() const noexcept;
    /// Units: m
    double getL_Waypoint_B_X35() const noexcept;
    /// Units: m
    double getL_Waypoint_B_X36() const noexcept;
    /// Units: m
    double getL_Waypoint_B_X37() const noexcept;
    /// Units: m
    double getL_Waypoint_B_X38() const noexcept;
    /// Units: m
    double getL_Waypoint_B_X39() const noexcept;
    /// Units: m
    double getL_Waypoint_B_X40() const noexcept;
    /// Units: m
    double getL_Waypoint_B_X41() const noexcept;
    /// Units: m
    double getL_Waypoint_B_X42() const noexcept;
    /// Units: m
    double getL_Waypoint_B_X43() const noexcept;
    /// Units: m
    double getL_Waypoint_B_X44() const noexcept;
    /// Units: m
    double getL_Waypoint_B_X45() const noexcept;
    /// Units: m
    double getL_Waypoint_B_X46() const noexcept;
    /// Units: m
    double getL_Waypoint_B_X47() const noexcept;
    /// Units: m
    double getL_Waypoint_B_X48() const noexcept;
    /// Units: m
    double getL_Waypoint_B_X49() const noexcept;
    /// Units: m
    double getL_Waypoint_B_X50() const noexcept;
    /// @brief signal comment: Xcoordinate51 for Trajectory B, Segment 3
    /// Units: m
    double getL_Waypoint_B_X51() const noexcept;

    int64_t setCRC_AV_Waypoints_B_X3(const double value) noexcept;
    int64_t setALIV_AV_Waypoints_B_X3(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_B_X35(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_B_X36(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_B_X37(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_B_X38(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_B_X39(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_B_X40(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_B_X41(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_B_X42(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_B_X43(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_B_X44(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_B_X45(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_B_X46(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_B_X47(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_B_X48(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_B_X49(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_B_X50(const double value) noexcept;
    /// @brief signal comment: Xcoordinate51 for Trajectory B, Segment 3
    /// Units: m
    int64_t setL_Waypoint_B_X51(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::avproto

#endif
