/// @copyright Copyright (c) 2022 - Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file:
/// https://gitlab.ci.motional.com/systems/av-netwrok-infrastructure/Gen2-AVT-Sample-B/-/blob/dd539e5d752bcae0408ed2b8f29b270cc0db624e/Gen2_AVT_B_Control_CAN1.dbc

#ifndef AV_Waypoints_B_Y3_av_proto_H_
#define AV_Waypoints_B_Y3_av_proto_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::avproto {

namespace AV_Waypoints_B_Y3_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

/// This class contains members for decoding/encoding the CAN message AV_Waypoints_B_Y3
/// The default message identifier for AV_Waypoints_B_Y3 is 0x130 (304)

/// For decoding this is the required length of a decodable message. If the message
/// is smaller there is data missing.
/// For encoding this the length of the CAN message encoded by this class assuming all
/// setters have been called. This value should be one greater than the largest index
/// written to by any of the setter methods.
const uint8_t AV_WAYPOINTS_B_Y3_PACKET_LEN = UINT8_C(32);
} // namespace AV_Waypoints_B_Y3_CONSTS

class AV_Waypoints_B_Y3
{
public:
    AV_Waypoints_B_Y3(const uint32_t id);
    AV_Waypoints_B_Y3(const uint32_t id, uint8_t* const payload, const uint8_t size);

    double getCRC_AV_Waypoints_B_Y3() const noexcept;
    double getALIV_AV_Waypoints_B_Y3() const noexcept;
    /// Units: m
    double getL_Waypoint_B_Y35() const noexcept;
    /// Units: m
    double getL_Waypoint_B_Y36() const noexcept;
    /// Units: m
    double getL_Waypoint_B_Y37() const noexcept;
    /// Units: m
    double getL_Waypoint_B_Y38() const noexcept;
    /// Units: m
    double getL_Waypoint_B_Y39() const noexcept;
    /// Units: m
    double getL_Waypoint_B_Y40() const noexcept;
    /// Units: m
    double getL_Waypoint_B_Y41() const noexcept;
    /// Units: m
    double getL_Waypoint_B_Y42() const noexcept;
    /// Units: m
    double getL_Waypoint_B_Y43() const noexcept;
    /// Units: m
    double getL_Waypoint_B_Y44() const noexcept;
    /// Units: m
    double getL_Waypoint_B_Y45() const noexcept;
    /// Units: m
    double getL_Waypoint_B_Y46() const noexcept;
    /// Units: m
    double getL_Waypoint_B_Y47() const noexcept;
    /// Units: m
    double getL_Waypoint_B_Y48() const noexcept;
    /// Units: m
    double getL_Waypoint_B_Y49() const noexcept;
    /// Units: m
    double getL_Waypoint_B_Y50() const noexcept;
    /// @brief signal comment: Ycoordinate51 for Trajectory B, Segment 3
    /// Units: m
    double getL_Waypoint_B_Y51() const noexcept;

    int64_t setCRC_AV_Waypoints_B_Y3(const double value) noexcept;
    int64_t setALIV_AV_Waypoints_B_Y3(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_B_Y35(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_B_Y36(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_B_Y37(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_B_Y38(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_B_Y39(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_B_Y40(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_B_Y41(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_B_Y42(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_B_Y43(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_B_Y44(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_B_Y45(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_B_Y46(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_B_Y47(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_B_Y48(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_B_Y49(const double value) noexcept;
    /// Units: m
    int64_t setL_Waypoint_B_Y50(const double value) noexcept;
    /// @brief signal comment: Ycoordinate51 for Trajectory B, Segment 3
    /// Units: m
    int64_t setL_Waypoint_B_Y51(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::avproto

#endif
