/// @copyright Copyright (c) 2022 - Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file:
/// https://gitlab.ci.motional.com/systems/av-netwrok-infrastructure/Gen2-AVT-Sample-B/-/blob/dd539e5d752bcae0408ed2b8f29b270cc0db624e/Gen2_AVT_B_Control_CAN2.dbc

#ifndef R_AV_BodyCMD_02_B2_200ms_av_proto_H_
#define R_AV_BodyCMD_02_B2_200ms_av_proto_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::avproto {

namespace R_AV_BodyCMD_02_B2_200ms_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

/// This class contains members for decoding/encoding the CAN message R_AV_BodyCMD_02_B2_200ms
/// The default message identifier for R_AV_BodyCMD_02_B2_200ms is 0x7a (122)

/// For decoding this is the required length of a decodable message. If the message
/// is smaller there is data missing.
/// For encoding this the length of the CAN message encoded by this class assuming all
/// setters have been called. This value should be one greater than the largest index
/// written to by any of the setter methods.
const uint8_t R_AV_BODYCMD_02_B2_200MS_PACKET_LEN = UINT8_C(8);
} // namespace R_AV_BodyCMD_02_B2_200ms_CONSTS

class R_AV_BodyCMD_02_B2_200ms
{
public:
    R_AV_BodyCMD_02_B2_200ms(const uint32_t id);
    R_AV_BodyCMD_02_B2_200ms(const uint32_t id, uint8_t* const payload, const uint8_t size);

    /// @brief signal comment: AV_BodyCMD_CyclicRedundancyCheck2_B2Value
    double getR_AV_BodyCMD_Crc2_B2Val() const noexcept;
    /// @brief signal comment: AV_BodyCMD_AliveCounter2_B2Value
    double getR_AV_BodyCMD_AlvCnt2_B2Val() const noexcept;
    /// @brief signal comment: DoorLock / Uinlock Command
    double getR_B2_01_DrLkUnLkCmd() const noexcept;
    /// @brief signal comment: Head Lamp Low beam on/off command
    double getR_B2_01_HdLmpLoOnCmd() const noexcept;
    /// @brief signal comment: Head Lamp High beam on/off command
    double getR_B2_01_HdLmpHiOnCmd() const noexcept;
    /// @brief signal comment: Windshield_wiper_control_front command
    double getR_B2_01_WshdWiperCmd() const noexcept;
    /// @brief signal comment: Turn_Signal_Left_command
    double getR_B2_01_Turn_Signal_Lf() const noexcept;
    /// @brief signal comment: Turn_Signal_Right_command
    double getR_B2_01_Turn_Signal_Rt() const noexcept;

    /// @brief signal comment: AV_BodyCMD_CyclicRedundancyCheck2_B2Value
    int64_t setR_AV_BodyCMD_Crc2_B2Val(const double value) noexcept;
    /// @brief signal comment: AV_BodyCMD_AliveCounter2_B2Value
    int64_t setR_AV_BodyCMD_AlvCnt2_B2Val(const double value) noexcept;
    /// @brief signal comment: DoorLock / Uinlock Command
    int64_t setR_B2_01_DrLkUnLkCmd(const double value) noexcept;
    /// @brief signal comment: Head Lamp Low beam on/off command
    int64_t setR_B2_01_HdLmpLoOnCmd(const double value) noexcept;
    /// @brief signal comment: Head Lamp High beam on/off command
    int64_t setR_B2_01_HdLmpHiOnCmd(const double value) noexcept;
    /// @brief signal comment: Windshield_wiper_control_front command
    int64_t setR_B2_01_WshdWiperCmd(const double value) noexcept;
    /// @brief signal comment: Turn_Signal_Left_command
    int64_t setR_B2_01_Turn_Signal_Lf(const double value) noexcept;
    /// @brief signal comment: Turn_Signal_Right_command
    int64_t setR_B2_01_Turn_Signal_Rt(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::avproto

#endif
