/// @copyright Copyright (c) 2022 - Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file:
/// https://gitlab.ci.motional.com/systems/av-netwrok-infrastructure/Gen2-AVT-Sample-B/-/blob/dd539e5d752bcae0408ed2b8f29b270cc0db624e/Gen2_AVT_B_Control_CAN2.dbc

#ifndef R_AV_Dynamics_Request_av_proto_H_
#define R_AV_Dynamics_Request_av_proto_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::avproto {

namespace R_AV_Dynamics_Request_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

/// This class contains members for decoding/encoding the CAN message R_AV_Dynamics_Request
/// The default message identifier for R_AV_Dynamics_Request is 0x10c (268)

/// For decoding this is the required length of a decodable message. If the message
/// is smaller there is data missing.
/// For encoding this the length of the CAN message encoded by this class assuming all
/// setters have been called. This value should be one greater than the largest index
/// written to by any of the setter methods.
const uint8_t R_AV_DYNAMICS_REQUEST_PACKET_LEN = UINT8_C(32);
} // namespace R_AV_Dynamics_Request_CONSTS

class R_AV_Dynamics_Request
{
public:
    R_AV_Dynamics_Request(const uint32_t id);
    R_AV_Dynamics_Request(const uint32_t id, uint8_t* const payload, const uint8_t size);

    /// @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
    double getR_CRC_AV_Dynamics_Request() const noexcept;
    /// @brief signal comment: Alive Counter, E2E Profile 5
    double getR_ALIV_AV_Dynamics_Request() const noexcept;
    /// @brief signal comment: Target Speed Request
    /// Units: m/s
    double getR_v_TargetSpeed_Rq() const noexcept;
    /// @brief signal comment: Feed Forward Acceleration Request
    /// Units: m/s^2
    double getR_a_FeedForwardAccel_Rq() const noexcept;
    /// @brief signal comment: Road Wheel Angle Request
    /// Units: rad
    double getR_u_RoadWheelAngle_Rq() const noexcept;
    /// @brief signal comment: Road Wheel Angle Rate Request
    /// Units: rad/s
    double getR_w_RoadWheelAngleRate_Rq() const noexcept;
    /// @brief signal comment: Road Wheel Angle acceleraton Request
    /// Units: rad/s^2
    double getR_a_RoadWheelAngleAccel_Rq() const noexcept;
    /// @brief signal comment: Placeholder for SecOC Freshness Value
    double getR_FV_AV_Dynamics_Request() const noexcept;
    /// @brief signal comment: Placeholder for SecOC Authenticator
    double getR_AUTH_AV_Dynamics_Request() const noexcept;

    /// @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
    int64_t setR_CRC_AV_Dynamics_Request(const double value) noexcept;
    /// @brief signal comment: Alive Counter, E2E Profile 5
    int64_t setR_ALIV_AV_Dynamics_Request(const double value) noexcept;
    /// @brief signal comment: Target Speed Request
    /// Units: m/s
    int64_t setR_v_TargetSpeed_Rq(const double value) noexcept;
    /// @brief signal comment: Feed Forward Acceleration Request
    /// Units: m/s^2
    int64_t setR_a_FeedForwardAccel_Rq(const double value) noexcept;
    /// @brief signal comment: Road Wheel Angle Request
    /// Units: rad
    int64_t setR_u_RoadWheelAngle_Rq(const double value) noexcept;
    /// @brief signal comment: Road Wheel Angle Rate Request
    /// Units: rad/s
    int64_t setR_w_RoadWheelAngleRate_Rq(const double value) noexcept;
    /// @brief signal comment: Road Wheel Angle acceleraton Request
    /// Units: rad/s^2
    int64_t setR_a_RoadWheelAngleAccel_Rq(const double value) noexcept;
    /// @brief signal comment: Placeholder for SecOC Freshness Value
    int64_t setR_FV_AV_Dynamics_Request(const double value) noexcept;
    /// @brief signal comment: Placeholder for SecOC Authenticator
    int64_t setR_AUTH_AV_Dynamics_Request(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::avproto

#endif
