/// @copyright Copyright (c) 2022 - Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file:
/// https://gitlab.ci.motional.com/systems/av-netwrok-infrastructure/Gen2-AVT-Sample-B/-/blob/dd539e5d752bcae0408ed2b8f29b270cc0db624e/Gen2_AVT_B_Control_CAN2.dbc

#ifndef R_AV_Heading_B_1_av_proto_H_
#define R_AV_Heading_B_1_av_proto_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::avproto {

namespace R_AV_Heading_B_1_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

/// This class contains members for decoding/encoding the CAN message R_AV_Heading_B_1
/// The default message identifier for R_AV_Heading_B_1 is 0x146 (326)

/// For decoding this is the required length of a decodable message. If the message
/// is smaller there is data missing.
/// For encoding this the length of the CAN message encoded by this class assuming all
/// setters have been called. This value should be one greater than the largest index
/// written to by any of the setter methods.
const uint8_t R_AV_HEADING_B_1_PACKET_LEN = UINT8_C(32);
} // namespace R_AV_Heading_B_1_CONSTS

class R_AV_Heading_B_1
{
public:
    R_AV_Heading_B_1(const uint32_t id);
    R_AV_Heading_B_1(const uint32_t id, uint8_t* const payload, const uint8_t size);

    /// @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
    double getR_CRC_AV_Heading_B_1() const noexcept;
    /// @brief signal comment: Alive Counter, E2E Profile 5
    double getR_ALIV_AV_Heading_B_1() const noexcept;
    /// @brief signal comment: Heading angle1 for Trajectory B, Segment 1
    /// Units: rad
    double getR_u_Heading_B_1() const noexcept;
    /// Units: rad
    double getR_u_Heading_B_2() const noexcept;
    /// Units: rad
    double getR_u_Heading_B_3() const noexcept;
    /// Units: rad
    double getR_u_Heading_B_4() const noexcept;
    /// Units: rad
    double getR_u_Heading_B_5() const noexcept;
    /// Units: rad
    double getR_u_Heading_B_6() const noexcept;
    /// Units: rad
    double getR_u_Heading_B_7() const noexcept;
    /// Units: rad
    double getR_u_Heading_B_8() const noexcept;
    /// Units: rad
    double getR_u_Heading_B_9() const noexcept;
    /// Units: rad
    double getR_u_Heading_B_10() const noexcept;
    /// Units: rad
    double getR_u_Heading_B_11() const noexcept;
    /// Units: rad
    double getR_u_Heading_B_12() const noexcept;
    /// Units: rad
    double getR_u_Heading_B_13() const noexcept;
    /// Units: rad
    double getR_u_Heading_B_14() const noexcept;
    /// Units: rad
    double getR_u_Heading_B_15() const noexcept;
    /// Units: rad
    double getR_u_Heading_B_16() const noexcept;
    /// @brief signal comment: Heading angle17 for Trajectory B, Segment 1
    /// Units: rad
    double getR_u_Heading_B_17() const noexcept;

    /// @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
    int64_t setR_CRC_AV_Heading_B_1(const double value) noexcept;
    /// @brief signal comment: Alive Counter, E2E Profile 5
    int64_t setR_ALIV_AV_Heading_B_1(const double value) noexcept;
    /// @brief signal comment: Heading angle1 for Trajectory B, Segment 1
    /// Units: rad
    int64_t setR_u_Heading_B_1(const double value) noexcept;
    /// Units: rad
    int64_t setR_u_Heading_B_2(const double value) noexcept;
    /// Units: rad
    int64_t setR_u_Heading_B_3(const double value) noexcept;
    /// Units: rad
    int64_t setR_u_Heading_B_4(const double value) noexcept;
    /// Units: rad
    int64_t setR_u_Heading_B_5(const double value) noexcept;
    /// Units: rad
    int64_t setR_u_Heading_B_6(const double value) noexcept;
    /// Units: rad
    int64_t setR_u_Heading_B_7(const double value) noexcept;
    /// Units: rad
    int64_t setR_u_Heading_B_8(const double value) noexcept;
    /// Units: rad
    int64_t setR_u_Heading_B_9(const double value) noexcept;
    /// Units: rad
    int64_t setR_u_Heading_B_10(const double value) noexcept;
    /// Units: rad
    int64_t setR_u_Heading_B_11(const double value) noexcept;
    /// Units: rad
    int64_t setR_u_Heading_B_12(const double value) noexcept;
    /// Units: rad
    int64_t setR_u_Heading_B_13(const double value) noexcept;
    /// Units: rad
    int64_t setR_u_Heading_B_14(const double value) noexcept;
    /// Units: rad
    int64_t setR_u_Heading_B_15(const double value) noexcept;
    /// Units: rad
    int64_t setR_u_Heading_B_16(const double value) noexcept;
    /// @brief signal comment: Heading angle17 for Trajectory B, Segment 1
    /// Units: rad
    int64_t setR_u_Heading_B_17(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::avproto

#endif
