/// @copyright Copyright (c) 2022 - Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file:
/// https://gitlab.ci.motional.com/systems/av-netwrok-infrastructure/Gen2-AVT-Sample-B/-/blob/dd539e5d752bcae0408ed2b8f29b270cc0db624e/Gen2_AVT_B_Control_CAN2.dbc

#ifndef R_AV_Protocol_Version_av_proto_H_
#define R_AV_Protocol_Version_av_proto_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::avproto {

namespace R_AV_Protocol_Version_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

/// This class contains members for decoding/encoding the CAN message R_AV_Protocol_Version
/// The default message identifier for R_AV_Protocol_Version is 0x380 (896)

/// For decoding this is the required length of a decodable message. If the message
/// is smaller there is data missing.
/// For encoding this the length of the CAN message encoded by this class assuming all
/// setters have been called. This value should be one greater than the largest index
/// written to by any of the setter methods.
const uint8_t R_AV_PROTOCOL_VERSION_PACKET_LEN = UINT8_C(32);
} // namespace R_AV_Protocol_Version_CONSTS

class R_AV_Protocol_Version
{
public:
    R_AV_Protocol_Version(const uint32_t id);
    R_AV_Protocol_Version(const uint32_t id, uint8_t* const payload, const uint8_t size);

    /// @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
    double getR_CRC_AV_Protocol_Version() const noexcept;
    /// @brief signal comment: Alive Counter, E2E Profile 5
    double getR_ALIV_AV_Protocol_Version() const noexcept;
    /// @brief signal comment: dbc release major version compatiblity published by the AV
    double getR_AV_Protocol_Major() const noexcept;
    /// @brief signal comment: dbc release minor version compatiblity published by the AV
    double getR_AV_Protocol_Minor() const noexcept;
    /// @brief signal comment: Placeholder for SecOC Freshness Value
    double getR_FV_AV_Protocol_Version() const noexcept;
    /// @brief signal comment: Placeholder for SecOC Authenticator
    double getR_AUTH_AV_Protocol_Version() const noexcept;

    /// @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
    int64_t setR_CRC_AV_Protocol_Version(const double value) noexcept;
    /// @brief signal comment: Alive Counter, E2E Profile 5
    int64_t setR_ALIV_AV_Protocol_Version(const double value) noexcept;
    /// @brief signal comment: dbc release major version compatiblity published by the AV
    int64_t setR_AV_Protocol_Major(const double value) noexcept;
    /// @brief signal comment: dbc release minor version compatiblity published by the AV
    int64_t setR_AV_Protocol_Minor(const double value) noexcept;
    /// @brief signal comment: Placeholder for SecOC Freshness Value
    int64_t setR_FV_AV_Protocol_Version(const double value) noexcept;
    /// @brief signal comment: Placeholder for SecOC Authenticator
    int64_t setR_AUTH_AV_Protocol_Version(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::avproto

#endif
