/// @copyright Copyright (c) 2022 - Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file:
/// https://gitlab.ci.motional.com/systems/av-netwrok-infrastructure/Gen2-AVT-Sample-B/-/blob/dd539e5d752bcae0408ed2b8f29b270cc0db624e/Gen2_AVT_B_Control_CAN2.dbc

#ifndef R_AV_System_Status_av_proto_H_
#define R_AV_System_Status_av_proto_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::avproto {

namespace R_AV_System_Status_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

/// This class contains members for decoding/encoding the CAN message R_AV_System_Status
/// The default message identifier for R_AV_System_Status is 0x221 (545)

/// For decoding this is the required length of a decodable message. If the message
/// is smaller there is data missing.
/// For encoding this the length of the CAN message encoded by this class assuming all
/// setters have been called. This value should be one greater than the largest index
/// written to by any of the setter methods.
const uint8_t R_AV_SYSTEM_STATUS_PACKET_LEN = UINT8_C(32);
} // namespace R_AV_System_Status_CONSTS

class R_AV_System_Status
{
public:
    R_AV_System_Status(const uint32_t id);
    R_AV_System_Status(const uint32_t id, uint8_t* const payload, const uint8_t size);

    /// @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
    double getR_CRC_AV_System_Status() const noexcept;
    /// @brief signal comment: Alive Counter, E2E Profile 5
    double getR_ALIV_AV_System_Status() const noexcept;
    /// @brief signal comment: X axis propulsion direction
    double getR_B_PropulsionDirection() const noexcept;
    /// @brief signal comment: AVSIS Stack indication system
    double getR_sts_AVState() const noexcept;
    /// @brief signal comment: AV health state used for determining AVSIS state
    double getR_sts_HealthState() const noexcept;
    /// @brief signal comment: AV System State Machine status
    double getR_sts_AVSSM_State() const noexcept;
    /// @brief signal comment: Authentication Switch Position
    double getR_sts_AVMode_Rq() const noexcept;
    /// @brief signal comment: Placeholder for SecOC Authenticator
    double getR_AUTH_AV_System_Status() const noexcept;
    /// @brief signal comment: Placeholder for SecOC Freshness Value
    double getR_FV_AV_System_Status() const noexcept;

    /// @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
    int64_t setR_CRC_AV_System_Status(const double value) noexcept;
    /// @brief signal comment: Alive Counter, E2E Profile 5
    int64_t setR_ALIV_AV_System_Status(const double value) noexcept;
    /// @brief signal comment: X axis propulsion direction
    int64_t setR_B_PropulsionDirection(const double value) noexcept;
    /// @brief signal comment: AVSIS Stack indication system
    int64_t setR_sts_AVState(const double value) noexcept;
    /// @brief signal comment: AV health state used for determining AVSIS state
    int64_t setR_sts_HealthState(const double value) noexcept;
    /// @brief signal comment: AV System State Machine status
    int64_t setR_sts_AVSSM_State(const double value) noexcept;
    /// @brief signal comment: Authentication Switch Position
    int64_t setR_sts_AVMode_Rq(const double value) noexcept;
    /// @brief signal comment: Placeholder for SecOC Authenticator
    int64_t setR_AUTH_AV_System_Status(const double value) noexcept;
    /// @brief signal comment: Placeholder for SecOC Freshness Value
    int64_t setR_FV_AV_System_Status(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::avproto

#endif
