/// @copyright Copyright (c) 2022 - Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file:
/// https://gitlab.ci.motional.com/systems/av-netwrok-infrastructure/Gen2-AVT-Sample-B/-/blob/dd539e5d752bcae0408ed2b8f29b270cc0db624e/Gen2_AVT_B_Control_CAN2.dbc

#ifndef R_AV_Waypoint_Speeds_A_3_av_proto_H_
#define R_AV_Waypoint_Speeds_A_3_av_proto_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::avproto {

namespace R_AV_Waypoint_Speeds_A_3_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

/// This class contains members for decoding/encoding the CAN message R_AV_Waypoint_Speeds_A_3
/// The default message identifier for R_AV_Waypoint_Speeds_A_3 is 0x139 (313)

/// For decoding this is the required length of a decodable message. If the message
/// is smaller there is data missing.
/// For encoding this the length of the CAN message encoded by this class assuming all
/// setters have been called. This value should be one greater than the largest index
/// written to by any of the setter methods.
const uint8_t R_AV_WAYPOINT_SPEEDS_A_3_PACKET_LEN = UINT8_C(32);
} // namespace R_AV_Waypoint_Speeds_A_3_CONSTS

class R_AV_Waypoint_Speeds_A_3
{
public:
    R_AV_Waypoint_Speeds_A_3(const uint32_t id);
    R_AV_Waypoint_Speeds_A_3(const uint32_t id, uint8_t* const payload, const uint8_t size);

    double getR_CRC_AV_Waypoint_Speeds_A_3() const noexcept;
    double getR_ALIV_AV_Waypoint_Speeds_A_3() const noexcept;
    /// Units: m/s
    double getR_v_WaypointSpeed_A_35() const noexcept;
    /// Units: m/s
    double getR_v_WaypointSpeed_A_36() const noexcept;
    /// Units: m/s
    double getR_v_WaypointSpeed_A_37() const noexcept;
    /// Units: m/s
    double getR_v_WaypointSpeed_A_38() const noexcept;
    /// Units: m/s
    double getR_v_WaypointSpeed_A_39() const noexcept;
    /// Units: m/s
    double getR_v_WaypointSpeed_A_40() const noexcept;
    /// Units: m/s
    double getR_v_WaypointSpeed_A_41() const noexcept;
    /// Units: m/s
    double getR_v_WaypointSpeed_A_42() const noexcept;
    /// Units: m/s
    double getR_v_WaypointSpeed_A_43() const noexcept;
    /// Units: m/s
    double getR_v_WaypointSpeed_A_44() const noexcept;
    /// Units: m/s
    double getR_v_WaypointSpeed_A_45() const noexcept;
    /// Units: m/s
    double getR_v_WaypointSpeed_A_46() const noexcept;
    /// Units: m/s
    double getR_v_WaypointSpeed_A_47() const noexcept;
    /// Units: m/s
    double getR_v_WaypointSpeed_A_48() const noexcept;
    /// Units: m/s
    double getR_v_WaypointSpeed_A_49() const noexcept;
    /// Units: m/s
    double getR_v_WaypointSpeed_A_50() const noexcept;
    /// @brief signal comment: Speed51 for Trajectory A, Segment 3
    /// Units: m/s
    double getR_v_WaypointSpeed_A_51() const noexcept;

    int64_t setR_CRC_AV_Waypoint_Speeds_A_3(const double value) noexcept;
    int64_t setR_ALIV_AV_Waypoint_Speeds_A_3(const double value) noexcept;
    /// Units: m/s
    int64_t setR_v_WaypointSpeed_A_35(const double value) noexcept;
    /// Units: m/s
    int64_t setR_v_WaypointSpeed_A_36(const double value) noexcept;
    /// Units: m/s
    int64_t setR_v_WaypointSpeed_A_37(const double value) noexcept;
    /// Units: m/s
    int64_t setR_v_WaypointSpeed_A_38(const double value) noexcept;
    /// Units: m/s
    int64_t setR_v_WaypointSpeed_A_39(const double value) noexcept;
    /// Units: m/s
    int64_t setR_v_WaypointSpeed_A_40(const double value) noexcept;
    /// Units: m/s
    int64_t setR_v_WaypointSpeed_A_41(const double value) noexcept;
    /// Units: m/s
    int64_t setR_v_WaypointSpeed_A_42(const double value) noexcept;
    /// Units: m/s
    int64_t setR_v_WaypointSpeed_A_43(const double value) noexcept;
    /// Units: m/s
    int64_t setR_v_WaypointSpeed_A_44(const double value) noexcept;
    /// Units: m/s
    int64_t setR_v_WaypointSpeed_A_45(const double value) noexcept;
    /// Units: m/s
    int64_t setR_v_WaypointSpeed_A_46(const double value) noexcept;
    /// Units: m/s
    int64_t setR_v_WaypointSpeed_A_47(const double value) noexcept;
    /// Units: m/s
    int64_t setR_v_WaypointSpeed_A_48(const double value) noexcept;
    /// Units: m/s
    int64_t setR_v_WaypointSpeed_A_49(const double value) noexcept;
    /// Units: m/s
    int64_t setR_v_WaypointSpeed_A_50(const double value) noexcept;
    /// @brief signal comment: Speed51 for Trajectory A, Segment 3
    /// Units: m/s
    int64_t setR_v_WaypointSpeed_A_51(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::avproto

#endif
