/// @copyright Copyright (c) 2022 - Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file:
/// https://gitlab.ci.motional.com/systems/av-netwrok-infrastructure/Gen2-AVT-Sample-B/-/blob/dd539e5d752bcae0408ed2b8f29b270cc0db624e/Gen2_AVT_B_Control_CAN2.dbc

#ifndef R_AV_Waypoints_B_Y4_av_proto_H_
#define R_AV_Waypoints_B_Y4_av_proto_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::avproto {

namespace R_AV_Waypoints_B_Y4_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

/// This class contains members for decoding/encoding the CAN message R_AV_Waypoints_B_Y4
/// The default message identifier for R_AV_Waypoints_B_Y4 is 0x131 (305)

/// For decoding this is the required length of a decodable message. If the message
/// is smaller there is data missing.
/// For encoding this the length of the CAN message encoded by this class assuming all
/// setters have been called. This value should be one greater than the largest index
/// written to by any of the setter methods.
const uint8_t R_AV_WAYPOINTS_B_Y4_PACKET_LEN = UINT8_C(32);
} // namespace R_AV_Waypoints_B_Y4_CONSTS

class R_AV_Waypoints_B_Y4
{
public:
    R_AV_Waypoints_B_Y4(const uint32_t id);
    R_AV_Waypoints_B_Y4(const uint32_t id, uint8_t* const payload, const uint8_t size);

    double getR_CRC_AV_Waypoints_B_Y4() const noexcept;
    double getR_ALIV_AV_Waypoints_B_Y4() const noexcept;
    /// Units: m
    double getR_L_Waypoint_B_Y52() const noexcept;
    /// Units: m
    double getR_L_Waypoint_B_Y53() const noexcept;
    /// Units: m
    double getR_L_Waypoint_B_Y54() const noexcept;
    /// Units: m
    double getR_L_Waypoint_B_Y55() const noexcept;
    /// Units: m
    double getR_L_Waypoint_B_Y56() const noexcept;
    /// Units: m
    double getR_L_Waypoint_B_Y57() const noexcept;
    /// Units: m
    double getR_L_Waypoint_B_Y58() const noexcept;
    /// Units: m
    double getR_L_Waypoint_B_Y59() const noexcept;
    /// @brief signal comment: Ycoordinate60 for Trajectory B, Segment 4
    /// Units: m
    double getR_L_Waypoint_B_Y60() const noexcept;

    int64_t setR_CRC_AV_Waypoints_B_Y4(const double value) noexcept;
    int64_t setR_ALIV_AV_Waypoints_B_Y4(const double value) noexcept;
    /// Units: m
    int64_t setR_L_Waypoint_B_Y52(const double value) noexcept;
    /// Units: m
    int64_t setR_L_Waypoint_B_Y53(const double value) noexcept;
    /// Units: m
    int64_t setR_L_Waypoint_B_Y54(const double value) noexcept;
    /// Units: m
    int64_t setR_L_Waypoint_B_Y55(const double value) noexcept;
    /// Units: m
    int64_t setR_L_Waypoint_B_Y56(const double value) noexcept;
    /// Units: m
    int64_t setR_L_Waypoint_B_Y57(const double value) noexcept;
    /// Units: m
    int64_t setR_L_Waypoint_B_Y58(const double value) noexcept;
    /// Units: m
    int64_t setR_L_Waypoint_B_Y59(const double value) noexcept;
    /// @brief signal comment: Ycoordinate60 for Trajectory B, Segment 4
    /// Units: m
    int64_t setR_L_Waypoint_B_Y60(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::avproto

#endif
