/// @copyright Copyright (c) 2022 - Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file:
/// https://gitlab.ci.motional.com/systems/av-netwrok-infrastructure/Gen2-AVT-Sample-B/-/blob/dd539e5d752bcae0408ed2b8f29b270cc0db624e/Gen2_AVT_B_Control_CAN2.dbc

#ifndef R_VIC_BodyCtrl_FB_01A_PE_200ms_av_proto_H_
#define R_VIC_BodyCtrl_FB_01A_PE_200ms_av_proto_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::avproto {

namespace R_VIC_BodyCtrl_FB_01A_PE_200ms_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

/// This class contains members for decoding/encoding the CAN message R_VIC_BodyCtrl_FB_01A_PE_200ms
/// The default message identifier for R_VIC_BodyCtrl_FB_01A_PE_200ms is 0x92 (146)

/// For decoding this is the required length of a decodable message. If the message
/// is smaller there is data missing.
/// For encoding this the length of the CAN message encoded by this class assuming all
/// setters have been called. This value should be one greater than the largest index
/// written to by any of the setter methods.
const uint8_t R_VIC_BODYCTRL_FB_01A_PE_200MS_PACKET_LEN = UINT8_C(32);
} // namespace R_VIC_BodyCtrl_FB_01A_PE_200ms_CONSTS

class R_VIC_BodyCtrl_FB_01A_PE_200ms
{
public:
    R_VIC_BodyCtrl_FB_01A_PE_200ms(const uint32_t id);
    R_VIC_BodyCtrl_FB_01A_PE_200ms(const uint32_t id, uint8_t* const payload, const uint8_t size);

    /// @brief signal comment: ACU_CyclicRedundancyCheck1Value
    double getR_VIC_BodyCtrl_FB_01A_Crc1Val() const noexcept;
    /// @brief signal comment: ACU_AliveCounter1Value
    double getR_VIC_BodyCtrl_FB_01A_AlvCnt1Val() const noexcept;
    /// @brief signal comment: Lamp_HeadLampLowStatus ##2G##BCM - BCMmsg20 - C_HLpLowAct
    double getR_Lamp_HdLmpLoSta() const noexcept;
    /// @brief signal comment: Lamp_LedHeadLampStatus ##2G## -  - CF_Afs_LedHLStat
    double getR_Lamp_LedHdLmpSta() const noexcept;
    /// @brief signal comment: Lamp_HeadLampLowRightOpenStatus ##2G## -  - C_HLampLowRhOpenSts
    double getR_Lamp_HdLmpLoRtOpnSta() const noexcept;
    /// @brief signal comment: Lamp_HeadLampLowLeftOpenStatus ##2G## -  - C_HLampLowLhOpenSts
    double getR_Lamp_HdLmpLoLftOpnSta() const noexcept;
    /// @brief signal comment: Lamp_HeadLampHighStatus ##2G##BCM - BCMmsg20 - C_HLpHighAct
    double getR_Lamp_HdLmpHiSta() const noexcept;
    /// @brief signal comment: Lamp_HeadLampHighRightOpenStatus ##2G## -  - C_HLampHighRhOpenSts
    double getR_Lamp_HdLmpHiRtOpnSta() const noexcept;
    /// @brief signal comment: Lamp_HeadLampHighLeftOpenStatus ##2G## -  - C_HLampHighLhOpenSts
    double getR_Lamp_HdLmpHiLftOpnSta() const noexcept;
    /// @brief signal comment: Headlamps low beam PCL status on RH
    double getR_Lamp_Hdlmp_Low_PCLstatus_RH() const noexcept;
    /// @brief signal comment: Headlamps low beam PCL status on LH
    double getR_Lamp_Hdlmp_Low_PCLstatus_LH() const noexcept;
    /// @brief signal comment: ExtLamp_HazardSwitchStatus ##2G## -  - C_HazardSw,CF_Gway_HazardSw
    double getR_ExtLamp_HzrdSwSta() const noexcept;
    /// @brief signal comment: Lamp_TurnSignalLampLeftActiveState
    double getR_Lamp_TrnSigLmpLftActiveSt() const noexcept;
    /// @brief signal comment: Lamp_TurnSignalLampRightActiveState
    double getR_Lamp_TrnSigLmpRtActiveSt() const noexcept;
    /// @brief signal comment: ExtLamp_TurnSignalLampLeftBlinkingStatus ##2G## -  - CF_Gway_TurnSigLh,C_TSigLhAct
    double getR_ExtLamp_TrnSigLmpLftBlnkngSta() const noexcept;
    /// @brief signal comment: ExtLamp_TurnSignalLampRightBlinkingStatus ##2G## -  - CF_Gway_TurnSigRh,C_TSigRhAct
    double getR_ExtLamp_TrnSigLmpRtBlnkngSta() const noexcept;
    /// @brief signal comment: Lamp_RearTurnSignalLampLeftOpenStatus ##2G## -  - C_RearTSIGLhOpenSts
    double getR_Lamp_RrTrnSigLmpLftOpnSta() const noexcept;
    /// @brief signal comment: Lamp_RearTurnSignalLampRightOpenStatus ##2G## -  - C_RearTSIGRhOpenSts
    double getR_Lamp_RrTrnSigLmpRtOpnSta() const noexcept;
    /// @brief signal comment: Lamp_FrontTurnSignalLampLeftOpenStatus ##2G## -  - C_FrontTSIGLhOpenSts
    double getR_Lamp_FrTrnSigLmpLftOpnSta() const noexcept;
    /// @brief signal comment: Lamp_FrontTurnSignalLampRightOpenStatus ##2G## -  - C_FrontTSIGRhOpenSts
    double getR_Lamp_FrTrnSigLmpRtOpnSta() const noexcept;
    /// @brief signal comment: Front left flasher lamp PCL
    double getR_Lamp_FrTrnSigLmpLftPCLSta() const noexcept;
    /// @brief signal comment: Front right flasher lamp PCL
    double getR_Lamp_FrTrnSigLmpRtPCLSta() const noexcept;
    /// @brief signal comment: Rear left flasher lamp PCL
    double getR_Lamp_RrTrnSigLmpLftPCLSta() const noexcept;
    /// @brief signal comment: Rear right flasher lamp PCL
    double getR_Lamp_RrTrnSigLmpRtPCLSta() const noexcept;
    double getR_ExtLamp_StpLmpSta() const noexcept;
    /// @brief signal comment: Lamp_StopLampLeftOpenStatus ##2G## -  - C_StopLampLhOpenSts
    double getR_Lamp_StpLmpLftOpnSta() const noexcept;
    /// @brief signal comment: Lamp_StopLampRightOpenStatus ##2G## -  - C_StopLampRhOpenSts
    double getR_Lamp_StpLmpRtOpnSta() const noexcept;
    /// @brief signal comment: This signal is used for control the Back-up Lamp function.
    double getR_ExtLamp_BckUpLmpSta() const noexcept;
    /// @brief signal comment: Lamp_AutoLightSensorNightStatus ##2G##BCM - BCMmsg24 - C_AutolightValue
    double getR_Lamp_AutoLtSnsrNightSta() const noexcept;
    /// @brief signal comment: Lamp_AutoLightSensorHorValue ##2G##BCM - BCMmsg24 - C_AutolightSensorHorState
    double getR_Lamp_AutoLtSnsrHorVal() const noexcept;
    /// @brief signal comment: Lamp_AutoLightSensorVerValue ##2G##BCM - BCMmsg24 - C_AutolightSensorVerState
    double getR_Lamp_AutoLtSnsrVerVal() const noexcept;
    double getR_Wiper_RainAmount() const noexcept;
    /// @brief signal comment: Wiper_RainSensorStatus ##2G##BCM - BCMmsg24 - C_RainSnsState
    double getR_Wiper_RainSnsrSta() const noexcept;
    double getR_Wiper_WiperRlyFRSta() const noexcept;
    /// @brief signal comment: Wiper_RearWiperWasherSwitchStatus
    double getR_Wiper_RrWiperWshSwSta() const noexcept;
    /// @brief signal comment: Wiper_IntermittentStepStatus
    double getR_Wiper_IntStepSta() const noexcept;
    /// @brief signal comment: DoorLock_DriverDoorUnLockStatus ##2G## -  - C_DrvUnlockState,CF_Gway_DrvUnlockState
    double getR_DoorLock_DrvDrUnLkSta() const noexcept;
    /// @brief signal comment: DoorLock_DriverDoorSwitchStatus ##2G## -  - C_DrvDrSw,CF_Gway_DrvDrSw,Warn_DrvDrSwSta
    double getR_Warn_DrvDrSwSta() const noexcept;
    /// @brief signal comment: DoorLock_AssistDoorUnLockStatus ##2G## -  - C_AstUnlockState,DoorLock_AsstDrUnLkSta
    double getR_DoorLock_AsstDrUnLkSta() const noexcept;
    /// @brief signal comment: Warn_AssistDoorSwitchStatus ##2G## -  - C_AstDrSw,CF_Gway_AstDrSw,Warn_AsstDrSwSta
    double getR_Warn_AsstDrSwSta() const noexcept;
    double getR_SBCM_AST_DoorStatus() const noexcept;
    double getR_SBCM_AST_Door_Blocked() const noexcept;
    /// @brief signal comment: DoorLock_RearLeftDoorUnLockStatus ##2G## -  - C_RLUnlockState,DoorLock_RrLftDrUnLkSta
    double getR_DoorLock_RrLftDrUnLkSta() const noexcept;
    /// @brief signal comment: Warn_RearLeftDoorSwitchStatus ##2G## -  - C_RLDrSw,CF_Gway_RLDrSw,Warn_RrLftDrSwSta
    double getR_Warn_RrLftDrSwSta() const noexcept;
    double getR_SBCM_RL_DoorStatus() const noexcept;
    double getR_SBCM_RL_Door_Blocked() const noexcept;
    /// @brief signal comment: DoorLock_RearRightDoorUnLockStatus ##2G## -  - C_RRUnlockState,DoorLock_RrRtDrUnLkSta
    double getR_DoorLock_RrRtDrUnLkSta() const noexcept;
    /// @brief signal comment: Warn_RearRightDoorSwitchStatus ##2G## -  - C_RRDrSw,CF_Gway_RRDrSw,Warn_RrRtDrSwSta
    double getR_Warn_RrRtDrSwSta() const noexcept;
    double getR_SBCM_RR_DoorStatus() const noexcept;
    double getR_SBCM_RR_Door_Blocked() const noexcept;
    double getR_PTGM_OpnClsState() const noexcept;
    double getR_PTGM_CmdWarn() const noexcept;
    double getR_PTGM_AntiPinchSnsr() const noexcept;
    /// @brief signal comment: Warn_HoodSwitchStatus ##2G## -  - C_HoodSw,CF_Gway_HoodSw
    double getR_Warn_HoodSwSta() const noexcept;
    /// @brief signal comment: Window_DriverSideWindowActionStatus ##2G##BCM - BCMmsg25 - C_DrvWindowActState
    double getR_Window_DrvrSdWdwActSta() const noexcept;
    /// @brief signal comment: Window_DriverSideWindowDetailOpenStatus ##2G##BCM - BCMmsg26 - C_DrvWdwDetailOpenState
    double getR_Window_DrvrSdWdwDetailOpnSta() const noexcept;
    /// @brief signal comment: Window_DriverSideWindowErrorAntiPinch ##2G##BCM - BCMmsg26 - C_DrvWdwErrAntiPinch
    double getR_Window_DrvrSdWdwErrAntPinch() const noexcept;
    /// @brief signal comment: Window_DriverPowerWindowAutoSwitchStatus
    double getR_Window_DrvPwrWdwAutoSwSta() const noexcept;
    /// @brief signal comment: Window_DriverPowerWindowDownSwitchStatus
    double getR_Window_DrvPwrWdwDnSwSta() const noexcept;
    /// @brief signal comment: Window_DriverPowerWindowUpSwitchStatus
    double getR_Window_DrvPwrWdwUpSwSta() const noexcept;
    /// @brief signal comment: Window_AssistantSideWindowActionStatus ##2G##BCM - BCMmsg25 - C_AstWindowActState
    double getR_Window_AsstSdWdwActSta() const noexcept;
    /// @brief signal comment: Window_AssistantSideWindowDetailOpenStatus ##2G##BCM - BCMmsg26 - C_AstWdwDetailOpenState
    double getR_Window_AsstSdWdwDetailOpnSta() const noexcept;
    /// @brief signal comment: Window_AssistantSideWindowErrorAntiPinch ##2G##BCM - BCMmsg26 - C_AstWdwErrAntiPinch
    double getR_Window_AsstSdWdwErrAntPinch() const noexcept;
    /// @brief signal comment: Window_AssistPowerWindowAutoSwitchStatus ##2G##DDM -  - C_AstPwdwAutoSwDDM
    double getR_Window_AsstPwrWdwAutoSwSta() const noexcept;
    /// @brief signal comment: Window_AssistantPowerWindowDownSwitchStatus ##2G##DDM -  - C_AstPwdwDnSwDDM
    double getR_Window_AsstPwrWdwDnSwSta() const noexcept;
    /// @brief signal comment: Window_AssistantPowerWindowUpSwitchStatus ##2G##DDM -  - C_AstPwdwUpSwDDM
    double getR_Window_AsstPwrWdwUpSwSta() const noexcept;
    /// @brief signal comment: Window_RearLeftPowerWindowAutoSwitchStatus ##2G##DDM -  - C_RLPwdwAutoSwDDM
    double getR_Window_RrLftPwrWdwAutoSwSta() const noexcept;
    /// @brief signal comment: Window_RearLeftPowerWindowDownSwitchStatus ##2G##DDM -  - C_RLPwdwDnSwDDM
    double getR_Window_RrLftPwrWdwDnSwSta() const noexcept;
    /// @brief signal comment: Window_RearLeftPowerWindowUpSwitchStatus ##2G##DDM -  - C_RLPwdwUpSwDDM
    double getR_Window_RrLftPwrWdwUpSwSta() const noexcept;
    /// @brief signal comment: Window_RearLeftWindowActionStatus ##2G##BCM - BCMmsg25 - C_RLWindowActState
    double getR_Window_RrLftWdwActSta() const noexcept;
    /// @brief signal comment: Window_RearLeftWindowDetailOpenStatus ##2G##BCM - BCMmsg26 - C_RLWdwDetailOpenState
    double getR_Window_RrLftWdwDetailOpnSta() const noexcept;
    /// @brief signal comment: Window_RearLeftWindowErrorAntiPinch ##2G##BCM - BCMmsg26 - C_RLWdwErrAntiPinch
    double getR_Window_RrLftWdwErrAntPinch() const noexcept;
    /// @brief signal comment: Window_RearRightPowerWindowAutoSwitchStatus ##2G##DDM -  - C_RRPwdwAutoSwDDM
    double getR_Window_RrRtPwrWdwAutoSwSta() const noexcept;
    /// @brief signal comment: Window_RearRightPowerWindowDownSwitchStatus ##2G##DDM -  - C_RRPwdwDnSwDDM
    double getR_Window_RrRtPwrWdwDnSwSta() const noexcept;
    /// @brief signal comment: Window_RearRightPowerWindowUpSwitchStatus ##2G##DDM -  - C_RRPwdwUpSwDDM
    double getR_Window_RrRtPwrWdwUpSwSta() const noexcept;
    /// @brief signal comment: Window_RearRightWindowActionStatus ##2G##BCM - BCMmsg25 - C_RRWindowActState
    double getR_Window_RrRtWdwActSta() const noexcept;
    /// @brief signal comment: Window_RearRightWindowDetailOpenStatus ##2G##BCM - BCMmsg26 - C_RRWdwDetailOpenState
    double getR_Window_RrRtWdwDetailOpnSta() const noexcept;
    /// @brief signal comment: Window_RearRightWindowErrorAntiPinch ##2G##BCM - BCMmsg26 - C_RRWdwErrAntiPinch
    double getR_Window_RrRtWdwErrAntPinch() const noexcept;
    /// @brief signal comment: Window_PowerWindowMoveInhibitStatus ##2G##DDM -  - C_PwdwInhibit
    double getR_Window_PwrWdwMvInhbtSta() const noexcept;
    /// @brief signal comment: BurglarHorn Relay Status
    double getR_BurglarHornRlySta() const noexcept;
    /// @brief signal comment: Front interior cabin light staus
    double getR_IntCabinLight_Fr() const noexcept;
    /// @brief signal comment: Rear left interior cabin light satus
    double getR_IntCabinLight_RrLf() const noexcept;
    /// @brief signal comment: Rear right interior cabin light staus
    double getR_IntCabinLight_RrRt() const noexcept;
    /// @brief signal comment: OHCL mood lamp Status
    double getR_OHCL_MoodLampSta() const noexcept;

    /// @brief signal comment: ACU_CyclicRedundancyCheck1Value
    int64_t setR_VIC_BodyCtrl_FB_01A_Crc1Val(const double value) noexcept;
    /// @brief signal comment: ACU_AliveCounter1Value
    int64_t setR_VIC_BodyCtrl_FB_01A_AlvCnt1Val(const double value) noexcept;
    /// @brief signal comment: Lamp_HeadLampLowStatus ##2G##BCM - BCMmsg20 - C_HLpLowAct
    int64_t setR_Lamp_HdLmpLoSta(const double value) noexcept;
    /// @brief signal comment: Lamp_LedHeadLampStatus ##2G## -  - CF_Afs_LedHLStat
    int64_t setR_Lamp_LedHdLmpSta(const double value) noexcept;
    /// @brief signal comment: Lamp_HeadLampLowRightOpenStatus ##2G## -  - C_HLampLowRhOpenSts
    int64_t setR_Lamp_HdLmpLoRtOpnSta(const double value) noexcept;
    /// @brief signal comment: Lamp_HeadLampLowLeftOpenStatus ##2G## -  - C_HLampLowLhOpenSts
    int64_t setR_Lamp_HdLmpLoLftOpnSta(const double value) noexcept;
    /// @brief signal comment: Lamp_HeadLampHighStatus ##2G##BCM - BCMmsg20 - C_HLpHighAct
    int64_t setR_Lamp_HdLmpHiSta(const double value) noexcept;
    /// @brief signal comment: Lamp_HeadLampHighRightOpenStatus ##2G## -  - C_HLampHighRhOpenSts
    int64_t setR_Lamp_HdLmpHiRtOpnSta(const double value) noexcept;
    /// @brief signal comment: Lamp_HeadLampHighLeftOpenStatus ##2G## -  - C_HLampHighLhOpenSts
    int64_t setR_Lamp_HdLmpHiLftOpnSta(const double value) noexcept;
    /// @brief signal comment: Headlamps low beam PCL status on RH
    int64_t setR_Lamp_Hdlmp_Low_PCLstatus_RH(const double value) noexcept;
    /// @brief signal comment: Headlamps low beam PCL status on LH
    int64_t setR_Lamp_Hdlmp_Low_PCLstatus_LH(const double value) noexcept;
    /// @brief signal comment: ExtLamp_HazardSwitchStatus ##2G## -  - C_HazardSw,CF_Gway_HazardSw
    int64_t setR_ExtLamp_HzrdSwSta(const double value) noexcept;
    /// @brief signal comment: Lamp_TurnSignalLampLeftActiveState
    int64_t setR_Lamp_TrnSigLmpLftActiveSt(const double value) noexcept;
    /// @brief signal comment: Lamp_TurnSignalLampRightActiveState
    int64_t setR_Lamp_TrnSigLmpRtActiveSt(const double value) noexcept;
    /// @brief signal comment: ExtLamp_TurnSignalLampLeftBlinkingStatus ##2G## -  - CF_Gway_TurnSigLh,C_TSigLhAct
    int64_t setR_ExtLamp_TrnSigLmpLftBlnkngSta(const double value) noexcept;
    /// @brief signal comment: ExtLamp_TurnSignalLampRightBlinkingStatus ##2G## -  - CF_Gway_TurnSigRh,C_TSigRhAct
    int64_t setR_ExtLamp_TrnSigLmpRtBlnkngSta(const double value) noexcept;
    /// @brief signal comment: Lamp_RearTurnSignalLampLeftOpenStatus ##2G## -  - C_RearTSIGLhOpenSts
    int64_t setR_Lamp_RrTrnSigLmpLftOpnSta(const double value) noexcept;
    /// @brief signal comment: Lamp_RearTurnSignalLampRightOpenStatus ##2G## -  - C_RearTSIGRhOpenSts
    int64_t setR_Lamp_RrTrnSigLmpRtOpnSta(const double value) noexcept;
    /// @brief signal comment: Lamp_FrontTurnSignalLampLeftOpenStatus ##2G## -  - C_FrontTSIGLhOpenSts
    int64_t setR_Lamp_FrTrnSigLmpLftOpnSta(const double value) noexcept;
    /// @brief signal comment: Lamp_FrontTurnSignalLampRightOpenStatus ##2G## -  - C_FrontTSIGRhOpenSts
    int64_t setR_Lamp_FrTrnSigLmpRtOpnSta(const double value) noexcept;
    /// @brief signal comment: Front left flasher lamp PCL
    int64_t setR_Lamp_FrTrnSigLmpLftPCLSta(const double value) noexcept;
    /// @brief signal comment: Front right flasher lamp PCL
    int64_t setR_Lamp_FrTrnSigLmpRtPCLSta(const double value) noexcept;
    /// @brief signal comment: Rear left flasher lamp PCL
    int64_t setR_Lamp_RrTrnSigLmpLftPCLSta(const double value) noexcept;
    /// @brief signal comment: Rear right flasher lamp PCL
    int64_t setR_Lamp_RrTrnSigLmpRtPCLSta(const double value) noexcept;
    int64_t setR_ExtLamp_StpLmpSta(const double value) noexcept;
    /// @brief signal comment: Lamp_StopLampLeftOpenStatus ##2G## -  - C_StopLampLhOpenSts
    int64_t setR_Lamp_StpLmpLftOpnSta(const double value) noexcept;
    /// @brief signal comment: Lamp_StopLampRightOpenStatus ##2G## -  - C_StopLampRhOpenSts
    int64_t setR_Lamp_StpLmpRtOpnSta(const double value) noexcept;
    /// @brief signal comment: This signal is used for control the Back-up Lamp function.
    int64_t setR_ExtLamp_BckUpLmpSta(const double value) noexcept;
    /// @brief signal comment: Lamp_AutoLightSensorNightStatus ##2G##BCM - BCMmsg24 - C_AutolightValue
    int64_t setR_Lamp_AutoLtSnsrNightSta(const double value) noexcept;
    /// @brief signal comment: Lamp_AutoLightSensorHorValue ##2G##BCM - BCMmsg24 - C_AutolightSensorHorState
    int64_t setR_Lamp_AutoLtSnsrHorVal(const double value) noexcept;
    /// @brief signal comment: Lamp_AutoLightSensorVerValue ##2G##BCM - BCMmsg24 - C_AutolightSensorVerState
    int64_t setR_Lamp_AutoLtSnsrVerVal(const double value) noexcept;
    int64_t setR_Wiper_RainAmount(const double value) noexcept;
    /// @brief signal comment: Wiper_RainSensorStatus ##2G##BCM - BCMmsg24 - C_RainSnsState
    int64_t setR_Wiper_RainSnsrSta(const double value) noexcept;
    int64_t setR_Wiper_WiperRlyFRSta(const double value) noexcept;
    /// @brief signal comment: Wiper_RearWiperWasherSwitchStatus
    int64_t setR_Wiper_RrWiperWshSwSta(const double value) noexcept;
    /// @brief signal comment: Wiper_IntermittentStepStatus
    int64_t setR_Wiper_IntStepSta(const double value) noexcept;
    /// @brief signal comment: DoorLock_DriverDoorUnLockStatus ##2G## -  - C_DrvUnlockState,CF_Gway_DrvUnlockState
    int64_t setR_DoorLock_DrvDrUnLkSta(const double value) noexcept;
    /// @brief signal comment: DoorLock_DriverDoorSwitchStatus ##2G## -  - C_DrvDrSw,CF_Gway_DrvDrSw,Warn_DrvDrSwSta
    int64_t setR_Warn_DrvDrSwSta(const double value) noexcept;
    /// @brief signal comment: DoorLock_AssistDoorUnLockStatus ##2G## -  - C_AstUnlockState,DoorLock_AsstDrUnLkSta
    int64_t setR_DoorLock_AsstDrUnLkSta(const double value) noexcept;
    /// @brief signal comment: Warn_AssistDoorSwitchStatus ##2G## -  - C_AstDrSw,CF_Gway_AstDrSw,Warn_AsstDrSwSta
    int64_t setR_Warn_AsstDrSwSta(const double value) noexcept;
    int64_t setR_SBCM_AST_DoorStatus(const double value) noexcept;
    int64_t setR_SBCM_AST_Door_Blocked(const double value) noexcept;
    /// @brief signal comment: DoorLock_RearLeftDoorUnLockStatus ##2G## -  - C_RLUnlockState,DoorLock_RrLftDrUnLkSta
    int64_t setR_DoorLock_RrLftDrUnLkSta(const double value) noexcept;
    /// @brief signal comment: Warn_RearLeftDoorSwitchStatus ##2G## -  - C_RLDrSw,CF_Gway_RLDrSw,Warn_RrLftDrSwSta
    int64_t setR_Warn_RrLftDrSwSta(const double value) noexcept;
    int64_t setR_SBCM_RL_DoorStatus(const double value) noexcept;
    int64_t setR_SBCM_RL_Door_Blocked(const double value) noexcept;
    /// @brief signal comment: DoorLock_RearRightDoorUnLockStatus ##2G## -  - C_RRUnlockState,DoorLock_RrRtDrUnLkSta
    int64_t setR_DoorLock_RrRtDrUnLkSta(const double value) noexcept;
    /// @brief signal comment: Warn_RearRightDoorSwitchStatus ##2G## -  - C_RRDrSw,CF_Gway_RRDrSw,Warn_RrRtDrSwSta
    int64_t setR_Warn_RrRtDrSwSta(const double value) noexcept;
    int64_t setR_SBCM_RR_DoorStatus(const double value) noexcept;
    int64_t setR_SBCM_RR_Door_Blocked(const double value) noexcept;
    int64_t setR_PTGM_OpnClsState(const double value) noexcept;
    int64_t setR_PTGM_CmdWarn(const double value) noexcept;
    int64_t setR_PTGM_AntiPinchSnsr(const double value) noexcept;
    /// @brief signal comment: Warn_HoodSwitchStatus ##2G## -  - C_HoodSw,CF_Gway_HoodSw
    int64_t setR_Warn_HoodSwSta(const double value) noexcept;
    /// @brief signal comment: Window_DriverSideWindowActionStatus ##2G##BCM - BCMmsg25 - C_DrvWindowActState
    int64_t setR_Window_DrvrSdWdwActSta(const double value) noexcept;
    /// @brief signal comment: Window_DriverSideWindowDetailOpenStatus ##2G##BCM - BCMmsg26 - C_DrvWdwDetailOpenState
    int64_t setR_Window_DrvrSdWdwDetailOpnSta(const double value) noexcept;
    /// @brief signal comment: Window_DriverSideWindowErrorAntiPinch ##2G##BCM - BCMmsg26 - C_DrvWdwErrAntiPinch
    int64_t setR_Window_DrvrSdWdwErrAntPinch(const double value) noexcept;
    /// @brief signal comment: Window_DriverPowerWindowAutoSwitchStatus
    int64_t setR_Window_DrvPwrWdwAutoSwSta(const double value) noexcept;
    /// @brief signal comment: Window_DriverPowerWindowDownSwitchStatus
    int64_t setR_Window_DrvPwrWdwDnSwSta(const double value) noexcept;
    /// @brief signal comment: Window_DriverPowerWindowUpSwitchStatus
    int64_t setR_Window_DrvPwrWdwUpSwSta(const double value) noexcept;
    /// @brief signal comment: Window_AssistantSideWindowActionStatus ##2G##BCM - BCMmsg25 - C_AstWindowActState
    int64_t setR_Window_AsstSdWdwActSta(const double value) noexcept;
    /// @brief signal comment: Window_AssistantSideWindowDetailOpenStatus ##2G##BCM - BCMmsg26 - C_AstWdwDetailOpenState
    int64_t setR_Window_AsstSdWdwDetailOpnSta(const double value) noexcept;
    /// @brief signal comment: Window_AssistantSideWindowErrorAntiPinch ##2G##BCM - BCMmsg26 - C_AstWdwErrAntiPinch
    int64_t setR_Window_AsstSdWdwErrAntPinch(const double value) noexcept;
    /// @brief signal comment: Window_AssistPowerWindowAutoSwitchStatus ##2G##DDM -  - C_AstPwdwAutoSwDDM
    int64_t setR_Window_AsstPwrWdwAutoSwSta(const double value) noexcept;
    /// @brief signal comment: Window_AssistantPowerWindowDownSwitchStatus ##2G##DDM -  - C_AstPwdwDnSwDDM
    int64_t setR_Window_AsstPwrWdwDnSwSta(const double value) noexcept;
    /// @brief signal comment: Window_AssistantPowerWindowUpSwitchStatus ##2G##DDM -  - C_AstPwdwUpSwDDM
    int64_t setR_Window_AsstPwrWdwUpSwSta(const double value) noexcept;
    /// @brief signal comment: Window_RearLeftPowerWindowAutoSwitchStatus ##2G##DDM -  - C_RLPwdwAutoSwDDM
    int64_t setR_Window_RrLftPwrWdwAutoSwSta(const double value) noexcept;
    /// @brief signal comment: Window_RearLeftPowerWindowDownSwitchStatus ##2G##DDM -  - C_RLPwdwDnSwDDM
    int64_t setR_Window_RrLftPwrWdwDnSwSta(const double value) noexcept;
    /// @brief signal comment: Window_RearLeftPowerWindowUpSwitchStatus ##2G##DDM -  - C_RLPwdwUpSwDDM
    int64_t setR_Window_RrLftPwrWdwUpSwSta(const double value) noexcept;
    /// @brief signal comment: Window_RearLeftWindowActionStatus ##2G##BCM - BCMmsg25 - C_RLWindowActState
    int64_t setR_Window_RrLftWdwActSta(const double value) noexcept;
    /// @brief signal comment: Window_RearLeftWindowDetailOpenStatus ##2G##BCM - BCMmsg26 - C_RLWdwDetailOpenState
    int64_t setR_Window_RrLftWdwDetailOpnSta(const double value) noexcept;
    /// @brief signal comment: Window_RearLeftWindowErrorAntiPinch ##2G##BCM - BCMmsg26 - C_RLWdwErrAntiPinch
    int64_t setR_Window_RrLftWdwErrAntPinch(const double value) noexcept;
    /// @brief signal comment: Window_RearRightPowerWindowAutoSwitchStatus ##2G##DDM -  - C_RRPwdwAutoSwDDM
    int64_t setR_Window_RrRtPwrWdwAutoSwSta(const double value) noexcept;
    /// @brief signal comment: Window_RearRightPowerWindowDownSwitchStatus ##2G##DDM -  - C_RRPwdwDnSwDDM
    int64_t setR_Window_RrRtPwrWdwDnSwSta(const double value) noexcept;
    /// @brief signal comment: Window_RearRightPowerWindowUpSwitchStatus ##2G##DDM -  - C_RRPwdwUpSwDDM
    int64_t setR_Window_RrRtPwrWdwUpSwSta(const double value) noexcept;
    /// @brief signal comment: Window_RearRightWindowActionStatus ##2G##BCM - BCMmsg25 - C_RRWindowActState
    int64_t setR_Window_RrRtWdwActSta(const double value) noexcept;
    /// @brief signal comment: Window_RearRightWindowDetailOpenStatus ##2G##BCM - BCMmsg26 - C_RRWdwDetailOpenState
    int64_t setR_Window_RrRtWdwDetailOpnSta(const double value) noexcept;
    /// @brief signal comment: Window_RearRightWindowErrorAntiPinch ##2G##BCM - BCMmsg26 - C_RRWdwErrAntiPinch
    int64_t setR_Window_RrRtWdwErrAntPinch(const double value) noexcept;
    /// @brief signal comment: Window_PowerWindowMoveInhibitStatus ##2G##DDM -  - C_PwdwInhibit
    int64_t setR_Window_PwrWdwMvInhbtSta(const double value) noexcept;
    /// @brief signal comment: BurglarHorn Relay Status
    int64_t setR_BurglarHornRlySta(const double value) noexcept;
    /// @brief signal comment: Front interior cabin light staus
    int64_t setR_IntCabinLight_Fr(const double value) noexcept;
    /// @brief signal comment: Rear left interior cabin light satus
    int64_t setR_IntCabinLight_RrLf(const double value) noexcept;
    /// @brief signal comment: Rear right interior cabin light staus
    int64_t setR_IntCabinLight_RrRt(const double value) noexcept;
    /// @brief signal comment: OHCL mood lamp Status
    int64_t setR_OHCL_MoodLampSta(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::avproto

#endif
