/// @copyright Copyright (c) 2022 - Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file:
/// https://gitlab.ci.motional.com/systems/av-netwrok-infrastructure/Gen2-AVT-Sample-B/-/blob/dd539e5d752bcae0408ed2b8f29b270cc0db624e/Gen2_AVT_B_Control_CAN1.dbc

#ifndef VIC_BodyCtrl_FB_01A_PE_200ms_av_proto_H_
#define VIC_BodyCtrl_FB_01A_PE_200ms_av_proto_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::avproto {

namespace VIC_BodyCtrl_FB_01A_PE_200ms_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

/// This class contains members for decoding/encoding the CAN message VIC_BodyCtrl_FB_01A_PE_200ms
/// The default message identifier for VIC_BodyCtrl_FB_01A_PE_200ms is 0x83 (131)

/// For decoding this is the required length of a decodable message. If the message
/// is smaller there is data missing.
/// For encoding this the length of the CAN message encoded by this class assuming all
/// setters have been called. This value should be one greater than the largest index
/// written to by any of the setter methods.
const uint8_t VIC_BODYCTRL_FB_01A_PE_200MS_PACKET_LEN = UINT8_C(32);
} // namespace VIC_BodyCtrl_FB_01A_PE_200ms_CONSTS

class VIC_BodyCtrl_FB_01A_PE_200ms
{
public:
    VIC_BodyCtrl_FB_01A_PE_200ms(const uint32_t id);
    VIC_BodyCtrl_FB_01A_PE_200ms(const uint32_t id, uint8_t* const payload, const uint8_t size);

    /// @brief signal comment: ACU_CyclicRedundancyCheck1Value
    double getVIC_BodyCtrl_FB_01A_Crc1Val() const noexcept;
    /// @brief signal comment: ACU_AliveCounter1Value
    double getVIC_BodyCtrl_FB_01A_AlvCnt1Val() const noexcept;
    /// @brief signal comment: Lamp_HeadLampLowStatus ##2G##BCM - BCMmsg20 - C_HLpLowAct
    double getLamp_HdLmpLoSta() const noexcept;
    /// @brief signal comment: Lamp_LedHeadLampStatus ##2G## -  - CF_Afs_LedHLStat
    double getLamp_LedHdLmpSta() const noexcept;
    /// @brief signal comment: Lamp_HeadLampLowRightOpenStatus ##2G## -  - C_HLampLowRhOpenSts
    double getLamp_HdLmpLoRtOpnSta() const noexcept;
    /// @brief signal comment: Lamp_HeadLampLowLeftOpenStatus ##2G## -  - C_HLampLowLhOpenSts
    double getLamp_HdLmpLoLftOpnSta() const noexcept;
    /// @brief signal comment: Lamp_HeadLampHighStatus ##2G##BCM - BCMmsg20 - C_HLpHighAct
    double getLamp_HdLmpHiSta() const noexcept;
    /// @brief signal comment: Lamp_HeadLampHighRightOpenStatus ##2G## -  - C_HLampHighRhOpenSts
    double getLamp_HdLmpHiRtOpnSta() const noexcept;
    /// @brief signal comment: Lamp_HeadLampHighLeftOpenStatus ##2G## -  - C_HLampHighLhOpenSts
    double getLamp_HdLmpHiLftOpnSta() const noexcept;
    /// @brief signal comment: Headlamps low beam PCL status on RH
    double getLamp_Hdlmp_Low_PCLstatus_RH() const noexcept;
    /// @brief signal comment: Headlamps low beam PCL status on LH
    double getLamp_Hdlmp_Low_PCLstatus_LH() const noexcept;
    /// @brief signal comment: ExtLamp_HazardSwitchStatus ##2G## -  - C_HazardSw,CF_Gway_HazardSw
    double getExtLamp_HzrdSwSta() const noexcept;
    /// @brief signal comment: Lamp_TurnSignalLampLeftActiveState
    double getLamp_TrnSigLmpLftActiveSt() const noexcept;
    /// @brief signal comment: Lamp_TurnSignalLampRightActiveState
    double getLamp_TrnSigLmpRtActiveSt() const noexcept;
    /// @brief signal comment: ExtLamp_TurnSignalLampLeftBlinkingStatus ##2G## -  - CF_Gway_TurnSigLh,C_TSigLhAct
    double getExtLamp_TrnSigLmpLftBlnkngSta() const noexcept;
    /// @brief signal comment: ExtLamp_TurnSignalLampRightBlinkingStatus ##2G## -  - CF_Gway_TurnSigRh,C_TSigRhAct
    double getExtLamp_TrnSigLmpRtBlnkngSta() const noexcept;
    /// @brief signal comment: Lamp_RearTurnSignalLampLeftOpenStatus ##2G## -  - C_RearTSIGLhOpenSts
    double getLamp_RrTrnSigLmpLftOpnSta() const noexcept;
    /// @brief signal comment: Lamp_RearTurnSignalLampRightOpenStatus ##2G## -  - C_RearTSIGRhOpenSts
    double getLamp_RrTrnSigLmpRtOpnSta() const noexcept;
    /// @brief signal comment: Lamp_FrontTurnSignalLampLeftOpenStatus ##2G## -  - C_FrontTSIGLhOpenSts
    double getLamp_FrTrnSigLmpLftOpnSta() const noexcept;
    /// @brief signal comment: Lamp_FrontTurnSignalLampRightOpenStatus ##2G## -  - C_FrontTSIGRhOpenSts
    double getLamp_FrTrnSigLmpRtOpnSta() const noexcept;
    /// @brief signal comment: Front left flasher lamp PCL
    double getLamp_FrTrnSigLmpLftPCLSta() const noexcept;
    /// @brief signal comment: Front right flasher lamp PCL
    double getLamp_FrTrnSigLmpRtPCLSta() const noexcept;
    /// @brief signal comment: Rear left flasher lamp PCL
    double getLamp_RrTrnSigLmpLftPCLSta() const noexcept;
    /// @brief signal comment: Rear right flasher lamp PCL
    double getLamp_RrTrnSigLmpRtPCLSta() const noexcept;
    double getExtLamp_StpLmpSta() const noexcept;
    /// @brief signal comment: Lamp_StopLampLeftOpenStatus ##2G## -  - C_StopLampLhOpenSts
    double getLamp_StpLmpLftOpnSta() const noexcept;
    /// @brief signal comment: Lamp_StopLampRightOpenStatus ##2G## -  - C_StopLampRhOpenSts
    double getLamp_StpLmpRtOpnSta() const noexcept;
    /// @brief signal comment: This signal is used for control the Back-up Lamp function.
    double getExtLamp_BckUpLmpSta() const noexcept;
    /// @brief signal comment: Lamp_AutoLightSensorNightStatus ##2G##BCM - BCMmsg24 - C_AutolightValue
    double getLamp_AutoLtSnsrNightSta() const noexcept;
    /// @brief signal comment: Lamp_AutoLightSensorHorValue ##2G##BCM - BCMmsg24 - C_AutolightSensorHorState
    double getLamp_AutoLtSnsrHorVal() const noexcept;
    /// @brief signal comment: Lamp_AutoLightSensorVerValue ##2G##BCM - BCMmsg24 - C_AutolightSensorVerState
    double getLamp_AutoLtSnsrVerVal() const noexcept;
    double getWiper_RainAmount() const noexcept;
    /// @brief signal comment: Wiper_RainSensorStatus ##2G##BCM - BCMmsg24 - C_RainSnsState
    double getWiper_RainSnsrSta() const noexcept;
    double getWiper_WiperRlyFRSta() const noexcept;
    /// @brief signal comment: Wiper_RearWiperWasherSwitchStatus
    double getWiper_RrWiperWshSwSta() const noexcept;
    /// @brief signal comment: Wiper_IntermittentStepStatus
    double getWiper_IntStepSta() const noexcept;
    /// @brief signal comment: DoorLock_DriverDoorUnLockStatus ##2G## -  - C_DrvUnlockState,CF_Gway_DrvUnlockState
    double getDoorLock_DrvDrUnLkSta() const noexcept;
    /// @brief signal comment: DoorLock_DriverDoorSwitchStatus ##2G## -  - C_DrvDrSw,CF_Gway_DrvDrSw,Warn_DrvDrSwSta
    double getWarn_DrvDrSwSta() const noexcept;
    /// @brief signal comment: DoorLock_AssistDoorUnLockStatus ##2G## -  - C_AstUnlockState,DoorLock_AsstDrUnLkSta
    double getDoorLock_AsstDrUnLkSta() const noexcept;
    /// @brief signal comment: Warn_AssistDoorSwitchStatus ##2G## -  - C_AstDrSw,CF_Gway_AstDrSw,Warn_AsstDrSwSta
    double getWarn_AsstDrSwSta() const noexcept;
    double getSBCM_AST_DoorStatus() const noexcept;
    double getSBCM_AST_Door_Blocked() const noexcept;
    /// @brief signal comment: DoorLock_RearLeftDoorUnLockStatus ##2G## -  - C_RLUnlockState,DoorLock_RrLftDrUnLkSta
    double getDoorLock_RrLftDrUnLkSta() const noexcept;
    /// @brief signal comment: Warn_RearLeftDoorSwitchStatus ##2G## -  - C_RLDrSw,CF_Gway_RLDrSw,Warn_RrLftDrSwSta
    double getWarn_RrLftDrSwSta() const noexcept;
    double getSBCM_RL_DoorStatus() const noexcept;
    double getSBCM_RL_Door_Blocked() const noexcept;
    /// @brief signal comment: DoorLock_RearRightDoorUnLockStatus ##2G## -  - C_RRUnlockState,DoorLock_RrRtDrUnLkSta
    double getDoorLock_RrRtDrUnLkSta() const noexcept;
    /// @brief signal comment: Warn_RearRightDoorSwitchStatus ##2G## -  - C_RRDrSw,CF_Gway_RRDrSw,Warn_RrRtDrSwSta
    double getWarn_RrRtDrSwSta() const noexcept;
    double getSBCM_RR_DoorStatus() const noexcept;
    double getSBCM_RR_Door_Blocked() const noexcept;
    double getPTGM_OpnClsState() const noexcept;
    double getPTGM_CmdWarn() const noexcept;
    double getPTGM_AntiPinchSnsr() const noexcept;
    /// @brief signal comment: Warn_HoodSwitchStatus ##2G## -  - C_HoodSw,CF_Gway_HoodSw
    double getWarn_HoodSwSta() const noexcept;
    /// @brief signal comment: Window_DriverSideWindowActionStatus ##2G##BCM - BCMmsg25 - C_DrvWindowActState
    double getWindow_DrvrSdWdwActSta() const noexcept;
    /// @brief signal comment: Window_DriverSideWindowDetailOpenStatus ##2G##BCM - BCMmsg26 - C_DrvWdwDetailOpenState
    double getWindow_DrvrSdWdwDetailOpnSta() const noexcept;
    /// @brief signal comment: Window_DriverSideWindowErrorAntiPinch ##2G##BCM - BCMmsg26 - C_DrvWdwErrAntiPinch
    double getWindow_DrvrSdWdwErrAntPinch() const noexcept;
    /// @brief signal comment: Window_DriverPowerWindowAutoSwitchStatus
    double getWindow_DrvPwrWdwAutoSwSta() const noexcept;
    /// @brief signal comment: Window_DriverPowerWindowDownSwitchStatus
    double getWindow_DrvPwrWdwDnSwSta() const noexcept;
    /// @brief signal comment: Window_DriverPowerWindowUpSwitchStatus
    double getWindow_DrvPwrWdwUpSwSta() const noexcept;
    /// @brief signal comment: Window_AssistantSideWindowActionStatus ##2G##BCM - BCMmsg25 - C_AstWindowActState
    double getWindow_AsstSdWdwActSta() const noexcept;
    /// @brief signal comment: Window_AssistantSideWindowDetailOpenStatus ##2G##BCM - BCMmsg26 - C_AstWdwDetailOpenState
    double getWindow_AsstSdWdwDetailOpnSta() const noexcept;
    /// @brief signal comment: Window_AssistantSideWindowErrorAntiPinch ##2G##BCM - BCMmsg26 - C_AstWdwErrAntiPinch
    double getWindow_AsstSdWdwErrAntPinch() const noexcept;
    /// @brief signal comment: Window_AssistPowerWindowAutoSwitchStatus ##2G##DDM -  - C_AstPwdwAutoSwDDM
    double getWindow_AsstPwrWdwAutoSwSta() const noexcept;
    /// @brief signal comment: Window_AssistantPowerWindowDownSwitchStatus ##2G##DDM -  - C_AstPwdwDnSwDDM
    double getWindow_AsstPwrWdwDnSwSta() const noexcept;
    /// @brief signal comment: Window_AssistantPowerWindowUpSwitchStatus ##2G##DDM -  - C_AstPwdwUpSwDDM
    double getWindow_AsstPwrWdwUpSwSta() const noexcept;
    /// @brief signal comment: Window_RearLeftPowerWindowAutoSwitchStatus ##2G##DDM -  - C_RLPwdwAutoSwDDM
    double getWindow_RrLftPwrWdwAutoSwSta() const noexcept;
    /// @brief signal comment: Window_RearLeftPowerWindowDownSwitchStatus ##2G##DDM -  - C_RLPwdwDnSwDDM
    double getWindow_RrLftPwrWdwDnSwSta() const noexcept;
    /// @brief signal comment: Window_RearLeftPowerWindowUpSwitchStatus ##2G##DDM -  - C_RLPwdwUpSwDDM
    double getWindow_RrLftPwrWdwUpSwSta() const noexcept;
    /// @brief signal comment: Window_RearLeftWindowActionStatus ##2G##BCM - BCMmsg25 - C_RLWindowActState
    double getWindow_RrLftWdwActSta() const noexcept;
    /// @brief signal comment: Window_RearLeftWindowDetailOpenStatus ##2G##BCM - BCMmsg26 - C_RLWdwDetailOpenState
    double getWindow_RrLftWdwDetailOpnSta() const noexcept;
    /// @brief signal comment: Window_RearLeftWindowErrorAntiPinch ##2G##BCM - BCMmsg26 - C_RLWdwErrAntiPinch
    double getWindow_RrLftWdwErrAntPinch() const noexcept;
    /// @brief signal comment: Window_RearRightPowerWindowAutoSwitchStatus ##2G##DDM -  - C_RRPwdwAutoSwDDM
    double getWindow_RrRtPwrWdwAutoSwSta() const noexcept;
    /// @brief signal comment: Window_RearRightPowerWindowDownSwitchStatus ##2G##DDM -  - C_RRPwdwDnSwDDM
    double getWindow_RrRtPwrWdwDnSwSta() const noexcept;
    /// @brief signal comment: Window_RearRightPowerWindowUpSwitchStatus ##2G##DDM -  - C_RRPwdwUpSwDDM
    double getWindow_RrRtPwrWdwUpSwSta() const noexcept;
    /// @brief signal comment: Window_RearRightWindowActionStatus ##2G##BCM - BCMmsg25 - C_RRWindowActState
    double getWindow_RrRtWdwActSta() const noexcept;
    /// @brief signal comment: Window_RearRightWindowDetailOpenStatus ##2G##BCM - BCMmsg26 - C_RRWdwDetailOpenState
    double getWindow_RrRtWdwDetailOpnSta() const noexcept;
    /// @brief signal comment: Window_RearRightWindowErrorAntiPinch ##2G##BCM - BCMmsg26 - C_RRWdwErrAntiPinch
    double getWindow_RrRtWdwErrAntPinch() const noexcept;
    /// @brief signal comment: Window_PowerWindowMoveInhibitStatus ##2G##DDM -  - C_PwdwInhibit
    double getWindow_PwrWdwMvInhbtSta() const noexcept;
    /// @brief signal comment: BurglarHorn Relay Status
    double getBurglarHornRlySta() const noexcept;
    /// @brief signal comment: Front interior cabin light staus
    double getIntCabinLight_Fr() const noexcept;
    /// @brief signal comment: Rear left interior cabin light satus
    double getIntCabinLight_RrLf() const noexcept;
    /// @brief signal comment: Rear right interior cabin light staus
    double getIntCabinLight_RrRt() const noexcept;
    /// @brief signal comment: OHCL mood lamp Status
    double getOHCL_MoodLampSta() const noexcept;

    /// @brief signal comment: ACU_CyclicRedundancyCheck1Value
    int64_t setVIC_BodyCtrl_FB_01A_Crc1Val(const double value) noexcept;
    /// @brief signal comment: ACU_AliveCounter1Value
    int64_t setVIC_BodyCtrl_FB_01A_AlvCnt1Val(const double value) noexcept;
    /// @brief signal comment: Lamp_HeadLampLowStatus ##2G##BCM - BCMmsg20 - C_HLpLowAct
    int64_t setLamp_HdLmpLoSta(const double value) noexcept;
    /// @brief signal comment: Lamp_LedHeadLampStatus ##2G## -  - CF_Afs_LedHLStat
    int64_t setLamp_LedHdLmpSta(const double value) noexcept;
    /// @brief signal comment: Lamp_HeadLampLowRightOpenStatus ##2G## -  - C_HLampLowRhOpenSts
    int64_t setLamp_HdLmpLoRtOpnSta(const double value) noexcept;
    /// @brief signal comment: Lamp_HeadLampLowLeftOpenStatus ##2G## -  - C_HLampLowLhOpenSts
    int64_t setLamp_HdLmpLoLftOpnSta(const double value) noexcept;
    /// @brief signal comment: Lamp_HeadLampHighStatus ##2G##BCM - BCMmsg20 - C_HLpHighAct
    int64_t setLamp_HdLmpHiSta(const double value) noexcept;
    /// @brief signal comment: Lamp_HeadLampHighRightOpenStatus ##2G## -  - C_HLampHighRhOpenSts
    int64_t setLamp_HdLmpHiRtOpnSta(const double value) noexcept;
    /// @brief signal comment: Lamp_HeadLampHighLeftOpenStatus ##2G## -  - C_HLampHighLhOpenSts
    int64_t setLamp_HdLmpHiLftOpnSta(const double value) noexcept;
    /// @brief signal comment: Headlamps low beam PCL status on RH
    int64_t setLamp_Hdlmp_Low_PCLstatus_RH(const double value) noexcept;
    /// @brief signal comment: Headlamps low beam PCL status on LH
    int64_t setLamp_Hdlmp_Low_PCLstatus_LH(const double value) noexcept;
    /// @brief signal comment: ExtLamp_HazardSwitchStatus ##2G## -  - C_HazardSw,CF_Gway_HazardSw
    int64_t setExtLamp_HzrdSwSta(const double value) noexcept;
    /// @brief signal comment: Lamp_TurnSignalLampLeftActiveState
    int64_t setLamp_TrnSigLmpLftActiveSt(const double value) noexcept;
    /// @brief signal comment: Lamp_TurnSignalLampRightActiveState
    int64_t setLamp_TrnSigLmpRtActiveSt(const double value) noexcept;
    /// @brief signal comment: ExtLamp_TurnSignalLampLeftBlinkingStatus ##2G## -  - CF_Gway_TurnSigLh,C_TSigLhAct
    int64_t setExtLamp_TrnSigLmpLftBlnkngSta(const double value) noexcept;
    /// @brief signal comment: ExtLamp_TurnSignalLampRightBlinkingStatus ##2G## -  - CF_Gway_TurnSigRh,C_TSigRhAct
    int64_t setExtLamp_TrnSigLmpRtBlnkngSta(const double value) noexcept;
    /// @brief signal comment: Lamp_RearTurnSignalLampLeftOpenStatus ##2G## -  - C_RearTSIGLhOpenSts
    int64_t setLamp_RrTrnSigLmpLftOpnSta(const double value) noexcept;
    /// @brief signal comment: Lamp_RearTurnSignalLampRightOpenStatus ##2G## -  - C_RearTSIGRhOpenSts
    int64_t setLamp_RrTrnSigLmpRtOpnSta(const double value) noexcept;
    /// @brief signal comment: Lamp_FrontTurnSignalLampLeftOpenStatus ##2G## -  - C_FrontTSIGLhOpenSts
    int64_t setLamp_FrTrnSigLmpLftOpnSta(const double value) noexcept;
    /// @brief signal comment: Lamp_FrontTurnSignalLampRightOpenStatus ##2G## -  - C_FrontTSIGRhOpenSts
    int64_t setLamp_FrTrnSigLmpRtOpnSta(const double value) noexcept;
    /// @brief signal comment: Front left flasher lamp PCL
    int64_t setLamp_FrTrnSigLmpLftPCLSta(const double value) noexcept;
    /// @brief signal comment: Front right flasher lamp PCL
    int64_t setLamp_FrTrnSigLmpRtPCLSta(const double value) noexcept;
    /// @brief signal comment: Rear left flasher lamp PCL
    int64_t setLamp_RrTrnSigLmpLftPCLSta(const double value) noexcept;
    /// @brief signal comment: Rear right flasher lamp PCL
    int64_t setLamp_RrTrnSigLmpRtPCLSta(const double value) noexcept;
    int64_t setExtLamp_StpLmpSta(const double value) noexcept;
    /// @brief signal comment: Lamp_StopLampLeftOpenStatus ##2G## -  - C_StopLampLhOpenSts
    int64_t setLamp_StpLmpLftOpnSta(const double value) noexcept;
    /// @brief signal comment: Lamp_StopLampRightOpenStatus ##2G## -  - C_StopLampRhOpenSts
    int64_t setLamp_StpLmpRtOpnSta(const double value) noexcept;
    /// @brief signal comment: This signal is used for control the Back-up Lamp function.
    int64_t setExtLamp_BckUpLmpSta(const double value) noexcept;
    /// @brief signal comment: Lamp_AutoLightSensorNightStatus ##2G##BCM - BCMmsg24 - C_AutolightValue
    int64_t setLamp_AutoLtSnsrNightSta(const double value) noexcept;
    /// @brief signal comment: Lamp_AutoLightSensorHorValue ##2G##BCM - BCMmsg24 - C_AutolightSensorHorState
    int64_t setLamp_AutoLtSnsrHorVal(const double value) noexcept;
    /// @brief signal comment: Lamp_AutoLightSensorVerValue ##2G##BCM - BCMmsg24 - C_AutolightSensorVerState
    int64_t setLamp_AutoLtSnsrVerVal(const double value) noexcept;
    int64_t setWiper_RainAmount(const double value) noexcept;
    /// @brief signal comment: Wiper_RainSensorStatus ##2G##BCM - BCMmsg24 - C_RainSnsState
    int64_t setWiper_RainSnsrSta(const double value) noexcept;
    int64_t setWiper_WiperRlyFRSta(const double value) noexcept;
    /// @brief signal comment: Wiper_RearWiperWasherSwitchStatus
    int64_t setWiper_RrWiperWshSwSta(const double value) noexcept;
    /// @brief signal comment: Wiper_IntermittentStepStatus
    int64_t setWiper_IntStepSta(const double value) noexcept;
    /// @brief signal comment: DoorLock_DriverDoorUnLockStatus ##2G## -  - C_DrvUnlockState,CF_Gway_DrvUnlockState
    int64_t setDoorLock_DrvDrUnLkSta(const double value) noexcept;
    /// @brief signal comment: DoorLock_DriverDoorSwitchStatus ##2G## -  - C_DrvDrSw,CF_Gway_DrvDrSw,Warn_DrvDrSwSta
    int64_t setWarn_DrvDrSwSta(const double value) noexcept;
    /// @brief signal comment: DoorLock_AssistDoorUnLockStatus ##2G## -  - C_AstUnlockState,DoorLock_AsstDrUnLkSta
    int64_t setDoorLock_AsstDrUnLkSta(const double value) noexcept;
    /// @brief signal comment: Warn_AssistDoorSwitchStatus ##2G## -  - C_AstDrSw,CF_Gway_AstDrSw,Warn_AsstDrSwSta
    int64_t setWarn_AsstDrSwSta(const double value) noexcept;
    int64_t setSBCM_AST_DoorStatus(const double value) noexcept;
    int64_t setSBCM_AST_Door_Blocked(const double value) noexcept;
    /// @brief signal comment: DoorLock_RearLeftDoorUnLockStatus ##2G## -  - C_RLUnlockState,DoorLock_RrLftDrUnLkSta
    int64_t setDoorLock_RrLftDrUnLkSta(const double value) noexcept;
    /// @brief signal comment: Warn_RearLeftDoorSwitchStatus ##2G## -  - C_RLDrSw,CF_Gway_RLDrSw,Warn_RrLftDrSwSta
    int64_t setWarn_RrLftDrSwSta(const double value) noexcept;
    int64_t setSBCM_RL_DoorStatus(const double value) noexcept;
    int64_t setSBCM_RL_Door_Blocked(const double value) noexcept;
    /// @brief signal comment: DoorLock_RearRightDoorUnLockStatus ##2G## -  - C_RRUnlockState,DoorLock_RrRtDrUnLkSta
    int64_t setDoorLock_RrRtDrUnLkSta(const double value) noexcept;
    /// @brief signal comment: Warn_RearRightDoorSwitchStatus ##2G## -  - C_RRDrSw,CF_Gway_RRDrSw,Warn_RrRtDrSwSta
    int64_t setWarn_RrRtDrSwSta(const double value) noexcept;
    int64_t setSBCM_RR_DoorStatus(const double value) noexcept;
    int64_t setSBCM_RR_Door_Blocked(const double value) noexcept;
    int64_t setPTGM_OpnClsState(const double value) noexcept;
    int64_t setPTGM_CmdWarn(const double value) noexcept;
    int64_t setPTGM_AntiPinchSnsr(const double value) noexcept;
    /// @brief signal comment: Warn_HoodSwitchStatus ##2G## -  - C_HoodSw,CF_Gway_HoodSw
    int64_t setWarn_HoodSwSta(const double value) noexcept;
    /// @brief signal comment: Window_DriverSideWindowActionStatus ##2G##BCM - BCMmsg25 - C_DrvWindowActState
    int64_t setWindow_DrvrSdWdwActSta(const double value) noexcept;
    /// @brief signal comment: Window_DriverSideWindowDetailOpenStatus ##2G##BCM - BCMmsg26 - C_DrvWdwDetailOpenState
    int64_t setWindow_DrvrSdWdwDetailOpnSta(const double value) noexcept;
    /// @brief signal comment: Window_DriverSideWindowErrorAntiPinch ##2G##BCM - BCMmsg26 - C_DrvWdwErrAntiPinch
    int64_t setWindow_DrvrSdWdwErrAntPinch(const double value) noexcept;
    /// @brief signal comment: Window_DriverPowerWindowAutoSwitchStatus
    int64_t setWindow_DrvPwrWdwAutoSwSta(const double value) noexcept;
    /// @brief signal comment: Window_DriverPowerWindowDownSwitchStatus
    int64_t setWindow_DrvPwrWdwDnSwSta(const double value) noexcept;
    /// @brief signal comment: Window_DriverPowerWindowUpSwitchStatus
    int64_t setWindow_DrvPwrWdwUpSwSta(const double value) noexcept;
    /// @brief signal comment: Window_AssistantSideWindowActionStatus ##2G##BCM - BCMmsg25 - C_AstWindowActState
    int64_t setWindow_AsstSdWdwActSta(const double value) noexcept;
    /// @brief signal comment: Window_AssistantSideWindowDetailOpenStatus ##2G##BCM - BCMmsg26 - C_AstWdwDetailOpenState
    int64_t setWindow_AsstSdWdwDetailOpnSta(const double value) noexcept;
    /// @brief signal comment: Window_AssistantSideWindowErrorAntiPinch ##2G##BCM - BCMmsg26 - C_AstWdwErrAntiPinch
    int64_t setWindow_AsstSdWdwErrAntPinch(const double value) noexcept;
    /// @brief signal comment: Window_AssistPowerWindowAutoSwitchStatus ##2G##DDM -  - C_AstPwdwAutoSwDDM
    int64_t setWindow_AsstPwrWdwAutoSwSta(const double value) noexcept;
    /// @brief signal comment: Window_AssistantPowerWindowDownSwitchStatus ##2G##DDM -  - C_AstPwdwDnSwDDM
    int64_t setWindow_AsstPwrWdwDnSwSta(const double value) noexcept;
    /// @brief signal comment: Window_AssistantPowerWindowUpSwitchStatus ##2G##DDM -  - C_AstPwdwUpSwDDM
    int64_t setWindow_AsstPwrWdwUpSwSta(const double value) noexcept;
    /// @brief signal comment: Window_RearLeftPowerWindowAutoSwitchStatus ##2G##DDM -  - C_RLPwdwAutoSwDDM
    int64_t setWindow_RrLftPwrWdwAutoSwSta(const double value) noexcept;
    /// @brief signal comment: Window_RearLeftPowerWindowDownSwitchStatus ##2G##DDM -  - C_RLPwdwDnSwDDM
    int64_t setWindow_RrLftPwrWdwDnSwSta(const double value) noexcept;
    /// @brief signal comment: Window_RearLeftPowerWindowUpSwitchStatus ##2G##DDM -  - C_RLPwdwUpSwDDM
    int64_t setWindow_RrLftPwrWdwUpSwSta(const double value) noexcept;
    /// @brief signal comment: Window_RearLeftWindowActionStatus ##2G##BCM - BCMmsg25 - C_RLWindowActState
    int64_t setWindow_RrLftWdwActSta(const double value) noexcept;
    /// @brief signal comment: Window_RearLeftWindowDetailOpenStatus ##2G##BCM - BCMmsg26 - C_RLWdwDetailOpenState
    int64_t setWindow_RrLftWdwDetailOpnSta(const double value) noexcept;
    /// @brief signal comment: Window_RearLeftWindowErrorAntiPinch ##2G##BCM - BCMmsg26 - C_RLWdwErrAntiPinch
    int64_t setWindow_RrLftWdwErrAntPinch(const double value) noexcept;
    /// @brief signal comment: Window_RearRightPowerWindowAutoSwitchStatus ##2G##DDM -  - C_RRPwdwAutoSwDDM
    int64_t setWindow_RrRtPwrWdwAutoSwSta(const double value) noexcept;
    /// @brief signal comment: Window_RearRightPowerWindowDownSwitchStatus ##2G##DDM -  - C_RRPwdwDnSwDDM
    int64_t setWindow_RrRtPwrWdwDnSwSta(const double value) noexcept;
    /// @brief signal comment: Window_RearRightPowerWindowUpSwitchStatus ##2G##DDM -  - C_RRPwdwUpSwDDM
    int64_t setWindow_RrRtPwrWdwUpSwSta(const double value) noexcept;
    /// @brief signal comment: Window_RearRightWindowActionStatus ##2G##BCM - BCMmsg25 - C_RRWindowActState
    int64_t setWindow_RrRtWdwActSta(const double value) noexcept;
    /// @brief signal comment: Window_RearRightWindowDetailOpenStatus ##2G##BCM - BCMmsg26 - C_RRWdwDetailOpenState
    int64_t setWindow_RrRtWdwDetailOpnSta(const double value) noexcept;
    /// @brief signal comment: Window_RearRightWindowErrorAntiPinch ##2G##BCM - BCMmsg26 - C_RRWdwErrAntiPinch
    int64_t setWindow_RrRtWdwErrAntPinch(const double value) noexcept;
    /// @brief signal comment: Window_PowerWindowMoveInhibitStatus ##2G##DDM -  - C_PwdwInhibit
    int64_t setWindow_PwrWdwMvInhbtSta(const double value) noexcept;
    /// @brief signal comment: BurglarHorn Relay Status
    int64_t setBurglarHornRlySta(const double value) noexcept;
    /// @brief signal comment: Front interior cabin light staus
    int64_t setIntCabinLight_Fr(const double value) noexcept;
    /// @brief signal comment: Rear left interior cabin light satus
    int64_t setIntCabinLight_RrLf(const double value) noexcept;
    /// @brief signal comment: Rear right interior cabin light staus
    int64_t setIntCabinLight_RrRt(const double value) noexcept;
    /// @brief signal comment: OHCL mood lamp Status
    int64_t setOHCL_MoodLampSta(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::avproto

#endif
