/// @copyright Copyright (c) 2021- Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file: /home/scotty/Downloads/Gen2_AVT_B_Control_CAN1.dbc

#ifndef VIC_BodyCtrl_FB_01C_PE_200ms_av_proto_H_
#define VIC_BodyCtrl_FB_01C_PE_200ms_av_proto_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::avproto {

namespace VIC_BodyCtrl_FB_01C_PE_200ms_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

/// This class contains members for decoding/encoding the CAN message VIC_BodyCtrl_FB_01C_PE_200ms
/// The default message identifier for VIC_BodyCtrl_FB_01C_PE_200ms is 0x88 (136)

/// For decoding this is the required length of a decodable message. If the message
/// is smaller there is data missing.
/// For encoding this the length of the CAN message encoded by this class assuming all
/// setters have been called. This value should be one greater than the largest index
/// written to by any of the setter methods.
const uint8_t VIC_BODYCTRL_FB_01C_PE_200MS_PACKET_LEN = UINT8_C(32);
} // namespace VIC_BodyCtrl_FB_01C_PE_200ms_CONSTS

class VIC_BodyCtrl_FB_01C_PE_200ms
{
public:
    VIC_BodyCtrl_FB_01C_PE_200ms(const uint32_t id);
    VIC_BodyCtrl_FB_01C_PE_200ms(const uint32_t id, uint8_t* const payload, const uint8_t size);

    /// @brief signal comment: ACU_CyclicRedundancyCheck1Value
    double getVIC_BodyCtrl_FB_01C_Crc1Val() const noexcept;
    /// @brief signal comment: ACU_AliveCounter1Value
    double getVIC_BodyCtrl_FB_01C_AlvCnt1Val() const noexcept;
    /// @brief signal comment: Warn_RearCenterSeatBeltSwitchStatus ##2G## -  - C_RCSeatBeltSw
    double getWarn_RrCtrStBltSwSta() const noexcept;
    /// @brief signal comment: Warn_RearLeftSeatBeltSwitchStatus ##2G## -  - C_RLSeatBeltSw
    double getWarn_RrLftStBltSwSta() const noexcept;
    /// @brief signal comment: Warn_RearRightSeatBeltSwitchStatus ##2G## -  - C_RRSeatBeltSw
    double getWarn_RrRtStBltSwSta() const noexcept;
    /// @brief signal comment: Warn_AssistSeatBeltSwitchStatus ##2G## -  - C_AstSeatBeltSw,CF_Gway_AstSeatBeltSw
    double getWarn_AsstStBltSwSta() const noexcept;
    /// @brief signal comment: Warn_DriverSeatbeltSwitchStatus ##2G## -  - C_DrvSeatBeltSw,CF_Gway_DrvSeatBeltSw
    double getWarn_DrvStBltSwSta() const noexcept;
    /// @brief signal comment: Warn_PassengerSeatOccupyStatus ##2G## -  - C_SBRMatSw
    double getWarn_PassStOccSta() const noexcept;
    /// @brief signal comment: ##2G## -  - C_RLSBRMatSw
    double getWarn_RrLftSBRMATSwSta() const noexcept;
    /// @brief signal comment: ##2G## -  - C_RRSBRMatSw
    double getWarn_RrRhtSBRMATSwSta() const noexcept;
    double getWarn_RrCtrSBRMATSwSta() const noexcept;
    double getAPSM_AstHeightPosition() const noexcept;
    double getAPSM_AstReclinePosition() const noexcept;
    double getAPSM_AstSlidePosition() const noexcept;
    /// @brief signal comment: APSM_SeatPositionReclineLimit_State
    double getAPSM_SeatPosRclnLmt_Sta() const noexcept;
    /// @brief signal comment: APSM_SeatPositionSlideLimitState
    double getAPSM_SeatPosSldLmt_Sta() const noexcept;
    /// @brief signal comment: Washer Fluid Switch Signal ##2G## -  - CF_Gway_WasherFluidSw
    double getWarn_WshrFldSwSta() const noexcept;
    /// @brief signal comment: Warn_DisplayWarningStatus ##2G##SMK - SMKmsg17 - C_SMKDispWarn
    double getWarn_DisWrngSta() const noexcept;
    /// @brief signal comment: Warn_ImmobilizerLampOnRequest ##2G##SMK - SMKmsg17 - C_ImmoLp
    double getWarn_ImmoLmpOnReq() const noexcept;
    /// @brief signal comment: BCM_Ignition1InputStatus ##2G##BCM - BCMmsg17 - C_Ign1
    double getBCM_Ign1InSta() const noexcept;
    /// @brief signal comment: BCM_Ignition1InputStatus ##2G##BCM - BCMmsg17 - C_Ign2
    double getBCM_Ign2InSta() const noexcept;
    /// @brief signal comment: BCM_IgnitionSwitchStatus ##2G##BCM - BCMmsg17 - C_IGNSw
    double getBCM_IgnSwSta() const noexcept;
    /// @brief signal comment: This is the actual battery voltage as measured on the battery pole by battery sensor.
    /// ##2G## -  - BS1_VBAT
    double getICU_BS1BatVol() const noexcept;
    /// @brief signal comment: setting condition is depending on battery sensor self diagnosis information ##2G## -  -
    /// BS1_BSInvalidFlag
    double getICU_BS1ValFlagSta() const noexcept;
    /// @brief signal comment: Fault State of SOC
    double getICU_BS2_FSOC() const noexcept;
    /// @brief signal comment: This signal is battery State of Charge as calculated by battery sensor. ##2G## -  -
    /// BS2_SOC,Batt_SoC
    double getICU_BS2SoC() const noexcept;
    /// @brief signal comment: APSS_RelaxModeButton
    double getAPSS_StRlxModeBtn() const noexcept;
    /// @brief signal comment: APSS_RelaxReturnButton
    double getAPSS_StRlxReturnBtn() const noexcept;
    /// @brief signal comment: APSS_RelaxTiltUpMoveButton
    double getAPSS_StRlxTltUpMvBtn() const noexcept;
    /// @brief signal comment: APSS_RelaxTiltDownMoveButton
    double getAPSS_StRlxTltDnMvBtn() const noexcept;
    /// @brief signal comment: Lamp_LightSwitchStatus
    double getLamp_LtSwSta() const noexcept;
    /// @brief signal comment: Lamp_TurnSignalLeftSwitchStatus
    double getLamp_TrnSigLftSwSta() const noexcept;
    /// @brief signal comment: Lamp_TurnSignalRightSwitchStatus
    double getLamp_TrnSigRtSwSta() const noexcept;
    /// @brief signal comment: Wiper_FrontWiperSwitchStatus
    double getWiper_FrWiperSwSta() const noexcept;

    /// @brief signal comment: ACU_CyclicRedundancyCheck1Value
    int64_t setVIC_BodyCtrl_FB_01C_Crc1Val(const double value) noexcept;
    /// @brief signal comment: ACU_AliveCounter1Value
    int64_t setVIC_BodyCtrl_FB_01C_AlvCnt1Val(const double value) noexcept;
    /// @brief signal comment: Warn_RearCenterSeatBeltSwitchStatus ##2G## -  - C_RCSeatBeltSw
    int64_t setWarn_RrCtrStBltSwSta(const double value) noexcept;
    /// @brief signal comment: Warn_RearLeftSeatBeltSwitchStatus ##2G## -  - C_RLSeatBeltSw
    int64_t setWarn_RrLftStBltSwSta(const double value) noexcept;
    /// @brief signal comment: Warn_RearRightSeatBeltSwitchStatus ##2G## -  - C_RRSeatBeltSw
    int64_t setWarn_RrRtStBltSwSta(const double value) noexcept;
    /// @brief signal comment: Warn_AssistSeatBeltSwitchStatus ##2G## -  - C_AstSeatBeltSw,CF_Gway_AstSeatBeltSw
    int64_t setWarn_AsstStBltSwSta(const double value) noexcept;
    /// @brief signal comment: Warn_DriverSeatbeltSwitchStatus ##2G## -  - C_DrvSeatBeltSw,CF_Gway_DrvSeatBeltSw
    int64_t setWarn_DrvStBltSwSta(const double value) noexcept;
    /// @brief signal comment: Warn_PassengerSeatOccupyStatus ##2G## -  - C_SBRMatSw
    int64_t setWarn_PassStOccSta(const double value) noexcept;
    /// @brief signal comment: ##2G## -  - C_RLSBRMatSw
    int64_t setWarn_RrLftSBRMATSwSta(const double value) noexcept;
    /// @brief signal comment: ##2G## -  - C_RRSBRMatSw
    int64_t setWarn_RrRhtSBRMATSwSta(const double value) noexcept;
    int64_t setWarn_RrCtrSBRMATSwSta(const double value) noexcept;
    int64_t setAPSM_AstHeightPosition(const double value) noexcept;
    int64_t setAPSM_AstReclinePosition(const double value) noexcept;
    int64_t setAPSM_AstSlidePosition(const double value) noexcept;
    /// @brief signal comment: APSM_SeatPositionReclineLimit_State
    int64_t setAPSM_SeatPosRclnLmt_Sta(const double value) noexcept;
    /// @brief signal comment: APSM_SeatPositionSlideLimitState
    int64_t setAPSM_SeatPosSldLmt_Sta(const double value) noexcept;
    /// @brief signal comment: Washer Fluid Switch Signal ##2G## -  - CF_Gway_WasherFluidSw
    int64_t setWarn_WshrFldSwSta(const double value) noexcept;
    /// @brief signal comment: Warn_DisplayWarningStatus ##2G##SMK - SMKmsg17 - C_SMKDispWarn
    int64_t setWarn_DisWrngSta(const double value) noexcept;
    /// @brief signal comment: Warn_ImmobilizerLampOnRequest ##2G##SMK - SMKmsg17 - C_ImmoLp
    int64_t setWarn_ImmoLmpOnReq(const double value) noexcept;
    /// @brief signal comment: BCM_Ignition1InputStatus ##2G##BCM - BCMmsg17 - C_Ign1
    int64_t setBCM_Ign1InSta(const double value) noexcept;
    /// @brief signal comment: BCM_Ignition1InputStatus ##2G##BCM - BCMmsg17 - C_Ign2
    int64_t setBCM_Ign2InSta(const double value) noexcept;
    /// @brief signal comment: BCM_IgnitionSwitchStatus ##2G##BCM - BCMmsg17 - C_IGNSw
    int64_t setBCM_IgnSwSta(const double value) noexcept;
    /// @brief signal comment: This is the actual battery voltage as measured on the battery pole by battery sensor.
    /// ##2G## -  - BS1_VBAT
    int64_t setICU_BS1BatVol(const double value) noexcept;
    /// @brief signal comment: setting condition is depending on battery sensor self diagnosis information ##2G## -  -
    /// BS1_BSInvalidFlag
    int64_t setICU_BS1ValFlagSta(const double value) noexcept;
    /// @brief signal comment: Fault State of SOC
    int64_t setICU_BS2_FSOC(const double value) noexcept;
    /// @brief signal comment: This signal is battery State of Charge as calculated by battery sensor. ##2G## -  -
    /// BS2_SOC,Batt_SoC
    int64_t setICU_BS2SoC(const double value) noexcept;
    /// @brief signal comment: APSS_RelaxModeButton
    int64_t setAPSS_StRlxModeBtn(const double value) noexcept;
    /// @brief signal comment: APSS_RelaxReturnButton
    int64_t setAPSS_StRlxReturnBtn(const double value) noexcept;
    /// @brief signal comment: APSS_RelaxTiltUpMoveButton
    int64_t setAPSS_StRlxTltUpMvBtn(const double value) noexcept;
    /// @brief signal comment: APSS_RelaxTiltDownMoveButton
    int64_t setAPSS_StRlxTltDnMvBtn(const double value) noexcept;
    /// @brief signal comment: Lamp_LightSwitchStatus
    int64_t setLamp_LtSwSta(const double value) noexcept;
    /// @brief signal comment: Lamp_TurnSignalLeftSwitchStatus
    int64_t setLamp_TrnSigLftSwSta(const double value) noexcept;
    /// @brief signal comment: Lamp_TurnSignalRightSwitchStatus
    int64_t setLamp_TrnSigRtSwSta(const double value) noexcept;
    /// @brief signal comment: Wiper_FrontWiperSwitchStatus
    int64_t setWiper_FrWiperSwSta(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::avproto

#endif
