/// @copyright Copyright (c) 2021- Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file: /home/scotty/Downloads/Gen2_AVT_B_Control_CAN1.dbc

#ifndef VIC_BodyCtrl_FB_02_P_200ms_av_proto_H_
#define VIC_BodyCtrl_FB_02_P_200ms_av_proto_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::avproto {

namespace VIC_BodyCtrl_FB_02_P_200ms_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

/// This class contains members for decoding/encoding the CAN message VIC_BodyCtrl_FB_02_P_200ms
/// The default message identifier for VIC_BodyCtrl_FB_02_P_200ms is 0x8a (138)

/// For decoding this is the required length of a decodable message. If the message
/// is smaller there is data missing.
/// For encoding this the length of the CAN message encoded by this class assuming all
/// setters have been called. This value should be one greater than the largest index
/// written to by any of the setter methods.
const uint8_t VIC_BODYCTRL_FB_02_P_200MS_PACKET_LEN = UINT8_C(32);
} // namespace VIC_BodyCtrl_FB_02_P_200ms_CONSTS

class VIC_BodyCtrl_FB_02_P_200ms
{
public:
    VIC_BodyCtrl_FB_02_P_200ms(const uint32_t id);
    VIC_BodyCtrl_FB_02_P_200ms(const uint32_t id, uint8_t* const payload, const uint8_t size);

    /// @brief signal comment: TPMS_CyclicRedundancyCheck1Value
    double getVIC_BodyCtrl_FB_02_Crc1Val() const noexcept;
    /// @brief signal comment: TPMS_AliveCounter1Value
    double getVIC_BodyCtrl_FB_02_AlvCnt1Val() const noexcept;
    /// @brief signal comment: TPMS_FrontLeftTirePressureValue ##2G##IBU - TPMS11 - PRESSURE_FL
    /// Units: PSI
    double getTPMS_FLTirePrsrVal() const noexcept;
    /// @brief signal comment: TPMS_FrontRightTirePressureValue ##2G##IBU - TPMS11 - PRESSURE_FR
    /// Units: PSI
    double getTPMS_FRTirePrsrVal() const noexcept;
    /// @brief signal comment: TPMS_RearLeftTirePressureValue ##2G##IBU - TPMS11 - PRESSURE_RL
    /// Units: PSI
    double getTPMS_RLTirePrsrVal() const noexcept;
    /// @brief signal comment: TPMS_RearRightTirePressureValue ##2G##IBU - TPMS11 - PRESSURE_RR
    /// Units: PSI
    double getTPMS_RRTirePrsrVal() const noexcept;
    /// @brief signal comment: TPMS_FrontLeftPositionWarningLampStatus ##2G##IBU - TPMS11 - POS_FL_W_LAMP
    double getTPMS_FLPosWrngLmpSta() const noexcept;
    /// @brief signal comment: TPMS_FrontRightPositionWarningLampStatus ##2G##IBU - TPMS11 - POS_FR_W_LAMP
    double getTPMS_FRPosWrngLmpSta() const noexcept;
    /// @brief signal comment: TPMS_PressureUnit ##2G##IBU - TPMS11 - UNIT
    double getTPMS_PrsrUnitSta() const noexcept;
    /// @brief signal comment: TPMS_RearLeftPositionWarningLampStatus ##2G##IBU - TPMS11 - POS_RL_W_LAMP
    double getTPMS_RLPosWrngLmpSta() const noexcept;
    /// @brief signal comment: TPMS_RearRightPositionWarningLampStatus ##2G##IBU - TPMS11 - POS_RR_W_LAMP
    double getTPMS_RRPosWrngLmpSta() const noexcept;
    /// @brief signal comment: TPMS_TreadWarningLampStatus ##2G##IBU - TPMS11 - TREAD_W_LAMP
    double getTPMS_TreadWrngLmpSta() const noexcept;
    /// @brief signal comment: TPMS_WarninglampStatus ##2G##IBU - TPMS11 - TPMS_W_LAMP
    double getTPMS_WrngLmpSta() const noexcept;
    /// @brief signal comment: TPMS_SensorStatus ##2G##IBU - TPMS11 - STATUS_TPMS
    double getTPMS_SnsrSta() const noexcept;
    /// @brief signal comment: CDM_HS_ OpenCloseState
    double getCDM_HS_OpnClsState() const noexcept;
    /// @brief signal comment: Temperature feedback driver side in C (DATC_DrvTempCDis)
    /// Units: ï¿½ï¿½
    double getDATC_AV_DrvTempCSta() const noexcept;
    /// @brief signal comment: Temperature feedback driver side in F (DATC_DrvTempFDis)
    /// Units: ï¿½ï¿½
    double getDATC_AV_DrvTempFSta() const noexcept;
    /// @brief signal comment: EWP for HPC Cooling actual rpm drive speed
    /// Units: rpm
    double getDATC_AV_EWPActRPM() const noexcept;
    /// @brief signal comment: Temperature feedbackpassenger side in C (DATC_PassTempCDis)
    /// Units: ï¿½ï¿½
    double getDATC_AV_PassTempCSta() const noexcept;
    /// @brief signal comment: Temperature feedbackpassenger side in F (DATC_PassTempFDis)
    /// Units: ï¿½ï¿½
    double getDATC_AV_PassTempFSta() const noexcept;
    /// @brief signal comment: HVAC Auto mode feedback (DATC_AUTOStep)
    double getDATC_AV_AutoSta() const noexcept;
    /// @brief signal comment: Blower speed feedback (DATC_BlwSta)
    double getDATC_AV_BlowerSta() const noexcept;
    /// @brief signal comment: Air direction  feedback(DATC_FrDrvModDis)
    double getDATC_AV_ModeSta() const noexcept;
    /// @brief signal comment: Front Defog feedback(DATC_DfgSw)
    double getDATC_AV_FrDefSta() const noexcept;
    /// @brief signal comment: HVAC recirculation feedback (DATC_IntakeDis)
    double getDATC_AV_IntakeSta() const noexcept;
    /// @brief signal comment: Temperature Unit feedback (DATC_TempDispUnitSta)
    double getDATC_AV_TempUnitSta() const noexcept;

    /// @brief signal comment: TPMS_CyclicRedundancyCheck1Value
    int64_t setVIC_BodyCtrl_FB_02_Crc1Val(const double value) noexcept;
    /// @brief signal comment: TPMS_AliveCounter1Value
    int64_t setVIC_BodyCtrl_FB_02_AlvCnt1Val(const double value) noexcept;
    /// @brief signal comment: TPMS_FrontLeftTirePressureValue ##2G##IBU - TPMS11 - PRESSURE_FL
    /// Units: PSI
    int64_t setTPMS_FLTirePrsrVal(const double value) noexcept;
    /// @brief signal comment: TPMS_FrontRightTirePressureValue ##2G##IBU - TPMS11 - PRESSURE_FR
    /// Units: PSI
    int64_t setTPMS_FRTirePrsrVal(const double value) noexcept;
    /// @brief signal comment: TPMS_RearLeftTirePressureValue ##2G##IBU - TPMS11 - PRESSURE_RL
    /// Units: PSI
    int64_t setTPMS_RLTirePrsrVal(const double value) noexcept;
    /// @brief signal comment: TPMS_RearRightTirePressureValue ##2G##IBU - TPMS11 - PRESSURE_RR
    /// Units: PSI
    int64_t setTPMS_RRTirePrsrVal(const double value) noexcept;
    /// @brief signal comment: TPMS_FrontLeftPositionWarningLampStatus ##2G##IBU - TPMS11 - POS_FL_W_LAMP
    int64_t setTPMS_FLPosWrngLmpSta(const double value) noexcept;
    /// @brief signal comment: TPMS_FrontRightPositionWarningLampStatus ##2G##IBU - TPMS11 - POS_FR_W_LAMP
    int64_t setTPMS_FRPosWrngLmpSta(const double value) noexcept;
    /// @brief signal comment: TPMS_PressureUnit ##2G##IBU - TPMS11 - UNIT
    int64_t setTPMS_PrsrUnitSta(const double value) noexcept;
    /// @brief signal comment: TPMS_RearLeftPositionWarningLampStatus ##2G##IBU - TPMS11 - POS_RL_W_LAMP
    int64_t setTPMS_RLPosWrngLmpSta(const double value) noexcept;
    /// @brief signal comment: TPMS_RearRightPositionWarningLampStatus ##2G##IBU - TPMS11 - POS_RR_W_LAMP
    int64_t setTPMS_RRPosWrngLmpSta(const double value) noexcept;
    /// @brief signal comment: TPMS_TreadWarningLampStatus ##2G##IBU - TPMS11 - TREAD_W_LAMP
    int64_t setTPMS_TreadWrngLmpSta(const double value) noexcept;
    /// @brief signal comment: TPMS_WarninglampStatus ##2G##IBU - TPMS11 - TPMS_W_LAMP
    int64_t setTPMS_WrngLmpSta(const double value) noexcept;
    /// @brief signal comment: TPMS_SensorStatus ##2G##IBU - TPMS11 - STATUS_TPMS
    int64_t setTPMS_SnsrSta(const double value) noexcept;
    /// @brief signal comment: CDM_HS_ OpenCloseState
    int64_t setCDM_HS_OpnClsState(const double value) noexcept;
    /// @brief signal comment: Temperature feedback driver side in C (DATC_DrvTempCDis)
    /// Units: ï¿½ï¿½
    int64_t setDATC_AV_DrvTempCSta(const double value) noexcept;
    /// @brief signal comment: Temperature feedback driver side in F (DATC_DrvTempFDis)
    /// Units: ï¿½ï¿½
    int64_t setDATC_AV_DrvTempFSta(const double value) noexcept;
    /// @brief signal comment: EWP for HPC Cooling actual rpm drive speed
    /// Units: rpm
    int64_t setDATC_AV_EWPActRPM(const double value) noexcept;
    /// @brief signal comment: Temperature feedbackpassenger side in C (DATC_PassTempCDis)
    /// Units: ï¿½ï¿½
    int64_t setDATC_AV_PassTempCSta(const double value) noexcept;
    /// @brief signal comment: Temperature feedbackpassenger side in F (DATC_PassTempFDis)
    /// Units: ï¿½ï¿½
    int64_t setDATC_AV_PassTempFSta(const double value) noexcept;
    /// @brief signal comment: HVAC Auto mode feedback (DATC_AUTOStep)
    int64_t setDATC_AV_AutoSta(const double value) noexcept;
    /// @brief signal comment: Blower speed feedback (DATC_BlwSta)
    int64_t setDATC_AV_BlowerSta(const double value) noexcept;
    /// @brief signal comment: Air direction  feedback(DATC_FrDrvModDis)
    int64_t setDATC_AV_ModeSta(const double value) noexcept;
    /// @brief signal comment: Front Defog feedback(DATC_DfgSw)
    int64_t setDATC_AV_FrDefSta(const double value) noexcept;
    /// @brief signal comment: HVAC recirculation feedback (DATC_IntakeDis)
    int64_t setDATC_AV_IntakeSta(const double value) noexcept;
    /// @brief signal comment: Temperature Unit feedback (DATC_TempDispUnitSta)
    int64_t setDATC_AV_TempUnitSta(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::avproto

#endif
