/// @copyright Copyright (c) 2021- Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file: /home/scotty/Downloads/Gen2_AVT_B_Control_CAN1.dbc

#ifndef VIC_BodyCtrl_FB_03_P_100ms_av_proto_H_
#define VIC_BodyCtrl_FB_03_P_100ms_av_proto_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::avproto {

namespace VIC_BodyCtrl_FB_03_P_100ms_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

/// This class contains members for decoding/encoding the CAN message VIC_BodyCtrl_FB_03_P_100ms
/// The default message identifier for VIC_BodyCtrl_FB_03_P_100ms is 0x8c (140)

/// For decoding this is the required length of a decodable message. If the message
/// is smaller there is data missing.
/// For encoding this the length of the CAN message encoded by this class assuming all
/// setters have been called. This value should be one greater than the largest index
/// written to by any of the setter methods.
const uint8_t VIC_BODYCTRL_FB_03_P_100MS_PACKET_LEN = UINT8_C(32);
} // namespace VIC_BodyCtrl_FB_03_P_100ms_CONSTS

class VIC_BodyCtrl_FB_03_P_100ms
{
public:
    VIC_BodyCtrl_FB_03_P_100ms(const uint32_t id);
    VIC_BodyCtrl_FB_03_P_100ms(const uint32_t id, uint8_t* const payload, const uint8_t size);

    /// @brief signal comment: TPMS_CyclicRedundancyCheck1Value
    double getVIC_BodyCtrl_FB_03_Crc1Val() const noexcept;
    /// @brief signal comment: TPMS_AliveCounter1Value
    double getVIC_BodyCtrl_FB_03_AlvCnt1Val() const noexcept;
    /// @brief signal comment: EDR trigger counter
    double getACU_NumOfEvtTrigVal() const noexcept;
    /// @brief signal comment: Emergency mode counter
    double getACU_NumOfEmerModVal() const noexcept;
    /// @brief signal comment: ACU_SystemWarningLampDisplay ##2G##ACU - ACU14 - CF_SWL_Ind
    double getACU_SysWrngLmpDis() const noexcept;
    /// @brief signal comment: ACU_TelltaleLampDisplay ##2G##ACU - ACU14 - CF_TTL_Ind
    double getACU_TlltlLmpDis() const noexcept;
    /// @brief signal comment: SeatBelt_DriverBuckleStatus ##2G##ACU - ACU11 - CF_DriBkl_Stat
    double getSeatBelt_DrvrBcklSta() const noexcept;
    /// @brief signal comment: ACU_ActiveFaultStatus ##2G##ACU - ACU11 - CF_Acu_FltStat
    double getACU_ActvFltSta() const noexcept;
    /// @brief signal comment: PAB ON_OFF S/W state for USM
    double getACU_PassArbg_SW_Sta() const noexcept;
    /// @brief signal comment: SeatBelt_PassengerBuckleStatus ##2G##ACU - ACU11 - CF_PasBkl_Stat
    double getSeatBelt_PassBcklSta() const noexcept;
    /// @brief signal comment: EDR triggered information bit
    double getACU_EvtTrigSta() const noexcept;
    double getACU_EmerModSta() const noexcept;
    /// @brief signal comment: Charge State for Alarm
    double getVCMS_ChgAlarm_Stat() const noexcept;
    /// @brief signal comment: Charge State Subcode for Charge Alarm
    double getVCMS_ChgAlarm_Subcode() const noexcept;
    /// @brief signal comment: (CF_Cms_SERVICE_LAMP_Req) CLU service lamp request
    /// Units: flag
    double getVCMS_SERVICE_LAMP_Req() const noexcept;
    /// @brief signal comment: VCU_DteBaseValue ##2G##VCU - VCU1 - CR_Vcu_DistEmpty_km(VCU6 - CR_Vcu_DistEmpty_km)
    /// Units: km
    double getVCU_DteBaseVal() const noexcept;
    /// @brief signal comment: VCU_EvDriveReadyClusterDisplayStatus ##2G##VCU - VCU1 - CF_Vcu_EvRdyClu
    double getVCU_EvDrvRdyCluDispSta() const noexcept;
    /// @brief signal comment: VCU_LowSocAlertStatus ##2G##VCU - VCU3 - CF_Vcu_LowSocAlert
    double getVCU_LowSocAlertSta() const noexcept;
    /// @brief signal comment: VCU_LowSocDisplayPercentValue
    double getVCU_LowSocDispPcVal() const noexcept;
    /// @brief signal comment: VCU_SeviceLampRequest ##2G##VCU - VCU5 - CF_Vcu_SerLamp
    double getVCU_ServiceLampReq() const noexcept;
    /// @brief signal comment: CLU_OdometerValue
    /// Units: km
    double getCLU_OdoVal() const noexcept;
    /// @brief signal comment: xEV_ServiceLampRequest
    double getxEV_SrvLmpReq() const noexcept;
    /// @brief signal comment: EV_LowTemperatureStatus
    double getEV_LoTempSta() const noexcept;
    /// @brief signal comment: EV_HighTemperatureStatus
    /// Units: flag
    double getEV_HiTempSta() const noexcept;
    /// @brief signal comment: LDC_SystemControllableStatus
    double getLDC_SysCtrlablSta() const noexcept;
    /// @brief signal comment: LDC_SystemOperatingStatus
    double getLDC_SysOpSta() const noexcept;
    /// @brief signal comment: LDC_PowerDeratingStatus
    double getLDC_PwrDeratingSta() const noexcept;
    /// @brief signal comment: LDC_ServiceLampRequest
    double getLDC_SrvLmpReq() const noexcept;
    /// @brief signal comment: LDC_SystemFaultStatus
    double getLDC_SysFltSta() const noexcept;
    /// @brief signal comment: LDC_AuxBatteryWarningLampRequest
    double getLDC_AuxBattWrnLmpReq() const noexcept;
    /// @brief signal comment: LDC_AuxBatteryWarningAlarmRequest
    double getLDC_AuxBattWrnAlrmReq() const noexcept;
    /// @brief signal comment: ALDC_SystemControllableStatus
    double getALDC_SysCtrlablSta() const noexcept;
    /// @brief signal comment: ALDC_SystemOperatingStatus
    double getALDC_SysOpSta() const noexcept;
    /// @brief signal comment: ALDC_PowerDeratingStatus
    double getALDC_PwrDeratingSta() const noexcept;
    /// @brief signal comment: ALDC_ServiceLampRequest
    double getALDC_SrvLmpReq() const noexcept;
    /// @brief signal comment: ALDC_SystemFaultStatus
    double getALDC_SysFltSta() const noexcept;
    /// @brief signal comment: ALDC_AuxBatteryWarningLampRequest
    double getALDC_AuxBattWrnLmpReq() const noexcept;
    /// @brief signal comment: ALDC_AuxBatteryWarningAlarmRequest
    double getALDC_AuxBattWrnAlrmReq() const noexcept;
    /// @brief signal comment: SeatBelt_DriverBuckleFaultStatus ##2G##ACU - ACU11 - CF_DriBkl_FltStat
    double getSeatBelt_DrvrBcklFltSta() const noexcept;
    /// @brief signal comment: SeatBelt_PassengerBuckleFaultStatus ##2G##ACU - ACU11 - CF_PasBkl_FltStat
    double getSeatBelt_PassBcklFltSta() const noexcept;

    /// @brief signal comment: TPMS_CyclicRedundancyCheck1Value
    int64_t setVIC_BodyCtrl_FB_03_Crc1Val(const double value) noexcept;
    /// @brief signal comment: TPMS_AliveCounter1Value
    int64_t setVIC_BodyCtrl_FB_03_AlvCnt1Val(const double value) noexcept;
    /// @brief signal comment: EDR trigger counter
    int64_t setACU_NumOfEvtTrigVal(const double value) noexcept;
    /// @brief signal comment: Emergency mode counter
    int64_t setACU_NumOfEmerModVal(const double value) noexcept;
    /// @brief signal comment: ACU_SystemWarningLampDisplay ##2G##ACU - ACU14 - CF_SWL_Ind
    int64_t setACU_SysWrngLmpDis(const double value) noexcept;
    /// @brief signal comment: ACU_TelltaleLampDisplay ##2G##ACU - ACU14 - CF_TTL_Ind
    int64_t setACU_TlltlLmpDis(const double value) noexcept;
    /// @brief signal comment: SeatBelt_DriverBuckleStatus ##2G##ACU - ACU11 - CF_DriBkl_Stat
    int64_t setSeatBelt_DrvrBcklSta(const double value) noexcept;
    /// @brief signal comment: ACU_ActiveFaultStatus ##2G##ACU - ACU11 - CF_Acu_FltStat
    int64_t setACU_ActvFltSta(const double value) noexcept;
    /// @brief signal comment: PAB ON_OFF S/W state for USM
    int64_t setACU_PassArbg_SW_Sta(const double value) noexcept;
    /// @brief signal comment: SeatBelt_PassengerBuckleStatus ##2G##ACU - ACU11 - CF_PasBkl_Stat
    int64_t setSeatBelt_PassBcklSta(const double value) noexcept;
    /// @brief signal comment: EDR triggered information bit
    int64_t setACU_EvtTrigSta(const double value) noexcept;
    int64_t setACU_EmerModSta(const double value) noexcept;
    /// @brief signal comment: Charge State for Alarm
    int64_t setVCMS_ChgAlarm_Stat(const double value) noexcept;
    /// @brief signal comment: Charge State Subcode for Charge Alarm
    int64_t setVCMS_ChgAlarm_Subcode(const double value) noexcept;
    /// @brief signal comment: (CF_Cms_SERVICE_LAMP_Req) CLU service lamp request
    /// Units: flag
    int64_t setVCMS_SERVICE_LAMP_Req(const double value) noexcept;
    /// @brief signal comment: VCU_DteBaseValue ##2G##VCU - VCU1 - CR_Vcu_DistEmpty_km(VCU6 - CR_Vcu_DistEmpty_km)
    /// Units: km
    int64_t setVCU_DteBaseVal(const double value) noexcept;
    /// @brief signal comment: VCU_EvDriveReadyClusterDisplayStatus ##2G##VCU - VCU1 - CF_Vcu_EvRdyClu
    int64_t setVCU_EvDrvRdyCluDispSta(const double value) noexcept;
    /// @brief signal comment: VCU_LowSocAlertStatus ##2G##VCU - VCU3 - CF_Vcu_LowSocAlert
    int64_t setVCU_LowSocAlertSta(const double value) noexcept;
    /// @brief signal comment: VCU_LowSocDisplayPercentValue
    int64_t setVCU_LowSocDispPcVal(const double value) noexcept;
    /// @brief signal comment: VCU_SeviceLampRequest ##2G##VCU - VCU5 - CF_Vcu_SerLamp
    int64_t setVCU_ServiceLampReq(const double value) noexcept;
    /// @brief signal comment: CLU_OdometerValue
    /// Units: km
    int64_t setCLU_OdoVal(const double value) noexcept;
    /// @brief signal comment: xEV_ServiceLampRequest
    int64_t setxEV_SrvLmpReq(const double value) noexcept;
    /// @brief signal comment: EV_LowTemperatureStatus
    int64_t setEV_LoTempSta(const double value) noexcept;
    /// @brief signal comment: EV_HighTemperatureStatus
    /// Units: flag
    int64_t setEV_HiTempSta(const double value) noexcept;
    /// @brief signal comment: LDC_SystemControllableStatus
    int64_t setLDC_SysCtrlablSta(const double value) noexcept;
    /// @brief signal comment: LDC_SystemOperatingStatus
    int64_t setLDC_SysOpSta(const double value) noexcept;
    /// @brief signal comment: LDC_PowerDeratingStatus
    int64_t setLDC_PwrDeratingSta(const double value) noexcept;
    /// @brief signal comment: LDC_ServiceLampRequest
    int64_t setLDC_SrvLmpReq(const double value) noexcept;
    /// @brief signal comment: LDC_SystemFaultStatus
    int64_t setLDC_SysFltSta(const double value) noexcept;
    /// @brief signal comment: LDC_AuxBatteryWarningLampRequest
    int64_t setLDC_AuxBattWrnLmpReq(const double value) noexcept;
    /// @brief signal comment: LDC_AuxBatteryWarningAlarmRequest
    int64_t setLDC_AuxBattWrnAlrmReq(const double value) noexcept;
    /// @brief signal comment: ALDC_SystemControllableStatus
    int64_t setALDC_SysCtrlablSta(const double value) noexcept;
    /// @brief signal comment: ALDC_SystemOperatingStatus
    int64_t setALDC_SysOpSta(const double value) noexcept;
    /// @brief signal comment: ALDC_PowerDeratingStatus
    int64_t setALDC_PwrDeratingSta(const double value) noexcept;
    /// @brief signal comment: ALDC_ServiceLampRequest
    int64_t setALDC_SrvLmpReq(const double value) noexcept;
    /// @brief signal comment: ALDC_SystemFaultStatus
    int64_t setALDC_SysFltSta(const double value) noexcept;
    /// @brief signal comment: ALDC_AuxBatteryWarningLampRequest
    int64_t setALDC_AuxBattWrnLmpReq(const double value) noexcept;
    /// @brief signal comment: ALDC_AuxBatteryWarningAlarmRequest
    int64_t setALDC_AuxBattWrnAlrmReq(const double value) noexcept;
    /// @brief signal comment: SeatBelt_DriverBuckleFaultStatus ##2G##ACU - ACU11 - CF_DriBkl_FltStat
    int64_t setSeatBelt_DrvrBcklFltSta(const double value) noexcept;
    /// @brief signal comment: SeatBelt_PassengerBuckleFaultStatus ##2G##ACU - ACU11 - CF_PasBkl_FltStat
    int64_t setSeatBelt_PassBcklFltSta(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::avproto

#endif
