/// @copyright Copyright (c) 2021- Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file: /home/scotty/Downloads/Gen2_AVT_B_Control_CAN1.dbc

#ifndef VIC_BodyCtrl_FB_04_P_10ms_av_proto_H_
#define VIC_BodyCtrl_FB_04_P_10ms_av_proto_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::avproto {

namespace VIC_BodyCtrl_FB_04_P_10ms_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

/// This class contains members for decoding/encoding the CAN message VIC_BodyCtrl_FB_04_P_10ms
/// The default message identifier for VIC_BodyCtrl_FB_04_P_10ms is 0x8e (142)

/// For decoding this is the required length of a decodable message. If the message
/// is smaller there is data missing.
/// For encoding this the length of the CAN message encoded by this class assuming all
/// setters have been called. This value should be one greater than the largest index
/// written to by any of the setter methods.
const uint8_t VIC_BODYCTRL_FB_04_P_10MS_PACKET_LEN = UINT8_C(32);
} // namespace VIC_BodyCtrl_FB_04_P_10ms_CONSTS

class VIC_BodyCtrl_FB_04_P_10ms
{
public:
    VIC_BodyCtrl_FB_04_P_10ms(const uint32_t id);
    VIC_BodyCtrl_FB_04_P_10ms(const uint32_t id, uint8_t* const payload, const uint8_t size);

    /// @brief signal comment: VCU_CyclicRedundancyCheck1Value
    double getVIC_BodyCtrl_FB_04_Crc1Val() const noexcept;
    /// @brief signal comment: VCU_AliveCounter1Value
    double getVIC_BodyCtrl_FB_04_AlvCnt1Val() const noexcept;
    /// @brief signal comment: VCU_EcmSequenceStatus ##2G##VCU - VCU1 - CF_Vcu_IGONStatus
    double getVCU_EcmSeqSta() const noexcept;
    /// @brief signal comment: VCU_EvDriveReadyStatus ##2G##VCU - VCU1 - CF_Vcu_EvRdy
    double getVCU_EvDrvRdySta() const noexcept;
    /// @brief signal comment: xEV_StateOfChargeValue
    /// Units: %
    double getxEV_SocVal_VCU() const noexcept;
    /// @brief signal comment: VCU_LimpHomeModeStatus
    double getVCU_LimpHomeModSta() const noexcept;
    /// @brief signal comment: VCMS Fault Type (CMS Diag, SEQ Diag, EVSE Diag, Fail-Safe Diag)
    double getVCMS_FltType() const noexcept;
    /// @brief signal comment: MCU_ServiceLampOnRequestByMg1
    /// Units: flag
    double getMCU_Mg1SrvLmpOnReq() const noexcept;
    /// @brief signal comment: VCU_GearPositionStatus ##2G##VCU - VCU1 - CF_Vcu_GarSelDisp
    double getVCU_GearPosSta() const noexcept;
    /// @brief signal comment: VCU_GearPositionStatusDisp
    double getVCU_GearPosStaDisp() const noexcept;
    /// @brief signal comment: VCMS Fault Code
    double getVCMS_FltCode() const noexcept;
    /// @brief signal comment: MDPS1 Communication status
    double getMDPS1_FDBK_CommSta() const noexcept;
    /// @brief signal comment: MDPS1 Fault status
    double getMDPS1_FDBK_FltSta() const noexcept;
    /// @brief signal comment: MDPS1 Status (State-Machine)
    double getMDPS1_FDBK_Status() const noexcept;
    /// @brief signal comment: IMU_LateralAccelerationSignalStatus ##2G##YRS - YRS11 - CF_Yrs_LatAcStat
    double getIMU_LatAccelSigSta() const noexcept;
    /// @brief signal comment: IMU_LateralAccelerationValue ##2G##YRS - YRS11 - CR_Yrs_LatAc
    /// Units: g
    double getIMU_LatAccelVal() const noexcept;
    /// @brief signal comment: IMU_LongitudinalAccelerationSignalStatus ##2G##YRS - YRS12 - CF_Yrs_LongAcStat
    double getIMU_LongAccelSigSta() const noexcept;
    /// @brief signal comment: IMU_LongitudinalAccelerationValue ##2G##YRS - YRS12 - CR_Yrs_LongAc
    /// Units: g
    double getIMU_LongAccelVal() const noexcept;
    /// @brief signal comment: IMU_Roll rate signal value
    /// Units: ï¿½ï¿½/s
    double getIMU_RollRtVal() const noexcept;
    /// @brief signal comment: IMU Rollrate signal status
    double getIMU_RollSigSta() const noexcept;
    /// @brief signal comment: IMU_Vertial Acceleration Signal Status
    double getIMU_VerAccelSigSta() const noexcept;
    /// @brief signal comment: IMU_Vertial Acceleration value
    /// Units: g
    double getIMU_VerAccelVal() const noexcept;
    /// @brief signal comment: IMU_YawRateValue ##2G##YRS - YRS11 - CR_Yrs_Yr
    /// Units: ï¿½ï¿½/s
    double getIMU_YawRtVal() const noexcept;
    /// @brief signal comment: IMU_YawSignalStatus ##2G##YRS - YRS11 - CF_Yrs_YrStat
    double getIMU_YawSigSta() const noexcept;

    /// @brief signal comment: VCU_CyclicRedundancyCheck1Value
    int64_t setVIC_BodyCtrl_FB_04_Crc1Val(const double value) noexcept;
    /// @brief signal comment: VCU_AliveCounter1Value
    int64_t setVIC_BodyCtrl_FB_04_AlvCnt1Val(const double value) noexcept;
    /// @brief signal comment: VCU_EcmSequenceStatus ##2G##VCU - VCU1 - CF_Vcu_IGONStatus
    int64_t setVCU_EcmSeqSta(const double value) noexcept;
    /// @brief signal comment: VCU_EvDriveReadyStatus ##2G##VCU - VCU1 - CF_Vcu_EvRdy
    int64_t setVCU_EvDrvRdySta(const double value) noexcept;
    /// @brief signal comment: xEV_StateOfChargeValue
    /// Units: %
    int64_t setxEV_SocVal_VCU(const double value) noexcept;
    /// @brief signal comment: VCU_LimpHomeModeStatus
    int64_t setVCU_LimpHomeModSta(const double value) noexcept;
    /// @brief signal comment: VCMS Fault Type (CMS Diag, SEQ Diag, EVSE Diag, Fail-Safe Diag)
    int64_t setVCMS_FltType(const double value) noexcept;
    /// @brief signal comment: MCU_ServiceLampOnRequestByMg1
    /// Units: flag
    int64_t setMCU_Mg1SrvLmpOnReq(const double value) noexcept;
    /// @brief signal comment: VCU_GearPositionStatus ##2G##VCU - VCU1 - CF_Vcu_GarSelDisp
    int64_t setVCU_GearPosSta(const double value) noexcept;
    /// @brief signal comment: VCU_GearPositionStatusDisp
    int64_t setVCU_GearPosStaDisp(const double value) noexcept;
    /// @brief signal comment: VCMS Fault Code
    int64_t setVCMS_FltCode(const double value) noexcept;
    /// @brief signal comment: MDPS1 Communication status
    int64_t setMDPS1_FDBK_CommSta(const double value) noexcept;
    /// @brief signal comment: MDPS1 Fault status
    int64_t setMDPS1_FDBK_FltSta(const double value) noexcept;
    /// @brief signal comment: MDPS1 Status (State-Machine)
    int64_t setMDPS1_FDBK_Status(const double value) noexcept;
    /// @brief signal comment: IMU_LateralAccelerationSignalStatus ##2G##YRS - YRS11 - CF_Yrs_LatAcStat
    int64_t setIMU_LatAccelSigSta(const double value) noexcept;
    /// @brief signal comment: IMU_LateralAccelerationValue ##2G##YRS - YRS11 - CR_Yrs_LatAc
    /// Units: g
    int64_t setIMU_LatAccelVal(const double value) noexcept;
    /// @brief signal comment: IMU_LongitudinalAccelerationSignalStatus ##2G##YRS - YRS12 - CF_Yrs_LongAcStat
    int64_t setIMU_LongAccelSigSta(const double value) noexcept;
    /// @brief signal comment: IMU_LongitudinalAccelerationValue ##2G##YRS - YRS12 - CR_Yrs_LongAc
    /// Units: g
    int64_t setIMU_LongAccelVal(const double value) noexcept;
    /// @brief signal comment: IMU_Roll rate signal value
    /// Units: ï¿½ï¿½/s
    int64_t setIMU_RollRtVal(const double value) noexcept;
    /// @brief signal comment: IMU Rollrate signal status
    int64_t setIMU_RollSigSta(const double value) noexcept;
    /// @brief signal comment: IMU_Vertial Acceleration Signal Status
    int64_t setIMU_VerAccelSigSta(const double value) noexcept;
    /// @brief signal comment: IMU_Vertial Acceleration value
    /// Units: g
    int64_t setIMU_VerAccelVal(const double value) noexcept;
    /// @brief signal comment: IMU_YawRateValue ##2G##YRS - YRS11 - CR_Yrs_Yr
    /// Units: ï¿½ï¿½/s
    int64_t setIMU_YawRtVal(const double value) noexcept;
    /// @brief signal comment: IMU_YawSignalStatus ##2G##YRS - YRS11 - CF_Yrs_YrStat
    int64_t setIMU_YawSigSta(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::avproto

#endif
