/// @copyright Copyright (c) 2022 - Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file:
/// https://gitlab.ci.motional.com/systems/av-netwrok-infrastructure/Gen2-AVT-Sample-B/-/blob/dd539e5d752bcae0408ed2b8f29b270cc0db624e/Gen2_AVT_B_Control_CAN1.dbc

#ifndef VIC_Protocol_LLC_Version_av_proto_H_
#define VIC_Protocol_LLC_Version_av_proto_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::avproto {

namespace VIC_Protocol_LLC_Version_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

/// This class contains members for decoding/encoding the CAN message VIC_Protocol_LLC_Version
/// The default message identifier for VIC_Protocol_LLC_Version is 0x340 (832)

/// For decoding this is the required length of a decodable message. If the message
/// is smaller there is data missing.
/// For encoding this the length of the CAN message encoded by this class assuming all
/// setters have been called. This value should be one greater than the largest index
/// written to by any of the setter methods.
const uint8_t VIC_PROTOCOL_LLC_VERSION_PACKET_LEN = UINT8_C(32);
} // namespace VIC_Protocol_LLC_Version_CONSTS

class VIC_Protocol_LLC_Version
{
public:
    VIC_Protocol_LLC_Version(const uint32_t id);
    VIC_Protocol_LLC_Version(const uint32_t id, uint8_t* const payload, const uint8_t size);

    /// @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
    double getCRC_LLC_Version() const noexcept;
    /// @brief signal comment: Alive Counter, E2E Profile 5
    double getALIV_LLC_Version() const noexcept;
    /// @brief signal comment: Vehicle platform information
    double getsts_CarType() const noexcept;
    /// @brief signal comment: low level controller hardware information
    double getsts_HardwareType() const noexcept;
    /// @brief signal comment: low level controller software config information
    double getsts_SCSoftwareVersion() const noexcept;
    /// @brief signal comment: VIC dbc compatible version(minor)
    double getVIC_Protocol_Minor() const noexcept;
    /// @brief signal comment: VIC dbc compatible version(major)
    double getVIC_Protocol_Major() const noexcept;
    /// @brief signal comment: Placeholder for SecOC Freshness Value
    double getFV_LLC_Version() const noexcept;
    /// @brief signal comment: Placeholder for SecOC Authenticator
    double getAUTH_LLC_Version() const noexcept;

    /// @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
    int64_t setCRC_LLC_Version(const double value) noexcept;
    /// @brief signal comment: Alive Counter, E2E Profile 5
    int64_t setALIV_LLC_Version(const double value) noexcept;
    /// @brief signal comment: Vehicle platform information
    int64_t setsts_CarType(const double value) noexcept;
    /// @brief signal comment: low level controller hardware information
    int64_t setsts_HardwareType(const double value) noexcept;
    /// @brief signal comment: low level controller software config information
    int64_t setsts_SCSoftwareVersion(const double value) noexcept;
    /// @brief signal comment: VIC dbc compatible version(minor)
    int64_t setVIC_Protocol_Minor(const double value) noexcept;
    /// @brief signal comment: VIC dbc compatible version(major)
    int64_t setVIC_Protocol_Major(const double value) noexcept;
    /// @brief signal comment: Placeholder for SecOC Freshness Value
    int64_t setFV_LLC_Version(const double value) noexcept;
    /// @brief signal comment: Placeholder for SecOC Authenticator
    int64_t setAUTH_LLC_Version(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::avproto

#endif
