/// @copyright Copyright (c) 2022 - Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file:
/// https://gitlab.ci.motional.com/systems/av-netwrok-infrastructure/Gen2-AVT-Sample-B/-/blob/dd539e5d752bcae0408ed2b8f29b270cc0db624e/Gen2_AVT_B_Control_CAN1.dbc

#ifndef VIC_VEH_DRV_Interface_av_proto_H_
#define VIC_VEH_DRV_Interface_av_proto_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::avproto {

namespace VIC_VEH_DRV_Interface_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

/// This class contains members for decoding/encoding the CAN message VIC_VEH_DRV_Interface
/// The default message identifier for VIC_VEH_DRV_Interface is 0x1e1 (481)

/// For decoding this is the required length of a decodable message. If the message
/// is smaller there is data missing.
/// For encoding this the length of the CAN message encoded by this class assuming all
/// setters have been called. This value should be one greater than the largest index
/// written to by any of the setter methods.
const uint8_t VIC_VEH_DRV_INTERFACE_PACKET_LEN = UINT8_C(32);
} // namespace VIC_VEH_DRV_Interface_CONSTS

class VIC_VEH_DRV_Interface
{
public:
    VIC_VEH_DRV_Interface(const uint32_t id);
    VIC_VEH_DRV_Interface(const uint32_t id, uint8_t* const payload, const uint8_t size);

    /// @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
    double getCRC_VEH_DRV_Interface() const noexcept;
    /// @brief signal comment: Alive Counter, E2E Profile 5
    double getALIV_VEH_DRV_Interface() const noexcept;
    double getB_AutoButton() const noexcept;
    double getB_BrakeOverride() const noexcept;
    double getB_LoggingButton() const noexcept;
    double getB_ParkingBrake() const noexcept;
    double getB_SteerOverride() const noexcept;
    double getB_ThrottleOverride() const noexcept;
    double getsts_IgnitionPosition() const noexcept;
    /// @brief signal comment: AEB operating norminally
    double getB_AEB_Nominal() const noexcept;
    /// @brief signal comment: Accelelerator pedal percentage depression
    /// Units: percent
    double getper_AccelPedalPostion() const noexcept;
    double getB_EngageButton() const noexcept;
    /// @brief signal comment: Brake pedal percentage depression
    /// Units: percent
    double getper_BrakePedalPosition() const noexcept;
    double getB_Seatbelt() const noexcept;
    /// @brief signal comment: All doors closed
    double getB_AllDoors_Closed() const noexcept;
    double getsts_AuthSwitch() const noexcept;
    double getB_EnableButton() const noexcept;
    double getsts_SWRC_CrsSw() const noexcept;
    /// @brief signal comment: All doors locked
    double getB_AllDoors_Locked() const noexcept;
    double getB_ManualTakeover() const noexcept;
    double getB_HoldManual() const noexcept;
    double getB_AD_Transition() const noexcept;
    double getB_ASD_Transition() const noexcept;
    double getB_TransitPark() const noexcept;
    double getB_EPB() const noexcept;
    /// @brief signal comment: AV Power State Ready
    double getB_AV_PwrState_Ready() const noexcept;
    /// @brief signal comment: AV health Norminal
    double getB_AVHealth_Nominal() const noexcept;
    double getsts_VIC1ModeManager() const noexcept;
    /// @brief signal comment: VIC1 ECU status to HPC, VIC2
    double getsts_VIC1_ECUState() const noexcept;
    /// @brief signal comment: Charging port closed
    double getB_ChrgPort_Closed() const noexcept;
    /// @brief signal comment: Driver seat belt buckled
    double getB_DvrSeatbelt_Secured() const noexcept;
    /// @brief signal comment: VIC ECU state norminal
    double getB_ECUState_Nominal() const noexcept;
    /// @brief signal comment: Engage Button Pressed
    double getB_EngageBtn_Press() const noexcept;
    /// @brief signal comment: EPC Applied State
    double getB_EPB_Applied() const noexcept;
    /// @brief signal comment: EPB Released State
    double getB_EPB_Released() const noexcept;
    /// @brief signal comment: E-Stop Button Pressed
    double getB_Estopbtn_Press() const noexcept;
    /// @brief signal comment: EV Driverable State
    double getB_EV_Driverable() const noexcept;
    /// @brief signal comment: GVPM IMU operating norminally
    double getB_GVPM_IMU_Nominal() const noexcept;
    /// @brief signal comment: Other VIC ECU state norminal
    double getB_Other_ECUstate_Nominal() const noexcept;
    /// @brief signal comment: SSA not present
    double getB_SSA_NotPresent() const noexcept;
    /// @brief signal comment: Transmission in Drive
    double getB_Trns_In_Drive() const noexcept;
    /// @brief signal comment: Transmission in Park
    double getB_Trns_In_Park() const noexcept;
    /// @brief signal comment: Trunk and Hood closed
    double getB_TrunkHood_Closed() const noexcept;
    /// @brief signal comment: Zero vehicle velocity state
    double getB_Zero_Veh_Vel() const noexcept;
    /// @brief signal comment: Body Control Actuator Interface Status
    double getsts_BdyInf_Mode() const noexcept;
    /// @brief signal comment: Brake Actuator Interface Status
    double getsts_BrkInf_Mode() const noexcept;
    /// @brief signal comment: Propulsion Actuator Interface Status
    double getsts_PpsInf_Mode() const noexcept;
    /// @brief signal comment: Steering Actuator Interface Status
    double getsts_SteerInf_Mode() const noexcept;
    /// @brief signal comment: Steering Actuator Interface Status
    double getsts_VIC_StopAction() const noexcept;
    /// @brief signal comment: Placeholder for SecOC Freshness Value
    double getFV_VEH_DRV_Interface() const noexcept;
    /// @brief signal comment: Placeholder for SecOC Authenticator
    double getAUTH_VEH_DRV_Interface() const noexcept;

    /// @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
    int64_t setCRC_VEH_DRV_Interface(const double value) noexcept;
    /// @brief signal comment: Alive Counter, E2E Profile 5
    int64_t setALIV_VEH_DRV_Interface(const double value) noexcept;
    int64_t setB_AutoButton(const double value) noexcept;
    int64_t setB_BrakeOverride(const double value) noexcept;
    int64_t setB_LoggingButton(const double value) noexcept;
    int64_t setB_ParkingBrake(const double value) noexcept;
    int64_t setB_SteerOverride(const double value) noexcept;
    int64_t setB_ThrottleOverride(const double value) noexcept;
    int64_t setsts_IgnitionPosition(const double value) noexcept;
    /// @brief signal comment: AEB operating norminally
    int64_t setB_AEB_Nominal(const double value) noexcept;
    /// @brief signal comment: Accelelerator pedal percentage depression
    /// Units: percent
    int64_t setper_AccelPedalPostion(const double value) noexcept;
    int64_t setB_EngageButton(const double value) noexcept;
    /// @brief signal comment: Brake pedal percentage depression
    /// Units: percent
    int64_t setper_BrakePedalPosition(const double value) noexcept;
    int64_t setB_Seatbelt(const double value) noexcept;
    /// @brief signal comment: All doors closed
    int64_t setB_AllDoors_Closed(const double value) noexcept;
    int64_t setsts_AuthSwitch(const double value) noexcept;
    int64_t setB_EnableButton(const double value) noexcept;
    int64_t setsts_SWRC_CrsSw(const double value) noexcept;
    /// @brief signal comment: All doors locked
    int64_t setB_AllDoors_Locked(const double value) noexcept;
    int64_t setB_ManualTakeover(const double value) noexcept;
    int64_t setB_HoldManual(const double value) noexcept;
    int64_t setB_AD_Transition(const double value) noexcept;
    int64_t setB_ASD_Transition(const double value) noexcept;
    int64_t setB_TransitPark(const double value) noexcept;
    int64_t setB_EPB(const double value) noexcept;
    /// @brief signal comment: AV Power State Ready
    int64_t setB_AV_PwrState_Ready(const double value) noexcept;
    /// @brief signal comment: AV health Norminal
    int64_t setB_AVHealth_Nominal(const double value) noexcept;
    int64_t setsts_VIC1ModeManager(const double value) noexcept;
    /// @brief signal comment: VIC1 ECU status to HPC, VIC2
    int64_t setsts_VIC1_ECUState(const double value) noexcept;
    /// @brief signal comment: Charging port closed
    int64_t setB_ChrgPort_Closed(const double value) noexcept;
    /// @brief signal comment: Driver seat belt buckled
    int64_t setB_DvrSeatbelt_Secured(const double value) noexcept;
    /// @brief signal comment: VIC ECU state norminal
    int64_t setB_ECUState_Nominal(const double value) noexcept;
    /// @brief signal comment: Engage Button Pressed
    int64_t setB_EngageBtn_Press(const double value) noexcept;
    /// @brief signal comment: EPC Applied State
    int64_t setB_EPB_Applied(const double value) noexcept;
    /// @brief signal comment: EPB Released State
    int64_t setB_EPB_Released(const double value) noexcept;
    /// @brief signal comment: E-Stop Button Pressed
    int64_t setB_Estopbtn_Press(const double value) noexcept;
    /// @brief signal comment: EV Driverable State
    int64_t setB_EV_Driverable(const double value) noexcept;
    /// @brief signal comment: GVPM IMU operating norminally
    int64_t setB_GVPM_IMU_Nominal(const double value) noexcept;
    /// @brief signal comment: Other VIC ECU state norminal
    int64_t setB_Other_ECUstate_Nominal(const double value) noexcept;
    /// @brief signal comment: SSA not present
    int64_t setB_SSA_NotPresent(const double value) noexcept;
    /// @brief signal comment: Transmission in Drive
    int64_t setB_Trns_In_Drive(const double value) noexcept;
    /// @brief signal comment: Transmission in Park
    int64_t setB_Trns_In_Park(const double value) noexcept;
    /// @brief signal comment: Trunk and Hood closed
    int64_t setB_TrunkHood_Closed(const double value) noexcept;
    /// @brief signal comment: Zero vehicle velocity state
    int64_t setB_Zero_Veh_Vel(const double value) noexcept;
    /// @brief signal comment: Body Control Actuator Interface Status
    int64_t setsts_BdyInf_Mode(const double value) noexcept;
    /// @brief signal comment: Brake Actuator Interface Status
    int64_t setsts_BrkInf_Mode(const double value) noexcept;
    /// @brief signal comment: Propulsion Actuator Interface Status
    int64_t setsts_PpsInf_Mode(const double value) noexcept;
    /// @brief signal comment: Steering Actuator Interface Status
    int64_t setsts_SteerInf_Mode(const double value) noexcept;
    /// @brief signal comment: Steering Actuator Interface Status
    int64_t setsts_VIC_StopAction(const double value) noexcept;
    /// @brief signal comment: Placeholder for SecOC Freshness Value
    int64_t setFV_VEH_DRV_Interface(const double value) noexcept;
    /// @brief signal comment: Placeholder for SecOC Authenticator
    int64_t setAUTH_VEH_DRV_Interface(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::avproto

#endif
