/// @copyright Copyright (c) 2022 - Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// brief This is a brief (1-line) description of the file.
/// This file is generated with dbc2cpp script version : 3.1.0
/// This file was generated from the following DBC file:
/// https://gitlab.ci.motional.com/systems/av-netwrok-infrastructure/Gen2-AVT-Sample-B/-/blob/dd539e5d752bcae0408ed2b8f29b270cc0db624e/Gen2_AVT_B_Control_CAN1.dbc

#ifndef VIC_VEH_Trans_Status_av_proto_H_
#define VIC_VEH_Trans_Status_av_proto_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::avproto {

namespace VIC_VEH_Trans_Status_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

/// This class contains members for decoding/encoding the CAN message VIC_VEH_Trans_Status
/// The default message identifier for VIC_VEH_Trans_Status is 0x1a0 (416)

/// For decoding this is the required length of a decodable message. If the message
/// is smaller there is data missing.
/// For encoding this the length of the CAN message encoded by this class assuming all
/// setters have been called. This value should be one greater than the largest index
/// written to by any of the setter methods.
const uint8_t VIC_VEH_TRANS_STATUS_PACKET_LEN = UINT8_C(32);
} // namespace VIC_VEH_Trans_Status_CONSTS

class VIC_VEH_Trans_Status
{
public:
    VIC_VEH_Trans_Status(const uint32_t id);
    VIC_VEH_Trans_Status(const uint32_t id, uint8_t* const payload, const uint8_t size);

    /// @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
    double getCRC_VEH_Trans_Status() const noexcept;
    /// @brief signal comment: Alive Counter, E2E Profile 5
    double getALIV_VEH_Trans_Status() const noexcept;
    /// @brief signal comment: Current transmision gear/state of the vehicle
    double getsts_GearNum() const noexcept;
    /// @brief signal comment: Current Drive state on vehicle
    double getsts_PRNDL() const noexcept;
    /// @brief signal comment: Placeholder for SecOC Freshness Value
    double getFV_VEH_Trans_Status() const noexcept;
    /// @brief signal comment: Placeholder for SecOC Authenticator
    double getAUTH_VEH_Trans_Status() const noexcept;

    /// @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
    int64_t setCRC_VEH_Trans_Status(const double value) noexcept;
    /// @brief signal comment: Alive Counter, E2E Profile 5
    int64_t setALIV_VEH_Trans_Status(const double value) noexcept;
    /// @brief signal comment: Current transmision gear/state of the vehicle
    int64_t setsts_GearNum(const double value) noexcept;
    /// @brief signal comment: Current Drive state on vehicle
    int64_t setsts_PRNDL(const double value) noexcept;
    /// @brief signal comment: Placeholder for SecOC Freshness Value
    int64_t setFV_VEH_Trans_Status(const double value) noexcept;
    /// @brief signal comment: Placeholder for SecOC Authenticator
    int64_t setAUTH_VEH_Trans_Status(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::avproto

#endif
