/**
 * \copyright
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Aptiv and its suppliers, if any.
 * The intellectual and technical concepts contained herein are proprietary to Aptiv and its suppliers and may be
 * covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material is strictly forbidden unless prior written
 * permission is obtained from Aptiv.
 *
 * \brief This is a brief (1-line) description of the file.
 *
 * This file is generated with dbc2cpp script version : 3.1.0
 *
 * This file was generated from the following DBC file:
 * /home/lixun/Workspace/gen2-avt-sample-a/Gen2_AVT_A_Control_CAN1.dbc
 *
 */

#ifndef AV_Body_Control_Request_g2h_H_
#define AV_Body_Control_Request_g2h_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::tcar {

namespace AV_Body_Control_Request_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

// This class contains members for decoding/encoding the CAN message AV_Body_Control_Request
// The default message identifier for AV_Body_Control_Request is 0x200 (512)

// For decoding this is the required length of a decodable message. If the message
// is smaller there is data missing.
// For encoding this the length of the CAN message encoded by this class assuming all
// setters have been called. This value should be one greater than the largest index
// written to by any of the setter methods.
const uint8_t AV_BODY_CONTROL_REQUEST_PACKET_LEN = UINT8_C(32);
} // namespace AV_Body_Control_Request_CONSTS

class AV_Body_Control_Request
{
public:
    AV_Body_Control_Request(const uint32_t id);
    AV_Body_Control_Request(const uint32_t id, uint8_t* const payload, const uint8_t size);

    /**
     * @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
     */
    double getCRC_AV_Body_Control_Request() const noexcept;
    /**
     * @brief signal comment: Alive Counter, E2E Profile 5
     */
    double getALIV_AV_Body_Control_Request() const noexcept;
    /**
     * @brief signal comment: AV turn indication before turn
     */
    double getsts_TurnSignal_Rq() const noexcept;
    /**
     * @brief signal comment: Placeholder for future Message Authentication Code(MAC)/Signature
     */
    double getMAC_AV_Body_Control_Req() const noexcept;

    /**
     * @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
     */
    int64_t setCRC_AV_Body_Control_Request(const double value) noexcept;
    /**
     * @brief signal comment: Alive Counter, E2E Profile 5
     */
    int64_t setALIV_AV_Body_Control_Request(const double value) noexcept;
    /**
     * @brief signal comment: AV turn indication before turn
     */
    int64_t setsts_TurnSignal_Rq(const double value) noexcept;
    /**
     * @brief signal comment: Placeholder for future Message Authentication Code(MAC)/Signature
     */
    int64_t setMAC_AV_Body_Control_Req(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::tcar

#endif
