/**
 * \copyright
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Aptiv and its suppliers, if any.
 * The intellectual and technical concepts contained herein are proprietary to Aptiv and its suppliers and may be
 * covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material is strictly forbidden unless prior written
 * permission is obtained from Aptiv.
 *
 * \brief This is a brief (1-line) description of the file.
 *
 * This file is generated with dbc2cpp script version : 3.1.0
 *
 * This file was generated from the following DBC file:
 * /home/lixun/Workspace/Gen2-AVT-Sample-A/Gen2_AVT_A_Control_CAN1.dbc
 *
 */

#ifndef AV_Curr_timestamp_g2h_H_
#define AV_Curr_timestamp_g2h_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::tcar {

namespace AV_Curr_timestamp_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

// This class contains members for decoding/encoding the CAN message AV_Curr_timestamp
// The default message identifier for AV_Curr_timestamp is 0x366 (870)

// For decoding this is the required length of a decodable message. If the message
// is smaller there is data missing.
// For encoding this the length of the CAN message encoded by this class assuming all
// setters have been called. This value should be one greater than the largest index
// written to by any of the setter methods.
const uint8_t AV_CURR_TIMESTAMP_PACKET_LEN = UINT8_C(32);
} // namespace AV_Curr_timestamp_CONSTS

class AV_Curr_timestamp
{
public:
    AV_Curr_timestamp(const uint32_t id);
    AV_Curr_timestamp(const uint32_t id, uint8_t* const payload, const uint8_t size);

    /**
     * @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
     */
    double getCRC_AV_Curr_time() const noexcept;
    /**
     * @brief signal comment: Alive Counter, E2E Profile 5
     */
    double getALIV_AV_Curr_time() const noexcept;
    /**
     * @brief signal comment: Integer Portion of current timestamp
     * Units: seconds
     */
    double gett_current_time_int() const noexcept;
    /**
     * @brief signal comment: Decimal portion of current timestamp
     * Units: microseconds
     */
    double gett_current_time_dec() const noexcept;
    /**
     * @brief signal comment: Placeholder for future Message Authentication Code(MAC)/Signature
     */
    double getMAC_AV_Curr_time() const noexcept;

    /**
     * @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
     */
    int64_t setCRC_AV_Curr_time(const double value) noexcept;
    /**
     * @brief signal comment: Alive Counter, E2E Profile 5
     */
    int64_t setALIV_AV_Curr_time(const double value) noexcept;
    /**
     * @brief signal comment: Integer Portion of current timestamp
     * Units: seconds
     */
    int64_t sett_current_time_int(const double value) noexcept;
    /**
     * @brief signal comment: Decimal portion of current timestamp
     * Units: microseconds
     */
    int64_t sett_current_time_dec(const double value) noexcept;
    /**
     * @brief signal comment: Placeholder for future Message Authentication Code(MAC)/Signature
     */
    int64_t setMAC_AV_Curr_time(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::tcar

#endif
