/**
 * \copyright
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Aptiv and its suppliers, if any.
 * The intellectual and technical concepts contained herein are proprietary to Aptiv and its suppliers and may be
 * covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material is strictly forbidden unless prior written
 * permission is obtained from Aptiv.
 *
 * \brief This is a brief (1-line) description of the file.
 *
 * This file is generated with dbc2cpp script version : 3.1.0
 *
 * This file was generated from the following DBC file:
 * /home/lixun/Workspace/gen2-avt-sample-a/Gen2_AVT_A_Control_CAN1.dbc
 *
 */

#ifndef AV_Heading_B_2_g2h_H_
#define AV_Heading_B_2_g2h_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::tcar {

namespace AV_Heading_B_2_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

// This class contains members for decoding/encoding the CAN message AV_Heading_B_2
// The default message identifier for AV_Heading_B_2 is 0x147 (327)

// For decoding this is the required length of a decodable message. If the message
// is smaller there is data missing.
// For encoding this the length of the CAN message encoded by this class assuming all
// setters have been called. This value should be one greater than the largest index
// written to by any of the setter methods.
const uint8_t AV_HEADING_B_2_PACKET_LEN = UINT8_C(32);
} // namespace AV_Heading_B_2_CONSTS

class AV_Heading_B_2
{
public:
    AV_Heading_B_2(const uint32_t id);
    AV_Heading_B_2(const uint32_t id, uint8_t* const payload, const uint8_t size);

    double getCRC_AV_Heading_B_2() const noexcept;
    double getALIV_AV_Heading_B_2() const noexcept;
    /**
     * @brief signal comment: Heading angle18 for Trajectory B, Segment 2
     * Units: rad
     */
    double getu_Heading_B_18() const noexcept;
    /**
     * Units: rad
     */
    double getu_Heading_B_19() const noexcept;
    /**
     * Units: rad
     */
    double getu_Heading_B_20() const noexcept;
    /**
     * Units: rad
     */
    double getu_Heading_B_21() const noexcept;
    /**
     * Units: rad
     */
    double getu_Heading_B_22() const noexcept;
    /**
     * Units: rad
     */
    double getu_Heading_B_23() const noexcept;
    /**
     * Units: rad
     */
    double getu_Heading_B_24() const noexcept;
    /**
     * Units: rad
     */
    double getu_Heading_B_25() const noexcept;
    /**
     * Units: rad
     */
    double getu_Heading_B_26() const noexcept;
    /**
     * Units: rad
     */
    double getu_Heading_B_27() const noexcept;
    /**
     * Units: rad
     */
    double getu_Heading_B_28() const noexcept;
    /**
     * Units: rad
     */
    double getu_Heading_B_29() const noexcept;
    /**
     * Units: rad
     */
    double getu_Heading_B_30() const noexcept;
    /**
     * Units: rad
     */
    double getu_Heading_B_31() const noexcept;
    /**
     * Units: rad
     */
    double getu_Heading_B_32() const noexcept;
    /**
     * Units: rad
     */
    double getu_Heading_B_33() const noexcept;
    /**
     * Units: rad
     */
    double getu_Heading_B_34() const noexcept;

    int64_t setCRC_AV_Heading_B_2(const double value) noexcept;
    int64_t setALIV_AV_Heading_B_2(const double value) noexcept;
    /**
     * @brief signal comment: Heading angle18 for Trajectory B, Segment 2
     * Units: rad
     */
    int64_t setu_Heading_B_18(const double value) noexcept;
    /**
     * Units: rad
     */
    int64_t setu_Heading_B_19(const double value) noexcept;
    /**
     * Units: rad
     */
    int64_t setu_Heading_B_20(const double value) noexcept;
    /**
     * Units: rad
     */
    int64_t setu_Heading_B_21(const double value) noexcept;
    /**
     * Units: rad
     */
    int64_t setu_Heading_B_22(const double value) noexcept;
    /**
     * Units: rad
     */
    int64_t setu_Heading_B_23(const double value) noexcept;
    /**
     * Units: rad
     */
    int64_t setu_Heading_B_24(const double value) noexcept;
    /**
     * Units: rad
     */
    int64_t setu_Heading_B_25(const double value) noexcept;
    /**
     * Units: rad
     */
    int64_t setu_Heading_B_26(const double value) noexcept;
    /**
     * Units: rad
     */
    int64_t setu_Heading_B_27(const double value) noexcept;
    /**
     * Units: rad
     */
    int64_t setu_Heading_B_28(const double value) noexcept;
    /**
     * Units: rad
     */
    int64_t setu_Heading_B_29(const double value) noexcept;
    /**
     * Units: rad
     */
    int64_t setu_Heading_B_30(const double value) noexcept;
    /**
     * Units: rad
     */
    int64_t setu_Heading_B_31(const double value) noexcept;
    /**
     * Units: rad
     */
    int64_t setu_Heading_B_32(const double value) noexcept;
    /**
     * Units: rad
     */
    int64_t setu_Heading_B_33(const double value) noexcept;
    /**
     * Units: rad
     */
    int64_t setu_Heading_B_34(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::tcar

#endif
