/**
 * \copyright
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Aptiv and its suppliers, if any.
 * The intellectual and technical concepts contained herein are proprietary to Aptiv and its suppliers and may be
 * covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material is strictly forbidden unless prior written
 * permission is obtained from Aptiv.
 *
 * \brief This is a brief (1-line) description of the file.
 *
 * This file is generated with dbc2cpp script version : 3.1.0
 *
 * This file was generated from the following DBC file: /home/scotty/Downloads/Gen2_AVT_B_Control_CAN1.dbc
 *
 */

#ifndef AV_MRMCommand_H_
#define AV_MRMCommand_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::tcar {

namespace AV_MRMCommand_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

// This class contains members for decoding/encoding the CAN message AV_MRMCommand
// The default message identifier for AV_MRMCommand is 0x452 (1106)

// For decoding this is the required length of a decodable message. If the message
// is smaller there is data missing.
// For encoding this the length of the CAN message encoded by this class assuming all
// setters have been called. This value should be one greater than the largest index
// written to by any of the setter methods.
const uint8_t AV_MRMCOMMAND_PACKET_LEN = UINT8_C(32);
} // namespace AV_MRMCommand_CONSTS

class AV_MRMCommand
{
public:
    AV_MRMCommand(const uint32_t id);
    AV_MRMCommand(const uint32_t id, uint8_t* const payload, const uint8_t size);

    /**
     * @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
     */
    double getCRC_FaultCode() const noexcept;
    /**
     * @brief signal comment: Alive Counter, E2E Profile 5
     */
    double getALIV_FaultCode() const noexcept;
    /**
     * @brief signal comment: Integer Portion of timestamp
     * Units: seconds
     */
    double gett_MRMCommand_int() const noexcept;
    /**
     * @brief signal comment: Decimal portion of timestamp
     * Units: microseconds
     */
    double gett_MRMCommand_dec() const noexcept;
    /**
     * @brief signal comment: MRM_Command sent by HPC to VIC
     */
    double getMRM_Type() const noexcept;
    /**
     * @brief signal comment: Placeholder for future Message Authentication Code(MAC)/Signature
     */
    double getMAC_FaultCode() const noexcept;

    /**
     * @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
     */
    int64_t setCRC_FaultCode(const double value) noexcept;
    /**
     * @brief signal comment: Alive Counter, E2E Profile 5
     */
    int64_t setALIV_FaultCode(const double value) noexcept;
    /**
     * @brief signal comment: Integer Portion of timestamp
     * Units: seconds
     */
    int64_t sett_MRMCommand_int(const double value) noexcept;
    /**
     * @brief signal comment: Decimal portion of timestamp
     * Units: microseconds
     */
    int64_t sett_MRMCommand_dec(const double value) noexcept;
    /**
     * @brief signal comment: MRM_Command sent by HPC to VIC
     */
    int64_t setMRM_Type(const double value) noexcept;
    /**
     * @brief signal comment: Placeholder for future Message Authentication Code(MAC)/Signature
     */
    int64_t setMAC_FaultCode(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};

} // namespace av::can::g2h::tcar

#endif
