/**
 * \copyright
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Aptiv and its suppliers, if any.
 * The intellectual and technical concepts contained herein are proprietary to Aptiv and its suppliers and may be
 * covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material is strictly forbidden unless prior written
 * permission is obtained from Aptiv.
 *
 * \brief This is a brief (1-line) description of the file.
 *
 * This file is generated with dbc2cpp script version : 3.1.0
 *
 * This file was generated from the following DBC file: /home/scotty/Downloads/Gen2_AVT_A_Control_CAN1.dbc
 *
 */

#ifndef AV_Sec_Path_Tracker_B_g2h_H_
#define AV_Sec_Path_Tracker_B_g2h_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::tcar {

namespace AV_Sec_Path_Tracker_B_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

// This class contains members for decoding/encoding the CAN message AV_Sec_Path_Tracker_B
// The default message identifier for AV_Sec_Path_Tracker_B is 0x121 (289)

// For decoding this is the required length of a decodable message. If the message
// is smaller there is data missing.
// For encoding this the length of the CAN message encoded by this class assuming all
// setters have been called. This value should be one greater than the largest index
// written to by any of the setter methods.
const uint8_t AV_SEC_PATH_TRACKER_B_PACKET_LEN = UINT8_C(32);
} // namespace AV_Sec_Path_Tracker_B_CONSTS

class AV_Sec_Path_Tracker_B
{
public:
    AV_Sec_Path_Tracker_B(const uint32_t id);
    AV_Sec_Path_Tracker_B(const uint32_t id, uint8_t* const payload, const uint8_t size);

    /**
     * @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
     */
    double getCRC_AV_Sec_Path_Tracker_B() const noexcept;
    /**
     * @brief signal comment: Alive Counter, E2E Profile 5
     */
    double getALIV_AV_Sec_Path_Tracker_B() const noexcept;
    /**
     * @brief signal comment: Curvature calculated based on Trajectory B Waypoints
     * Units: 1/m
     */
    double getc_Curvature_B() const noexcept;
    /**
     * @brief signal comment: Heading error calculated based on Trajectory B Waypoints
     * Units: rad
     */
    double getu_HeadingError_B() const noexcept;
    /**
     * @brief signal comment: CrossTrack Error calculated based on Trajectory B Waypoints
     * Units: m
     */
    double getL_CrossTrackError_B() const noexcept;
    /**
     * @brief signal comment:  AV reporting error in the longitudinal direction while safe stop trajectory
     * Units: m
     */
    double getL_station_error_m_B() const noexcept;
    /**
     * @brief signal comment: Placeholder for future Message Authentication Code(MAC)/Signature
     */
    double getMAC_AV_Sec_Path_Tracker_B() const noexcept;

    /**
     * @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
     */
    int64_t setCRC_AV_Sec_Path_Tracker_B(const double value) noexcept;
    /**
     * @brief signal comment: Alive Counter, E2E Profile 5
     */
    int64_t setALIV_AV_Sec_Path_Tracker_B(const double value) noexcept;
    /**
     * @brief signal comment: Curvature calculated based on Trajectory B Waypoints
     * Units: 1/m
     */
    int64_t setc_Curvature_B(const double value) noexcept;
    /**
     * @brief signal comment: Heading error calculated based on Trajectory B Waypoints
     * Units: rad
     */
    int64_t setu_HeadingError_B(const double value) noexcept;
    /**
     * @brief signal comment: CrossTrack Error calculated based on Trajectory B Waypoints
     * Units: m
     */
    int64_t setL_CrossTrackError_B(const double value) noexcept;
    /**
     * @brief signal comment:  AV reporting error in the longitudinal direction while safe stop trajectory
     * Units: m
     */
    int64_t setL_station_error_m_B(const double value) noexcept;
    /**
     * @brief signal comment: Placeholder for future Message Authentication Code(MAC)/Signature
     */
    int64_t setMAC_AV_Sec_Path_Tracker_B(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::tcar

#endif
