/**
 * \copyright
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Aptiv and its suppliers, if any.
 * The intellectual and technical concepts contained herein are proprietary to Aptiv and its suppliers and may be
 * covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material is strictly forbidden unless prior written
 * permission is obtained from Aptiv.
 *
 * \brief This is a brief (1-line) description of the file.
 *
 * This file is generated with dbc2cpp script version : 3.1.0
 *
 * This file was generated from the following DBC file: Gen2_AVT_A_Control_CAN1.dbc
 *
 */

#ifndef AV_Washer_Cleaning_H_
#define AV_Washer_Cleaning_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::tcar {

namespace AV_Washer_Cleaning_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

// This class contains members for decoding/encoding the CAN message AV_Washer_Cleaning
// The default message identifier for AV_Washer_Cleaning is 0x370 (880)

// For decoding this is the required length of a decodable message. If the message
// is smaller there is data missing.
// For encoding this the length of the CAN message encoded by this class assuming all
// setters have been called. This value should be one greater than the largest index
// written to by any of the setter methods.
const uint8_t AV_WASHER_CLEANING_PACKET_LEN = UINT8_C(32);
} // namespace AV_Washer_Cleaning_CONSTS

class AV_Washer_Cleaning
{
public:
    AV_Washer_Cleaning(const uint32_t id);
    AV_Washer_Cleaning(const uint32_t id, uint8_t* const payload, const uint8_t size);

    /**
     * @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
     */
    double getCRC_AV_Washer_Cleaning() const noexcept;
    /**
     * @brief signal comment: Alive Counter, E2E Profile 5
     */
    double getALIV_AV_Washer_Cleaning() const noexcept;
    /**
     * @brief signal comment: Command to Wash-clean CAM_M_F
     */
    double getWash_Clean_CAM_M_F() const noexcept;
    /**
     * @brief signal comment: Command to Wash-clean CAM_W_F
     */
    double getWash_Clean_CAM_W_F() const noexcept;
    /**
     * @brief signal comment: Command to Wash-clean LIDAR_F
     */
    double getWash_Clean_LIDAR_F() const noexcept;
    /**
     * @brief signal comment: Command to Wash-clean LIDAR_T
     */
    double getWash_Clean_LIDAR_T() const noexcept;
    /**
     * @brief signal comment: Placeholder for future use, nozzle currently not present for this sensor.
     */
    double getWash_Clean_CAM_M_L0() const noexcept;
    /**
     * @brief signal comment: Placeholder for future use, nozzle currently not present for this sensor.
     */
    double getWash_Clean_CAM_W_L0() const noexcept;
    /**
     * @brief signal comment: Placeholder for future use, nozzle currently not present for this sensor.
     */
    double getWash_Clean_CAM_M_L1() const noexcept;
    /**
     * @brief signal comment: Placeholder for future use, nozzle currently not present for this sensor.
     */
    double getWash_Clean_CAM_M_L2() const noexcept;
    /**
     * @brief signal comment: Placeholder for future use, nozzle currently not present for this sensor.
     */
    double getWash_Clean_CAM_M_B() const noexcept;
    /**
     * @brief signal comment: Placeholder for future use, nozzle currently not present for this sensor.
     */
    double getWash_Clean_CAM_W_B() const noexcept;
    /**
     * @brief signal comment: Placeholder for future use, nozzle currently not present for this sensor.
     */
    double getWash_Clean_CAM_M_R2() const noexcept;
    /**
     * @brief signal comment: Placeholder for future use, nozzle currently not present for this sensor.
     */
    double getWash_Clean_CAM_M_R1() const noexcept;
    /**
     * @brief signal comment: Placeholder for future use, nozzle currently not present for this sensor.
     */
    double getWash_Clean_CAM_M_R0() const noexcept;
    /**
     * @brief signal comment: Placeholder for future use, nozzle currently not present for this sensor.
     */
    double getWash_Clean_CAM_W_R0() const noexcept;
    /**
     * @brief signal comment: Placeholder for future use, nozzle currently not present for this sensor.
     */
    double getWash_Clean_CAM_N_F() const noexcept;
    /**
     * @brief signal comment: Placeholder for future use, nozzle currently not present for this sensor.
     */
    double getWash_Clean_LIDAR_R() const noexcept;
    /**
     * @brief signal comment: Placeholder for future use, nozzle currently not present for this sensor.
     */
    double getWash_Clean_LIDAR_B() const noexcept;
    /**
     * @brief signal comment: Placeholder for future use, nozzle currently not present for this sensor.
     */
    double getWash_Clean_LIDAR_L() const noexcept;
    /**
     * @brief signal comment: Placeholder for future Message Authentication Code(MAC)/Signature
     */
    double getMAC_AV_Washer_Cleaning() const noexcept;

    /**
     * @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
     */
    int64_t setCRC_AV_Washer_Cleaning(const double value) noexcept;
    /**
     * @brief signal comment: Alive Counter, E2E Profile 5
     */
    int64_t setALIV_AV_Washer_Cleaning(const double value) noexcept;
    /**
     * @brief signal comment: Command to Wash-clean CAM_M_F
     */
    int64_t setWash_Clean_CAM_M_F(const double value) noexcept;
    /**
     * @brief signal comment: Command to Wash-clean CAM_W_F
     */
    int64_t setWash_Clean_CAM_W_F(const double value) noexcept;
    /**
     * @brief signal comment: Command to Wash-clean LIDAR_F
     */
    int64_t setWash_Clean_LIDAR_F(const double value) noexcept;
    /**
     * @brief signal comment: Command to Wash-clean LIDAR_T
     */
    int64_t setWash_Clean_LIDAR_T(const double value) noexcept;
    /**
     * @brief signal comment: Placeholder for future use, nozzle currently not present for this sensor.
     */
    int64_t setWash_Clean_CAM_M_L0(const double value) noexcept;
    /**
     * @brief signal comment: Placeholder for future use, nozzle currently not present for this sensor.
     */
    int64_t setWash_Clean_CAM_W_L0(const double value) noexcept;
    /**
     * @brief signal comment: Placeholder for future use, nozzle currently not present for this sensor.
     */
    int64_t setWash_Clean_CAM_M_L1(const double value) noexcept;
    /**
     * @brief signal comment: Placeholder for future use, nozzle currently not present for this sensor.
     */
    int64_t setWash_Clean_CAM_M_L2(const double value) noexcept;
    /**
     * @brief signal comment: Placeholder for future use, nozzle currently not present for this sensor.
     */
    int64_t setWash_Clean_CAM_M_B(const double value) noexcept;
    /**
     * @brief signal comment: Placeholder for future use, nozzle currently not present for this sensor.
     */
    int64_t setWash_Clean_CAM_W_B(const double value) noexcept;
    /**
     * @brief signal comment: Placeholder for future use, nozzle currently not present for this sensor.
     */
    int64_t setWash_Clean_CAM_M_R2(const double value) noexcept;
    /**
     * @brief signal comment: Placeholder for future use, nozzle currently not present for this sensor.
     */
    int64_t setWash_Clean_CAM_M_R1(const double value) noexcept;
    /**
     * @brief signal comment: Placeholder for future use, nozzle currently not present for this sensor.
     */
    int64_t setWash_Clean_CAM_M_R0(const double value) noexcept;
    /**
     * @brief signal comment: Placeholder for future use, nozzle currently not present for this sensor.
     */
    int64_t setWash_Clean_CAM_W_R0(const double value) noexcept;
    /**
     * @brief signal comment: Placeholder for future use, nozzle currently not present for this sensor.
     */
    int64_t setWash_Clean_CAM_N_F(const double value) noexcept;
    /**
     * @brief signal comment: Placeholder for future use, nozzle currently not present for this sensor.
     */
    int64_t setWash_Clean_LIDAR_R(const double value) noexcept;
    /**
     * @brief signal comment: Placeholder for future use, nozzle currently not present for this sensor.
     */
    int64_t setWash_Clean_LIDAR_B(const double value) noexcept;
    /**
     * @brief signal comment: Placeholder for future use, nozzle currently not present for this sensor.
     */
    int64_t setWash_Clean_LIDAR_L(const double value) noexcept;
    /**
     * @brief signal comment: Placeholder for future Message Authentication Code(MAC)/Signature
     */
    int64_t setMAC_AV_Washer_Cleaning(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::tcar

#endif
