/**
 * \copyright
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Aptiv and its suppliers, if any.
 * The intellectual and technical concepts contained herein are proprietary to Aptiv and its suppliers and may be
 * covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material is strictly forbidden unless prior written
 * permission is obtained from Aptiv.
 *
 * \brief This is a brief (1-line) description of the file.
 *
 * This file is generated with dbc2cpp script version : 3.1.0
 *
 * This file was generated from the following DBC file:
 * /home/lixun/Workspace/gen2-avt-sample-a/Gen2_AVT_A_Control_CAN1.dbc
 *
 */

#ifndef AV_Waypoint_Speeds_B_1_g2h_H_
#define AV_Waypoint_Speeds_B_1_g2h_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::tcar {

namespace AV_Waypoint_Speeds_B_1_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

// This class contains members for decoding/encoding the CAN message AV_Waypoint_Speeds_B_1
// The default message identifier for AV_Waypoint_Speeds_B_1 is 0x13b (315)

// For decoding this is the required length of a decodable message. If the message
// is smaller there is data missing.
// For encoding this the length of the CAN message encoded by this class assuming all
// setters have been called. This value should be one greater than the largest index
// written to by any of the setter methods.
const uint8_t AV_WAYPOINT_SPEEDS_B_1_PACKET_LEN = UINT8_C(32);
} // namespace AV_Waypoint_Speeds_B_1_CONSTS

class AV_Waypoint_Speeds_B_1
{
public:
    AV_Waypoint_Speeds_B_1(const uint32_t id);
    AV_Waypoint_Speeds_B_1(const uint32_t id, uint8_t* const payload, const uint8_t size);

    /**
     * @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
     */
    double getCRC_AV_Waypoint_Speeds_B_1() const noexcept;
    /**
     * @brief signal comment: Alive Counter, E2E Profile 5
     */
    double getALIV_AV_Waypoint_Speeds_B_1() const noexcept;
    /**
     * @brief signal comment: Speed1 for Trajectory B, Segment 1
     * Units: m/s
     */
    double getv_WaypointSpeed_B_1() const noexcept;
    /**
     * Units: m/s
     */
    double getv_WaypointSpeed_B_2() const noexcept;
    /**
     * Units: m/s
     */
    double getv_WaypointSpeed_B_3() const noexcept;
    /**
     * Units: m/s
     */
    double getv_WaypointSpeed_B_4() const noexcept;
    /**
     * Units: m/s
     */
    double getv_WaypointSpeed_B_5() const noexcept;
    /**
     * Units: m/s
     */
    double getv_WaypointSpeed_B_6() const noexcept;
    /**
     * Units: m/s
     */
    double getv_WaypointSpeed_B_7() const noexcept;
    /**
     * Units: m/s
     */
    double getv_WaypointSpeed_B_8() const noexcept;
    /**
     * Units: m/s
     */
    double getv_WaypointSpeed_B_9() const noexcept;
    /**
     * Units: m/s
     */
    double getv_WaypointSpeed_B_10() const noexcept;
    /**
     * Units: m/s
     */
    double getv_WaypointSpeed_B_11() const noexcept;
    /**
     * Units: m/s
     */
    double getv_WaypointSpeed_B_12() const noexcept;
    /**
     * Units: m/s
     */
    double getv_WaypointSpeed_B_13() const noexcept;
    /**
     * Units: m/s
     */
    double getv_WaypointSpeed_B_14() const noexcept;
    /**
     * Units: m/s
     */
    double getv_WaypointSpeed_B_15() const noexcept;
    /**
     * Units: m/s
     */
    double getv_WaypointSpeed_B_16() const noexcept;
    /**
     * @brief signal comment: Speed17 for Trajectory B, Segment 1
     * Units: m/s
     */
    double getv_WaypointSpeed_B_17() const noexcept;

    /**
     * @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
     */
    int64_t setCRC_AV_Waypoint_Speeds_B_1(const double value) noexcept;
    /**
     * @brief signal comment: Alive Counter, E2E Profile 5
     */
    int64_t setALIV_AV_Waypoint_Speeds_B_1(const double value) noexcept;
    /**
     * @brief signal comment: Speed1 for Trajectory B, Segment 1
     * Units: m/s
     */
    int64_t setv_WaypointSpeed_B_1(const double value) noexcept;
    /**
     * Units: m/s
     */
    int64_t setv_WaypointSpeed_B_2(const double value) noexcept;
    /**
     * Units: m/s
     */
    int64_t setv_WaypointSpeed_B_3(const double value) noexcept;
    /**
     * Units: m/s
     */
    int64_t setv_WaypointSpeed_B_4(const double value) noexcept;
    /**
     * Units: m/s
     */
    int64_t setv_WaypointSpeed_B_5(const double value) noexcept;
    /**
     * Units: m/s
     */
    int64_t setv_WaypointSpeed_B_6(const double value) noexcept;
    /**
     * Units: m/s
     */
    int64_t setv_WaypointSpeed_B_7(const double value) noexcept;
    /**
     * Units: m/s
     */
    int64_t setv_WaypointSpeed_B_8(const double value) noexcept;
    /**
     * Units: m/s
     */
    int64_t setv_WaypointSpeed_B_9(const double value) noexcept;
    /**
     * Units: m/s
     */
    int64_t setv_WaypointSpeed_B_10(const double value) noexcept;
    /**
     * Units: m/s
     */
    int64_t setv_WaypointSpeed_B_11(const double value) noexcept;
    /**
     * Units: m/s
     */
    int64_t setv_WaypointSpeed_B_12(const double value) noexcept;
    /**
     * Units: m/s
     */
    int64_t setv_WaypointSpeed_B_13(const double value) noexcept;
    /**
     * Units: m/s
     */
    int64_t setv_WaypointSpeed_B_14(const double value) noexcept;
    /**
     * Units: m/s
     */
    int64_t setv_WaypointSpeed_B_15(const double value) noexcept;
    /**
     * Units: m/s
     */
    int64_t setv_WaypointSpeed_B_16(const double value) noexcept;
    /**
     * @brief signal comment: Speed17 for Trajectory B, Segment 1
     * Units: m/s
     */
    int64_t setv_WaypointSpeed_B_17(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::tcar

#endif
