/**
 * \copyright
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Aptiv and its suppliers, if any.
 * The intellectual and technical concepts contained herein are proprietary to Aptiv and its suppliers and may be
 * covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material is strictly forbidden unless prior written
 * permission is obtained from Aptiv.
 *
 * \brief This is a brief (1-line) description of the file.
 *
 * This file is generated with dbc2cpp script version : 3.1.0
 *
 * This file was generated from the following DBC file:
 * /home/lixun/Workspace/gen2-avt-sample-a/Gen2_AVT_A_Control_CAN1.dbc
 *
 */

#ifndef AV_Waypoints_A_X3_g2h_H_
#define AV_Waypoints_A_X3_g2h_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::tcar {

namespace AV_Waypoints_A_X3_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

// This class contains members for decoding/encoding the CAN message AV_Waypoints_A_X3
// The default message identifier for AV_Waypoints_A_X3 is 0x124 (292)

// For decoding this is the required length of a decodable message. If the message
// is smaller there is data missing.
// For encoding this the length of the CAN message encoded by this class assuming all
// setters have been called. This value should be one greater than the largest index
// written to by any of the setter methods.
const uint8_t AV_WAYPOINTS_A_X3_PACKET_LEN = UINT8_C(32);
} // namespace AV_Waypoints_A_X3_CONSTS

class AV_Waypoints_A_X3
{
public:
    AV_Waypoints_A_X3(const uint32_t id);
    AV_Waypoints_A_X3(const uint32_t id, uint8_t* const payload, const uint8_t size);

    double getCRC_AV_Waypoints_A_X3() const noexcept;
    double getALIV_AV_Waypoints_A_X3() const noexcept;
    /**
     * Units: m
     */
    double getL_Waypoint_A_X35() const noexcept;
    /**
     * Units: m
     */
    double getL_Waypoint_A_X36() const noexcept;
    /**
     * Units: m
     */
    double getL_Waypoint_A_X37() const noexcept;
    /**
     * Units: m
     */
    double getL_Waypoint_A_X38() const noexcept;
    /**
     * Units: m
     */
    double getL_Waypoint_A_X39() const noexcept;
    /**
     * Units: m
     */
    double getL_Waypoint_A_X40() const noexcept;
    /**
     * Units: m
     */
    double getL_Waypoint_A_X41() const noexcept;
    /**
     * Units: m
     */
    double getL_Waypoint_A_X42() const noexcept;
    /**
     * Units: m
     */
    double getL_Waypoint_A_X43() const noexcept;
    /**
     * Units: m
     */
    double getL_Waypoint_A_X44() const noexcept;
    /**
     * Units: m
     */
    double getL_Waypoint_A_X45() const noexcept;
    /**
     * Units: m
     */
    double getL_Waypoint_A_X46() const noexcept;
    /**
     * Units: m
     */
    double getL_Waypoint_A_X47() const noexcept;
    /**
     * Units: m
     */
    double getL_Waypoint_A_X48() const noexcept;
    /**
     * Units: m
     */
    double getL_Waypoint_A_X49() const noexcept;
    /**
     * Units: m
     */
    double getL_Waypoint_A_X50() const noexcept;
    /**
     * @brief signal comment: Xcoordinate51 for Trajectory A, Segment 3
     * Units: m
     */
    double getL_Waypoint_A_X51() const noexcept;

    int64_t setCRC_AV_Waypoints_A_X3(const double value) noexcept;
    int64_t setALIV_AV_Waypoints_A_X3(const double value) noexcept;
    /**
     * Units: m
     */
    int64_t setL_Waypoint_A_X35(const double value) noexcept;
    /**
     * Units: m
     */
    int64_t setL_Waypoint_A_X36(const double value) noexcept;
    /**
     * Units: m
     */
    int64_t setL_Waypoint_A_X37(const double value) noexcept;
    /**
     * Units: m
     */
    int64_t setL_Waypoint_A_X38(const double value) noexcept;
    /**
     * Units: m
     */
    int64_t setL_Waypoint_A_X39(const double value) noexcept;
    /**
     * Units: m
     */
    int64_t setL_Waypoint_A_X40(const double value) noexcept;
    /**
     * Units: m
     */
    int64_t setL_Waypoint_A_X41(const double value) noexcept;
    /**
     * Units: m
     */
    int64_t setL_Waypoint_A_X42(const double value) noexcept;
    /**
     * Units: m
     */
    int64_t setL_Waypoint_A_X43(const double value) noexcept;
    /**
     * Units: m
     */
    int64_t setL_Waypoint_A_X44(const double value) noexcept;
    /**
     * Units: m
     */
    int64_t setL_Waypoint_A_X45(const double value) noexcept;
    /**
     * Units: m
     */
    int64_t setL_Waypoint_A_X46(const double value) noexcept;
    /**
     * Units: m
     */
    int64_t setL_Waypoint_A_X47(const double value) noexcept;
    /**
     * Units: m
     */
    int64_t setL_Waypoint_A_X48(const double value) noexcept;
    /**
     * Units: m
     */
    int64_t setL_Waypoint_A_X49(const double value) noexcept;
    /**
     * Units: m
     */
    int64_t setL_Waypoint_A_X50(const double value) noexcept;
    /**
     * @brief signal comment: Xcoordinate51 for Trajectory A, Segment 3
     * Units: m
     */
    int64_t setL_Waypoint_A_X51(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::tcar

#endif
