/**
 * \copyright
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Aptiv and its suppliers, if any.
 * The intellectual and technical concepts contained herein are proprietary to Aptiv and its suppliers and may be
 * covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material is strictly forbidden unless prior written
 * permission is obtained from Aptiv.
 *
 * \brief This is a brief (1-line) description of the file.
 *
 * This file is generated with dbc2cpp script version : 3.1.0
 *
 * This file was generated from the following DBC file:
 * /home/lixun/Workspace/gen2-avt-sample-a/Gen2_AVT_A_Control_CAN1.dbc
 *
 */

#ifndef AV_Waypoints_B_Y2_g2h_H_
#define AV_Waypoints_B_Y2_g2h_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::tcar {

namespace AV_Waypoints_B_Y2_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

// This class contains members for decoding/encoding the CAN message AV_Waypoints_B_Y2
// The default message identifier for AV_Waypoints_B_Y2 is 0x12f (303)

// For decoding this is the required length of a decodable message. If the message
// is smaller there is data missing.
// For encoding this the length of the CAN message encoded by this class assuming all
// setters have been called. This value should be one greater than the largest index
// written to by any of the setter methods.
const uint8_t AV_WAYPOINTS_B_Y2_PACKET_LEN = UINT8_C(32);
} // namespace AV_Waypoints_B_Y2_CONSTS

class AV_Waypoints_B_Y2
{
public:
    AV_Waypoints_B_Y2(const uint32_t id);
    AV_Waypoints_B_Y2(const uint32_t id, uint8_t* const payload, const uint8_t size);

    double getCRC_AV_Waypoints_B_Y2() const noexcept;
    double getALIV_AV_Waypoints_B_Y2() const noexcept;
    /**
     * Units: m
     */
    double getL_Waypoint_B_Y18() const noexcept;
    /**
     * Units: m
     */
    double getL_Waypoint_B_Y19() const noexcept;
    /**
     * Units: m
     */
    double getL_Waypoint_B_Y20() const noexcept;
    /**
     * Units: m
     */
    double getL_Waypoint_B_Y21() const noexcept;
    /**
     * Units: m
     */
    double getL_Waypoint_B_Y22() const noexcept;
    /**
     * Units: m
     */
    double getL_Waypoint_B_Y23() const noexcept;
    /**
     * Units: m
     */
    double getL_Waypoint_B_Y24() const noexcept;
    /**
     * Units: m
     */
    double getL_Waypoint_B_Y25() const noexcept;
    /**
     * Units: m
     */
    double getL_Waypoint_B_Y26() const noexcept;
    /**
     * Units: m
     */
    double getL_Waypoint_B_Y27() const noexcept;
    /**
     * Units: m
     */
    double getL_Waypoint_B_Y28() const noexcept;
    /**
     * Units: m
     */
    double getL_Waypoint_B_Y29() const noexcept;
    /**
     * Units: m
     */
    double getL_Waypoint_B_Y30() const noexcept;
    /**
     * Units: m
     */
    double getL_Waypoint_B_Y31() const noexcept;
    /**
     * Units: m
     */
    double getL_Waypoint_B_Y32() const noexcept;
    /**
     * Units: m
     */
    double getL_Waypoint_B_Y33() const noexcept;
    /**
     * @brief signal comment: Ycoordinate34 for Trajectory B, Segment 2
     * Units: m
     */
    double getL_Waypoint_B_Y34() const noexcept;

    int64_t setCRC_AV_Waypoints_B_Y2(const double value) noexcept;
    int64_t setALIV_AV_Waypoints_B_Y2(const double value) noexcept;
    /**
     * Units: m
     */
    int64_t setL_Waypoint_B_Y18(const double value) noexcept;
    /**
     * Units: m
     */
    int64_t setL_Waypoint_B_Y19(const double value) noexcept;
    /**
     * Units: m
     */
    int64_t setL_Waypoint_B_Y20(const double value) noexcept;
    /**
     * Units: m
     */
    int64_t setL_Waypoint_B_Y21(const double value) noexcept;
    /**
     * Units: m
     */
    int64_t setL_Waypoint_B_Y22(const double value) noexcept;
    /**
     * Units: m
     */
    int64_t setL_Waypoint_B_Y23(const double value) noexcept;
    /**
     * Units: m
     */
    int64_t setL_Waypoint_B_Y24(const double value) noexcept;
    /**
     * Units: m
     */
    int64_t setL_Waypoint_B_Y25(const double value) noexcept;
    /**
     * Units: m
     */
    int64_t setL_Waypoint_B_Y26(const double value) noexcept;
    /**
     * Units: m
     */
    int64_t setL_Waypoint_B_Y27(const double value) noexcept;
    /**
     * Units: m
     */
    int64_t setL_Waypoint_B_Y28(const double value) noexcept;
    /**
     * Units: m
     */
    int64_t setL_Waypoint_B_Y29(const double value) noexcept;
    /**
     * Units: m
     */
    int64_t setL_Waypoint_B_Y30(const double value) noexcept;
    /**
     * Units: m
     */
    int64_t setL_Waypoint_B_Y31(const double value) noexcept;
    /**
     * Units: m
     */
    int64_t setL_Waypoint_B_Y32(const double value) noexcept;
    /**
     * Units: m
     */
    int64_t setL_Waypoint_B_Y33(const double value) noexcept;
    /**
     * @brief signal comment: Ycoordinate34 for Trajectory B, Segment 2
     * Units: m
     */
    int64_t setL_Waypoint_B_Y34(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::tcar

#endif
