/**
 * \copyright
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Aptiv and its suppliers, if any.
 * The intellectual and technical concepts contained herein are proprietary to Aptiv and its suppliers and may be
 * covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material is strictly forbidden unless prior written
 * permission is obtained from Aptiv.
 *
 * \brief This is a brief (1-line) description of the file.
 *
 * This file is generated with dbc2cpp script version : 3.1.0
 *
 * This file was generated from the following DBC file:
 * /home/lixun/Workspace/Gen2-AVT-Sample-A/Gen2_AVT_A_Control_CAN1.dbc
 *
 */

#ifndef VIC_Acceleration_g2h_H_
#define VIC_Acceleration_g2h_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::tcar {

namespace VIC_Acceleration_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

// This class contains members for decoding/encoding the CAN message VIC_Acceleration
// The default message identifier for VIC_Acceleration is 0x60 (96)

// For decoding this is the required length of a decodable message. If the message
// is smaller there is data missing.
// For encoding this the length of the CAN message encoded by this class assuming all
// setters have been called. This value should be one greater than the largest index
// written to by any of the setter methods.
const uint8_t VIC_ACCELERATION_PACKET_LEN = UINT8_C(32);
} // namespace VIC_Acceleration_CONSTS

class VIC_Acceleration
{
public:
    VIC_Acceleration(const uint32_t id);
    VIC_Acceleration(const uint32_t id, uint8_t* const payload, const uint8_t size);

    /**
     * @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
     */
    double getCRC_Acceleration() const noexcept;
    /**
     * @brief signal comment: Alive Counter, E2E Profile 5
     */
    double getALIV_Acceleration() const noexcept;
    /**
     * @brief signal comment: Feedback for acc to AV, based on speed selected by AV
     * Units: m/s^2
     */
    double geta_AccelerationDesired() const noexcept;
    /**
     * @brief signal comment: Current lateral acceleration of AV
     * Units: m/s^2
     */
    double geta_AccelLateralCurrent() const noexcept;
    /**
     * @brief signal comment: Current longitudnal acceleration of AV
     * Units: m/s^2
     */
    double geta_AccelLongitudinalCurrent() const noexcept;
    /**
     * @brief signal comment: VIC Feedback for de-acceleraton arbitration selected
     * Units: m/s^2
     */
    double geta_DecelArbitrated() const noexcept;
    /**
     * @brief signal comment: Acceleration pedal percentage command by controller
     * Units: %
     */
    double geta_AccelPedalPosition() const noexcept;
    /**
     * @brief signal comment: Brake pedal percentage command by controller
     * Units: %
     */
    double geta_BrakePedalPosition() const noexcept;
    /**
     * @brief signal comment: Placeholder for future Message Authentication Code(MAC)/Signature
     */
    double getMAC_Acceleration() const noexcept;

    /**
     * @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
     */
    int64_t setCRC_Acceleration(const double value) noexcept;
    /**
     * @brief signal comment: Alive Counter, E2E Profile 5
     */
    int64_t setALIV_Acceleration(const double value) noexcept;
    /**
     * @brief signal comment: Feedback for acc to AV, based on speed selected by AV
     * Units: m/s^2
     */
    int64_t seta_AccelerationDesired(const double value) noexcept;
    /**
     * @brief signal comment: Current lateral acceleration of AV
     * Units: m/s^2
     */
    int64_t seta_AccelLateralCurrent(const double value) noexcept;
    /**
     * @brief signal comment: Current longitudnal acceleration of AV
     * Units: m/s^2
     */
    int64_t seta_AccelLongitudinalCurrent(const double value) noexcept;
    /**
     * @brief signal comment: VIC Feedback for de-acceleraton arbitration selected
     * Units: m/s^2
     */
    int64_t seta_DecelArbitrated(const double value) noexcept;
    /**
     * @brief signal comment: Acceleration pedal percentage command by controller
     * Units: %
     */
    int64_t seta_AccelPedalPosition(const double value) noexcept;
    /**
     * @brief signal comment: Brake pedal percentage command by controller
     * Units: %
     */
    int64_t seta_BrakePedalPosition(const double value) noexcept;
    /**
     * @brief signal comment: Placeholder for future Message Authentication Code(MAC)/Signature
     */
    int64_t setMAC_Acceleration(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::tcar

#endif
