/**
 * \copyright
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Aptiv and its suppliers, if any.
 * The intellectual and technical concepts contained herein are proprietary to Aptiv and its suppliers and may be
 * covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material is strictly forbidden unless prior written
 * permission is obtained from Aptiv.
 *
 * \brief This is a brief (1-line) description of the file.
 *
 * This file is generated with dbc2cpp script version : 3.1.0
 *
 * This file was generated from the following DBC file:
 * /home/lixun/Workspace/gen2-avt-sample-a/Gen2_AVT_A_Control_CAN1.dbc
 *
 */

#ifndef VIC_Body_Axes_g2h_H_
#define VIC_Body_Axes_g2h_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::tcar {

namespace VIC_Body_Axes_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

// This class contains members for decoding/encoding the CAN message VIC_Body_Axes
// The default message identifier for VIC_Body_Axes is 0x320 (800)

// For decoding this is the required length of a decodable message. If the message
// is smaller there is data missing.
// For encoding this the length of the CAN message encoded by this class assuming all
// setters have been called. This value should be one greater than the largest index
// written to by any of the setter methods.
const uint8_t VIC_BODY_AXES_PACKET_LEN = UINT8_C(32);
} // namespace VIC_Body_Axes_CONSTS

class VIC_Body_Axes
{
public:
    VIC_Body_Axes(const uint32_t id);
    VIC_Body_Axes(const uint32_t id, uint8_t* const payload, const uint8_t size);

    /**
     * @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
     */
    double getCRC_Body_Axes() const noexcept;
    /**
     * @brief signal comment: Alive Counter, E2E Profile 5
     */
    double getALIV_Body_Axes() const noexcept;
    /**
     * @brief signal comment: Roll based of Odometery IMU fusion
     * Units: rad
     */
    double getu_Roll() const noexcept;
    /**
     * @brief signal comment: Pitch based of Odometery IMU fusion
     * Units: rad
     */
    double getu_Pitch() const noexcept;
    /**
     * @brief signal comment: Yaw based of Odometery IMU fusion
     * Units: rad
     */
    double getu_Yaw() const noexcept;
    /**
     * @brief signal comment: Placeholder for future Message Authentication Code(MAC)/Signature
     */
    double getMAC_Body_Axes() const noexcept;

    /**
     * @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
     */
    int64_t setCRC_Body_Axes(const double value) noexcept;
    /**
     * @brief signal comment: Alive Counter, E2E Profile 5
     */
    int64_t setALIV_Body_Axes(const double value) noexcept;
    /**
     * @brief signal comment: Roll based of Odometery IMU fusion
     * Units: rad
     */
    int64_t setu_Roll(const double value) noexcept;
    /**
     * @brief signal comment: Pitch based of Odometery IMU fusion
     * Units: rad
     */
    int64_t setu_Pitch(const double value) noexcept;
    /**
     * @brief signal comment: Yaw based of Odometery IMU fusion
     * Units: rad
     */
    int64_t setu_Yaw(const double value) noexcept;
    /**
     * @brief signal comment: Placeholder for future Message Authentication Code(MAC)/Signature
     */
    int64_t setMAC_Body_Axes(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::tcar

#endif
