/**
 * \copyright
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Aptiv and its suppliers, if any.
 * The intellectual and technical concepts contained herein are proprietary to Aptiv and its suppliers and may be
 * covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material is strictly forbidden unless prior written
 * permission is obtained from Aptiv.
 *
 * \brief This is a brief (1-line) description of the file.
 *
 * This file is generated with dbc2cpp script version : 3.1.0
 *
 * This file was generated from the following DBC file: /home/scotty/Downloads/Gen2_AVT_A_Control_CAN1.dbc
 *
 */

#ifndef VIC_Dynamic_Error_g2h_H_
#define VIC_Dynamic_Error_g2h_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::tcar {

namespace VIC_Dynamic_Error_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

// This class contains members for decoding/encoding the CAN message VIC_Dynamic_Error
// The default message identifier for VIC_Dynamic_Error is 0x392 (914)

// For decoding this is the required length of a decodable message. If the message
// is smaller there is data missing.
// For encoding this the length of the CAN message encoded by this class assuming all
// setters have been called. This value should be one greater than the largest index
// written to by any of the setter methods.
const uint8_t VIC_DYNAMIC_ERROR_PACKET_LEN = UINT8_C(32);
} // namespace VIC_Dynamic_Error_CONSTS

class VIC_Dynamic_Error
{
public:
    VIC_Dynamic_Error(const uint32_t id);
    VIC_Dynamic_Error(const uint32_t id, uint8_t* const payload, const uint8_t size);

    /**
     * @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
     */
    double getCRC_Dynamic_Error() const noexcept;
    /**
     * @brief signal comment: Alive Counter, E2E Profile 5
     */
    double getALIV_Dynamic_Error() const noexcept;
    /**
     * @brief signal comment: Cross Track Distance predicted by VIC
     * Units: m
     */
    double getL_CrossTrackError_10ms() const noexcept;
    /**
     * @brief signal comment: Heading Angle Error predicted by VIC
     * Units: rad
     */
    double getu_HeadingError_10ms() const noexcept;
    /**
     * @brief signal comment: Error between Target Speed and Actual Speed (Longitudinal)
     * Units: m/s
     */
    double getv_SpeedTrackingError() const noexcept;
    /**
     * @brief signal comment: Error between Target Acceleration and Actual Acceleration (Longitudinal)
     * Units: m/s^2
     */
    double geta_AccelTrackingError() const noexcept;
    /**
     * @brief signal comment: Error between Target Wheel Torque and Actual Wheel Torque
     * Units: Nm
     */
    double getTq_WheelTorqueTrackingError() const noexcept;
    /**
     * @brief signal comment: Error between Target Accel Pedal Position and Actual Accel Pedal Position
     * Units: %
     */
    double getper_AccelPedalTrackingError() const noexcept;
    /**
     * @brief signal comment: Error between Target Brake Pressure and Actual Brake Pressure
     * Units: bar
     */
    double getP_BrakePressureTrackingError() const noexcept;
    /**
     * @brief signal comment: Error between Target Brake Pedal Position and Actual Brake Pedal Position
     * Units: %
     */
    double getper_BrakePedalTrackingError() const noexcept;
    /**
     * @brief signal comment: Error between Target Steering Angle and Actual Steering Angle
     * Units: deg
     */
    double getu_SteeringWheelTrackingError() const noexcept;
    /**
     * @brief signal comment: DBW calculated error in the longitudinal direction while nominal trajectory
     * Units: m
     */
    double getL_VIC_station_error_m_A() const noexcept;
    /**
     * @brief signal comment: DBW calculated error in the longitudinal direction while safestop trajectory
     * Units: m
     */
    double getL_VIC_station_error_m_B() const noexcept;
    /**
     * @brief signal comment: Placeholder for future Message Authentication Code(MAC)/Signature
     */
    double getMAC_Dynamic_Error() const noexcept;

    /**
     * @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
     */
    int64_t setCRC_Dynamic_Error(const double value) noexcept;
    /**
     * @brief signal comment: Alive Counter, E2E Profile 5
     */
    int64_t setALIV_Dynamic_Error(const double value) noexcept;
    /**
     * @brief signal comment: Cross Track Distance predicted by VIC
     * Units: m
     */
    int64_t setL_CrossTrackError_10ms(const double value) noexcept;
    /**
     * @brief signal comment: Heading Angle Error predicted by VIC
     * Units: rad
     */
    int64_t setu_HeadingError_10ms(const double value) noexcept;
    /**
     * @brief signal comment: Error between Target Speed and Actual Speed (Longitudinal)
     * Units: m/s
     */
    int64_t setv_SpeedTrackingError(const double value) noexcept;
    /**
     * @brief signal comment: Error between Target Acceleration and Actual Acceleration (Longitudinal)
     * Units: m/s^2
     */
    int64_t seta_AccelTrackingError(const double value) noexcept;
    /**
     * @brief signal comment: Error between Target Wheel Torque and Actual Wheel Torque
     * Units: Nm
     */
    int64_t setTq_WheelTorqueTrackingError(const double value) noexcept;
    /**
     * @brief signal comment: Error between Target Accel Pedal Position and Actual Accel Pedal Position
     * Units: %
     */
    int64_t setper_AccelPedalTrackingError(const double value) noexcept;
    /**
     * @brief signal comment: Error between Target Brake Pressure and Actual Brake Pressure
     * Units: bar
     */
    int64_t setP_BrakePressureTrackingError(const double value) noexcept;
    /**
     * @brief signal comment: Error between Target Brake Pedal Position and Actual Brake Pedal Position
     * Units: %
     */
    int64_t setper_BrakePedalTrackingError(const double value) noexcept;
    /**
     * @brief signal comment: Error between Target Steering Angle and Actual Steering Angle
     * Units: deg
     */
    int64_t setu_SteeringWheelTrackingError(const double value) noexcept;
    /**
     * @brief signal comment: DBW calculated error in the longitudinal direction while nominal trajectory
     * Units: m
     */
    int64_t setL_VIC_station_error_m_A(const double value) noexcept;
    /**
     * @brief signal comment: DBW calculated error in the longitudinal direction while safestop trajectory
     * Units: m
     */
    int64_t setL_VIC_station_error_m_B(const double value) noexcept;
    /**
     * @brief signal comment: Placeholder for future Message Authentication Code(MAC)/Signature
     */
    int64_t setMAC_Dynamic_Error(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::tcar

#endif
