/**
 * \copyright
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Aptiv and its suppliers, if any.
 * The intellectual and technical concepts contained herein are proprietary to Aptiv and its suppliers and may be
 * covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material is strictly forbidden unless prior written
 * permission is obtained from Aptiv.
 *
 * \brief This is a brief (1-line) description of the file.
 *
 * This file is generated with dbc2cpp script version : 3.1.0
 *
 * This file was generated from the following DBC file: /home/scotty/Downloads/Gen2_AVT_A_Control_CAN1.dbc
 *
 */

#ifndef VIC_Dynamic_Request_g2h_H_
#define VIC_Dynamic_Request_g2h_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::tcar {

namespace VIC_Dynamic_Request_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

// This class contains members for decoding/encoding the CAN message VIC_Dynamic_Request
// The default message identifier for VIC_Dynamic_Request is 0x391 (913)

// For decoding this is the required length of a decodable message. If the message
// is smaller there is data missing.
// For encoding this the length of the CAN message encoded by this class assuming all
// setters have been called. This value should be one greater than the largest index
// written to by any of the setter methods.
const uint8_t VIC_DYNAMIC_REQUEST_PACKET_LEN = UINT8_C(32);
} // namespace VIC_Dynamic_Request_CONSTS

class VIC_Dynamic_Request
{
public:
    VIC_Dynamic_Request(const uint32_t id);
    VIC_Dynamic_Request(const uint32_t id, uint8_t* const payload, const uint8_t size);

    /**
     * @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
     */
    double getCRC_Dynamic_Request() const noexcept;
    /**
     * @brief signal comment: Alive Counter, E2E Profile 5
     */
    double getALIV_Dynamic_Request() const noexcept;
    /**
     * @brief signal comment: Target Curvature estimation by VIC
     */
    double getc_Curvature_Rq() const noexcept;
    /**
     * @brief signal comment: Target longitudinal speed predicted by VIC
     * Units: m/s
     */
    double getv_TargetSpeed_Rq_10ms() const noexcept;
    /**
     * @brief signal comment: Feedforward term for vehicle longitudinal acceleration predicted by VIC
     * Units: m/s^2
     */
    double geta_FeedForwardAccel_Rq_10ms() const noexcept;
    /**
     * @brief signal comment: Changing rate of longitudinal acceleration request
     * Units: m/s^3
     */
    double getj_TargetJerk_Rq() const noexcept;
    /**
     * @brief signal comment: Changing rate of road wheel angle request predicted by VIC
     * Units: rad/s
     */
    double getw_RoadWheelAngleRate_Rq_10ms() const noexcept;
    /**
     * @brief signal comment: Changing rate of hand wheel angle request
     * Units: deg/s
     */
    double getw_HandWheelAngleRate_Rq() const noexcept;
    /**
     * @brief signal comment: Changing rate of hand wheel angle velocity request
     * Units: deg/s^2
     */
    double geta_HandWheelAngleAccel_Rq() const noexcept;
    /**
     * @brief signal comment: Requested Wheel Torque
     * Units: Nm
     */
    double getTq_WheelTorque_Rq() const noexcept;
    /**
     * @brief signal comment: Disturbance on Longitudinal Force
     * Units: N
     */
    double getF_LongitudinalForceDisturb() const noexcept;
    /**
     * @brief signal comment: Disturbance on Lateral Force
     * Units: N
     */
    double getF_LateralForceDisturb() const noexcept;
    /**
     * @brief signal comment: Placeholder for future Message Authentication Code(MAC)/Signature
     */
    double getMAC_Dynamic_Request() const noexcept;

    /**
     * @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
     */
    int64_t setCRC_Dynamic_Request(const double value) noexcept;
    /**
     * @brief signal comment: Alive Counter, E2E Profile 5
     */
    int64_t setALIV_Dynamic_Request(const double value) noexcept;
    /**
     * @brief signal comment: Target Curvature estimation by VIC
     */
    int64_t setc_Curvature_Rq(const double value) noexcept;
    /**
     * @brief signal comment: Target longitudinal speed predicted by VIC
     * Units: m/s
     */
    int64_t setv_TargetSpeed_Rq_10ms(const double value) noexcept;
    /**
     * @brief signal comment: Feedforward term for vehicle longitudinal acceleration predicted by VIC
     * Units: m/s^2
     */
    int64_t seta_FeedForwardAccel_Rq_10ms(const double value) noexcept;
    /**
     * @brief signal comment: Changing rate of longitudinal acceleration request
     * Units: m/s^3
     */
    int64_t setj_TargetJerk_Rq(const double value) noexcept;
    /**
     * @brief signal comment: Changing rate of road wheel angle request predicted by VIC
     * Units: rad/s
     */
    int64_t setw_RoadWheelAngleRate_Rq_10ms(const double value) noexcept;
    /**
     * @brief signal comment: Changing rate of hand wheel angle request
     * Units: deg/s
     */
    int64_t setw_HandWheelAngleRate_Rq(const double value) noexcept;
    /**
     * @brief signal comment: Changing rate of hand wheel angle velocity request
     * Units: deg/s^2
     */
    int64_t seta_HandWheelAngleAccel_Rq(const double value) noexcept;
    /**
     * @brief signal comment: Requested Wheel Torque
     * Units: Nm
     */
    int64_t setTq_WheelTorque_Rq(const double value) noexcept;
    /**
     * @brief signal comment: Disturbance on Longitudinal Force
     * Units: N
     */
    int64_t setF_LongitudinalForceDisturb(const double value) noexcept;
    /**
     * @brief signal comment: Disturbance on Lateral Force
     * Units: N
     */
    int64_t setF_LateralForceDisturb(const double value) noexcept;
    /**
     * @brief signal comment: Placeholder for future Message Authentication Code(MAC)/Signature
     */
    int64_t setMAC_Dynamic_Request(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::tcar

#endif
