/**
 * \copyright
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Aptiv and its suppliers, if any.
 * The intellectual and technical concepts contained herein are proprietary to Aptiv and its suppliers and may be
 * covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material is strictly forbidden unless prior written
 * permission is obtained from Aptiv.
 *
 * \brief This is a brief (1-line) description of the file.
 *
 * This file is generated with dbc2cpp script version : 3.1.0
 *
 * This file was generated from the following DBC file:
 * /home/lixun/Workspace/gen2-avt-sample-a/Gen2_AVT_A_Control_CAN1.dbc
 *
 */

#ifndef VIC_Error_State_g2h_H_
#define VIC_Error_State_g2h_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::tcar {

namespace VIC_Error_State_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

// This class contains members for decoding/encoding the CAN message VIC_Error_State
// The default message identifier for VIC_Error_State is 0x168 (360)

// For decoding this is the required length of a decodable message. If the message
// is smaller there is data missing.
// For encoding this the length of the CAN message encoded by this class assuming all
// setters have been called. This value should be one greater than the largest index
// written to by any of the setter methods.
const uint8_t VIC_ERROR_STATE_PACKET_LEN = UINT8_C(32);
} // namespace VIC_Error_State_CONSTS

class VIC_Error_State
{
public:
    VIC_Error_State(const uint32_t id);
    VIC_Error_State(const uint32_t id, uint8_t* const payload, const uint8_t size);

    /**
     * @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
     */
    double getCRC_Error_State() const noexcept;
    /**
     * @brief signal comment: Alive Counter, E2E Profile 5
     */
    double getALIV_Error_State() const noexcept;
    /**
     * @brief signal comment: VIC state machine updates all Error states
     */
    double getB_AVStackDegraded() const noexcept;
    double getB_AVStackFailed() const noexcept;
    double getB_DoorOpened() const noexcept;
    double getB_EBCMDegraded() const noexcept;
    double getB_EBCMFailed() const noexcept;
    double getB_EPBFailed() const noexcept;
    double getB_EPSDegraded() const noexcept;
    double getB_EPSFailed() const noexcept;
    double getB_ESCDegraded() const noexcept;
    double getB_ESCFailed() const noexcept;
    double getB_SafetyDriverNotDetected() const noexcept;
    double getB_SafetyStewardNotDetected() const noexcept;
    double getB_TCGWFault() const noexcept;
    double getB_TIBFault() const noexcept;
    double getB_TurnSignalMismatch() const noexcept;
    double getB_ComfortStopBTNPressed() const noexcept;
    double getB_EStopBTNPressed() const noexcept;
    double getB_SCIBFault() const noexcept;
    double getB_AuthSWTHFault() const noexcept;
    double getB_ComfortStopBTNFault() const noexcept;
    double getB_EnableBTNFault() const noexcept;
    double getB_EStopBTNFault() const noexcept;
    /**
     * @brief signal comment: Placeholder for future Message Authentication Code(MAC)/Signature
     */
    double getMAC_Error_State() const noexcept;

    /**
     * @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
     */
    int64_t setCRC_Error_State(const double value) noexcept;
    /**
     * @brief signal comment: Alive Counter, E2E Profile 5
     */
    int64_t setALIV_Error_State(const double value) noexcept;
    /**
     * @brief signal comment: VIC state machine updates all Error states
     */
    int64_t setB_AVStackDegraded(const double value) noexcept;
    int64_t setB_AVStackFailed(const double value) noexcept;
    int64_t setB_DoorOpened(const double value) noexcept;
    int64_t setB_EBCMDegraded(const double value) noexcept;
    int64_t setB_EBCMFailed(const double value) noexcept;
    int64_t setB_EPBFailed(const double value) noexcept;
    int64_t setB_EPSDegraded(const double value) noexcept;
    int64_t setB_EPSFailed(const double value) noexcept;
    int64_t setB_ESCDegraded(const double value) noexcept;
    int64_t setB_ESCFailed(const double value) noexcept;
    int64_t setB_SafetyDriverNotDetected(const double value) noexcept;
    int64_t setB_SafetyStewardNotDetected(const double value) noexcept;
    int64_t setB_TCGWFault(const double value) noexcept;
    int64_t setB_TIBFault(const double value) noexcept;
    int64_t setB_TurnSignalMismatch(const double value) noexcept;
    int64_t setB_ComfortStopBTNPressed(const double value) noexcept;
    int64_t setB_EStopBTNPressed(const double value) noexcept;
    int64_t setB_SCIBFault(const double value) noexcept;
    int64_t setB_AuthSWTHFault(const double value) noexcept;
    int64_t setB_ComfortStopBTNFault(const double value) noexcept;
    int64_t setB_EnableBTNFault(const double value) noexcept;
    int64_t setB_EStopBTNFault(const double value) noexcept;
    /**
     * @brief signal comment: Placeholder for future Message Authentication Code(MAC)/Signature
     */
    int64_t setMAC_Error_State(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::tcar

#endif
