/**
 * \copyright
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Aptiv and its suppliers, if any.
 * The intellectual and technical concepts contained herein are proprietary to Aptiv and its suppliers and may be
 * covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material is strictly forbidden unless prior written
 * permission is obtained from Aptiv.
 *
 * \brief This is a brief (1-line) description of the file.
 *
 * This file is generated with dbc2cpp script version : 3.1.0
 *
 * This file was generated from the following DBC file:
 * /home/lixun/Workspace/gen2-avt-sample-a/Gen2_AVT_A_Control_CAN1.dbc
 *
 */

#ifndef VIC_Lateral_Control_g2h_H_
#define VIC_Lateral_Control_g2h_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::tcar {

namespace VIC_Lateral_Control_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

// This class contains members for decoding/encoding the CAN message VIC_Lateral_Control
// The default message identifier for VIC_Lateral_Control is 0xc0 (192)

// For decoding this is the required length of a decodable message. If the message
// is smaller there is data missing.
// For encoding this the length of the CAN message encoded by this class assuming all
// setters have been called. This value should be one greater than the largest index
// written to by any of the setter methods.
const uint8_t VIC_LATERAL_CONTROL_PACKET_LEN = UINT8_C(32);
} // namespace VIC_Lateral_Control_CONSTS

class VIC_Lateral_Control
{
public:
    VIC_Lateral_Control(const uint32_t id);
    VIC_Lateral_Control(const uint32_t id, uint8_t* const payload, const uint8_t size);

    /**
     * @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
     */
    double getCRC_Lateral_Control() const noexcept;
    /**
     * @brief signal comment: Alive Counter, E2E Profile 5
     */
    double getALIV_Lateral_Control() const noexcept;
    /**
     * @brief signal comment: Vehicle yaw rate shared/forwarded via VIC
     * Units: rad/s
     */
    double getw_YawRate() const noexcept;
    /**
     * @brief signal comment: TBD
     */
    double getB_YawRate_Valid() const noexcept;
    /**
     * @brief signal comment: Wheel angle requested by AV
     * Units: rad
     */
    double getu_RoadWheelAngleDesired() const noexcept;
    /**
     * @brief signal comment: Actual current wheel angle
     * Units: rad
     */
    double getu_RoadWheelAngleCurrent() const noexcept;
    /**
     * @brief signal comment: TBD
     */
    double getsts_LatControlMode() const noexcept;
    /**
     * @brief signal comment: Placeholder for future Message Authentication Code(MAC)/Signature
     */
    double getMAC_Lateral_Control() const noexcept;

    /**
     * @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
     */
    int64_t setCRC_Lateral_Control(const double value) noexcept;
    /**
     * @brief signal comment: Alive Counter, E2E Profile 5
     */
    int64_t setALIV_Lateral_Control(const double value) noexcept;
    /**
     * @brief signal comment: Vehicle yaw rate shared/forwarded via VIC
     * Units: rad/s
     */
    int64_t setw_YawRate(const double value) noexcept;
    /**
     * @brief signal comment: TBD
     */
    int64_t setB_YawRate_Valid(const double value) noexcept;
    /**
     * @brief signal comment: Wheel angle requested by AV
     * Units: rad
     */
    int64_t setu_RoadWheelAngleDesired(const double value) noexcept;
    /**
     * @brief signal comment: Actual current wheel angle
     * Units: rad
     */
    int64_t setu_RoadWheelAngleCurrent(const double value) noexcept;
    /**
     * @brief signal comment: TBD
     */
    int64_t setsts_LatControlMode(const double value) noexcept;
    /**
     * @brief signal comment: Placeholder for future Message Authentication Code(MAC)/Signature
     */
    int64_t setMAC_Lateral_Control(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::tcar

#endif
