/**
 * \copyright
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Aptiv and its suppliers, if any.
 * The intellectual and technical concepts contained herein are proprietary to Aptiv and its suppliers and may be
 * covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material is strictly forbidden unless prior written
 * permission is obtained from Aptiv.
 *
 * \brief This is a brief (1-line) description of the file.
 *
 * This file is generated with dbc2cpp script version : 3.1.0
 *
 * This file was generated from the following DBC file:
 * /home/lixun/Workspace/gen2-avt-sample-a/Gen2_AVT_A_Control_CAN1.dbc
 *
 */

#ifndef VIC_VEH_DRV_Interface_g2h_H_
#define VIC_VEH_DRV_Interface_g2h_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::tcar {

namespace VIC_VEH_DRV_Interface_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

// This class contains members for decoding/encoding the CAN message VIC_VEH_DRV_Interface
// The default message identifier for VIC_VEH_DRV_Interface is 0x1e0 (480)

// For decoding this is the required length of a decodable message. If the message
// is smaller there is data missing.
// For encoding this the length of the CAN message encoded by this class assuming all
// setters have been called. This value should be one greater than the largest index
// written to by any of the setter methods.
const uint8_t VIC_VEH_DRV_INTERFACE_PACKET_LEN = UINT8_C(32);
} // namespace VIC_VEH_DRV_Interface_CONSTS

class VIC_VEH_DRV_Interface
{
public:
    VIC_VEH_DRV_Interface(const uint32_t id);
    VIC_VEH_DRV_Interface(const uint32_t id, uint8_t* const payload, const uint8_t size);

    /**
     * @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
     */
    double getCRC_VEH_DRV_Interface() const noexcept;
    /**
     * @brief signal comment: Alive Counter, E2E Profile 5
     */
    double getALIV_VEH_DRV_Interface() const noexcept;
    double getB_AutoButton() const noexcept;
    double getB_BrakeOverride() const noexcept;
    double getB_LoggingButton() const noexcept;
    double getB_ParkingBrake() const noexcept;
    double getB_SteerOverride() const noexcept;
    double getB_ThrottleOverride() const noexcept;
    double getsts_IgnitionPosition() const noexcept;
    /**
     * @brief signal comment: Accelelerator pedal percentage depression
     * Units: percent
     */
    double getper_AccelPedalPostion() const noexcept;
    double getB_EngageButton() const noexcept;
    /**
     * @brief signal comment: Brake pedal percentage depression
     * Units: percent
     */
    double getper_BrakePedalPosition() const noexcept;
    double getB_Seatbelt() const noexcept;
    double getsts_AuthSwitch() const noexcept;
    double getB_EnableButton() const noexcept;
    double getsts_SWRC_CrsSw() const noexcept;
    double getB_ManualTakeover() const noexcept;
    double getB_HoldManual() const noexcept;
    double getB_AD_Transition() const noexcept;
    double getB_ASD_Transition() const noexcept;
    double getB_TransitPark() const noexcept;
    double getB_EPB() const noexcept;
    double getsts_SCModeManager() const noexcept;
    /**
     * @brief signal comment: Placeholder for future Message Authentication Code(MAC)/Signature
     */
    double getMAC_VEH_DRV_Interface() const noexcept;

    /**
     * @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
     */
    int64_t setCRC_VEH_DRV_Interface(const double value) noexcept;
    /**
     * @brief signal comment: Alive Counter, E2E Profile 5
     */
    int64_t setALIV_VEH_DRV_Interface(const double value) noexcept;
    int64_t setB_AutoButton(const double value) noexcept;
    int64_t setB_BrakeOverride(const double value) noexcept;
    int64_t setB_LoggingButton(const double value) noexcept;
    int64_t setB_ParkingBrake(const double value) noexcept;
    int64_t setB_SteerOverride(const double value) noexcept;
    int64_t setB_ThrottleOverride(const double value) noexcept;
    int64_t setsts_IgnitionPosition(const double value) noexcept;
    /**
     * @brief signal comment: Accelelerator pedal percentage depression
     * Units: percent
     */
    int64_t setper_AccelPedalPostion(const double value) noexcept;
    int64_t setB_EngageButton(const double value) noexcept;
    /**
     * @brief signal comment: Brake pedal percentage depression
     * Units: percent
     */
    int64_t setper_BrakePedalPosition(const double value) noexcept;
    int64_t setB_Seatbelt(const double value) noexcept;
    int64_t setsts_AuthSwitch(const double value) noexcept;
    int64_t setB_EnableButton(const double value) noexcept;
    int64_t setsts_SWRC_CrsSw(const double value) noexcept;
    int64_t setB_ManualTakeover(const double value) noexcept;
    int64_t setB_HoldManual(const double value) noexcept;
    int64_t setB_AD_Transition(const double value) noexcept;
    int64_t setB_ASD_Transition(const double value) noexcept;
    int64_t setB_TransitPark(const double value) noexcept;
    int64_t setB_EPB(const double value) noexcept;
    int64_t setsts_SCModeManager(const double value) noexcept;
    /**
     * @brief signal comment: Placeholder for future Message Authentication Code(MAC)/Signature
     */
    int64_t setMAC_VEH_DRV_Interface(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::tcar

#endif
