/**
 * \copyright
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Aptiv and its suppliers, if any.
 * The intellectual and technical concepts contained herein are proprietary to Aptiv and its suppliers and may be
 * covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material is strictly forbidden unless prior written
 * permission is obtained from Aptiv.
 *
 * \brief This is a brief (1-line) description of the file.
 *
 * This file is generated with dbc2cpp script version : 3.1.0
 *
 * This file was generated from the following DBC file:
 * /home/lixun/Workspace/gen2-avt-sample-a/Gen2_AVT_A_Control_CAN1.dbc
 *
 */

#ifndef VIC_VEH_Door_Status_g2h_H_
#define VIC_VEH_Door_Status_g2h_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::tcar {

namespace VIC_VEH_Door_Status_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

// This class contains members for decoding/encoding the CAN message VIC_VEH_Door_Status
// The default message identifier for VIC_VEH_Door_Status is 0x240 (576)

// For decoding this is the required length of a decodable message. If the message
// is smaller there is data missing.
// For encoding this the length of the CAN message encoded by this class assuming all
// setters have been called. This value should be one greater than the largest index
// written to by any of the setter methods.
const uint8_t VIC_VEH_DOOR_STATUS_PACKET_LEN = UINT8_C(32);
} // namespace VIC_VEH_Door_Status_CONSTS

class VIC_VEH_Door_Status
{
public:
    VIC_VEH_Door_Status(const uint32_t id);
    VIC_VEH_Door_Status(const uint32_t id, uint8_t* const payload, const uint8_t size);

    /**
     * @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
     */
    double getCRC_VEH_Door_Status() const noexcept;
    /**
     * @brief signal comment: Alive Counter, E2E Profile 5
     */
    double getALIV_VEH_Door_Status() const noexcept;
    double getsts_FuelDoorAjar() const noexcept;
    double getB_HoodAjar() const noexcept;
    double getB_LiftgateContact() const noexcept;
    double getB_LiftGateAjar() const noexcept;
    double getsts_DoorLockStatus() const noexcept;
    /**
     * @brief signal comment: TBD
     */
    double getsts_DoorAjarStatus() const noexcept;
    /**
     * @brief signal comment: TBD
     */
    double getsts_DoorContactStatus() const noexcept;
    /**
     * @brief signal comment: Placeholder for future Message Authentication Code(MAC)/Signature
     */
    double getMAC_VEH_Door_Status() const noexcept;

    /**
     * @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
     */
    int64_t setCRC_VEH_Door_Status(const double value) noexcept;
    /**
     * @brief signal comment: Alive Counter, E2E Profile 5
     */
    int64_t setALIV_VEH_Door_Status(const double value) noexcept;
    int64_t setsts_FuelDoorAjar(const double value) noexcept;
    int64_t setB_HoodAjar(const double value) noexcept;
    int64_t setB_LiftgateContact(const double value) noexcept;
    int64_t setB_LiftGateAjar(const double value) noexcept;
    int64_t setsts_DoorLockStatus(const double value) noexcept;
    /**
     * @brief signal comment: TBD
     */
    int64_t setsts_DoorAjarStatus(const double value) noexcept;
    /**
     * @brief signal comment: TBD
     */
    int64_t setsts_DoorContactStatus(const double value) noexcept;
    /**
     * @brief signal comment: Placeholder for future Message Authentication Code(MAC)/Signature
     */
    int64_t setMAC_VEH_Door_Status(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::tcar

#endif
