/**
 * \copyright
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Aptiv and its suppliers, if any.
 * The intellectual and technical concepts contained herein are proprietary to Aptiv and its suppliers and may be
 * covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material is strictly forbidden unless prior written
 * permission is obtained from Aptiv.
 *
 * \brief This is a brief (1-line) description of the file.
 *
 * This file is generated with dbc2cpp script version : 3.1.0
 *
 * This file was generated from the following DBC file:
 * /home/lixun/Workspace/gen2-avt-sample-a/Gen2_AVT_A_Control_CAN1.dbc
 *
 */

#ifndef VIC_Velocity_g2h_H_
#define VIC_Velocity_g2h_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace av::can::g2h::tcar {

namespace VIC_Velocity_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

// This class contains members for decoding/encoding the CAN message VIC_Velocity
// The default message identifier for VIC_Velocity is 0xa0 (160)

// For decoding this is the required length of a decodable message. If the message
// is smaller there is data missing.
// For encoding this the length of the CAN message encoded by this class assuming all
// setters have been called. This value should be one greater than the largest index
// written to by any of the setter methods.
const uint8_t VIC_VELOCITY_PACKET_LEN = UINT8_C(32);
} // namespace VIC_Velocity_CONSTS

class VIC_Velocity
{
public:
    VIC_Velocity(const uint32_t id);
    VIC_Velocity(const uint32_t id, uint8_t* const payload, const uint8_t size);

    /**
     * @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
     */
    double getCRC_Velocity() const noexcept;
    /**
     * @brief signal comment: Alive Counter, E2E Profile 5
     */
    double getALIV_Velocity() const noexcept;
    /**
     * @brief signal comment: Center of Gravity Velocity
     * Units: m/s
     */
    double getv_VCOG() const noexcept;
    /**
     * @brief signal comment: Vehicle Velocity X coordinate
     * Units: m/s
     */
    double getv_Vx() const noexcept;
    /**
     * @brief signal comment: Vehicle Velocity Y coordinate
     * Units: m/s
     */
    double getv_Vy() const noexcept;
    /**
     * @brief signal comment: TBD
     */
    double getB_VehicleSpeed_Valid() const noexcept;
    /**
     * @brief signal comment: Placeholder for future Message Authentication Code(MAC)/Signature
     */
    double getMAC_Velocity() const noexcept;

    /**
     * @brief signal comment: Cyclic Redundancy Check, E2E Profile 5
     */
    int64_t setCRC_Velocity(const double value) noexcept;
    /**
     * @brief signal comment: Alive Counter, E2E Profile 5
     */
    int64_t setALIV_Velocity(const double value) noexcept;
    /**
     * @brief signal comment: Center of Gravity Velocity
     * Units: m/s
     */
    int64_t setv_VCOG(const double value) noexcept;
    /**
     * @brief signal comment: Vehicle Velocity X coordinate
     * Units: m/s
     */
    int64_t setv_Vx(const double value) noexcept;
    /**
     * @brief signal comment: Vehicle Velocity Y coordinate
     * Units: m/s
     */
    int64_t setv_Vy(const double value) noexcept;
    /**
     * @brief signal comment: TBD
     */
    int64_t setB_VehicleSpeed_Valid(const double value) noexcept;
    /**
     * @brief signal comment: Placeholder for future Message Authentication Code(MAC)/Signature
     */
    int64_t setMAC_Velocity(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};
} // namespace av::can::g2h::tcar

#endif
