/**
 * \copyright
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Aptiv and its suppliers, if any.
 * The intellectual and technical concepts contained herein are proprietary to Aptiv and its suppliers and may be
 * covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material is strictly forbidden unless prior written
 * permission is obtained from Aptiv.
 *
 * \brief This is a brief (1-line) description of the file.
 *
 * This file is generated with dbc2cpp script version : 3.0.0
 *
 * This file was generated from the following DBC file: /media/jhsu/Jeffery_SSD/dbc/20200327_CANFD__Chassis.dbc
 *
 */

#ifndef WHL_01_10ms_H_
#define WHL_01_10ms_H_
#include "interfaces/CanFdPort/Type.h"
#include <cstdint>

namespace WHL_01_10ms_CONSTS {
const uint32_t ERROR_OUT_OF_BOUNDARY = UINT32_C(0xFFFFFFFF);

// This class contains members for decoding/encoding the CAN message WHL_01_10ms
// The default message identifier for WHL_01_10ms is 0xa0 (160)

// For decoding this is the required length of a decodable message. If the message
// is smaller there is data missing.
// For encoding this the length of the CAN message encoded by this class assuming all
// setters have been called. This value should be one greater than the largest index
// written to by any of the setter methods.
const uint8_t WHL_01_10MS_PACKET_LEN = UINT8_C(24);
} // namespace WHL_01_10ms_CONSTS

class WHL_01_10ms
{
public:
    WHL_01_10ms(const uint32_t id);
    WHL_01_10ms(const uint32_t id, uint8_t* const payload, const uint8_t size);

    /**
     * @brief signal comment: WHL_CyclicRedundancyCheck1Value
     */
    double getWHL_Crc1Val() const noexcept;
    /**
     * @brief signal comment: WHL_AliveCounter1Value
     */
    double getWHL_AlvCnt1Val() const noexcept;
    /**
     * @brief signal comment: WHL_PulseFrontLeftValue ##2G##ESC - WHL_PUL11 - WHL_PUL_FL
     * Units: pulse count
     */
    double getWHL_PlsFLVal() const noexcept;
    /**
     * @brief signal comment: WHL_PulseFrontRightValue ##2G##ESC - WHL_PUL11 - WHL_PUL_FR
     * Units: pulse count
     */
    double getWHL_PlsFRVal() const noexcept;
    /**
     * @brief signal comment: WHL_PulseRearLeftValue ##2G##ESC - WHL_PUL11 - WHL_PUL_RL
     * Units: pulse count
     */
    double getWHL_PlsRLVal() const noexcept;
    /**
     * @brief signal comment: WHL_PulseRearRightValue ##2G##ESC - WHL_PUL11 - WHL_PUL_RR
     * Units: pulse count
     */
    double getWHL_PlsRRVal() const noexcept;
    /**
     * @brief signal comment: WHL_DirectionFrontLeftValue ##2G##ESC - WHL_PUL11 - WHL_DIR_FL
     */
    double getWHL_DirFLVal() const noexcept;
    /**
     * @brief signal comment: WHL_DirectionFrontRightValue ##2G##ESC - WHL_PUL11 - WHL_DIR_FR
     */
    double getWHL_DirFRVal() const noexcept;
    /**
     * @brief signal comment: WHL_DirectionRearLeftValue ##2G##ESC - WHL_PUL11 - WHL_DIR_RL
     */
    double getWHL_DirRLVal() const noexcept;
    /**
     * @brief signal comment: WHL_DirectionRearRightValue ##2G##ESC - WHL_PUL11 - WHL_DIR_RR
     */
    double getWHL_DirRRVal() const noexcept;
    /**
     * @brief signal comment: WHL_SpeedFrontLeftValue ##2G##ESC - WHL_SPD11 - WHL_SPD_FL
     * Units: km^h
     */
    double getWHL_SpdFLVal() const noexcept;
    /**
     * @brief signal comment: WHL_SpeedFrontRightValue ##2G##ESC - WHL_SPD11 - WHL_SPD_FR
     * Units: km^h
     */
    double getWHL_SpdFRVal() const noexcept;
    /**
     * @brief signal comment: WHL_SpeedRearLeftValue ##2G##ESC - WHL_SPD11 - WHL_SPD_RL
     * Units: km^h
     */
    double getWHL_SpdRLVal() const noexcept;
    /**
     * @brief signal comment: WHL_SpeedRearRightValue ##2G##ESC - WHL_SPD11 - WHL_SPD_RR
     * Units: km^h
     */
    double getWHL_SpdRRVal() const noexcept;
    /**
     * @brief signal comment: WHL_SpeedCalculationParameter
     * Units: mm
     */
    double getWHL_SpdCalParmtr() const noexcept;

    /**
     * @brief signal comment: WHL_CyclicRedundancyCheck1Value
     */
    int64_t setWHL_Crc1Val(const double value) noexcept;
    /**
     * @brief signal comment: WHL_AliveCounter1Value
     */
    int64_t setWHL_AlvCnt1Val(const double value) noexcept;
    /**
     * @brief signal comment: WHL_PulseFrontLeftValue ##2G##ESC - WHL_PUL11 - WHL_PUL_FL
     * Units: pulse count
     */
    int64_t setWHL_PlsFLVal(const double value) noexcept;
    /**
     * @brief signal comment: WHL_PulseFrontRightValue ##2G##ESC - WHL_PUL11 - WHL_PUL_FR
     * Units: pulse count
     */
    int64_t setWHL_PlsFRVal(const double value) noexcept;
    /**
     * @brief signal comment: WHL_PulseRearLeftValue ##2G##ESC - WHL_PUL11 - WHL_PUL_RL
     * Units: pulse count
     */
    int64_t setWHL_PlsRLVal(const double value) noexcept;
    /**
     * @brief signal comment: WHL_PulseRearRightValue ##2G##ESC - WHL_PUL11 - WHL_PUL_RR
     * Units: pulse count
     */
    int64_t setWHL_PlsRRVal(const double value) noexcept;
    /**
     * @brief signal comment: WHL_DirectionFrontLeftValue ##2G##ESC - WHL_PUL11 - WHL_DIR_FL
     */
    int64_t setWHL_DirFLVal(const double value) noexcept;
    /**
     * @brief signal comment: WHL_DirectionFrontRightValue ##2G##ESC - WHL_PUL11 - WHL_DIR_FR
     */
    int64_t setWHL_DirFRVal(const double value) noexcept;
    /**
     * @brief signal comment: WHL_DirectionRearLeftValue ##2G##ESC - WHL_PUL11 - WHL_DIR_RL
     */
    int64_t setWHL_DirRLVal(const double value) noexcept;
    /**
     * @brief signal comment: WHL_DirectionRearRightValue ##2G##ESC - WHL_PUL11 - WHL_DIR_RR
     */
    int64_t setWHL_DirRRVal(const double value) noexcept;
    /**
     * @brief signal comment: WHL_SpeedFrontLeftValue ##2G##ESC - WHL_SPD11 - WHL_SPD_FL
     * Units: km^h
     */
    int64_t setWHL_SpdFLVal(const double value) noexcept;
    /**
     * @brief signal comment: WHL_SpeedFrontRightValue ##2G##ESC - WHL_SPD11 - WHL_SPD_FR
     * Units: km^h
     */
    int64_t setWHL_SpdFRVal(const double value) noexcept;
    /**
     * @brief signal comment: WHL_SpeedRearLeftValue ##2G##ESC - WHL_SPD11 - WHL_SPD_RL
     * Units: km^h
     */
    int64_t setWHL_SpdRLVal(const double value) noexcept;
    /**
     * @brief signal comment: WHL_SpeedRearRightValue ##2G##ESC - WHL_SPD11 - WHL_SPD_RR
     * Units: km^h
     */
    int64_t setWHL_SpdRRVal(const double value) noexcept;
    /**
     * @brief signal comment: WHL_SpeedCalculationParameter
     * Units: mm
     */
    int64_t setWHL_SpdCalParmtr(const double value) noexcept;

    const CanFdPacket& getCanPacket() const;

private:
    CanFdPacket canPacket_{};
};

#endif
