/// @copyright Copyright (c) 2021- Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// @brief Common test fixture for defining environment variable dependencies.

#pragma once

#include "gtest/gtest.h"
#include <TestUtils/EnvBackup.hpp>

class ConfigFixture : public ::testing::Test
{
public:
    const std::string testSrcDir{getenv("TEST_SRCDIR")};
    const std::string testDataDir{testSrcDir + std::string{"/av_stack/platform/middleware/libs/config/test/testData/"}};

private:
    TestUtils::EnvBackup ottoDir{"OTTO_DIR", testSrcDir};
    TestUtils::EnvBackup ottoConfigDir{"OTTO_CONFIG_DIR", testSrcDir + "/av_stack/config/"};
    TestUtils::EnvBackup activeConfigDir{"ACTIVE_CONFIG_DIR", testSrcDir + "/av_stack/config/active"};
};
