"""
 ***********************************************************************************************************************
 * APTIV PRIVILEGED AND CONFIDENTIAL
 *
 * @file ConfigUtilsUnitTest
 * @product Tests
 * @version 1 <Release Number>
 * @released TODO <date>
 * @updated 2019-04-02 <date>
 * @brief This reads configurations from python files and covnerts them to libconfig.
 *
 * Copyright (c) 2019 - Aptiv. All rights reserved.
 * NOTE: Removing this heading is prohibited.
 ***********************************************************************************************************************
"""
import argparse

# import copy
import imp
import os
import shutil
import sys


def generate_cfg_file(src, tgt):

    # local import to hide hacks
    sys.path.append(os.path.expandvars("$OTTO_CONFIG_DIR"))
    import common.libconf as libconf

    # calibration = copy.deepcopy(src.test_dict)
    s = imp.load_source("src", src)

    with open(tgt, "w") as f:
        f.write("root =\n{\n")
        libconf.dump(s.root, f)
        f.write("};")


if __name__ == "__main__":

    parser = argparse.ArgumentParser(description="A script that generates cfg file from python config file")

    parser.add_argument("src", help="the source python config file")
    parser.add_argument("tgt", help="the cfg file name used for saving the result")
    args = parser.parse_args()

    # assume source and target file names are given relative to the data directory
    data_path = os.path.abspath("..") + "/data/"

    generate_cfg_file(data_path + args.src, data_path + args.tgt)

    # clean up
    if os.path.exists(data_path + args.src + "c"):
        os.remove(data_path + args.src + "c")
    if os.path.exists(data_path + "__pycache__"):
        shutil.rmtree(data_path + "__pycache__")
