/*!
 **********************************************************
 * @file      Clock/Playback/Client/Impl.h
 * @author    Junsung Kim
 * @date      06/09/2016
 * @attention using a timestamp marked when the data is
 * @attention sent for the log playback support
 *
 * @author    Junsung Kim
 * @date      02/18/2016
 * @attention The clock format is otime instead of boost
 *
 * @attention Copyright (c) 2016- Delphi Automotive.
 * @attention All rights reserved.
 **********************************************************
 */

/**********************************************************
  Copyright (c) 2014-2015 Ottomatika, Inc.
 **********************************************************/

/**********************************************************
  Copyright (c) 2010-2013 Carnegie Mellon University,
  All rights reserved.

  This source code was developed in part with support from
  sponsors including General Motors, the National Science
  Foundation and the US Department of Transportation.

  Use of this software is strictly governed by agreements
  between Carnegie Mellon University and various sponsors.

  Users of this software must also be fully aware and agree
  that Carnegie Mellon does not guarantee the correct
  functioning of this software in any system. Carnegie
  Mellon or any of its affiliates will not be liable for any
  damage and/or penalties resulting from the use of this
  software. Any user of this software takes complete
  responsibility for the use of any software or design.
 **********************************************************/

/**
 * @file    Clock/Playback/Client/Impl.h
 * @author  Tugrul Galatali
 * @date    11/06/2006
 *
 * @attention Copyright (c) 2006
 * @attention Carnegie Mellon University
 * @attention All rights reserved.
 */
#ifndef _CLOCK_PLAYBACK_CLIENT_IMPL_H_
#define _CLOCK_PLAYBACK_CLIENT_IMPL_H_

#pragma message("The ClockPlaybackClient is being deprecated. To get time, use a CommsPlaybackClock instead.")

#include <Clock/ClockSource.h>
#include <interfaces/Clock/Playback/Input/Channel/Abstract.h>

class ClockPlaybackClient
    : public Clock
    , public PlaybackClockParamsInput
{
public:
    ClockPlaybackClient(ConfigSection& cs, const task::Access& acc);
    virtual ~ClockPlaybackClient();

    virtual bool initialize();
    virtual void cleanup();

    virtual ottotime::otimePoint getCurrentTime();

    virtual bool get(PlaybackClockParams& val, bool blocking = false);
    virtual void unblock() override;
    virtual void clear() override;

private:
    uint32_t headerVersion_;
    bool receivedParams_;
    PlaybackClockParams latestParams_;
};

#endif
