/**********************************************************
  Copyright (c) 2014-    Ottomatika, Inc.
 **********************************************************/

/**********************************************************
  Copyright (c) 2010-2013 Carnegie Mellon University,
  All rights reserved.

  This source code was developed in part with support from
  sponsors including General Motors, the National Science
  Foundation and the US Department of Transportation.

  Use of this software is strictly governed by agreements
  between Carnegie Mellon University and various sponsors.

  Users of this software must also be fully aware and agree
  that Carnegie Mellon does not guarantee the correct
  functioning of this software in any system. Carnegie
  Mellon or any of its affiliates will not be liable for any
  damage and/or penalties resulting from the use of this
  software. Any user of this software takes complete
  responsibility for the use of any software or design.
 **********************************************************/

/**
 * @file    Generic/Output/Channel/Impl.spec.cc
 * @author  Tugrul Galatali
 * @date    09/13/2006
 *
 * @attention Copyright (c) 2006
 * @attention Carnegie Mellon University
 * @attention All rights reserved.
 */

#include <interfaces/Generic/Output/Channel/Impl.h>

#define GenericOutputSpecialization(BaseTypeName, MessageType)                                                         \
    class BaseTypeName##OutputChannel : public GenericOutputChannel<MessageType>                                       \
    {                                                                                                                  \
    public:                                                                                                            \
        BaseTypeName##OutputChannel(ConfigSection& cs, const task::Access& acc)                                        \
            : GenericOutputChannel<MessageType>(cs, acc)                                                               \
        {}                                                                                                             \
                                                                                                                       \
        ~BaseTypeName##OutputChannel() override = default;                                                             \
    };
