/**********************************************************
  Copyright (c) 2014-    Ottomatika, Inc.
 **********************************************************/

/**********************************************************
  Copyright (c) 2010-2013 Carnegie Mellon University,
  All rights reserved.

  This source code was developed in part with support from
  sponsors including General Motors, the National Science
  Foundation and the US Department of Transportation.

  Use of this software is strictly governed by agreements
  between Carnegie Mellon University and various sponsors.

  Users of this software must also be fully aware and agree
  that Carnegie Mellon does not guarantee the correct
  functioning of this software in any system. Carnegie
  Mellon or any of its affiliates will not be liable for any
  damage and/or penalties resulting from the use of this
  software. Any user of this software takes complete
  responsibility for the use of any software or design.
 **********************************************************/

/**
 * @file    Base/Input.h
 * @author  Tugrul Galatali
 * @date    10/02/2006
 *
 * @attention Copyright (c) 2006
 * @attention Carnegie Mellon University
 * @attention All rights reserved.
 */
#ifndef _INTERFACES_BASETYPES_INPUT_H_
#define _INTERFACES_BASETYPES_INPUT_H_

namespace interfaces {
namespace baseTypes {

template<typename T>
class Input
{
public:
    virtual ~Input() = default;

    virtual bool get(T& val, bool blocking = false) = 0;
    /**
     * @brief API to unblock the underlying channel of the Input interface.
     */
    virtual void unblock() = 0;

    /**
     * @brief Clear the data recieved on the input interface
     */
    virtual void clear() = 0;
};

} // namespace baseTypes
} // namespace interfaces

#endif
