/**********************************************************
  Copyright (c) 2014-    Ottomatika, Inc.
 **********************************************************/

/**********************************************************
  Copyright (c) 2010-2013 Carnegie Mellon University,
  All rights reserved.

  This source code was developed in part with support from
  sponsors including General Motors, the National Science
  Foundation and the US Department of Transportation.

  Use of this software is strictly governed by agreements
  between Carnegie Mellon University and various sponsors.

  Users of this software must also be fully aware and agree
  that Carnegie Mellon does not guarantee the correct
  functioning of this software in any system. Carnegie
  Mellon or any of its affiliates will not be liable for any
  damage and/or penalties resulting from the use of this
  software. Any user of this software takes complete
  responsibility for the use of any software or design.
 **********************************************************/

/**
 * @file csvable.h
 * @author Tugrul Galatali
 * @date 10/17/2006
 *
 * @attention Copyright (C) 2006
 * @attention Carnegie Mellon University
 * @attention All rights reserved.
 **/
#ifndef _CSVABLE_H_
#define _CSVABLE_H_

#include <ostream>
#include <string>

class csvable
{
public:
    virtual ~csvable() = default;

    virtual void toCsv(std::ostream& out) const = 0;
    virtual bool getFieldNames([[maybe_unused]] std::string& out) const { return false; }
};

#define PluginCSVable(PluginCommsBaseClass)                                                                            \
    extern "C"                                                                                                         \
    {                                                                                                                  \
        csvable* getCSVable(const void* blob, const unsigned int size)                                                 \
        {                                                                                                              \
            return SerializeUtil::restoreAltType<PluginCommsBaseClass, csvable*>(blob, size);                          \
        }                                                                                                              \
    }

#endif
