/*!
 ***********************************************************
 * @file FileWriter.cc
 *
 * @brief file implementing FileWriter class
 *
 * A writer that outputs log events to file.
 *
 * This class writes LogEvent objects to file.  If the file exists, it is
 * overwritten.  Each LogEvent is written to a separate line in the file.
 *
 *
 * @section License
 *
 * Copyright (c) 2015- Delphi Automotive. All rights
 * reserved.
 *
 * @section changeLogs Change Logs
 *
 ***********************************************************
 */

/**********************************************************
  Copyright (c) 2014-2015 Ottomatika, Inc.
 **********************************************************/

/**********************************************************
  Copyright (c) 2010-2013 Carnegie Mellon University,
  All rights reserved.

  This source code was developed in part with support from
  sponsors including General Motors, the National Science
  Foundation and the US Department of Transportation.

  Use of this software is strictly governed by agreements
  between Carnegie Mellon University and various sponsors.

  Users of this software must also be fully aware and agree
  that Carnegie Mellon does not guarantee the correct
  functioning of this software in any system. Carnegie
  Mellon or any of its affiliates will not be liable for any
  damage and/or penalties resulting from the use of this
  software. Any user of this software takes complete
  responsibility for the use of any software or design.
 **********************************************************/

/*
 ***********************************************************
 * FileWriter.cc
 * Bryan Salesky
 * 02/28/2006
 *
 * Copyright (C) 2006 CMU. All rights reserved.
 ***********************************************************
 */
#include "FileWriter.h"
#include <iostream>

using namespace std;
using namespace logger;

FileWriter::FileWriter()
    : LogWriter()
{}

FileWriter::~FileWriter() {}

void FileWriter::write_(const LogEvent& event) {}
