/**********************************************************
  Copyright (c) 2014-    Ottomatika, Inc.
 **********************************************************/

/**********************************************************
  Copyright (c) 2010-2013 Carnegie Mellon University,
  All rights reserved.

  This source code was developed in part with support from
  sponsors including General Motors, the National Science
  Foundation and the US Department of Transportation.

  Use of this software is strictly governed by agreements
  between Carnegie Mellon University and various sponsors.

  Users of this software must also be fully aware and agree
  that Carnegie Mellon does not guarantee the correct
  functioning of this software in any system. Carnegie
  Mellon or any of its affiliates will not be liable for any
  damage and/or penalties resulting from the use of this
  software. Any user of this software takes complete
  responsibility for the use of any software or design.
 **********************************************************/

/**
 * @file BezierCurve.h
 * @author: Chris Urmson (curmson@ri.cmu.edu)
 * @date: 11/16/2006
 *
 * @attention Copyright (c) 2006
 * @attention Carnegie Mellon University
 * @attention All rights reserved.
 */
#ifndef _BEZIERCURVE_H_
#define _BEZIERCURVE_H_
#include "recgeometry/recGeometry.h"
/**
 * @brief a simple class to generate a bezier curve given a start and end point and a pair of vectors
 * @ingroup recGeometryGroup
 *
 * math source from: http://www.moshplant.com/direct-or/bezier/math.html
 */
class BezierCurve
{
    RecPoint2D x0_;
    RecPoint2D a_, b_, c_;

public:
    BezierCurve(RecPoint2D start, RecPoint2D end, RecVector2D startDirection, RecVector2D endDirection);
    BezierCurve(RecPoint2D x0, RecPoint2D x1, RecPoint2D x2, RecPoint2D x3);

    RecPoint2D getCurvePoint(double t);
};

#endif // ifndef _BEZIERCURVE_H_
