/**
 * @file EuclideanCluster.h
 * @author: Wenda Xu (wenda@ottomatika.com)
 * @date: 10/08/2015
 *
 * @attention Copyright (c) 2015
 * @attention All rights reserved.
 */

#ifndef EUCLIDEANCLUSTER_H
#define EUCLIDEANCLUSTER_H

#include "RecKDTree2D.h"
#include "recgeometry/recGeometry.h"
#include <math.h>

class EuclideanCluster
{
public:
    EuclideanCluster();
    // Attention: lidarPts need to be in local coordinate
    bool cluster(std::vector<std::vector<RecPoint2D>>& segments, const std::vector<RecPoint2D>& lidarPts);

public:
    // prepare for adaptive radius
    double minRadius_;
    double maxRadius_;
    double resolutionAng_;
    double minLineAng_;
    double rate_;
    double radius_;
};

#endif // EUCLIDEANCLUSTER_H
