/*!
 ***********************************************************************************************************************
 * APTIV PRIVILEGED AND CONFIDENTIAL
 *
 * @file <recgeometryPythonBindings.cpp>
 * @brief recgeometryPythonBindings - Python bindings for the recgeometry APIs.
 *
 * @section License
 *
 * Copyright (c) 2018- Aptiv. All rights reserved.
 * NOTE: Removing this heading is prohibited.
 *
 * @section Open Source License List
 *
 * This is a list of any open-source project used by this file.
 ***********************************************************************************************************************
 */

#include <iostream>
#include <math.h>
#include <recgeometry/recGeometry.h>

#include <pybind11/pybind11.h>

using namespace std;
namespace py = pybind11;

PYBIND11_MODULE(PyRecGeometry, pyMod)
{
    pyMod.doc() = "pybind11 wrapper for recgeometry";
    py::class_<RecPoint2D>(pyMod, "RecPoint2D")
        .def(py::init<>())
        .def(py::init<double, double>())
        .def(py::init<const RecPoint2D&>());
}
