#!/usr/bin/env python3
import unittest

# sys.path.append(os.environ['OTTO_DIR'] + "/lib")
from PyRecGeometry import RecPoint2D


class RecPoint2DTest(unittest.TestCase):
    def test_object_creation(self):
        # Ensure object creation is possible with trivial inputs or no inpits
        self.assertIsNotNone(RecPoint2D())
        self.assertIsNotNone(RecPoint2D(2.0, 1.0))

        temp_rec_point = RecPoint2D(2, 1.0)
        self.assertIsNotNone(RecPoint2D(temp_rec_point))

        # Ensure that creating one object from another results in 2 different objects - we are comparing object
        # pointers here and not the values themselves.
        self.assertNotEqual(temp_rec_point, RecPoint2D(temp_rec_point))


if __name__ == "__main__":
    unittest.main()
