/**********************************************************
  Copyright (c) 2014-    Ottomatika, Inc.
 **********************************************************/

/**********************************************************
  Copyright (c) 2010-2013 Carnegie Mellon University,
  All rights reserved.

  This source code was developed in part with support from
  sponsors including General Motors, the National Science
  Foundation and the US Department of Transportation.

  Use of this software is strictly governed by agreements
  between Carnegie Mellon University and various sponsors.

  Users of this software must also be fully aware and agree
  that Carnegie Mellon does not guarantee the correct
  functioning of this software in any system. Carnegie
  Mellon or any of its affiliates will not be liable for any
  damage and/or penalties resulting from the use of this
  software. Any user of this software takes complete
  responsibility for the use of any software or design.
 **********************************************************/

/**
 * @file testRectangleFitter.cc
 * @author: Chris Urmson (curmson@ri.cmu.edu)
 * @date:
 *
 * @attention Copyright (c) 2007
 * @attention Carnegie Mellon University
 * @attention All rights reserved.
 */
#ifndef _TESTRECTANGLEFITTER_CC_
#define _TESTRECTANGLEFITTER_CC_

#include <fstream>
#include <iostream>
#include <recgeometry/rectangleFitter.h>
#include <string>

using namespace std;

int main(void)
{
    RectangleFitter rf;
    std::vector<RecPoint3D> pts;
    string line;
    float f1, f2, f3;
    // Read in the points
    cout << "\n Rect Fitting:" << endl;
    ifstream myfile("clust2.dat");

    if (myfile.is_open()) {
        while (!myfile.eof()) {
            getline(myfile, line);
            char line2[100];
            strcpy(line2, line.c_str());
            sscanf(line2, "%g %g %g", &f1, &f2, &f3);
            pts.push_back(RecPoint3D(f1, f2, f3));
        }
        myfile.close();
    }

    std::vector<RecPoint2D> cornerPts;
    if (!pts.empty()) {
        cornerPts = rf.findBestRectangle<RecPoint3D>(pts);
    }

    if (!cornerPts.empty()) {
        cout << "\n corner points are: " << endl;
        cout << cornerPts[0] << " " << cornerPts[1] << " " << cornerPts[2] << " " << cornerPts[3] << endl;
    }
}

#endif // ifndef _TESTRECTANGLEFITTER_CC_
