#pragma once

#include "lib/avlog/DataLogReader.hpp"
#include <sms/SmsSchema.hpp>

namespace av::sms {

class SmsIngestionReader
{
public:
    SmsIngestionReader(const std::string& file, bool messageOutput)
        : reader_(file)
        , messageOutput_(messageOutput)
    {}

    /// @brief Read the log file and return the JSON representation
    nlohmann::json read();

private:
    /// @brief Adds the string to the table while streaming through the file.
    void addInternString(InternString str);

    avlog::DataLogReader reader_;
    std::unordered_map<uint32_t, std::string> internTable_;
    const bool messageOutput_;
};

} // namespace av::sms
