# Running the `avlogSmsBenchmark` Benchmark

## Running over default parameter set (`runBenchmark.py`) 

To run the benchmark, simply run the `runBenchmark.py` script. This will run
`avlogSmsBenchmark` sequentially over the predefined set of parameters found
in the python script. The script expects the folder in which `avlogSmsBenchmark`
resides present in your `PATH` environment variable.

If running this benchmark from within the development Docker environment, run
the following command from the root of the `av-stack` repository in your bash
console to add the appropriate path to your `PATH`:

```bash
export PATH=$PATH:$(readlink -f ./bazel-bin/platform/middleware/libs/sms/tests/benchmark)
```

**Note:** The benchmarks will place the log files in the working directory you
run `runBenchmark.py`.

The results of each parameter set are printed to standard output in a tabular
format. An example output may look like:

fileSize [KB] | duration [ms] | entry count | thread count
xxxxx           xxxx            1000000       1            
xxxxx           xxxx            1000000       2            
xxxxx           xxxx            1000000       4            
xxxxx           xxxx            1000000       8            
xxxxx           xxxx            1000000       16           
xxxxx           xxxx            1000000       24           
xxxxx           xxxx            1000000       32 

## Running manually

To run the `avlogSmsBenchmark` executable, supply 2 unnamed arguments:
`entryCount` and `threadCount`. `entryCount` dictates how many trace events
will be logged, and `threadCount` determines across how many threads the 
trace events will be logged.

The total time to run the benchmark across these parameters will be printed
to `stdout`. It is recommended to modify the `runBenchmark.py` script
to run the benchmark instead of running the executable directly.
