/**
 * \copyright
 * Copyright (c) 2020- Motional. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Motional and its suppliers, if any.
 * The intellectual and technical concepts contained herein are proprietary to Motional and its suppliers and may be
 * covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material is strictly forbidden unless prior written
 * permission is obtained from Motional.
 *
 * \brief Defines an interface for AV task application
 */

#ifndef TASK_APPLICATION_INTERFACE_H
#define TASK_APPLICATION_INTERFACE_H

namespace task {

/**
 * \brief Defines an interface for AV task application
 */
class TaskApplicationInterface
{
public:
    /**
     * \brief Default constructor
     */
    TaskApplicationInterface() = default;

    /**
     * \brief Default destructor
     */
    virtual ~TaskApplicationInterface() = default;

    /**
     * \brief Initialize the task application
     *
     * \param argc The number of arguments
     * \param argv The list of arguments
     *
     * \return True if the creation is fine, false, otherwise
     */
    virtual bool initTask(int argc, char** argv) = 0;

    /**
     * \brief Run the task application
     *
     * \param Void
     *
     * \return True if the running is fine, false, otherwise
     */
    virtual bool runTask() = 0;
};

} // namespace task

#endif // TASK_APPLICATION_INTERFACE_H
