/// @copyright Copyright (c) 2021- Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// @brief Definition of the DeserializerBase abstract interface.
#pragma once

#include <string>
#include <string_view>

namespace av::repro {

class DeserializerBase
{
public:
    DeserializerBase() noexcept = default;
    virtual ~DeserializerBase() noexcept = default;

    /// Interface for receiving a message in a particular topic.
    virtual void receive(const std::string& blob, const std::string_view& origin) = 0;
};

} // namespace av::repro
