/// @copyright Copyright (c) 2021- Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// @brief Function definitions for the EventInfo class.
#include <repro/EventInfo.hpp>

#include <cstdint>

namespace av::repro {

EventInfo::EventInfo(Duration time, std::string_view topic, std::string_view origin, uint32_t id) noexcept
    : time_(time)
    , topic_(topic)
    , origin_(origin)
    , id_(id)
{}

Duration EventInfo::time() const noexcept
{
    return time_;
}

const std::string_view& EventInfo::topic() const noexcept
{
    return topic_;
}

const std::string_view& EventInfo::origin() const noexcept
{
    return origin_;
}

uint32_t EventInfo::id() const noexcept
{
    return id_;
}

} // namespace av::repro
