/// @copyright Copyright (c) 2021- Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// @brief Declaration of functions for operating on serialized blobs with headers.
#pragma once

#include <avtime/AvClock.hpp>

#include <string>

namespace av::repro {

/// Parse a message timestamp.
Duration parseTimestamp(const std::string& blob);

/// Parse a timestamp in a playback clock message.
Duration parsePlaybackClock(const std::string& blob);

/// Parse a message ID.
uint32_t parseID(const std::string& blob);

} // namespace av::repro
