/// @copyright Copyright (c) 2021- Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// @brief Typedefs for message and timeout handler functions.
#pragma once

#include <functional>
#include <string>
#include <vector>

namespace av::repro {

// Forward declarations.
class Event;
template<typename Type>
class Message;

/// The function signature for a timeout handler.
using TimeoutHandler = std::function<void()>;

/// The data structure that holds the inputs to a message handler.
template<typename Type>
using Inputs = std::vector<Message<Type>>;
/// The function signature for a message handler.
template<typename Type>
using MessageHandler = std::function<void(const Inputs<Type>&)>;

/// The function that is called to enqueue events.
using Enqueuer = std::function<void(Event&&)>;

} // namespace av::repro
