#include <thread>

#include <task/Task.h>

using namespace task;

class LongInitTask : public Task
{
public:
    explicit LongInitTask(const std::string& taskName)
        : Task(taskName)
    {}
    bool initialize() override
    {
        AVLOG_INFO("LongInitTask::initialize begin");
        std::this_thread::sleep_for(std::chrono::seconds(5));
        AVLOG_INFO("LongInitTask::initialize end");
        return true;
    }
    bool executive() override
    {
        AVLOG_INFO("LongInitTask::executive");
        return false;
    }
    void cleanup() override { AVLOG_INFO("LongInitTask::cleanup"); }
};

Task* Task::get()
{
    static LongInitTask task("LongInitTask");
    return &task;
}
