/**
 * \copyright
 * Copyright (c) 2020- Motional. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Motional and its suppliers, if any.
 * The intellectual and technical concepts contained herein are proprietary to Motional and its suppliers and may be
 * covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material is strictly forbidden unless prior written
 * permission is obtained from Motional.
 *
 * \brief Runs all the google tests linked to the binary this is compiled with.
 */

#ifdef MONITOR_MALLOC_TIMES
#include "platform/middleware/libs/task/alloc.h"
#endif
#include <gmock/gmock.h>
#include <gtest/gtest.h>
#include <task/Task.h>

/*!
 * TASK::GET hack
 */
task::Task* task::Task::get(void)
{
    return nullptr;
}

/*!
 * Need this additional main to override the other one and actually run the tests
 */
GTEST_API_ int main(int argc, char** argv)
{
    ::testing::InitGoogleMock(&argc, argv);
    const auto res = RUN_ALL_TESTS();
#ifdef MONITOR_MALLOC_TIMES
    alloc_write_report();
#endif
    return res;
}
