/**
 * \copyright
 * Copyright (c) 2020- Motional. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Motional and its suppliers, if any.
 * The intellectual and technical concepts contained herein are proprietary to Motional and its suppliers and may be
 * covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material is strictly forbidden unless prior written
 * permission is obtained from Motional.
 *
 * \brief Implement makeTaskScheduler function unit tests
 */

#include <config/ConfigParser.h>

namespace {
ConfigSection makeConfigSection(const std::string& clockType, double rate, double minRate)
{
    // put it together
    std::string configString = "params = {";
    if (!clockType.empty()) {
        // add a clockType section
        configString += "clockType = \"" + clockType + "\";";
    }
    // add the cycle rate
    configString += "cycleRate_hz = " + std::to_string(rate) + ";";
    // add the min rate
    configString += "minCycleRate_hz = " + std::to_string(minRate) + ";";
    // close
    configString += "}";

    // parse it
    ConfigParser parser;
    parser.parseString(configString);
    ConfigSection out;
    parser.getSection("params", out);

    return out;
}
} // namespace
