/// @copyright Copyright (c) 2021- Motional. All rights reserved.
///
/// NOTICE: Removing this heading is prohibited.
///
/// All information contained herein is, and remains the property of Motional,
/// its affiliates, and its suppliers (if any). The intellectual and technical
/// concepts contained herein are proprietary to Motional, its affiliates, and
/// its suppliers (if any) and may be covered by U.S. and Foreign Patents,
/// patents in process, and are protected by trade secrets or copyright law.
/// Dissemination of this information or reproduction of this material is
/// strictly forbidden unless prior written permission is obtained from Motional.
///
/// @file
/// @brief Declare addition (concatenation) between string_view and string.

#include <string>
#include <string_view>

#pragma once

/**
 * @brief Addition operator between string and string_view, because for some reason this is not implemented in the STL.
 *
 * @param[in] lhs: The left hand side
 * @param[in] rhs: The right hand side
 *
 * @return The concatenated value ${lhs}${rhs}
 **/
std::string operator+(const std::string& lhs, const std::string_view& rhs);

/**
 * @brief Addition operator between string and string_view, because for some reason this is not implemented in the STL.
 *
 * @param[in] lhs: The left hand side
 * @param[in] rhs: The right hand side
 *
 * @return The concatenated value ${lhs}${rhs}
 **/
std::string operator+(const std::string_view& lhs, const std::string& rhs);
