// Copyright (c) 2021- Motional. All rights reserved.
//
// NOTICE: Removing this heading is prohibited.
//
// All information contained herein is, and remains the property of Motional, its affiliates, and
// its suppliers (if any). The intellectual and technical concepts contained herein are proprietary
// to Motional, its affiliates, and its suppliers (if any) and may be covered by U.S. and Foreign
// Patents, patents in process, and are protected by trade secrets or copyright law. Dissemination
// of this information or reproduction of this material is strictly forbidden unless prior written
// permission is obtained from Motional.

#include "lib/avtime/AvClock.hpp"

namespace av {

TimePoint AvClock::now()
{
    static const std::chrono::steady_clock::duration SYS_STEADY_OFFSET = ([]() {
        const auto sys_now = std::chrono::system_clock::now();
        const auto steady_now = std::chrono::steady_clock::now();
        return sys_now.time_since_epoch() - steady_now.time_since_epoch();
    })();
    return TimePoint{(std::chrono::steady_clock::now() + SYS_STEADY_OFFSET).time_since_epoch()};
}

} // namespace av
