// Copyright (c) 2021- Motional. All rights reserved.
//
// NOTICE: Removing this heading is prohibited.
//
// All information contained herein is, and remains the property of Motional, its affiliates, and
// its suppliers (if any). The intellectual and technical concepts contained herein are proprietary
// to Motional, its affiliates, and its suppliers (if any) and may be covered by U.S. and Foreign
// Patents, patents in process, and are protected by trade secrets or copyright law. Dissemination
// of this information or reproduction of this material is strictly forbidden unless prior written
// permission is obtained from Motional.

#pragma once

#include <chrono>

namespace av {

inline int64_t usecFromDuration(const std::chrono::nanoseconds duration)
{
    return std::chrono::duration_cast<std::chrono::microseconds>(duration).count();
}

template<typename Clock>
int64_t usecFromTimePoint(const std::chrono::time_point<Clock>& timePoint)
{
    return usecFromDuration(timePoint.time_since_epoch());
}

inline std::chrono::nanoseconds durationFromUsec(const int64_t usec)
{
    return std::chrono::microseconds{usec};
}

template<typename Clock>
std::chrono::time_point<Clock> timePointFromUsec(const int64_t usec)
{
    return std::chrono::time_point<Clock>{durationFromUsec(usec)};
}

} // namespace av
