#include <interfaces/AvAirCleaning/AvAirCleaning.h>

#include <iterator>
#include <type_traits>

#include <cereal/cereal.hpp>
#include <cereal/archives/json.hpp>
#include <cereal/archives/binary.hpp>

#include <cereal/types/map.hpp>
#include <cereal/types/vector.hpp>
#include <cereal/types/array.hpp>
#include <cereal/types/string.hpp>
#include <cereal/types/complex.hpp>

#include <ODatum/IntrospectionArchive.h>
#include <ODatum/Hash.h>





 namespace av {
 namespace msg {


AvAirCleaning::AvAirCleaning() = default;

AvAirCleaning::AvAirCleaning(
    uint16_t crcAvAirCleaning_arg ,
    uint8_t alivAvAirCleaning_arg ,
    uint8_t airCleanCam_M_F_arg ,
    uint8_t airCleanCam_W_F_arg ,
    uint8_t airCleanLidar_F_arg ,
    uint8_t airCleanLidar_T_arg ,
    uint64_t macAvAirCleaning_arg 
    ):
    crcAvAirCleaning { std::move(crcAvAirCleaning_arg) } // NOLINT
      ,alivAvAirCleaning { std::move(alivAvAirCleaning_arg) } // NOLINT
      ,airCleanCam_M_F { std::move(airCleanCam_M_F_arg) } // NOLINT
      ,airCleanCam_W_F { std::move(airCleanCam_W_F_arg) } // NOLINT
      ,airCleanLidar_F { std::move(airCleanLidar_F_arg) } // NOLINT
      ,airCleanLidar_T { std::move(airCleanLidar_T_arg) } // NOLINT
      ,macAvAirCleaning { std::move(macAvAirCleaning_arg) } // NOLINT
      {
}

AvAirCleaning::AvAirCleaning(const AvAirCleaning&) = default;

// NOLINTNEXTLINE
AvAirCleaning::AvAirCleaning(AvAirCleaning&&) = default;

AvAirCleaning& AvAirCleaning::operator=(const AvAirCleaning&) = default;

// NOLINTNEXTLINE
AvAirCleaning& AvAirCleaning::operator=(AvAirCleaning&&) = default;

void AvAirCleaning::toCsv(std::ostream& out) const
{
    out.precision(16);
    out << std::boolalpha;
    out << crcAvAirCleaning;out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(alivAvAirCleaning);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(airCleanCam_M_F);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(airCleanCam_W_F);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(airCleanLidar_F);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(airCleanLidar_T);out << ",";
    out << macAvAirCleaning;
    
}

std::stringstream AvAirCleaning::toStringstream() const
{
    std::stringstream out;
    toCsv(out);
    return out;
}

template<class Archive>
    void AvAirCleaning::serialize(Archive& ar, [[maybe_unused]] unsigned int version)
    {

        ar& CEREAL_NVP(crcAvAirCleaning);
        ar& CEREAL_NVP(alivAvAirCleaning);
        ar& CEREAL_NVP(airCleanCam_M_F);
        ar& CEREAL_NVP(airCleanCam_W_F);
        ar& CEREAL_NVP(airCleanLidar_F);
        ar& CEREAL_NVP(airCleanLidar_T);
        ar& CEREAL_NVP(macAvAirCleaning);
    }


template void AvAirCleaning::serialize(cereal::BinaryInputArchive& ar, unsigned int version);
template void AvAirCleaning::serialize(cereal::BinaryOutputArchive& ar, unsigned int version);
template void AvAirCleaning::serialize(cereal::IntrospectionArchive& ar, unsigned int version);
template void AvAirCleaning::serialize(cereal::JSONInputArchive& ar, unsigned int version);
template void AvAirCleaning::serialize(cereal::JSONOutputArchive& ar, unsigned int version);
template void AvAirCleaning::serialize(cereal::PortableBinaryInputArchive& ar, unsigned int version);
template void AvAirCleaning::serialize(cereal::PortableBinaryOutputArchive& ar, unsigned int version);

std::ostream& operator<< (std::ostream& os, const AvAirCleaning& avaircleaning)
{
    avaircleaning.toCsv(os);
    return os;
}

bool operator== (const AvAirCleaning &lhs, const AvAirCleaning &rhs)
{
    return (  lhs.crcAvAirCleaning== rhs.crcAvAirCleaning &&
     lhs.alivAvAirCleaning== rhs.alivAvAirCleaning &&
     lhs.airCleanCam_M_F== rhs.airCleanCam_M_F &&
     lhs.airCleanCam_W_F== rhs.airCleanCam_W_F &&
     lhs.airCleanLidar_F== rhs.airCleanLidar_F &&
     lhs.airCleanLidar_T== rhs.airCleanLidar_T &&
     lhs.macAvAirCleaning== rhs.macAvAirCleaning 
    );
}

std::size_t AvAirCleaning::hash() const noexcept
{
    std::size_t result = 17;
    result = result * 31 + std::hash<uint16_t>()(crcAvAirCleaning);
    result = result * 31 + std::hash<uint8_t>()(alivAvAirCleaning);
    result = result * 31 + std::hash<uint8_t>()(airCleanCam_M_F);
    result = result * 31 + std::hash<uint8_t>()(airCleanCam_W_F);
    result = result * 31 + std::hash<uint8_t>()(airCleanLidar_F);
    result = result * 31 + std::hash<uint8_t>()(airCleanLidar_T);
    result = result * 31 + std::hash<uint64_t>()(macAvAirCleaning);
    return result;
}

 } // namespace av
 } // namespace msg


CEREAL_BIND_TO_ARCHIVES(av::msg::AvAirCleaning)

