#include <interfaces/AvInitReady/AvInitReady.h>

#include <iterator>
#include <type_traits>

#include <cereal/cereal.hpp>
#include <cereal/archives/json.hpp>
#include <cereal/archives/binary.hpp>

#include <cereal/types/map.hpp>
#include <cereal/types/vector.hpp>
#include <cereal/types/array.hpp>
#include <cereal/types/string.hpp>
#include <cereal/types/complex.hpp>

#include <ODatum/IntrospectionArchive.h>
#include <ODatum/Hash.h>





 namespace av {
 namespace msg {


AvInitReady::AvInitReady() = default;

AvInitReady::AvInitReady(
    TimePoint m_Timestamp_arg 
    ):
    m_Timestamp { std::move(m_Timestamp_arg) } // NOLINT
      {
}

AvInitReady::AvInitReady(const AvInitReady&) = default;

// NOLINTNEXTLINE
AvInitReady::AvInitReady(AvInitReady&&) = default;

AvInitReady& AvInitReady::operator=(const AvInitReady&) = default;

// NOLINTNEXTLINE
AvInitReady& AvInitReady::operator=(AvInitReady&&) = default;

void AvInitReady::toCsv(std::ostream& out) const
{
    out.precision(16);
    out << std::boolalpha;
    out << m_Timestamp;
    
}

std::stringstream AvInitReady::toStringstream() const
{
    std::stringstream out;
    toCsv(out);
    return out;
}

template<class Archive>
    void AvInitReady::serialize(Archive& ar, unsigned int version)
{
	if (version >= 1) {
		ar& CEREAL_NVP(m_Timestamp);
	}
}

}} // to close av::msg namespace temporary

struct AvInitReady : public av::msg::AvInitReady {};
CEREAL_CLASS_VERSION(AvInitReady, 2)
CEREAL_REGISTER_TYPE(AvInitReady)

namespace av {
namespace msg {


template void AvInitReady::serialize(cereal::BinaryInputArchive& ar, unsigned int version);
template void AvInitReady::serialize(cereal::BinaryOutputArchive& ar, unsigned int version);
template void AvInitReady::serialize(cereal::IntrospectionArchive& ar, unsigned int version);
template void AvInitReady::serialize(cereal::JSONInputArchive& ar, unsigned int version);
template void AvInitReady::serialize(cereal::JSONOutputArchive& ar, unsigned int version);
template void AvInitReady::serialize(cereal::PortableBinaryInputArchive& ar, unsigned int version);
template void AvInitReady::serialize(cereal::PortableBinaryOutputArchive& ar, unsigned int version);

std::ostream& operator<< (std::ostream& os, const AvInitReady& avinitready)
{
    avinitready.toCsv(os);
    return os;
}

bool operator== (const AvInitReady &lhs, const AvInitReady &rhs)
{
    return (  lhs.m_Timestamp== rhs.m_Timestamp 
    );
}

std::size_t AvInitReady::hash() const noexcept
{
    std::size_t result = 17;
    result = result * 31 + 0;
    return result;
}

 } // namespace av
 } // namespace msg


CEREAL_BIND_TO_ARCHIVES(av::msg::AvInitReady)

