#include <interfaces/AvWasherCleaning/AvWasherCleaning.h>

#include <iterator>
#include <type_traits>

#include <cereal/cereal.hpp>
#include <cereal/archives/json.hpp>
#include <cereal/archives/binary.hpp>

#include <cereal/types/map.hpp>
#include <cereal/types/vector.hpp>
#include <cereal/types/array.hpp>
#include <cereal/types/string.hpp>
#include <cereal/types/complex.hpp>

#include <ODatum/IntrospectionArchive.h>
#include <ODatum/Hash.h>





 namespace av {
 namespace msg {


AvWasherCleaning::AvWasherCleaning() = default;

AvWasherCleaning::AvWasherCleaning(
    uint16_t crcAvWasherCleaning_arg ,
    uint8_t alivAvWasherCleaning_arg ,
    uint8_t washCleanCam_M_F_arg ,
    uint8_t washCleanCam_W_F_arg ,
    uint8_t washCleanLidar_F_arg ,
    uint8_t washCleanLidar_T_arg ,
    uint8_t washCleanCam_M_L0_arg ,
    uint8_t washCleanCam_W_L0_arg ,
    uint8_t washCleanCam_M_L1_arg ,
    uint8_t washCleanCam_M_L2_arg ,
    uint8_t washCleanCam_M_B_arg ,
    uint8_t washCleanCam_W_B_arg ,
    uint8_t washCleanCam_M_R2_arg ,
    uint8_t washCleanCam_M_R1_arg ,
    uint8_t washCleanCam_M_R0_arg ,
    uint8_t washCleanCam_W_R0_arg ,
    uint8_t washCleanCam_N_F_arg ,
    uint8_t washCleanLidar_R_arg ,
    uint8_t washCleanLidar_B_arg ,
    uint8_t washCleanLidar_L_arg ,
    uint64_t macAvWasherCleaning_arg 
    ):
    crcAvWasherCleaning { std::move(crcAvWasherCleaning_arg) } // NOLINT
      ,alivAvWasherCleaning { std::move(alivAvWasherCleaning_arg) } // NOLINT
      ,washCleanCam_M_F { std::move(washCleanCam_M_F_arg) } // NOLINT
      ,washCleanCam_W_F { std::move(washCleanCam_W_F_arg) } // NOLINT
      ,washCleanLidar_F { std::move(washCleanLidar_F_arg) } // NOLINT
      ,washCleanLidar_T { std::move(washCleanLidar_T_arg) } // NOLINT
      ,washCleanCam_M_L0 { std::move(washCleanCam_M_L0_arg) } // NOLINT
      ,washCleanCam_W_L0 { std::move(washCleanCam_W_L0_arg) } // NOLINT
      ,washCleanCam_M_L1 { std::move(washCleanCam_M_L1_arg) } // NOLINT
      ,washCleanCam_M_L2 { std::move(washCleanCam_M_L2_arg) } // NOLINT
      ,washCleanCam_M_B { std::move(washCleanCam_M_B_arg) } // NOLINT
      ,washCleanCam_W_B { std::move(washCleanCam_W_B_arg) } // NOLINT
      ,washCleanCam_M_R2 { std::move(washCleanCam_M_R2_arg) } // NOLINT
      ,washCleanCam_M_R1 { std::move(washCleanCam_M_R1_arg) } // NOLINT
      ,washCleanCam_M_R0 { std::move(washCleanCam_M_R0_arg) } // NOLINT
      ,washCleanCam_W_R0 { std::move(washCleanCam_W_R0_arg) } // NOLINT
      ,washCleanCam_N_F { std::move(washCleanCam_N_F_arg) } // NOLINT
      ,washCleanLidar_R { std::move(washCleanLidar_R_arg) } // NOLINT
      ,washCleanLidar_B { std::move(washCleanLidar_B_arg) } // NOLINT
      ,washCleanLidar_L { std::move(washCleanLidar_L_arg) } // NOLINT
      ,macAvWasherCleaning { std::move(macAvWasherCleaning_arg) } // NOLINT
      {
}

AvWasherCleaning::AvWasherCleaning(const AvWasherCleaning&) = default;

// NOLINTNEXTLINE
AvWasherCleaning::AvWasherCleaning(AvWasherCleaning&&) = default;

AvWasherCleaning& AvWasherCleaning::operator=(const AvWasherCleaning&) = default;

// NOLINTNEXTLINE
AvWasherCleaning& AvWasherCleaning::operator=(AvWasherCleaning&&) = default;

void AvWasherCleaning::toCsv(std::ostream& out) const
{
    out.precision(16);
    out << std::boolalpha;
    out << crcAvWasherCleaning;out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(alivAvWasherCleaning);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washCleanCam_M_F);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washCleanCam_W_F);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washCleanLidar_F);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washCleanLidar_T);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washCleanCam_M_L0);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washCleanCam_W_L0);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washCleanCam_M_L1);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washCleanCam_M_L2);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washCleanCam_M_B);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washCleanCam_W_B);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washCleanCam_M_R2);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washCleanCam_M_R1);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washCleanCam_M_R0);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washCleanCam_W_R0);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washCleanCam_N_F);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washCleanLidar_R);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washCleanLidar_B);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washCleanLidar_L);out << ",";
    out << macAvWasherCleaning;
    
}

std::stringstream AvWasherCleaning::toStringstream() const
{
    std::stringstream out;
    toCsv(out);
    return out;
}

template<class Archive>
    void AvWasherCleaning::serialize(Archive& ar, [[maybe_unused]] unsigned int version)
    {

        ar& CEREAL_NVP(crcAvWasherCleaning);
        ar& CEREAL_NVP(alivAvWasherCleaning);
        ar& CEREAL_NVP(washCleanCam_M_F);
        ar& CEREAL_NVP(washCleanCam_W_F);
        ar& CEREAL_NVP(washCleanLidar_F);
        ar& CEREAL_NVP(washCleanLidar_T);
        ar& CEREAL_NVP(washCleanCam_M_L0);
        ar& CEREAL_NVP(washCleanCam_W_L0);
        ar& CEREAL_NVP(washCleanCam_M_L1);
        ar& CEREAL_NVP(washCleanCam_M_L2);
        ar& CEREAL_NVP(washCleanCam_M_B);
        ar& CEREAL_NVP(washCleanCam_W_B);
        ar& CEREAL_NVP(washCleanCam_M_R2);
        ar& CEREAL_NVP(washCleanCam_M_R1);
        ar& CEREAL_NVP(washCleanCam_M_R0);
        ar& CEREAL_NVP(washCleanCam_W_R0);
        ar& CEREAL_NVP(washCleanCam_N_F);
        ar& CEREAL_NVP(washCleanLidar_R);
        ar& CEREAL_NVP(washCleanLidar_B);
        ar& CEREAL_NVP(washCleanLidar_L);
        ar& CEREAL_NVP(macAvWasherCleaning);
    }


template void AvWasherCleaning::serialize(cereal::BinaryInputArchive& ar, unsigned int version);
template void AvWasherCleaning::serialize(cereal::BinaryOutputArchive& ar, unsigned int version);
template void AvWasherCleaning::serialize(cereal::IntrospectionArchive& ar, unsigned int version);
template void AvWasherCleaning::serialize(cereal::JSONInputArchive& ar, unsigned int version);
template void AvWasherCleaning::serialize(cereal::JSONOutputArchive& ar, unsigned int version);
template void AvWasherCleaning::serialize(cereal::PortableBinaryInputArchive& ar, unsigned int version);
template void AvWasherCleaning::serialize(cereal::PortableBinaryOutputArchive& ar, unsigned int version);

std::ostream& operator<< (std::ostream& os, const AvWasherCleaning& avwashercleaning)
{
    avwashercleaning.toCsv(os);
    return os;
}

bool operator== (const AvWasherCleaning &lhs, const AvWasherCleaning &rhs)
{
    return (  lhs.crcAvWasherCleaning== rhs.crcAvWasherCleaning &&
     lhs.alivAvWasherCleaning== rhs.alivAvWasherCleaning &&
     lhs.washCleanCam_M_F== rhs.washCleanCam_M_F &&
     lhs.washCleanCam_W_F== rhs.washCleanCam_W_F &&
     lhs.washCleanLidar_F== rhs.washCleanLidar_F &&
     lhs.washCleanLidar_T== rhs.washCleanLidar_T &&
     lhs.washCleanCam_M_L0== rhs.washCleanCam_M_L0 &&
     lhs.washCleanCam_W_L0== rhs.washCleanCam_W_L0 &&
     lhs.washCleanCam_M_L1== rhs.washCleanCam_M_L1 &&
     lhs.washCleanCam_M_L2== rhs.washCleanCam_M_L2 &&
     lhs.washCleanCam_M_B== rhs.washCleanCam_M_B &&
     lhs.washCleanCam_W_B== rhs.washCleanCam_W_B &&
     lhs.washCleanCam_M_R2== rhs.washCleanCam_M_R2 &&
     lhs.washCleanCam_M_R1== rhs.washCleanCam_M_R1 &&
     lhs.washCleanCam_M_R0== rhs.washCleanCam_M_R0 &&
     lhs.washCleanCam_W_R0== rhs.washCleanCam_W_R0 &&
     lhs.washCleanCam_N_F== rhs.washCleanCam_N_F &&
     lhs.washCleanLidar_R== rhs.washCleanLidar_R &&
     lhs.washCleanLidar_B== rhs.washCleanLidar_B &&
     lhs.washCleanLidar_L== rhs.washCleanLidar_L &&
     lhs.macAvWasherCleaning== rhs.macAvWasherCleaning 
    );
}

std::size_t AvWasherCleaning::hash() const noexcept
{
    std::size_t result = 17;
    result = result * 31 + std::hash<uint16_t>()(crcAvWasherCleaning);
    result = result * 31 + std::hash<uint8_t>()(alivAvWasherCleaning);
    result = result * 31 + std::hash<uint8_t>()(washCleanCam_M_F);
    result = result * 31 + std::hash<uint8_t>()(washCleanCam_W_F);
    result = result * 31 + std::hash<uint8_t>()(washCleanLidar_F);
    result = result * 31 + std::hash<uint8_t>()(washCleanLidar_T);
    result = result * 31 + std::hash<uint8_t>()(washCleanCam_M_L0);
    result = result * 31 + std::hash<uint8_t>()(washCleanCam_W_L0);
    result = result * 31 + std::hash<uint8_t>()(washCleanCam_M_L1);
    result = result * 31 + std::hash<uint8_t>()(washCleanCam_M_L2);
    result = result * 31 + std::hash<uint8_t>()(washCleanCam_M_B);
    result = result * 31 + std::hash<uint8_t>()(washCleanCam_W_B);
    result = result * 31 + std::hash<uint8_t>()(washCleanCam_M_R2);
    result = result * 31 + std::hash<uint8_t>()(washCleanCam_M_R1);
    result = result * 31 + std::hash<uint8_t>()(washCleanCam_M_R0);
    result = result * 31 + std::hash<uint8_t>()(washCleanCam_W_R0);
    result = result * 31 + std::hash<uint8_t>()(washCleanCam_N_F);
    result = result * 31 + std::hash<uint8_t>()(washCleanLidar_R);
    result = result * 31 + std::hash<uint8_t>()(washCleanLidar_B);
    result = result * 31 + std::hash<uint8_t>()(washCleanLidar_L);
    result = result * 31 + std::hash<uint64_t>()(macAvWasherCleaning);
    return result;
}

 } // namespace av
 } // namespace msg


CEREAL_BIND_TO_ARCHIVES(av::msg::AvWasherCleaning)

