/*!
 ***********************************************************************************************************************
 * APTIV PRIVILEGED AND CONFIDENTIAL
 *
 * THIS IS AN AUTO GENERATED FILE!
 * DO NOT EDIT BY HAND!
 * check platform/idl_generator/jinja_templates/struct.template
 *
 * @brief Auto Generated Cereal Interface
 *
 * @section License
 *
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTE: Removing this heading is prohibited.
 *
 * @section Open Source License List
 *
 * This is a list of any open-source project used by this file.
 ***********************************************************************************************************************
 */

#ifndef _BASELABSDIAGNOSTICDATA_H_
#define _BASELABSDIAGNOSTICDATA_H_

#include <ODatum/ODatum.h>
#include <interfaces/traits/csvable.h>

#include <interfaces/BaselabsDiagnosticDataDefinitions.hpp>






 namespace safetyhigh {


class EgoMotionState
    : public csvable
    , public aptv::ODatum
{
public:
    EgoMotionState();

    EgoMotionState(
        float yaw_rate_arg ,
        float velocity_arg ,
        float acceleration_arg ,
        uint64_t measurement_time_stamp_arg ,
        uint64_t arrival_time_stamp_arg ,
        bool invalid_status_arg 
        );

    EgoMotionState(const EgoMotionState&);

    // NOLINTNEXTLINE
    EgoMotionState(EgoMotionState&&);

    EgoMotionState& operator=(const EgoMotionState&);

    // NOLINTNEXTLINE
    EgoMotionState& operator=(EgoMotionState&&);

    
    float yaw_rate
    {};
    float velocity
    {};
    float acceleration
    {};
    uint64_t measurement_time_stamp
    {};
    uint64_t arrival_time_stamp
    {};
    bool invalid_status
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const EgoMotionState& egomotionstate);

    friend bool operator== (const EgoMotionState &lhs, const EgoMotionState &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace safetyhigh


template<> struct std::hash<safetyhigh::EgoMotionState>
{
    std::size_t operator()(safetyhigh::EgoMotionState const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(safetyhigh::EgoMotionState, 1)
ODATUM_NAMED_TYPE(safetyhigh::EgoMotionState)

 namespace safetyhigh {


class EgoMotion
    : public csvable
    , public aptv::ODatum
{
public:
    EgoMotion();

    EgoMotion(
        EgoMotionState ego_motion_state_data_arg ,
        uint64_t last_update_time_arg 
        );

    EgoMotion(const EgoMotion&);

    // NOLINTNEXTLINE
    EgoMotion(EgoMotion&&);

    EgoMotion& operator=(const EgoMotion&);

    // NOLINTNEXTLINE
    EgoMotion& operator=(EgoMotion&&);

    
    EgoMotionState ego_motion_state_data
    {};
    uint64_t last_update_time
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const EgoMotion& egomotion);

    friend bool operator== (const EgoMotion &lhs, const EgoMotion &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace safetyhigh


template<> struct std::hash<safetyhigh::EgoMotion>
{
    std::size_t operator()(safetyhigh::EgoMotion const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(safetyhigh::EgoMotion, 1)
ODATUM_NAMED_TYPE(safetyhigh::EgoMotion)

 namespace safetyhigh {


class OccupancyGrid
    : public csvable
    , public aptv::ODatum
{
public:
    OccupancyGrid();

    OccupancyGrid(
        float cell_size_x_arg ,
        float cell_size_y_arg ,
        uint32_t cell_count_x_arg ,
        uint32_t cell_count_y_arg ,
        float size_x_arg ,
        float size_y_arg ,
        float reference_point_in_grid_x_arg ,
        float reference_point_in_grid_y_arg ,
        float reference_point_in_world_x_arg ,
        float reference_point_in_world_y_arg ,
        float ego_position_diff_x_arg ,
        float ego_position_diff_y_arg ,
        float ego_heading_arg ,
        std::vector<float> grid_cell_occupancies_arg ,
        uint64_t time_stamp_arg 
        );

    OccupancyGrid(const OccupancyGrid&);

    // NOLINTNEXTLINE
    OccupancyGrid(OccupancyGrid&&);

    OccupancyGrid& operator=(const OccupancyGrid&);

    // NOLINTNEXTLINE
    OccupancyGrid& operator=(OccupancyGrid&&);

    
    float cell_size_x
    {};
    float cell_size_y
    {};
    uint32_t cell_count_x
    {};
    uint32_t cell_count_y
    {};
    float size_x
    {};
    float size_y
    {};
    float reference_point_in_grid_x
    {};
    float reference_point_in_grid_y
    {};
    float reference_point_in_world_x
    {};
    float reference_point_in_world_y
    {};
    float ego_position_diff_x
    {};
    float ego_position_diff_y
    {};
    float ego_heading
    {};
    std::vector<float> grid_cell_occupancies
    {};
    uint64_t time_stamp
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const OccupancyGrid& occupancygrid);

    friend bool operator== (const OccupancyGrid &lhs, const OccupancyGrid &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace safetyhigh


template<> struct std::hash<safetyhigh::OccupancyGrid>
{
    std::size_t operator()(safetyhigh::OccupancyGrid const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(safetyhigh::OccupancyGrid, 1)
ODATUM_NAMED_TYPE(safetyhigh::OccupancyGrid)

 namespace safetyhigh {


class Track
    : public csvable
    , public aptv::ODatum
{
public:
    Track();

    Track(
        uint64_t id_arg ,
        float existence_probability_arg ,
        float x_arg ,
        float y_arg ,
        float v_x_arg ,
        float v_y_arg ,
        float a_x_arg ,
        float a_y_arg ,
        float length_arg ,
        float length_variance_arg ,
        float width_arg ,
        float width_variance_arg ,
        std::vector<float> covariance_arg 
        );

    Track(const Track&);

    // NOLINTNEXTLINE
    Track(Track&&);

    Track& operator=(const Track&);

    // NOLINTNEXTLINE
    Track& operator=(Track&&);

    
    uint64_t id
    {};
    float existence_probability
    {};
    float x
    {};
    float y
    {};
    float v_x
    {};
    float v_y
    {};
    float a_x
    {};
    float a_y
    {};
    float length
    {};
    float length_variance
    {};
    float width
    {};
    float width_variance
    {};
    std::vector<float> covariance
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const Track& track);

    friend bool operator== (const Track &lhs, const Track &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace safetyhigh


template<> struct std::hash<safetyhigh::Track>
{
    std::size_t operator()(safetyhigh::Track const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(safetyhigh::Track, 1)
ODATUM_NAMED_TYPE(safetyhigh::Track)

 namespace safetyhigh {


class TrackListData
    : public csvable
    , public aptv::ODatum
{
public:
    TrackListData();

    TrackListData(
        uint32_t number_of_tracks_arg ,
        std::vector<Track> track_list_arg ,
        uint64_t time_stamp_arg 
        );

    TrackListData(const TrackListData&);

    // NOLINTNEXTLINE
    TrackListData(TrackListData&&);

    TrackListData& operator=(const TrackListData&);

    // NOLINTNEXTLINE
    TrackListData& operator=(TrackListData&&);

    
    uint32_t number_of_tracks
    {};
    std::vector<Track> track_list
    {};
    uint64_t time_stamp
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const TrackListData& tracklistdata);

    friend bool operator== (const TrackListData &lhs, const TrackListData &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace safetyhigh


template<> struct std::hash<safetyhigh::TrackListData>
{
    std::size_t operator()(safetyhigh::TrackListData const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(safetyhigh::TrackListData, 1)
ODATUM_NAMED_TYPE(safetyhigh::TrackListData)

 namespace safetyhigh {


class LongitudinalBrakingRequest
    : public csvable
    , public aptv::ODatum
{
public:
    LongitudinalBrakingRequest();

    LongitudinalBrakingRequest(
        BRAKING_REQ braking_request_arg ,
        uint64_t track_id_arg ,
        uint64_t grid_cell_index_arg ,
        uint64_t time_stamp_arg 
        );

    LongitudinalBrakingRequest(const LongitudinalBrakingRequest&);

    // NOLINTNEXTLINE
    LongitudinalBrakingRequest(LongitudinalBrakingRequest&&);

    LongitudinalBrakingRequest& operator=(const LongitudinalBrakingRequest&);

    // NOLINTNEXTLINE
    LongitudinalBrakingRequest& operator=(LongitudinalBrakingRequest&&);

    
    BRAKING_REQ braking_request
    {};
    uint64_t track_id
    {};
    uint64_t grid_cell_index
    {};
    uint64_t time_stamp
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const LongitudinalBrakingRequest& longitudinalbrakingrequest);

    friend bool operator== (const LongitudinalBrakingRequest &lhs, const LongitudinalBrakingRequest &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace safetyhigh


template<> struct std::hash<safetyhigh::LongitudinalBrakingRequest>
{
    std::size_t operator()(safetyhigh::LongitudinalBrakingRequest const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(safetyhigh::LongitudinalBrakingRequest, 1)
ODATUM_NAMED_TYPE(safetyhigh::LongitudinalBrakingRequest)



 namespace safetyhigh {


class BaselabsDiagnosticData
    : public csvable
    , public aptv::ODatum
{
public:
    BaselabsDiagnosticData();

    BaselabsDiagnosticData(
        EgoMotion ego_motion_grid_arg ,
        EgoMotion ego_motion_tracks_arg ,
        OccupancyGrid diag_occupancy_grid_arg ,
        TrackListData diag_track_list_arg ,
        LongitudinalBrakingRequest braking_request_obsa_arg ,
        LongitudinalBrakingRequest braking_request_sbsa_arg ,
        LongitudinalBrakingRequest braking_request_dm_arg ,
        uint64_t last_update_time_grid_arg ,
        uint64_t last_update_time_tracks_arg ,
        uint64_t time_stamp_arg 
        );

    BaselabsDiagnosticData(const BaselabsDiagnosticData&);

    // NOLINTNEXTLINE
    BaselabsDiagnosticData(BaselabsDiagnosticData&&);

    BaselabsDiagnosticData& operator=(const BaselabsDiagnosticData&);

    // NOLINTNEXTLINE
    BaselabsDiagnosticData& operator=(BaselabsDiagnosticData&&);

    
    EgoMotion ego_motion_grid
    {};
    EgoMotion ego_motion_tracks
    {};
    OccupancyGrid diag_occupancy_grid
    {};
    TrackListData diag_track_list
    {};
    LongitudinalBrakingRequest braking_request_obsa
    {};
    LongitudinalBrakingRequest braking_request_sbsa
    {};
    LongitudinalBrakingRequest braking_request_dm
    {};
    uint64_t last_update_time_grid
    {};
    uint64_t last_update_time_tracks
    {};
    uint64_t time_stamp
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const BaselabsDiagnosticData& baselabsdiagnosticdata);

    friend bool operator== (const BaselabsDiagnosticData &lhs, const BaselabsDiagnosticData &rhs);

    template<class Archive>
    void serialize([[maybe_unused]] Archive& ar, [[maybe_unused]] unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace safetyhigh


template<> struct std::hash<safetyhigh::BaselabsDiagnosticData>
{
    std::size_t operator()(safetyhigh::BaselabsDiagnosticData const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(safetyhigh::BaselabsDiagnosticData, 1)
ODATUM_NAMED_TYPE(safetyhigh::BaselabsDiagnosticData)



#endif // _BASELABSDIAGNOSTICDATA_H_
