#include <interfaces/CopyProgressResponse_avt/CopyProgressResponse_avt.h>

#include <iterator>
#include <type_traits>

#include <cereal/cereal.hpp>
#include <cereal/archives/json.hpp>
#include <cereal/archives/binary.hpp>

#include <cereal/types/map.hpp>
#include <cereal/types/vector.hpp>
#include <cereal/types/array.hpp>
#include <cereal/types/string.hpp>
#include <cereal/types/complex.hpp>

#include <ODatum/IntrospectionArchive.h>
#include <ODatum/Hash.h>





 namespace av {
 namespace msg {


CopyProgressResponse_avt::CopyProgressResponse_avt() = default;

CopyProgressResponse_avt::CopyProgressResponse_avt(
    ResponseType type_arg ,
    std::string sender_arg ,
    std::string recipient_arg ,
    uint64_t currentProgress_arg 
    ):
    type { std::move(type_arg) } // NOLINT
      ,sender { std::move(sender_arg) } // NOLINT
      ,recipient { std::move(recipient_arg) } // NOLINT
      ,currentProgress { std::move(currentProgress_arg) } // NOLINT
      {
}

CopyProgressResponse_avt::CopyProgressResponse_avt(const CopyProgressResponse_avt&) = default;

// NOLINTNEXTLINE
CopyProgressResponse_avt::CopyProgressResponse_avt(CopyProgressResponse_avt&&) = default;

CopyProgressResponse_avt& CopyProgressResponse_avt::operator=(const CopyProgressResponse_avt&) = default;

// NOLINTNEXTLINE
CopyProgressResponse_avt& CopyProgressResponse_avt::operator=(CopyProgressResponse_avt&&) = default;

void CopyProgressResponse_avt::toCsv(std::ostream& out) const
{
    out.precision(16);
    out << std::boolalpha;
    out << static_cast<uint32_t>(type);out << ",";
    out << "\"";
        out << sender;
        out << "\"";out << ",";
    out << "\"";
        out << recipient;
        out << "\"";out << ",";
    out << currentProgress;
    
}

std::stringstream CopyProgressResponse_avt::toStringstream() const
{
    std::stringstream out;
    toCsv(out);
    return out;
}

template<class Archive>
    void CopyProgressResponse_avt::serialize(Archive& ar, [[maybe_unused]] unsigned int version)
    {

        ar& CEREAL_NVP(type);
        ar& CEREAL_NVP(sender);
        ar& CEREAL_NVP(recipient);
        ar& CEREAL_NVP(currentProgress);
    }


template void CopyProgressResponse_avt::serialize(cereal::BinaryInputArchive& ar, unsigned int version);
template void CopyProgressResponse_avt::serialize(cereal::BinaryOutputArchive& ar, unsigned int version);
template void CopyProgressResponse_avt::serialize(cereal::IntrospectionArchive& ar, unsigned int version);
template void CopyProgressResponse_avt::serialize(cereal::JSONInputArchive& ar, unsigned int version);
template void CopyProgressResponse_avt::serialize(cereal::JSONOutputArchive& ar, unsigned int version);
template void CopyProgressResponse_avt::serialize(cereal::PortableBinaryInputArchive& ar, unsigned int version);
template void CopyProgressResponse_avt::serialize(cereal::PortableBinaryOutputArchive& ar, unsigned int version);

std::ostream& operator<< (std::ostream& os, const CopyProgressResponse_avt& copyprogressresponse_avt)
{
    copyprogressresponse_avt.toCsv(os);
    return os;
}

bool operator== (const CopyProgressResponse_avt &lhs, const CopyProgressResponse_avt &rhs)
{
    return (  lhs.type== rhs.type &&
     lhs.sender== rhs.sender &&
     lhs.recipient== rhs.recipient &&
     lhs.currentProgress== rhs.currentProgress 
    );
}

std::size_t CopyProgressResponse_avt::hash() const noexcept
{
    std::size_t result = 17;
    result = result * 31 + std::hash<ResponseType>()(type);
    result = result * 31 + std::hash<std::string>()(sender);
    result = result * 31 + std::hash<std::string>()(recipient);
    result = result * 31 + std::hash<uint64_t>()(currentProgress);
    return result;
}

 } // namespace av
 } // namespace msg


CEREAL_BIND_TO_ARCHIVES(av::msg::CopyProgressResponse_avt)

