/*!
 ***********************************************************************************************************************
 * APTIV PRIVILEGED AND CONFIDENTIAL
 *
 * THIS IS AN AUTO GENERATED FILE!
 * DO NOT EDIT BY HAND!
 * check platform/idl_generator/jinja_templates/struct.template
 *
 * @brief Auto Generated Cereal Interface
 *
 * @section License
 *
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTE: Removing this heading is prohibited.
 *
 * @section Open Source License List
 *
 * This is a list of any open-source project used by this file.
 ***********************************************************************************************************************
 */

#ifndef _CUSTOMDRAWING_H_
#define _CUSTOMDRAWING_H_

#include <ODatum/ODatum.h>
#include <interfaces/traits/csvable.h>

#include <interfaces/PlannerCustomDrawingDefinitions.hpp>






 namespace av {
 namespace msg {
 namespace planner {


class Color
    : public csvable
    , public aptv::ODatum
{
public:
    Color();

    Color(
        float r_arg ,
        float g_arg ,
        float b_arg ,
        float a_arg 
        );

    Color(const Color&);

    // NOLINTNEXTLINE
    Color(Color&&);

    Color& operator=(const Color&);

    // NOLINTNEXTLINE
    Color& operator=(Color&&);

    
    float r
    {};
    float g
    {};
    float b
    {};
    float a
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const Color& color);

    friend bool operator== (const Color &lhs, const Color &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace planner


template<> struct std::hash<av::msg::planner::Color>
{
    std::size_t operator()(av::msg::planner::Color const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::planner::Color, 1)
ODATUM_NAMED_TYPE(av::msg::planner::Color)

 namespace av {
 namespace msg {
 namespace planner {


class Point
    : public csvable
    , public aptv::ODatum
{
public:
    Point();

    Point(
        double x_arg ,
        double y_arg ,
        double z_arg 
        );

    Point(const Point&);

    // NOLINTNEXTLINE
    Point(Point&&);

    Point& operator=(const Point&);

    // NOLINTNEXTLINE
    Point& operator=(Point&&);

    
    double x
    {};
    double y
    {};
    double z
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const Point& point);

    friend bool operator== (const Point &lhs, const Point &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace planner


template<> struct std::hash<av::msg::planner::Point>
{
    std::size_t operator()(av::msg::planner::Point const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::planner::Point, 1)
ODATUM_NAMED_TYPE(av::msg::planner::Point)

 namespace av {
 namespace msg {
 namespace planner {


class DrawingPoint
    : public csvable
    , public aptv::ODatum
{
public:
    DrawingPoint();

    DrawingPoint(
        Point vertex_arg ,
        Color color_arg ,
        float size_arg 
        );

    DrawingPoint(const DrawingPoint&);

    // NOLINTNEXTLINE
    DrawingPoint(DrawingPoint&&);

    DrawingPoint& operator=(const DrawingPoint&);

    // NOLINTNEXTLINE
    DrawingPoint& operator=(DrawingPoint&&);

    
    Point vertex
    {};
    Color color
    {};
    float size
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const DrawingPoint& drawingpoint);

    friend bool operator== (const DrawingPoint &lhs, const DrawingPoint &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace planner


template<> struct std::hash<av::msg::planner::DrawingPoint>
{
    std::size_t operator()(av::msg::planner::DrawingPoint const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::planner::DrawingPoint, 1)
ODATUM_NAMED_TYPE(av::msg::planner::DrawingPoint)

 namespace av {
 namespace msg {
 namespace planner {


class DrawingLine
    : public csvable
    , public aptv::ODatum
{
public:
    DrawingLine();

    DrawingLine(
        Point start_arg ,
        Point end_arg ,
        Color color_arg ,
        float width_arg 
        );

    DrawingLine(const DrawingLine&);

    // NOLINTNEXTLINE
    DrawingLine(DrawingLine&&);

    DrawingLine& operator=(const DrawingLine&);

    // NOLINTNEXTLINE
    DrawingLine& operator=(DrawingLine&&);

    
    Point start
    {};
    Point end
    {};
    Color color
    {};
    float width
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const DrawingLine& drawingline);

    friend bool operator== (const DrawingLine &lhs, const DrawingLine &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace planner


template<> struct std::hash<av::msg::planner::DrawingLine>
{
    std::size_t operator()(av::msg::planner::DrawingLine const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::planner::DrawingLine, 1)
ODATUM_NAMED_TYPE(av::msg::planner::DrawingLine)



 namespace av {
 namespace msg {
 namespace planner {


class CustomDrawing
    : public csvable
    , public aptv::ODatum
{
public:
    CustomDrawing();

    CustomDrawing(
        std::vector<DrawingPoint> points_arg ,
        std::vector<DrawingLine> lines_arg 
        );

    CustomDrawing(const CustomDrawing&);

    // NOLINTNEXTLINE
    CustomDrawing(CustomDrawing&&);

    CustomDrawing& operator=(const CustomDrawing&);

    // NOLINTNEXTLINE
    CustomDrawing& operator=(CustomDrawing&&);

    
    std::vector<DrawingPoint> points
    {};
    std::vector<DrawingLine> lines
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const CustomDrawing& customdrawing);

    friend bool operator== (const CustomDrawing &lhs, const CustomDrawing &rhs);

    template<class Archive>
    void serialize([[maybe_unused]] Archive& ar, [[maybe_unused]] unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace planner


template<> struct std::hash<av::msg::planner::CustomDrawing>
{
    std::size_t operator()(av::msg::planner::CustomDrawing const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::planner::CustomDrawing, 1)
ODATUM_NAMED_TYPE(av::msg::planner::CustomDrawing)



#endif // _CUSTOMDRAWING_H_
