#include <interfaces/DeviceConfigReport/DeviceConfigReport.h>

#include <iterator>
#include <type_traits>

#include <cereal/cereal.hpp>
#include <cereal/archives/json.hpp>
#include <cereal/archives/binary.hpp>

#include <cereal/types/map.hpp>
#include <cereal/types/vector.hpp>
#include <cereal/types/array.hpp>
#include <cereal/types/string.hpp>
#include <cereal/types/complex.hpp>

#include <ODatum/IntrospectionArchive.h>
#include <ODatum/Hash.h>





 namespace av {
 namespace msg {


DeviceConfigReport::DeviceConfigReport() = default;

DeviceConfigReport::DeviceConfigReport(
    std::string deviceReport_arg 
    ):
    deviceReport { std::move(deviceReport_arg) } // NOLINT
      {
}

DeviceConfigReport::DeviceConfigReport(const DeviceConfigReport&) = default;

// NOLINTNEXTLINE
DeviceConfigReport::DeviceConfigReport(DeviceConfigReport&&) = default;

DeviceConfigReport& DeviceConfigReport::operator=(const DeviceConfigReport&) = default;

// NOLINTNEXTLINE
DeviceConfigReport& DeviceConfigReport::operator=(DeviceConfigReport&&) = default;

void DeviceConfigReport::toCsv(std::ostream& out) const
{
    out.precision(16);
    out << std::boolalpha;
    out << "\"";
        out << deviceReport;
        out << "\"";
    
}

std::stringstream DeviceConfigReport::toStringstream() const
{
    std::stringstream out;
    toCsv(out);
    return out;
}

template<class Archive>
    void DeviceConfigReport::serialize(Archive& ar, [[maybe_unused]] unsigned int version)
    {

        ar& CEREAL_NVP(deviceReport);
    }


template void DeviceConfigReport::serialize(cereal::BinaryInputArchive& ar, unsigned int version);
template void DeviceConfigReport::serialize(cereal::BinaryOutputArchive& ar, unsigned int version);
template void DeviceConfigReport::serialize(cereal::IntrospectionArchive& ar, unsigned int version);
template void DeviceConfigReport::serialize(cereal::JSONInputArchive& ar, unsigned int version);
template void DeviceConfigReport::serialize(cereal::JSONOutputArchive& ar, unsigned int version);
template void DeviceConfigReport::serialize(cereal::PortableBinaryInputArchive& ar, unsigned int version);
template void DeviceConfigReport::serialize(cereal::PortableBinaryOutputArchive& ar, unsigned int version);

std::ostream& operator<< (std::ostream& os, const DeviceConfigReport& deviceconfigreport)
{
    deviceconfigreport.toCsv(os);
    return os;
}

bool operator== (const DeviceConfigReport &lhs, const DeviceConfigReport &rhs)
{
    return (  lhs.deviceReport== rhs.deviceReport 
    );
}

std::size_t DeviceConfigReport::hash() const noexcept
{
    std::size_t result = 17;
    result = result * 31 + std::hash<std::string>()(deviceReport);
    return result;
}

 } // namespace av
 } // namespace msg


CEREAL_BIND_TO_ARCHIVES(av::msg::DeviceConfigReport)

