/*!
 ***********************************************************************************************************************
 * APTIV PRIVILEGED AND CONFIDENTIAL
 *
 * THIS IS AN AUTO GENERATED FILE!
 * DO NOT EDIT BY HAND!
 * check platform/idl_generator/jinja_templates/struct.template
 *
 * @brief Auto Generated Cereal Interface
 *
 * @section License
 *
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTE: Removing this heading is prohibited.
 *
 * @section Open Source License List
 *
 * This is a list of any open-source project used by this file.
 ***********************************************************************************************************************
 */

#ifndef _DSRCMESSAGE_H_
#define _DSRCMESSAGE_H_

#include <ODatum/ODatum.h>
#include <interfaces/traits/csvable.h>

#include <interfaces/DSRCMessageDefinitions.hpp>


#include <interfaces/TimePoint/TimePoint.h>

#include <interfaces/MultiIntersectionTLStatus/MultiIntersectionTLStatus.h>





 namespace av {
 namespace msg {


class Signal
    : public csvable
    , public aptv::ODatum
{
public:
    Signal();

    Signal(
        uint64_t signalId_arg ,
        LIGHT_COLOR color_arg ,
        LIGHT_SHAPE shape_arg ,
        LIGHT_STATE state_arg 
        );

    Signal(const Signal&);

    // NOLINTNEXTLINE
    Signal(Signal&&);

    Signal& operator=(const Signal&);

    // NOLINTNEXTLINE
    Signal& operator=(Signal&&);

    
    uint64_t signalId
    {};
    LIGHT_COLOR color
    {};
    LIGHT_SHAPE shape
    {};
    LIGHT_STATE state
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const Signal& signal);

    friend bool operator== (const Signal &lhs, const Signal &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::Signal>
{
    std::size_t operator()(av::msg::Signal const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::Signal, 1)
ODATUM_NAMED_TYPE(av::msg::Signal)

 namespace av {
 namespace msg {


class IntersectionState
    : public csvable
    , public aptv::ODatum
{
public:
    IntersectionState();

    IntersectionState(
        uint64_t intersectionId_arg ,
        std::vector<Signal> signals_arg 
        );

    IntersectionState(const IntersectionState&);

    // NOLINTNEXTLINE
    IntersectionState(IntersectionState&&);

    IntersectionState& operator=(const IntersectionState&);

    // NOLINTNEXTLINE
    IntersectionState& operator=(IntersectionState&&);

    
    uint64_t intersectionId
    {};
    std::vector<Signal> signals
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const IntersectionState& intersectionstate);

    friend bool operator== (const IntersectionState &lhs, const IntersectionState &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::IntersectionState>
{
    std::size_t operator()(av::msg::IntersectionState const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::IntersectionState, 1)
ODATUM_NAMED_TYPE(av::msg::IntersectionState)



 namespace av {
 namespace msg {


class DsrcMessage
    : public csvable
    , public aptv::ODatum
{
public:
    DsrcMessage();

    DsrcMessage(
        TimePoint timestamp_arg ,
        std::vector<IntersectionState> intersectionStates_arg 
        );

    DsrcMessage(const DsrcMessage&);

    // NOLINTNEXTLINE
    DsrcMessage(DsrcMessage&&);

    DsrcMessage& operator=(const DsrcMessage&);

    // NOLINTNEXTLINE
    DsrcMessage& operator=(DsrcMessage&&);

    
    TimePoint timestamp
    {};
    std::vector<IntersectionState> intersectionStates
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const DsrcMessage& dsrcmessage);

    friend bool operator== (const DsrcMessage &lhs, const DsrcMessage &rhs);

    template<class Archive>
    void serialize([[maybe_unused]] Archive& ar, [[maybe_unused]] unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::DsrcMessage>
{
    std::size_t operator()(av::msg::DsrcMessage const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::DsrcMessage, 1)
ODATUM_NAMED_TYPE(av::msg::DsrcMessage)



#endif // _DSRCMESSAGE_H_
