/*!
 ***********************************************************************************************************************
 * APTIV PRIVILEGED AND CONFIDENTIAL
 *
 * THIS IS AN AUTO GENERATED FILE!
 * DO NOT EDIT BY HAND!
 * check platform/idl_generator/jinja_templates/struct.template
 *
 * @brief Auto Generated Cereal Interface
 *
 * @section License
 *
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTE: Removing this heading is prohibited.
 *
 * @section Open Source License List
 *
 * This is a list of any open-source project used by this file.
 ***********************************************************************************************************************
 */

#ifndef _FLRA1RADARDATA_H_
#define _FLRA1RADARDATA_H_

#include <ODatum/ODatum.h>
#include <interfaces/traits/csvable.h>

#include <interfaces/FlrA1RadarDataDefinitions.hpp>


#include <interfaces/TimePoint/TimePoint.h>

#include <interfaces/Vector3d/Vector3d.h>





 namespace av {
 namespace msg {


class RadarDetection
    : public csvable
    , public aptv::ODatum
{
public:
    RadarDetection();

    RadarDetection(
        uint32_t canId_arg ,
        double range_arg ,
        double rangeError_arg ,
        double rangeVelocity_arg ,
        double rangeVelocityError_arg ,
        double unfoldedRangeVelocity_arg ,
        double snr_arg ,
        double crossSection_arg ,
        double elevation_arg ,
        double elevationError_arg ,
        CONFIDENCE_LEVEL elevationConfidence_arg ,
        double azimuth_arg ,
        double azimuthError_arg ,
        CONFIDENCE_LEVEL azimuthConfidence_arg ,
        double azimuthAmbiguityProbability_arg ,
        uint8_t azimuthAmbiguityId_arg ,
        bool vehicleClutter_arg ,
        bool superResTarget_arg ,
        double pointTargetProbability_arg ,
        double existenceProbability_arg ,
        bool outsideSector_arg ,
        std::vector<double> meta_arg ,
        av::geometry::Vector3d positionWrtSensor_arg ,
        av::geometry::Vector3d positionWrtVehicle_arg ,
        av::geometry::Vector3d positionWrtGlobal_arg 
        );

    RadarDetection(const RadarDetection&);

    // NOLINTNEXTLINE
    RadarDetection(RadarDetection&&);

    RadarDetection& operator=(const RadarDetection&);

    // NOLINTNEXTLINE
    RadarDetection& operator=(RadarDetection&&);

    
    uint32_t canId
    {};
    double range
    {};
    double rangeError
    {};
    double rangeVelocity
    {};
    double rangeVelocityError
    {};
    double unfoldedRangeVelocity
    {};
    double snr
    {};
    double crossSection
    {};
    double elevation
    {};
    double elevationError
    {};
    CONFIDENCE_LEVEL elevationConfidence
    {};
    double azimuth
    {};
    double azimuthError
    {};
    CONFIDENCE_LEVEL azimuthConfidence
    {};
    double azimuthAmbiguityProbability
    {};
    uint8_t azimuthAmbiguityId
    {};
    bool vehicleClutter
    {};
    bool superResTarget
    {};
    double pointTargetProbability
    {};
    double existenceProbability
    {};
    bool outsideSector
    {};
    std::vector<double> meta
    {};
    av::geometry::Vector3d positionWrtSensor
    {};
    av::geometry::Vector3d positionWrtVehicle
    {};
    av::geometry::Vector3d positionWrtGlobal
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const RadarDetection& radardetection);

    friend bool operator== (const RadarDetection &lhs, const RadarDetection &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::RadarDetection>
{
    std::size_t operator()(av::msg::RadarDetection const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::RadarDetection, 1)
ODATUM_NAMED_TYPE(av::msg::RadarDetection)



 namespace av {
 namespace msg {


class FlrA1RadarData
    : public csvable
    , public aptv::ODatum
{
public:
    FlrA1RadarData();

    FlrA1RadarData(
        std::string radarName_arg ,
        av::msg::TimePoint sensorTimeStamp_arg ,
        av::msg::TimePoint messageTimeStamp_arg ,
        uint16_t scanIndex_arg ,
        double dopplerCoverage_arg ,
        uint16_t rangeCoverage_arg ,
        double fovHorizontal_arg ,
        double fovVertical_arg ,
        std::vector<RadarDetection> detections_arg ,
        std::vector<double> metaBurst_arg 
        );

    FlrA1RadarData(const FlrA1RadarData&);

    // NOLINTNEXTLINE
    FlrA1RadarData(FlrA1RadarData&&);

    FlrA1RadarData& operator=(const FlrA1RadarData&);

    // NOLINTNEXTLINE
    FlrA1RadarData& operator=(FlrA1RadarData&&);

    
    std::string radarName
    {};
    av::msg::TimePoint sensorTimeStamp
    {};
    av::msg::TimePoint messageTimeStamp
    {};
    uint16_t scanIndex
    {};
    double dopplerCoverage
    {};
    uint16_t rangeCoverage
    {};
    double fovHorizontal
    {};
    double fovVertical
    {};
    std::vector<RadarDetection> detections
    {};
    std::vector<double> metaBurst
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const FlrA1RadarData& flra1radardata);

    friend bool operator== (const FlrA1RadarData &lhs, const FlrA1RadarData &rhs);

    template<class Archive>
    void serialize([[maybe_unused]] Archive& ar, [[maybe_unused]] unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::FlrA1RadarData>
{
    std::size_t operator()(av::msg::FlrA1RadarData const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::FlrA1RadarData, 2)
ODATUM_NAMED_TYPE(av::msg::FlrA1RadarData)



#endif // _FLRA1RADARDATA_H_
