/*!
 ***********************************************************************************************************************
 * APTIV PRIVILEGED AND CONFIDENTIAL
 *
 * THIS IS AN AUTO GENERATED FILE!
 * DO NOT EDIT BY HAND!
 * check platform/idl_generator/jinja_templates/struct.template
 *
 * @brief Auto Generated Cereal Interface
 *
 * @section License
 *
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTE: Removing this heading is prohibited.
 *
 * @section Open Source License List
 *
 * This is a list of any open-source project used by this file.
 ***********************************************************************************************************************
 */

#ifndef _H264FRAMEMETA_H_
#define _H264FRAMEMETA_H_

#include <ODatum/ODatum.h>
#include <interfaces/traits/csvable.h>

#include <interfaces/H264FrameMetaDefinitions.hpp>






 namespace av {
 namespace camera {


class WhiteBalance
    : public csvable
    , public aptv::ODatum
{
public:
    WhiteBalance();

    WhiteBalance(
        uint32_t red_arg ,
        uint32_t green_arg ,
        uint32_t blue_arg 
        );

    WhiteBalance(const WhiteBalance&);

    // NOLINTNEXTLINE
    WhiteBalance(WhiteBalance&&);

    WhiteBalance& operator=(const WhiteBalance&);

    // NOLINTNEXTLINE
    WhiteBalance& operator=(WhiteBalance&&);

    
    uint32_t red
    {};
    uint32_t green
    {};
    uint32_t blue
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const WhiteBalance& whitebalance);

    friend bool operator== (const WhiteBalance &lhs, const WhiteBalance &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace camera


template<> struct std::hash<av::camera::WhiteBalance>
{
    std::size_t operator()(av::camera::WhiteBalance const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::camera::WhiteBalance, 1)
ODATUM_NAMED_TYPE(av::camera::WhiteBalance)

 namespace av {
 namespace camera {


class EmbeddedData
    : public csvable
    , public aptv::ODatum
{
public:
    EmbeddedData();

    EmbeddedData(
        std::array<char,2986> frontEmbeddedDataLine_arg ,
        std::array<char,2986> rearEmbeddedDataLine1_arg ,
        std::array<char,2986> rearEmbeddedDataLine2_arg ,
        std::array<char,2986> rearEmbeddedDataLine3_arg ,
        std::array<char,2986> rearEmbeddedDataLine4_arg ,
        std::array<char,2986> rearEmbeddedDataLine5_arg ,
        std::array<char,2986> rearEmbeddedDataLine6_arg 
        );

    EmbeddedData(const EmbeddedData&);

    // NOLINTNEXTLINE
    EmbeddedData(EmbeddedData&&);

    EmbeddedData& operator=(const EmbeddedData&);

    // NOLINTNEXTLINE
    EmbeddedData& operator=(EmbeddedData&&);

    
    std::array<char,2986> frontEmbeddedDataLine
    {};
    std::array<char,2986> rearEmbeddedDataLine1
    {};
    std::array<char,2986> rearEmbeddedDataLine2
    {};
    std::array<char,2986> rearEmbeddedDataLine3
    {};
    std::array<char,2986> rearEmbeddedDataLine4
    {};
    std::array<char,2986> rearEmbeddedDataLine5
    {};
    std::array<char,2986> rearEmbeddedDataLine6
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const EmbeddedData& embeddeddata);

    friend bool operator== (const EmbeddedData &lhs, const EmbeddedData &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace camera


template<> struct std::hash<av::camera::EmbeddedData>
{
    std::size_t operator()(av::camera::EmbeddedData const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::camera::EmbeddedData, 1)
ODATUM_NAMED_TYPE(av::camera::EmbeddedData)



 namespace av {
 namespace camera {


class H264FrameMeta
    : public csvable
    , public aptv::ODatum
{
public:
    H264FrameMeta();

    H264FrameMeta(
        std::string cameraId_arg ,
        uint16_t width_arg ,
        uint16_t height_arg ,
        PIXEL_FORMAT pixelFormat_arg ,
        TIME_SYNC_STATUS timeSyncStatus_arg ,
        int64_t syncTriggerOffset_us_arg ,
        int64_t captureTime_us_arg ,
        int64_t receiveTime_us_arg ,
        int64_t ingestTime_us_arg ,
        std::array<uint32_t,4> analogGain_arg ,
        std::array<uint32_t,4> digitalGain_arg ,
        WhiteBalance whiteBalance_arg ,
        std::array<uint32_t,4> exposureTime_us_arg ,
        int64_t startOfFrame_us_arg ,
        uint32_t capPts_arg ,
        EmbeddedData embeddedDataLines_arg ,
        std::array<char,40> firmwareHash_arg 
        );

    H264FrameMeta(const H264FrameMeta&);

    // NOLINTNEXTLINE
    H264FrameMeta(H264FrameMeta&&);

    H264FrameMeta& operator=(const H264FrameMeta&);

    // NOLINTNEXTLINE
    H264FrameMeta& operator=(H264FrameMeta&&);

    
    std::string cameraId
    {};
    uint16_t width
    {};
    uint16_t height
    {};
    PIXEL_FORMAT pixelFormat
    {};
    TIME_SYNC_STATUS timeSyncStatus
    {};
    int64_t syncTriggerOffset_us
    {};
    int64_t captureTime_us
    {};
    int64_t receiveTime_us
    {};
    int64_t ingestTime_us
    {};
    std::array<uint32_t,4> analogGain
    {};
    std::array<uint32_t,4> digitalGain
    {};
    WhiteBalance whiteBalance
    {};
    std::array<uint32_t,4> exposureTime_us
    {};
    int64_t startOfFrame_us
    {};
    uint32_t capPts
    {};
    EmbeddedData embeddedDataLines
    {};
    std::array<char,40> firmwareHash
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const H264FrameMeta& h264framemeta);

    friend bool operator== (const H264FrameMeta &lhs, const H264FrameMeta &rhs);

    template<class Archive>
    void serialize([[maybe_unused]] Archive& ar, [[maybe_unused]] unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace camera


template<> struct std::hash<av::camera::H264FrameMeta>
{
    std::size_t operator()(av::camera::H264FrameMeta const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::camera::H264FrameMeta, 3)
ODATUM_NAMED_TYPE(av::camera::H264FrameMeta)



#endif // _H264FRAMEMETA_H_
