/*!
 ***********************************************************************************************************************
 * APTIV PRIVILEGED AND CONFIDENTIAL
 *
 * THIS IS AN AUTO GENERATED FILE!
 * DO NOT EDIT BY HAND!
 * check platform/idl_generator/jinja_templates/struct.template
 *
 * @brief Auto Generated Cereal Interface
 *
 * @section License
 *
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTE: Removing this heading is prohibited.
 *
 * @section Open Source License List
 *
 * This is a list of any open-source project used by this file.
 ***********************************************************************************************************************
 */

#ifndef _HOMOTOPYEXTRACTORDEBUG_H_
#define _HOMOTOPYEXTRACTORDEBUG_H_

#include <ODatum/ODatum.h>
#include <interfaces/traits/csvable.h>

#include <interfaces/HomotopyExtractorDebugDefinitions.hpp>


#include <interfaces/RoutePlanWithStaticConstraints/RoutePlanWithStaticConstraints.h>

#include <interfaces/LocalizationPose/LocalizationPose.h>

#include <interfaces/controller_status_message/controller_status_message.h>

#include <interfaces/Vector3d/Vector3d.h>

#include <interfaces/WorldTrackDecisions/WorldTrackDecisions.h>

#include <interfaces/route_obstacles/route_obstacles.h>





 namespace av {
 namespace msg {
 namespace plan_ctrl {


class MapParams
    : public csvable
    , public aptv::ODatum
{
public:
    MapParams();

    MapParams(
        std::string mapFilePath_arg ,
        std::string mapBuilder_arg ,
        double minRadius_m_arg ,
        double baseLineResolution_m_arg ,
        double crosswalkExtentX_m_arg ,
        double crosswalkExtentY_m_arg 
        );

    MapParams(const MapParams&);

    // NOLINTNEXTLINE
    MapParams(MapParams&&);

    MapParams& operator=(const MapParams&);

    // NOLINTNEXTLINE
    MapParams& operator=(MapParams&&);

    
    std::string mapFilePath
    {};
    std::string mapBuilder
    {};
    double minRadius_m
    {};
    double baseLineResolution_m
    {};
    double crosswalkExtentX_m
    {};
    double crosswalkExtentY_m
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const MapParams& mapparams);

    friend bool operator== (const MapParams &lhs, const MapParams &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace plan_ctrl


template<> struct std::hash<av::msg::plan_ctrl::MapParams>
{
    std::size_t operator()(av::msg::plan_ctrl::MapParams const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::plan_ctrl::MapParams, 1)
ODATUM_NAMED_TYPE(av::msg::plan_ctrl::MapParams)

 namespace av {
 namespace msg {
 namespace plan_ctrl {


class AvtestTrack
    : public csvable
    , public aptv::ODatum
{
public:
    AvtestTrack();

    AvtestTrack(
        bool active_arg ,
        double x_arg ,
        double y_arg ,
        double heading_arg ,
        double width_arg ,
        double length_arg ,
        uint64_t id_arg ,
        double vx_arg ,
        double vy_arg ,
        double acceleration_arg ,
        bool real_arg ,
        double radius_arg 
        );

    AvtestTrack(const AvtestTrack&);

    // NOLINTNEXTLINE
    AvtestTrack(AvtestTrack&&);

    AvtestTrack& operator=(const AvtestTrack&);

    // NOLINTNEXTLINE
    AvtestTrack& operator=(AvtestTrack&&);

    
    bool active
    {};
    double x
    {};
    double y
    {};
    double heading
    {};
    double width
    {};
    double length
    {};
    uint64_t id
    {};
    double vx
    {};
    double vy
    {};
    double acceleration
    {};
    bool real
    {};
    double radius
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const AvtestTrack& avtesttrack);

    friend bool operator== (const AvtestTrack &lhs, const AvtestTrack &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace plan_ctrl


template<> struct std::hash<av::msg::plan_ctrl::AvtestTrack>
{
    std::size_t operator()(av::msg::plan_ctrl::AvtestTrack const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::plan_ctrl::AvtestTrack, 1)
ODATUM_NAMED_TYPE(av::msg::plan_ctrl::AvtestTrack)

 namespace av {
 namespace msg {
 namespace plan_ctrl {


class AvtestConvexHull
    : public csvable
    , public aptv::ODatum
{
public:
    AvtestConvexHull();

    AvtestConvexHull(
        std::vector<av::geometry::Vector3d> hull_arg ,
        av::geometry::Vector3d center_arg ,
        double radius_arg ,
        uint64_t id_arg ,
        double vx_arg ,
        double vy_arg 
        );

    AvtestConvexHull(const AvtestConvexHull&);

    // NOLINTNEXTLINE
    AvtestConvexHull(AvtestConvexHull&&);

    AvtestConvexHull& operator=(const AvtestConvexHull&);

    // NOLINTNEXTLINE
    AvtestConvexHull& operator=(AvtestConvexHull&&);

    
    std::vector<av::geometry::Vector3d> hull
    {};
    av::geometry::Vector3d center
    {};
    double radius
    {};
    uint64_t id
    {};
    double vx
    {};
    double vy
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const AvtestConvexHull& avtestconvexhull);

    friend bool operator== (const AvtestConvexHull &lhs, const AvtestConvexHull &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace plan_ctrl


template<> struct std::hash<av::msg::plan_ctrl::AvtestConvexHull>
{
    std::size_t operator()(av::msg::plan_ctrl::AvtestConvexHull const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::plan_ctrl::AvtestConvexHull, 1)
ODATUM_NAMED_TYPE(av::msg::plan_ctrl::AvtestConvexHull)

 namespace av {
 namespace msg {
 namespace plan_ctrl {


class AvtestWorld
    : public csvable
    , public aptv::ODatum
{
public:
    AvtestWorld();

    AvtestWorld(
        std::vector<AvtestTrack> vehicles_arg ,
        std::vector<AvtestTrack> pedestrians_arg ,
        std::vector<AvtestTrack> bicyclists_arg ,
        std::vector<AvtestConvexHull> genericObjects_arg ,
        std::vector<AvtestConvexHull> constructionZones_arg 
        );

    AvtestWorld(const AvtestWorld&);

    // NOLINTNEXTLINE
    AvtestWorld(AvtestWorld&&);

    AvtestWorld& operator=(const AvtestWorld&);

    // NOLINTNEXTLINE
    AvtestWorld& operator=(AvtestWorld&&);

    
    std::vector<AvtestTrack> vehicles
    {};
    std::vector<AvtestTrack> pedestrians
    {};
    std::vector<AvtestTrack> bicyclists
    {};
    std::vector<AvtestConvexHull> genericObjects
    {};
    std::vector<AvtestConvexHull> constructionZones
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const AvtestWorld& avtestworld);

    friend bool operator== (const AvtestWorld &lhs, const AvtestWorld &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace plan_ctrl


template<> struct std::hash<av::msg::plan_ctrl::AvtestWorld>
{
    std::size_t operator()(av::msg::plan_ctrl::AvtestWorld const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::plan_ctrl::AvtestWorld, 1)
ODATUM_NAMED_TYPE(av::msg::plan_ctrl::AvtestWorld)

 namespace av {
 namespace msg {
 namespace plan_ctrl {


class AvtestDynamicWorld
    : public csvable
    , public aptv::ODatum
{
public:
    AvtestDynamicWorld();

    AvtestDynamicWorld(
        std::vector<AvtestWorld> world_arg ,
        std::vector<int64_t> time_us_arg 
        );

    AvtestDynamicWorld(const AvtestDynamicWorld&);

    // NOLINTNEXTLINE
    AvtestDynamicWorld(AvtestDynamicWorld&&);

    AvtestDynamicWorld& operator=(const AvtestDynamicWorld&);

    // NOLINTNEXTLINE
    AvtestDynamicWorld& operator=(AvtestDynamicWorld&&);

    
    std::vector<AvtestWorld> world
    {};
    std::vector<int64_t> time_us
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const AvtestDynamicWorld& avtestdynamicworld);

    friend bool operator== (const AvtestDynamicWorld &lhs, const AvtestDynamicWorld &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace plan_ctrl


template<> struct std::hash<av::msg::plan_ctrl::AvtestDynamicWorld>
{
    std::size_t operator()(av::msg::plan_ctrl::AvtestDynamicWorld const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::plan_ctrl::AvtestDynamicWorld, 1)
ODATUM_NAMED_TYPE(av::msg::plan_ctrl::AvtestDynamicWorld)

 namespace av {
 namespace msg {
 namespace plan_ctrl {


class EgoStateExtended
    : public csvable
    , public aptv::ODatum
{
public:
    EgoStateExtended();

    EgoStateExtended(
        double rear_axle_x_arg ,
        double rear_axle_y_arg ,
        double rear_axle_heading_arg ,
        double vx_arg ,
        double vy_arg ,
        double ax_arg ,
        double ay_arg ,
        double roadWheelAngle_arg ,
        double angularVelocity_arg ,
        double angularAcceleration_arg ,
        bool isAuto_arg ,
        int64_t time_stamp_arg 
        );

    EgoStateExtended(const EgoStateExtended&);

    // NOLINTNEXTLINE
    EgoStateExtended(EgoStateExtended&&);

    EgoStateExtended& operator=(const EgoStateExtended&);

    // NOLINTNEXTLINE
    EgoStateExtended& operator=(EgoStateExtended&&);

    
    double rear_axle_x
    {};
    double rear_axle_y
    {};
    double rear_axle_heading
    {};
    double vx
    {};
    double vy
    {};
    double ax
    {};
    double ay
    {};
    double roadWheelAngle
    {};
    double angularVelocity
    {};
    double angularAcceleration
    {};
    bool isAuto
    {};
    int64_t time_stamp
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const EgoStateExtended& egostateextended);

    friend bool operator== (const EgoStateExtended &lhs, const EgoStateExtended &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace plan_ctrl


template<> struct std::hash<av::msg::plan_ctrl::EgoStateExtended>
{
    std::size_t operator()(av::msg::plan_ctrl::EgoStateExtended const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::plan_ctrl::EgoStateExtended, 1)
ODATUM_NAMED_TYPE(av::msg::plan_ctrl::EgoStateExtended)



 namespace av {
 namespace msg {
 namespace plan_ctrl {


class HomotopyExtractorDebug
    : public csvable
    , public aptv::ODatum
{
public:
    HomotopyExtractorDebug();

    HomotopyExtractorDebug(
        MapParams mapParams_arg ,
        EgoStateExtended x0_arg ,
        RoutePlanWithStaticConstraints routePlan_arg ,
        AvtestDynamicWorld dynamicWorld_arg ,
        std::vector<NamedVectorOfDouble> debugVariables_arg ,
        std::vector<WorldTrackDecisions> foundOptions_arg ,
        route_obstacles obstacles_arg 
        );

    HomotopyExtractorDebug(const HomotopyExtractorDebug&);

    // NOLINTNEXTLINE
    HomotopyExtractorDebug(HomotopyExtractorDebug&&);

    HomotopyExtractorDebug& operator=(const HomotopyExtractorDebug&);

    // NOLINTNEXTLINE
    HomotopyExtractorDebug& operator=(HomotopyExtractorDebug&&);

    
    MapParams mapParams
    {};
    EgoStateExtended x0
    {};
    RoutePlanWithStaticConstraints routePlan
    {};
    AvtestDynamicWorld dynamicWorld
    {};
    std::vector<NamedVectorOfDouble> debugVariables
    {};
    std::vector<WorldTrackDecisions> foundOptions
    {};
    route_obstacles obstacles
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const HomotopyExtractorDebug& homotopyextractordebug);

    friend bool operator== (const HomotopyExtractorDebug &lhs, const HomotopyExtractorDebug &rhs);

    template<class Archive>
    void serialize([[maybe_unused]] Archive& ar, [[maybe_unused]] unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace plan_ctrl


template<> struct std::hash<av::msg::plan_ctrl::HomotopyExtractorDebug>
{
    std::size_t operator()(av::msg::plan_ctrl::HomotopyExtractorDebug const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::plan_ctrl::HomotopyExtractorDebug, 2)
ODATUM_NAMED_TYPE(av::msg::plan_ctrl::HomotopyExtractorDebug)



#endif // _HOMOTOPYEXTRACTORDEBUG_H_
