/*!
 ***********************************************************************************************************************
 * APTIV PRIVILEGED AND CONFIDENTIAL
 *
 * THIS IS AN AUTO GENERATED FILE!
 * DO NOT EDIT BY HAND!
 * check infrastructure/idl_generator/jinja_templates/struct.template
 *
 * @brief Auto Generated Cereal Interface
 *
 * @section License
 *
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTE: Removing this heading is prohibited.
 *
 * @section Open Source License List
 *
 * This is a list of any open-source project used by this file.
 ***********************************************************************************************************************
 */

#ifndef _INTERSECTIONTLSTATUS_H_
#define _INTERSECTIONTLSTATUS_H_

#include <ODatum/ODatum.h>
#include <interfaces/traits/csvable.h>

#include <interfaces/IntersectionTLStatusDefinitions.hpp>


#include <interfaces/TimePoint/TimePoint.h>





 namespace av {
 namespace msg {


class StateScoreMapping
    : public csvable
    , public aptv::ODatum
{
public:
    StateScoreMapping();

    StateScoreMapping(
        EDGE_STATE state_arg ,
        double probability_arg 
        );

    StateScoreMapping(const StateScoreMapping&);

    // NOLINTNEXTLINE
    StateScoreMapping(StateScoreMapping&&);

    StateScoreMapping& operator=(const StateScoreMapping&);

    // NOLINTNEXTLINE
    StateScoreMapping& operator=(StateScoreMapping&&);

    
    EDGE_STATE state
    {};
    double probability
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const StateScoreMapping& statescoremapping);

    friend bool operator== (const StateScoreMapping &lhs, const StateScoreMapping &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::StateScoreMapping>
{
    std::size_t operator()(av::msg::StateScoreMapping const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::StateScoreMapping, 1)
ODATUM_NAMED_TYPE(av::msg::StateScoreMapping)

 namespace av {
 namespace msg {


class EdgeTLStatus
    : public csvable
    , public aptv::ODatum
{
public:
    EdgeTLStatus();

    EdgeTLStatus(
        FOV_STATE fov_state_arg ,
        LIGHT_COLOR color_arg ,
        LIGHT_SHAPE shape_arg ,
        LIGHT_STATE state_arg ,
        std::vector<StateScoreMapping> score_arg ,
        double remaining_time_arg ,
        TimePoint timestamp_arg 
        );

    EdgeTLStatus(const EdgeTLStatus&);

    // NOLINTNEXTLINE
    EdgeTLStatus(EdgeTLStatus&&);

    EdgeTLStatus& operator=(const EdgeTLStatus&);

    // NOLINTNEXTLINE
    EdgeTLStatus& operator=(EdgeTLStatus&&);

    
    FOV_STATE fov_state
    {};
    LIGHT_COLOR color
    {};
    LIGHT_SHAPE shape
    {};
    LIGHT_STATE state
    {};
    std::vector<StateScoreMapping> score
    {};
    double remaining_time
    {};
    TimePoint timestamp
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const EdgeTLStatus& edgetlstatus);

    friend bool operator== (const EdgeTLStatus &lhs, const EdgeTLStatus &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::EdgeTLStatus>
{
    std::size_t operator()(av::msg::EdgeTLStatus const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::EdgeTLStatus, 2)
ODATUM_NAMED_TYPE(av::msg::EdgeTLStatus)

 namespace av {
 namespace msg {


class EdgeTLStatusMapping
    : public csvable
    , public aptv::ODatum
{
public:
    EdgeTLStatusMapping();

    EdgeTLStatusMapping(
        std::string to_roadblock_id_arg ,
        EdgeTLStatus tl_status_arg 
        );

    EdgeTLStatusMapping(const EdgeTLStatusMapping&);

    // NOLINTNEXTLINE
    EdgeTLStatusMapping(EdgeTLStatusMapping&&);

    EdgeTLStatusMapping& operator=(const EdgeTLStatusMapping&);

    // NOLINTNEXTLINE
    EdgeTLStatusMapping& operator=(EdgeTLStatusMapping&&);

    
    std::string to_roadblock_id
    {};
    EdgeTLStatus tl_status
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const EdgeTLStatusMapping& edgetlstatusmapping);

    friend bool operator== (const EdgeTLStatusMapping &lhs, const EdgeTLStatusMapping &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::EdgeTLStatusMapping>
{
    std::size_t operator()(av::msg::EdgeTLStatusMapping const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::EdgeTLStatusMapping, 1)
ODATUM_NAMED_TYPE(av::msg::EdgeTLStatusMapping)



 namespace av {
 namespace msg {


class IntersectionTLStatus
    : public csvable
    , public aptv::ODatum
{
public:
    IntersectionTLStatus();

    IntersectionTLStatus(
        int64_t stamp_arg ,
        std::string intersection_id_arg ,
        std::string from_roadblock_id_arg ,
        std::vector<EdgeTLStatusMapping> topology_edges_arg 
        );

    IntersectionTLStatus(const IntersectionTLStatus&);

    // NOLINTNEXTLINE
    IntersectionTLStatus(IntersectionTLStatus&&);

    IntersectionTLStatus& operator=(const IntersectionTLStatus&);

    // NOLINTNEXTLINE
    IntersectionTLStatus& operator=(IntersectionTLStatus&&);

    
    int64_t stamp
    {};
    std::string intersection_id
    {};
    std::string from_roadblock_id
    {};
    std::vector<EdgeTLStatusMapping> topology_edges
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const IntersectionTLStatus& intersectiontlstatus);

    friend bool operator== (const IntersectionTLStatus &lhs, const IntersectionTLStatus &rhs);

    template<class Archive>
    void serialize([[maybe_unused]] Archive& ar, [[maybe_unused]] unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::IntersectionTLStatus>
{
    std::size_t operator()(av::msg::IntersectionTLStatus const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::IntersectionTLStatus, 1)
ODATUM_NAMED_TYPE(av::msg::IntersectionTLStatus)



#endif // _INTERSECTIONTLSTATUS_H_
