/*!
 ***********************************************************************************************************************
 * APTIV PRIVILEGED AND CONFIDENTIAL
 *
 * THIS IS AN AUTO GENERATED FILE!
 * DO NOT EDIT BY HAND!
 * check platform/idl_generator/jinja_templates/struct.template
 *
 * @brief Auto Generated Cereal Interface
 *
 * @section License
 *
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTE: Removing this heading is prohibited.
 *
 * @section Open Source License List
 *
 * This is a list of any open-source project used by this file.
 ***********************************************************************************************************************
 */

#ifndef _LANEGRAPH_H_
#define _LANEGRAPH_H_

#include <ODatum/ODatum.h>
#include <interfaces/traits/csvable.h>

#include <interfaces/LaneGraphDefinitions.hpp>


#include <interfaces/MapId/MapId.h>





 namespace av {
 namespace msg {


class GraphVertex
    : public csvable
    , public aptv::ODatum
{
public:
    GraphVertex();

    GraphVertex(
        MapId vertexID_arg 
        );

    GraphVertex(const GraphVertex&);

    // NOLINTNEXTLINE
    GraphVertex(GraphVertex&&);

    GraphVertex& operator=(const GraphVertex&);

    // NOLINTNEXTLINE
    GraphVertex& operator=(GraphVertex&&);

    
    MapId vertexID
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const GraphVertex& graphvertex);

    friend bool operator== (const GraphVertex &lhs, const GraphVertex &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::GraphVertex>
{
    std::size_t operator()(av::msg::GraphVertex const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::GraphVertex, 1)
ODATUM_NAMED_TYPE(av::msg::GraphVertex)

 namespace av {
 namespace msg {


class GraphEdge
    : public csvable
    , public aptv::ODatum
{
public:
    GraphEdge();

    GraphEdge(
        MapId fromVertexID_arg ,
        MapId toVertexID_arg ,
        std::string edgeType_arg 
        );

    GraphEdge(const GraphEdge&);

    // NOLINTNEXTLINE
    GraphEdge(GraphEdge&&);

    GraphEdge& operator=(const GraphEdge&);

    // NOLINTNEXTLINE
    GraphEdge& operator=(GraphEdge&&);

    
    MapId fromVertexID
    {};
    MapId toVertexID
    {};
    std::string edgeType
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const GraphEdge& graphedge);

    friend bool operator== (const GraphEdge &lhs, const GraphEdge &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::GraphEdge>
{
    std::size_t operator()(av::msg::GraphEdge const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::GraphEdge, 1)
ODATUM_NAMED_TYPE(av::msg::GraphEdge)



 namespace av {
 namespace msg {


class LaneGraph
    : public csvable
    , public aptv::ODatum
{
public:
    LaneGraph();

    LaneGraph(
        uint32_t numVertices_arg ,
        uint32_t numEdges_arg ,
        std::vector<GraphVertex> vertices_arg ,
        std::vector<GraphEdge> edges_arg 
        );

    LaneGraph(const LaneGraph&);

    // NOLINTNEXTLINE
    LaneGraph(LaneGraph&&);

    LaneGraph& operator=(const LaneGraph&);

    // NOLINTNEXTLINE
    LaneGraph& operator=(LaneGraph&&);

    
    uint32_t numVertices
    {};
    uint32_t numEdges
    {};
    std::vector<GraphVertex> vertices
    {};
    std::vector<GraphEdge> edges
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const LaneGraph& lanegraph);

    friend bool operator== (const LaneGraph &lhs, const LaneGraph &rhs);

    template<class Archive>
    void serialize([[maybe_unused]] Archive& ar, [[maybe_unused]] unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::LaneGraph>
{
    std::size_t operator()(av::msg::LaneGraph const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::LaneGraph, 1)
ODATUM_NAMED_TYPE(av::msg::LaneGraph)



#endif // _LANEGRAPH_H_
