/*!
 ***********************************************************************************************************************
 * APTIV PRIVILEGED AND CONFIDENTIAL
 *
 * THIS IS AN AUTO GENERATED FILE!
 * DO NOT EDIT BY HAND!
 * check platform/idl_generator/jinja_templates/struct.template
 *
 * @brief Auto Generated Cereal Interface
 *
 * @section License
 *
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTE: Removing this heading is prohibited.
 *
 * @section Open Source License List
 *
 * This is a list of any open-source project used by this file.
 ***********************************************************************************************************************
 */

#ifndef _LIDARSCAN_H_
#define _LIDARSCAN_H_

#include <ODatum/ODatum.h>
#include <interfaces/traits/csvable.h>

#include <interfaces/LidarScanDefinitions.hpp>


#include <interfaces/TimePoint/TimePoint.h>

#include <interfaces/otimePoint/otimePoint.h>





 namespace av {
 namespace msg {


class LidarReturn
    : public csvable
    , public aptv::ODatum
{
public:
    LidarReturn();

    LidarReturn(
        float x_arg ,
        float y_arg ,
        float z_arg ,
        float range_m_arg ,
        float azimuth_rad_arg ,
        float elevation_rad_arg ,
        float intensity_arg ,
        uint8_t layer_arg ,
        uint8_t echo_arg ,
        uint16_t echo_pulse_width_arg ,
        uint32_t flags_arg ,
        TimePoint timeStamp_arg ,
        TimePoint sensorTimeStamp_arg ,
        uint16_t weight_arg 
        );

    LidarReturn(const LidarReturn&);

    // NOLINTNEXTLINE
    LidarReturn(LidarReturn&&);

    LidarReturn& operator=(const LidarReturn&);

    // NOLINTNEXTLINE
    LidarReturn& operator=(LidarReturn&&);

    
    float x
    {};
    float y
    {};
    float z
    {};
    float range_m
    {};
    float azimuth_rad
    {};
    float elevation_rad
    {};
    float intensity
    {};
    uint8_t layer
    {};
    uint8_t echo
    {};
    uint16_t echo_pulse_width
    {};
    uint32_t flags
    {};
    TimePoint timeStamp
    {};
    TimePoint sensorTimeStamp
    {};
    uint16_t weight
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const LidarReturn& lidarreturn);

    friend bool operator== (const LidarReturn &lhs, const LidarReturn &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::LidarReturn>
{
    std::size_t operator()(av::msg::LidarReturn const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::LidarReturn, 7)
ODATUM_NAMED_TYPE(av::msg::LidarReturn)



 namespace av {
 namespace msg {


class LidarScan
    : public csvable
    , public aptv::ODatum
{
public:
    LidarScan();

    LidarScan(
        bool hasIntensity_arg ,
        bool downSampled_arg ,
        std::string sensorName_arg ,
        std::vector<LidarReturn> data_arg 
        );

    LidarScan(const LidarScan&);

    // NOLINTNEXTLINE
    LidarScan(LidarScan&&);

    LidarScan& operator=(const LidarScan&);

    // NOLINTNEXTLINE
    LidarScan& operator=(LidarScan&&);

    
    bool hasIntensity
    {};
    bool downSampled
    {};
    std::string sensorName
    {};
    std::vector<LidarReturn> data
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const LidarScan& lidarscan);

    friend bool operator== (const LidarScan &lhs, const LidarScan &rhs);

    template<class Archive>
    void serialize([[maybe_unused]] Archive& ar, [[maybe_unused]] unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::LidarScan>
{
    std::size_t operator()(av::msg::LidarScan const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::LidarScan, 5)
ODATUM_NAMED_TYPE(av::msg::LidarScan)



#endif // _LIDARSCAN_H_
