#include <interfaces/LocalizationSystemHealthStatus/LocalizationSystemHealthStatus.h>

#include <iterator>
#include <type_traits>

#include <cereal/cereal.hpp>
#include <cereal/archives/json.hpp>
#include <cereal/archives/binary.hpp>

#include <cereal/types/map.hpp>
#include <cereal/types/vector.hpp>
#include <cereal/types/array.hpp>
#include <cereal/types/string.hpp>
#include <cereal/types/complex.hpp>

#include <ODatum/IntrospectionArchive.h>
#include <ODatum/Hash.h>





 namespace av {
 namespace msg {


LocalizationSystemHealthStatus::LocalizationSystemHealthStatus() = default;

LocalizationSystemHealthStatus::LocalizationSystemHealthStatus(
    TimePoint timeStamp_arg ,
    LocalizationHealthColor color_arg 
    ):
    timeStamp { std::move(timeStamp_arg) } // NOLINT
      ,color { std::move(color_arg) } // NOLINT
      {
}

LocalizationSystemHealthStatus::LocalizationSystemHealthStatus(const LocalizationSystemHealthStatus&) = default;

// NOLINTNEXTLINE
LocalizationSystemHealthStatus::LocalizationSystemHealthStatus(LocalizationSystemHealthStatus&&) = default;

LocalizationSystemHealthStatus& LocalizationSystemHealthStatus::operator=(const LocalizationSystemHealthStatus&) = default;

// NOLINTNEXTLINE
LocalizationSystemHealthStatus& LocalizationSystemHealthStatus::operator=(LocalizationSystemHealthStatus&&) = default;

void LocalizationSystemHealthStatus::toCsv(std::ostream& out) const
{
    out.precision(16);
    out << std::boolalpha;
    out << timeStamp;out << ",";
    out << static_cast<uint32_t>(color);
    
}

std::stringstream LocalizationSystemHealthStatus::toStringstream() const
{
    std::stringstream out;
    toCsv(out);
    return out;
}

template<class Archive>
    void LocalizationSystemHealthStatus::serialize(Archive& ar, unsigned int version)
{
    ar& CEREAL_NVP(timeStamp);
    ar& CEREAL_NVP(color);
}

}} // to close av::msg namespace temporary

struct LocalizationSystemHealthStatus : public av::msg::LocalizationSystemHealthStatus{};
CEREAL_CLASS_VERSION(LocalizationSystemHealthStatus, 2)
CEREAL_REGISTER_TYPE(LocalizationSystemHealthStatus)

namespace av {
namespace msg {



template void LocalizationSystemHealthStatus::serialize(cereal::BinaryInputArchive& ar, unsigned int version);
template void LocalizationSystemHealthStatus::serialize(cereal::BinaryOutputArchive& ar, unsigned int version);
template void LocalizationSystemHealthStatus::serialize(cereal::IntrospectionArchive& ar, unsigned int version);
template void LocalizationSystemHealthStatus::serialize(cereal::JSONInputArchive& ar, unsigned int version);
template void LocalizationSystemHealthStatus::serialize(cereal::JSONOutputArchive& ar, unsigned int version);
template void LocalizationSystemHealthStatus::serialize(cereal::PortableBinaryInputArchive& ar, unsigned int version);
template void LocalizationSystemHealthStatus::serialize(cereal::PortableBinaryOutputArchive& ar, unsigned int version);

std::ostream& operator<< (std::ostream& os, const LocalizationSystemHealthStatus& localizationsystemhealthstatus)
{
    localizationsystemhealthstatus.toCsv(os);
    return os;
}

bool operator== (const LocalizationSystemHealthStatus &lhs, const LocalizationSystemHealthStatus &rhs)
{
    return (  lhs.timeStamp== rhs.timeStamp &&
     lhs.color== rhs.color 
    );
}

std::size_t LocalizationSystemHealthStatus::hash() const noexcept
{
    std::size_t result = 17;
    result = result * 31 + 0;
    result = result * 31 + std::hash<LocalizationHealthColor>()(color);
    return result;
}

 } // namespace av
 } // namespace msg


CEREAL_BIND_TO_ARCHIVES(av::msg::LocalizationSystemHealthStatus)

