/*!
 ***********************************************************************************************************************
 * APTIV PRIVILEGED AND CONFIDENTIAL
 *
 * THIS IS AN AUTO GENERATED FILE!
 * DO NOT EDIT BY HAND!
 * check platform/idl_generator/jinja_templates/struct.template
 *
 * @brief Auto Generated Cereal Interface
 *
 * @section License
 *
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTE: Removing this heading is prohibited.
 *
 * @section Open Source License List
 *
 * This is a list of any open-source project used by this file.
 ***********************************************************************************************************************
 */

#ifndef _MLPLANNERDEBUG_H_
#define _MLPLANNERDEBUG_H_

#include <ODatum/ODatum.h>
#include <interfaces/traits/csvable.h>

#include <interfaces/MLPlannerDebugDefinitions.hpp>


#include <interfaces/TimePoint/TimePoint.h>

#include <interfaces/PathPointMassModelTrajectory/PathPointMassModelTrajectory.h>

#include <interfaces/HomotopyExtractorDebug/HomotopyExtractorDebug.h>

#include <interfaces/RoutePlan/RoutePlan.h>





 namespace av {
 namespace msg {
 namespace plan_ctrl {


class CartesianState
    : public csvable
    , public aptv::ODatum
{
public:
    CartesianState();

    CartesianState(
        double x_arg ,
        double y_arg ,
        double heading_arg ,
        double velocity_arg ,
        double acceleration_arg ,
        double delta_arg 
        );

    CartesianState(const CartesianState&);

    // NOLINTNEXTLINE
    CartesianState(CartesianState&&);

    CartesianState& operator=(const CartesianState&);

    // NOLINTNEXTLINE
    CartesianState& operator=(CartesianState&&);

    
    double x
    {};
    double y
    {};
    double heading
    {};
    double velocity
    {};
    double acceleration
    {};
    double delta
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const CartesianState& cartesianstate);

    friend bool operator== (const CartesianState &lhs, const CartesianState &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace plan_ctrl


template<> struct std::hash<av::msg::plan_ctrl::CartesianState>
{
    std::size_t operator()(av::msg::plan_ctrl::CartesianState const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::plan_ctrl::CartesianState, 1)
ODATUM_NAMED_TYPE(av::msg::plan_ctrl::CartesianState)

 namespace av {
 namespace msg {
 namespace plan_ctrl {


class CartesianStateTrajectory
    : public csvable
    , public aptv::ODatum
{
public:
    CartesianStateTrajectory();

    CartesianStateTrajectory(
        std::vector<CartesianState> states_arg 
        );

    CartesianStateTrajectory(const CartesianStateTrajectory&);

    // NOLINTNEXTLINE
    CartesianStateTrajectory(CartesianStateTrajectory&&);

    CartesianStateTrajectory& operator=(const CartesianStateTrajectory&);

    // NOLINTNEXTLINE
    CartesianStateTrajectory& operator=(CartesianStateTrajectory&&);

    
    std::vector<CartesianState> states
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const CartesianStateTrajectory& cartesianstatetrajectory);

    friend bool operator== (const CartesianStateTrajectory &lhs, const CartesianStateTrajectory &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace plan_ctrl


template<> struct std::hash<av::msg::plan_ctrl::CartesianStateTrajectory>
{
    std::size_t operator()(av::msg::plan_ctrl::CartesianStateTrajectory const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::plan_ctrl::CartesianStateTrajectory, 1)
ODATUM_NAMED_TYPE(av::msg::plan_ctrl::CartesianStateTrajectory)

 namespace av {
 namespace msg {
 namespace plan_ctrl {


class MLPlannerTrajectory
    : public csvable
    , public aptv::ODatum
{
public:
    MLPlannerTrajectory();

    MLPlannerTrajectory(
        uint64_t index_arg ,
        std::vector<NamedVectorOfDouble> featureValues_arg ,
        double reward_arg ,
        CartesianStateTrajectory trajectory_arg 
        );

    MLPlannerTrajectory(const MLPlannerTrajectory&);

    // NOLINTNEXTLINE
    MLPlannerTrajectory(MLPlannerTrajectory&&);

    MLPlannerTrajectory& operator=(const MLPlannerTrajectory&);

    // NOLINTNEXTLINE
    MLPlannerTrajectory& operator=(MLPlannerTrajectory&&);

    
    uint64_t index
    {};
    std::vector<NamedVectorOfDouble> featureValues
    {};
    double reward
    {};
    CartesianStateTrajectory trajectory
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const MLPlannerTrajectory& mlplannertrajectory);

    friend bool operator== (const MLPlannerTrajectory &lhs, const MLPlannerTrajectory &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace plan_ctrl


template<> struct std::hash<av::msg::plan_ctrl::MLPlannerTrajectory>
{
    std::size_t operator()(av::msg::plan_ctrl::MLPlannerTrajectory const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::plan_ctrl::MLPlannerTrajectory, 1)
ODATUM_NAMED_TYPE(av::msg::plan_ctrl::MLPlannerTrajectory)



 namespace av {
 namespace msg {
 namespace plan_ctrl {


class MLPlannerDebug
    : public csvable
    , public aptv::ODatum
{
public:
    MLPlannerDebug();

    MLPlannerDebug(
        TimePoint timeStamp_arg ,
        std::string versionString_arg ,
        EgoStateExtended x0_arg ,
        std::vector<double> accelerationOptions_arg ,
        double trajectoryEpsilon_arg ,
        std::vector<MLPlannerTrajectory> trajectories_arg ,
        RoutePlan routePlan_arg ,
        PathPointMassModelTrajectory bookkeptTrajectory_arg 
        );

    MLPlannerDebug(const MLPlannerDebug&);

    // NOLINTNEXTLINE
    MLPlannerDebug(MLPlannerDebug&&);

    MLPlannerDebug& operator=(const MLPlannerDebug&);

    // NOLINTNEXTLINE
    MLPlannerDebug& operator=(MLPlannerDebug&&);

    
    TimePoint timeStamp
    {};
    std::string versionString
    {};
    EgoStateExtended x0
    {};
    std::vector<double> accelerationOptions
    {};
    double trajectoryEpsilon
    {};
    std::vector<MLPlannerTrajectory> trajectories
    {};
    RoutePlan routePlan
    {};
    PathPointMassModelTrajectory bookkeptTrajectory
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const MLPlannerDebug& mlplannerdebug);

    friend bool operator== (const MLPlannerDebug &lhs, const MLPlannerDebug &rhs);

    template<class Archive>
    void serialize([[maybe_unused]] Archive& ar, [[maybe_unused]] unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace plan_ctrl


template<> struct std::hash<av::msg::plan_ctrl::MLPlannerDebug>
{
    std::size_t operator()(av::msg::plan_ctrl::MLPlannerDebug const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::plan_ctrl::MLPlannerDebug, 3)
ODATUM_NAMED_TYPE(av::msg::plan_ctrl::MLPlannerDebug)



#endif // _MLPLANNERDEBUG_H_
