/*!
 ***********************************************************************************************************************
 * APTIV PRIVILEGED AND CONFIDENTIAL
 *
 * THIS IS AN AUTO GENERATED FILE!
 * DO NOT EDIT BY HAND!
 * check platform/idl_generator/jinja_templates/struct.template
 *
 * @brief Auto Generated Cereal Interface
 *
 * @section License
 *
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTE: Removing this heading is prohibited.
 *
 * @section Open Source License List
 *
 * This is a list of any open-source project used by this file.
 ***********************************************************************************************************************
 */

#ifndef _MOTIONPLANNERMSGS_H_
#define _MOTIONPLANNERMSGS_H_

#include <ODatum/ODatum.h>
#include <interfaces/traits/csvable.h>

#include <interfaces/MotionPlannerMsgsDefinitions.hpp>


#include <interfaces/OptionalRouteProgress/OptionalRouteProgress.h>

#include <interfaces/PlannerHeader/PlannerHeader.h>

#include <interfaces/Path/Path.h>

#include <interfaces/SE2/SE2.h>





 namespace av {
 namespace msg {


class SE2Vertex
    : public csvable
    , public aptv::ODatum
{
public:
    SE2Vertex();

    SE2Vertex(
        int32_t id_arg ,
        msg::SE2 state_arg 
        );

    SE2Vertex(const SE2Vertex&);

    // NOLINTNEXTLINE
    SE2Vertex(SE2Vertex&&);

    SE2Vertex& operator=(const SE2Vertex&);

    // NOLINTNEXTLINE
    SE2Vertex& operator=(SE2Vertex&&);

    
    int32_t id
    {};
    msg::SE2 state
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const SE2Vertex& se2vertex);

    friend bool operator== (const SE2Vertex &lhs, const SE2Vertex &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::SE2Vertex>
{
    std::size_t operator()(av::msg::SE2Vertex const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::SE2Vertex, 1)
ODATUM_NAMED_TYPE(av::msg::SE2Vertex)

 namespace av {
 namespace msg {


class DubinsEdge
    : public csvable
    , public aptv::ODatum
{
public:
    DubinsEdge();

    DubinsEdge(
        int32_t parentId_arg ,
        int32_t childId_arg ,
        DubinsTransition transition_arg 
        );

    DubinsEdge(const DubinsEdge&);

    // NOLINTNEXTLINE
    DubinsEdge(DubinsEdge&&);

    DubinsEdge& operator=(const DubinsEdge&);

    // NOLINTNEXTLINE
    DubinsEdge& operator=(DubinsEdge&&);

    
    int32_t parentId
    {};
    int32_t childId
    {};
    DubinsTransition transition
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const DubinsEdge& dubinsedge);

    friend bool operator== (const DubinsEdge &lhs, const DubinsEdge &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::DubinsEdge>
{
    std::size_t operator()(av::msg::DubinsEdge const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::DubinsEdge, 1)
ODATUM_NAMED_TYPE(av::msg::DubinsEdge)

 namespace av {
 namespace msg {


class EdgeInfo
    : public csvable
    , public aptv::ODatum
{
public:
    EdgeInfo();

    EdgeInfo(
        bool inCollision_arg ,
        bool isBaseline_arg ,
        bool isCommitted_arg 
        );

    EdgeInfo(const EdgeInfo&);

    // NOLINTNEXTLINE
    EdgeInfo(EdgeInfo&&);

    EdgeInfo& operator=(const EdgeInfo&);

    // NOLINTNEXTLINE
    EdgeInfo& operator=(EdgeInfo&&);

    
    bool inCollision
    {};
    bool isBaseline
    {};
    bool isCommitted
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const EdgeInfo& edgeinfo);

    friend bool operator== (const EdgeInfo &lhs, const EdgeInfo &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::EdgeInfo>
{
    std::size_t operator()(av::msg::EdgeInfo const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::EdgeInfo, 1)
ODATUM_NAMED_TYPE(av::msg::EdgeInfo)

 namespace av {
 namespace msg {


class VertexInfo
    : public csvable
    , public aptv::ODatum
{
public:
    VertexInfo();

    VertexInfo(
        bool placeholder_arg 
        );

    VertexInfo(const VertexInfo&);

    // NOLINTNEXTLINE
    VertexInfo(VertexInfo&&);

    VertexInfo& operator=(const VertexInfo&);

    // NOLINTNEXTLINE
    VertexInfo& operator=(VertexInfo&&);

    
    bool placeholder
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const VertexInfo& vertexinfo);

    friend bool operator== (const VertexInfo &lhs, const VertexInfo &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::VertexInfo>
{
    std::size_t operator()(av::msg::VertexInfo const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::VertexInfo, 2)
ODATUM_NAMED_TYPE(av::msg::VertexInfo)

 namespace av {
 namespace msg {


class PathInfo
    : public csvable
    , public aptv::ODatum
{
public:
    PathInfo();

    PathInfo(
        std::vector<DubinsEdge> edges_arg ,
        std::vector<EdgeInfo> edgesInfo_arg ,
        std::vector<SE2Vertex> vertices_arg ,
        std::vector<VertexInfo> verticesInfo_arg 
        );

    PathInfo(const PathInfo&);

    // NOLINTNEXTLINE
    PathInfo(PathInfo&&);

    PathInfo& operator=(const PathInfo&);

    // NOLINTNEXTLINE
    PathInfo& operator=(PathInfo&&);

    
    std::vector<DubinsEdge> edges
    {};
    std::vector<EdgeInfo> edgesInfo
    {};
    std::vector<SE2Vertex> vertices
    {};
    std::vector<VertexInfo> verticesInfo
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const PathInfo& pathinfo);

    friend bool operator== (const PathInfo &lhs, const PathInfo &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::PathInfo>
{
    std::size_t operator()(av::msg::PathInfo const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::PathInfo, 2)
ODATUM_NAMED_TYPE(av::msg::PathInfo)

 namespace av {
 namespace msg {


class GraphInfo
    : public csvable
    , public aptv::ODatum
{
public:
    GraphInfo();

    GraphInfo(
        int32_t rootId_arg ,
        int32_t goalId_arg ,
        std::vector<SE2Vertex> vertices_arg ,
        std::vector<DubinsEdge> edges_arg ,
        std::vector<EdgeInfo> edgesInfo_arg ,
        std::vector<VertexInfo> verticesInfo_arg 
        );

    GraphInfo(const GraphInfo&);

    // NOLINTNEXTLINE
    GraphInfo(GraphInfo&&);

    GraphInfo& operator=(const GraphInfo&);

    // NOLINTNEXTLINE
    GraphInfo& operator=(GraphInfo&&);

    
    int32_t rootId
    {};
    int32_t goalId
    {};
    std::vector<SE2Vertex> vertices
    {};
    std::vector<DubinsEdge> edges
    {};
    std::vector<EdgeInfo> edgesInfo
    {};
    std::vector<VertexInfo> verticesInfo
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const GraphInfo& graphinfo);

    friend bool operator== (const GraphInfo &lhs, const GraphInfo &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::GraphInfo>
{
    std::size_t operator()(av::msg::GraphInfo const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::GraphInfo, 2)
ODATUM_NAMED_TYPE(av::msg::GraphInfo)

 namespace av {
 namespace msg {


class MotionPlannerDebugMsgs
    : public csvable
    , public aptv::ODatum
{
public:
    MotionPlannerDebugMsgs();

    MotionPlannerDebugMsgs(
        PathInfo pathInfo_arg ,
        GraphInfo graphInfo_arg 
        );

    MotionPlannerDebugMsgs(const MotionPlannerDebugMsgs&);

    // NOLINTNEXTLINE
    MotionPlannerDebugMsgs(MotionPlannerDebugMsgs&&);

    MotionPlannerDebugMsgs& operator=(const MotionPlannerDebugMsgs&);

    // NOLINTNEXTLINE
    MotionPlannerDebugMsgs& operator=(MotionPlannerDebugMsgs&&);

    
    PathInfo pathInfo
    {};
    GraphInfo graphInfo
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const MotionPlannerDebugMsgs& motionplannerdebugmsgs);

    friend bool operator== (const MotionPlannerDebugMsgs &lhs, const MotionPlannerDebugMsgs &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::MotionPlannerDebugMsgs>
{
    std::size_t operator()(av::msg::MotionPlannerDebugMsgs const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::MotionPlannerDebugMsgs, 2)
ODATUM_NAMED_TYPE(av::msg::MotionPlannerDebugMsgs)



 namespace av {
 namespace msg {


class MotionPlannerMsgs
    : public csvable
    , public aptv::ODatum
{
public:
    MotionPlannerMsgs();

    MotionPlannerMsgs(
        plan_ctrl::PlannerHeader header_arg ,
        Path path_arg ,
        RouteProgress routeProgress_arg ,
        MotionPlannerDebugMsgs debugMsgs_arg 
        );

    MotionPlannerMsgs(const MotionPlannerMsgs&);

    // NOLINTNEXTLINE
    MotionPlannerMsgs(MotionPlannerMsgs&&);

    MotionPlannerMsgs& operator=(const MotionPlannerMsgs&);

    // NOLINTNEXTLINE
    MotionPlannerMsgs& operator=(MotionPlannerMsgs&&);

    
    plan_ctrl::PlannerHeader header
    {};
    Path path
    {};
    RouteProgress routeProgress
    {};
    MotionPlannerDebugMsgs debugMsgs
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const MotionPlannerMsgs& motionplannermsgs);

    friend bool operator== (const MotionPlannerMsgs &lhs, const MotionPlannerMsgs &rhs);

    template<class Archive>
    void serialize([[maybe_unused]] Archive& ar, [[maybe_unused]] unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::MotionPlannerMsgs>
{
    std::size_t operator()(av::msg::MotionPlannerMsgs const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::MotionPlannerMsgs, 2)
ODATUM_NAMED_TYPE(av::msg::MotionPlannerMsgs)



#endif // _MOTIONPLANNERMSGS_H_
