#include <interfaces/PDUStatusMock/PDUStatusMock.h>

#include <iterator>
#include <type_traits>

#include <cereal/cereal.hpp>
#include <cereal/archives/json.hpp>
#include <cereal/archives/binary.hpp>

#include <cereal/types/map.hpp>
#include <cereal/types/vector.hpp>
#include <cereal/types/array.hpp>
#include <cereal/types/string.hpp>
#include <cereal/types/complex.hpp>

#include <ODatum/IntrospectionArchive.h>
#include <ODatum/Hash.h>


 namespace av {
 namespace msg {


pdu2_curr_ch8_ch11::pdu2_curr_ch8_ch11() = default;

pdu2_curr_ch8_ch11::pdu2_curr_ch8_ch11(
    TimePoint timestamp_arg ,
    float pdu2_curr_ch8_lrr_r4_arg ,
    float pdu2_curr_ch9_lrr_r2_arg ,
    float pdu2_curr_ch10_lrr_l2_arg ,
    float pdu2_curr_ch11_eth_lidar_b_arg 
    ):
    timestamp { std::move(timestamp_arg) } // NOLINT
      ,
    pdu2_curr_ch8_lrr_r4 { std::move(pdu2_curr_ch8_lrr_r4_arg) } // NOLINT
      ,
    pdu2_curr_ch9_lrr_r2 { std::move(pdu2_curr_ch9_lrr_r2_arg) } // NOLINT
      ,
    pdu2_curr_ch10_lrr_l2 { std::move(pdu2_curr_ch10_lrr_l2_arg) } // NOLINT
      ,
    pdu2_curr_ch11_eth_lidar_b { std::move(pdu2_curr_ch11_eth_lidar_b_arg) } // NOLINT
      
    {
}

pdu2_curr_ch8_ch11::pdu2_curr_ch8_ch11(const pdu2_curr_ch8_ch11&) = default;

// NOLINTNEXTLINE
pdu2_curr_ch8_ch11::pdu2_curr_ch8_ch11(pdu2_curr_ch8_ch11&&) = default;

pdu2_curr_ch8_ch11& pdu2_curr_ch8_ch11::operator=(const pdu2_curr_ch8_ch11&) = default;

// NOLINTNEXTLINE
pdu2_curr_ch8_ch11& pdu2_curr_ch8_ch11::operator=(pdu2_curr_ch8_ch11&&) = default;

void pdu2_curr_ch8_ch11::toCsv(std::ostream& out) const
{
    out.precision(16);
    out << std::boolalpha;
    out << timestamp;out << ",";
    out << pdu2_curr_ch8_lrr_r4;out << ",";
    out << pdu2_curr_ch9_lrr_r2;out << ",";
    out << pdu2_curr_ch10_lrr_l2;out << ",";
    out << pdu2_curr_ch11_eth_lidar_b;
    
}

std::stringstream pdu2_curr_ch8_ch11::toStringstream() const
{
    std::stringstream out;
    toCsv(out);
    return out;
}

template<class Archive>
    void pdu2_curr_ch8_ch11::serialize(Archive& ar, [[maybe_unused]] unsigned int version)
    {

        ar& CEREAL_NVP(timestamp);
        ar& CEREAL_NVP(pdu2_curr_ch8_lrr_r4);
        ar& CEREAL_NVP(pdu2_curr_ch9_lrr_r2);
        ar& CEREAL_NVP(pdu2_curr_ch10_lrr_l2);
        ar& CEREAL_NVP(pdu2_curr_ch11_eth_lidar_b);
    }


template void pdu2_curr_ch8_ch11::serialize(cereal::BinaryInputArchive& ar, unsigned int version);
template void pdu2_curr_ch8_ch11::serialize(cereal::BinaryOutputArchive& ar, unsigned int version);
template void pdu2_curr_ch8_ch11::serialize(cereal::IntrospectionArchive& ar, unsigned int version);
template void pdu2_curr_ch8_ch11::serialize(cereal::JSONInputArchive& ar, unsigned int version);
template void pdu2_curr_ch8_ch11::serialize(cereal::JSONOutputArchive& ar, unsigned int version);
template void pdu2_curr_ch8_ch11::serialize(cereal::PortableBinaryInputArchive& ar, unsigned int version);
template void pdu2_curr_ch8_ch11::serialize(cereal::PortableBinaryOutputArchive& ar, unsigned int version);

std::ostream& operator<< (std::ostream& os, const pdu2_curr_ch8_ch11& pdu2_curr_ch8_ch11)
{
    pdu2_curr_ch8_ch11.toCsv(os);
    return os;
}

bool operator== (const pdu2_curr_ch8_ch11 &lhs, const pdu2_curr_ch8_ch11 &rhs)
{
    return (  lhs.timestamp== rhs.timestamp &&
     lhs.pdu2_curr_ch8_lrr_r4== rhs.pdu2_curr_ch8_lrr_r4 &&
     lhs.pdu2_curr_ch9_lrr_r2== rhs.pdu2_curr_ch9_lrr_r2 &&
     lhs.pdu2_curr_ch10_lrr_l2== rhs.pdu2_curr_ch10_lrr_l2 &&
     lhs.pdu2_curr_ch11_eth_lidar_b== rhs.pdu2_curr_ch11_eth_lidar_b 
    );
}

std::size_t pdu2_curr_ch8_ch11::hash() const noexcept
{
    std::size_t result = 17;
    result = result * 31 + 0;
    result = result * 31 + std::hash<float>()(pdu2_curr_ch8_lrr_r4);
    result = result * 31 + std::hash<float>()(pdu2_curr_ch9_lrr_r2);
    result = result * 31 + std::hash<float>()(pdu2_curr_ch10_lrr_l2);
    result = result * 31 + std::hash<float>()(pdu2_curr_ch11_eth_lidar_b);
    return result;
}

 } // namespace av
 } // namespace msg


CEREAL_BIND_TO_ARCHIVES(av::msg::pdu2_curr_ch8_ch11)

 namespace av {
 namespace msg {


pdu2_curr_ch12_ch15::pdu2_curr_ch12_ch15() = default;

pdu2_curr_ch12_ch15::pdu2_curr_ch12_ch15(
    TimePoint timestamp_arg ,
    float pdu2_curr_ch12_eth_lidar_l_arg ,
    float pdu2_curr_ch13_arg ,
    float pdu2_curr_ch14_lrr_l4_arg ,
    float pdu_curr_ch15_media_gw_1_arg 
    ):
    timestamp { std::move(timestamp_arg) } // NOLINT
      ,
    pdu2_curr_ch12_eth_lidar_l { std::move(pdu2_curr_ch12_eth_lidar_l_arg) } // NOLINT
      ,
    pdu2_curr_ch13 { std::move(pdu2_curr_ch13_arg) } // NOLINT
      ,
    pdu2_curr_ch14_lrr_l4 { std::move(pdu2_curr_ch14_lrr_l4_arg) } // NOLINT
      ,
    pdu_curr_ch15_media_gw_1 { std::move(pdu_curr_ch15_media_gw_1_arg) } // NOLINT
      
    {
}

pdu2_curr_ch12_ch15::pdu2_curr_ch12_ch15(const pdu2_curr_ch12_ch15&) = default;

// NOLINTNEXTLINE
pdu2_curr_ch12_ch15::pdu2_curr_ch12_ch15(pdu2_curr_ch12_ch15&&) = default;

pdu2_curr_ch12_ch15& pdu2_curr_ch12_ch15::operator=(const pdu2_curr_ch12_ch15&) = default;

// NOLINTNEXTLINE
pdu2_curr_ch12_ch15& pdu2_curr_ch12_ch15::operator=(pdu2_curr_ch12_ch15&&) = default;

void pdu2_curr_ch12_ch15::toCsv(std::ostream& out) const
{
    out.precision(16);
    out << std::boolalpha;
    out << timestamp;out << ",";
    out << pdu2_curr_ch12_eth_lidar_l;out << ",";
    out << pdu2_curr_ch13;out << ",";
    out << pdu2_curr_ch14_lrr_l4;out << ",";
    out << pdu_curr_ch15_media_gw_1;
    
}

std::stringstream pdu2_curr_ch12_ch15::toStringstream() const
{
    std::stringstream out;
    toCsv(out);
    return out;
}

template<class Archive>
    void pdu2_curr_ch12_ch15::serialize(Archive& ar, [[maybe_unused]] unsigned int version)
    {

        ar& CEREAL_NVP(timestamp);
        ar& CEREAL_NVP(pdu2_curr_ch12_eth_lidar_l);
        ar& CEREAL_NVP(pdu2_curr_ch13);
        ar& CEREAL_NVP(pdu2_curr_ch14_lrr_l4);
        ar& CEREAL_NVP(pdu_curr_ch15_media_gw_1);
    }


template void pdu2_curr_ch12_ch15::serialize(cereal::BinaryInputArchive& ar, unsigned int version);
template void pdu2_curr_ch12_ch15::serialize(cereal::BinaryOutputArchive& ar, unsigned int version);
template void pdu2_curr_ch12_ch15::serialize(cereal::IntrospectionArchive& ar, unsigned int version);
template void pdu2_curr_ch12_ch15::serialize(cereal::JSONInputArchive& ar, unsigned int version);
template void pdu2_curr_ch12_ch15::serialize(cereal::JSONOutputArchive& ar, unsigned int version);
template void pdu2_curr_ch12_ch15::serialize(cereal::PortableBinaryInputArchive& ar, unsigned int version);
template void pdu2_curr_ch12_ch15::serialize(cereal::PortableBinaryOutputArchive& ar, unsigned int version);

std::ostream& operator<< (std::ostream& os, const pdu2_curr_ch12_ch15& pdu2_curr_ch12_ch15)
{
    pdu2_curr_ch12_ch15.toCsv(os);
    return os;
}

bool operator== (const pdu2_curr_ch12_ch15 &lhs, const pdu2_curr_ch12_ch15 &rhs)
{
    return (  lhs.timestamp== rhs.timestamp &&
     lhs.pdu2_curr_ch12_eth_lidar_l== rhs.pdu2_curr_ch12_eth_lidar_l &&
     lhs.pdu2_curr_ch13== rhs.pdu2_curr_ch13 &&
     lhs.pdu2_curr_ch14_lrr_l4== rhs.pdu2_curr_ch14_lrr_l4 &&
     lhs.pdu_curr_ch15_media_gw_1== rhs.pdu_curr_ch15_media_gw_1 
    );
}

std::size_t pdu2_curr_ch12_ch15::hash() const noexcept
{
    std::size_t result = 17;
    result = result * 31 + 0;
    result = result * 31 + std::hash<float>()(pdu2_curr_ch12_eth_lidar_l);
    result = result * 31 + std::hash<float>()(pdu2_curr_ch13);
    result = result * 31 + std::hash<float>()(pdu2_curr_ch14_lrr_l4);
    result = result * 31 + std::hash<float>()(pdu_curr_ch15_media_gw_1);
    return result;
}

 } // namespace av
 } // namespace msg


CEREAL_BIND_TO_ARCHIVES(av::msg::pdu2_curr_ch12_ch15)

 namespace av {
 namespace msg {


pdu2_curr_ch24_ch27::pdu2_curr_ch24_ch27() = default;

pdu2_curr_ch24_ch27::pdu2_curr_ch24_ch27(
    TimePoint timestamp_arg ,
    float pdu2_curr_ch24_lidar_f_arg ,
    float pdu2_curr_ch25_lidar_l_arg ,
    float pdu2_curr_ch26_lidar_r_arg ,
    float pdu2_curr_ch27_lidar_b_arg 
    ):
    timestamp { std::move(timestamp_arg) } // NOLINT
      ,
    pdu2_curr_ch24_lidar_f { std::move(pdu2_curr_ch24_lidar_f_arg) } // NOLINT
      ,
    pdu2_curr_ch25_lidar_l { std::move(pdu2_curr_ch25_lidar_l_arg) } // NOLINT
      ,
    pdu2_curr_ch26_lidar_r { std::move(pdu2_curr_ch26_lidar_r_arg) } // NOLINT
      ,
    pdu2_curr_ch27_lidar_b { std::move(pdu2_curr_ch27_lidar_b_arg) } // NOLINT
      
    {
}

pdu2_curr_ch24_ch27::pdu2_curr_ch24_ch27(const pdu2_curr_ch24_ch27&) = default;

// NOLINTNEXTLINE
pdu2_curr_ch24_ch27::pdu2_curr_ch24_ch27(pdu2_curr_ch24_ch27&&) = default;

pdu2_curr_ch24_ch27& pdu2_curr_ch24_ch27::operator=(const pdu2_curr_ch24_ch27&) = default;

// NOLINTNEXTLINE
pdu2_curr_ch24_ch27& pdu2_curr_ch24_ch27::operator=(pdu2_curr_ch24_ch27&&) = default;

void pdu2_curr_ch24_ch27::toCsv(std::ostream& out) const
{
    out.precision(16);
    out << std::boolalpha;
    out << timestamp;out << ",";
    out << pdu2_curr_ch24_lidar_f;out << ",";
    out << pdu2_curr_ch25_lidar_l;out << ",";
    out << pdu2_curr_ch26_lidar_r;out << ",";
    out << pdu2_curr_ch27_lidar_b;
    
}

std::stringstream pdu2_curr_ch24_ch27::toStringstream() const
{
    std::stringstream out;
    toCsv(out);
    return out;
}

template<class Archive>
    void pdu2_curr_ch24_ch27::serialize(Archive& ar, [[maybe_unused]] unsigned int version)
    {

        ar& CEREAL_NVP(timestamp);
        ar& CEREAL_NVP(pdu2_curr_ch24_lidar_f);
        ar& CEREAL_NVP(pdu2_curr_ch25_lidar_l);
        ar& CEREAL_NVP(pdu2_curr_ch26_lidar_r);
        ar& CEREAL_NVP(pdu2_curr_ch27_lidar_b);
    }


template void pdu2_curr_ch24_ch27::serialize(cereal::BinaryInputArchive& ar, unsigned int version);
template void pdu2_curr_ch24_ch27::serialize(cereal::BinaryOutputArchive& ar, unsigned int version);
template void pdu2_curr_ch24_ch27::serialize(cereal::IntrospectionArchive& ar, unsigned int version);
template void pdu2_curr_ch24_ch27::serialize(cereal::JSONInputArchive& ar, unsigned int version);
template void pdu2_curr_ch24_ch27::serialize(cereal::JSONOutputArchive& ar, unsigned int version);
template void pdu2_curr_ch24_ch27::serialize(cereal::PortableBinaryInputArchive& ar, unsigned int version);
template void pdu2_curr_ch24_ch27::serialize(cereal::PortableBinaryOutputArchive& ar, unsigned int version);

std::ostream& operator<< (std::ostream& os, const pdu2_curr_ch24_ch27& pdu2_curr_ch24_ch27)
{
    pdu2_curr_ch24_ch27.toCsv(os);
    return os;
}

bool operator== (const pdu2_curr_ch24_ch27 &lhs, const pdu2_curr_ch24_ch27 &rhs)
{
    return (  lhs.timestamp== rhs.timestamp &&
     lhs.pdu2_curr_ch24_lidar_f== rhs.pdu2_curr_ch24_lidar_f &&
     lhs.pdu2_curr_ch25_lidar_l== rhs.pdu2_curr_ch25_lidar_l &&
     lhs.pdu2_curr_ch26_lidar_r== rhs.pdu2_curr_ch26_lidar_r &&
     lhs.pdu2_curr_ch27_lidar_b== rhs.pdu2_curr_ch27_lidar_b 
    );
}

std::size_t pdu2_curr_ch24_ch27::hash() const noexcept
{
    std::size_t result = 17;
    result = result * 31 + 0;
    result = result * 31 + std::hash<float>()(pdu2_curr_ch24_lidar_f);
    result = result * 31 + std::hash<float>()(pdu2_curr_ch25_lidar_l);
    result = result * 31 + std::hash<float>()(pdu2_curr_ch26_lidar_r);
    result = result * 31 + std::hash<float>()(pdu2_curr_ch27_lidar_b);
    return result;
}

 } // namespace av
 } // namespace msg


CEREAL_BIND_TO_ARCHIVES(av::msg::pdu2_curr_ch24_ch27)




 namespace av {
 namespace msg {


PDUStatusMock::PDUStatusMock() = default;

PDUStatusMock::PDUStatusMock(
    TimePoint timestamp_arg ,
    pdu2_curr_ch8_ch11 ch8_ch11_arg ,
    pdu2_curr_ch12_ch15 ch12_ch15_arg ,
    pdu2_curr_ch24_ch27 ch24_ch27_arg 
    ):
    timestamp { std::move(timestamp_arg) } // NOLINT
      ,ch8_ch11 { std::move(ch8_ch11_arg) } // NOLINT
      ,ch12_ch15 { std::move(ch12_ch15_arg) } // NOLINT
      ,ch24_ch27 { std::move(ch24_ch27_arg) } // NOLINT
      {
}

PDUStatusMock::PDUStatusMock(const PDUStatusMock&) = default;

// NOLINTNEXTLINE
PDUStatusMock::PDUStatusMock(PDUStatusMock&&) = default;

PDUStatusMock& PDUStatusMock::operator=(const PDUStatusMock&) = default;

// NOLINTNEXTLINE
PDUStatusMock& PDUStatusMock::operator=(PDUStatusMock&&) = default;

void PDUStatusMock::toCsv(std::ostream& out) const
{
    out.precision(16);
    out << std::boolalpha;
    out << timestamp;out << ",";
    out << ch8_ch11;out << ",";
    out << ch12_ch15;out << ",";
    out << ch24_ch27;
    
}

std::stringstream PDUStatusMock::toStringstream() const
{
    std::stringstream out;
    toCsv(out);
    return out;
}

template<class Archive>
    void PDUStatusMock::serialize(Archive& ar, [[maybe_unused]] unsigned int version)
    {

        ar& CEREAL_NVP(timestamp);
        ar& CEREAL_NVP(ch8_ch11);
        ar& CEREAL_NVP(ch12_ch15);
        ar& CEREAL_NVP(ch24_ch27);
    }


template void PDUStatusMock::serialize(cereal::BinaryInputArchive& ar, unsigned int version);
template void PDUStatusMock::serialize(cereal::BinaryOutputArchive& ar, unsigned int version);
template void PDUStatusMock::serialize(cereal::IntrospectionArchive& ar, unsigned int version);
template void PDUStatusMock::serialize(cereal::JSONInputArchive& ar, unsigned int version);
template void PDUStatusMock::serialize(cereal::JSONOutputArchive& ar, unsigned int version);
template void PDUStatusMock::serialize(cereal::PortableBinaryInputArchive& ar, unsigned int version);
template void PDUStatusMock::serialize(cereal::PortableBinaryOutputArchive& ar, unsigned int version);

std::ostream& operator<< (std::ostream& os, const PDUStatusMock& pdustatusmock)
{
    pdustatusmock.toCsv(os);
    return os;
}

bool operator== (const PDUStatusMock &lhs, const PDUStatusMock &rhs)
{
    return (  lhs.timestamp== rhs.timestamp &&
     lhs.ch8_ch11== rhs.ch8_ch11 &&
     lhs.ch12_ch15== rhs.ch12_ch15 &&
     lhs.ch24_ch27== rhs.ch24_ch27 
    );
}

std::size_t PDUStatusMock::hash() const noexcept
{
    std::size_t result = 17;
    result = result * 31 + 0;
    result = result * 31 + std::hash<pdu2_curr_ch8_ch11>()(ch8_ch11);
    result = result * 31 + std::hash<pdu2_curr_ch12_ch15>()(ch12_ch15);
    result = result * 31 + std::hash<pdu2_curr_ch24_ch27>()(ch24_ch27);
    return result;
}

 } // namespace av
 } // namespace msg


CEREAL_BIND_TO_ARCHIVES(av::msg::PDUStatusMock)

