/*!
 ***********************************************************************************************************************
 * APTIV PRIVILEGED AND CONFIDENTIAL
 *
 * THIS IS AN AUTO GENERATED FILE!
 * DO NOT EDIT BY HAND!
 * check platform/idl_generator/jinja_templates/struct.template
 *
 * @brief Auto Generated Cereal Interface
 *
 * @section License
 *
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTE: Removing this heading is prohibited.
 *
 * @section Open Source License List
 *
 * This is a list of any open-source project used by this file.
 ***********************************************************************************************************************
 */

#ifndef _ROUTEPLAN_H_
#define _ROUTEPLAN_H_

#include <ODatum/ODatum.h>
#include <interfaces/traits/csvable.h>

#include <interfaces/RoutePlanDefinitions.hpp>


#include <interfaces/PlannedPathWithBounds/PlannedPathWithBounds.h>





 namespace av {
 namespace msg {
 namespace plan_ctrl {


class PathRepresentation
    : public csvable
    , public aptv::ODatum
{
public:
    PathRepresentation();

    PathRepresentation(
        int64_t laneConnector_arg ,
        bool isLaneConnectorValid_arg ,
        int64_t laneFrom_arg ,
        bool isLaneFromValid_arg 
        );

    PathRepresentation(const PathRepresentation&);

    // NOLINTNEXTLINE
    PathRepresentation(PathRepresentation&&);

    PathRepresentation& operator=(const PathRepresentation&);

    // NOLINTNEXTLINE
    PathRepresentation& operator=(PathRepresentation&&);

    
    int64_t laneConnector
    {};
    bool isLaneConnectorValid
    {};
    int64_t laneFrom
    {};
    bool isLaneFromValid
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const PathRepresentation& pathrepresentation);

    friend bool operator== (const PathRepresentation &lhs, const PathRepresentation &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace plan_ctrl


template<> struct std::hash<av::msg::plan_ctrl::PathRepresentation>
{
    std::size_t operator()(av::msg::plan_ctrl::PathRepresentation const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::plan_ctrl::PathRepresentation, 1)
ODATUM_NAMED_TYPE(av::msg::plan_ctrl::PathRepresentation)

 namespace av {
 namespace msg {
 namespace plan_ctrl {


class PathWithRoute
    : public csvable
    , public aptv::ODatum
{
public:
    PathWithRoute();

    PathWithRoute(
        Path path_arg ,
        std::vector<PathRepresentation> laneSequence_arg 
        );

    PathWithRoute(const PathWithRoute&);

    // NOLINTNEXTLINE
    PathWithRoute(PathWithRoute&&);

    PathWithRoute& operator=(const PathWithRoute&);

    // NOLINTNEXTLINE
    PathWithRoute& operator=(PathWithRoute&&);

    
    Path path
    {};
    std::vector<PathRepresentation> laneSequence
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const PathWithRoute& pathwithroute);

    friend bool operator== (const PathWithRoute &lhs, const PathWithRoute &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace plan_ctrl


template<> struct std::hash<av::msg::plan_ctrl::PathWithRoute>
{
    std::size_t operator()(av::msg::plan_ctrl::PathWithRoute const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::plan_ctrl::PathWithRoute, 1)
ODATUM_NAMED_TYPE(av::msg::plan_ctrl::PathWithRoute)

 namespace av {
 namespace msg {
 namespace plan_ctrl {


class OptionalPaths
    : public csvable
    , public aptv::ODatum
{
public:
    OptionalPaths();

    OptionalPaths(
        PathWithRoute path_arg ,
        double station_interval_in_anchor_max_arg ,
        double station_interval_in_anchor_min_arg ,
        bool isDesiredLane_arg ,
        bool isOppositeDirection_arg ,
        bool isLeft_arg 
        );

    OptionalPaths(const OptionalPaths&);

    // NOLINTNEXTLINE
    OptionalPaths(OptionalPaths&&);

    OptionalPaths& operator=(const OptionalPaths&);

    // NOLINTNEXTLINE
    OptionalPaths& operator=(OptionalPaths&&);

    
    PathWithRoute path
    {};
    double station_interval_in_anchor_max
    {};
    double station_interval_in_anchor_min
    {};
    bool isDesiredLane
    {};
    bool isOppositeDirection
    {};
    bool isLeft
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const OptionalPaths& optionalpaths);

    friend bool operator== (const OptionalPaths &lhs, const OptionalPaths &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace plan_ctrl


template<> struct std::hash<av::msg::plan_ctrl::OptionalPaths>
{
    std::size_t operator()(av::msg::plan_ctrl::OptionalPaths const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::plan_ctrl::OptionalPaths, 1)
ODATUM_NAMED_TYPE(av::msg::plan_ctrl::OptionalPaths)



 namespace av {
 namespace msg {
 namespace plan_ctrl {


class RoutePlan
    : public csvable
    , public aptv::ODatum
{
public:
    RoutePlan();

    RoutePlan(
        int64_t timestamp_arg ,
        PathWithRoute anchor_path_arg ,
        std::vector<OptionalPaths> adjacent_paths_arg ,
        std::vector<int64_t> roadBlocksRoute_arg ,
        std::vector<int64_t> laneRoute_arg 
        );

    RoutePlan(const RoutePlan&);

    // NOLINTNEXTLINE
    RoutePlan(RoutePlan&&);

    RoutePlan& operator=(const RoutePlan&);

    // NOLINTNEXTLINE
    RoutePlan& operator=(RoutePlan&&);

    
    int64_t timestamp
    {};
    PathWithRoute anchor_path
    {};
    std::vector<OptionalPaths> adjacent_paths
    {};
    std::vector<int64_t> roadBlocksRoute
    {};
    std::vector<int64_t> laneRoute
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const RoutePlan& routeplan);

    friend bool operator== (const RoutePlan &lhs, const RoutePlan &rhs);

    template<class Archive>
    void serialize([[maybe_unused]] Archive& ar, [[maybe_unused]] unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace plan_ctrl


template<> struct std::hash<av::msg::plan_ctrl::RoutePlan>
{
    std::size_t operator()(av::msg::plan_ctrl::RoutePlan const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::plan_ctrl::RoutePlan, 1)
ODATUM_NAMED_TYPE(av::msg::plan_ctrl::RoutePlan)



#endif // _ROUTEPLAN_H_
