/*!
 ***********************************************************************************************************************
 * APTIV PRIVILEGED AND CONFIDENTIAL
 *
 * THIS IS AN AUTO GENERATED FILE!
 * DO NOT EDIT BY HAND!
 * check platform/idl_generator/jinja_templates/struct.template
 *
 * @brief Auto Generated Cereal Interface
 *
 * @section License
 *
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTE: Removing this heading is prohibited.
 *
 * @section Open Source License List
 *
 * This is a list of any open-source project used by this file.
 ***********************************************************************************************************************
 */

#ifndef _ROUTINGRESPONSE_H_
#define _ROUTINGRESPONSE_H_

#include <ODatum/ODatum.h>
#include <interfaces/traits/csvable.h>

#include <interfaces/RoutingResponseDefinitions.hpp>


#include <interfaces/GUID/GUID.h>

#include <interfaces/MapId/MapId.h>

#include <interfaces/SE2/SE2.h>

#include <interfaces/TimePoint/TimePoint.h>





 namespace av {
 namespace msg {


class RoutingItemMeta
    : public csvable
    , public aptv::ODatum
{
public:
    RoutingItemMeta();

    RoutingItemMeta(
        uint64_t MaxStandingTimeSec_arg 
        );

    RoutingItemMeta(const RoutingItemMeta&);

    // NOLINTNEXTLINE
    RoutingItemMeta(RoutingItemMeta&&);

    RoutingItemMeta& operator=(const RoutingItemMeta&);

    // NOLINTNEXTLINE
    RoutingItemMeta& operator=(RoutingItemMeta&&);

    
    uint64_t MaxStandingTimeSec
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const RoutingItemMeta& routingitemmeta);

    friend bool operator== (const RoutingItemMeta &lhs, const RoutingItemMeta &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::RoutingItemMeta>
{
    std::size_t operator()(av::msg::RoutingItemMeta const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::RoutingItemMeta, 1)
ODATUM_NAMED_TYPE(av::msg::RoutingItemMeta)

 namespace av {
 namespace msg {


class RoutingItem
    : public csvable
    , public aptv::ODatum
{
public:
    RoutingItem();

    RoutingItem(
        av::msg::SE2 startPose_arg ,
        av::msg::SE2 targetPose_arg ,
        std::vector<MapId> roadblocks_arg ,
        RoutingItemMeta meta_arg 
        );

    RoutingItem(const RoutingItem&);

    // NOLINTNEXTLINE
    RoutingItem(RoutingItem&&);

    RoutingItem& operator=(const RoutingItem&);

    // NOLINTNEXTLINE
    RoutingItem& operator=(RoutingItem&&);

    
    av::msg::SE2 startPose
    {};
    av::msg::SE2 targetPose
    {};
    std::vector<MapId> roadblocks
    {};
    RoutingItemMeta meta
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const RoutingItem& routingitem);

    friend bool operator== (const RoutingItem &lhs, const RoutingItem &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::RoutingItem>
{
    std::size_t operator()(av::msg::RoutingItem const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::RoutingItem, 1)
ODATUM_NAMED_TYPE(av::msg::RoutingItem)

 namespace av {
 namespace msg {


class RoutingResponseStatus
    : public csvable
    , public aptv::ODatum
{
public:
    RoutingResponseStatus();

    RoutingResponseStatus(
        RoutingResponseState state_arg ,
        std::string details_arg 
        );

    RoutingResponseStatus(const RoutingResponseStatus&);

    // NOLINTNEXTLINE
    RoutingResponseStatus(RoutingResponseStatus&&);

    RoutingResponseStatus& operator=(const RoutingResponseStatus&);

    // NOLINTNEXTLINE
    RoutingResponseStatus& operator=(RoutingResponseStatus&&);

    
    RoutingResponseState state
    {};
    std::string details
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const RoutingResponseStatus& routingresponsestatus);

    friend bool operator== (const RoutingResponseStatus &lhs, const RoutingResponseStatus &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::RoutingResponseStatus>
{
    std::size_t operator()(av::msg::RoutingResponseStatus const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::RoutingResponseStatus, 1)
ODATUM_NAMED_TYPE(av::msg::RoutingResponseStatus)



 namespace av {
 namespace msg {


class RoutingResponse
    : public csvable
    , public aptv::ODatum
{
public:
    RoutingResponse();

    RoutingResponse(
        av::msg::TimePoint timestamp_arg ,
        msg::GUID requestId_arg ,
        int32_t utmZone_arg ,
        RoutingResponseStatus status_arg ,
        std::vector<RoutingItem> items_arg 
        );

    RoutingResponse(const RoutingResponse&);

    // NOLINTNEXTLINE
    RoutingResponse(RoutingResponse&&);

    RoutingResponse& operator=(const RoutingResponse&);

    // NOLINTNEXTLINE
    RoutingResponse& operator=(RoutingResponse&&);

    
    av::msg::TimePoint timestamp
    {};
    msg::GUID requestId
    {};
    int32_t utmZone
    {};
    RoutingResponseStatus status
    {};
    std::vector<RoutingItem> items
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const RoutingResponse& routingresponse);

    friend bool operator== (const RoutingResponse &lhs, const RoutingResponse &rhs);

    template<class Archive>
    void serialize([[maybe_unused]] Archive& ar, [[maybe_unused]] unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::RoutingResponse>
{
    std::size_t operator()(av::msg::RoutingResponse const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::RoutingResponse, 1)
ODATUM_NAMED_TYPE(av::msg::RoutingResponse)



#endif // _ROUTINGRESPONSE_H_
