#include <interfaces/RvaAssistanceRequestEvent/RvaAssistanceRequestEvent.h>

#include <iterator>
#include <type_traits>

#include <cereal/cereal.hpp>
#include <cereal/archives/json.hpp>
#include <cereal/archives/binary.hpp>

#include <cereal/types/map.hpp>
#include <cereal/types/vector.hpp>
#include <cereal/types/array.hpp>
#include <cereal/types/string.hpp>
#include <cereal/types/complex.hpp>

#include <ODatum/IntrospectionArchive.h>
#include <ODatum/Hash.h>





 namespace av {
 namespace msg {
 namespace rva {
 namespace hmi_metric {


RvaAssistanceRequestEvent::RvaAssistanceRequestEvent() = default;

RvaAssistanceRequestEvent::RvaAssistanceRequestEvent(
    Component component_arg ,
    av::msg::AssistanceRequest assistanceRequest_arg 
    ):
    component { std::move(component_arg) } // NOLINT
      ,assistanceRequest { std::move(assistanceRequest_arg) } // NOLINT
      {
}

RvaAssistanceRequestEvent::RvaAssistanceRequestEvent(const RvaAssistanceRequestEvent&) = default;

// NOLINTNEXTLINE
RvaAssistanceRequestEvent::RvaAssistanceRequestEvent(RvaAssistanceRequestEvent&&) = default;

RvaAssistanceRequestEvent& RvaAssistanceRequestEvent::operator=(const RvaAssistanceRequestEvent&) = default;

// NOLINTNEXTLINE
RvaAssistanceRequestEvent& RvaAssistanceRequestEvent::operator=(RvaAssistanceRequestEvent&&) = default;

void RvaAssistanceRequestEvent::toCsv(std::ostream& out) const
{
    out.precision(16);
    out << std::boolalpha;
    out << static_cast<uint32_t>(component);out << ",";
    out << assistanceRequest;
    
}

std::stringstream RvaAssistanceRequestEvent::toStringstream() const
{
    std::stringstream out;
    toCsv(out);
    return out;
}

template<class Archive>
    void RvaAssistanceRequestEvent::serialize(Archive& ar, [[maybe_unused]] unsigned int version)
    {

        ar& CEREAL_NVP(component);
        ar& CEREAL_NVP(assistanceRequest);
    }


template void RvaAssistanceRequestEvent::serialize(cereal::BinaryInputArchive& ar, unsigned int version);
template void RvaAssistanceRequestEvent::serialize(cereal::BinaryOutputArchive& ar, unsigned int version);
template void RvaAssistanceRequestEvent::serialize(cereal::IntrospectionArchive& ar, unsigned int version);
template void RvaAssistanceRequestEvent::serialize(cereal::JSONInputArchive& ar, unsigned int version);
template void RvaAssistanceRequestEvent::serialize(cereal::JSONOutputArchive& ar, unsigned int version);
template void RvaAssistanceRequestEvent::serialize(cereal::PortableBinaryInputArchive& ar, unsigned int version);
template void RvaAssistanceRequestEvent::serialize(cereal::PortableBinaryOutputArchive& ar, unsigned int version);

std::ostream& operator<< (std::ostream& os, const RvaAssistanceRequestEvent& rvaassistancerequestevent)
{
    rvaassistancerequestevent.toCsv(os);
    return os;
}

bool operator== (const RvaAssistanceRequestEvent &lhs, const RvaAssistanceRequestEvent &rhs)
{
    return (  lhs.component== rhs.component &&
     lhs.assistanceRequest== rhs.assistanceRequest 
    );
}

std::size_t RvaAssistanceRequestEvent::hash() const noexcept
{
    std::size_t result = 17;
    result = result * 31 + std::hash<Component>()(component);
    result = result * 31 + std::hash<av::msg::AssistanceRequest>()(assistanceRequest);
    return result;
}

 } // namespace av
 } // namespace msg
 } // namespace rva
 } // namespace hmi_metric


CEREAL_BIND_TO_ARCHIVES(av::msg::rva::hmi_metric::RvaAssistanceRequestEvent)

