#include <interfaces/RvaPathPlanningActivationState/RvaPathPlanningActivationState.h>

#include <iterator>
#include <type_traits>

#include <cereal/cereal.hpp>
#include <cereal/archives/json.hpp>
#include <cereal/archives/binary.hpp>

#include <cereal/types/map.hpp>
#include <cereal/types/vector.hpp>
#include <cereal/types/array.hpp>
#include <cereal/types/string.hpp>
#include <cereal/types/complex.hpp>

#include <ODatum/IntrospectionArchive.h>
#include <ODatum/Hash.h>





 namespace av {
 namespace msg {


RvaPathPlanningActivationState::RvaPathPlanningActivationState() = default;

RvaPathPlanningActivationState::RvaPathPlanningActivationState(
    ActivationState state_arg 
    ):
    state { std::move(state_arg) } // NOLINT
      {
}

RvaPathPlanningActivationState::RvaPathPlanningActivationState(const RvaPathPlanningActivationState&) = default;

// NOLINTNEXTLINE
RvaPathPlanningActivationState::RvaPathPlanningActivationState(RvaPathPlanningActivationState&&) = default;

RvaPathPlanningActivationState& RvaPathPlanningActivationState::operator=(const RvaPathPlanningActivationState&) = default;

// NOLINTNEXTLINE
RvaPathPlanningActivationState& RvaPathPlanningActivationState::operator=(RvaPathPlanningActivationState&&) = default;

void RvaPathPlanningActivationState::toCsv(std::ostream& out) const
{
    out.precision(16);
    out << std::boolalpha;
    out << static_cast<uint32_t>(state);
    
}

std::stringstream RvaPathPlanningActivationState::toStringstream() const
{
    std::stringstream out;
    toCsv(out);
    return out;
}

template<class Archive>
    void RvaPathPlanningActivationState::serialize(Archive& ar, [[maybe_unused]] unsigned int version)
    {

        ar& CEREAL_NVP(state);
    }


template void RvaPathPlanningActivationState::serialize(cereal::BinaryInputArchive& ar, unsigned int version);
template void RvaPathPlanningActivationState::serialize(cereal::BinaryOutputArchive& ar, unsigned int version);
template void RvaPathPlanningActivationState::serialize(cereal::IntrospectionArchive& ar, unsigned int version);
template void RvaPathPlanningActivationState::serialize(cereal::JSONInputArchive& ar, unsigned int version);
template void RvaPathPlanningActivationState::serialize(cereal::JSONOutputArchive& ar, unsigned int version);
template void RvaPathPlanningActivationState::serialize(cereal::PortableBinaryInputArchive& ar, unsigned int version);
template void RvaPathPlanningActivationState::serialize(cereal::PortableBinaryOutputArchive& ar, unsigned int version);

std::ostream& operator<< (std::ostream& os, const RvaPathPlanningActivationState& rvapathplanningactivationstate)
{
    rvapathplanningactivationstate.toCsv(os);
    return os;
}

bool operator== (const RvaPathPlanningActivationState &lhs, const RvaPathPlanningActivationState &rhs)
{
    return (  lhs.state== rhs.state 
    );
}

std::size_t RvaPathPlanningActivationState::hash() const noexcept
{
    std::size_t result = 17;
    result = result * 31 + std::hash<ActivationState>()(state);
    return result;
}

 } // namespace av
 } // namespace msg


CEREAL_BIND_TO_ARCHIVES(av::msg::RvaPathPlanningActivationState)

