#include <interfaces/RvaPathPlanningStatusEvent/RvaPathPlanningStatusEvent.h>

#include <iterator>
#include <type_traits>

#include <cereal/cereal.hpp>
#include <cereal/archives/json.hpp>
#include <cereal/archives/binary.hpp>

#include <cereal/types/map.hpp>
#include <cereal/types/vector.hpp>
#include <cereal/types/array.hpp>
#include <cereal/types/string.hpp>
#include <cereal/types/complex.hpp>

#include <ODatum/IntrospectionArchive.h>
#include <ODatum/Hash.h>





 namespace av {
 namespace msg {
 namespace rva {
 namespace hmi_metric {


RvaPathPlanningStatusEvent::RvaPathPlanningStatusEvent() = default;

RvaPathPlanningStatusEvent::RvaPathPlanningStatusEvent(
    bool pathAccepted_arg ,
    bool pathSelected_arg 
    ):
    pathAccepted { std::move(pathAccepted_arg) } // NOLINT
      ,pathSelected { std::move(pathSelected_arg) } // NOLINT
      {
}

RvaPathPlanningStatusEvent::RvaPathPlanningStatusEvent(const RvaPathPlanningStatusEvent&) = default;

// NOLINTNEXTLINE
RvaPathPlanningStatusEvent::RvaPathPlanningStatusEvent(RvaPathPlanningStatusEvent&&) = default;

RvaPathPlanningStatusEvent& RvaPathPlanningStatusEvent::operator=(const RvaPathPlanningStatusEvent&) = default;

// NOLINTNEXTLINE
RvaPathPlanningStatusEvent& RvaPathPlanningStatusEvent::operator=(RvaPathPlanningStatusEvent&&) = default;

void RvaPathPlanningStatusEvent::toCsv(std::ostream& out) const
{
    out.precision(16);
    out << std::boolalpha;
    out << pathAccepted;out << ",";
    out << pathSelected;
    
}

std::stringstream RvaPathPlanningStatusEvent::toStringstream() const
{
    std::stringstream out;
    toCsv(out);
    return out;
}

template<class Archive>
    void RvaPathPlanningStatusEvent::serialize(Archive& ar, [[maybe_unused]] unsigned int version)
    {

        ar& CEREAL_NVP(pathAccepted);
        ar& CEREAL_NVP(pathSelected);
    }


template void RvaPathPlanningStatusEvent::serialize(cereal::BinaryInputArchive& ar, unsigned int version);
template void RvaPathPlanningStatusEvent::serialize(cereal::BinaryOutputArchive& ar, unsigned int version);
template void RvaPathPlanningStatusEvent::serialize(cereal::IntrospectionArchive& ar, unsigned int version);
template void RvaPathPlanningStatusEvent::serialize(cereal::JSONInputArchive& ar, unsigned int version);
template void RvaPathPlanningStatusEvent::serialize(cereal::JSONOutputArchive& ar, unsigned int version);
template void RvaPathPlanningStatusEvent::serialize(cereal::PortableBinaryInputArchive& ar, unsigned int version);
template void RvaPathPlanningStatusEvent::serialize(cereal::PortableBinaryOutputArchive& ar, unsigned int version);

std::ostream& operator<< (std::ostream& os, const RvaPathPlanningStatusEvent& rvapathplanningstatusevent)
{
    rvapathplanningstatusevent.toCsv(os);
    return os;
}

bool operator== (const RvaPathPlanningStatusEvent &lhs, const RvaPathPlanningStatusEvent &rhs)
{
    return (  lhs.pathAccepted== rhs.pathAccepted &&
     lhs.pathSelected== rhs.pathSelected 
    );
}

std::size_t RvaPathPlanningStatusEvent::hash() const noexcept
{
    std::size_t result = 17;
    result = result * 31 + std::hash<bool>()(pathAccepted);
    result = result * 31 + std::hash<bool>()(pathSelected);
    return result;
}

 } // namespace av
 } // namespace msg
 } // namespace rva
 } // namespace hmi_metric


CEREAL_BIND_TO_ARCHIVES(av::msg::rva::hmi_metric::RvaPathPlanningStatusEvent)

