#include <interfaces/RvaSensorCleaningRequestUIEvent/RvaSensorCleaningRequestUIEvent.h>

#include <iterator>
#include <type_traits>

#include <cereal/cereal.hpp>
#include <cereal/archives/json.hpp>
#include <cereal/archives/binary.hpp>

#include <cereal/types/map.hpp>
#include <cereal/types/vector.hpp>
#include <cereal/types/array.hpp>
#include <cereal/types/string.hpp>
#include <cereal/types/complex.hpp>

#include <ODatum/IntrospectionArchive.h>
#include <ODatum/Hash.h>





 namespace av {
 namespace msg {
 namespace rva {
 namespace hmi_metric {


RvaSensorCleaningRequestUIEvent::RvaSensorCleaningRequestUIEvent() = default;

RvaSensorCleaningRequestUIEvent::RvaSensorCleaningRequestUIEvent(
    RvaSensorCleaningRequestUIEventType type_arg ,
    std::string commandId_arg ,
    std::string sensorId_arg ,
    bool keyboardUsed_arg 
    ):
    type { std::move(type_arg) } // NOLINT
      ,commandId { std::move(commandId_arg) } // NOLINT
      ,sensorId { std::move(sensorId_arg) } // NOLINT
      ,keyboardUsed { std::move(keyboardUsed_arg) } // NOLINT
      {
}

RvaSensorCleaningRequestUIEvent::RvaSensorCleaningRequestUIEvent(const RvaSensorCleaningRequestUIEvent&) = default;

// NOLINTNEXTLINE
RvaSensorCleaningRequestUIEvent::RvaSensorCleaningRequestUIEvent(RvaSensorCleaningRequestUIEvent&&) = default;

RvaSensorCleaningRequestUIEvent& RvaSensorCleaningRequestUIEvent::operator=(const RvaSensorCleaningRequestUIEvent&) = default;

// NOLINTNEXTLINE
RvaSensorCleaningRequestUIEvent& RvaSensorCleaningRequestUIEvent::operator=(RvaSensorCleaningRequestUIEvent&&) = default;

void RvaSensorCleaningRequestUIEvent::toCsv(std::ostream& out) const
{
    out.precision(16);
    out << std::boolalpha;
    out << static_cast<uint32_t>(type);out << ",";
    out << "\"";
        out << commandId;
        out << "\"";out << ",";
    out << "\"";
        out << sensorId;
        out << "\"";out << ",";
    out << keyboardUsed;
    
}

std::stringstream RvaSensorCleaningRequestUIEvent::toStringstream() const
{
    std::stringstream out;
    toCsv(out);
    return out;
}

template<class Archive>
    void RvaSensorCleaningRequestUIEvent::serialize(Archive& ar, [[maybe_unused]] unsigned int version)
    {

        ar& CEREAL_NVP(type);
        ar& CEREAL_NVP(commandId);
        ar& CEREAL_NVP(sensorId);
        ar& CEREAL_NVP(keyboardUsed);
    }


template void RvaSensorCleaningRequestUIEvent::serialize(cereal::BinaryInputArchive& ar, unsigned int version);
template void RvaSensorCleaningRequestUIEvent::serialize(cereal::BinaryOutputArchive& ar, unsigned int version);
template void RvaSensorCleaningRequestUIEvent::serialize(cereal::IntrospectionArchive& ar, unsigned int version);
template void RvaSensorCleaningRequestUIEvent::serialize(cereal::JSONInputArchive& ar, unsigned int version);
template void RvaSensorCleaningRequestUIEvent::serialize(cereal::JSONOutputArchive& ar, unsigned int version);
template void RvaSensorCleaningRequestUIEvent::serialize(cereal::PortableBinaryInputArchive& ar, unsigned int version);
template void RvaSensorCleaningRequestUIEvent::serialize(cereal::PortableBinaryOutputArchive& ar, unsigned int version);

std::ostream& operator<< (std::ostream& os, const RvaSensorCleaningRequestUIEvent& rvasensorcleaningrequestuievent)
{
    rvasensorcleaningrequestuievent.toCsv(os);
    return os;
}

bool operator== (const RvaSensorCleaningRequestUIEvent &lhs, const RvaSensorCleaningRequestUIEvent &rhs)
{
    return (  lhs.type== rhs.type &&
     lhs.commandId== rhs.commandId &&
     lhs.sensorId== rhs.sensorId &&
     lhs.keyboardUsed== rhs.keyboardUsed 
    );
}

std::size_t RvaSensorCleaningRequestUIEvent::hash() const noexcept
{
    std::size_t result = 17;
    result = result * 31 + std::hash<RvaSensorCleaningRequestUIEventType>()(type);
    result = result * 31 + std::hash<std::string>()(commandId);
    result = result * 31 + std::hash<std::string>()(sensorId);
    result = result * 31 + std::hash<bool>()(keyboardUsed);
    return result;
}

 } // namespace av
 } // namespace msg
 } // namespace rva
 } // namespace hmi_metric


CEREAL_BIND_TO_ARCHIVES(av::msg::rva::hmi_metric::RvaSensorCleaningRequestUIEvent)

