#include <interfaces/RvaSensorCleaningStatusEvent/RvaSensorCleaningStatusEvent.h>

#include <iterator>
#include <type_traits>

#include <cereal/cereal.hpp>
#include <cereal/archives/json.hpp>
#include <cereal/archives/binary.hpp>

#include <cereal/types/map.hpp>
#include <cereal/types/vector.hpp>
#include <cereal/types/array.hpp>
#include <cereal/types/string.hpp>
#include <cereal/types/complex.hpp>

#include <ODatum/IntrospectionArchive.h>
#include <ODatum/Hash.h>





 namespace av {
 namespace msg {
 namespace rva {
 namespace hmi_metric {


RvaSensorCleaningStatusEvent::RvaSensorCleaningStatusEvent() = default;

RvaSensorCleaningStatusEvent::RvaSensorCleaningStatusEvent(
    RvaSensorCleaningStatusEventType type_arg ,
    std::string commandId_arg ,
    std::string sensorId_arg ,
    std::string info_arg 
    ):
    type { std::move(type_arg) } // NOLINT
      ,commandId { std::move(commandId_arg) } // NOLINT
      ,sensorId { std::move(sensorId_arg) } // NOLINT
      ,info { std::move(info_arg) } // NOLINT
      {
}

RvaSensorCleaningStatusEvent::RvaSensorCleaningStatusEvent(const RvaSensorCleaningStatusEvent&) = default;

// NOLINTNEXTLINE
RvaSensorCleaningStatusEvent::RvaSensorCleaningStatusEvent(RvaSensorCleaningStatusEvent&&) = default;

RvaSensorCleaningStatusEvent& RvaSensorCleaningStatusEvent::operator=(const RvaSensorCleaningStatusEvent&) = default;

// NOLINTNEXTLINE
RvaSensorCleaningStatusEvent& RvaSensorCleaningStatusEvent::operator=(RvaSensorCleaningStatusEvent&&) = default;

void RvaSensorCleaningStatusEvent::toCsv(std::ostream& out) const
{
    out.precision(16);
    out << std::boolalpha;
    out << static_cast<uint32_t>(type);out << ",";
    out << "\"";
        out << commandId;
        out << "\"";out << ",";
    out << "\"";
        out << sensorId;
        out << "\"";out << ",";
    out << "\"";
        out << info;
        out << "\"";
    
}

std::stringstream RvaSensorCleaningStatusEvent::toStringstream() const
{
    std::stringstream out;
    toCsv(out);
    return out;
}

template<class Archive>
    void RvaSensorCleaningStatusEvent::serialize(Archive& ar, [[maybe_unused]] unsigned int version)
    {

        ar& CEREAL_NVP(type);
        ar& CEREAL_NVP(commandId);
        ar& CEREAL_NVP(sensorId);
        ar& CEREAL_NVP(info);
    }


template void RvaSensorCleaningStatusEvent::serialize(cereal::BinaryInputArchive& ar, unsigned int version);
template void RvaSensorCleaningStatusEvent::serialize(cereal::BinaryOutputArchive& ar, unsigned int version);
template void RvaSensorCleaningStatusEvent::serialize(cereal::IntrospectionArchive& ar, unsigned int version);
template void RvaSensorCleaningStatusEvent::serialize(cereal::JSONInputArchive& ar, unsigned int version);
template void RvaSensorCleaningStatusEvent::serialize(cereal::JSONOutputArchive& ar, unsigned int version);
template void RvaSensorCleaningStatusEvent::serialize(cereal::PortableBinaryInputArchive& ar, unsigned int version);
template void RvaSensorCleaningStatusEvent::serialize(cereal::PortableBinaryOutputArchive& ar, unsigned int version);

std::ostream& operator<< (std::ostream& os, const RvaSensorCleaningStatusEvent& rvasensorcleaningstatusevent)
{
    rvasensorcleaningstatusevent.toCsv(os);
    return os;
}

bool operator== (const RvaSensorCleaningStatusEvent &lhs, const RvaSensorCleaningStatusEvent &rhs)
{
    return (  lhs.type== rhs.type &&
     lhs.commandId== rhs.commandId &&
     lhs.sensorId== rhs.sensorId &&
     lhs.info== rhs.info 
    );
}

std::size_t RvaSensorCleaningStatusEvent::hash() const noexcept
{
    std::size_t result = 17;
    result = result * 31 + std::hash<RvaSensorCleaningStatusEventType>()(type);
    result = result * 31 + std::hash<std::string>()(commandId);
    result = result * 31 + std::hash<std::string>()(sensorId);
    result = result * 31 + std::hash<std::string>()(info);
    return result;
}

 } // namespace av
 } // namespace msg
 } // namespace rva
 } // namespace hmi_metric


CEREAL_BIND_TO_ARCHIVES(av::msg::rva::hmi_metric::RvaSensorCleaningStatusEvent)

