#include <interfaces/RvaWaitAndGoMsg/RvaWaitAndGoMsg.h>

#include <iterator>
#include <type_traits>

#include <cereal/cereal.hpp>
#include <cereal/archives/json.hpp>
#include <cereal/archives/binary.hpp>

#include <cereal/types/map.hpp>
#include <cereal/types/vector.hpp>
#include <cereal/types/array.hpp>
#include <cereal/types/string.hpp>
#include <cereal/types/complex.hpp>

#include <ODatum/IntrospectionArchive.h>
#include <ODatum/Hash.h>





 namespace av {
 namespace msg {


RvaWaitAndGoMsg::RvaWaitAndGoMsg() = default;

RvaWaitAndGoMsg::RvaWaitAndGoMsg(
    TimePoint timestamp_arg ,
    WaitAndGo command_arg 
    ):
    timestamp { std::move(timestamp_arg) } // NOLINT
      ,command { std::move(command_arg) } // NOLINT
      {
}

RvaWaitAndGoMsg::RvaWaitAndGoMsg(const RvaWaitAndGoMsg&) = default;

// NOLINTNEXTLINE
RvaWaitAndGoMsg::RvaWaitAndGoMsg(RvaWaitAndGoMsg&&) = default;

RvaWaitAndGoMsg& RvaWaitAndGoMsg::operator=(const RvaWaitAndGoMsg&) = default;

// NOLINTNEXTLINE
RvaWaitAndGoMsg& RvaWaitAndGoMsg::operator=(RvaWaitAndGoMsg&&) = default;

void RvaWaitAndGoMsg::toCsv(std::ostream& out) const
{
    out.precision(16);
    out << std::boolalpha;
    out << timestamp;out << ",";
    out << static_cast<uint32_t>(command);
    
}

std::stringstream RvaWaitAndGoMsg::toStringstream() const
{
    std::stringstream out;
    toCsv(out);
    return out;
}

template<class Archive>
    void RvaWaitAndGoMsg::serialize(Archive& ar, [[maybe_unused]] unsigned int version)
    {

        ar& CEREAL_NVP(timestamp);
        ar& CEREAL_NVP(command);
    }


template void RvaWaitAndGoMsg::serialize(cereal::BinaryInputArchive& ar, unsigned int version);
template void RvaWaitAndGoMsg::serialize(cereal::BinaryOutputArchive& ar, unsigned int version);
template void RvaWaitAndGoMsg::serialize(cereal::IntrospectionArchive& ar, unsigned int version);
template void RvaWaitAndGoMsg::serialize(cereal::JSONInputArchive& ar, unsigned int version);
template void RvaWaitAndGoMsg::serialize(cereal::JSONOutputArchive& ar, unsigned int version);
template void RvaWaitAndGoMsg::serialize(cereal::PortableBinaryInputArchive& ar, unsigned int version);
template void RvaWaitAndGoMsg::serialize(cereal::PortableBinaryOutputArchive& ar, unsigned int version);

std::ostream& operator<< (std::ostream& os, const RvaWaitAndGoMsg& rvawaitandgomsg)
{
    rvawaitandgomsg.toCsv(os);
    return os;
}

bool operator== (const RvaWaitAndGoMsg &lhs, const RvaWaitAndGoMsg &rhs)
{
    return (  lhs.timestamp== rhs.timestamp &&
     lhs.command== rhs.command 
    );
}

std::size_t RvaWaitAndGoMsg::hash() const noexcept
{
    std::size_t result = 17;
    result = result * 31 + 0;
    result = result * 31 + std::hash<WaitAndGo>()(command);
    return result;
}

 } // namespace av
 } // namespace msg


CEREAL_BIND_TO_ARCHIVES(av::msg::RvaWaitAndGoMsg)

