#include <interfaces/RvaWaitAndGoUIEvent/RvaWaitAndGoUIEvent.h>

#include <iterator>
#include <type_traits>

#include <cereal/cereal.hpp>
#include <cereal/archives/json.hpp>
#include <cereal/archives/binary.hpp>

#include <cereal/types/map.hpp>
#include <cereal/types/vector.hpp>
#include <cereal/types/array.hpp>
#include <cereal/types/string.hpp>
#include <cereal/types/complex.hpp>

#include <ODatum/IntrospectionArchive.h>
#include <ODatum/Hash.h>





 namespace av {
 namespace msg {
 namespace rva {
 namespace hmi_metric {


RvaWaitAndGoUIEvent::RvaWaitAndGoUIEvent() = default;

RvaWaitAndGoUIEvent::RvaWaitAndGoUIEvent(
    RvaWaitAndGoUIEventType type_arg ,
    bool keyboardUsed_arg 
    ):
    type { std::move(type_arg) } // NOLINT
      ,keyboardUsed { std::move(keyboardUsed_arg) } // NOLINT
      {
}

RvaWaitAndGoUIEvent::RvaWaitAndGoUIEvent(const RvaWaitAndGoUIEvent&) = default;

// NOLINTNEXTLINE
RvaWaitAndGoUIEvent::RvaWaitAndGoUIEvent(RvaWaitAndGoUIEvent&&) = default;

RvaWaitAndGoUIEvent& RvaWaitAndGoUIEvent::operator=(const RvaWaitAndGoUIEvent&) = default;

// NOLINTNEXTLINE
RvaWaitAndGoUIEvent& RvaWaitAndGoUIEvent::operator=(RvaWaitAndGoUIEvent&&) = default;

void RvaWaitAndGoUIEvent::toCsv(std::ostream& out) const
{
    out.precision(16);
    out << std::boolalpha;
    out << static_cast<uint32_t>(type);out << ",";
    out << keyboardUsed;
    
}

std::stringstream RvaWaitAndGoUIEvent::toStringstream() const
{
    std::stringstream out;
    toCsv(out);
    return out;
}

template<class Archive>
    void RvaWaitAndGoUIEvent::serialize(Archive& ar, [[maybe_unused]] unsigned int version)
    {

        ar& CEREAL_NVP(type);
        ar& CEREAL_NVP(keyboardUsed);
    }


template void RvaWaitAndGoUIEvent::serialize(cereal::BinaryInputArchive& ar, unsigned int version);
template void RvaWaitAndGoUIEvent::serialize(cereal::BinaryOutputArchive& ar, unsigned int version);
template void RvaWaitAndGoUIEvent::serialize(cereal::IntrospectionArchive& ar, unsigned int version);
template void RvaWaitAndGoUIEvent::serialize(cereal::JSONInputArchive& ar, unsigned int version);
template void RvaWaitAndGoUIEvent::serialize(cereal::JSONOutputArchive& ar, unsigned int version);
template void RvaWaitAndGoUIEvent::serialize(cereal::PortableBinaryInputArchive& ar, unsigned int version);
template void RvaWaitAndGoUIEvent::serialize(cereal::PortableBinaryOutputArchive& ar, unsigned int version);

std::ostream& operator<< (std::ostream& os, const RvaWaitAndGoUIEvent& rvawaitandgouievent)
{
    rvawaitandgouievent.toCsv(os);
    return os;
}

bool operator== (const RvaWaitAndGoUIEvent &lhs, const RvaWaitAndGoUIEvent &rhs)
{
    return (  lhs.type== rhs.type &&
     lhs.keyboardUsed== rhs.keyboardUsed 
    );
}

std::size_t RvaWaitAndGoUIEvent::hash() const noexcept
{
    std::size_t result = 17;
    result = result * 31 + std::hash<RvaWaitAndGoUIEventType>()(type);
    result = result * 31 + std::hash<bool>()(keyboardUsed);
    return result;
}

 } // namespace av
 } // namespace msg
 } // namespace rva
 } // namespace hmi_metric


CEREAL_BIND_TO_ARCHIVES(av::msg::rva::hmi_metric::RvaWaitAndGoUIEvent)

