#include <interfaces/RvaZoomUIEvent/RvaZoomUIEvent.h>

#include <iterator>
#include <type_traits>

#include <cereal/cereal.hpp>
#include <cereal/archives/json.hpp>
#include <cereal/archives/binary.hpp>

#include <cereal/types/map.hpp>
#include <cereal/types/vector.hpp>
#include <cereal/types/array.hpp>
#include <cereal/types/string.hpp>
#include <cereal/types/complex.hpp>

#include <ODatum/IntrospectionArchive.h>
#include <ODatum/Hash.h>





 namespace av {
 namespace msg {
 namespace rva {
 namespace hmi_metric {


RvaZoomUIEvent::RvaZoomUIEvent() = default;

RvaZoomUIEvent::RvaZoomUIEvent(
    RvaZoomUIEventType type_arg ,
    bool keyboardUsed_arg 
    ):
    type { std::move(type_arg) } // NOLINT
      ,keyboardUsed { std::move(keyboardUsed_arg) } // NOLINT
      {
}

RvaZoomUIEvent::RvaZoomUIEvent(const RvaZoomUIEvent&) = default;

// NOLINTNEXTLINE
RvaZoomUIEvent::RvaZoomUIEvent(RvaZoomUIEvent&&) = default;

RvaZoomUIEvent& RvaZoomUIEvent::operator=(const RvaZoomUIEvent&) = default;

// NOLINTNEXTLINE
RvaZoomUIEvent& RvaZoomUIEvent::operator=(RvaZoomUIEvent&&) = default;

void RvaZoomUIEvent::toCsv(std::ostream& out) const
{
    out.precision(16);
    out << std::boolalpha;
    out << static_cast<uint32_t>(type);out << ",";
    out << keyboardUsed;
    
}

std::stringstream RvaZoomUIEvent::toStringstream() const
{
    std::stringstream out;
    toCsv(out);
    return out;
}

template<class Archive>
    void RvaZoomUIEvent::serialize(Archive& ar, [[maybe_unused]] unsigned int version)
    {

        ar& CEREAL_NVP(type);
        ar& CEREAL_NVP(keyboardUsed);
    }


template void RvaZoomUIEvent::serialize(cereal::BinaryInputArchive& ar, unsigned int version);
template void RvaZoomUIEvent::serialize(cereal::BinaryOutputArchive& ar, unsigned int version);
template void RvaZoomUIEvent::serialize(cereal::IntrospectionArchive& ar, unsigned int version);
template void RvaZoomUIEvent::serialize(cereal::JSONInputArchive& ar, unsigned int version);
template void RvaZoomUIEvent::serialize(cereal::JSONOutputArchive& ar, unsigned int version);
template void RvaZoomUIEvent::serialize(cereal::PortableBinaryInputArchive& ar, unsigned int version);
template void RvaZoomUIEvent::serialize(cereal::PortableBinaryOutputArchive& ar, unsigned int version);

std::ostream& operator<< (std::ostream& os, const RvaZoomUIEvent& rvazoomuievent)
{
    rvazoomuievent.toCsv(os);
    return os;
}

bool operator== (const RvaZoomUIEvent &lhs, const RvaZoomUIEvent &rhs)
{
    return (  lhs.type== rhs.type &&
     lhs.keyboardUsed== rhs.keyboardUsed 
    );
}

std::size_t RvaZoomUIEvent::hash() const noexcept
{
    std::size_t result = 17;
    result = result * 31 + std::hash<RvaZoomUIEventType>()(type);
    result = result * 31 + std::hash<bool>()(keyboardUsed);
    return result;
}

 } // namespace av
 } // namespace msg
 } // namespace rva
 } // namespace hmi_metric


CEREAL_BIND_TO_ARCHIVES(av::msg::rva::hmi_metric::RvaZoomUIEvent)

