#include <interfaces/SH1_Protocol_Version_avt/SH1_Protocol_Version_avt.h>

#include <iterator>
#include <type_traits>

#include <cereal/cereal.hpp>
#include <cereal/archives/json.hpp>
#include <cereal/archives/binary.hpp>

#include <cereal/types/map.hpp>
#include <cereal/types/vector.hpp>
#include <cereal/types/array.hpp>
#include <cereal/types/string.hpp>
#include <cereal/types/complex.hpp>

#include <ODatum/IntrospectionArchive.h>
#include <ODatum/Hash.h>





 namespace av {
 namespace msg {


SH1_Protocol_Version_avt::SH1_Protocol_Version_avt() = default;

SH1_Protocol_Version_avt::SH1_Protocol_Version_avt(
    uint8_t SH1_Protocol_Major_arg ,
    uint8_t SH1_Protocol_Minor_arg ,
    uint8_t ALIV_SH1_Protocol_Version_arg ,
    uint8_t CRC_SH1_Protocol_Version_arg 
    ):
    SH1_Protocol_Major { std::move(SH1_Protocol_Major_arg) } // NOLINT
      ,SH1_Protocol_Minor { std::move(SH1_Protocol_Minor_arg) } // NOLINT
      ,ALIV_SH1_Protocol_Version { std::move(ALIV_SH1_Protocol_Version_arg) } // NOLINT
      ,CRC_SH1_Protocol_Version { std::move(CRC_SH1_Protocol_Version_arg) } // NOLINT
      {
}

SH1_Protocol_Version_avt::SH1_Protocol_Version_avt(const SH1_Protocol_Version_avt&) = default;

// NOLINTNEXTLINE
SH1_Protocol_Version_avt::SH1_Protocol_Version_avt(SH1_Protocol_Version_avt&&) = default;

SH1_Protocol_Version_avt& SH1_Protocol_Version_avt::operator=(const SH1_Protocol_Version_avt&) = default;

// NOLINTNEXTLINE
SH1_Protocol_Version_avt& SH1_Protocol_Version_avt::operator=(SH1_Protocol_Version_avt&&) = default;

void SH1_Protocol_Version_avt::toCsv(std::ostream& out) const
{
    out.precision(16);
    out << std::boolalpha;
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(SH1_Protocol_Major);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(SH1_Protocol_Minor);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(ALIV_SH1_Protocol_Version);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(CRC_SH1_Protocol_Version);
    
}

std::stringstream SH1_Protocol_Version_avt::toStringstream() const
{
    std::stringstream out;
    toCsv(out);
    return out;
}

template<class Archive>
    void SH1_Protocol_Version_avt::serialize(Archive& ar, [[maybe_unused]] unsigned int version)
    {

        ar& CEREAL_NVP(SH1_Protocol_Major);
        ar& CEREAL_NVP(SH1_Protocol_Minor);
        ar& CEREAL_NVP(ALIV_SH1_Protocol_Version);
        ar& CEREAL_NVP(CRC_SH1_Protocol_Version);
    }


template void SH1_Protocol_Version_avt::serialize(cereal::BinaryInputArchive& ar, unsigned int version);
template void SH1_Protocol_Version_avt::serialize(cereal::BinaryOutputArchive& ar, unsigned int version);
template void SH1_Protocol_Version_avt::serialize(cereal::IntrospectionArchive& ar, unsigned int version);
template void SH1_Protocol_Version_avt::serialize(cereal::JSONInputArchive& ar, unsigned int version);
template void SH1_Protocol_Version_avt::serialize(cereal::JSONOutputArchive& ar, unsigned int version);
template void SH1_Protocol_Version_avt::serialize(cereal::PortableBinaryInputArchive& ar, unsigned int version);
template void SH1_Protocol_Version_avt::serialize(cereal::PortableBinaryOutputArchive& ar, unsigned int version);

std::ostream& operator<< (std::ostream& os, const SH1_Protocol_Version_avt& sh1_protocol_version_avt)
{
    sh1_protocol_version_avt.toCsv(os);
    return os;
}

bool operator== (const SH1_Protocol_Version_avt &lhs, const SH1_Protocol_Version_avt &rhs)
{
    return (  lhs.SH1_Protocol_Major== rhs.SH1_Protocol_Major &&
     lhs.SH1_Protocol_Minor== rhs.SH1_Protocol_Minor &&
     lhs.ALIV_SH1_Protocol_Version== rhs.ALIV_SH1_Protocol_Version &&
     lhs.CRC_SH1_Protocol_Version== rhs.CRC_SH1_Protocol_Version 
    );
}

std::size_t SH1_Protocol_Version_avt::hash() const noexcept
{
    std::size_t result = 17;
    result = result * 31 + std::hash<uint8_t>()(SH1_Protocol_Major);
    result = result * 31 + std::hash<uint8_t>()(SH1_Protocol_Minor);
    result = result * 31 + std::hash<uint8_t>()(ALIV_SH1_Protocol_Version);
    result = result * 31 + std::hash<uint8_t>()(CRC_SH1_Protocol_Version);
    return result;
}

 } // namespace av
 } // namespace msg


CEREAL_BIND_TO_ARCHIVES(av::msg::SH1_Protocol_Version_avt)

