#include <interfaces/SH2_Error_State_avt/SH2_Error_State_avt.h>

#include <iterator>
#include <type_traits>

#include <cereal/cereal.hpp>
#include <cereal/archives/json.hpp>
#include <cereal/archives/binary.hpp>

#include <cereal/types/map.hpp>
#include <cereal/types/vector.hpp>
#include <cereal/types/array.hpp>
#include <cereal/types/string.hpp>
#include <cereal/types/complex.hpp>

#include <ODatum/IntrospectionArchive.h>
#include <ODatum/Hash.h>





 namespace av {
 namespace msg {


SH2_Error_State_avt::SH2_Error_State_avt() = default;

SH2_Error_State_avt::SH2_Error_State_avt(
    std::vector<bool> B_SH2Fault1_arg 
    ):
    B_SH2Fault1 { std::move(B_SH2Fault1_arg) } // NOLINT
      {
}

SH2_Error_State_avt::SH2_Error_State_avt(const SH2_Error_State_avt&) = default;

// NOLINTNEXTLINE
SH2_Error_State_avt::SH2_Error_State_avt(SH2_Error_State_avt&&) = default;

SH2_Error_State_avt& SH2_Error_State_avt::operator=(const SH2_Error_State_avt&) = default;

// NOLINTNEXTLINE
SH2_Error_State_avt& SH2_Error_State_avt::operator=(SH2_Error_State_avt&&) = default;

void SH2_Error_State_avt::toCsv(std::ostream& out) const
{
    out.precision(16);
    out << std::boolalpha;
    // Enclose sequence in double quotations and curly brackets to keep CSV line length uniform
        
        out << "\"{{";
        
        if (!B_SH2Fault1.empty())
        {
            std::copy(B_SH2Fault1.begin(), B_SH2Fault1.end() - 1, std::ostream_iterator<bool>(out, "},{"));
            std::copy(B_SH2Fault1.end()-1, B_SH2Fault1.end(), std::ostream_iterator<bool>(out, ""));
        }
        out << "}}\"";
    
}

std::stringstream SH2_Error_State_avt::toStringstream() const
{
    std::stringstream out;
    toCsv(out);
    return out;
}

template<class Archive>
    void SH2_Error_State_avt::serialize(Archive& ar, [[maybe_unused]] unsigned int version)
    {

        ar& CEREAL_NVP(B_SH2Fault1);
    }


template void SH2_Error_State_avt::serialize(cereal::BinaryInputArchive& ar, unsigned int version);
template void SH2_Error_State_avt::serialize(cereal::BinaryOutputArchive& ar, unsigned int version);
template void SH2_Error_State_avt::serialize(cereal::IntrospectionArchive& ar, unsigned int version);
template void SH2_Error_State_avt::serialize(cereal::JSONInputArchive& ar, unsigned int version);
template void SH2_Error_State_avt::serialize(cereal::JSONOutputArchive& ar, unsigned int version);
template void SH2_Error_State_avt::serialize(cereal::PortableBinaryInputArchive& ar, unsigned int version);
template void SH2_Error_State_avt::serialize(cereal::PortableBinaryOutputArchive& ar, unsigned int version);

std::ostream& operator<< (std::ostream& os, const SH2_Error_State_avt& sh2_error_state_avt)
{
    sh2_error_state_avt.toCsv(os);
    return os;
}

bool operator== (const SH2_Error_State_avt &lhs, const SH2_Error_State_avt &rhs)
{
    return (  lhs.B_SH2Fault1== rhs.B_SH2Fault1 
    );
}

std::size_t SH2_Error_State_avt::hash() const noexcept
{
    std::size_t result = 17;
    result = result * 31 + hashVector(B_SH2Fault1);
    return result;
}

 } // namespace av
 } // namespace msg


CEREAL_BIND_TO_ARCHIVES(av::msg::SH2_Error_State_avt)

