#include <interfaces/SH2_Outputs_avt/SH2_Outputs_avt.h>

#include <iterator>
#include <type_traits>

#include <cereal/cereal.hpp>
#include <cereal/archives/json.hpp>
#include <cereal/archives/binary.hpp>

#include <cereal/types/map.hpp>
#include <cereal/types/vector.hpp>
#include <cereal/types/array.hpp>
#include <cereal/types/string.hpp>
#include <cereal/types/complex.hpp>

#include <ODatum/IntrospectionArchive.h>
#include <ODatum/Hash.h>





 namespace av {
 namespace msg {


SH2_Outputs_avt::SH2_Outputs_avt() = default;

SH2_Outputs_avt::SH2_Outputs_avt(
    STS_DOGSwState sts_DOGSwState_arg ,
    STS_DOGState sts_DOGState_arg ,
    B_DecelRequestSH2Type B_DecelRequestSH2_arg ,
    uint8_t b_ThrottleOffSH2_arg ,
    uint8_t b_BrakePreChargeSH2_arg ,
    uint8_t aliv_SH2_Outputs_arg 
    ):
    sts_DOGSwState { std::move(sts_DOGSwState_arg) } // NOLINT
      ,sts_DOGState { std::move(sts_DOGState_arg) } // NOLINT
      ,B_DecelRequestSH2 { std::move(B_DecelRequestSH2_arg) } // NOLINT
      ,b_ThrottleOffSH2 { std::move(b_ThrottleOffSH2_arg) } // NOLINT
      ,b_BrakePreChargeSH2 { std::move(b_BrakePreChargeSH2_arg) } // NOLINT
      ,aliv_SH2_Outputs { std::move(aliv_SH2_Outputs_arg) } // NOLINT
      {
}

SH2_Outputs_avt::SH2_Outputs_avt(const SH2_Outputs_avt&) = default;

// NOLINTNEXTLINE
SH2_Outputs_avt::SH2_Outputs_avt(SH2_Outputs_avt&&) = default;

SH2_Outputs_avt& SH2_Outputs_avt::operator=(const SH2_Outputs_avt&) = default;

// NOLINTNEXTLINE
SH2_Outputs_avt& SH2_Outputs_avt::operator=(SH2_Outputs_avt&&) = default;

void SH2_Outputs_avt::toCsv(std::ostream& out) const
{
    out.precision(16);
    out << std::boolalpha;
    out << static_cast<uint32_t>(sts_DOGSwState);out << ",";
    out << static_cast<uint32_t>(sts_DOGState);out << ",";
    out << static_cast<uint32_t>(B_DecelRequestSH2);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(b_ThrottleOffSH2);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(b_BrakePreChargeSH2);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(aliv_SH2_Outputs);
    
}

std::stringstream SH2_Outputs_avt::toStringstream() const
{
    std::stringstream out;
    toCsv(out);
    return out;
}

template<class Archive>
    void SH2_Outputs_avt::serialize(Archive& ar, unsigned int version)
{
    if(version >= 2)
    {
        ar& CEREAL_NVP(sts_DOGSwState);
        ar& CEREAL_NVP(sts_DOGState);
        ar& CEREAL_NVP(B_DecelRequestSH2);
        ar& CEREAL_NVP(b_ThrottleOffSH2);
        ar& CEREAL_NVP(b_BrakePreChargeSH2);
        ar& CEREAL_NVP(aliv_SH2_Outputs);
    }
}


template void SH2_Outputs_avt::serialize(cereal::BinaryInputArchive& ar, unsigned int version);
template void SH2_Outputs_avt::serialize(cereal::BinaryOutputArchive& ar, unsigned int version);
template void SH2_Outputs_avt::serialize(cereal::IntrospectionArchive& ar, unsigned int version);
template void SH2_Outputs_avt::serialize(cereal::JSONInputArchive& ar, unsigned int version);
template void SH2_Outputs_avt::serialize(cereal::JSONOutputArchive& ar, unsigned int version);
template void SH2_Outputs_avt::serialize(cereal::PortableBinaryInputArchive& ar, unsigned int version);
template void SH2_Outputs_avt::serialize(cereal::PortableBinaryOutputArchive& ar, unsigned int version);

std::ostream& operator<< (std::ostream& os, const SH2_Outputs_avt& sh2_outputs_avt)
{
    sh2_outputs_avt.toCsv(os);
    return os;
}

bool operator== (const SH2_Outputs_avt &lhs, const SH2_Outputs_avt &rhs)
{
    return (  lhs.sts_DOGSwState== rhs.sts_DOGSwState &&
     lhs.sts_DOGState== rhs.sts_DOGState &&
     lhs.B_DecelRequestSH2== rhs.B_DecelRequestSH2 &&
     lhs.b_ThrottleOffSH2== rhs.b_ThrottleOffSH2 &&
     lhs.b_BrakePreChargeSH2== rhs.b_BrakePreChargeSH2 &&
     lhs.aliv_SH2_Outputs== rhs.aliv_SH2_Outputs 
    );
}

std::size_t SH2_Outputs_avt::hash() const noexcept
{
    std::size_t result = 17;
    result = result * 31 + std::hash<STS_DOGSwState>()(sts_DOGSwState);
    result = result * 31 + std::hash<STS_DOGState>()(sts_DOGState);
    result = result * 31 + std::hash<B_DecelRequestSH2Type>()(B_DecelRequestSH2);
    result = result * 31 + std::hash<uint8_t>()(b_ThrottleOffSH2);
    result = result * 31 + std::hash<uint8_t>()(b_BrakePreChargeSH2);
    result = result * 31 + std::hash<uint8_t>()(aliv_SH2_Outputs);
    return result;
}

 } // namespace av
 } // namespace msg


CEREAL_BIND_TO_ARCHIVES(av::msg::SH2_Outputs_avt)

