/*!
 ***********************************************************************************************************************
 * APTIV PRIVILEGED AND CONFIDENTIAL
 *
 * THIS IS AN AUTO GENERATED FILE!
 * DO NOT EDIT BY HAND!
 * check platform/idl_generator/jinja_templates/struct.template
 *
 * @brief Auto Generated Cereal Interface
 *
 * @section License
 *
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTE: Removing this heading is prohibited.
 *
 * @section Open Source License List
 *
 * This is a list of any open-source project used by this file.
 ***********************************************************************************************************************
 */

#ifndef _SYSTEMHEALTHMESSAGE_AVT_H_
#define _SYSTEMHEALTHMESSAGE_AVT_H_

#include <ODatum/ODatum.h>
#include <interfaces/traits/csvable.h>

#include <interfaces/SystemHealthMessage_avtDefinitions.hpp>






 namespace av {
 namespace msg {


class SystemMemInfo
    : public csvable
    , public aptv::ODatum
{
public:
    SystemMemInfo();

    SystemMemInfo(
        uint64_t total_kb_arg ,
        uint64_t free_kb_arg ,
        uint64_t available_kb_arg ,
        uint64_t buffers_kb_arg ,
        uint64_t cached_kb_arg 
        );

    SystemMemInfo(const SystemMemInfo&);

    // NOLINTNEXTLINE
    SystemMemInfo(SystemMemInfo&&);

    SystemMemInfo& operator=(const SystemMemInfo&);

    // NOLINTNEXTLINE
    SystemMemInfo& operator=(SystemMemInfo&&);

    
    uint64_t total_kb
    {};
    uint64_t free_kb
    {};
    uint64_t available_kb
    {};
    uint64_t buffers_kb
    {};
    uint64_t cached_kb
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const SystemMemInfo& systemmeminfo);

    friend bool operator== (const SystemMemInfo &lhs, const SystemMemInfo &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::SystemMemInfo>
{
    std::size_t operator()(av::msg::SystemMemInfo const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::SystemMemInfo, 1)
ODATUM_NAMED_TYPE(av::msg::SystemMemInfo)

 namespace av {
 namespace msg {


class GpuDeviceData
    : public csvable
    , public aptv::ODatum
{
public:
    GpuDeviceData();

    GpuDeviceData(
        int32_t utilization__arg ,
        int64_t memoryUsage__arg ,
        int64_t vramApertureUsage__arg ,
        int32_t temperature__arg ,
        int32_t powerUsage__arg ,
        int32_t graphicsClockSpeed__arg ,
        int32_t smClockSpeed__arg ,
        int32_t memClockSpeed__arg ,
        int32_t videoClockSpeed__arg 
        );

    GpuDeviceData(const GpuDeviceData&);

    // NOLINTNEXTLINE
    GpuDeviceData(GpuDeviceData&&);

    GpuDeviceData& operator=(const GpuDeviceData&);

    // NOLINTNEXTLINE
    GpuDeviceData& operator=(GpuDeviceData&&);

    
    int32_t utilization_
    {};
    int64_t memoryUsage_
    {};
    int64_t vramApertureUsage_
    {};
    int32_t temperature_
    {};
    int32_t powerUsage_
    {};
    int32_t graphicsClockSpeed_
    {};
    int32_t smClockSpeed_
    {};
    int32_t memClockSpeed_
    {};
    int32_t videoClockSpeed_
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const GpuDeviceData& gpudevicedata);

    friend bool operator== (const GpuDeviceData &lhs, const GpuDeviceData &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::GpuDeviceData>
{
    std::size_t operator()(av::msg::GpuDeviceData const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::GpuDeviceData, 1)
ODATUM_NAMED_TYPE(av::msg::GpuDeviceData)

 namespace av {
 namespace msg {


class GpuResource
    : public csvable
    , public aptv::ODatum
{
public:
    GpuResource();

    GpuResource(
        std::string uuid_arg ,
        GpuDeviceData resource_arg 
        );

    GpuResource(const GpuResource&);

    // NOLINTNEXTLINE
    GpuResource(GpuResource&&);

    GpuResource& operator=(const GpuResource&);

    // NOLINTNEXTLINE
    GpuResource& operator=(GpuResource&&);

    
    std::string uuid
    {};
    GpuDeviceData resource
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const GpuResource& gpuresource);

    friend bool operator== (const GpuResource &lhs, const GpuResource &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::GpuResource>
{
    std::size_t operator()(av::msg::GpuResource const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::GpuResource, 1)
ODATUM_NAMED_TYPE(av::msg::GpuResource)

 namespace av {
 namespace msg {


class SystemResourceData
    : public csvable
    , public aptv::ODatum
{
public:
    SystemResourceData();

    SystemResourceData(
        std::string hostname__arg ,
        std::vector<double> cpuUtilization__arg ,
        double cpuLoad__arg ,
        uint64_t memUtilization__arg ,
        double gpuUtilization__arg ,
        std::vector<double> cpuFreq__arg ,
        std::vector<GpuResource> gpuResources__arg ,
        SystemMemInfo memInfo__arg ,
        double cpuTemperature__arg 
        );

    SystemResourceData(const SystemResourceData&);

    // NOLINTNEXTLINE
    SystemResourceData(SystemResourceData&&);

    SystemResourceData& operator=(const SystemResourceData&);

    // NOLINTNEXTLINE
    SystemResourceData& operator=(SystemResourceData&&);

    
    std::string hostname_
    {};
    std::vector<double> cpuUtilization_
    {};
    double cpuLoad_
    {};
    uint64_t memUtilization_
    {};
    double gpuUtilization_
    {};
    std::vector<double> cpuFreq_
    {};
    std::vector<GpuResource> gpuResources_
    {};
    SystemMemInfo memInfo_
    {};
    double cpuTemperature_
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const SystemResourceData& systemresourcedata);

    friend bool operator== (const SystemResourceData &lhs, const SystemResourceData &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::SystemResourceData>
{
    std::size_t operator()(av::msg::SystemResourceData const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::SystemResourceData, 5)
ODATUM_NAMED_TYPE(av::msg::SystemResourceData)

 namespace av {
 namespace msg {


class GpuProcessData
    : public csvable
    , public aptv::ODatum
{
public:
    GpuProcessData();

    GpuProcessData(
        int64_t gpuMemoryUsage__arg ,
        int32_t decoderUtil__arg ,
        int32_t encoderUtil__arg ,
        int32_t framebufferMemoryUtil__arg ,
        int32_t streamMultiprocessorUtil__arg 
        );

    GpuProcessData(const GpuProcessData&);

    // NOLINTNEXTLINE
    GpuProcessData(GpuProcessData&&);

    GpuProcessData& operator=(const GpuProcessData&);

    // NOLINTNEXTLINE
    GpuProcessData& operator=(GpuProcessData&&);

    
    int64_t gpuMemoryUsage_
    {};
    int32_t decoderUtil_
    {};
    int32_t encoderUtil_
    {};
    int32_t framebufferMemoryUtil_
    {};
    int32_t streamMultiprocessorUtil_
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const GpuProcessData& gpuprocessdata);

    friend bool operator== (const GpuProcessData &lhs, const GpuProcessData &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::GpuProcessData>
{
    std::size_t operator()(av::msg::GpuProcessData const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::GpuProcessData, 1)
ODATUM_NAMED_TYPE(av::msg::GpuProcessData)

 namespace av {
 namespace msg {


class TaskHealthData
    : public csvable
    , public aptv::ODatum
{
public:
    TaskHealthData();

    TaskHealthData(
        std::string instanceName__arg ,
        std::string executableName__arg ,
        double cpuUtilization__arg ,
        uint64_t memUtilizationVirtual__arg ,
        uint64_t memUtilizationRSS__arg ,
        GpuProcessData gpuData__arg ,
        int32_t status__arg 
        );

    TaskHealthData(const TaskHealthData&);

    // NOLINTNEXTLINE
    TaskHealthData(TaskHealthData&&);

    TaskHealthData& operator=(const TaskHealthData&);

    // NOLINTNEXTLINE
    TaskHealthData& operator=(TaskHealthData&&);

    
    std::string instanceName_
    {};
    std::string executableName_
    {};
    double cpuUtilization_
    {};
    uint64_t memUtilizationVirtual_
    {};
    uint64_t memUtilizationRSS_
    {};
    GpuProcessData gpuData_
    {};
    int32_t status_
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const TaskHealthData& taskhealthdata);

    friend bool operator== (const TaskHealthData &lhs, const TaskHealthData &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::TaskHealthData>
{
    std::size_t operator()(av::msg::TaskHealthData const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::TaskHealthData, 3)
ODATUM_NAMED_TYPE(av::msg::TaskHealthData)



 namespace av {
 namespace msg {


class SystemHealthMessage_avt
    : public csvable
    , public aptv::ODatum
{
public:
    SystemHealthMessage_avt();

    SystemHealthMessage_avt(
        SystemResourceData systemResources__arg ,
        std::vector<TaskHealthData> taskHealth__arg ,
        int64_t time__arg 
        );

    SystemHealthMessage_avt(const SystemHealthMessage_avt&);

    // NOLINTNEXTLINE
    SystemHealthMessage_avt(SystemHealthMessage_avt&&);

    SystemHealthMessage_avt& operator=(const SystemHealthMessage_avt&);

    // NOLINTNEXTLINE
    SystemHealthMessage_avt& operator=(SystemHealthMessage_avt&&);

    
    SystemResourceData systemResources_
    {};
    std::vector<TaskHealthData> taskHealth_
    {};
    int64_t time_
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const SystemHealthMessage_avt& systemhealthmessage_avt);

    friend bool operator== (const SystemHealthMessage_avt &lhs, const SystemHealthMessage_avt &rhs);

    template<class Archive>
    void serialize([[maybe_unused]] Archive& ar, [[maybe_unused]] unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::SystemHealthMessage_avt>
{
    std::size_t operator()(av::msg::SystemHealthMessage_avt const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::SystemHealthMessage_avt, 3)
ODATUM_NAMED_TYPE(av::msg::SystemHealthMessage_avt)



#endif // _SYSTEMHEALTHMESSAGE_AVT_H_
