/*!
 ***********************************************************************************************************************
 * APTIV PRIVILEGED AND CONFIDENTIAL
 *
 * THIS IS AN AUTO GENERATED FILE!
 * DO NOT EDIT BY HAND!
 * check infrastructure/idl_generator/jinja_templates/struct.template
 *
 * @brief Auto Generated Cereal Interface
 *
 * @section License
 *
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTE: Removing this heading is prohibited.
 *
 * @section Open Source License List
 *
 * This is a list of any open-source project used by this file.
 ***********************************************************************************************************************
 */

#ifndef _TRACKEDENTITIES_H_
#define _TRACKEDENTITIES_H_

#include <ODatum/ODatum.h>
#include <interfaces/traits/csvable.h>

#include <interfaces/TrackedEntitiesDefinitions.hpp>


#include <interfaces/target_prediction_avt/target_prediction_avt.h>





 namespace av {
 namespace msg {
 namespace tracker {


class TrackedPose
    : public csvable
    , public aptv::ODatum
{
public:
    TrackedPose();

    TrackedPose(
        double x_meters_arg ,
        double y_meters_arg ,
        double z_meters_arg ,
        double heading_radians_arg 
        );

    TrackedPose(const TrackedPose&);

    // NOLINTNEXTLINE
    TrackedPose(TrackedPose&&);

    TrackedPose& operator=(const TrackedPose&);

    // NOLINTNEXTLINE
    TrackedPose& operator=(TrackedPose&&);

    
    double x_meters
    {};
    double y_meters
    {};
    double z_meters
    {};
    double heading_radians
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const TrackedPose& trackedpose);

    friend bool operator== (const TrackedPose &lhs, const TrackedPose &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace tracker


template<> struct std::hash<av::msg::tracker::TrackedPose>
{
    std::size_t operator()(av::msg::tracker::TrackedPose const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::tracker::TrackedPose, 1)
ODATUM_NAMED_TYPE(av::msg::tracker::TrackedPose)

 namespace av {
 namespace msg {
 namespace tracker {


class Vertex
    : public csvable
    , public aptv::ODatum
{
public:
    Vertex();

    Vertex(
        double x_arg ,
        double y_arg 
        );

    Vertex(const Vertex&);

    // NOLINTNEXTLINE
    Vertex(Vertex&&);

    Vertex& operator=(const Vertex&);

    // NOLINTNEXTLINE
    Vertex& operator=(Vertex&&);

    
    double x
    {};
    double y
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const Vertex& vertex);

    friend bool operator== (const Vertex &lhs, const Vertex &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace tracker


template<> struct std::hash<av::msg::tracker::Vertex>
{
    std::size_t operator()(av::msg::tracker::Vertex const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::tracker::Vertex, 1)
ODATUM_NAMED_TYPE(av::msg::tracker::Vertex)

 namespace av {
 namespace msg {
 namespace tracker {


class ConvexPolygon
    : public csvable
    , public aptv::ODatum
{
public:
    ConvexPolygon();

    ConvexPolygon(
        bool isBox_arg ,
        std::vector<Vertex> points_arg ,
        double height_arg 
        );

    ConvexPolygon(const ConvexPolygon&);

    // NOLINTNEXTLINE
    ConvexPolygon(ConvexPolygon&&);

    ConvexPolygon& operator=(const ConvexPolygon&);

    // NOLINTNEXTLINE
    ConvexPolygon& operator=(ConvexPolygon&&);

    
    bool isBox
    {};
    std::vector<Vertex> points
    {};
    double height
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const ConvexPolygon& convexpolygon);

    friend bool operator== (const ConvexPolygon &lhs, const ConvexPolygon &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace tracker


template<> struct std::hash<av::msg::tracker::ConvexPolygon>
{
    std::size_t operator()(av::msg::tracker::ConvexPolygon const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::tracker::ConvexPolygon, 2)
ODATUM_NAMED_TYPE(av::msg::tracker::ConvexPolygon)

 namespace av {
 namespace msg {
 namespace tracker {


class TrackedEntity
    : public csvable
    , public aptv::ODatum
{
public:
    TrackedEntity();

    TrackedEntity(
        int64_t trackId_arg ,
        int64_t timeFirstDetection_arg ,
        int64_t timeLastDetection_arg ,
        TrackedEntityType classType_arg ,
        std::vector<double> classTypeProbabilities_arg ,
        double confidence_arg ,
        double probabilityActive_arg ,
        TrackedPose pose_arg ,
        prediction::Matrix2D poseCov_arg ,
        Velocity velocity_arg ,
        prediction::Matrix2D velocityCov_arg ,
        std::vector<ConvexPolygon> convexPolygons_arg ,
        std::vector<prediction::Trajectory> trajectories_arg ,
        prediction::Acceleration acceleration_arg ,
        double angularVelocityRadps_arg 
        );

    TrackedEntity(const TrackedEntity&);

    // NOLINTNEXTLINE
    TrackedEntity(TrackedEntity&&);

    TrackedEntity& operator=(const TrackedEntity&);

    // NOLINTNEXTLINE
    TrackedEntity& operator=(TrackedEntity&&);

    
    int64_t trackId
    {};
    int64_t timeFirstDetection
    {};
    int64_t timeLastDetection
    {};
    TrackedEntityType classType
    {};
    std::vector<double> classTypeProbabilities
    {};
    double confidence
    {};
    double probabilityActive
    {};
    TrackedPose pose
    {};
    prediction::Matrix2D poseCov
    {};
    Velocity velocity
    {};
    prediction::Matrix2D velocityCov
    {};
    std::vector<ConvexPolygon> convexPolygons
    {};
    std::vector<prediction::Trajectory> trajectories
    {};
    prediction::Acceleration acceleration
    {};
    double angularVelocityRadps
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const TrackedEntity& trackedentity);

    friend bool operator== (const TrackedEntity &lhs, const TrackedEntity &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace tracker


template<> struct std::hash<av::msg::tracker::TrackedEntity>
{
    std::size_t operator()(av::msg::tracker::TrackedEntity const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::tracker::TrackedEntity, 2)
ODATUM_NAMED_TYPE(av::msg::tracker::TrackedEntity)



 namespace av {
 namespace msg {
 namespace tracker {


class TrackedEntities
    : public csvable
    , public aptv::ODatum
{
public:
    TrackedEntities();

    TrackedEntities(
        int64_t timeStamp_arg ,
        std::string frameId_arg ,
        std::vector<TrackedEntity> trackedEntities_arg 
        );

    TrackedEntities(const TrackedEntities&);

    // NOLINTNEXTLINE
    TrackedEntities(TrackedEntities&&);

    TrackedEntities& operator=(const TrackedEntities&);

    // NOLINTNEXTLINE
    TrackedEntities& operator=(TrackedEntities&&);

    
    int64_t timeStamp
    {};
    std::string frameId
    {};
    std::vector<TrackedEntity> trackedEntities
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const TrackedEntities& trackedentities);

    friend bool operator== (const TrackedEntities &lhs, const TrackedEntities &rhs);

    template<class Archive>
    void serialize([[maybe_unused]] Archive& ar, [[maybe_unused]] unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace tracker


template<> struct std::hash<av::msg::tracker::TrackedEntities>
{
    std::size_t operator()(av::msg::tracker::TrackedEntities const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::tracker::TrackedEntities, 1)
ODATUM_NAMED_TYPE(av::msg::tracker::TrackedEntities)



#endif // _TRACKEDENTITIES_H_
