/*!
 ***********************************************************************************************************************
 * APTIV PRIVILEGED AND CONFIDENTIAL
 *
 * THIS IS AN AUTO GENERATED FILE!
 * DO NOT EDIT BY HAND!
 * check platform/idl_generator/jinja_templates/struct.template
 *
 * @brief Auto Generated Cereal Interface
 *
 * @section License
 *
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTE: Removing this heading is prohibited.
 *
 * @section Open Source License List
 *
 * This is a list of any open-source project used by this file.
 ***********************************************************************************************************************
 */

#ifndef _TRAFFICLIGHTNETWORKMESSAGE_H_
#define _TRAFFICLIGHTNETWORKMESSAGE_H_

#include <ODatum/ODatum.h>
#include <interfaces/traits/csvable.h>

#include <interfaces/TrafficLightNetworkMessageDefinitions.hpp>


#include <interfaces/MultiIntersectionTLStatus/MultiIntersectionTLStatus.h>





 namespace av {
 namespace msg {
 namespace tln {


class point2D
    : public csvable
    , public aptv::ODatum
{
public:
    point2D();

    point2D(
        double x_arg ,
        double y_arg 
        );

    point2D(const point2D&);

    // NOLINTNEXTLINE
    point2D(point2D&&);

    point2D& operator=(const point2D&);

    // NOLINTNEXTLINE
    point2D& operator=(point2D&&);

    
    double x
    {};
    double y
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const point2D& point2d);

    friend bool operator== (const point2D &lhs, const point2D &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace tln


template<> struct std::hash<av::msg::tln::point2D>
{
    std::size_t operator()(av::msg::tln::point2D const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::tln::point2D, 1)
ODATUM_NAMED_TYPE(av::msg::tln::point2D)

 namespace av {
 namespace msg {
 namespace tln {


class TLNBoundingBox
    : public csvable
    , public aptv::ODatum
{
public:
    TLNBoundingBox();

    TLNBoundingBox(
        point2D topLeftCorner_arg ,
        double width_arg ,
        double height_arg ,
        double attributeScore_arg 
        );

    TLNBoundingBox(const TLNBoundingBox&);

    // NOLINTNEXTLINE
    TLNBoundingBox(TLNBoundingBox&&);

    TLNBoundingBox& operator=(const TLNBoundingBox&);

    // NOLINTNEXTLINE
    TLNBoundingBox& operator=(TLNBoundingBox&&);

    
    point2D topLeftCorner
    {};
    double width
    {};
    double height
    {};
    double attributeScore
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const TLNBoundingBox& tlnboundingbox);

    friend bool operator== (const TLNBoundingBox &lhs, const TLNBoundingBox &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace tln


template<> struct std::hash<av::msg::tln::TLNBoundingBox>
{
    std::size_t operator()(av::msg::tln::TLNBoundingBox const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::tln::TLNBoundingBox, 1)
ODATUM_NAMED_TYPE(av::msg::tln::TLNBoundingBox)

 namespace av {
 namespace msg {
 namespace tln {


class TLNLens
    : public csvable
    , public aptv::ODatum
{
public:
    TLNLens();

    TLNLens(
        point2D lensCenter_arg ,
        LIGHT_COLOR color_arg ,
        LIGHT_SHAPE shape_arg ,
        double attributeScore_arg 
        );

    TLNLens(const TLNLens&);

    // NOLINTNEXTLINE
    TLNLens(TLNLens&&);

    TLNLens& operator=(const TLNLens&);

    // NOLINTNEXTLINE
    TLNLens& operator=(TLNLens&&);

    
    point2D lensCenter
    {};
    LIGHT_COLOR color
    {};
    LIGHT_SHAPE shape
    {};
    double attributeScore
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const TLNLens& tlnlens);

    friend bool operator== (const TLNLens &lhs, const TLNLens &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace tln


template<> struct std::hash<av::msg::tln::TLNLens>
{
    std::size_t operator()(av::msg::tln::TLNLens const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::tln::TLNLens, 1)
ODATUM_NAMED_TYPE(av::msg::tln::TLNLens)

 namespace av {
 namespace msg {
 namespace tln {


class TLNObject
    : public csvable
    , public aptv::ODatum
{
public:
    TLNObject();

    TLNObject(
        TLN_OBJECT_TYPE type_arg ,
        TLN_OBJECT_ORIENTATION orientation_arg ,
        double confidenceLevel_arg ,
        TLNBoundingBox boundingBox_arg ,
        std::vector<TLNLens> lenses_arg 
        );

    TLNObject(const TLNObject&);

    // NOLINTNEXTLINE
    TLNObject(TLNObject&&);

    TLNObject& operator=(const TLNObject&);

    // NOLINTNEXTLINE
    TLNObject& operator=(TLNObject&&);

    
    TLN_OBJECT_TYPE type
    {};
    TLN_OBJECT_ORIENTATION orientation
    {};
    double confidenceLevel
    {};
    TLNBoundingBox boundingBox
    {};
    std::vector<TLNLens> lenses
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const TLNObject& tlnobject);

    friend bool operator== (const TLNObject &lhs, const TLNObject &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace tln


template<> struct std::hash<av::msg::tln::TLNObject>
{
    std::size_t operator()(av::msg::tln::TLNObject const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::tln::TLNObject, 1)
ODATUM_NAMED_TYPE(av::msg::tln::TLNObject)



 namespace av {
 namespace msg {
 namespace tln {


class TrafficLightNetworkMessage
    : public csvable
    , public aptv::ODatum
{
public:
    TrafficLightNetworkMessage();

    TrafficLightNetworkMessage(
        int64_t timestamp_arg ,
        std::string sensorId_arg ,
        std::vector<TLNObject> objects_arg ,
        TLN_MESSAGE_TYPE type_arg ,
        std::string cnn_model_arg 
        );

    TrafficLightNetworkMessage(const TrafficLightNetworkMessage&);

    // NOLINTNEXTLINE
    TrafficLightNetworkMessage(TrafficLightNetworkMessage&&);

    TrafficLightNetworkMessage& operator=(const TrafficLightNetworkMessage&);

    // NOLINTNEXTLINE
    TrafficLightNetworkMessage& operator=(TrafficLightNetworkMessage&&);

    
    int64_t timestamp
    {};
    std::string sensorId
    {};
    std::vector<TLNObject> objects
    {};
    TLN_MESSAGE_TYPE type
    {};
    std::string cnn_model
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const TrafficLightNetworkMessage& trafficlightnetworkmessage);

    friend bool operator== (const TrafficLightNetworkMessage &lhs, const TrafficLightNetworkMessage &rhs);

    template<class Archive>
    void serialize([[maybe_unused]] Archive& ar, [[maybe_unused]] unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace tln


template<> struct std::hash<av::msg::tln::TrafficLightNetworkMessage>
{
    std::size_t operator()(av::msg::tln::TrafficLightNetworkMessage const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::tln::TrafficLightNetworkMessage, 1)
ODATUM_NAMED_TYPE(av::msg::tln::TrafficLightNetworkMessage)



#endif // _TRAFFICLIGHTNETWORKMESSAGE_H_
