/*!
 ***********************************************************************************************************************
 * APTIV PRIVILEGED AND CONFIDENTIAL
 *
 * THIS IS AN AUTO GENERATED FILE!
 * DO NOT EDIT BY HAND!
 * check platform/idl_generator/jinja_templates/struct.template
 *
 * @brief Auto Generated Cereal Interface
 *
 * @section License
 *
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTE: Removing this heading is prohibited.
 *
 * @section Open Source License List
 *
 * This is a list of any open-source project used by this file.
 ***********************************************************************************************************************
 */

#ifndef _VALIDATIONRESULTS_H_
#define _VALIDATIONRESULTS_H_

#include <ODatum/ODatum.h>
#include <interfaces/traits/csvable.h>

#include <interfaces/ValidationResultsDefinitions.hpp>


#include <interfaces/Duration/Duration.h>

#include <interfaces/Quaterniond/Quaterniond.h>

#include <interfaces/TimePoint/TimePoint.h>

#include <interfaces/Vector3d/Vector3d.h>





 namespace av {
 namespace msg {
 namespace calibration {


class SensorValidationData
    : public csvable
    , public aptv::ODatum
{
public:
    SensorValidationData();

    SensorValidationData(
        std::string name_arg ,
        bool isValidationValid_arg ,
        bool isValidationAngleGood_arg ,
        float icpScore_arg ,
        float svdScore_arg ,
        float rotationErrorDegree_arg ,
        av::geometry::Quaterniond rotationError_arg ,
        av::geometry::Vector3d translationError_arg 
        );

    SensorValidationData(const SensorValidationData&);

    // NOLINTNEXTLINE
    SensorValidationData(SensorValidationData&&);

    SensorValidationData& operator=(const SensorValidationData&);

    // NOLINTNEXTLINE
    SensorValidationData& operator=(SensorValidationData&&);

    
    std::string name
    {};
    bool isValidationValid
    {};
    bool isValidationAngleGood
    {};
    float icpScore
    {};
    float svdScore
    {};
    float rotationErrorDegree
    {};
    av::geometry::Quaterniond rotationError
    {};
    av::geometry::Vector3d translationError
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const SensorValidationData& sensorvalidationdata);

    friend bool operator== (const SensorValidationData &lhs, const SensorValidationData &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace calibration


template<> struct std::hash<av::msg::calibration::SensorValidationData>
{
    std::size_t operator()(av::msg::calibration::SensorValidationData const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::calibration::SensorValidationData, 1)
ODATUM_NAMED_TYPE(av::msg::calibration::SensorValidationData)



 namespace av {
 namespace msg {
 namespace calibration {


class ValidationResults
    : public csvable
    , public aptv::ODatum
{
public:
    ValidationResults();

    ValidationResults(
        std::vector<SensorValidationData> sensors_arg ,
        av::msg::Duration validationDuration_arg ,
        av::msg::TimePoint validationDate_arg ,
        std::string vehicleName_arg 
        );

    ValidationResults(const ValidationResults&);

    // NOLINTNEXTLINE
    ValidationResults(ValidationResults&&);

    ValidationResults& operator=(const ValidationResults&);

    // NOLINTNEXTLINE
    ValidationResults& operator=(ValidationResults&&);

    
    std::vector<SensorValidationData> sensors
    {};
    av::msg::Duration validationDuration
    {};
    av::msg::TimePoint validationDate
    {};
    std::string vehicleName
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const ValidationResults& validationresults);

    friend bool operator== (const ValidationResults &lhs, const ValidationResults &rhs);

    template<class Archive>
    void serialize([[maybe_unused]] Archive& ar, [[maybe_unused]] unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace calibration


template<> struct std::hash<av::msg::calibration::ValidationResults>
{
    std::size_t operator()(av::msg::calibration::ValidationResults const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::calibration::ValidationResults, 1)
ODATUM_NAMED_TYPE(av::msg::calibration::ValidationResults)



#endif // _VALIDATIONRESULTS_H_
