/*!
 ***********************************************************************************************************************
 * APTIV PRIVILEGED AND CONFIDENTIAL
 *
 * THIS IS AN AUTO GENERATED FILE!
 * DO NOT EDIT BY HAND!
 * check platform/idl_generator/jinja_templates/struct.template
 *
 * @brief Auto Generated Cereal Interface
 *
 * @section License
 *
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTE: Removing this heading is prohibited.
 *
 * @section Open Source License List
 *
 * This is a list of any open-source project used by this file.
 ***********************************************************************************************************************
 */

#ifndef _VECTOROFGLOBALSTATICREFERENCE_H_
#define _VECTOROFGLOBALSTATICREFERENCE_H_

#include <ODatum/ODatum.h>
#include <interfaces/traits/csvable.h>

#include <interfaces/VectorOfGlobalStaticReferenceDefinitions.hpp>


#include <interfaces/PlannedPathWithBounds/PlannedPathWithBounds.h>

#include <interfaces/Pose2d/Pose2d.h>

#include <interfaces/SE2/SE2.h>

#include <interfaces/TimePoint/TimePoint.h>





 namespace av {
 namespace msg {


class SampledTransition
    : public csvable
    , public aptv::ODatum
{
public:
    SampledTransition();

    SampledTransition(
        TimePoint time_arg ,
        double progressReference_arg ,
        double progressFrontBumper_arg ,
        double progressRearAxle_arg ,
        SE2 pose_arg ,
        double lateralReference_arg ,
        double curvature_arg ,
        double speed_arg 
        );

    SampledTransition(const SampledTransition&);

    // NOLINTNEXTLINE
    SampledTransition(SampledTransition&&);

    SampledTransition& operator=(const SampledTransition&);

    // NOLINTNEXTLINE
    SampledTransition& operator=(SampledTransition&&);

    
    TimePoint time
    {};
    double progressReference
    {};
    double progressFrontBumper
    {};
    double progressRearAxle
    {};
    SE2 pose
    {};
    double lateralReference
    {};
    double curvature
    {};
    double speed
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const SampledTransition& sampledtransition);

    friend bool operator== (const SampledTransition &lhs, const SampledTransition &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::SampledTransition>
{
    std::size_t operator()(av::msg::SampledTransition const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::SampledTransition, 1)
ODATUM_NAMED_TYPE(av::msg::SampledTransition)

 namespace av {
 namespace msg {


class VTConstraint
    : public csvable
    , public aptv::ODatum
{
public:
    VTConstraint();

    VTConstraint(
        TimePoint time_arg ,
        double s_arg ,
        double minSpeed_arg ,
        double accelAtMinSpeed_arg ,
        double maxSpeed_arg ,
        double accelAtMaxSpeed_arg 
        );

    VTConstraint(const VTConstraint&);

    // NOLINTNEXTLINE
    VTConstraint(VTConstraint&&);

    VTConstraint& operator=(const VTConstraint&);

    // NOLINTNEXTLINE
    VTConstraint& operator=(VTConstraint&&);

    
    TimePoint time
    {};
    double s
    {};
    double minSpeed
    {};
    double accelAtMinSpeed
    {};
    double maxSpeed
    {};
    double accelAtMaxSpeed
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const VTConstraint& vtconstraint);

    friend bool operator== (const VTConstraint &lhs, const VTConstraint &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::VTConstraint>
{
    std::size_t operator()(av::msg::VTConstraint const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::VTConstraint, 1)
ODATUM_NAMED_TYPE(av::msg::VTConstraint)

 namespace av {
 namespace msg {


class SampledSTConstraint
    : public csvable
    , public aptv::ODatum
{
public:
    SampledSTConstraint();

    SampledSTConstraint(
        TimePoint time_arg ,
        double station_arg ,
        HardAndSoftBounds stationBounds_arg ,
        double longitudinalSpeed_arg ,
        bool anchorLane_arg 
        );

    SampledSTConstraint(const SampledSTConstraint&);

    // NOLINTNEXTLINE
    SampledSTConstraint(SampledSTConstraint&&);

    SampledSTConstraint& operator=(const SampledSTConstraint&);

    // NOLINTNEXTLINE
    SampledSTConstraint& operator=(SampledSTConstraint&&);

    
    TimePoint time
    {};
    double station
    {};
    HardAndSoftBounds stationBounds
    {};
    double longitudinalSpeed
    {};
    bool anchorLane
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const SampledSTConstraint& sampledstconstraint);

    friend bool operator== (const SampledSTConstraint &lhs, const SampledSTConstraint &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::SampledSTConstraint>
{
    std::size_t operator()(av::msg::SampledSTConstraint const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::SampledSTConstraint, 2)
ODATUM_NAMED_TYPE(av::msg::SampledSTConstraint)

 namespace av {
 namespace msg {


class LateralTube
    : public csvable
    , public aptv::ODatum
{
public:
    LateralTube();

    LateralTube(
        HardAndSoftBounds tubeRefpoint_arg ,
        HardAndSoftBounds tubeFrontAxle_arg ,
        HardAndSoftBounds tubeRearAxle_arg ,
        HardAndSoftBoundsSpatialConstraintType constraintType_arg 
        );

    LateralTube(const LateralTube&);

    // NOLINTNEXTLINE
    LateralTube(LateralTube&&);

    LateralTube& operator=(const LateralTube&);

    // NOLINTNEXTLINE
    LateralTube& operator=(LateralTube&&);

    
    HardAndSoftBounds tubeRefpoint
    {};
    HardAndSoftBounds tubeFrontAxle
    {};
    HardAndSoftBounds tubeRearAxle
    {};
    HardAndSoftBoundsSpatialConstraintType constraintType
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const LateralTube& lateraltube);

    friend bool operator== (const LateralTube &lhs, const LateralTube &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::LateralTube>
{
    std::size_t operator()(av::msg::LateralTube const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::LateralTube, 1)
ODATUM_NAMED_TYPE(av::msg::LateralTube)

 namespace av {
 namespace msg {


class TubeAsSpline
    : public csvable
    , public aptv::ODatum
{
public:
    TubeAsSpline();

    TubeAsSpline(
        std::vector<double> controlPointsHardUpper_arg ,
        std::vector<double> controlPointsHardLower_arg ,
        std::vector<double> controlPointsSoftUpper_arg ,
        std::vector<double> controlPointsSoftLower_arg 
        );

    TubeAsSpline(const TubeAsSpline&);

    // NOLINTNEXTLINE
    TubeAsSpline(TubeAsSpline&&);

    TubeAsSpline& operator=(const TubeAsSpline&);

    // NOLINTNEXTLINE
    TubeAsSpline& operator=(TubeAsSpline&&);

    
    std::vector<double> controlPointsHardUpper
    {};
    std::vector<double> controlPointsHardLower
    {};
    std::vector<double> controlPointsSoftUpper
    {};
    std::vector<double> controlPointsSoftLower
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const TubeAsSpline& tubeasspline);

    friend bool operator== (const TubeAsSpline &lhs, const TubeAsSpline &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::TubeAsSpline>
{
    std::size_t operator()(av::msg::TubeAsSpline const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::TubeAsSpline, 1)
ODATUM_NAMED_TYPE(av::msg::TubeAsSpline)

 namespace av {
 namespace msg {


class TrackConstraintInfo
    : public csvable
    , public aptv::ODatum
{
public:
    TrackConstraintInfo();

    TrackConstraintInfo(
        EdgeClearanceInfo clearanceInfo_arg ,
        ProximityBiasingParameters params_arg 
        );

    TrackConstraintInfo(const TrackConstraintInfo&);

    // NOLINTNEXTLINE
    TrackConstraintInfo(TrackConstraintInfo&&);

    TrackConstraintInfo& operator=(const TrackConstraintInfo&);

    // NOLINTNEXTLINE
    TrackConstraintInfo& operator=(TrackConstraintInfo&&);

    
    EdgeClearanceInfo clearanceInfo
    {};
    ProximityBiasingParameters params
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const TrackConstraintInfo& trackconstraintinfo);

    friend bool operator== (const TrackConstraintInfo &lhs, const TrackConstraintInfo &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::TrackConstraintInfo>
{
    std::size_t operator()(av::msg::TrackConstraintInfo const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::TrackConstraintInfo, 1)
ODATUM_NAMED_TYPE(av::msg::TrackConstraintInfo)

 namespace av {
 namespace msg {


class BiasingConstraints
    : public csvable
    , public aptv::ODatum
{
public:
    BiasingConstraints();

    BiasingConstraints(
        double stationAlongPath_arg ,
        bool hasValue_arg ,
        TrackConstraintInfo biasingInfo_arg 
        );

    BiasingConstraints(const BiasingConstraints&);

    // NOLINTNEXTLINE
    BiasingConstraints(BiasingConstraints&&);

    BiasingConstraints& operator=(const BiasingConstraints&);

    // NOLINTNEXTLINE
    BiasingConstraints& operator=(BiasingConstraints&&);

    
    double stationAlongPath
    {};
    bool hasValue
    {};
    TrackConstraintInfo biasingInfo
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const BiasingConstraints& biasingconstraints);

    friend bool operator== (const BiasingConstraints &lhs, const BiasingConstraints &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::BiasingConstraints>
{
    std::size_t operator()(av::msg::BiasingConstraints const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::BiasingConstraints, 1)
ODATUM_NAMED_TYPE(av::msg::BiasingConstraints)

 namespace av {
 namespace msg {


class MostConstrainingTrack
    : public csvable
    , public aptv::ODatum
{
public:
    MostConstrainingTrack();

    MostConstrainingTrack(
        MostConstrainingTrackType type_arg ,
        int64_t trackId_arg ,
        int64_t mapId_arg ,
        std::string debug_arg 
        );

    MostConstrainingTrack(const MostConstrainingTrack&);

    // NOLINTNEXTLINE
    MostConstrainingTrack(MostConstrainingTrack&&);

    MostConstrainingTrack& operator=(const MostConstrainingTrack&);

    // NOLINTNEXTLINE
    MostConstrainingTrack& operator=(MostConstrainingTrack&&);

    
    MostConstrainingTrackType type
    {};
    int64_t trackId
    {};
    int64_t mapId
    {};
    std::string debug
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const MostConstrainingTrack& mostconstrainingtrack);

    friend bool operator== (const MostConstrainingTrack &lhs, const MostConstrainingTrack &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::MostConstrainingTrack>
{
    std::size_t operator()(av::msg::MostConstrainingTrack const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::MostConstrainingTrack, 1)
ODATUM_NAMED_TYPE(av::msg::MostConstrainingTrack)

 namespace av {
 namespace msg {


class OptionalLateralReferenceAsCubicSpline
    : public csvable
    , public aptv::ODatum
{
public:
    OptionalLateralReferenceAsCubicSpline();

    OptionalLateralReferenceAsCubicSpline(
        bool hasValue_arg ,
        double spanLength_arg ,
        double startStation_arg ,
        std::vector<double> controlPoints_arg 
        );

    OptionalLateralReferenceAsCubicSpline(const OptionalLateralReferenceAsCubicSpline&);

    // NOLINTNEXTLINE
    OptionalLateralReferenceAsCubicSpline(OptionalLateralReferenceAsCubicSpline&&);

    OptionalLateralReferenceAsCubicSpline& operator=(const OptionalLateralReferenceAsCubicSpline&);

    // NOLINTNEXTLINE
    OptionalLateralReferenceAsCubicSpline& operator=(OptionalLateralReferenceAsCubicSpline&&);

    
    bool hasValue
    {};
    double spanLength
    {};
    double startStation
    {};
    std::vector<double> controlPoints
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const OptionalLateralReferenceAsCubicSpline& optionallateralreferenceascubicspline);

    friend bool operator== (const OptionalLateralReferenceAsCubicSpline &lhs, const OptionalLateralReferenceAsCubicSpline &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::OptionalLateralReferenceAsCubicSpline>
{
    std::size_t operator()(av::msg::OptionalLateralReferenceAsCubicSpline const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::OptionalLateralReferenceAsCubicSpline, 1)
ODATUM_NAMED_TYPE(av::msg::OptionalLateralReferenceAsCubicSpline)

 namespace av {
 namespace msg {


class PairOfVectors
    : public csvable
    , public aptv::ODatum
{
public:
    PairOfVectors();

    PairOfVectors(
        std::vector<double> first_arg ,
        std::vector<double> second_arg 
        );

    PairOfVectors(const PairOfVectors&);

    // NOLINTNEXTLINE
    PairOfVectors(PairOfVectors&&);

    PairOfVectors& operator=(const PairOfVectors&);

    // NOLINTNEXTLINE
    PairOfVectors& operator=(PairOfVectors&&);

    
    std::vector<double> first
    {};
    std::vector<double> second
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const PairOfVectors& pairofvectors);

    friend bool operator== (const PairOfVectors &lhs, const PairOfVectors &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::PairOfVectors>
{
    std::size_t operator()(av::msg::PairOfVectors const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::PairOfVectors, 1)
ODATUM_NAMED_TYPE(av::msg::PairOfVectors)

 namespace av {
 namespace msg {


class OptionalPairOfVectors
    : public csvable
    , public aptv::ODatum
{
public:
    OptionalPairOfVectors();

    OptionalPairOfVectors(
        bool hasValue_arg ,
        PairOfVectors value_arg 
        );

    OptionalPairOfVectors(const OptionalPairOfVectors&);

    // NOLINTNEXTLINE
    OptionalPairOfVectors(OptionalPairOfVectors&&);

    OptionalPairOfVectors& operator=(const OptionalPairOfVectors&);

    // NOLINTNEXTLINE
    OptionalPairOfVectors& operator=(OptionalPairOfVectors&&);

    
    bool hasValue
    {};
    PairOfVectors value
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const OptionalPairOfVectors& optionalpairofvectors);

    friend bool operator== (const OptionalPairOfVectors &lhs, const OptionalPairOfVectors &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::OptionalPairOfVectors>
{
    std::size_t operator()(av::msg::OptionalPairOfVectors const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::OptionalPairOfVectors, 1)
ODATUM_NAMED_TYPE(av::msg::OptionalPairOfVectors)

 namespace av {
 namespace msg {


class CubicTransitionBSpline
    : public csvable
    , public aptv::ODatum
{
public:
    CubicTransitionBSpline();

    CubicTransitionBSpline(
        PairOfVectors cartesianControlPoints_arg ,
        PairOfVectors mapProgressToStation_arg ,
        PairOfVectors mapStationToProgress_arg ,
        OptionalPairOfVectors mapStationToLateralOffset_arg 
        );

    CubicTransitionBSpline(const CubicTransitionBSpline&);

    // NOLINTNEXTLINE
    CubicTransitionBSpline(CubicTransitionBSpline&&);

    CubicTransitionBSpline& operator=(const CubicTransitionBSpline&);

    // NOLINTNEXTLINE
    CubicTransitionBSpline& operator=(CubicTransitionBSpline&&);

    
    PairOfVectors cartesianControlPoints
    {};
    PairOfVectors mapProgressToStation
    {};
    PairOfVectors mapStationToProgress
    {};
    OptionalPairOfVectors mapStationToLateralOffset
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const CubicTransitionBSpline& cubictransitionbspline);

    friend bool operator== (const CubicTransitionBSpline &lhs, const CubicTransitionBSpline &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::CubicTransitionBSpline>
{
    std::size_t operator()(av::msg::CubicTransitionBSpline const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::CubicTransitionBSpline, 2)
ODATUM_NAMED_TYPE(av::msg::CubicTransitionBSpline)

 namespace av {
 namespace msg {


class GlobalStaticReferenceVariableMembers
    : public csvable
    , public aptv::ODatum
{
public:
    GlobalStaticReferenceVariableMembers();

    GlobalStaticReferenceVariableMembers(
        SampledTransition reference_arg ,
        VTConstraint vtConstraint_arg ,
        SampledSTConstraint stConstraint_arg ,
        LateralTube sampledTubeConstraint_arg ,
        TubeAsSpline splineTubeConstraint_arg ,
        BiasingConstraints biasingLeft_arg ,
        BiasingConstraints biasingRight_arg ,
        std::vector<MostConstrainingTrack> mostConstrainingTracks_arg 
        );

    GlobalStaticReferenceVariableMembers(const GlobalStaticReferenceVariableMembers&);

    // NOLINTNEXTLINE
    GlobalStaticReferenceVariableMembers(GlobalStaticReferenceVariableMembers&&);

    GlobalStaticReferenceVariableMembers& operator=(const GlobalStaticReferenceVariableMembers&);

    // NOLINTNEXTLINE
    GlobalStaticReferenceVariableMembers& operator=(GlobalStaticReferenceVariableMembers&&);

    
    SampledTransition reference
    {};
    VTConstraint vtConstraint
    {};
    SampledSTConstraint stConstraint
    {};
    LateralTube sampledTubeConstraint
    {};
    TubeAsSpline splineTubeConstraint
    {};
    BiasingConstraints biasingLeft
    {};
    BiasingConstraints biasingRight
    {};
    std::vector<MostConstrainingTrack> mostConstrainingTracks
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const GlobalStaticReferenceVariableMembers& globalstaticreferencevariablemembers);

    friend bool operator== (const GlobalStaticReferenceVariableMembers &lhs, const GlobalStaticReferenceVariableMembers &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::GlobalStaticReferenceVariableMembers>
{
    std::size_t operator()(av::msg::GlobalStaticReferenceVariableMembers const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::GlobalStaticReferenceVariableMembers, 2)
ODATUM_NAMED_TYPE(av::msg::GlobalStaticReferenceVariableMembers)

 namespace av {
 namespace msg {


class GlobalStaticReferenceConstantMembers
    : public csvable
    , public aptv::ODatum
{
public:
    GlobalStaticReferenceConstantMembers();

    GlobalStaticReferenceConstantMembers(
        OptionalLateralReferenceAsCubicSpline optionalCommittedPath_arg ,
        CubicTransitionBSpline transitionSpline_arg 
        );

    GlobalStaticReferenceConstantMembers(const GlobalStaticReferenceConstantMembers&);

    // NOLINTNEXTLINE
    GlobalStaticReferenceConstantMembers(GlobalStaticReferenceConstantMembers&&);

    GlobalStaticReferenceConstantMembers& operator=(const GlobalStaticReferenceConstantMembers&);

    // NOLINTNEXTLINE
    GlobalStaticReferenceConstantMembers& operator=(GlobalStaticReferenceConstantMembers&&);

    
    OptionalLateralReferenceAsCubicSpline optionalCommittedPath
    {};
    CubicTransitionBSpline transitionSpline
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const GlobalStaticReferenceConstantMembers& globalstaticreferenceconstantmembers);

    friend bool operator== (const GlobalStaticReferenceConstantMembers &lhs, const GlobalStaticReferenceConstantMembers &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::GlobalStaticReferenceConstantMembers>
{
    std::size_t operator()(av::msg::GlobalStaticReferenceConstantMembers const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::GlobalStaticReferenceConstantMembers, 1)
ODATUM_NAMED_TYPE(av::msg::GlobalStaticReferenceConstantMembers)



 namespace av {
 namespace msg {


class VectorOfGlobalStaticReference
    : public csvable
    , public aptv::ODatum
{
public:
    VectorOfGlobalStaticReference();

    VectorOfGlobalStaticReference(
        GlobalStaticReferenceConstantMembers constantMembers_arg ,
        std::vector<GlobalStaticReferenceVariableMembers> variableMembers_arg 
        );

    VectorOfGlobalStaticReference(const VectorOfGlobalStaticReference&);

    // NOLINTNEXTLINE
    VectorOfGlobalStaticReference(VectorOfGlobalStaticReference&&);

    VectorOfGlobalStaticReference& operator=(const VectorOfGlobalStaticReference&);

    // NOLINTNEXTLINE
    VectorOfGlobalStaticReference& operator=(VectorOfGlobalStaticReference&&);

    
    GlobalStaticReferenceConstantMembers constantMembers
    {};
    std::vector<GlobalStaticReferenceVariableMembers> variableMembers
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const VectorOfGlobalStaticReference& vectorofglobalstaticreference);

    friend bool operator== (const VectorOfGlobalStaticReference &lhs, const VectorOfGlobalStaticReference &rhs);

    template<class Archive>
    void serialize([[maybe_unused]] Archive& ar, [[maybe_unused]] unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::VectorOfGlobalStaticReference>
{
    std::size_t operator()(av::msg::VectorOfGlobalStaticReference const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::VectorOfGlobalStaticReference, 0)
ODATUM_NAMED_TYPE(av::msg::VectorOfGlobalStaticReference)



#endif // _VECTOROFGLOBALSTATICREFERENCE_H_
