#include <interfaces/VicAirCleaningFb/VicAirCleaningFb.h>

#include <iterator>
#include <type_traits>

#include <cereal/cereal.hpp>
#include <cereal/archives/json.hpp>
#include <cereal/archives/binary.hpp>

#include <cereal/types/map.hpp>
#include <cereal/types/vector.hpp>
#include <cereal/types/array.hpp>
#include <cereal/types/string.hpp>
#include <cereal/types/complex.hpp>

#include <ODatum/IntrospectionArchive.h>
#include <ODatum/Hash.h>





 namespace av {
 namespace msg {


VicAirCleaningFb::VicAirCleaningFb() = default;

VicAirCleaningFb::VicAirCleaningFb(
    uint16_t crc_VicAirCleaningFb_arg ,
    uint8_t alivVicAirCleaningFb_arg ,
    uint8_t airFbCam_M_F_arg ,
    uint8_t airFbCam_W_F_arg ,
    uint8_t airFbLidar_F_arg ,
    uint8_t airFbLidar_T_arg ,
    uint64_t macVicAirCleaningFb_arg 
    ):
    crc_VicAirCleaningFb { std::move(crc_VicAirCleaningFb_arg) } // NOLINT
      ,alivVicAirCleaningFb { std::move(alivVicAirCleaningFb_arg) } // NOLINT
      ,airFbCam_M_F { std::move(airFbCam_M_F_arg) } // NOLINT
      ,airFbCam_W_F { std::move(airFbCam_W_F_arg) } // NOLINT
      ,airFbLidar_F { std::move(airFbLidar_F_arg) } // NOLINT
      ,airFbLidar_T { std::move(airFbLidar_T_arg) } // NOLINT
      ,macVicAirCleaningFb { std::move(macVicAirCleaningFb_arg) } // NOLINT
      {
}

VicAirCleaningFb::VicAirCleaningFb(const VicAirCleaningFb&) = default;

// NOLINTNEXTLINE
VicAirCleaningFb::VicAirCleaningFb(VicAirCleaningFb&&) = default;

VicAirCleaningFb& VicAirCleaningFb::operator=(const VicAirCleaningFb&) = default;

// NOLINTNEXTLINE
VicAirCleaningFb& VicAirCleaningFb::operator=(VicAirCleaningFb&&) = default;

void VicAirCleaningFb::toCsv(std::ostream& out) const
{
    out.precision(16);
    out << std::boolalpha;
    out << crc_VicAirCleaningFb;out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(alivVicAirCleaningFb);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(airFbCam_M_F);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(airFbCam_W_F);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(airFbLidar_F);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(airFbLidar_T);out << ",";
    out << macVicAirCleaningFb;
    
}

std::stringstream VicAirCleaningFb::toStringstream() const
{
    std::stringstream out;
    toCsv(out);
    return out;
}

template<class Archive>
    void VicAirCleaningFb::serialize(Archive& ar, [[maybe_unused]] unsigned int version)
    {

        ar& CEREAL_NVP(crc_VicAirCleaningFb);
        ar& CEREAL_NVP(alivVicAirCleaningFb);
        ar& CEREAL_NVP(airFbCam_M_F);
        ar& CEREAL_NVP(airFbCam_W_F);
        ar& CEREAL_NVP(airFbLidar_F);
        ar& CEREAL_NVP(airFbLidar_T);
        ar& CEREAL_NVP(macVicAirCleaningFb);
    }


template void VicAirCleaningFb::serialize(cereal::BinaryInputArchive& ar, unsigned int version);
template void VicAirCleaningFb::serialize(cereal::BinaryOutputArchive& ar, unsigned int version);
template void VicAirCleaningFb::serialize(cereal::IntrospectionArchive& ar, unsigned int version);
template void VicAirCleaningFb::serialize(cereal::JSONInputArchive& ar, unsigned int version);
template void VicAirCleaningFb::serialize(cereal::JSONOutputArchive& ar, unsigned int version);
template void VicAirCleaningFb::serialize(cereal::PortableBinaryInputArchive& ar, unsigned int version);
template void VicAirCleaningFb::serialize(cereal::PortableBinaryOutputArchive& ar, unsigned int version);

std::ostream& operator<< (std::ostream& os, const VicAirCleaningFb& vicaircleaningfb)
{
    vicaircleaningfb.toCsv(os);
    return os;
}

bool operator== (const VicAirCleaningFb &lhs, const VicAirCleaningFb &rhs)
{
    return (  lhs.crc_VicAirCleaningFb== rhs.crc_VicAirCleaningFb &&
     lhs.alivVicAirCleaningFb== rhs.alivVicAirCleaningFb &&
     lhs.airFbCam_M_F== rhs.airFbCam_M_F &&
     lhs.airFbCam_W_F== rhs.airFbCam_W_F &&
     lhs.airFbLidar_F== rhs.airFbLidar_F &&
     lhs.airFbLidar_T== rhs.airFbLidar_T &&
     lhs.macVicAirCleaningFb== rhs.macVicAirCleaningFb 
    );
}

std::size_t VicAirCleaningFb::hash() const noexcept
{
    std::size_t result = 17;
    result = result * 31 + std::hash<uint16_t>()(crc_VicAirCleaningFb);
    result = result * 31 + std::hash<uint8_t>()(alivVicAirCleaningFb);
    result = result * 31 + std::hash<uint8_t>()(airFbCam_M_F);
    result = result * 31 + std::hash<uint8_t>()(airFbCam_W_F);
    result = result * 31 + std::hash<uint8_t>()(airFbLidar_F);
    result = result * 31 + std::hash<uint8_t>()(airFbLidar_T);
    result = result * 31 + std::hash<uint64_t>()(macVicAirCleaningFb);
    return result;
}

 } // namespace av
 } // namespace msg


CEREAL_BIND_TO_ARCHIVES(av::msg::VicAirCleaningFb)

