#include <interfaces/VicWasherCleaningFb/VicWasherCleaningFb.h>

#include <iterator>
#include <type_traits>

#include <cereal/cereal.hpp>
#include <cereal/archives/json.hpp>
#include <cereal/archives/binary.hpp>

#include <cereal/types/map.hpp>
#include <cereal/types/vector.hpp>
#include <cereal/types/array.hpp>
#include <cereal/types/string.hpp>
#include <cereal/types/complex.hpp>

#include <ODatum/IntrospectionArchive.h>
#include <ODatum/Hash.h>





 namespace av {
 namespace msg {


VicWasherCleaningFb::VicWasherCleaningFb() = default;

VicWasherCleaningFb::VicWasherCleaningFb(
    uint16_t crcVicWasherCleaningFb_arg ,
    uint8_t alivVicWasherCleaningFb_arg ,
    uint8_t washFbCam_M_F_arg ,
    uint8_t washFbCam_W_F_arg ,
    uint8_t washFbLidar_F_arg ,
    uint8_t washFbLidar_T_arg ,
    uint8_t washFbCam_M_L0_arg ,
    uint8_t washFbCam_W_L0_arg ,
    uint8_t washFbCam_M_L1_arg ,
    uint8_t washFbCam_M_L2_arg ,
    uint8_t washFbCam_M_B_arg ,
    uint8_t washFbCam_W_B_arg ,
    uint8_t washFbCam_M_R2_arg ,
    uint8_t washFbCam_M_R1_arg ,
    uint8_t washFbCam_M_R0_arg ,
    uint8_t washFbCam_W_R0_arg ,
    uint8_t washFbCam_N_F_arg ,
    uint8_t washFbLidar_R_arg ,
    uint8_t washFbLidar_B_arg ,
    uint8_t washFbLidar_L_arg ,
    uint64_t macVicWasherCleaningFb_arg 
    ):
    crcVicWasherCleaningFb { std::move(crcVicWasherCleaningFb_arg) } // NOLINT
      ,alivVicWasherCleaningFb { std::move(alivVicWasherCleaningFb_arg) } // NOLINT
      ,washFbCam_M_F { std::move(washFbCam_M_F_arg) } // NOLINT
      ,washFbCam_W_F { std::move(washFbCam_W_F_arg) } // NOLINT
      ,washFbLidar_F { std::move(washFbLidar_F_arg) } // NOLINT
      ,washFbLidar_T { std::move(washFbLidar_T_arg) } // NOLINT
      ,washFbCam_M_L0 { std::move(washFbCam_M_L0_arg) } // NOLINT
      ,washFbCam_W_L0 { std::move(washFbCam_W_L0_arg) } // NOLINT
      ,washFbCam_M_L1 { std::move(washFbCam_M_L1_arg) } // NOLINT
      ,washFbCam_M_L2 { std::move(washFbCam_M_L2_arg) } // NOLINT
      ,washFbCam_M_B { std::move(washFbCam_M_B_arg) } // NOLINT
      ,washFbCam_W_B { std::move(washFbCam_W_B_arg) } // NOLINT
      ,washFbCam_M_R2 { std::move(washFbCam_M_R2_arg) } // NOLINT
      ,washFbCam_M_R1 { std::move(washFbCam_M_R1_arg) } // NOLINT
      ,washFbCam_M_R0 { std::move(washFbCam_M_R0_arg) } // NOLINT
      ,washFbCam_W_R0 { std::move(washFbCam_W_R0_arg) } // NOLINT
      ,washFbCam_N_F { std::move(washFbCam_N_F_arg) } // NOLINT
      ,washFbLidar_R { std::move(washFbLidar_R_arg) } // NOLINT
      ,washFbLidar_B { std::move(washFbLidar_B_arg) } // NOLINT
      ,washFbLidar_L { std::move(washFbLidar_L_arg) } // NOLINT
      ,macVicWasherCleaningFb { std::move(macVicWasherCleaningFb_arg) } // NOLINT
      {
}

VicWasherCleaningFb::VicWasherCleaningFb(const VicWasherCleaningFb&) = default;

// NOLINTNEXTLINE
VicWasherCleaningFb::VicWasherCleaningFb(VicWasherCleaningFb&&) = default;

VicWasherCleaningFb& VicWasherCleaningFb::operator=(const VicWasherCleaningFb&) = default;

// NOLINTNEXTLINE
VicWasherCleaningFb& VicWasherCleaningFb::operator=(VicWasherCleaningFb&&) = default;

void VicWasherCleaningFb::toCsv(std::ostream& out) const
{
    out.precision(16);
    out << std::boolalpha;
    out << crcVicWasherCleaningFb;out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(alivVicWasherCleaningFb);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washFbCam_M_F);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washFbCam_W_F);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washFbLidar_F);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washFbLidar_T);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washFbCam_M_L0);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washFbCam_W_L0);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washFbCam_M_L1);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washFbCam_M_L2);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washFbCam_M_B);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washFbCam_W_B);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washFbCam_M_R2);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washFbCam_M_R1);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washFbCam_M_R0);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washFbCam_W_R0);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washFbCam_N_F);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washFbLidar_R);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washFbLidar_B);out << ",";
    // Cast to uint16_t to print as integer instead of char
        out << static_cast<uint16_t>(washFbLidar_L);out << ",";
    out << macVicWasherCleaningFb;
    
}

std::stringstream VicWasherCleaningFb::toStringstream() const
{
    std::stringstream out;
    toCsv(out);
    return out;
}

template<class Archive>
    void VicWasherCleaningFb::serialize(Archive& ar, [[maybe_unused]] unsigned int version)
    {

        ar& CEREAL_NVP(crcVicWasherCleaningFb);
        ar& CEREAL_NVP(alivVicWasherCleaningFb);
        ar& CEREAL_NVP(washFbCam_M_F);
        ar& CEREAL_NVP(washFbCam_W_F);
        ar& CEREAL_NVP(washFbLidar_F);
        ar& CEREAL_NVP(washFbLidar_T);
        ar& CEREAL_NVP(washFbCam_M_L0);
        ar& CEREAL_NVP(washFbCam_W_L0);
        ar& CEREAL_NVP(washFbCam_M_L1);
        ar& CEREAL_NVP(washFbCam_M_L2);
        ar& CEREAL_NVP(washFbCam_M_B);
        ar& CEREAL_NVP(washFbCam_W_B);
        ar& CEREAL_NVP(washFbCam_M_R2);
        ar& CEREAL_NVP(washFbCam_M_R1);
        ar& CEREAL_NVP(washFbCam_M_R0);
        ar& CEREAL_NVP(washFbCam_W_R0);
        ar& CEREAL_NVP(washFbCam_N_F);
        ar& CEREAL_NVP(washFbLidar_R);
        ar& CEREAL_NVP(washFbLidar_B);
        ar& CEREAL_NVP(washFbLidar_L);
        ar& CEREAL_NVP(macVicWasherCleaningFb);
    }


template void VicWasherCleaningFb::serialize(cereal::BinaryInputArchive& ar, unsigned int version);
template void VicWasherCleaningFb::serialize(cereal::BinaryOutputArchive& ar, unsigned int version);
template void VicWasherCleaningFb::serialize(cereal::IntrospectionArchive& ar, unsigned int version);
template void VicWasherCleaningFb::serialize(cereal::JSONInputArchive& ar, unsigned int version);
template void VicWasherCleaningFb::serialize(cereal::JSONOutputArchive& ar, unsigned int version);
template void VicWasherCleaningFb::serialize(cereal::PortableBinaryInputArchive& ar, unsigned int version);
template void VicWasherCleaningFb::serialize(cereal::PortableBinaryOutputArchive& ar, unsigned int version);

std::ostream& operator<< (std::ostream& os, const VicWasherCleaningFb& vicwashercleaningfb)
{
    vicwashercleaningfb.toCsv(os);
    return os;
}

bool operator== (const VicWasherCleaningFb &lhs, const VicWasherCleaningFb &rhs)
{
    return (  lhs.crcVicWasherCleaningFb== rhs.crcVicWasherCleaningFb &&
     lhs.alivVicWasherCleaningFb== rhs.alivVicWasherCleaningFb &&
     lhs.washFbCam_M_F== rhs.washFbCam_M_F &&
     lhs.washFbCam_W_F== rhs.washFbCam_W_F &&
     lhs.washFbLidar_F== rhs.washFbLidar_F &&
     lhs.washFbLidar_T== rhs.washFbLidar_T &&
     lhs.washFbCam_M_L0== rhs.washFbCam_M_L0 &&
     lhs.washFbCam_W_L0== rhs.washFbCam_W_L0 &&
     lhs.washFbCam_M_L1== rhs.washFbCam_M_L1 &&
     lhs.washFbCam_M_L2== rhs.washFbCam_M_L2 &&
     lhs.washFbCam_M_B== rhs.washFbCam_M_B &&
     lhs.washFbCam_W_B== rhs.washFbCam_W_B &&
     lhs.washFbCam_M_R2== rhs.washFbCam_M_R2 &&
     lhs.washFbCam_M_R1== rhs.washFbCam_M_R1 &&
     lhs.washFbCam_M_R0== rhs.washFbCam_M_R0 &&
     lhs.washFbCam_W_R0== rhs.washFbCam_W_R0 &&
     lhs.washFbCam_N_F== rhs.washFbCam_N_F &&
     lhs.washFbLidar_R== rhs.washFbLidar_R &&
     lhs.washFbLidar_B== rhs.washFbLidar_B &&
     lhs.washFbLidar_L== rhs.washFbLidar_L &&
     lhs.macVicWasherCleaningFb== rhs.macVicWasherCleaningFb 
    );
}

std::size_t VicWasherCleaningFb::hash() const noexcept
{
    std::size_t result = 17;
    result = result * 31 + std::hash<uint16_t>()(crcVicWasherCleaningFb);
    result = result * 31 + std::hash<uint8_t>()(alivVicWasherCleaningFb);
    result = result * 31 + std::hash<uint8_t>()(washFbCam_M_F);
    result = result * 31 + std::hash<uint8_t>()(washFbCam_W_F);
    result = result * 31 + std::hash<uint8_t>()(washFbLidar_F);
    result = result * 31 + std::hash<uint8_t>()(washFbLidar_T);
    result = result * 31 + std::hash<uint8_t>()(washFbCam_M_L0);
    result = result * 31 + std::hash<uint8_t>()(washFbCam_W_L0);
    result = result * 31 + std::hash<uint8_t>()(washFbCam_M_L1);
    result = result * 31 + std::hash<uint8_t>()(washFbCam_M_L2);
    result = result * 31 + std::hash<uint8_t>()(washFbCam_M_B);
    result = result * 31 + std::hash<uint8_t>()(washFbCam_W_B);
    result = result * 31 + std::hash<uint8_t>()(washFbCam_M_R2);
    result = result * 31 + std::hash<uint8_t>()(washFbCam_M_R1);
    result = result * 31 + std::hash<uint8_t>()(washFbCam_M_R0);
    result = result * 31 + std::hash<uint8_t>()(washFbCam_W_R0);
    result = result * 31 + std::hash<uint8_t>()(washFbCam_N_F);
    result = result * 31 + std::hash<uint8_t>()(washFbLidar_R);
    result = result * 31 + std::hash<uint8_t>()(washFbLidar_B);
    result = result * 31 + std::hash<uint8_t>()(washFbLidar_L);
    result = result * 31 + std::hash<uint64_t>()(macVicWasherCleaningFb);
    return result;
}

 } // namespace av
 } // namespace msg


CEREAL_BIND_TO_ARCHIVES(av::msg::VicWasherCleaningFb)

