/*!
 ***********************************************************************************************************************
 * APTIV PRIVILEGED AND CONFIDENTIAL
 *
 * THIS IS AN AUTO GENERATED FILE!
 * DO NOT EDIT BY HAND!
 * check platform/idl_generator/jinja_templates/struct.template
 *
 * @brief Auto Generated Cereal Interface
 *
 * @section License
 *
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTE: Removing this heading is prohibited.
 *
 * @section Open Source License List
 *
 * This is a list of any open-source project used by this file.
 ***********************************************************************************************************************
 */

#ifndef _WITNESSTRAJWITHBOUNDS_H_
#define _WITNESSTRAJWITHBOUNDS_H_

#include <ODatum/ODatum.h>
#include <interfaces/traits/csvable.h>

#include <interfaces/WitnessTrajWithBoundsDefinitions.hpp>


#include <interfaces/SE2/SE2.h>





 namespace av {
 namespace msg {


class WitnessTrajState
    : public csvable
    , public aptv::ODatum
{
public:
    WitnessTrajState();

    WitnessTrajState(
        double x_m_arg ,
        double y_m_arg ,
        double yaw_rad_arg ,
        double curvature_k_arg ,
        double velocity_mps_arg ,
        double accel_mps2_arg ,
        double refpointOffset_m_arg 
        );

    WitnessTrajState(const WitnessTrajState&);

    // NOLINTNEXTLINE
    WitnessTrajState(WitnessTrajState&&);

    WitnessTrajState& operator=(const WitnessTrajState&);

    // NOLINTNEXTLINE
    WitnessTrajState& operator=(WitnessTrajState&&);

    
    double x_m
    {};
    double y_m
    {};
    double yaw_rad
    {};
    double curvature_k
    {};
    double velocity_mps
    {};
    double accel_mps2
    {};
    double refpointOffset_m
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const WitnessTrajState& witnesstrajstate);

    friend bool operator== (const WitnessTrajState &lhs, const WitnessTrajState &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::WitnessTrajState>
{
    std::size_t operator()(av::msg::WitnessTrajState const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::WitnessTrajState, 1)
ODATUM_NAMED_TYPE(av::msg::WitnessTrajState)

 namespace av {
 namespace msg {


class ConstraintBox
    : public csvable
    , public aptv::ODatum
{
public:
    ConstraintBox();

    ConstraintBox(
        double upper_arg ,
        double lower_arg 
        );

    ConstraintBox(const ConstraintBox&);

    // NOLINTNEXTLINE
    ConstraintBox(ConstraintBox&&);

    ConstraintBox& operator=(const ConstraintBox&);

    // NOLINTNEXTLINE
    ConstraintBox& operator=(ConstraintBox&&);

    
    double upper
    {};
    double lower
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const ConstraintBox& constraintbox);

    friend bool operator== (const ConstraintBox &lhs, const ConstraintBox &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::ConstraintBox>
{
    std::size_t operator()(av::msg::ConstraintBox const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::ConstraintBox, 1)
ODATUM_NAMED_TYPE(av::msg::ConstraintBox)



 namespace av {
 namespace msg {


class WitnessTrajWithBounds
    : public csvable
    , public aptv::ODatum
{
public:
    WitnessTrajWithBounds();

    WitnessTrajWithBounds(
        int64_t time_us_arg ,
        double timestep_s_arg ,
        int32_t numStates_arg ,
        std::vector<WitnessTrajState> states_arg ,
        std::vector<ConstraintBox> lateralTubeConstraints_m_arg ,
        std::vector<ConstraintBox> yawConstraints_rad_arg ,
        std::vector<ConstraintBox> tracksLonVel_mps2_arg ,
        std::vector<ConstraintBox> tracksLateralDistance_m_arg ,
        int32_t numConstraintsLeft_arg ,
        std::vector<SE2> leftConstraints_arg ,
        int32_t numConstraintsRight_arg ,
        std::vector<SE2> rightConstraints_arg 
        );

    WitnessTrajWithBounds(const WitnessTrajWithBounds&);

    // NOLINTNEXTLINE
    WitnessTrajWithBounds(WitnessTrajWithBounds&&);

    WitnessTrajWithBounds& operator=(const WitnessTrajWithBounds&);

    // NOLINTNEXTLINE
    WitnessTrajWithBounds& operator=(WitnessTrajWithBounds&&);

    
    int64_t time_us
    {};
    double timestep_s
    {};
    int32_t numStates
    {};
    std::vector<WitnessTrajState> states
    {};
    std::vector<ConstraintBox> lateralTubeConstraints_m
    {};
    std::vector<ConstraintBox> yawConstraints_rad
    {};
    std::vector<ConstraintBox> tracksLonVel_mps2
    {};
    std::vector<ConstraintBox> tracksLateralDistance_m
    {};
    int32_t numConstraintsLeft
    {};
    std::vector<SE2> leftConstraints
    {};
    int32_t numConstraintsRight
    {};
    std::vector<SE2> rightConstraints
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const WitnessTrajWithBounds& witnesstrajwithbounds);

    friend bool operator== (const WitnessTrajWithBounds &lhs, const WitnessTrajWithBounds &rhs);

    template<class Archive>
    void serialize([[maybe_unused]] Archive& ar, [[maybe_unused]] unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::WitnessTrajWithBounds>
{
    std::size_t operator()(av::msg::WitnessTrajWithBounds const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::WitnessTrajWithBounds, 2)
ODATUM_NAMED_TYPE(av::msg::WitnessTrajWithBounds)



#endif // _WITNESSTRAJWITHBOUNDS_H_
