/*!
 ***********************************************************************************************************************
 * APTIV PRIVILEGED AND CONFIDENTIAL
 *
 * THIS IS AN AUTO GENERATED FILE!
 * DO NOT EDIT BY HAND!
 * check platform/idl_generator/jinja_templates/struct.template
 *
 * @brief Auto Generated Cereal Interface
 *
 * @section License
 *
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTE: Removing this heading is prohibited.
 *
 * @section Open Source License List
 *
 * This is a list of any open-source project used by this file.
 ***********************************************************************************************************************
 */

#ifndef _WORLDMANAGER_H_
#define _WORLDMANAGER_H_

#include <ODatum/ODatum.h>
#include <interfaces/traits/csvable.h>

#include <interfaces/WorldManagerDefinitions.hpp>


#include <interfaces/SE2/SE2.h>

#include <interfaces/controller_status_message/controller_status_message.h>





 namespace av {
 namespace msg {
 namespace world_types {


class TrackInfoBase
    : public csvable
    , public aptv::ODatum
{
public:
    TrackInfoBase();

    TrackInfoBase(
        int64_t id_arg ,
        bool isReal_arg ,
        bool isActive_arg ,
        bool isConverged_arg ,
        av::msg::SE2 centerPose_arg ,
        av::msg::SE2 frontPose_arg ,
        av::msg::SE2 rearPose_arg ,
        av::msg::SE2 leftCornerPose_arg ,
        av::msg::SE2 rightCornerPose_arg ,
        double length_arg ,
        double width_arg ,
        double vx_arg ,
        double vy_arg ,
        double speed_arg ,
        double accel_arg ,
        double yawRate_arg ,
        std::vector<double> typeBelief_arg ,
        double beliefThreshold_arg 
        );

    TrackInfoBase(const TrackInfoBase&);

    // NOLINTNEXTLINE
    TrackInfoBase(TrackInfoBase&&);

    TrackInfoBase& operator=(const TrackInfoBase&);

    // NOLINTNEXTLINE
    TrackInfoBase& operator=(TrackInfoBase&&);

    
    int64_t id
    {};
    bool isReal
    {};
    bool isActive
    {};
    bool isConverged
    {};
    av::msg::SE2 centerPose
    {};
    av::msg::SE2 frontPose
    {};
    av::msg::SE2 rearPose
    {};
    av::msg::SE2 leftCornerPose
    {};
    av::msg::SE2 rightCornerPose
    {};
    double length
    {};
    double width
    {};
    double vx
    {};
    double vy
    {};
    double speed
    {};
    double accel
    {};
    double yawRate
    {};
    std::vector<double> typeBelief
    {};
    double beliefThreshold
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const TrackInfoBase& trackinfobase);

    friend bool operator== (const TrackInfoBase &lhs, const TrackInfoBase &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace world_types


template<> struct std::hash<av::msg::world_types::TrackInfoBase>
{
    std::size_t operator()(av::msg::world_types::TrackInfoBase const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::world_types::TrackInfoBase, 1)
ODATUM_NAMED_TYPE(av::msg::world_types::TrackInfoBase)

 namespace av {
 namespace msg {
 namespace world_types {


class TurnSignal
    : public csvable
    , public aptv::ODatum
{
public:
    TurnSignal();

    TurnSignal(
        TurnSignalType signal_arg ,
        double secOn_arg 
        );

    TurnSignal(const TurnSignal&);

    // NOLINTNEXTLINE
    TurnSignal(TurnSignal&&);

    TurnSignal& operator=(const TurnSignal&);

    // NOLINTNEXTLINE
    TurnSignal& operator=(TurnSignal&&);

    
    TurnSignalType signal
    {};
    double secOn
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const TurnSignal& turnsignal);

    friend bool operator== (const TurnSignal &lhs, const TurnSignal &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace world_types


template<> struct std::hash<av::msg::world_types::TurnSignal>
{
    std::size_t operator()(av::msg::world_types::TurnSignal const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::world_types::TurnSignal, 1)
ODATUM_NAMED_TYPE(av::msg::world_types::TurnSignal)

 namespace av {
 namespace msg {
 namespace world_types {


class AccelConstraint
    : public csvable
    , public aptv::ODatum
{
public:
    AccelConstraint();

    AccelConstraint(
        std::string type_arg ,
        double accel_arg ,
        std::string id_arg 
        );

    AccelConstraint(const AccelConstraint&);

    // NOLINTNEXTLINE
    AccelConstraint(AccelConstraint&&);

    AccelConstraint& operator=(const AccelConstraint&);

    // NOLINTNEXTLINE
    AccelConstraint& operator=(AccelConstraint&&);

    
    std::string type
    {};
    double accel
    {};
    std::string id
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const AccelConstraint& accelconstraint);

    friend bool operator== (const AccelConstraint &lhs, const AccelConstraint &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace world_types


template<> struct std::hash<av::msg::world_types::AccelConstraint>
{
    std::size_t operator()(av::msg::world_types::AccelConstraint const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::world_types::AccelConstraint, 1)
ODATUM_NAMED_TYPE(av::msg::world_types::AccelConstraint)

 namespace av {
 namespace msg {
 namespace world_types {


class LaneGroup
    : public csvable
    , public aptv::ODatum
{
public:
    LaneGroup();

    LaneGroup(
        std::vector<std::string> lanes_arg 
        );

    LaneGroup(const LaneGroup&);

    // NOLINTNEXTLINE
    LaneGroup(LaneGroup&&);

    LaneGroup& operator=(const LaneGroup&);

    // NOLINTNEXTLINE
    LaneGroup& operator=(LaneGroup&&);

    
    std::vector<std::string> lanes
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const LaneGroup& lanegroup);

    friend bool operator== (const LaneGroup &lhs, const LaneGroup &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace world_types


template<> struct std::hash<av::msg::world_types::LaneGroup>
{
    std::size_t operator()(av::msg::world_types::LaneGroup const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::world_types::LaneGroup, 1)
ODATUM_NAMED_TYPE(av::msg::world_types::LaneGroup)

 namespace av {
 namespace msg {
 namespace world_types {


class TrafficLight
    : public csvable
    , public aptv::ODatum
{
public:
    TrafficLight();

    TrafficLight(
        int8_t fov_arg ,
        int8_t state_arg ,
        int8_t confidenceLevel_arg 
        );

    TrafficLight(const TrafficLight&);

    // NOLINTNEXTLINE
    TrafficLight(TrafficLight&&);

    TrafficLight& operator=(const TrafficLight&);

    // NOLINTNEXTLINE
    TrafficLight& operator=(TrafficLight&&);

    
    int8_t fov
    {};
    int8_t state
    {};
    int8_t confidenceLevel
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const TrafficLight& trafficlight);

    friend bool operator== (const TrafficLight &lhs, const TrafficLight &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace world_types


template<> struct std::hash<av::msg::world_types::TrafficLight>
{
    std::size_t operator()(av::msg::world_types::TrafficLight const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::world_types::TrafficLight, 1)
ODATUM_NAMED_TYPE(av::msg::world_types::TrafficLight)

 namespace av {
 namespace msg {
 namespace world_types {


class DistanceAndIds
    : public csvable
    , public aptv::ODatum
{
public:
    DistanceAndIds();

    DistanceAndIds(
        double distance_arg ,
        int64_t track1Id_arg ,
        int64_t track2Id_arg 
        );

    DistanceAndIds(const DistanceAndIds&);

    // NOLINTNEXTLINE
    DistanceAndIds(DistanceAndIds&&);

    DistanceAndIds& operator=(const DistanceAndIds&);

    // NOLINTNEXTLINE
    DistanceAndIds& operator=(DistanceAndIds&&);

    
    double distance
    {};
    int64_t track1Id
    {};
    int64_t track2Id
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const DistanceAndIds& distanceandids);

    friend bool operator== (const DistanceAndIds &lhs, const DistanceAndIds &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace world_types


template<> struct std::hash<av::msg::world_types::DistanceAndIds>
{
    std::size_t operator()(av::msg::world_types::DistanceAndIds const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::world_types::DistanceAndIds, 1)
ODATUM_NAMED_TYPE(av::msg::world_types::DistanceAndIds)

 namespace av {
 namespace msg {
 namespace world_types {


class TimeToCollisionAndIds
    : public csvable
    , public aptv::ODatum
{
public:
    TimeToCollisionAndIds();

    TimeToCollisionAndIds(
        double timeToCollision_arg ,
        int64_t track1Id_arg ,
        int64_t track2Id_arg 
        );

    TimeToCollisionAndIds(const TimeToCollisionAndIds&);

    // NOLINTNEXTLINE
    TimeToCollisionAndIds(TimeToCollisionAndIds&&);

    TimeToCollisionAndIds& operator=(const TimeToCollisionAndIds&);

    // NOLINTNEXTLINE
    TimeToCollisionAndIds& operator=(TimeToCollisionAndIds&&);

    
    double timeToCollision
    {};
    int64_t track1Id
    {};
    int64_t track2Id
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const TimeToCollisionAndIds& timetocollisionandids);

    friend bool operator== (const TimeToCollisionAndIds &lhs, const TimeToCollisionAndIds &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace world_types


template<> struct std::hash<av::msg::world_types::TimeToCollisionAndIds>
{
    std::size_t operator()(av::msg::world_types::TimeToCollisionAndIds const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::world_types::TimeToCollisionAndIds, 1)
ODATUM_NAMED_TYPE(av::msg::world_types::TimeToCollisionAndIds)

 namespace av {
 namespace msg {
 namespace world_types {


class TimeId
    : public csvable
    , public aptv::ODatum
{
public:
    TimeId();

    TimeId(
        double time_arg ,
        int64_t trackId_arg 
        );

    TimeId(const TimeId&);

    // NOLINTNEXTLINE
    TimeId(TimeId&&);

    TimeId& operator=(const TimeId&);

    // NOLINTNEXTLINE
    TimeId& operator=(TimeId&&);

    
    double time
    {};
    int64_t trackId
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const TimeId& timeid);

    friend bool operator== (const TimeId &lhs, const TimeId &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace world_types


template<> struct std::hash<av::msg::world_types::TimeId>
{
    std::size_t operator()(av::msg::world_types::TimeId const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::world_types::TimeId, 1)
ODATUM_NAMED_TYPE(av::msg::world_types::TimeId)

 namespace av {
 namespace msg {
 namespace world_types {


class Route
    : public csvable
    , public aptv::ODatum
{
public:
    Route();

    Route(
        bool isOppositeDirection_arg ,
        std::vector<av::msg::world_types::LaneGroup> groups_arg ,
        av::msg::SE2 currentGoal_arg 
        );

    Route(const Route&);

    // NOLINTNEXTLINE
    Route(Route&&);

    Route& operator=(const Route&);

    // NOLINTNEXTLINE
    Route& operator=(Route&&);

    
    bool isOppositeDirection
    {};
    std::vector<av::msg::world_types::LaneGroup> groups
    {};
    av::msg::SE2 currentGoal
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const Route& route);

    friend bool operator== (const Route &lhs, const Route &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace world_types


template<> struct std::hash<av::msg::world_types::Route>
{
    std::size_t operator()(av::msg::world_types::Route const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::world_types::Route, 1)
ODATUM_NAMED_TYPE(av::msg::world_types::Route)

 namespace av {
 namespace msg {
 namespace world_types {


class TrafficLights
    : public csvable
    , public aptv::ODatum
{
public:
    TrafficLights();

    TrafficLights(
        int64_t utime_arg ,
        std::string intersectionId_arg ,
        std::string fromRoadblockId_arg ,
        av::msg::world_types::TrafficLight mainLightInfo_arg ,
        std::vector<std::string> toRoadblockIds_arg ,
        std::vector<av::msg::world_types::TrafficLight> dedicatedLightInfo_arg 
        );

    TrafficLights(const TrafficLights&);

    // NOLINTNEXTLINE
    TrafficLights(TrafficLights&&);

    TrafficLights& operator=(const TrafficLights&);

    // NOLINTNEXTLINE
    TrafficLights& operator=(TrafficLights&&);

    
    int64_t utime
    {};
    std::string intersectionId
    {};
    std::string fromRoadblockId
    {};
    av::msg::world_types::TrafficLight mainLightInfo
    {};
    std::vector<std::string> toRoadblockIds
    {};
    std::vector<av::msg::world_types::TrafficLight> dedicatedLightInfo
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const TrafficLights& trafficlights);

    friend bool operator== (const TrafficLights &lhs, const TrafficLights &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace world_types


template<> struct std::hash<av::msg::world_types::TrafficLights>
{
    std::size_t operator()(av::msg::world_types::TrafficLights const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::world_types::TrafficLights, 1)
ODATUM_NAMED_TYPE(av::msg::world_types::TrafficLights)

 namespace av {
 namespace msg {
 namespace world_types {


class WorldTrack
    : public csvable
    , public aptv::ODatum
{
public:
    WorldTrack();

    WorldTrack(
        av::msg::world_types::TrackInfoBase trackBase_arg ,
        av::msg::world_types::TurnSignal turnSignal_arg ,
        av::msg::world_types::Route route_arg ,
        std::vector<av::msg::SE2> waypoint_arg ,
        std::vector<std::string> adjacentLanes_arg ,
        int64_t trackAhead_arg ,
        std::vector<int64_t> tracksBlocked_arg ,
        std::vector<av::msg::world_types::AccelConstraint> accelConstraints_arg 
        );

    WorldTrack(const WorldTrack&);

    // NOLINTNEXTLINE
    WorldTrack(WorldTrack&&);

    WorldTrack& operator=(const WorldTrack&);

    // NOLINTNEXTLINE
    WorldTrack& operator=(WorldTrack&&);

    
    av::msg::world_types::TrackInfoBase trackBase
    {};
    av::msg::world_types::TurnSignal turnSignal
    {};
    av::msg::world_types::Route route
    {};
    std::vector<av::msg::SE2> waypoint
    {};
    std::vector<std::string> adjacentLanes
    {};
    int64_t trackAhead
    {};
    std::vector<int64_t> tracksBlocked
    {};
    std::vector<av::msg::world_types::AccelConstraint> accelConstraints
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const WorldTrack& worldtrack);

    friend bool operator== (const WorldTrack &lhs, const WorldTrack &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace world_types


template<> struct std::hash<av::msg::world_types::WorldTrack>
{
    std::size_t operator()(av::msg::world_types::WorldTrack const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::world_types::WorldTrack, 1)
ODATUM_NAMED_TYPE(av::msg::world_types::WorldTrack)

 namespace av {
 namespace msg {
 namespace world_types {


class World
    : public csvable
    , public aptv::ODatum
{
public:
    World();

    World(
        int64_t utime_arg ,
        int64_t egoId_arg ,
        std::vector<av::msg::world_types::WorldTrack> tracks_arg ,
        av::msg::world_types::TrafficLights trafficLights_arg 
        );

    World(const World&);

    // NOLINTNEXTLINE
    World(World&&);

    World& operator=(const World&);

    // NOLINTNEXTLINE
    World& operator=(World&&);

    
    int64_t utime
    {};
    int64_t egoId
    {};
    std::vector<av::msg::world_types::WorldTrack> tracks
    {};
    av::msg::world_types::TrafficLights trafficLights
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const World& world);

    friend bool operator== (const World &lhs, const World &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace world_types


template<> struct std::hash<av::msg::world_types::World>
{
    std::size_t operator()(av::msg::world_types::World const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::world_types::World, 1)
ODATUM_NAMED_TYPE(av::msg::world_types::World)

 namespace av {
 namespace msg {
 namespace world_types {


class WorldTrajectory
    : public csvable
    , public aptv::ODatum
{
public:
    WorldTrajectory();

    WorldTrajectory(
        std::vector<av::msg::world_types::World> trajectory_arg 
        );

    WorldTrajectory(const WorldTrajectory&);

    // NOLINTNEXTLINE
    WorldTrajectory(WorldTrajectory&&);

    WorldTrajectory& operator=(const WorldTrajectory&);

    // NOLINTNEXTLINE
    WorldTrajectory& operator=(WorldTrajectory&&);

    
    std::vector<av::msg::world_types::World> trajectory
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const WorldTrajectory& worldtrajectory);

    friend bool operator== (const WorldTrajectory &lhs, const WorldTrajectory &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace world_types


template<> struct std::hash<av::msg::world_types::WorldTrajectory>
{
    std::size_t operator()(av::msg::world_types::WorldTrajectory const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::world_types::WorldTrajectory, 1)
ODATUM_NAMED_TYPE(av::msg::world_types::WorldTrajectory)



 namespace av {
 namespace msg {


class WorldManager
    : public csvable
    , public aptv::ODatum
{
public:
    WorldManager();

    WorldManager(
        int8_t rollingCounter_arg ,
        av::msg::world_types::World current_arg ,
        std::vector<av::msg::world_types::WorldTrajectory> predictions_arg ,
        std::vector<av::msg::NamedVectorOfDouble> debugVariables_arg 
        );

    WorldManager(const WorldManager&);

    // NOLINTNEXTLINE
    WorldManager(WorldManager&&);

    WorldManager& operator=(const WorldManager&);

    // NOLINTNEXTLINE
    WorldManager& operator=(WorldManager&&);

    
    int8_t rollingCounter
    {};
    av::msg::world_types::World current
    {};
    std::vector<av::msg::world_types::WorldTrajectory> predictions
    {};
    std::vector<av::msg::NamedVectorOfDouble> debugVariables
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const WorldManager& worldmanager);

    friend bool operator== (const WorldManager &lhs, const WorldManager &rhs);

    template<class Archive>
    void serialize([[maybe_unused]] Archive& ar, [[maybe_unused]] unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg


template<> struct std::hash<av::msg::WorldManager>
{
    std::size_t operator()(av::msg::WorldManager const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::WorldManager, 2)
ODATUM_NAMED_TYPE(av::msg::WorldManager)



#endif // _WORLDMANAGER_H_
