#include <interfaces/auto_ready_avt/auto_ready_avt.h>

#include <iterator>
#include <type_traits>

#include <cereal/cereal.hpp>
#include <cereal/archives/json.hpp>
#include <cereal/archives/binary.hpp>

#include <cereal/types/map.hpp>
#include <cereal/types/vector.hpp>
#include <cereal/types/array.hpp>
#include <cereal/types/string.hpp>
#include <cereal/types/complex.hpp>

#include <ODatum/IntrospectionArchive.h>
#include <ODatum/Hash.h>







auto_ready_avt::auto_ready_avt() = default;

auto_ready_avt::auto_ready_avt(
    int64_t timeStamp__arg ,
    bool isAutoReady__arg ,
    bool isSafeInAuto__arg ,
    std::string autoReadyMessage__arg ,
    std::string safeInAutoMessage__arg 
    ):
    timeStamp_ { std::move(timeStamp__arg) } // NOLINT
      ,isAutoReady_ { std::move(isAutoReady__arg) } // NOLINT
      ,isSafeInAuto_ { std::move(isSafeInAuto__arg) } // NOLINT
      ,autoReadyMessage_ { std::move(autoReadyMessage__arg) } // NOLINT
      ,safeInAutoMessage_ { std::move(safeInAutoMessage__arg) } // NOLINT
      {
}

auto_ready_avt::auto_ready_avt(const auto_ready_avt&) = default;

// NOLINTNEXTLINE
auto_ready_avt::auto_ready_avt(auto_ready_avt&&) = default;

auto_ready_avt& auto_ready_avt::operator=(const auto_ready_avt&) = default;

// NOLINTNEXTLINE
auto_ready_avt& auto_ready_avt::operator=(auto_ready_avt&&) = default;

void auto_ready_avt::toCsv(std::ostream& out) const
{
    out.precision(16);
    out << std::boolalpha;
    out << timeStamp_;out << ",";
    out << isAutoReady_;out << ",";
    out << isSafeInAuto_;out << ",";
    out << "\"";
        out << autoReadyMessage_;
        out << "\"";out << ",";
    out << "\"";
        out << safeInAutoMessage_;
        out << "\"";
    
}

std::stringstream auto_ready_avt::toStringstream() const
{
    std::stringstream out;
    toCsv(out);
    return out;
}

template<class Archive>
    void auto_ready_avt::serialize(Archive& ar, [[maybe_unused]] unsigned int version)
    {

        ar& CEREAL_NVP(timeStamp_);
        ar& CEREAL_NVP(isAutoReady_);
        ar& CEREAL_NVP(isSafeInAuto_);
        ar& CEREAL_NVP(autoReadyMessage_);
        ar& CEREAL_NVP(safeInAutoMessage_);
    }


template void auto_ready_avt::serialize(cereal::BinaryInputArchive& ar, unsigned int version);
template void auto_ready_avt::serialize(cereal::BinaryOutputArchive& ar, unsigned int version);
template void auto_ready_avt::serialize(cereal::IntrospectionArchive& ar, unsigned int version);
template void auto_ready_avt::serialize(cereal::JSONInputArchive& ar, unsigned int version);
template void auto_ready_avt::serialize(cereal::JSONOutputArchive& ar, unsigned int version);
template void auto_ready_avt::serialize(cereal::PortableBinaryInputArchive& ar, unsigned int version);
template void auto_ready_avt::serialize(cereal::PortableBinaryOutputArchive& ar, unsigned int version);

std::ostream& operator<< (std::ostream& os, const auto_ready_avt& auto_ready_avt)
{
    auto_ready_avt.toCsv(os);
    return os;
}

bool operator== (const auto_ready_avt &lhs, const auto_ready_avt &rhs)
{
    return (  lhs.timeStamp_== rhs.timeStamp_ &&
     lhs.isAutoReady_== rhs.isAutoReady_ &&
     lhs.isSafeInAuto_== rhs.isSafeInAuto_ &&
     lhs.autoReadyMessage_== rhs.autoReadyMessage_ &&
     lhs.safeInAutoMessage_== rhs.safeInAutoMessage_ 
    );
}

std::size_t auto_ready_avt::hash() const noexcept
{
    std::size_t result = 17;
    result = result * 31 + std::hash<int64_t>()(timeStamp_);
    result = result * 31 + std::hash<bool>()(isAutoReady_);
    result = result * 31 + std::hash<bool>()(isSafeInAuto_);
    result = result * 31 + std::hash<std::string>()(autoReadyMessage_);
    result = result * 31 + std::hash<std::string>()(safeInAutoMessage_);
    return result;
}



CEREAL_BIND_TO_ARCHIVES(auto_ready_avt)

