#include <interfaces/av_status_avt/av_status_avt.h>

#include <iterator>
#include <type_traits>

#include <cereal/cereal.hpp>
#include <cereal/archives/json.hpp>
#include <cereal/archives/binary.hpp>

#include <cereal/types/map.hpp>
#include <cereal/types/vector.hpp>
#include <cereal/types/array.hpp>
#include <cereal/types/string.hpp>
#include <cereal/types/complex.hpp>

#include <ODatum/IntrospectionArchive.h>
#include <ODatum/Hash.h>





 namespace av {
 namespace msg {


av_status_avt::av_status_avt() = default;

av_status_avt::av_status_avt(
    bool autonomous_arg ,
    bool brakeOverride_arg ,
    bool steerOverride_arg ,
    bool throttleOverride_arg ,
    bool manualOverride_arg 
    ):
    autonomous { std::move(autonomous_arg) } // NOLINT
      ,brakeOverride { std::move(brakeOverride_arg) } // NOLINT
      ,steerOverride { std::move(steerOverride_arg) } // NOLINT
      ,throttleOverride { std::move(throttleOverride_arg) } // NOLINT
      ,manualOverride { std::move(manualOverride_arg) } // NOLINT
      {
}

av_status_avt::av_status_avt(const av_status_avt&) = default;

// NOLINTNEXTLINE
av_status_avt::av_status_avt(av_status_avt&&) = default;

av_status_avt& av_status_avt::operator=(const av_status_avt&) = default;

// NOLINTNEXTLINE
av_status_avt& av_status_avt::operator=(av_status_avt&&) = default;

void av_status_avt::toCsv(std::ostream& out) const
{
    out.precision(16);
    out << std::boolalpha;
    out << autonomous;out << ",";
    out << brakeOverride;out << ",";
    out << steerOverride;out << ",";
    out << throttleOverride;out << ",";
    out << manualOverride;
    
}

std::stringstream av_status_avt::toStringstream() const
{
    std::stringstream out;
    toCsv(out);
    return out;
}

template<class Archive>
    void av_status_avt::serialize(Archive& ar, [[maybe_unused]] unsigned int version)
    {

        ar& CEREAL_NVP(autonomous);
        ar& CEREAL_NVP(brakeOverride);
        ar& CEREAL_NVP(steerOverride);
        ar& CEREAL_NVP(throttleOverride);
        ar& CEREAL_NVP(manualOverride);
    }


template void av_status_avt::serialize(cereal::BinaryInputArchive& ar, unsigned int version);
template void av_status_avt::serialize(cereal::BinaryOutputArchive& ar, unsigned int version);
template void av_status_avt::serialize(cereal::IntrospectionArchive& ar, unsigned int version);
template void av_status_avt::serialize(cereal::JSONInputArchive& ar, unsigned int version);
template void av_status_avt::serialize(cereal::JSONOutputArchive& ar, unsigned int version);
template void av_status_avt::serialize(cereal::PortableBinaryInputArchive& ar, unsigned int version);
template void av_status_avt::serialize(cereal::PortableBinaryOutputArchive& ar, unsigned int version);

std::ostream& operator<< (std::ostream& os, const av_status_avt& av_status_avt)
{
    av_status_avt.toCsv(os);
    return os;
}

bool operator== (const av_status_avt &lhs, const av_status_avt &rhs)
{
    return (  lhs.autonomous== rhs.autonomous &&
     lhs.brakeOverride== rhs.brakeOverride &&
     lhs.steerOverride== rhs.steerOverride &&
     lhs.throttleOverride== rhs.throttleOverride &&
     lhs.manualOverride== rhs.manualOverride 
    );
}

std::size_t av_status_avt::hash() const noexcept
{
    std::size_t result = 17;
    result = result * 31 + std::hash<bool>()(autonomous);
    result = result * 31 + std::hash<bool>()(brakeOverride);
    result = result * 31 + std::hash<bool>()(steerOverride);
    result = result * 31 + std::hash<bool>()(throttleOverride);
    result = result * 31 + std::hash<bool>()(manualOverride);
    return result;
}

 } // namespace av
 } // namespace msg


CEREAL_BIND_TO_ARCHIVES(av::msg::av_status_avt)

