#include <interfaces/baselabs_system_monitoring_avt/baselabs_system_monitoring_avt.h>

#include <iterator>
#include <type_traits>

#include <cereal/cereal.hpp>
#include <cereal/archives/json.hpp>
#include <cereal/archives/binary.hpp>

#include <cereal/types/map.hpp>
#include <cereal/types/vector.hpp>
#include <cereal/types/array.hpp>
#include <cereal/types/string.hpp>
#include <cereal/types/complex.hpp>

#include <ODatum/IntrospectionArchive.h>
#include <ODatum/Hash.h>





 namespace av {
 namespace msg {


baselabs_system_monitoring_avt::baselabs_system_monitoring_avt() = default;

baselabs_system_monitoring_avt::baselabs_system_monitoring_avt(
    int64_t timeStamp_arg ,
    SH1_Outputs_avt SH1_Outputs_arg ,
    SH1_Protocol_Version_avt SH1_Protocol_Version_arg ,
    SH1_Error_State_avt SH1_Error_State_arg 
    ):
    timeStamp { std::move(timeStamp_arg) } // NOLINT
      ,SH1_Outputs { std::move(SH1_Outputs_arg) } // NOLINT
      ,SH1_Protocol_Version { std::move(SH1_Protocol_Version_arg) } // NOLINT
      ,SH1_Error_State { std::move(SH1_Error_State_arg) } // NOLINT
      {
}

baselabs_system_monitoring_avt::baselabs_system_monitoring_avt(const baselabs_system_monitoring_avt&) = default;

// NOLINTNEXTLINE
baselabs_system_monitoring_avt::baselabs_system_monitoring_avt(baselabs_system_monitoring_avt&&) = default;

baselabs_system_monitoring_avt& baselabs_system_monitoring_avt::operator=(const baselabs_system_monitoring_avt&) = default;

// NOLINTNEXTLINE
baselabs_system_monitoring_avt& baselabs_system_monitoring_avt::operator=(baselabs_system_monitoring_avt&&) = default;

void baselabs_system_monitoring_avt::toCsv(std::ostream& out) const
{
    out.precision(16);
    out << std::boolalpha;
    out << timeStamp;out << ",";
    out << SH1_Outputs;out << ",";
    out << SH1_Protocol_Version;out << ",";
    out << SH1_Error_State;
    
}

std::stringstream baselabs_system_monitoring_avt::toStringstream() const
{
    std::stringstream out;
    toCsv(out);
    return out;
}

template<class Archive>
    void baselabs_system_monitoring_avt::serialize(Archive& ar, [[maybe_unused]] unsigned int version)
    {

        ar& CEREAL_NVP(timeStamp);
        ar& CEREAL_NVP(SH1_Outputs);
        ar& CEREAL_NVP(SH1_Protocol_Version);
        ar& CEREAL_NVP(SH1_Error_State);
    }


template void baselabs_system_monitoring_avt::serialize(cereal::BinaryInputArchive& ar, unsigned int version);
template void baselabs_system_monitoring_avt::serialize(cereal::BinaryOutputArchive& ar, unsigned int version);
template void baselabs_system_monitoring_avt::serialize(cereal::IntrospectionArchive& ar, unsigned int version);
template void baselabs_system_monitoring_avt::serialize(cereal::JSONInputArchive& ar, unsigned int version);
template void baselabs_system_monitoring_avt::serialize(cereal::JSONOutputArchive& ar, unsigned int version);
template void baselabs_system_monitoring_avt::serialize(cereal::PortableBinaryInputArchive& ar, unsigned int version);
template void baselabs_system_monitoring_avt::serialize(cereal::PortableBinaryOutputArchive& ar, unsigned int version);

std::ostream& operator<< (std::ostream& os, const baselabs_system_monitoring_avt& baselabs_system_monitoring_avt)
{
    baselabs_system_monitoring_avt.toCsv(os);
    return os;
}

bool operator== (const baselabs_system_monitoring_avt &lhs, const baselabs_system_monitoring_avt &rhs)
{
    return (  lhs.timeStamp== rhs.timeStamp &&
     lhs.SH1_Outputs== rhs.SH1_Outputs &&
     lhs.SH1_Protocol_Version== rhs.SH1_Protocol_Version &&
     lhs.SH1_Error_State== rhs.SH1_Error_State 
    );
}

std::size_t baselabs_system_monitoring_avt::hash() const noexcept
{
    std::size_t result = 17;
    result = result * 31 + std::hash<int64_t>()(timeStamp);
    result = result * 31 + std::hash<SH1_Outputs_avt>()(SH1_Outputs);
    result = result * 31 + std::hash<SH1_Protocol_Version_avt>()(SH1_Protocol_Version);
    result = result * 31 + std::hash<SH1_Error_State_avt>()(SH1_Error_State);
    return result;
}

 } // namespace av
 } // namespace msg


CEREAL_BIND_TO_ARCHIVES(av::msg::baselabs_system_monitoring_avt)

