#include <interfaces/dynamic_occupancy_grid_avt/dynamic_occupancy_grid_avt.h>

#include <iterator>
#include <type_traits>

#include <cereal/cereal.hpp>
#include <cereal/archives/json.hpp>
#include <cereal/archives/binary.hpp>

#include <cereal/types/map.hpp>
#include <cereal/types/vector.hpp>
#include <cereal/types/array.hpp>
#include <cereal/types/string.hpp>
#include <cereal/types/complex.hpp>

#include <ODatum/IntrospectionArchive.h>
#include <ODatum/Hash.h>





 namespace av {
 namespace msg {


dynamic_occupancy_grid_avt::dynamic_occupancy_grid_avt() = default;

dynamic_occupancy_grid_avt::dynamic_occupancy_grid_avt(
    int64_t timeStamp_arg ,
    SH2_Outputs_avt SH2_Outputs_arg ,
    SH2_Protocol_Version_avt SH2_Protocol_Version_arg ,
    SH2_Error_State_avt SH2_Error_State_arg 
    ):
    timeStamp { std::move(timeStamp_arg) } // NOLINT
      ,SH2_Outputs { std::move(SH2_Outputs_arg) } // NOLINT
      ,SH2_Protocol_Version { std::move(SH2_Protocol_Version_arg) } // NOLINT
      ,SH2_Error_State { std::move(SH2_Error_State_arg) } // NOLINT
      {
}

dynamic_occupancy_grid_avt::dynamic_occupancy_grid_avt(const dynamic_occupancy_grid_avt&) = default;

// NOLINTNEXTLINE
dynamic_occupancy_grid_avt::dynamic_occupancy_grid_avt(dynamic_occupancy_grid_avt&&) = default;

dynamic_occupancy_grid_avt& dynamic_occupancy_grid_avt::operator=(const dynamic_occupancy_grid_avt&) = default;

// NOLINTNEXTLINE
dynamic_occupancy_grid_avt& dynamic_occupancy_grid_avt::operator=(dynamic_occupancy_grid_avt&&) = default;

void dynamic_occupancy_grid_avt::toCsv(std::ostream& out) const
{
    out.precision(16);
    out << std::boolalpha;
    out << timeStamp;out << ",";
    out << SH2_Outputs;out << ",";
    out << SH2_Protocol_Version;out << ",";
    out << SH2_Error_State;
    
}

std::stringstream dynamic_occupancy_grid_avt::toStringstream() const
{
    std::stringstream out;
    toCsv(out);
    return out;
}

template<class Archive>
    void dynamic_occupancy_grid_avt::serialize(Archive& ar, [[maybe_unused]] unsigned int version)
    {

        ar& CEREAL_NVP(timeStamp);
        ar& CEREAL_NVP(SH2_Outputs);
        ar& CEREAL_NVP(SH2_Protocol_Version);
        ar& CEREAL_NVP(SH2_Error_State);
    }


template void dynamic_occupancy_grid_avt::serialize(cereal::BinaryInputArchive& ar, unsigned int version);
template void dynamic_occupancy_grid_avt::serialize(cereal::BinaryOutputArchive& ar, unsigned int version);
template void dynamic_occupancy_grid_avt::serialize(cereal::IntrospectionArchive& ar, unsigned int version);
template void dynamic_occupancy_grid_avt::serialize(cereal::JSONInputArchive& ar, unsigned int version);
template void dynamic_occupancy_grid_avt::serialize(cereal::JSONOutputArchive& ar, unsigned int version);
template void dynamic_occupancy_grid_avt::serialize(cereal::PortableBinaryInputArchive& ar, unsigned int version);
template void dynamic_occupancy_grid_avt::serialize(cereal::PortableBinaryOutputArchive& ar, unsigned int version);

std::ostream& operator<< (std::ostream& os, const dynamic_occupancy_grid_avt& dynamic_occupancy_grid_avt)
{
    dynamic_occupancy_grid_avt.toCsv(os);
    return os;
}

bool operator== (const dynamic_occupancy_grid_avt &lhs, const dynamic_occupancy_grid_avt &rhs)
{
    return (  lhs.timeStamp== rhs.timeStamp &&
     lhs.SH2_Outputs== rhs.SH2_Outputs &&
     lhs.SH2_Protocol_Version== rhs.SH2_Protocol_Version &&
     lhs.SH2_Error_State== rhs.SH2_Error_State 
    );
}

std::size_t dynamic_occupancy_grid_avt::hash() const noexcept
{
    std::size_t result = 17;
    result = result * 31 + std::hash<int64_t>()(timeStamp);
    result = result * 31 + std::hash<SH2_Outputs_avt>()(SH2_Outputs);
    result = result * 31 + std::hash<SH2_Protocol_Version_avt>()(SH2_Protocol_Version);
    result = result * 31 + std::hash<SH2_Error_State_avt>()(SH2_Error_State);
    return result;
}

 } // namespace av
 } // namespace msg


CEREAL_BIND_TO_ARCHIVES(av::msg::dynamic_occupancy_grid_avt)

