#include <interfaces/log_playback_avt/log_playback_avt.h>

#include <iterator>
#include <type_traits>

#include <cereal/cereal.hpp>
#include <cereal/archives/json.hpp>
#include <cereal/archives/binary.hpp>

#include <cereal/types/map.hpp>
#include <cereal/types/vector.hpp>
#include <cereal/types/array.hpp>
#include <cereal/types/string.hpp>
#include <cereal/types/complex.hpp>

#include <ODatum/IntrospectionArchive.h>
#include <ODatum/Hash.h>





 namespace av {
 namespace msg {


log_playback_avt::log_playback_avt() = default;

log_playback_avt::log_playback_avt(
    std::string activeConfigPath_arg 
    ):
    activeConfigPath { std::move(activeConfigPath_arg) } // NOLINT
      {
}

log_playback_avt::log_playback_avt(const log_playback_avt&) = default;

// NOLINTNEXTLINE
log_playback_avt::log_playback_avt(log_playback_avt&&) = default;

log_playback_avt& log_playback_avt::operator=(const log_playback_avt&) = default;

// NOLINTNEXTLINE
log_playback_avt& log_playback_avt::operator=(log_playback_avt&&) = default;

void log_playback_avt::toCsv(std::ostream& out) const
{
    out.precision(16);
    out << std::boolalpha;
    out << "\"";
        out << activeConfigPath;
        out << "\"";
    
}

std::stringstream log_playback_avt::toStringstream() const
{
    std::stringstream out;
    toCsv(out);
    return out;
}

template<class Archive>
    void log_playback_avt::serialize(Archive& ar, [[maybe_unused]] unsigned int version)
    {

        ar& CEREAL_NVP(activeConfigPath);
    }


template void log_playback_avt::serialize(cereal::BinaryInputArchive& ar, unsigned int version);
template void log_playback_avt::serialize(cereal::BinaryOutputArchive& ar, unsigned int version);
template void log_playback_avt::serialize(cereal::IntrospectionArchive& ar, unsigned int version);
template void log_playback_avt::serialize(cereal::JSONInputArchive& ar, unsigned int version);
template void log_playback_avt::serialize(cereal::JSONOutputArchive& ar, unsigned int version);
template void log_playback_avt::serialize(cereal::PortableBinaryInputArchive& ar, unsigned int version);
template void log_playback_avt::serialize(cereal::PortableBinaryOutputArchive& ar, unsigned int version);

std::ostream& operator<< (std::ostream& os, const log_playback_avt& log_playback_avt)
{
    log_playback_avt.toCsv(os);
    return os;
}

bool operator== (const log_playback_avt &lhs, const log_playback_avt &rhs)
{
    return (  lhs.activeConfigPath== rhs.activeConfigPath 
    );
}

std::size_t log_playback_avt::hash() const noexcept
{
    std::size_t result = 17;
    result = result * 31 + std::hash<std::string>()(activeConfigPath);
    return result;
}

 } // namespace av
 } // namespace msg


CEREAL_BIND_TO_ARCHIVES(av::msg::log_playback_avt)

