#include <interfaces/motion_planner_avt/motion_planner_avt.h>

#include <iterator>
#include <type_traits>

#include <cereal/cereal.hpp>
#include <cereal/archives/json.hpp>
#include <cereal/archives/binary.hpp>

#include <cereal/types/map.hpp>
#include <cereal/types/vector.hpp>
#include <cereal/types/array.hpp>
#include <cereal/types/string.hpp>
#include <cereal/types/complex.hpp>

#include <ODatum/IntrospectionArchive.h>
#include <ODatum/Hash.h>





 namespace av {
 namespace msg {
 namespace plan_ctrl {


motion_planner_avt::motion_planner_avt() = default;

motion_planner_avt::motion_planner_avt(
    PlannerHeader header_arg ,
    Path path_arg 
    ):
    header { std::move(header_arg) } // NOLINT
      ,path { std::move(path_arg) } // NOLINT
      {
}

motion_planner_avt::motion_planner_avt(const motion_planner_avt&) = default;

// NOLINTNEXTLINE
motion_planner_avt::motion_planner_avt(motion_planner_avt&&) = default;

motion_planner_avt& motion_planner_avt::operator=(const motion_planner_avt&) = default;

// NOLINTNEXTLINE
motion_planner_avt& motion_planner_avt::operator=(motion_planner_avt&&) = default;

void motion_planner_avt::toCsv(std::ostream& out) const
{
    out.precision(16);
    out << std::boolalpha;
    out << header;out << ",";
    out << path;
    
}

std::stringstream motion_planner_avt::toStringstream() const
{
    std::stringstream out;
    toCsv(out);
    return out;
}

template<class Archive>
    void motion_planner_avt::serialize(Archive& ar, [[maybe_unused]] unsigned int version)
    {

        ar& CEREAL_NVP(header);
        ar& CEREAL_NVP(path);
    }


template void motion_planner_avt::serialize(cereal::BinaryInputArchive& ar, unsigned int version);
template void motion_planner_avt::serialize(cereal::BinaryOutputArchive& ar, unsigned int version);
template void motion_planner_avt::serialize(cereal::IntrospectionArchive& ar, unsigned int version);
template void motion_planner_avt::serialize(cereal::JSONInputArchive& ar, unsigned int version);
template void motion_planner_avt::serialize(cereal::JSONOutputArchive& ar, unsigned int version);
template void motion_planner_avt::serialize(cereal::PortableBinaryInputArchive& ar, unsigned int version);
template void motion_planner_avt::serialize(cereal::PortableBinaryOutputArchive& ar, unsigned int version);

std::ostream& operator<< (std::ostream& os, const motion_planner_avt& motion_planner_avt)
{
    motion_planner_avt.toCsv(os);
    return os;
}

bool operator== (const motion_planner_avt &lhs, const motion_planner_avt &rhs)
{
    return (  lhs.header== rhs.header &&
     lhs.path== rhs.path 
    );
}

std::size_t motion_planner_avt::hash() const noexcept
{
    std::size_t result = 17;
    result = result * 31 + std::hash<PlannerHeader>()(header);
    result = result * 31 + std::hash<Path>()(path);
    return result;
}

 } // namespace av
 } // namespace msg
 } // namespace plan_ctrl


CEREAL_BIND_TO_ARCHIVES(av::msg::plan_ctrl::motion_planner_avt)

