#include <interfaces/my_message_avt/my_message_avt.h>

#include <iterator>
#include <type_traits>

#include <cereal/cereal.hpp>
#include <cereal/archives/json.hpp>
#include <cereal/archives/binary.hpp>

#include <cereal/types/map.hpp>
#include <cereal/types/vector.hpp>
#include <cereal/types/array.hpp>
#include <cereal/types/string.hpp>
#include <cereal/types/complex.hpp>

#include <ODatum/IntrospectionArchive.h>
#include <ODatum/Hash.h>





 namespace av {
 namespace msg {


my_message_avt::my_message_avt() = default;

my_message_avt::my_message_avt(
    std::string hello_arg ,
    std::string world_arg 
    ):
    hello { std::move(hello_arg) } // NOLINT
      ,world { std::move(world_arg) } // NOLINT
      {
}

my_message_avt::my_message_avt(const my_message_avt&) = default;

// NOLINTNEXTLINE
my_message_avt::my_message_avt(my_message_avt&&) = default;

my_message_avt& my_message_avt::operator=(const my_message_avt&) = default;

// NOLINTNEXTLINE
my_message_avt& my_message_avt::operator=(my_message_avt&&) = default;

void my_message_avt::toCsv(std::ostream& out) const
{
    out.precision(16);
    out << std::boolalpha;
    out << "\"";
        out << hello;
        out << "\"";out << ",";
    out << "\"";
        out << world;
        out << "\"";
    
}

std::stringstream my_message_avt::toStringstream() const
{
    std::stringstream out;
    toCsv(out);
    return out;
}

template<class Archive>
    void my_message_avt::serialize(Archive& ar, [[maybe_unused]] unsigned int version)
    {

        ar& CEREAL_NVP(hello);
        ar& CEREAL_NVP(world);
    }


template void my_message_avt::serialize(cereal::BinaryInputArchive& ar, unsigned int version);
template void my_message_avt::serialize(cereal::BinaryOutputArchive& ar, unsigned int version);
template void my_message_avt::serialize(cereal::IntrospectionArchive& ar, unsigned int version);
template void my_message_avt::serialize(cereal::JSONInputArchive& ar, unsigned int version);
template void my_message_avt::serialize(cereal::JSONOutputArchive& ar, unsigned int version);
template void my_message_avt::serialize(cereal::PortableBinaryInputArchive& ar, unsigned int version);
template void my_message_avt::serialize(cereal::PortableBinaryOutputArchive& ar, unsigned int version);

std::ostream& operator<< (std::ostream& os, const my_message_avt& my_message_avt)
{
    my_message_avt.toCsv(os);
    return os;
}

bool operator== (const my_message_avt &lhs, const my_message_avt &rhs)
{
    return (  lhs.hello== rhs.hello &&
     lhs.world== rhs.world 
    );
}

std::size_t my_message_avt::hash() const noexcept
{
    std::size_t result = 17;
    result = result * 31 + std::hash<std::string>()(hello);
    result = result * 31 + std::hash<std::string>()(world);
    return result;
}

 } // namespace av
 } // namespace msg


CEREAL_BIND_TO_ARCHIVES(av::msg::my_message_avt)

