#include <interfaces/shield_generic_msg_avt/shield_generic_msg_avt.h>

#include <iterator>
#include <type_traits>

#include <cereal/cereal.hpp>
#include <cereal/archives/json.hpp>
#include <cereal/archives/binary.hpp>

#include <cereal/types/map.hpp>
#include <cereal/types/vector.hpp>
#include <cereal/types/array.hpp>
#include <cereal/types/string.hpp>
#include <cereal/types/complex.hpp>

#include <ODatum/IntrospectionArchive.h>
#include <ODatum/Hash.h>





 namespace av {
 namespace msg {


shield_generic_msg_avt::shield_generic_msg_avt() = default;

shield_generic_msg_avt::shield_generic_msg_avt(
    std::string message_arg 
    ):
    message { std::move(message_arg) } // NOLINT
      {
}

shield_generic_msg_avt::shield_generic_msg_avt(const shield_generic_msg_avt&) = default;

// NOLINTNEXTLINE
shield_generic_msg_avt::shield_generic_msg_avt(shield_generic_msg_avt&&) = default;

shield_generic_msg_avt& shield_generic_msg_avt::operator=(const shield_generic_msg_avt&) = default;

// NOLINTNEXTLINE
shield_generic_msg_avt& shield_generic_msg_avt::operator=(shield_generic_msg_avt&&) = default;

void shield_generic_msg_avt::toCsv(std::ostream& out) const
{
    out.precision(16);
    out << std::boolalpha;
    out << "\"";
        out << message;
        out << "\"";
    
}

std::stringstream shield_generic_msg_avt::toStringstream() const
{
    std::stringstream out;
    toCsv(out);
    return out;
}

template<class Archive>
    void shield_generic_msg_avt::serialize(Archive& ar, [[maybe_unused]] unsigned int version)
    {

        ar& CEREAL_NVP(message);
    }


template void shield_generic_msg_avt::serialize(cereal::BinaryInputArchive& ar, unsigned int version);
template void shield_generic_msg_avt::serialize(cereal::BinaryOutputArchive& ar, unsigned int version);
template void shield_generic_msg_avt::serialize(cereal::IntrospectionArchive& ar, unsigned int version);
template void shield_generic_msg_avt::serialize(cereal::JSONInputArchive& ar, unsigned int version);
template void shield_generic_msg_avt::serialize(cereal::JSONOutputArchive& ar, unsigned int version);
template void shield_generic_msg_avt::serialize(cereal::PortableBinaryInputArchive& ar, unsigned int version);
template void shield_generic_msg_avt::serialize(cereal::PortableBinaryOutputArchive& ar, unsigned int version);

std::ostream& operator<< (std::ostream& os, const shield_generic_msg_avt& shield_generic_msg_avt)
{
    shield_generic_msg_avt.toCsv(os);
    return os;
}

bool operator== (const shield_generic_msg_avt &lhs, const shield_generic_msg_avt &rhs)
{
    return (  lhs.message== rhs.message 
    );
}

std::size_t shield_generic_msg_avt::hash() const noexcept
{
    std::size_t result = 17;
    result = result * 31 + std::hash<std::string>()(message);
    return result;
}

 } // namespace av
 } // namespace msg


CEREAL_BIND_TO_ARCHIVES(av::msg::shield_generic_msg_avt)

