#include <interfaces/sync_image_message_avt/sync_image_message_avt.h>

#include <iterator>
#include <type_traits>

#include <cereal/cereal.hpp>
#include <cereal/archives/json.hpp>
#include <cereal/archives/binary.hpp>

#include <cereal/types/map.hpp>
#include <cereal/types/vector.hpp>
#include <cereal/types/array.hpp>
#include <cereal/types/string.hpp>
#include <cereal/types/complex.hpp>

#include <ODatum/IntrospectionArchive.h>
#include <ODatum/Hash.h>







sync_image_message_avt::sync_image_message_avt() = default;

sync_image_message_avt::sync_image_message_avt(
    CompressedImageMessage image_arg ,
    bool isSynced__arg ,
    int64_t STT__arg ,
    bool isImageDropped__arg ,
    int64_t ATT__arg ,
    int64_t exposureTime__arg 
    ):
    image { std::move(image_arg) } // NOLINT
      ,isSynced_ { std::move(isSynced__arg) } // NOLINT
      ,STT_ { std::move(STT__arg) } // NOLINT
      ,isImageDropped_ { std::move(isImageDropped__arg) } // NOLINT
      ,ATT_ { std::move(ATT__arg) } // NOLINT
      ,exposureTime_ { std::move(exposureTime__arg) } // NOLINT
      {
}

sync_image_message_avt::sync_image_message_avt(const sync_image_message_avt&) = default;

// NOLINTNEXTLINE
sync_image_message_avt::sync_image_message_avt(sync_image_message_avt&&) = default;

sync_image_message_avt& sync_image_message_avt::operator=(const sync_image_message_avt&) = default;

// NOLINTNEXTLINE
sync_image_message_avt& sync_image_message_avt::operator=(sync_image_message_avt&&) = default;

void sync_image_message_avt::toCsv(std::ostream& out) const
{
    out.precision(16);
    out << std::boolalpha;
    out << image;out << ",";
    out << isSynced_;out << ",";
    out << STT_;out << ",";
    out << isImageDropped_;out << ",";
    out << ATT_;out << ",";
    out << exposureTime_;
    
}

std::stringstream sync_image_message_avt::toStringstream() const
{
    std::stringstream out;
    toCsv(out);
    return out;
}

template<class Archive>
    void sync_image_message_avt::serialize(Archive& ar, [[maybe_unused]] unsigned int version)
    {

        ar& CEREAL_NVP(image);
        ar& CEREAL_NVP(isSynced_);
        ar& CEREAL_NVP(STT_);
        ar& CEREAL_NVP(isImageDropped_);
        ar& CEREAL_NVP(ATT_);
        ar& CEREAL_NVP(exposureTime_);
    }


template void sync_image_message_avt::serialize(cereal::BinaryInputArchive& ar, unsigned int version);
template void sync_image_message_avt::serialize(cereal::BinaryOutputArchive& ar, unsigned int version);
template void sync_image_message_avt::serialize(cereal::IntrospectionArchive& ar, unsigned int version);
template void sync_image_message_avt::serialize(cereal::JSONInputArchive& ar, unsigned int version);
template void sync_image_message_avt::serialize(cereal::JSONOutputArchive& ar, unsigned int version);
template void sync_image_message_avt::serialize(cereal::PortableBinaryInputArchive& ar, unsigned int version);
template void sync_image_message_avt::serialize(cereal::PortableBinaryOutputArchive& ar, unsigned int version);

std::ostream& operator<< (std::ostream& os, const sync_image_message_avt& sync_image_message_avt)
{
    sync_image_message_avt.toCsv(os);
    return os;
}

bool operator== (const sync_image_message_avt &lhs, const sync_image_message_avt &rhs)
{
    return (  lhs.image== rhs.image &&
     lhs.isSynced_== rhs.isSynced_ &&
     lhs.STT_== rhs.STT_ &&
     lhs.isImageDropped_== rhs.isImageDropped_ &&
     lhs.ATT_== rhs.ATT_ &&
     lhs.exposureTime_== rhs.exposureTime_ 
    );
}

std::size_t sync_image_message_avt::hash() const noexcept
{
    std::size_t result = 17;
    result = result * 31 + std::hash<CompressedImageMessage>()(image);
    result = result * 31 + std::hash<bool>()(isSynced_);
    result = result * 31 + std::hash<int64_t>()(STT_);
    result = result * 31 + std::hash<bool>()(isImageDropped_);
    result = result * 31 + std::hash<int64_t>()(ATT_);
    result = result * 31 + std::hash<int64_t>()(exposureTime_);
    return result;
}



CEREAL_BIND_TO_ARCHIVES(sync_image_message_avt)

