/*!
 ***********************************************************************************************************************
 * APTIV PRIVILEGED AND CONFIDENTIAL
 *
 * THIS IS AN AUTO GENERATED FILE!
 * DO NOT EDIT BY HAND!
 * check infrastructure/idl_generator/jinja_templates/struct.template
 *
 * @brief Auto Generated Cereal Interface
 *
 * @section License
 *
 * Copyright (c) 2019- Aptiv. All rights reserved.
 * NOTE: Removing this heading is prohibited.
 *
 * @section Open Source License List
 *
 * This is a list of any open-source project used by this file.
 ***********************************************************************************************************************
 */

#ifndef _TARGET_PREDICTION_AVT_H_
#define _TARGET_PREDICTION_AVT_H_

#include <ODatum/ODatum.h>
#include <interfaces/traits/csvable.h>

#include <interfaces/target_prediction_avtDefinitions.hpp>


#include <interfaces/Velocity/Velocity.h>





 namespace av {
 namespace msg {
 namespace prediction {


class Position
    : public csvable
    , public aptv::ODatum
{
public:
    Position();

    Position(
        double x_m_arg ,
        double y_m_arg ,
        double z_m_arg 
        );

    Position(const Position&);

    // NOLINTNEXTLINE
    Position(Position&&);

    Position& operator=(const Position&);

    // NOLINTNEXTLINE
    Position& operator=(Position&&);

    
    double x_m
    {};
    double y_m
    {};
    double z_m
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const Position& position);

    friend bool operator== (const Position &lhs, const Position &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace prediction


template<> struct std::hash<av::msg::prediction::Position>
{
    std::size_t operator()(av::msg::prediction::Position const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::prediction::Position, 1)
ODATUM_NAMED_TYPE(av::msg::prediction::Position)

 namespace av {
 namespace msg {
 namespace prediction {


class Size
    : public csvable
    , public aptv::ODatum
{
public:
    Size();

    Size(
        double length_m_arg ,
        double width_m_arg ,
        double height_m_arg 
        );

    Size(const Size&);

    // NOLINTNEXTLINE
    Size(Size&&);

    Size& operator=(const Size&);

    // NOLINTNEXTLINE
    Size& operator=(Size&&);

    
    double length_m
    {};
    double width_m
    {};
    double height_m
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const Size& size);

    friend bool operator== (const Size &lhs, const Size &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace prediction


template<> struct std::hash<av::msg::prediction::Size>
{
    std::size_t operator()(av::msg::prediction::Size const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::prediction::Size, 1)
ODATUM_NAMED_TYPE(av::msg::prediction::Size)

 namespace av {
 namespace msg {
 namespace prediction {


class Acceleration
    : public csvable
    , public aptv::ODatum
{
public:
    Acceleration();

    Acceleration(
        double accelerationX_mps2_arg ,
        double accelerationY_mps2_arg ,
        double accelerationZ_mps2_arg 
        );

    Acceleration(const Acceleration&);

    // NOLINTNEXTLINE
    Acceleration(Acceleration&&);

    Acceleration& operator=(const Acceleration&);

    // NOLINTNEXTLINE
    Acceleration& operator=(Acceleration&&);

    
    double accelerationX_mps2
    {};
    double accelerationY_mps2
    {};
    double accelerationZ_mps2
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const Acceleration& acceleration);

    friend bool operator== (const Acceleration &lhs, const Acceleration &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace prediction


template<> struct std::hash<av::msg::prediction::Acceleration>
{
    std::size_t operator()(av::msg::prediction::Acceleration const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::prediction::Acceleration, 1)
ODATUM_NAMED_TYPE(av::msg::prediction::Acceleration)

 namespace av {
 namespace msg {
 namespace prediction {


class Vector1D
    : public csvable
    , public aptv::ODatum
{
public:
    Vector1D();

    Vector1D(
        std::vector<double> data_arg 
        );

    Vector1D(const Vector1D&);

    // NOLINTNEXTLINE
    Vector1D(Vector1D&&);

    Vector1D& operator=(const Vector1D&);

    // NOLINTNEXTLINE
    Vector1D& operator=(Vector1D&&);

    
    std::vector<double> data
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const Vector1D& vector1d);

    friend bool operator== (const Vector1D &lhs, const Vector1D &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace prediction


template<> struct std::hash<av::msg::prediction::Vector1D>
{
    std::size_t operator()(av::msg::prediction::Vector1D const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::prediction::Vector1D, 1)
ODATUM_NAMED_TYPE(av::msg::prediction::Vector1D)

 namespace av {
 namespace msg {
 namespace prediction {


class Matrix2D
    : public csvable
    , public aptv::ODatum
{
public:
    Matrix2D();

    Matrix2D(
        std::vector<Vector1D> rows_arg 
        );

    Matrix2D(const Matrix2D&);

    // NOLINTNEXTLINE
    Matrix2D(Matrix2D&&);

    Matrix2D& operator=(const Matrix2D&);

    // NOLINTNEXTLINE
    Matrix2D& operator=(Matrix2D&&);

    
    std::vector<Vector1D> rows
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const Matrix2D& matrix2d);

    friend bool operator== (const Matrix2D &lhs, const Matrix2D &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace prediction


template<> struct std::hash<av::msg::prediction::Matrix2D>
{
    std::size_t operator()(av::msg::prediction::Matrix2D const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::prediction::Matrix2D, 1)
ODATUM_NAMED_TYPE(av::msg::prediction::Matrix2D)

 namespace av {
 namespace msg {
 namespace prediction {


class AgentAttributes
    : public csvable
    , public aptv::ODatum
{
public:
    AgentAttributes();

    AgentAttributes(
        int32_t type_arg ,
        std::vector<double> probs_arg ,
        double confidence_arg ,
        double prob_active_arg ,
        Size size_arg ,
        double angular_velocity_radps_arg ,
        Acceleration acceleration_arg ,
        std::vector<float> similarity_embedding_arg 
        );

    AgentAttributes(const AgentAttributes&);

    // NOLINTNEXTLINE
    AgentAttributes(AgentAttributes&&);

    AgentAttributes& operator=(const AgentAttributes&);

    // NOLINTNEXTLINE
    AgentAttributes& operator=(AgentAttributes&&);

    
    int32_t type
    {};
    std::vector<double> probs
    {};
    double confidence
    {};
    double prob_active
    {};
    Size size
    {};
    double angular_velocity_radps
    {};
    Acceleration acceleration
    {};
    std::vector<float> similarity_embedding
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const AgentAttributes& agentattributes);

    friend bool operator== (const AgentAttributes &lhs, const AgentAttributes &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace prediction


template<> struct std::hash<av::msg::prediction::AgentAttributes>
{
    std::size_t operator()(av::msg::prediction::AgentAttributes const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::prediction::AgentAttributes, 2)
ODATUM_NAMED_TYPE(av::msg::prediction::AgentAttributes)

 namespace av {
 namespace msg {
 namespace prediction {


class Waypoint
    : public csvable
    , public aptv::ODatum
{
public:
    Waypoint();

    Waypoint(
        int64_t time_usecs_arg ,
        Position position_m_arg ,
        Matrix2D position_cov_m2_arg ,
        double heading_rad_arg ,
        Velocity velocity_mps_arg 
        );

    Waypoint(const Waypoint&);

    // NOLINTNEXTLINE
    Waypoint(Waypoint&&);

    Waypoint& operator=(const Waypoint&);

    // NOLINTNEXTLINE
    Waypoint& operator=(Waypoint&&);

    
    int64_t time_usecs
    {};
    Position position_m
    {};
    Matrix2D position_cov_m2
    {};
    double heading_rad
    {};
    Velocity velocity_mps
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const Waypoint& waypoint);

    friend bool operator== (const Waypoint &lhs, const Waypoint &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace prediction


template<> struct std::hash<av::msg::prediction::Waypoint>
{
    std::size_t operator()(av::msg::prediction::Waypoint const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::prediction::Waypoint, 1)
ODATUM_NAMED_TYPE(av::msg::prediction::Waypoint)

 namespace av {
 namespace msg {
 namespace prediction {


class Trajectory
    : public csvable
    , public aptv::ODatum
{
public:
    Trajectory();

    Trajectory(
        double probability_arg ,
        std::vector<Waypoint> waypoints_arg 
        );

    Trajectory(const Trajectory&);

    // NOLINTNEXTLINE
    Trajectory(Trajectory&&);

    Trajectory& operator=(const Trajectory&);

    // NOLINTNEXTLINE
    Trajectory& operator=(Trajectory&&);

    
    double probability
    {};
    std::vector<Waypoint> waypoints
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const Trajectory& trajectory);

    friend bool operator== (const Trajectory &lhs, const Trajectory &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace prediction


template<> struct std::hash<av::msg::prediction::Trajectory>
{
    std::size_t operator()(av::msg::prediction::Trajectory const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::prediction::Trajectory, 1)
ODATUM_NAMED_TYPE(av::msg::prediction::Trajectory)

 namespace av {
 namespace msg {
 namespace prediction {


class Agent
    : public csvable
    , public aptv::ODatum
{
public:
    Agent();

    Agent(
        AgentAttributes attributes_arg ,
        std::vector<prediction::Trajectory> trajectories_arg 
        );

    Agent(const Agent&);

    // NOLINTNEXTLINE
    Agent(Agent&&);

    Agent& operator=(const Agent&);

    // NOLINTNEXTLINE
    Agent& operator=(Agent&&);

    
    AgentAttributes attributes
    {};
    std::vector<prediction::Trajectory> trajectories
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const Agent& agent);

    friend bool operator== (const Agent &lhs, const Agent &rhs);

    template<class Archive>
    void serialize(Archive& ar, unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace prediction


template<> struct std::hash<av::msg::prediction::Agent>
{
    std::size_t operator()(av::msg::prediction::Agent const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::prediction::Agent, 1)
ODATUM_NAMED_TYPE(av::msg::prediction::Agent)



 namespace av {
 namespace msg {
 namespace prediction {


class target_prediction_avt
    : public csvable
    , public aptv::ODatum
{
public:
    target_prediction_avt();

    target_prediction_avt(
        int64_t time_usecs_arg ,
        std::string frame_id_arg ,
        float detection_range_m_arg ,
        std::vector<Agent> agents_arg 
        );

    target_prediction_avt(const target_prediction_avt&);

    // NOLINTNEXTLINE
    target_prediction_avt(target_prediction_avt&&);

    target_prediction_avt& operator=(const target_prediction_avt&);

    // NOLINTNEXTLINE
    target_prediction_avt& operator=(target_prediction_avt&&);

    
    int64_t time_usecs
    {};
    std::string frame_id
    {};
    float detection_range_m
    {};
    std::vector<Agent> agents
    {};

    void toCsv(std::ostream& out) const;

    std::stringstream toStringstream() const;

    friend std::ostream& operator<< (std::ostream& os, const target_prediction_avt& target_prediction_avt);

    friend bool operator== (const target_prediction_avt &lhs, const target_prediction_avt &rhs);

    template<class Archive>
    void serialize([[maybe_unused]] Archive& ar, [[maybe_unused]] unsigned int version);

    std::size_t hash() const noexcept;
};

 } // namespace av
 } // namespace msg
 } // namespace prediction


template<> struct std::hash<av::msg::prediction::target_prediction_avt>
{
    std::size_t operator()(av::msg::prediction::target_prediction_avt const& obj) const noexcept
    {
        return obj.hash();
    }
};

CEREAL_CLASS_VERSION(av::msg::prediction::target_prediction_avt, 1)
ODATUM_NAMED_TYPE(av::msg::prediction::target_prediction_avt)



#endif // _TARGET_PREDICTION_AVT_H_
