/**
 * \copyright
 * Copyright (c) 2020- Aptiv. All rights reserved.
 * NOTICE: Removing this heading is prohibited.
 * All information contained herein is, and remains the property of Aptiv and its suppliers, if any.
 * The intellectual and technical concepts contained herein are proprietary to Aptiv and its suppliers and may be
 * covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material is strictly forbidden unless prior written
 * permission is obtained from Aptiv.
 *
 * \brief FuzzUtilsTests: this file contains unit tests for fuzz utilities.
 */

#include <FuzzUtils/FuzzUtils.h>

#include <fstream>
#include <gtest/gtest.h>

class FuzzUtilsTest : public ::testing::Test
{
public:
    FuzzUtilsTest() {}

    void SetUp() override {}

    void TearDown() override {}

protected:
};

TEST_F(FuzzUtilsTest, testLoadBuffer)
{
    std::fstream myfile = std::fstream("testfile.bin", std::ios::out | std::ios::binary);
    if (!myfile) {
        FAIL() << "Error instantiating fstream of testfile.bin";
    }

    char data{42};
    myfile.write(&data, sizeof(char));
    myfile.close();

    std::unique_ptr<FuzzData> fuzzData;
    ASSERT_NO_THROW(fuzzData = getFuzzDataFromFile("testfile.bin"));
    ASSERT_EQ(fuzzData->getSize(), 2);
    ASSERT_EQ(fuzzData->getData()[0], 42);
}

int main(int argc, char** argv)
{
    ::testing::InitGoogleTest(&argc, argv);
    return RUN_ALL_TESTS();
}
